/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],X=function(F){for(var t=[],M=0,D=F.length;M<D;M++)t[M]=Q[F[M]];return t};"use strict";var ge=this,me=typeof global=="object"?global:{},K;(function(F){F.global=ge;var t=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();F.Environment=t})(K||(K={}));var K;(function(F){var t=function(){function P(s,E,l){this.type=s,this.detail=E,this.timestamp=l}return P}();F.LoaderEvent=t;var M=function(){function P(s){this._events=[new t(1,"",s)]}return P.prototype.record=function(s,E){this._events.push(new t(s,E,F.Utilities.getHighPerformanceTimestamp()))},P.prototype.getEvents=function(){return this._events},P}();F.LoaderEventRecorder=M;var D=function(){function P(){}return P.prototype.record=function(s,E){},P.prototype.getEvents=function(){return[]},P.INSTANCE=new P,P}();F.NullLoaderEventRecorder=D})(K||(K={}));var K;(function(F){var t=function(){function M(){}return M.fileUriToFilePath=function(D,P){if(P=decodeURI(P).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(P))return P.substr(8);if(/^file:\/\//.test(P))return P.substr(5)}else if(/^file:\/\//.test(P))return P.substr(7);return P},M.startsWith=function(D,P){return D.length>=P.length&&D.substr(0,P.length)===P},M.endsWith=function(D,P){return D.length>=P.length&&D.substr(D.length-P.length)===P},M.containsQueryString=function(D){return/^[^\#]*\?/gi.test(D)},M.isAbsolutePath=function(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)},M.forEachProperty=function(D,P){if(D){var s=void 0;for(s in D)D.hasOwnProperty(s)&&P(s,D[s])}},M.isEmpty=function(D){var P=!0;return M.forEachProperty(D,function(){P=!1}),P},M.recursiveClone=function(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;var P=Array.isArray(D)?[]:{};return M.forEachProperty(D,function(s,E){E&&typeof E=="object"?P[s]=M.recursiveClone(E):P[s]=E}),P},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(D){return M.startsWith(D,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();F.Utilities=t})(K||(K={}));var K;(function(F){function t(P){if(P instanceof Error)return P;var s=new Error(P.message||String(P)||"Unknown Error");return P.stack&&(s.stack=P.stack),s}F.ensureError=t;var M=function(){function P(){}return P.validateConfigurationOptions=function(s){function E(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(s=s||{},typeof s.baseUrl!="string"&&(s.baseUrl=""),typeof s.isBuild!="boolean"&&(s.isBuild=!1),typeof s.paths!="object"&&(s.paths={}),typeof s.config!="object"&&(s.config={}),typeof s.catchError=="undefined"&&(s.catchError=!1),typeof s.recordStats=="undefined"&&(s.recordStats=!1),typeof s.urlArgs!="string"&&(s.urlArgs=""),typeof s.onError!="function"&&(s.onError=E),Array.isArray(s.ignoreDuplicateModules)||(s.ignoreDuplicateModules=[]),s.baseUrl.length>0&&(F.Utilities.endsWith(s.baseUrl,"/")||(s.baseUrl+="/")),typeof s.cspNonce!="string"&&(s.cspNonce=""),typeof s.preferScriptTags=="undefined"&&(s.preferScriptTags=!1),Array.isArray(s.nodeModules)||(s.nodeModules=[]),s.nodeCachedData&&typeof s.nodeCachedData=="object"&&(typeof s.nodeCachedData.seed!="string"&&(s.nodeCachedData.seed="seed"),(typeof s.nodeCachedData.writeDelay!="number"||s.nodeCachedData.writeDelay<0)&&(s.nodeCachedData.writeDelay=1e3*7),!s.nodeCachedData.path||typeof s.nodeCachedData.path!="string")){var l=t(new Error("INVALID cached data configuration, 'path' MUST be set"));l.phase="configuration",s.onError(l),s.nodeCachedData=void 0}return s},P.mergeConfigurationOptions=function(s,E){s===void 0&&(s=null),E===void 0&&(E=null);var l=F.Utilities.recursiveClone(E||{});return F.Utilities.forEachProperty(s,function(u,a){u==="ignoreDuplicateModules"&&typeof l.ignoreDuplicateModules!="undefined"?l.ignoreDuplicateModules=l.ignoreDuplicateModules.concat(a):u==="paths"&&typeof l.paths!="undefined"?F.Utilities.forEachProperty(a,function(b,C){return l.paths[b]=C}):u==="config"&&typeof l.config!="undefined"?F.Utilities.forEachProperty(a,function(b,C){return l.config[b]=C}):l[u]=F.Utilities.recursiveClone(a)}),P.validateConfigurationOptions(l)},P}();F.ConfigurationOptionsUtil=M;var D=function(){function P(s,E){if(this._env=s,this.options=M.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var l=this.options.nodeRequire.main.filename,u=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var l=this.options.nodeMain,u=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,u+1)}}}return P.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var s=0;s<this.options.ignoreDuplicateModules.length;s++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[s]]=!0},P.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var s=0,E=this.options.nodeModules;s<E.length;s++){var l=E[s];this.nodeModulesMap[l]=!0}},P.prototype._createSortedPathsRules=function(){var s=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(E,l){Array.isArray(l)?s.sortedPathsRules.push({from:E,to:l}):s.sortedPathsRules.push({from:E,to:[l]})}),this.sortedPathsRules.sort(function(E,l){return l.from.length-E.from.length})},P.prototype.cloneAndMerge=function(s){return new P(this._env,M.mergeConfigurationOptions(s,this.options))},P.prototype.getOptionsLiteral=function(){return this.options},P.prototype._applyPaths=function(s){for(var E,l=0,u=this.sortedPathsRules.length;l<u;l++)if(E=this.sortedPathsRules[l],F.Utilities.startsWith(s,E.from)){for(var a=[],b=0,C=E.to.length;b<C;b++)a.push(E.to[b]+s.substr(E.from.length));return a}return[s]},P.prototype._addUrlArgsToUrl=function(s){return F.Utilities.containsQueryString(s)?s+"&"+this.options.urlArgs:s+"?"+this.options.urlArgs},P.prototype._addUrlArgsIfNecessaryToUrl=function(s){return this.options.urlArgs?this._addUrlArgsToUrl(s):s},P.prototype._addUrlArgsIfNecessaryToUrls=function(s){if(this.options.urlArgs)for(var E=0,l=s.length;E<l;E++)s[E]=this._addUrlArgsToUrl(s[E]);return s},P.prototype.moduleIdToPaths=function(s){var E=this.nodeModulesMap[s]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(s);if(E)return this.isBuild()?["empty:"]:["node|"+s];var l=s,u;if(!F.Utilities.endsWith(l,".js")&&!F.Utilities.isAbsolutePath(l)){u=this._applyPaths(l);for(var a=0,b=u.length;a<b;a++)this.isBuild()&&u[a]==="empty:"||(F.Utilities.isAbsolutePath(u[a])||(u[a]=this.options.baseUrl+u[a]),!F.Utilities.endsWith(u[a],".js")&&!F.Utilities.containsQueryString(u[a])&&(u[a]=u[a]+".js"))}else!F.Utilities.endsWith(l,".js")&&!F.Utilities.containsQueryString(l)&&(l=l+".js"),u=[l];return this._addUrlArgsIfNecessaryToUrls(u)},P.prototype.requireToUrl=function(s){var E=s;return F.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],F.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)},P.prototype.isBuild=function(){return this.options.isBuild},P.prototype.isDuplicateMessageIgnoredFor=function(s){return this.ignoreDuplicateModulesMap.hasOwnProperty(s)},P.prototype.getConfigForModule=function(s){if(this.options.config)return this.options.config[s]},P.prototype.shouldCatchError=function(){return this.options.catchError},P.prototype.shouldRecordStats=function(){return this.options.recordStats},P.prototype.onError=function(s){this.options.onError(s)},P}();F.Configuration=D})(K||(K={}));var K;(function(F){var t=function(){function l(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(u,a,b,C){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var c=u.getConfig().getOptionsLiteral().preferScriptTags;c?this._scriptLoader=new M:this._scriptLoader=new P(this._env)}else this._env.isNode?this._scriptLoader=new P(this._env):this._scriptLoader=new M;var g={callback:b,errorback:C};if(this._callbackMap.hasOwnProperty(a)){this._callbackMap[a].push(g);return}this._callbackMap[a]=[g],this._scriptLoader.load(u,a,function(){return h.triggerCallback(a)},function(L){return h.triggerErrorback(a,L)})},l.prototype.triggerCallback=function(u){var a=this._callbackMap[u];delete this._callbackMap[u];for(var b=0;b<a.length;b++)a[b].callback()},l.prototype.triggerErrorback=function(u,a){var b=this._callbackMap[u];delete this._callbackMap[u];for(var C=0;C<b.length;C++)b[C].errorback(a)},l}(),M=function(){function l(){}return l.prototype.attachListeners=function(u,a,b){var C=function(){u.removeEventListener("load",h),u.removeEventListener("error",c)},h=function(g){C(),a()},c=function(g){C(),b(g)};u.addEventListener("load",h),u.addEventListener("error",c)},l.prototype.load=function(u,a,b,C){if(/^node\|/.test(a)){var h=u.getConfig().getOptionsLiteral(),c=s(u.getRecorder(),h.nodeRequire||F.global.nodeRequire),g=a.split("|"),L=null;try{L=c(g[1])}catch(i){C(i);return}u.enqueueDefineAnonymousModule([],function(){return L}),b()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,b,C);var _=u.getConfig().getOptionsLiteral().trustedTypesPolicy;_&&(a=_.createScriptURL(a)),S.setAttribute("src",a);var n=u.getConfig().getOptionsLiteral().cspNonce;n&&S.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(S)}},l}(),D=function(){function l(){}return l.prototype.load=function(u,a,b,C){var h=u.getConfig().getOptionsLiteral().trustedTypesPolicy,c=/^((http:)|(https:)|(file:))/.test(a)&&a.substring(0,self.origin.length)!==self.origin;if(!c){fetch(a).then(function(g){if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(function(g){g=g+`
//# sourceURL=`+a;var L=h?self.eval(h.createScript("",g)):new Function(g);L.call(self),b()}).then(void 0,C);return}try{h&&(a=h.createScriptURL(a)),importScripts(a),b()}catch(g){C(g)}},l}(),P=function(){function l(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))},l.prototype._initNodeRequire=function(u,a){var b=a.getConfig().getOptionsLiteral().nodeCachedData;if(!!b&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var C=this,h=u("module");function c(g){var L=g.constructor,S=function(n){try{return g.require(n)}finally{}};return S.resolve=function(n,i){return L._resolveFilename(n,g,!1,i)},S.main=process.mainModule,S.extensions=L._extensions,S.cache=L._cache,S}h.prototype._compile=function(g,L){var S=h.wrap(g.replace(/^#!.*/,"")),_=a.getRecorder(),n=C._getCachedDataPath(b,L),i={filename:L},r;try{var o=C._fs.readFileSync(n);r=o.slice(0,16),i.cachedData=o.slice(16),_.record(60,n)}catch(p){_.record(61,n)}var f=new C._vm.Script(S,i),v=f.runInThisContext(i),d=C._path.dirname(L),m=c(this),w=[this.exports,m,this,L,d,process,me,Buffer],N=v.apply(this.exports,w);return C._handleCachedData(f,S,n,!i.cachedData,a),C._verifyCachedData(f,S,n,r,a),N}}},l.prototype.load=function(u,a,b,C){var h=this,c=u.getConfig().getOptionsLiteral(),g=s(u.getRecorder(),c.nodeRequire||F.global.nodeRequire),L=c.nodeInstrumenter||function(v){return v};this._init(g),this._initNodeRequire(g,u);var S=u.getRecorder();if(/^node\|/.test(a)){var _=a.split("|"),n=null;try{n=g(_[1])}catch(v){C(v);return}u.enqueueDefineAnonymousModule([],function(){return n}),b()}else{a=F.Utilities.fileUriToFilePath(this._env.isWindows,a);var i=this._path.normalize(a),r=this._getElectronRendererScriptPathOrUri(i),o=Boolean(c.nodeCachedData),f=o?this._getCachedDataPath(c.nodeCachedData,a):void 0;this._readSourceAndCachedData(i,f,S,function(v,d,m,w){if(v){C(v);return}var N;d.charCodeAt(0)===l._BOM?N=l._PREFIX+d.substring(1)+l._SUFFIX:N=l._PREFIX+d+l._SUFFIX,N=L(N,i);var p={filename:r,cachedData:m},I=h._createAndEvalScript(u,N,p,b,C);h._handleCachedData(I,N,f,o&&!m,u),h._verifyCachedData(I,N,f,w,u)})}},l.prototype._createAndEvalScript=function(u,a,b,C,h){var c=u.getRecorder();c.record(31,b.filename);var g=new this._vm.Script(a,b),L=g.runInThisContext(b),S=u.getGlobalAMDDefineFunc(),_=!1,n=function(){return _=!0,S.apply(null,arguments)};return n.amd=S.amd,L.call(F.global,u.getGlobalAMDRequireFunc(),n,b.filename,this._path.dirname(b.filename)),c.record(32,b.filename),_?C():h(new Error("Didn't receive define call in "+b.filename+"!")),g},l.prototype._getElectronRendererScriptPathOrUri=function(u){if(!this._env.isElectronRenderer)return u;var a=u.match(/^([a-z])\:(.*)/i);return a?"file:///"+(a[1].toUpperCase()+":"+a[2]).replace(/\\/g,"/"):"file://"+u},l.prototype._getCachedDataPath=function(u,a){var b=this._crypto.createHash("md5").update(a,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),C=this._path.basename(a).replace(/\.js$/,"");return this._path.join(u.path,C+"-"+b+".code")},l.prototype._handleCachedData=function(u,a,b,C,h){var c=this;u.cachedDataRejected?this._fs.unlink(b,function(g){h.getRecorder().record(62,b),c._createAndWriteCachedData(u,a,b,h),g&&h.getConfig().onError(g)}):C&&this._createAndWriteCachedData(u,a,b,h)},l.prototype._createAndWriteCachedData=function(u,a,b,C){var h=this,c=Math.ceil(C.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),g=-1,L=0,S=void 0,_=function(){setTimeout(function(){S||(S=h._crypto.createHash("md5").update(a,"utf8").digest());var n=u.createCachedData();if(!(n.length===0||n.length===g||L>=5)){if(n.length<g){_();return}g=n.length,h._fs.writeFile(b,Buffer.concat([S,n]),function(i){i&&C.getConfig().onError(i),C.getRecorder().record(63,b),_()})}},c*Math.pow(4,L++))};_()},l.prototype._readSourceAndCachedData=function(u,a,b,C){if(!a)this._fs.readFile(u,{encoding:"utf8"},C);else{var h=void 0,c=void 0,g=void 0,L=2,S=function(_){_?C(_):--L==0&&C(void 0,h,c,g)};this._fs.readFile(u,{encoding:"utf8"},function(_,n){h=n,S(_)}),this._fs.readFile(a,function(_,n){!_&&n&&n.length>0?(g=n.slice(0,16),c=n.slice(16),b.record(60,a)):b.record(61,a),S()})}},l.prototype._verifyCachedData=function(u,a,b,C,h){var c=this;!C||u.cachedDataRejected||setTimeout(function(){var g=c._crypto.createHash("md5").update(a,"utf8").digest();C.equals(g)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+b+"' now, but a RESTART IS REQUIRED")),c._fs.unlink(b,function(L){L&&h.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function s(l,u){if(u.__$__isRecorded)return u;var a=function(C){l.record(33,C);try{return u(C)}finally{l.record(34,C)}};return a.__$__isRecorded=!0,a}F.ensureRecordedNodeRequire=s;function E(l){return new t(l)}F.createScriptLoader=E})(K||(K={}));var K;(function(F){var t=function(){function l(u){var a=u.lastIndexOf("/");a!==-1?this.fromModulePath=u.substr(0,a+1):this.fromModulePath=""}return l._normalizeModuleId=function(u){var a=u,b;for(b=/\/\.\//;b.test(a);)a=a.replace(b,"/");for(a=a.replace(/^\.\//g,""),b=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;b.test(a);)a=a.replace(b,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a},l.prototype.resolveModule=function(u){var a=u;return F.Utilities.isAbsolutePath(a)||(F.Utilities.startsWith(a,"./")||F.Utilities.startsWith(a,"../"))&&(a=l._normalizeModuleId(this.fromModulePath+a)),a},l.ROOT=new l(""),l}();F.ModuleIdResolver=t;var M=function(){function l(u,a,b,C,h,c){this.id=u,this.strId=a,this.dependencies=b,this._callback=C,this._errorback=h,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return l._safeInvokeFunction=function(u,a){try{return{returnedValue:u.apply(F.global,a),producedError:null}}catch(b){return{returnedValue:null,producedError:b}}},l._invokeFactory=function(u,a,b,C){return u.isBuild()&&!F.Utilities.isAnonymousModule(a)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(b,C):{returnedValue:b.apply(F.global,C),producedError:null}},l.prototype.complete=function(u,a,b){this._isComplete=!0;var C=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var h=l._invokeFactory(a,this.strId,this._callback,b);C=h.producedError,u.record(22,this.strId),!C&&typeof h.returnedValue!="undefined"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(C){var c=F.ensureError(C);c.phase="factory",c.moduleId=this.strId,this.error=c,a.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},l.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},l.prototype.isComplete=function(){return this._isComplete},l}();F.Module=M;var D=function(){function l(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return l.prototype.getMaxModuleId=function(){return this._nextId},l.prototype.getModuleId=function(u){var a=this._strModuleIdToIntModuleId.get(u);return typeof a=="undefined"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(u,a),this._intModuleIdToStrModuleId[a]=u),a},l.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},l}(),P=function(){function l(u){this.id=u}return l.EXPORTS=new l(0),l.MODULE=new l(1),l.REQUIRE=new l(2),l}();F.RegularDependency=P;var s=function(){function l(u,a,b){this.id=u,this.pluginId=a,this.pluginParam=b}return l}();F.PluginDependency=s;var E=function(){function l(u,a,b,C,h){h===void 0&&(h=0),this._env=u,this._scriptLoader=a,this._loaderAvailableTimestamp=h,this._defineFunc=b,this._requireFunc=C,this._moduleIdProvider=new D,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return l.prototype.reset=function(){return new l(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},l.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},l.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},l._findRelevantLocationInStack=function(u,a){for(var b=function(r){return r.replace(/\\/g,"/")},C=b(u),h=a.split(/\n/),c=0;c<h.length;c++){var g=h[c].match(/(.*):(\d+):(\d+)\)?$/);if(g){var L=g[1],S=g[2],_=g[3],n=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(n),L=b(L),L===C){var i={line:parseInt(S,10),col:parseInt(_,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+u)},l.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],a=0,b=0,C=this._modules2.length;b<C;b++){var h=this._modules2[b];if(!!h){var c=this._buildInfoPath[h.id]||null,g=this._buildInfoDefineStack[h.id]||null,L=this._buildInfoDependencies[h.id];u[a++]={id:h.strId,path:c,defineLocation:c&&g?l._findRelevantLocationInStack(c,g):null,dependencies:L,shim:null,exports:h.exports}}}return u},l.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},l.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},l.prototype.enqueueDefineAnonymousModule=function(u,a){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var b=null;this._config.isBuild()&&(b=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:b,dependencies:u,callback:a}},l.prototype.defineModule=function(u,a,b,C,h,c){var g=this;c===void 0&&(c=new t(u));var L=this._moduleIdProvider.getModuleId(u);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var S=new M(L,u,this._normalizeDependencies(a,c),b,C,c);this._modules2[L]=S,this._config.isBuild()&&(this._buildInfoDefineStack[L]=h,this._buildInfoDependencies[L]=(S.dependencies||[]).map(function(_){return g._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(S)},l.prototype._normalizeDependency=function(u,a){if(u==="exports")return P.EXPORTS;if(u==="module")return P.MODULE;if(u==="require")return P.REQUIRE;var b=u.indexOf("!");if(b>=0){var C=a.resolveModule(u.substr(0,b)),h=a.resolveModule(u.substr(b+1)),c=this._moduleIdProvider.getModuleId(C+"!"+h),g=this._moduleIdProvider.getModuleId(C);return new s(c,g,h)}return new P(this._moduleIdProvider.getModuleId(a.resolveModule(u)))},l.prototype._normalizeDependencies=function(u,a){for(var b=[],C=0,h=0,c=u.length;h<c;h++)b[C++]=this._normalizeDependency(u[h],a);return b},l.prototype._relativeRequire=function(u,a,b,C){if(typeof a=="string")return this.synchronousRequire(a,u);this.defineModule(F.Utilities.generateAnonymousModule(),a,b,C,null,u)},l.prototype.synchronousRequire=function(u,a){a===void 0&&(a=new t(u));var b=this._normalizeDependency(u,a),C=this._modules2[b.id];if(!C)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!C.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(C.error)throw C.error;return C.exports},l.prototype.configure=function(u,a){var b=this._config.shouldRecordStats();a?this._config=new F.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!b&&(this._recorder=null)},l.prototype.getConfig=function(){return this._config},l.prototype._onLoad=function(u){if(this._currentAnnonymousDefineCall!==null){var a=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),a.dependencies,a.callback,null,a.stack)}},l.prototype._createLoadError=function(u,a){var b=this,C=this._moduleIdProvider.getStrModuleId(u),h=(this._inverseDependencies2[u]||[]).map(function(g){return b._moduleIdProvider.getStrModuleId(g)}),c=F.ensureError(a);return c.phase="loading",c.moduleId=C,c.neededBy=h,c},l.prototype._onLoadError=function(u,a){var b=this._createLoadError(u,a);this._modules2[u]||(this._modules2[u]=new M(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},function(){},null));for(var C=[],h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)C[h]=!1;var g=!1,L=[];for(L.push(u),C[u]=!0;L.length>0;){var S=L.shift(),_=this._modules2[S];_&&(g=_.onDependencyError(b)||g);var n=this._inverseDependencies2[S];if(n)for(var h=0,c=n.length;h<c;h++){var i=n[h];C[i]||(L.push(i),C[i]=!0)}}g||this._config.onError(b)},l.prototype._hasDependencyPath=function(u,a){var b=this._modules2[u];if(!b)return!1;for(var C=[],h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)C[h]=!1;var g=[];for(g.push(b),C[u]=!0;g.length>0;){var L=g.shift(),S=L.dependencies;if(S)for(var h=0,c=S.length;h<c;h++){var _=S[h];if(_.id===a)return!0;var n=this._modules2[_.id];n&&!C[_.id]&&(C[_.id]=!0,g.push(n))}}return!1},l.prototype._findCyclePath=function(u,a,b){if(u===a||b===50)return[u];var C=this._modules2[u];if(!C)return null;var h=C.dependencies;if(h)for(var c=0,g=h.length;c<g;c++){var L=this._findCyclePath(h[c].id,a,b+1);if(L!==null)return L.push(u),L}return null},l.prototype._createRequire=function(u){var a=this,b=function(C,h,c){return a._relativeRequire(u,C,h,c)};return b.toUrl=function(C){return a._config.requireToUrl(u.resolveModule(C))},b.getStats=function(){return a.getLoaderEvents()},b.hasDependencyCycle=function(){return a._hasDependencyCycle},b.config=function(C,h){h===void 0&&(h=!1),a.configure(C,h)},b.__$__nodeRequire=F.global.nodeRequire,b},l.prototype._loadModule=function(u){var a=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var b=this._moduleIdProvider.getStrModuleId(u),C=this._config.moduleIdToPaths(b),h=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(b.indexOf("/")===-1||h.test(b))&&C.push("node|"+b);var c=-1,g=function(L){if(c++,c>=C.length)a._onLoadError(u,L);else{var S=C[c],_=a.getRecorder();if(a._config.isBuild()&&S==="empty:"){a._buildInfoPath[u]=S,a.defineModule(a._moduleIdProvider.getStrModuleId(u),[],null,null,null),a._onLoad(u);return}_.record(10,S),a._scriptLoader.load(a,S,function(){a._config.isBuild()&&(a._buildInfoPath[u]=S),_.record(11,S),a._onLoad(u)},function(n){_.record(12,S),g(n)})}};g(null)}},l.prototype._loadPluginDependency=function(u,a){var b=this;if(!(this._modules2[a.id]||this._knownModules2[a.id])){this._knownModules2[a.id]=!0;var C=function(h){b.defineModule(b._moduleIdProvider.getStrModuleId(a.id),[],h,null,null)};C.error=function(h){b._config.onError(b._createLoadError(a.id,h))},u.load(a.pluginParam,this._createRequire(t.ROOT),C,this._config.getOptionsLiteral())}},l.prototype._resolve=function(u){var a=this,b=u.dependencies;if(b)for(var C=0,h=b.length;C<h;C++){var c=b[C];if(c===P.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(c===P.MODULE){u.unresolvedDependenciesCount--;continue}if(c===P.REQUIRE){u.unresolvedDependenciesCount--;continue}var g=this._modules2[c.id];if(g&&g.isComplete()){if(g.error){u.onDependencyError(g.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var L=this._findCyclePath(c.id,u.id,0)||[];L.reverse(),L.push(c.id),console.warn(L.map(function(n){return a._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(u.id),c instanceof s){var S=this._modules2[c.pluginId];if(S&&S.isComplete()){this._loadPluginDependency(S.exports,c);continue}var _=this._inversePluginDependencies2.get(c.pluginId);_||(_=[],this._inversePluginDependencies2.set(c.pluginId,_)),_.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},l.prototype._onModuleComplete=function(u){var a=this,b=this.getRecorder();if(!u.isComplete()){var C=u.dependencies,h=[];if(C)for(var c=0,g=C.length;c<g;c++){var L=C[c];if(L===P.EXPORTS){h[c]=u.exports;continue}if(L===P.MODULE){h[c]={id:u.strId,config:function(){return a._config.getConfigForModule(u.strId)}};continue}if(L===P.REQUIRE){h[c]=this._createRequire(u.moduleIdResolver);continue}var S=this._modules2[L.id];if(S){h[c]=S.exports;continue}h[c]=null}u.complete(b,this._config,h);var _=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,_)for(var c=0,g=_.length;c<g;c++){var n=_[c],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(u.id);if(r){this._inversePluginDependencies2.delete(u.id);for(var c=0,g=r.length;c<g;c++)this._loadPluginDependency(u.exports,r[c])}}},l}();F.ModuleManager=E})(K||(K={}));var G,K;(function(F){var t=new F.Environment,M=null,D=function(l,u,a){typeof l!="string"&&(a=u,u=l,l=null),(typeof u!="object"||!Array.isArray(u))&&(a=u,u=null),u||(u=["require","exports","module"]),l?M.defineModule(l,u,a,null,null):M.enqueueDefineAnonymousModule(u,a)};D.amd={jQuery:!0};var P=function(l,u){u===void 0&&(u=!1),M.configure(l,u)},s=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){P(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};s.config=P,s.getConfig=function(){return M.getConfig().getOptionsLiteral()},s.reset=function(){M=M.reset()},s.getBuildInfo=function(){return M.getBuildInfo()},s.getStats=function(){return M.getLoaderEvents()},s.define=function(){return D.apply(null,arguments)};function E(){if(typeof F.global.require!="undefined"||typeof require!="undefined"){var l=F.global.require||require;if(typeof l=="function"&&typeof l.resolve=="function"){var u=F.ensureRecordedNodeRequire(M.getRecorder(),l);F.global.nodeRequire=u,s.nodeRequire=u,s.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer?(module.exports=s,require=s):(t.isElectronRenderer||(F.global.define=D),F.global.require=s)}F.init=E,(typeof F.global.define!="function"||!F.global.define.amd)&&(M=new F.ModuleManager(t,F.createScriptLoader(t),D,s,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require!="undefined"&&typeof F.global.require!="function"&&s.config(F.global.require),G=function(){return D.apply(null,arguments)},G.amd=D.amd,typeof doNotInitLoader=="undefined"&&E())})(K||(K={}));"use strict";var _e=this,fe;(function(F){var t=_e||{},M=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,D=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function P(a,b){var C;return b.length===0?C=a:C=a.replace(/\{(\d+)\}/g,function(h,c){var g=c[0];return typeof b[g]!="undefined"?b[g]:h}),D&&(C="\uFF3B"+C.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C}function s(a,b){var C=a[b];return C||(C=a["*"],C)?C:null}function E(a,b){for(var C=[],h=0;h<arguments.length-2;h++)C[h]=arguments[h+2];return P(b,C)}function l(a){return function(b,C){var h=Array.prototype.slice.call(arguments,2);return P(a[b],h)}}var u=function(){function a(){this.localize=E}return a.prototype.setPseudoTranslation=function(b){D=b},a.prototype.create=function(b,C){return{localize:l(C[b])}},a.prototype.load=function(b,C,h,c){if(c=c||{},!b||b.length===0)h({localize:E});else{var g=void 0;if(M&&M.getString)g=".nls.keys",C([b+g],function(_){h({localize:function(n,i){if(!_[n])return"NLS error: unknown key "+n;var r=_[n].keys;if(i>=r.length)return"NLS error unknow index "+i;var o=r[i],f=[];f[0]=n+"_"+o;for(var v=0;v<arguments.length-2;v++)f[v+1]=arguments[v+2];return M.getString.apply(M,f)}})});else if(c.isBuild)C([b+".nls",b+".nls.keys"],function(_,n){a.BUILD_MAP[b]=_,a.BUILD_MAP_KEYS[b]=n,h(_)});else{var L=c["vs/nls"]||{},S=L.availableLanguages?s(L.availableLanguages,b):null;g=".nls",S!==null&&S!==a.DEFAULT_TAG&&(g=g+"."+S),C([b+g],function(_){Array.isArray(_)?_.localize=l(_):_.localize=l(_[b]),h(_)})}}},a.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},a.prototype.write=function(b,C,h){var c=h.getEntryPoint(),g=this._getEntryPointsMap();g[c]=g[c]||[],g[c].push(C),C!==c&&h.asModule(b+"!"+C,"define(['vs/nls', 'vs/nls!"+c+`'], function(nls, data) { return nls.create("`+C+'", data); });')},a.prototype.writeFile=function(b,C,h,c,g){var L=this._getEntryPointsMap();if(L.hasOwnProperty(C)){for(var S=h.toUrl(C+".nls.js"),_=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=L[C],i={},r=0;r<n.length;r++)i[n[r]]=a.BUILD_MAP[n[r]];_.push('define("'+C+'.nls", '+JSON.stringify(i,null,"	")+");"),c(S,_.join(`\r
`))}},a.prototype.finishBuild=function(b){b("nls.metadata.json",JSON.stringify({keys:a.BUILD_MAP_KEYS,messages:a.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},a.DEFAULT_TAG="i-default",a.BUILD_MAP={},a.BUILD_MAP_KEYS={},a}();F.NLSPlugin=u,function(){G("vs/nls",new u)}()})(fe||(fe={})),G(Q[15],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class M{constructor(P,s,E,l){this.originalStart=P,this.originalLength=s,this.modifiedStart=E,this.modifiedLength=l}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=M}),G(Q[4],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(v=>{v(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}t.ErrorHandler=M,t.errorHandler=new M;function D(o){t.errorHandler.setUnexpectedErrorHandler(o)}t.setUnexpectedErrorHandler=D;function P(o){u(o)||t.errorHandler.onUnexpectedError(o)}t.onUnexpectedError=P;function s(o){u(o)||t.errorHandler.onUnexpectedExternalError(o)}t.onUnexpectedExternalError=s;function E(o){if(o instanceof Error){let{name:f,message:v}=o;const d=o.stacktrace||o.stack;return{$isError:!0,name:f,message:v,stack:d}}return o}t.transformErrorForSerialization=E;const l="Canceled";function u(o){return o instanceof Error&&o.name===l&&o.message===l}t.isPromiseCanceledError=u;class a extends Error{constructor(){super(l);this.name=this.message}}t.CancellationError=a;function b(){const o=new Error(l);return o.name=o.message,o}t.canceled=b;function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}t.illegalArgument=C;function h(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}t.illegalState=h;function c(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=c;function g(o){const f=new Error(`${o} has been disposed`);return f.name="DISPOSED",f}t.disposed=g;function L(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}t.getErrorMessage=L;class S extends Error{constructor(f){super("NotImplemented");f&&(this.message=f)}}t.NotImplementedError=S;class _ extends Error{constructor(f){super("NotSupported");f&&(this.message=f)}}t.NotSupportedError=_;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(o){const f=o;return f instanceof Error&&Array.isArray(f.actions)}t.isErrorWithActions=i;function r(o,f=Object.create(null)){const v=new Error(o);return f.actions&&(v.actions=f.actions),v}t.createErrorWithActions=r}),G(Q[7],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function M(D){const P=this;let s=!1,E;return function(){return s||(s=!0,E=D.apply(P,arguments)),E}}t.once=M}),G(Q[16],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var M;(function(D){function P(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}D.is=P;const s=Object.freeze([]);function E(){return s}D.empty=E;function*l(o){yield o}D.single=l;function u(o){return o||s}D.from=u;function a(o){return!o||o[Symbol.iterator]().next().done===!0}D.isEmpty=a;function b(o){return o[Symbol.iterator]().next().value}D.first=b;function C(o,f){for(const v of o)if(f(v))return!0;return!1}D.some=C;function h(o,f){for(const v of o)if(f(v))return v}D.find=h;function*c(o,f){for(const v of o)f(v)&&(yield v)}D.filter=c;function*g(o,f){for(const v of o)yield f(v)}D.map=g;function*L(...o){for(const f of o)for(const v of f)yield v}D.concat=L;function*S(o){for(const f of o)for(const v of f)yield v}D.concatNested=S;function _(o,f,v){let d=v;for(const m of o)d=f(d,m);return d}D.reduce=_;function*n(o,f,v=o.length){for(f<0&&(f+=o.length),v<0?v+=o.length:v>o.length&&(v=o.length);f<v;f++)yield o[f]}D.slice=n;function i(o,f=Number.POSITIVE_INFINITY){const v=[];if(f===0)return[v,o];const d=o[Symbol.iterator]();for(let m=0;m<f;m++){const w=d.next();if(w.done)return[v,D.empty()];v.push(w.value)}return[v,{[Symbol.iterator](){return d}}]}D.consume=i;function r(o,f,v=(d,m)=>d===m){const d=o[Symbol.iterator](),m=f[Symbol.iterator]();for(;;){const w=d.next(),N=m.next();if(w.done!==N.done)return!1;if(w.done)return!0;if(!v(w.value,N.value))return!1}}D.equals=r})(M=t.Iterable||(t.Iterable={}))}),G(Q[17],X([0,1,4]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(D=t.KeyCode||(t.KeyCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const s=new P,E=new P,l=new P;(function(){function n(i,r,o=r,f=o){s.define(i,r),E.define(i,o),l.define(i,f)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function i(d){return s.keyCodeToStr(d)}n.toString=i;function r(d){return s.strToKeyCode(d)}n.fromString=r;function o(d){return E.keyCodeToStr(d)}n.toUserSettingsUS=o;function f(d){return l.keyCodeToStr(d)}n.toUserSettingsGeneral=f;function v(d){return E.strToKeyCode(d)||l.strToKeyCode(d)}n.fromUserSettings=v})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(a||(a={}));var b;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(b=t.KeyMod||(t.KeyMod={}));function C(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=C;function h(n,i){if(n===0)return null;const r=(n&65535)>>>0,o=(n&4294901760)>>>16;return o!==0?new L([c(r,i),c(o,i)]):new L([c(r,i)])}t.createKeybinding=h;function c(n,i){const r=!!(n&2048),o=!!(n&256),f=i===2?o:r,v=!!(n&1024),d=!!(n&512),m=i===2?r:o,w=n&255;return new g(f,v,d,m,w)}t.createSimpleKeybinding=c;class g{constructor(i,r,o,f,v){this.ctrlKey=i,this.shiftKey=r,this.altKey=o,this.metaKey=f,this.keyCode=v}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",o=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${i}${r}${o}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new L([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=g;class L{constructor(i){if(i.length===0)throw(0,M.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,o=this.parts.length;r<o;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=L;class S{constructor(i,r,o,f,v,d){this.ctrlKey=i,this.shiftKey=r,this.altKey=o,this.metaKey=f,this.keyLabel=v,this.keyAriaLabel=d}}t.ResolvedKeybindingPart=S;class _{}t.ResolvedKeybinding=_}),G(Q[8],X([0,1,7,16]),function(F,t,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.trackDisposable=t.setDisposableTracker=void 0;const P=!1;let s=null;function E(i){s=i}if(t.setDisposableTracker=E,P){const i="__is_disposable_tracked__";s=new class{trackDisposable(r){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(o)},3e3)}markTracked(r){if(r&&r!==L.None)try{r[i]=!0}catch(o){}}}}function l(i){!s||s.markTracked(i)}function u(i){return s&&s.trackDisposable(i),i}t.trackDisposable=u;class a extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}t.MultiDisposeError=a;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}t.isDisposable=b;function C(i){if(D.Iterable.is(i)){let r=[];for(const o of i)if(o){l(o);try{o.dispose()}catch(f){r.push(f)}}if(r.length===1)throw r[0];if(r.length>1)throw new a(r);return Array.isArray(i)?[]:i}else if(i)return l(i),i.dispose(),i}t.dispose=C;function h(...i){return i.forEach(l),c(()=>C(i))}t.combinedDisposable=h;function c(i){const r=u({dispose:()=>{l(r),i()}});return r}t.toDisposable=c;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return l(r),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}t.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this._store=new g,u(this)}dispose(){l(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}t.Disposable=L,L.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,u(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){var o;this._isDisposed||r===this._value||((o=this._value)===null||o===void 0||o.dispose(),r&&l(r),this._value=r)}clear(){this.value=void 0}dispose(){var r;this._isDisposed=!0,l(this),(r=this._value)===null||r===void 0||r.dispose(),this._value=void 0}}t.MutableDisposable=S;class _{constructor(){this.references=new Map}acquire(r,...o){let f=this.references.get(r);f||(f={counter:0,object:this.createReferencedObject(r,...o)},this.references.set(r,f));const{object:v}=f,d=(0,M.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(r,f.object),this.references.delete(r))});return f.counter++,{object:v,dispose:d}}}t.ReferenceCollection=_;class n{constructor(r){this.object=r}dispose(){}}t.ImmortalReference=n}),G(Q[18],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class M{constructor(s){this.element=s,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class D{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(s){return this._insert(s,!1)}push(s){return this._insert(s,!0)}_insert(s,E){const l=new M(s);if(this._first===M.Undefined)this._first=l,this._last=l;else if(E){const a=this._last;this._last=l,l.prev=a,a.next=l}else{const a=this._first;this._first=l,l.next=a,a.prev=l}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(l))}}shift(){if(this._first!==M.Undefined){const s=this._first.element;return this._remove(this._first),s}}pop(){if(this._last!==M.Undefined){const s=this._last.element;return this._remove(this._last),s}}_remove(s){if(s.prev!==M.Undefined&&s.next!==M.Undefined){const E=s.prev;E.next=s.next,s.next.prev=E}else s.prev===M.Undefined&&s.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):s.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):s.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let s=this._first;for(;s!==M.Undefined;)yield s.element,s=s.next}}t.LinkedList=D}),G(Q[2],X([0,1]),function(F,t){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=t.globals=void 0;const D="en";let P=!1,s=!1,E=!1,l=!1,u=!1,a=!1,b=!1,C,h=D,c,g;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let L;typeof process!="undefined"?L=process:typeof t.globals.vscode!="undefined"&&(L=t.globals.vscode.process);const S=typeof((M=L==null?void 0:L.versions)===null||M===void 0?void 0:M.electron)=="string"&&L.type==="renderer";if(t.isElectronSandboxed=S&&(L==null?void 0:L.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const m=L==null?void 0:L.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof m=="string")return m==="none"||m==="code"||m==="bypassHeatCheck"||m==="bypassHeatCheckAndEagerCompile"?m:"bypassHeatCheck"})(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)g=navigator.userAgent,P=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,b=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=g.indexOf("Linux")>=0,a=!0,C=navigator.language,h=C;else if(typeof L=="object"){P=L.platform==="win32",s=L.platform==="darwin",E=L.platform==="linux",l=E&&!!L.env.SNAP&&!!L.env.SNAP_REVISION,C=D,h=D;const m=L.env.VSCODE_NLS_CONFIG;if(m)try{const w=JSON.parse(m),N=w.availableLanguages["*"];C=w.locale,h=N||D,c=w._translationsConfigFile}catch(w){}u=!0}else console.error("Unable to resolve platform.");var _;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(_=t.Platform||(t.Platform={}));function n(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=n;let i=0;s?i=1:P?i=3:E&&(i=2),t.isWindows=P,t.isMacintosh=s,t.isLinux=E,t.isLinuxSnap=l,t.isNative=u,t.isWeb=a,t.isIOS=b,t.platform=i,t.userAgent=g,t.language=h;var r;(function(m){function w(){return t.language}m.value=w;function N(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}m.isDefaultVariant=N;function p(){return t.language==="en"}m.isDefault=p})(r=t.Language||(t.Language={})),t.locale=C,t.translationsConfigFile=c,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let N=[];t.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let R=0,y=N.length;R<y;R++){const q=N[R];if(q.id===I.data.vscodeSetImmediateId){N.splice(R,1),q.callback();return}}});let p=0;return I=>{const R=++p;N.push({id:R,callback:I}),t.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof(L==null?void 0:L.nextTick)=="function")return L.nextTick.bind(L);const w=Promise.resolve();return N=>w.then(N)}();var o;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(o=t.OperatingSystem||(t.OperatingSystem={})),t.OS=s||b?2:P?1:3;let f=!0,v=!1;function d(){if(!v){v=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,f=new Uint16Array(m.buffer)[0]===(2<<8)+1}return f}t.isLittleEndian=d}),G(Q[19],X([0,1,2]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let D;if(typeof process!="undefined")D={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}};else if(typeof M.globals.vscode!="undefined"){const P=M.globals.vscode.process;D={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(s){return(0,M.setImmediate)(s)}}}else D={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},nextTick(P){return(0,M.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.platform=D.platform,t.nextTick=D.nextTick}),G(Q[20],X([0,1,19]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const D=65,P=97,s=90,E=122,l=46,u=47,a=92,b=58,C=63;class h extends Error{constructor(r,o,f){let v;typeof o=="string"&&o.indexOf("not ")===0?(v="must not be",o=o.replace(/^not /,"")):v="must be";const d=r.indexOf(".")!==-1?"property":"argument";let m=`The "${r}" ${d} ${v} of type ${o}`;m+=`. Received type ${typeof f}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,r){if(typeof i!="string")throw new h(r,"string",i)}function g(i){return i===u||i===a}function L(i){return i===u}function S(i){return i>=D&&i<=s||i>=P&&i<=E}function _(i,r,o,f){let v="",d=0,m=-1,w=0,N=0;for(let p=0;p<=i.length;++p){if(p<i.length)N=i.charCodeAt(p);else{if(f(N))break;N=u}if(f(N)){if(!(m===p-1||w===1))if(w===2){if(v.length<2||d!==2||v.charCodeAt(v.length-1)!==l||v.charCodeAt(v.length-2)!==l){if(v.length>2){const I=v.lastIndexOf(o);I===-1?(v="",d=0):(v=v.slice(0,I),d=v.length-1-v.lastIndexOf(o)),m=p,w=0;continue}else if(v.length!==0){v="",d=0,m=p,w=0;continue}}r&&(v+=v.length>0?`${o}..`:"..",d=2)}else v.length>0?v+=`${o}${i.slice(m+1,p)}`:v=i.slice(m+1,p),d=p-m-1;m=p,w=0}else N===l&&w!==-1?++w:w=-1}return v}function n(i,r){if(r===null||typeof r!="object")throw new h("pathObject","Object",r);const o=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return o?o===r.root?`${o}${f}`:`${o}${i}${f}`:f}t.win32={resolve(...i){let r="",o="",f=!1;for(let v=i.length-1;v>=-1;v--){let d;if(v>=0){if(d=i[v],c(d,"path"),d.length===0)continue}else r.length===0?d=M.cwd():(d=M.env[`=${r}`]||M.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==r.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${r}\\`));const m=d.length;let w=0,N="",p=!1;const I=d.charCodeAt(0);if(m===1)g(I)&&(w=1,p=!0);else if(g(I))if(p=!0,g(d.charCodeAt(1))){let R=2,y=R;for(;R<m&&!g(d.charCodeAt(R));)R++;if(R<m&&R!==y){const q=d.slice(y,R);for(y=R;R<m&&g(d.charCodeAt(R));)R++;if(R<m&&R!==y){for(y=R;R<m&&!g(d.charCodeAt(R));)R++;(R===m||R!==y)&&(N=`\\\\${q}\\${d.slice(y,R)}`,w=R)}}}else w=1;else S(I)&&d.charCodeAt(1)===b&&(N=d.slice(0,2),w=2,m>2&&g(d.charCodeAt(2))&&(p=!0,w=3));if(N.length>0)if(r.length>0){if(N.toLowerCase()!==r.toLowerCase())continue}else r=N;if(f){if(r.length>0)break}else if(o=`${d.slice(w)}\\${o}`,f=p,p&&r.length>0)break}return o=_(o,!f,"\\",g),f?`${r}\\${o}`:`${r}${o}`||"."},normalize(i){c(i,"path");const r=i.length;if(r===0)return".";let o=0,f,v=!1;const d=i.charCodeAt(0);if(r===1)return L(d)?"\\":i;if(g(d))if(v=!0,g(i.charCodeAt(1))){let w=2,N=w;for(;w<r&&!g(i.charCodeAt(w));)w++;if(w<r&&w!==N){const p=i.slice(N,w);for(N=w;w<r&&g(i.charCodeAt(w));)w++;if(w<r&&w!==N){for(N=w;w<r&&!g(i.charCodeAt(w));)w++;if(w===r)return`\\\\${p}\\${i.slice(N)}\\`;w!==N&&(f=`\\\\${p}\\${i.slice(N,w)}`,o=w)}}}else o=1;else S(d)&&i.charCodeAt(1)===b&&(f=i.slice(0,2),o=2,r>2&&g(i.charCodeAt(2))&&(v=!0,o=3));let m=o<r?_(i.slice(o),!v,"\\",g):"";return m.length===0&&!v&&(m="."),m.length>0&&g(i.charCodeAt(r-1))&&(m+="\\"),f===void 0?v?`\\${m}`:m:v?`${f}\\${m}`:`${f}${m}`},isAbsolute(i){c(i,"path");const r=i.length;if(r===0)return!1;const o=i.charCodeAt(0);return g(o)||r>2&&S(o)&&i.charCodeAt(1)===b&&g(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,o;for(let d=0;d<i.length;++d){const m=i[d];c(m,"path"),m.length>0&&(r===void 0?r=o=m:r+=`\\${m}`)}if(r===void 0)return".";let f=!0,v=0;if(typeof o=="string"&&g(o.charCodeAt(0))){++v;const d=o.length;d>1&&g(o.charCodeAt(1))&&(++v,d>2&&(g(o.charCodeAt(2))?++v:f=!1))}if(f){for(;v<r.length&&g(r.charCodeAt(v));)v++;v>=2&&(r=`\\${r.slice(v)}`)}return t.win32.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r)return"";const o=t.win32.resolve(i),f=t.win32.resolve(r);if(o===f||(i=o.toLowerCase(),r=f.toLowerCase(),i===r))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===a;)v++;let d=i.length;for(;d-1>v&&i.charCodeAt(d-1)===a;)d--;const m=d-v;let w=0;for(;w<r.length&&r.charCodeAt(w)===a;)w++;let N=r.length;for(;N-1>w&&r.charCodeAt(N-1)===a;)N--;const p=N-w,I=m<p?m:p;let R=-1,y=0;for(;y<I;y++){const j=i.charCodeAt(v+y);if(j!==r.charCodeAt(w+y))break;j===a&&(R=y)}if(y!==I){if(R===-1)return f}else{if(p>I){if(r.charCodeAt(w+y)===a)return f.slice(w+y+1);if(y===2)return f.slice(w+y)}m>I&&(i.charCodeAt(v+y)===a?R=y:y===2&&(R=3)),R===-1&&(R=0)}let q="";for(y=v+R+1;y<=d;++y)(y===d||i.charCodeAt(y)===a)&&(q+=q.length===0?"..":"\\..");return w+=R,q.length>0?`${q}${f.slice(w,N)}`:(f.charCodeAt(w)===a&&++w,f.slice(w,N))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===a){if(r.charCodeAt(1)===a){const o=r.charCodeAt(2);if(o!==C&&o!==l)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(S(r.charCodeAt(0))&&r.charCodeAt(1)===b&&r.charCodeAt(2)===a)return`\\\\?\\${r}`;return i},dirname(i){c(i,"path");const r=i.length;if(r===0)return".";let o=-1,f=0;const v=i.charCodeAt(0);if(r===1)return g(v)?i:".";if(g(v)){if(o=f=1,g(i.charCodeAt(1))){let w=2,N=w;for(;w<r&&!g(i.charCodeAt(w));)w++;if(w<r&&w!==N){for(N=w;w<r&&g(i.charCodeAt(w));)w++;if(w<r&&w!==N){for(N=w;w<r&&!g(i.charCodeAt(w));)w++;if(w===r)return i;w!==N&&(o=f=w+1)}}}}else S(v)&&i.charCodeAt(1)===b&&(o=r>2&&g(i.charCodeAt(2))?3:2,f=o);let d=-1,m=!0;for(let w=r-1;w>=f;--w)if(g(i.charCodeAt(w))){if(!m){d=w;break}}else m=!1;if(d===-1){if(o===-1)return".";d=o}return i.slice(0,d)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let o=0,f=-1,v=!0,d;if(i.length>=2&&S(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(o=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let m=r.length-1,w=-1;for(d=i.length-1;d>=o;--d){const N=i.charCodeAt(d);if(g(N)){if(!v){o=d+1;break}}else w===-1&&(v=!1,w=d+1),m>=0&&(N===r.charCodeAt(m)?--m==-1&&(f=d):(m=-1,f=w))}return o===f?f=w:f===-1&&(f=i.length),i.slice(o,f)}for(d=i.length-1;d>=o;--d)if(g(i.charCodeAt(d))){if(!v){o=d+1;break}}else f===-1&&(v=!1,f=d+1);return f===-1?"":i.slice(o,f)},extname(i){c(i,"path");let r=0,o=-1,f=0,v=-1,d=!0,m=0;i.length>=2&&i.charCodeAt(1)===b&&S(i.charCodeAt(0))&&(r=f=2);for(let w=i.length-1;w>=r;--w){const N=i.charCodeAt(w);if(g(N)){if(!d){f=w+1;break}continue}v===-1&&(d=!1,v=w+1),N===l?o===-1?o=w:m!==1&&(m=1):o!==-1&&(m=-1)}return o===-1||v===-1||m===0||m===1&&o===v-1&&o===f+1?"":i.slice(o,v)},format:n.bind(null,"\\"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const o=i.length;let f=0,v=i.charCodeAt(0);if(o===1)return g(v)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(g(v)){if(f=1,g(i.charCodeAt(1))){let R=2,y=R;for(;R<o&&!g(i.charCodeAt(R));)R++;if(R<o&&R!==y){for(y=R;R<o&&g(i.charCodeAt(R));)R++;if(R<o&&R!==y){for(y=R;R<o&&!g(i.charCodeAt(R));)R++;R===o?f=R:R!==y&&(f=R+1)}}}}else if(S(v)&&i.charCodeAt(1)===b){if(o<=2)return r.root=r.dir=i,r;if(f=2,g(i.charCodeAt(2))){if(o===3)return r.root=r.dir=i,r;f=3}}f>0&&(r.root=i.slice(0,f));let d=-1,m=f,w=-1,N=!0,p=i.length-1,I=0;for(;p>=f;--p){if(v=i.charCodeAt(p),g(v)){if(!N){m=p+1;break}continue}w===-1&&(N=!1,w=p+1),v===l?d===-1?d=p:I!==1&&(I=1):d!==-1&&(I=-1)}return w!==-1&&(d===-1||I===0||I===1&&d===w-1&&d===m+1?r.base=r.name=i.slice(m,w):(r.name=i.slice(m,d),r.base=i.slice(m,w),r.ext=i.slice(d,w))),m>0&&m!==f?r.dir=i.slice(0,m-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",o=!1;for(let f=i.length-1;f>=-1&&!o;f--){const v=f>=0?i[f]:M.cwd();c(v,"path"),v.length!==0&&(r=`${v}/${r}`,o=v.charCodeAt(0)===u)}return r=_(r,!o,"/",L),o?`/${r}`:r.length>0?r:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u,o=i.charCodeAt(i.length-1)===u;return i=_(i,!r,"/",L),i.length===0?r?"/":o?"./":".":(o&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let r;for(let o=0;o<i.length;++o){const f=i[o];c(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const o=1,f=i.length,v=f-o,d=1,m=r.length-d,w=v<m?v:m;let N=-1,p=0;for(;p<w;p++){const R=i.charCodeAt(o+p);if(R!==r.charCodeAt(d+p))break;R===u&&(N=p)}if(p===w)if(m>w){if(r.charCodeAt(d+p)===u)return r.slice(d+p+1);if(p===0)return r.slice(d+p)}else v>w&&(i.charCodeAt(o+p)===u?N=p:p===0&&(N=0));let I="";for(p=o+N+1;p<=f;++p)(p===f||i.charCodeAt(p)===u)&&(I+=I.length===0?"..":"/..");return`${I}${r.slice(d+N)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u;let o=-1,f=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===u){if(!f){o=v;break}}else f=!1;return o===-1?r?"/":".":r&&o===1?"//":i.slice(0,o)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let o=0,f=-1,v=!0,d;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let m=r.length-1,w=-1;for(d=i.length-1;d>=0;--d){const N=i.charCodeAt(d);if(N===u){if(!v){o=d+1;break}}else w===-1&&(v=!1,w=d+1),m>=0&&(N===r.charCodeAt(m)?--m==-1&&(f=d):(m=-1,f=w))}return o===f?f=w:f===-1&&(f=i.length),i.slice(o,f)}for(d=i.length-1;d>=0;--d)if(i.charCodeAt(d)===u){if(!v){o=d+1;break}}else f===-1&&(v=!1,f=d+1);return f===-1?"":i.slice(o,f)},extname(i){c(i,"path");let r=-1,o=0,f=-1,v=!0,d=0;for(let m=i.length-1;m>=0;--m){const w=i.charCodeAt(m);if(w===u){if(!v){o=m+1;break}continue}f===-1&&(v=!1,f=m+1),w===l?r===-1?r=m:d!==1&&(d=1):r!==-1&&(d=-1)}return r===-1||f===-1||d===0||d===1&&r===f-1&&r===o+1?"":i.slice(r,f)},format:n.bind(null,"/"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const o=i.charCodeAt(0)===u;let f;o?(r.root="/",f=1):f=0;let v=-1,d=0,m=-1,w=!0,N=i.length-1,p=0;for(;N>=f;--N){const I=i.charCodeAt(N);if(I===u){if(!w){d=N+1;break}continue}m===-1&&(w=!1,m=N+1),I===l?v===-1?v=N:p!==1&&(p=1):v!==-1&&(p=-1)}if(m!==-1){const I=d===0&&o?1:d;v===-1||p===0||p===1&&v===m-1&&v===d+1?r.base=r.name=i.slice(I,m):(r.name=i.slice(I,v),r.base=i.slice(I,m),r.ext=i.slice(v,m))}return d>0?r.dir=i.slice(0,d-1):o&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=M.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=M.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=M.platform==="win32"?t.win32.join:t.posix.join,t.resolve=M.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=M.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=M.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=M.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=M.platform==="win32"?t.win32.extname:t.posix.extname,t.format=M.platform==="win32"?t.win32.format:t.posix.format,t.parse=M.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=M.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=M.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=M.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),G(Q[9],X([0,1,2]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const D=M.globals.performance&&typeof M.globals.performance.now=="function";class P{constructor(E){this._highResolution=D&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new P(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}t.StopWatch=P}),G(Q[10],X([0,1,4,7,8,18,9]),function(F,t,M,D,P,s,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var l;(function(_){_.None=()=>P.Disposable.None;function n(e){return(B,H=null,W)=>{let z=!1,Z;return Z=e(x=>{if(!z)return Z?Z.dispose():z=!0,B.call(H,x)},null,W),z&&Z.dispose(),Z}}_.once=n;function i(e,B){return m((H,W=null,z)=>e(Z=>H.call(W,B(Z)),null,z))}_.map=i;function r(e,B){return m((H,W=null,z)=>e(Z=>{B(Z),H.call(W,Z)},null,z))}_.forEach=r;function o(e,B){return m((H,W=null,z)=>e(Z=>B(Z)&&H.call(W,Z),null,z))}_.filter=o;function f(e){return e}_.signal=f;function v(...e){return(B,H=null,W)=>(0,P.combinedDisposable)(...e.map(z=>z(Z=>B.call(H,Z),null,W)))}_.any=v;function d(e,B,H){let W=H;return i(e,z=>(W=B(W,z),W))}_.reduce=d;function m(e){let B;const H=new h({onFirstListenerAdd(){B=e(H.fire,H)},onLastListenerRemove(){B.dispose()}});return H.event}_.snapshot=m;function w(e,B,H=100,W=!1,z){let Z,x,te,le=0;const ue=new h({leakWarningThreshold:z,onFirstListenerAdd(){Z=e(ae=>{le++,x=B(x,ae),W&&!te&&(ue.fire(x),x=void 0),clearTimeout(te),te=setTimeout(()=>{const ce=x;x=void 0,te=void 0,(!W||le>1)&&ue.fire(ce),le=0},H)})},onLastListenerRemove(){Z.dispose()}});return ue.event}_.debounce=w;function N(e){const B=new Date().getTime();return i(n(e),H=>new Date().getTime()-B)}_.stopwatch=N;function p(e){let B=!0,H;return o(e,W=>{const z=B||W!==H;return B=!1,H=W,z})}_.latch=p;function I(e,B=!1,H=[]){let W=H.slice(),z=e(te=>{W?W.push(te):x.fire(te)});const Z=()=>{W&&W.forEach(te=>x.fire(te)),W=null},x=new h({onFirstListenerAdd(){z||(z=e(te=>x.fire(te)))},onFirstListenerDidAdd(){W&&(B?setTimeout(Z):Z())},onLastListenerRemove(){z&&z.dispose(),z=null}});return x.event}_.buffer=I;class R{constructor(B){this.event=B}map(B){return new R(i(this.event,B))}forEach(B){return new R(r(this.event,B))}filter(B){return new R(o(this.event,B))}reduce(B,H){return new R(d(this.event,B,H))}latch(){return new R(p(this.event))}debounce(B,H=100,W=!1,z){return new R(w(this.event,B,H,W,z))}on(B,H,W){return this.event(B,H,W)}once(B,H,W){return n(this.event)(B,H,W)}}function y(e){return new R(e)}_.chain=y;function q(e,B,H=W=>W){const W=(...te)=>x.fire(H(...te)),z=()=>e.on(B,W),Z=()=>e.removeListener(B,W),x=new h({onFirstListenerAdd:z,onLastListenerRemove:Z});return x.event}_.fromNodeEventEmitter=q;function j(e,B,H=W=>W){const W=(...te)=>x.fire(H(...te)),z=()=>e.addEventListener(B,W),Z=()=>e.removeEventListener(B,W),x=new h({onFirstListenerAdd:z,onLastListenerRemove:Z});return x.event}_.fromDOMEventEmitter=j;function J(e){const B=new h;let H=!1;return e.then(void 0,()=>null).then(()=>{H?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),H=!0,B.event}_.fromPromise=J;function V(e){return new Promise(B=>n(e)(B))}_.toPromise=V})(l=t.Event||(t.Event={}));class u{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${u._idPool++}`}start(n){this._stopWatch=new E.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let a=-1;function b(_){const n=a;return a=_,{dispose(){a=n}}}t.setGlobalLeakWarningThreshold=b;class C{constructor(n,i=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n){let i=a;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),!(i<=0||n<i)){this._stacks||(this._stacks=new Map);const r=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(r)||0;if(this._stacks.set(r,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let f,v=0;for(const[d,m]of this._stacks)(!f||v<m)&&(f=d,v=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${v}):`),console.warn(f)}return()=>{const f=this._stacks.get(r)||0;this._stacks.set(r,f-1)}}}}class h{constructor(n){var i;this._disposed=!1,this._options=n,this._leakageMon=a>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((i=this._options)===null||i===void 0?void 0:i._profName)?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(n,i,r)=>{var o;this._listeners||(this._listeners=new s.LinkedList);const f=this._listeners.isEmpty();f&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const v=this._listeners.push(i?[n,i]:n);f&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,i);const d=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let m;return m={dispose:()=>{d&&d(),m.dispose=h._noop,this._disposed||(v(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},r instanceof P.DisposableStore?r.add(m):Array.isArray(r)&&r.push(m),m}),this._event}fire(n){var i,r;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,n]);for((i=this._perfMon)===null||i===void 0||i.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,f]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,f):o[0].call(o[1],f)}catch(v){(0,M.onUnexpectedError)(v)}}(r=this._perfMon)===null||r===void 0||r.stop()}}dispose(){var n,i,r;(n=this._listeners)===null||n===void 0||n.clear(),(i=this._deliveryQueue)===null||i===void 0||i.clear(),(r=this._leakageMon)===null||r===void 0||r.dispose(),this._disposed=!0}}t.Emitter=h,h._noop=function(){};class c extends h{constructor(n){super(n);this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=n==null?void 0:n.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}t.PauseableEmitter=c;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const r=()=>{this.hasListeners&&this.unhook(i);const o=this.events.indexOf(i);this.events.splice(o,1)};return(0,P.toDisposable)((0,D.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=g;class L{constructor(){this.buffers=[]}wrapEvent(n){return(i,r,o)=>n(f=>{const v=this.buffers[this.buffers.length-1];v?v.push(()=>i.call(r,f)):i.call(r,f)},void 0,o)}bufferEvents(n){const i=[];this.buffers.push(i);const r=n();return this.buffers.pop(),i.forEach(o=>o()),r}}t.EventBufferer=L;class S{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=P.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=S}),G(Q[21],X([0,1,10]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const D=Object.freeze(function(l,u){const a=setTimeout(l.bind(u),0);return{dispose(){clearTimeout(a)}}});var P;(function(l){function u(a){return a===l.None||a===l.Cancelled||a instanceof s?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}l.isCancellationToken=u,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(P=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=P.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=E}),G(Q[5],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function M(A){return!A||typeof A!="string"?!0:A.trim().length===0}t.isFalsyOrWhitespace=M;const D=/{(\d+)}/g;function P(A,...U){return U.length===0?A:A.replace(D,function(T,k){const O=parseInt(k,10);return isNaN(O)||O<0||O>=U.length?T:U[O]})}t.format=P;function s(A){return A.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.escape=s;function E(A){return A.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=E;function l(A,U){let T=0;const k=U.charCodeAt(0);for(let O=A.length-1;O>=0;O--)A.charCodeAt(O)===k&&T++;return T}t.count=l;function u(A,U,T="\u2026"){return A.length<=U?A:`${A.substr(0,U)}${T}`}t.truncate=u;function a(A,U=" "){const T=b(A,U);return C(T,U)}t.trim=a;function b(A,U){if(!A||!U)return A;const T=U.length;if(T===0||A.length===0)return A;let k=0;for(;A.indexOf(U,k)===k;)k=k+T;return A.substring(k)}t.ltrim=b;function C(A,U){if(!A||!U)return A;const T=U.length,k=A.length;if(T===0||k===0)return A;let O=k,Y=-1;for(;Y=A.lastIndexOf(U,O-1),!(Y===-1||Y+T!==O);){if(Y===0)return"";O=Y}return A.substring(0,O)}t.rtrim=C;function h(A){return A.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=h;function c(A){return A.replace(/\*/g,"")}t.stripWildcards=c;function g(A,U,T={}){if(!A)throw new Error("Cannot create regex from empty string");U||(A=E(A)),T.wholeWord&&(/\B/.test(A.charAt(0))||(A="\\b"+A),/\B/.test(A.charAt(A.length-1))||(A=A+"\\b"));let k="";return T.global&&(k+="g"),T.matchCase||(k+="i"),T.multiline&&(k+="m"),T.unicode&&(k+="u"),new RegExp(A,k)}t.createRegExp=g;function L(A){return A.source==="^"||A.source==="^$"||A.source==="$"||A.source==="^\\s*$"?!1:!!(A.exec("")&&A.lastIndex===0)}t.regExpLeadsToEndlessLoop=L;function S(A){return!!A.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function _(A){return(A.global?"g":"")+(A.ignoreCase?"i":"")+(A.multiline?"m":"")+(A.unicode?"u":"")}t.regExpFlags=_;function n(A){return A.split(/\r\n|\r|\n/)}t.splitLines=n;function i(A){for(let U=0,T=A.length;U<T;U++){const k=A.charCodeAt(U);if(k!==32&&k!==9)return U}return-1}t.firstNonWhitespaceIndex=i;function r(A,U=0,T=A.length){for(let k=U;k<T;k++){const O=A.charCodeAt(k);if(O!==32&&O!==9)return A.substring(U,k)}return A.substring(U,T)}t.getLeadingWhitespace=r;function o(A,U=A.length-1){for(let T=U;T>=0;T--){const k=A.charCodeAt(T);if(k!==32&&k!==9)return T}return-1}t.lastNonWhitespaceIndex=o;function f(A,U){return A<U?-1:A>U?1:0}t.compare=f;function v(A,U,T=0,k=A.length,O=0,Y=U.length){for(;T<k&&O<Y;T++,O++){let ne=A.charCodeAt(T),ie=U.charCodeAt(O);if(ne<ie)return-1;if(ne>ie)return 1}const $=k-T,ee=Y-O;return $<ee?-1:$>ee?1:0}t.compareSubstring=v;function d(A,U){return m(A,U,0,A.length,0,U.length)}t.compareIgnoreCase=d;function m(A,U,T=0,k=A.length,O=0,Y=U.length){for(;T<k&&O<Y;T++,O++){let ne=A.charCodeAt(T),ie=U.charCodeAt(O);if(ne!==ie){const se=ne-ie;if(!(se===32&&N(ie))&&!(se===-32&&N(ne)))return w(ne)&&w(ie)?se:v(A.toLowerCase(),U.toLowerCase(),T,k,O,Y)}}const $=k-T,ee=Y-O;return $<ee?-1:$>ee?1:0}t.compareSubstringIgnoreCase=m;function w(A){return A>=97&&A<=122}t.isLowerAsciiLetter=w;function N(A){return A>=65&&A<=90}t.isUpperAsciiLetter=N;function p(A){return w(A)||N(A)}function I(A,U){return A.length===U.length&&R(A,U)}t.equalsIgnoreCase=I;function R(A,U,T=A.length){for(let k=0;k<T;k++){const O=A.charCodeAt(k),Y=U.charCodeAt(k);if(O!==Y){if(p(O)&&p(Y)){const $=Math.abs(O-Y);if($!==0&&$!==32)return!1}else if(String.fromCharCode(O).toLowerCase()!==String.fromCharCode(Y).toLowerCase())return!1}}return!0}function y(A,U){const T=U.length;return U.length>A.length?!1:R(A,U,T)}t.startsWithIgnoreCase=y;function q(A,U){let T,k=Math.min(A.length,U.length);for(T=0;T<k;T++)if(A.charCodeAt(T)!==U.charCodeAt(T))return T;return k}t.commonPrefixLength=q;function j(A,U){let T,k=Math.min(A.length,U.length);const O=A.length-1,Y=U.length-1;for(T=0;T<k;T++)if(A.charCodeAt(O-T)!==U.charCodeAt(Y-T))return T;return k}t.commonSuffixLength=j;function J(A){return 55296<=A&&A<=56319}t.isHighSurrogate=J;function V(A){return 56320<=A&&A<=57343}t.isLowSurrogate=V;function e(A,U){return(A-55296<<10)+(U-56320)+65536}t.computeCodePoint=e;function B(A,U,T){const k=A.charCodeAt(T);if(J(k)&&T+1<U){const O=A.charCodeAt(T+1);if(V(O))return e(k,O)}return k}t.getNextCodePoint=B;function H(A,U){const T=A.charCodeAt(U-1);if(V(T)&&U>1){const k=A.charCodeAt(U-2);if(J(k))return e(k,T)}return T}function W(A,U){const T=re.getInstance(),k=U,O=A.length,Y=B(A,O,U);U+=Y>=65536?2:1;let $=T.getGraphemeBreakType(Y);for(;U<O;){const ee=B(A,O,U),ne=T.getGraphemeBreakType(ee);if(oe($,ne))break;U+=ee>=65536?2:1,$=ne}return U-k}t.nextCharLength=W;function z(A,U){const T=re.getInstance(),k=U,O=H(A,U);U-=O>=65536?2:1;let Y=T.getGraphemeBreakType(O);for(;U>0;){const $=H(A,U),ee=T.getGraphemeBreakType($);if(oe(ee,Y))break;U-=$>=65536?2:1,Y=ee}return k-U}t.prevCharLength=z;function Z(A,U){const T=re.getInstance(),k=A.length,O=U,Y=B(A,k,U),$=T.getGraphemeBreakType(Y);U+=Y>=65536?2:1;let ee=$;for(;U<k;){const ie=B(A,k,U),se=T.getGraphemeBreakType(ie);if(oe(ee,se))break;U+=ie>=65536?2:1,ee=se}const ne=U;for(U=O,ee=$;U>0;){const ie=H(A,U),se=T.getGraphemeBreakType(ie);if(oe(se,ee))break;U-=ie>=65536?2:1,ee=se}return[U,ne]}function x(A,U){return U>0&&V(A.charCodeAt(U))?Z(A,U-1):Z(A,U)}t.getCharContainingOffset=x;function te(A){const U=A.length;let T=0,k=0;for(;k<U;){const $=B(A,U,k);k+=$>=65536?2:1,$<128?T+=1:$<2048?T+=2:$<65536?T+=3:T+=4}const O=new Uint8Array(T);k=0;let Y=0;for(;k<U;){const $=B(A,U,k);k+=$>=65536?2:1,$<128?O[Y++]=$:$<2048?(O[Y++]=192|($&1984)>>>6,O[Y++]=128|($&63)>>>0):$<65536?(O[Y++]=224|($&61440)>>>12,O[Y++]=128|($&4032)>>>6,O[Y++]=128|($&63)>>>0):(O[Y++]=240|($&1835008)>>>18,O[Y++]=128|($&258048)>>>12,O[Y++]=128|($&4032)>>>6,O[Y++]=128|($&63)>>>0)}return O}t.encodeUTF8=te;function le(A){const U=A.byteLength,T=[];let k=0;for(;k<U;){const O=A[k];let Y;if(O>=240&&k+3<U?Y=(A[k++]&7)<<18>>>0|(A[k++]&63)<<12>>>0|(A[k++]&63)<<6>>>0|(A[k++]&63)<<0>>>0:O>=224&&k+2<U?Y=(A[k++]&15)<<12>>>0|(A[k++]&63)<<6>>>0|(A[k++]&63)<<0>>>0:O>=192&&k+1<U?Y=(A[k++]&31)<<6>>>0|(A[k++]&63)<<0>>>0:Y=A[k++],Y>=0&&Y<=55295||Y>=57344&&Y<=65535)T.push(String.fromCharCode(Y));else if(Y>=65536&&Y<=1114111){const $=Y-65536,ee=55296+(($&1047552)>>>10),ne=56320+(($&1023)>>>0);T.push(String.fromCharCode(ee)),T.push(String.fromCharCode(ne))}else T.push(String.fromCharCode(65533))}return T.join("")}t.decodeUTF8=le;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(A){return ue.test(A)}t.containsRTL=ae;const ce=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(A){return ce.test(A)}t.containsEmoji=ve;const Le=/^[\t\n\r\x20-\x7E]*$/;function be(A){return Le.test(A)}t.isBasicASCII=be,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ee(A){return t.UNUSUAL_LINE_TERMINATORS.test(A)}t.containsUnusualLineTerminators=Ee;function Se(A){for(let U=0,T=A.length;U<T;U++)if(he(A.charCodeAt(U)))return!0;return!1}t.containsFullWidthCharacter=Se;function he(A){return A=+A,A>=11904&&A<=55215||A>=63744&&A<=64255||A>=65281&&A<=65374}t.isFullWidthCharacter=he;function Ae(A){return A>=127462&&A<=127487||A===8986||A===8987||A===9200||A===9203||A>=9728&&A<=10175||A===11088||A===11093||A>=127744&&A<=128591||A>=128640&&A<=128764||A>=128992&&A<=129003||A>=129280&&A<=129535||A>=129648&&A<=129750}t.isEmojiImprecise=Ae;function Ne(A,U){if(A.length<U)return A;const T=/\b/g;let k=0;for(;T.test(A)&&!(A.length-T.lastIndex<U);)k=T.lastIndex,T.lastIndex+=1;return A.substring(k).replace(/^\s/,"")}t.lcut=Ne;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Pe=/\x1b\[0?m/g;function Me(A){return A&&(A=A.replace(we,""),A=A.replace(Ce,""),A=A.replace(Pe,"")),A}t.removeAnsiEscapeCodes=Me,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(A){return!!(A&&A.length>0&&A.charCodeAt(0)===65279)}t.startsWithUTF8BOM=de;function pe(A){return de(A)?A.substr(1):A}t.stripUTF8BOM=pe;function De(A,U){if(!A||!U||A.length<U.length)return!1;const T=U.length,k=A.toLowerCase();let O=0,Y=-1;for(;O<T;){const $=k.indexOf(U[O],Y+1);if($<0)return!1;Y=$,O++}return!0}t.fuzzyContains=De;function Ue(A,U=!1){return A?(U&&(A=A.replace(/\\./g,"")),A.toLowerCase()!==A):!1}t.containsUppercaseCharacter=Ue;function Re(A){return A.charAt(0).toUpperCase()+A.slice(1)}t.uppercaseFirstLetter=Re;function Ie(A,U=1){if(U===0)return"";let T=-1;do T=A.indexOf(`
`,T+1),U--;while(U>0&&T>=0);return T===-1?A:(A[T-1]==="\r"&&T--,A.substr(0,T))}t.getNLines=Ie;function Fe(A){const U=90-65+1;return A=A%(2*U),A<U?String.fromCharCode(97+A):String.fromCharCode(65+A-U)}t.singleLetterHash=Fe;function Te(A){return re.getInstance().getGraphemeBreakType(A)}t.getGraphemeBreakType=Te;function oe(A,U){return A===0?U!==5&&U!==7:A===2&&U===3?!1:A===4||A===2||A===3||U===4||U===2||U===3?!0:!(A===8&&(U===8||U===9||U===11||U===12)||(A===11||A===9)&&(U===9||U===10)||(A===12||A===10)&&U===10||U===5||U===13||U===7||A===1||A===13&&U===14||A===6&&U===6)}t.breakBetweenGraphemeBreakType=oe;var ke;(function(A){A[A.Other=0]="Other",A[A.Prepend=1]="Prepend",A[A.CR=2]="CR",A[A.LF=3]="LF",A[A.Control=4]="Control",A[A.Extend=5]="Extend",A[A.Regional_Indicator=6]="Regional_Indicator",A[A.SpacingMark=7]="SpacingMark",A[A.L=8]="L",A[A.V=9]="V",A[A.T=10]="T",A[A.LV=11]="LV",A[A.LVT=12]="LVT",A[A.ZWJ=13]="ZWJ",A[A.Extended_Pictographic=14]="Extended_Pictographic"})(ke=t.GraphemeBreakType||(t.GraphemeBreakType={}));class re{constructor(){this._data=We()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const T=this._data,k=T.length/3;let O=1;for(;O<=k;)if(U<T[3*O])O=2*O;else if(U>T[3*O+1])O=2*O+1;else return T[3*O+2];return 0}}re._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),G(Q[22],X([0,1,5]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function D(_){return P(_,0)}t.hash=D;function P(_,n){switch(typeof _){case"object":return _===null?s(349,n):Array.isArray(_)?u(_,n):a(_,n);case"string":return l(_,n);case"boolean":return E(_,n);case"number":return s(_,n);case"undefined":return s(937,n);default:return s(617,n)}}t.doHash=P;function s(_,n){return(n<<5)-n+_|0}function E(_,n){return s(_?433:863,n)}function l(_,n){n=s(149417,n);for(let i=0,r=_.length;i<r;i++)n=s(_.charCodeAt(i),n);return n}t.stringHash=l;function u(_,n){return n=s(104579,n),_.reduce((i,r)=>P(r,i),n)}function a(_,n){return n=s(181387,n),Object.keys(_).sort().reduce((i,r)=>(i=l(r,i),P(_[r],i)),n)}class b{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=P(n,this._value),this._value}}t.Hasher=b;var C;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function h(_,n,i=32){const r=i-n,o=~((1<<r)-1);return(_<<n|(o&_)>>>r)>>>0}function c(_,n=0,i=_.byteLength,r=0){for(let o=0;o<i;o++)_[n+o]=r}function g(_,n,i="0"){for(;_.length<n;)_=i+_;return _}function L(_,n=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(i=>i.toString(16).padStart(2,"0")).join(""):g((_>>>0).toString(16),n/4)}t.toHexString=L;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i!==0){const r=this._buff;let o=this._buffLen,f=this._leftoverHighSurrogate,v,d;for(f!==0?(v=f,d=-1,f=0):(v=n.charCodeAt(0),d=0);;){let m=v;if(M.isHighSurrogate(v))if(d+1<i){const w=n.charCodeAt(d+1);M.isLowSurrogate(w)?(d++,m=M.computeCodePoint(v,w)):m=65533}else{f=v;break}else M.isLowSurrogate(v)&&(m=65533);if(o=this._push(r,o,m),d++,d<i)v=n.charCodeAt(d);else break}this._buffLen=o,this._leftoverHighSurrogate=f}}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),L(this._h0)+L(this._h1)+L(this._h2)+L(this._h3)+L(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=S._bigBlock32,i=this._buffDV;for(let p=0;p<64;p+=4)n.setUint32(p,i.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)n.setUint32(p,h(n.getUint32(p-12,!1)^n.getUint32(p-32,!1)^n.getUint32(p-56,!1)^n.getUint32(p-64,!1),1),!1);let r=this._h0,o=this._h1,f=this._h2,v=this._h3,d=this._h4,m,w,N;for(let p=0;p<80;p++)p<20?(m=o&f|~o&v,w=1518500249):p<40?(m=o^f^v,w=1859775393):p<60?(m=o&f|o&v|f&v,w=2400959708):(m=o^f^v,w=3395469782),N=h(r,5)+m+d+w+n.getUint32(p*4,!1)&4294967295,d=v,v=f,f=h(o,30),o=r,r=N;this._h0=this._h0+r&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+d&4294967295}}t.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),G(Q[11],X([0,1,15,22]),function(F,t,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class P{constructor(h){this.source=h}getElements(){const h=this.source,c=new Int32Array(h.length);for(let g=0,L=h.length;g<L;g++)c[g]=h.charCodeAt(g);return c}}t.StringDiffSequence=P;function s(C,h,c){return new b(new P(C),new P(h)).ComputeDiff(c).changes}t.stringDiff=s;class E{static Assert(h,c){if(!h)throw new Error(c)}}t.Debug=E;class l{static Copy(h,c,g,L,S){for(let _=0;_<S;_++)g[L+_]=h[c+_]}static Copy2(h,c,g,L,S){for(let _=0;_<S;_++)g[L+_]=h[c+_]}}t.MyArray=l;var u;(function(C){C[C.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(h,c){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(h,c){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(h,c,g=null){this.ContinueProcessingPredicate=g;const[L,S,_]=b._getElements(h),[n,i,r]=b._getElements(c);this._hasStrings=_&&r,this._originalStringElements=L,this._originalElementsOrHash=S,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(h){return h.length>0&&typeof h[0]=="string"}static _getElements(h){const c=h.getElements();if(b._isStringArray(c)){const g=new Int32Array(c.length);for(let L=0,S=c.length;L<S;L++)g[L]=(0,D.stringHash)(c[L],0);return[c,g,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(h,c){return this._originalElementsOrHash[h]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[h]===this._modifiedStringElements[c]:!0}OriginalElementsAreEqual(h,c){return this._originalElementsOrHash[h]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[h]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(h,c){return this._modifiedElementsOrHash[h]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[h]===this._modifiedStringElements[c]:!0}ComputeDiff(h){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,h)}_ComputeDiff(h,c,g,L,S){const _=[!1];let n=this.ComputeDiffRecursive(h,c,g,L,_);return S&&(n=this.PrettifyChanges(n)),{quitEarly:_[0],changes:n}}ComputeDiffRecursive(h,c,g,L,S){for(S[0]=!1;h<=c&&g<=L&&this.ElementsAreEqual(h,g);)h++,g++;for(;c>=h&&L>=g&&this.ElementsAreEqual(c,L);)c--,L--;if(h>c||g>L){let f;return g<=L?(E.Assert(h===c+1,"originalStart should only be one more than originalEnd"),f=[new M.DiffChange(h,0,g,L-g+1)]):h<=c?(E.Assert(g===L+1,"modifiedStart should only be one more than modifiedEnd"),f=[new M.DiffChange(h,c-h+1,g,0)]):(E.Assert(h===c+1,"originalStart should only be one more than originalEnd"),E.Assert(g===L+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const _=[0],n=[0],i=this.ComputeRecursionPoint(h,c,g,L,_,n,S),r=_[0],o=n[0];if(i!==null)return i;if(!S[0]){const f=this.ComputeDiffRecursive(h,r,g,o,S);let v=[];return S[0]?v=[new M.DiffChange(r+1,c-(r+1)+1,o+1,L-(o+1)+1)]:v=this.ComputeDiffRecursive(r+1,c,o+1,L,S),this.ConcatenateChanges(f,v)}return[new M.DiffChange(h,c-h+1,g,L-g+1)]}WALKTRACE(h,c,g,L,S,_,n,i,r,o,f,v,d,m,w,N,p,I){let R=null,y=null,q=new a,j=c,J=g,V=d[0]-N[0]-L,e=-1073741824,B=this.m_forwardHistory.length-1;do{const H=V+h;H===j||H<J&&r[H-1]<r[H+1]?(f=r[H+1],m=f-V-L,f<e&&q.MarkNextChange(),e=f,q.AddModifiedElement(f+1,m),V=H+1-h):(f=r[H-1]+1,m=f-V-L,f<e&&q.MarkNextChange(),e=f-1,q.AddOriginalElement(f,m+1),V=H-1-h),B>=0&&(r=this.m_forwardHistory[B],h=r[0],j=1,J=r.length-1)}while(--B>=-1);if(R=q.getReverseChanges(),I[0]){let H=d[0]+1,W=N[0]+1;if(R!==null&&R.length>0){const z=R[R.length-1];H=Math.max(H,z.getOriginalEnd()),W=Math.max(W,z.getModifiedEnd())}y=[new M.DiffChange(H,v-H+1,W,w-W+1)]}else{q=new a,j=_,J=n,V=d[0]-N[0]-i,e=1073741824,B=p?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const H=V+S;H===j||H<J&&o[H-1]>=o[H+1]?(f=o[H+1]-1,m=f-V-i,f>e&&q.MarkNextChange(),e=f+1,q.AddOriginalElement(f+1,m+1),V=H+1-S):(f=o[H-1],m=f-V-i,f>e&&q.MarkNextChange(),e=f,q.AddModifiedElement(f+1,m+1),V=H-1-S),B>=0&&(o=this.m_reverseHistory[B],S=o[0],j=1,J=o.length-1)}while(--B>=-1);y=q.getChanges()}return this.ConcatenateChanges(R,y)}ComputeRecursionPoint(h,c,g,L,S,_,n){let i=0,r=0,o=0,f=0,v=0,d=0;h--,g--,S[0]=0,_[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const m=c-h+(L-g),w=m+1,N=new Int32Array(w),p=new Int32Array(w),I=L-g,R=c-h,y=h-g,q=c-L,J=(R-I)%2==0;N[I]=h,p[R]=c,n[0]=!1;for(let V=1;V<=m/2+1;V++){let e=0,B=0;o=this.ClipDiagonalBound(I-V,V,I,w),f=this.ClipDiagonalBound(I+V,V,I,w);for(let W=o;W<=f;W+=2){W===o||W<f&&N[W-1]<N[W+1]?i=N[W+1]:i=N[W-1]+1,r=i-(W-I)-y;const z=i;for(;i<c&&r<L&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(N[W]=i,i+r>e+B&&(e=i,B=r),!J&&Math.abs(W-R)<=V-1&&i>=p[W])return S[0]=i,_[0]=r,z<=p[W]&&1447>0&&V<=1447+1?this.WALKTRACE(I,o,f,y,R,v,d,q,N,p,i,c,S,r,L,_,J,n):null}const H=(e-h+(B-g)-V)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(e,H))return n[0]=!0,S[0]=e,_[0]=B,H>0&&1447>0&&V<=1447+1?this.WALKTRACE(I,o,f,y,R,v,d,q,N,p,i,c,S,r,L,_,J,n):(h++,g++,[new M.DiffChange(h,c-h+1,g,L-g+1)]);v=this.ClipDiagonalBound(R-V,V,R,w),d=this.ClipDiagonalBound(R+V,V,R,w);for(let W=v;W<=d;W+=2){W===v||W<d&&p[W-1]>=p[W+1]?i=p[W+1]-1:i=p[W-1],r=i-(W-R)-q;const z=i;for(;i>h&&r>g&&this.ElementsAreEqual(i,r);)i--,r--;if(p[W]=i,J&&Math.abs(W-I)<=V&&i<=N[W])return S[0]=i,_[0]=r,z>=N[W]&&1447>0&&V<=1447+1?this.WALKTRACE(I,o,f,y,R,v,d,q,N,p,i,c,S,r,L,_,J,n):null}if(V<=1447){let W=new Int32Array(f-o+2);W[0]=I-o+1,l.Copy2(N,o,W,1,f-o+1),this.m_forwardHistory.push(W),W=new Int32Array(d-v+2),W[0]=R-v+1,l.Copy2(p,v,W,1,d-v+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(I,o,f,y,R,v,d,q,N,p,i,c,S,r,L,_,J,n)}PrettifyChanges(h){for(let c=0;c<h.length;c++){const g=h[c],L=c<h.length-1?h[c+1].originalStart:this._originalElementsOrHash.length,S=c<h.length-1?h[c+1].modifiedStart:this._modifiedElementsOrHash.length,_=g.originalLength>0,n=g.modifiedLength>0;for(;g.originalStart+g.originalLength<L&&g.modifiedStart+g.modifiedLength<S&&(!_||this.OriginalElementsAreEqual(g.originalStart,g.originalStart+g.originalLength))&&(!n||this.ModifiedElementsAreEqual(g.modifiedStart,g.modifiedStart+g.modifiedLength));)g.originalStart++,g.modifiedStart++;let i=[null];if(c<h.length-1&&this.ChangesOverlap(h[c],h[c+1],i)){h[c]=i[0],h.splice(c+1,1),c--;continue}}for(let c=h.length-1;c>=0;c--){const g=h[c];let L=0,S=0;if(c>0){const f=h[c-1];L=f.originalStart+f.originalLength,S=f.modifiedStart+f.modifiedLength}const _=g.originalLength>0,n=g.modifiedLength>0;let i=0,r=this._boundaryScore(g.originalStart,g.originalLength,g.modifiedStart,g.modifiedLength);for(let f=1;;f++){const v=g.originalStart-f,d=g.modifiedStart-f;if(v<L||d<S||_&&!this.OriginalElementsAreEqual(v,v+g.originalLength)||n&&!this.ModifiedElementsAreEqual(d,d+g.modifiedLength))break;const w=(v===L&&d===S?5:0)+this._boundaryScore(v,g.originalLength,d,g.modifiedLength);w>r&&(r=w,i=f)}g.originalStart-=i,g.modifiedStart-=i;const o=[null];if(c>0&&this.ChangesOverlap(h[c-1],h[c],o)){h[c-1]=o[0],h.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,g=h.length;c<g;c++){const L=h[c-1],S=h[c],_=S.originalStart-L.originalStart-L.originalLength,n=L.originalStart,i=S.originalStart+S.originalLength,r=i-n,o=L.modifiedStart,f=S.modifiedStart+S.modifiedLength,v=f-o;if(_<5&&r<20&&v<20){const d=this._findBetterContiguousSequence(n,r,o,v,_);if(d){const[m,w]=d;(m!==L.originalStart+L.originalLength||w!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=m-L.originalStart,L.modifiedLength=w-L.modifiedStart,S.originalStart=m+_,S.modifiedStart=w+_,S.originalLength=i-S.originalStart,S.modifiedLength=f-S.modifiedStart)}}}return h}_findBetterContiguousSequence(h,c,g,L,S){if(c<S||L<S)return null;const _=h+c-S+1,n=g+L-S+1;let i=0,r=0,o=0;for(let f=h;f<_;f++)for(let v=g;v<n;v++){const d=this._contiguousSequenceScore(f,v,S);d>0&&d>i&&(i=d,r=f,o=v)}return i>0?[r,o]:null}_contiguousSequenceScore(h,c,g){let L=0;for(let S=0;S<g;S++){if(!this.ElementsAreEqual(h+S,c+S))return 0;L+=this._originalStringElements[h+S].length}return L}_OriginalIsBoundary(h){return h<=0||h>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[h])}_OriginalRegionIsBoundary(h,c){if(this._OriginalIsBoundary(h)||this._OriginalIsBoundary(h-1))return!0;if(c>0){const g=h+c;if(this._OriginalIsBoundary(g-1)||this._OriginalIsBoundary(g))return!0}return!1}_ModifiedIsBoundary(h){return h<=0||h>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[h])}_ModifiedRegionIsBoundary(h,c){if(this._ModifiedIsBoundary(h)||this._ModifiedIsBoundary(h-1))return!0;if(c>0){const g=h+c;if(this._ModifiedIsBoundary(g-1)||this._ModifiedIsBoundary(g))return!0}return!1}_boundaryScore(h,c,g,L){const S=this._OriginalRegionIsBoundary(h,c)?1:0,_=this._ModifiedRegionIsBoundary(g,L)?1:0;return S+_}ConcatenateChanges(h,c){let g=[];if(h.length===0||c.length===0)return c.length>0?c:h;if(this.ChangesOverlap(h[h.length-1],c[0],g)){const L=new Array(h.length+c.length-1);return l.Copy(h,0,L,0,h.length-1),L[h.length-1]=g[0],l.Copy(c,1,L,h.length,c.length-1),L}else{const L=new Array(h.length+c.length);return l.Copy(h,0,L,0,h.length),l.Copy(c,0,L,h.length,c.length),L}}ChangesOverlap(h,c,g){if(E.Assert(h.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),E.Assert(h.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=c.originalStart||h.modifiedStart+h.modifiedLength>=c.modifiedStart){const L=h.originalStart;let S=h.originalLength;const _=h.modifiedStart;let n=h.modifiedLength;return h.originalStart+h.originalLength>=c.originalStart&&(S=c.originalStart+c.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=c.modifiedStart&&(n=c.modifiedStart+c.modifiedLength-h.modifiedStart),g[0]=new M.DiffChange(L,S,_,n),!0}else return g[0]=null,!1}ClipDiagonalBound(h,c,g,L){if(h>=0&&h<L)return h;const S=g,_=L-g-1,n=c%2==0;if(h<0){const i=S%2==0;return n===i?0:1}else{const i=_%2==0;return n===i?L-1:L-2}}}t.LcsDiff=b}),G(Q[12],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function M(N){return Array.isArray(N)}t.isArray=M;function D(N){return typeof N=="string"}t.isString=D;function P(N){return Array.isArray(N)&&N.every(p=>D(p))}t.isStringArray=P;function s(N){return typeof N=="object"&&N!==null&&!Array.isArray(N)&&!(N instanceof RegExp)&&!(N instanceof Date)}t.isObject=s;function E(N){return typeof N=="number"&&!isNaN(N)}t.isNumber=E;function l(N){return!!N&&typeof N[Symbol.iterator]=="function"}t.isIterable=l;function u(N){return N===!0||N===!1}t.isBoolean=u;function a(N){return typeof N=="undefined"}t.isUndefined=a;function b(N){return!C(N)}t.isDefined=b;function C(N){return a(N)||N===null}t.isUndefinedOrNull=C;function h(N,p){if(!N)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}t.assertType=h;function c(N){if(C(N))throw new Error("Assertion Failed: argument is undefined or null");return N}t.assertIsDefined=c;function g(...N){const p=[];for(let I=0;I<N.length;I++){const R=N[I];if(C(R))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);p.push(R)}return p}t.assertAllDefined=g;const L=Object.prototype.hasOwnProperty;function S(N){if(!s(N))return!1;for(let p in N)if(L.call(N,p))return!1;return!0}t.isEmptyObject=S;function _(N){return typeof N=="function"}t.isFunction=_;function n(...N){return N.length>0&&N.every(_)}t.areFunctions=n;function i(N,p){const I=Math.min(N.length,p.length);for(let R=0;R<I;R++)r(N[R],p[R])}t.validateConstraints=i;function r(N,p){if(D(p)){if(typeof N!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(_(p)){try{if(N instanceof p)return}catch(I){}if(!C(N)&&N.constructor===p||p.length===1&&p.call(void 0,N)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function o(N){let p=[],I=Object.getPrototypeOf(N);for(;Object.prototype!==I;)p=p.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return p}t.getAllPropertyNames=o;function f(N){const p=[];for(const I of o(N))typeof N[I]=="function"&&p.push(I);return p}t.getAllMethodNames=f;function v(N,p){const I=y=>function(){const q=Array.prototype.slice.call(arguments,0);return p(y,q)};let R={};for(const y of N)R[y]=I(y);return R}t.createProxyObject=v;function d(N){return N===null?void 0:N}t.withNullAsUndefined=d;function m(N){return typeof N=="undefined"?null:N}t.withUndefinedAsNull=m;function w(N){return class{constructor(){return new Proxy({},{get(p,I){if(p[I])return p[I];throw new Error(`Not Implemented: ${N}->${String(I)}`)}})}}}t.NotImplementedProxy=w}),G(Q[13],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var M;(function(s){s[s.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",s[s.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",s[s.MAX_UINT_8=255]="MAX_UINT_8",s[s.MAX_UINT_16=65535]="MAX_UINT_16",s[s.MAX_UINT_32=4294967295]="MAX_UINT_32",s[s.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=t.Constants||(t.Constants={}));function D(s){return s<0?0:s>255?255:s|0}t.toUint8=D;function P(s){return s<0?0:s>4294967295?4294967295:s|0}t.toUint32=P}),G(Q[14],X([0,1,2,20]),function(F,t,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const P=/^\w[\w\d+.-]*$/,s=/^\//,E=/^\/\//;function l(d,m){if(!d.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!P.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!s.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(d,m){return!d&&!m?"file":d}function a(d,m){switch(d){case"https":case"http":case"file":m?m[0]!==C&&(m=C+m):m=C;break}return m}const b="",C="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{constructor(m,w,N,p,I,R=!1){typeof m=="object"?(this.scheme=m.scheme||b,this.authority=m.authority||b,this.path=m.path||b,this.query=m.query||b,this.fragment=m.fragment||b):(this.scheme=u(m,R),this.authority=w||b,this.path=a(this.scheme,N||b),this.query=p||b,this.fragment=I||b,l(this,R))}static isUri(m){return m instanceof c?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}get fsPath(){return i(this,!1)}with(m){if(!m)return this;let{scheme:w,authority:N,path:p,query:I,fragment:R}=m;return w===void 0?w=this.scheme:w===null&&(w=b),N===void 0?N=this.authority:N===null&&(N=b),p===void 0?p=this.path:p===null&&(p=b),I===void 0?I=this.query:I===null&&(I=b),R===void 0?R=this.fragment:R===null&&(R=b),w===this.scheme&&N===this.authority&&p===this.path&&I===this.query&&R===this.fragment?this:new L(w,N,p,I,R)}static parse(m,w=!1){const N=h.exec(m);return N?new L(N[2]||b,v(N[4]||b),v(N[5]||b),v(N[7]||b),v(N[9]||b),w):new L(b,b,b,b,b)}static file(m){let w=b;if(M.isWindows&&(m=m.replace(/\\/g,C)),m[0]===C&&m[1]===C){const N=m.indexOf(C,2);N===-1?(w=m.substring(2),m=C):(w=m.substring(2,N),m=m.substring(N)||C)}return new L("file",w,m,b,b)}static from(m){return new L(m.scheme,m.authority,m.path,m.query,m.fragment)}static joinPath(m,...w){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return M.isWindows&&m.scheme==="file"?N=c.file(D.win32.join(i(m,!0),...w)).path:N=D.posix.join(m.path,...w),m.with({path:N})}toString(m=!1){return r(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof c)return m;{const w=new L(m);return w._formatted=m.external,w._fsPath=m._sep===g?m.fsPath:null,w}}else return m}}t.URI=c;const g=M.isWindows?1:void 0;class L extends c{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(m=!1){return m?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=g),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(d,m){let w,N=-1;for(let p=0;p<d.length;p++){const I=d.charCodeAt(p);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||m&&I===47)N!==-1&&(w+=encodeURIComponent(d.substring(N,p)),N=-1),w!==void 0&&(w+=d.charAt(p));else{w===void 0&&(w=d.substr(0,p));const R=S[I];R!==void 0?(N!==-1&&(w+=encodeURIComponent(d.substring(N,p)),N=-1),w+=R):N===-1&&(N=p)}}return N!==-1&&(w+=encodeURIComponent(d.substring(N))),w!==void 0?w:d}function n(d){let m;for(let w=0;w<d.length;w++){const N=d.charCodeAt(w);N===35||N===63?(m===void 0&&(m=d.substr(0,w)),m+=S[N]):m!==void 0&&(m+=d[w])}return m!==void 0?m:d}function i(d,m){let w;return d.authority&&d.path.length>1&&d.scheme==="file"?w=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?m?w=d.path.substr(1):w=d.path[1].toLowerCase()+d.path.substr(2):w=d.path,M.isWindows&&(w=w.replace(/\//g,"\\")),w}t.uriToFsPath=i;function r(d,m){const w=m?n:_;let N="",{scheme:p,authority:I,path:R,query:y,fragment:q}=d;if(p&&(N+=p,N+=":"),(I||p==="file")&&(N+=C,N+=C),I){let j=I.indexOf("@");if(j!==-1){const J=I.substr(0,j);I=I.substr(j+1),j=J.indexOf(":"),j===-1?N+=w(J,!1):(N+=w(J.substr(0,j),!1),N+=":",N+=w(J.substr(j+1),!1)),N+="@"}I=I.toLowerCase(),j=I.indexOf(":"),j===-1?N+=w(I,!1):(N+=w(I.substr(0,j),!1),N+=I.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}N+=w(R,!0)}return y&&(N+="?",N+=w(y,!1)),q&&(N+="#",N+=m?q:_(q,!1)),N}function o(d){try{return decodeURIComponent(d)}catch(m){return d.length>3?d.substr(0,3)+o(d.substr(3)):d}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(f)?d.replace(f,m=>o(m)):d}}),G(Q[34],X([0,1,4,8,2,12]),function(F,t,M,D,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const E="$initialize";let l=!1;function u(c){!P.isWeb||(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}t.logOnceWebWorkerWarning=u;class a{constructor(g){this._workerId=-1,this._handler=g,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(g){this._workerId=g}sendMessage(g,L){let S=String(++this._lastSentReq);return new Promise((_,n)=>{this._pendingReplies[S]={resolve:_,reject:n},this._send({vsWorker:this._workerId,req:S,method:g,args:L})})}handleMessage(g){!g||!g.vsWorker||this._workerId!==-1&&g.vsWorker!==this._workerId||this._handleMessage(g)}_handleMessage(g){if(g.seq){let n=g;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let L=g,S=L.req;this._handler.handleMessage(L.method,L.args).then(n=>{this._send({vsWorker:this._workerId,seq:S,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,M.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:S,res:void 0,err:(0,M.transformErrorForSerialization)(n)})})}_send(g){let L=[];if(g.req){const S=g;for(let _=0;_<S.args.length;_++)S.args[_]instanceof ArrayBuffer&&L.push(S.args[_])}else{const S=g;S.res instanceof ArrayBuffer&&L.push(S.res)}this._handler.sendMessage(g,L)}}class b extends D.Disposable{constructor(g,L,S){super();let _=null;this._worker=this._register(g.create("vs/base/common/worker/simpleWorker",o=>{this._protocol.handleMessage(o)},o=>{_&&_(o)})),this._protocol=new a({sendMessage:(o,f)=>{this._worker.postMessage(o,f)},handleMessage:(o,f)=>{if(typeof S[o]!="function")return Promise.reject(new Error("Missing method "+o+" on main thread host."));try{return Promise.resolve(S[o].apply(S,f))}catch(v){return Promise.reject(v)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=s.getAllMethodNames(S);this._onModuleLoaded=this._protocol.sendMessage(E,[this._worker.getId(),JSON.parse(JSON.stringify(n)),L,i]);const r=(o,f)=>this._request(o,f);this._lazyProxy=new Promise((o,f)=>{_=f,this._onModuleLoaded.then(v=>{o(s.createProxyObject(v,r))},v=>{f(v),this._onError("Worker failed to load "+L,v)})})}getProxyObject(){return this._lazyProxy}_request(g,L){return new Promise((S,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(g,L).then(S,_)},_)})}_onError(g,L){console.error(g),console.info(L)}}t.SimpleWorkerClient=b;class C{constructor(g,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new a({sendMessage:(S,_)=>{g(S,_)},handleMessage:(S,_)=>this._handleMessage(S,_)})}onmessage(g){this._protocol.handleMessage(g)}_handleMessage(g,L){if(g===E)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this._requestHandler[g].apply(this._requestHandler,L))}catch(S){return Promise.reject(S)}}initialize(g,L,S,_){this._protocol.setWorkerId(g);const n=(r,o)=>this._protocol.sendMessage(r,o),i=s.createProxyObject(_,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(s.getAllMethodNames(this._requestHandler))):(L&&(typeof L.baseUrl!="undefined"&&delete L.baseUrl,typeof L.paths!="undefined"&&typeof L.paths.vs!="undefined"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,self.require.config(L)),new Promise((r,o)=>{self.require([S],f=>{if(this._requestHandler=f.create(i),!this._requestHandler){o(new Error("No RequestHandler!"));return}r(s.getAllMethodNames(this._requestHandler))},o)}))}}t.SimpleWorkerServer=C;function h(c){return new C(c,null)}t.create=h}),G(Q[23],X([0,1,13]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class D{constructor(l){let u=(0,M.toUint8)(l);this._defaultValue=u,this._asciiMap=D._createAsciiMap(u),this._map=new Map}static _createAsciiMap(l){let u=new Uint8Array(256);for(let a=0;a<256;a++)u[a]=l;return u}set(l,u){let a=(0,M.toUint8)(u);l>=0&&l<256?this._asciiMap[l]=a:this._map.set(l,a)}get(l){return l>=0&&l<256?this._asciiMap[l]:this._map.get(l)||this._defaultValue}}t.CharacterClassifier=D;var P;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(P||(P={}));class s{constructor(){this._actual=new D(0)}add(l){this._actual.set(l,1)}has(l){return this._actual.get(l)===1}}t.CharacterSet=s}),G(Q[3],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class M{constructor(P,s){this.lineNumber=P,this.column=s}with(P=this.lineNumber,s=this.column){return P===this.lineNumber&&s===this.column?this:new M(P,s)}delta(P=0,s=0){return this.with(this.lineNumber+P,this.column+s)}equals(P){return M.equals(this,P)}static equals(P,s){return!P&&!s?!0:!!P&&!!s&&P.lineNumber===s.lineNumber&&P.column===s.column}isBefore(P){return M.isBefore(this,P)}static isBefore(P,s){return P.lineNumber<s.lineNumber?!0:s.lineNumber<P.lineNumber?!1:P.column<s.column}isBeforeOrEqual(P){return M.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,s){return P.lineNumber<s.lineNumber?!0:s.lineNumber<P.lineNumber?!1:P.column<=s.column}static compare(P,s){let E=P.lineNumber|0,l=s.lineNumber|0;if(E===l){let u=P.column|0,a=s.column|0;return u-a}return E-l}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new M(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}t.Position=M}),G(Q[6],X([0,1,3]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class D{constructor(s,E,l,u){s>l||s===l&&E>u?(this.startLineNumber=l,this.startColumn=u,this.endLineNumber=s,this.endColumn=E):(this.startLineNumber=s,this.startColumn=E,this.endLineNumber=l,this.endColumn=u)}isEmpty(){return D.isEmpty(this)}static isEmpty(s){return s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn}containsPosition(s){return D.containsPosition(this,s)}static containsPosition(s,E){return!(E.lineNumber<s.startLineNumber||E.lineNumber>s.endLineNumber||E.lineNumber===s.startLineNumber&&E.column<s.startColumn||E.lineNumber===s.endLineNumber&&E.column>s.endColumn)}containsRange(s){return D.containsRange(this,s)}static containsRange(s,E){return!(E.startLineNumber<s.startLineNumber||E.endLineNumber<s.startLineNumber||E.startLineNumber>s.endLineNumber||E.endLineNumber>s.endLineNumber||E.startLineNumber===s.startLineNumber&&E.startColumn<s.startColumn||E.endLineNumber===s.endLineNumber&&E.endColumn>s.endColumn)}strictContainsRange(s){return D.strictContainsRange(this,s)}static strictContainsRange(s,E){return!(E.startLineNumber<s.startLineNumber||E.endLineNumber<s.startLineNumber||E.startLineNumber>s.endLineNumber||E.endLineNumber>s.endLineNumber||E.startLineNumber===s.startLineNumber&&E.startColumn<=s.startColumn||E.endLineNumber===s.endLineNumber&&E.endColumn>=s.endColumn)}plusRange(s){return D.plusRange(this,s)}static plusRange(s,E){let l,u,a,b;return E.startLineNumber<s.startLineNumber?(l=E.startLineNumber,u=E.startColumn):E.startLineNumber===s.startLineNumber?(l=E.startLineNumber,u=Math.min(E.startColumn,s.startColumn)):(l=s.startLineNumber,u=s.startColumn),E.endLineNumber>s.endLineNumber?(a=E.endLineNumber,b=E.endColumn):E.endLineNumber===s.endLineNumber?(a=E.endLineNumber,b=Math.max(E.endColumn,s.endColumn)):(a=s.endLineNumber,b=s.endColumn),new D(l,u,a,b)}intersectRanges(s){return D.intersectRanges(this,s)}static intersectRanges(s,E){let l=s.startLineNumber,u=s.startColumn,a=s.endLineNumber,b=s.endColumn,C=E.startLineNumber,h=E.startColumn,c=E.endLineNumber,g=E.endColumn;return l<C?(l=C,u=h):l===C&&(u=Math.max(u,h)),a>c?(a=c,b=g):a===c&&(b=Math.min(b,g)),l>a||l===a&&u>b?null:new D(l,u,a,b)}equalsRange(s){return D.equalsRange(this,s)}static equalsRange(s,E){return!!s&&!!E&&s.startLineNumber===E.startLineNumber&&s.startColumn===E.startColumn&&s.endLineNumber===E.endLineNumber&&s.endColumn===E.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(s){return new M.Position(s.endLineNumber,s.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(s){return new M.Position(s.startLineNumber,s.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(s,E){return new D(this.startLineNumber,this.startColumn,s,E)}setStartPosition(s,E){return new D(s,E,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(s){return new D(s.startLineNumber,s.startColumn,s.startLineNumber,s.startColumn)}static fromPositions(s,E=s){return new D(s.lineNumber,s.column,E.lineNumber,E.column)}static lift(s){return s?new D(s.startLineNumber,s.startColumn,s.endLineNumber,s.endColumn):null}static isIRange(s){return s&&typeof s.startLineNumber=="number"&&typeof s.startColumn=="number"&&typeof s.endLineNumber=="number"&&typeof s.endColumn=="number"}static areIntersectingOrTouching(s,E){return!(s.endLineNumber<E.startLineNumber||s.endLineNumber===E.startLineNumber&&s.endColumn<E.startColumn||E.endLineNumber<s.startLineNumber||E.endLineNumber===s.startLineNumber&&E.endColumn<s.startColumn)}static areIntersecting(s,E){return!(s.endLineNumber<E.startLineNumber||s.endLineNumber===E.startLineNumber&&s.endColumn<=E.startColumn||E.endLineNumber<s.startLineNumber||E.endLineNumber===s.startLineNumber&&E.endColumn<=s.startColumn)}static compareRangesUsingStarts(s,E){if(s&&E){const a=s.startLineNumber|0,b=E.startLineNumber|0;if(a===b){const C=s.startColumn|0,h=E.startColumn|0;if(C===h){const c=s.endLineNumber|0,g=E.endLineNumber|0;if(c===g){const L=s.endColumn|0,S=E.endColumn|0;return L-S}return c-g}return C-h}return a-b}return(s?1:0)-(E?1:0)}static compareRangesUsingEnds(s,E){return s.endLineNumber===E.endLineNumber?s.endColumn===E.endColumn?s.startLineNumber===E.startLineNumber?s.startColumn-E.startColumn:s.startLineNumber-E.startLineNumber:s.endColumn-E.endColumn:s.endLineNumber-E.endLineNumber}static spansMultipleLines(s){return s.endLineNumber>s.startLineNumber}}t.Range=D}),G(Q[24],X([0,1,3,6]),function(F,t,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var P;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(P=t.SelectionDirection||(t.SelectionDirection={}));class s extends D.Range{constructor(l,u,a,b){super(l,u,a,b);this.selectionStartLineNumber=l,this.selectionStartColumn=u,this.positionLineNumber=a,this.positionColumn=b}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(l){return s.selectionsEqual(this,l)}static selectionsEqual(l,u){return l.selectionStartLineNumber===u.selectionStartLineNumber&&l.selectionStartColumn===u.selectionStartColumn&&l.positionLineNumber===u.positionLineNumber&&l.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(l,u){return this.getDirection()===0?new s(this.startLineNumber,this.startColumn,l,u):new s(l,u,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(l,u){return this.getDirection()===0?new s(l,u,this.endLineNumber,this.endColumn):new s(this.endLineNumber,this.endColumn,l,u)}static fromPositions(l,u=l){return new s(l.lineNumber,l.column,u.lineNumber,u.column)}static liftSelection(l){return new s(l.selectionStartLineNumber,l.selectionStartColumn,l.positionLineNumber,l.positionColumn)}static selectionsArrEqual(l,u){if(l&&!u||!l&&u)return!1;if(!l&&!u)return!0;if(l.length!==u.length)return!1;for(let a=0,b=l.length;a<b;a++)if(!this.selectionsEqual(l[a],u[a]))return!1;return!0}static isISelection(l){return l&&typeof l.selectionStartLineNumber=="number"&&typeof l.selectionStartColumn=="number"&&typeof l.positionLineNumber=="number"&&typeof l.positionColumn=="number"}static createWithDirection(l,u,a,b,C){return C===0?new s(l,u,a,b):new s(a,b,l,u)}}t.Selection=s}),G(Q[25],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class M{constructor(E,l,u){this.offset=E|0,this.type=l,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=M;class D{constructor(E,l){this.tokens=E,this.endState=l}}t.TokenizationResult=D;class P{constructor(E,l){this.tokens=E,this.endState=l}}t.TokenizationResult2=P}),G(Q[26],X([0,1,11,5]),function(F,t,M,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const P=3;function s(L,S,_,n){return new M.LcsDiff(L,S,_).ComputeDiff(n)}class E{constructor(S){const _=[],n=[];for(let i=0,r=S.length;i<r;i++)_[i]=h(S[i],1),n[i]=c(S[i],1);this.lines=S,this._startColumns=_,this._endColumns=n}getElements(){const S=[];for(let _=0,n=this.lines.length;_<n;_++)S[_]=this.lines[_].substring(this._startColumns[_]-1,this._endColumns[_]-1);return S}getStartLineNumber(S){return S+1}getEndLineNumber(S){return S+1}createCharSequence(S,_,n){const i=[],r=[],o=[];let f=0;for(let v=_;v<=n;v++){const d=this.lines[v],m=S?this._startColumns[v]:1,w=S?this._endColumns[v]:d.length+1;for(let N=m;N<w;N++)i[f]=d.charCodeAt(N-1),r[f]=v+1,o[f]=N,f++}return new l(i,r,o)}}class l{constructor(S,_,n){this._charCodes=S,this._lineNumbers=_,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(S){return this._lineNumbers[S]}getStartColumn(S){return this._columns[S]}getEndLineNumber(S){return this._lineNumbers[S]}getEndColumn(S){return this._columns[S]+1}}class u{constructor(S,_,n,i,r,o,f,v){this.originalStartLineNumber=S,this.originalStartColumn=_,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=f,this.modifiedEndColumn=v}static createFromDiffChange(S,_,n){let i,r,o,f,v,d,m,w;return S.originalLength===0?(i=0,r=0,o=0,f=0):(i=_.getStartLineNumber(S.originalStart),r=_.getStartColumn(S.originalStart),o=_.getEndLineNumber(S.originalStart+S.originalLength-1),f=_.getEndColumn(S.originalStart+S.originalLength-1)),S.modifiedLength===0?(v=0,d=0,m=0,w=0):(v=n.getStartLineNumber(S.modifiedStart),d=n.getStartColumn(S.modifiedStart),m=n.getEndLineNumber(S.modifiedStart+S.modifiedLength-1),w=n.getEndColumn(S.modifiedStart+S.modifiedLength-1)),new u(i,r,o,f,v,d,m,w)}}function a(L){if(L.length<=1)return L;const S=[L[0]];let _=S[0];for(let n=1,i=L.length;n<i;n++){const r=L[n],o=r.originalStart-(_.originalStart+_.originalLength),f=r.modifiedStart-(_.modifiedStart+_.modifiedLength);Math.min(o,f)<P?(_.originalLength=r.originalStart+r.originalLength-_.originalStart,_.modifiedLength=r.modifiedStart+r.modifiedLength-_.modifiedStart):(S.push(r),_=r)}return S}class b{constructor(S,_,n,i,r){this.originalStartLineNumber=S,this.originalEndLineNumber=_,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(S,_,n,i,r,o,f){let v,d,m,w,N;if(_.originalLength===0?(v=n.getStartLineNumber(_.originalStart)-1,d=0):(v=n.getStartLineNumber(_.originalStart),d=n.getEndLineNumber(_.originalStart+_.originalLength-1)),_.modifiedLength===0?(m=i.getStartLineNumber(_.modifiedStart)-1,w=0):(m=i.getStartLineNumber(_.modifiedStart),w=i.getEndLineNumber(_.modifiedStart+_.modifiedLength-1)),o&&_.originalLength>0&&_.originalLength<20&&_.modifiedLength>0&&_.modifiedLength<20&&r()){const p=n.createCharSequence(S,_.originalStart,_.originalStart+_.originalLength-1),I=i.createCharSequence(S,_.modifiedStart,_.modifiedStart+_.modifiedLength-1);let R=s(p,I,r,!0).changes;f&&(R=a(R)),N=[];for(let y=0,q=R.length;y<q;y++)N.push(u.createFromDiffChange(R[y],p,I))}return new b(v,d,m,w,N)}}class C{constructor(S,_,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=S,this.modifiedLines=_,this.original=new E(S),this.modified=new E(_),this.continueLineDiff=g(n.maxComputationTime),this.continueCharDiff=g(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const S=s(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),_=S.changes,n=S.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let v=0,d=_.length;v<d;v++)f.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_[v],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:f}}const i=[];let r=0,o=0;for(let f=-1,v=_.length;f<v;f++){const d=f+1<v?_[f+1]:null,m=d?d.originalStart:this.originalLines.length,w=d?d.modifiedStart:this.modifiedLines.length;for(;r<m&&o<w;){const N=this.originalLines[r],p=this.modifiedLines[o];if(N!==p){{let I=h(N,1),R=h(p,1);for(;I>1&&R>1;){const y=N.charCodeAt(I-2),q=p.charCodeAt(R-2);if(y!==q)break;I--,R--}(I>1||R>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,I,o+1,1,R)}{let I=c(N,1),R=c(p,1);const y=N.length+1,q=p.length+1;for(;I<y&&R<q;){const j=N.charCodeAt(I-1),J=N.charCodeAt(R-1);if(j!==J)break;I++,R++}(I<y||R<q)&&this._pushTrimWhitespaceCharChange(i,r+1,I,y,o+1,R,q)}}r++,o++}d&&(i.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=d.originalLength,o+=d.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(S,_,n,i,r,o,f){if(!this._mergeTrimWhitespaceCharChange(S,_,n,i,r,o,f)){let v;this.shouldComputeCharChanges&&(v=[new u(_,n,_,i,r,o,r,f)]),S.push(new b(_,_,r,r,v))}}_mergeTrimWhitespaceCharChange(S,_,n,i,r,o,f){const v=S.length;if(v===0)return!1;const d=S[v-1];return d.originalEndLineNumber===0||d.modifiedEndLineNumber===0?!1:d.originalEndLineNumber+1===_&&d.modifiedEndLineNumber+1===r?(d.originalEndLineNumber=_,d.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&d.charChanges&&d.charChanges.push(new u(_,n,_,i,r,o,r,f)),!0):!1}}t.DiffComputer=C;function h(L,S){const _=D.firstNonWhitespaceIndex(L);return _===-1?S:_+1}function c(L,S){const _=D.lastNonWhitespaceIndex(L);return _===-1?S:_+2}function g(L){if(L===0)return()=>!0;const S=Date.now();return()=>Date.now()-S<L}}),G(Q[27],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(l=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const a of t.USUAL_WORD_SEPARATORS)l.indexOf(a)>=0||(u+="\\"+a);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=M();function D(l){let u=t.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)u=l;else{let a="g";l.ignoreCase&&(a+="i"),l.multiline&&(a+="m"),l.unicode&&(a+="u"),u=new RegExp(l.source,a)}return u.lastIndex=0,u}t.ensureValidWordDefinition=D;const P={maxLen:1e3,windowSize:15,timeBudget:150};function s(l,u,a,b,C=P){if(a.length>C.maxLen){let S=l-C.maxLen/2;return S<0?S=0:b+=S,a=a.substring(S,l+C.maxLen/2),s(l,u,a,b,C)}const h=Date.now(),c=l-1-b;let g=-1,L=null;for(let S=1;!(Date.now()-h>=C.timeBudget);S++){const _=c-C.windowSize*S;u.lastIndex=Math.max(0,_);const n=E(u,a,c,g);if(!n&&L||(L=n,_<=0))break;g=_}if(L){let S={word:L[0],startColumn:b+1+L.index,endColumn:b+1+L.index+L[0].length};return u.lastIndex=0,S}return null}t.getWordAtText=s;function E(l,u,a,b){let C;for(;C=l.exec(u);){const h=C.index||0;if(h<=a&&l.lastIndex>=a)return C;if(b>0&&h>b)return null}return null}}),G(Q[28],X([0,1,23]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var D;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(D=t.State||(t.State={}));class P{constructor(g,L,S){const _=new Uint8Array(g*L);for(let n=0,i=g*L;n<i;n++)_[n]=S;this._data=_,this.rows=g,this.cols=L}get(g,L){return this._data[g*this.cols+L]}set(g,L,S){this._data[g*this.cols+L]=S}}t.Uint8Matrix=P;class s{constructor(g){let L=0,S=0;for(let n=0,i=g.length;n<i;n++){let[r,o,f]=g[n];o>L&&(L=o),r>S&&(S=r),f>S&&(S=f)}L++,S++;let _=new P(S,L,0);for(let n=0,i=g.length;n<i;n++){let[r,o,f]=g[n];_.set(r,o,f)}this._states=_,this._maxCharCode=L}nextState(g,L){return L<0||L>=this._maxCharCode?0:this._states.get(g,L)}}t.StateMachine=s;let E=null;function l(){return E===null&&(E=new s([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var u;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let a=null;function b(){if(a===null){a=new M.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<c.length;L++)a.set(c.charCodeAt(L),1);const g=".,;";for(let L=0;L<g.length;L++)a.set(g.charCodeAt(L),2)}return a}class C{static _createLink(g,L,S,_,n){let i=n-1;do{const r=L.charCodeAt(i);if(g.get(r)!==2)break;i--}while(i>_);if(_>0){const r=L.charCodeAt(_-1),o=L.charCodeAt(i);(r===40&&o===41||r===91&&o===93||r===123&&o===125)&&i--}return{range:{startLineNumber:S,startColumn:_+1,endLineNumber:S,endColumn:i+2},url:L.substring(_,i+1)}}static computeLinks(g,L=l()){const S=b();let _=[];for(let n=1,i=g.getLineCount();n<=i;n++){const r=g.getLineContent(n),o=r.length;let f=0,v=0,d=0,m=1,w=!1,N=!1,p=!1,I=!1;for(;f<o;){let R=!1;const y=r.charCodeAt(f);if(m===13){let q;switch(y){case 40:w=!0,q=0;break;case 41:q=w?0:1;break;case 91:p=!0,N=!0,q=0;break;case 93:p=!1,q=N?0:1;break;case 123:I=!0,q=0;break;case 125:q=I?0:1;break;case 39:q=d===34||d===96?0:1;break;case 34:q=d===39||d===96?0:1;break;case 96:q=d===39||d===34?0:1;break;case 42:q=d===42?1:0;break;case 124:q=d===124?1:0;break;case 32:q=p?0:1;break;default:q=S.get(y)}q===1&&(_.push(C._createLink(S,r,n,v,f)),R=!0)}else if(m===12){let q;y===91?(N=!0,q=0):q=S.get(y),q===1?R=!0:m=13}else m=L.nextState(m,y),m===0&&(R=!0);R&&(m=1,w=!1,N=!1,I=!1,v=f+1,d=y),f++}m===13&&_.push(C._createLink(S,r,n,v,o))}return _}}t.LinkComputer=C;function h(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:C.computeLinks(c)}t.computeLinks=h}),G(Q[29],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(P,s,E,l,u){if(P&&s){let a=this.doNavigateValueSet(s,u);if(a)return{range:P,value:a}}if(E&&l){let a=this.doNavigateValueSet(l,u);if(a)return{range:E,value:a}}return null}doNavigateValueSet(P,s){let E=this.numberReplace(P,s);return E!==null?E:this.textReplace(P,s)}numberReplace(P,s){let E=Math.pow(10,P.length-(P.lastIndexOf(".")+1)),l=Number(P),u=parseFloat(P);return!isNaN(l)&&!isNaN(u)&&l===u?l===0&&!s?null:(l=Math.floor(l*E),l+=s?E:-E,String(l/E)):null}textReplace(P,s){return this.valueSetsReplace(this._defaultValueSet,P,s)}valueSetsReplace(P,s,E){let l=null;for(let u=0,a=P.length;l===null&&u<a;u++)l=this.valueSetReplace(P[u],s,E);return l}valueSetReplace(P,s,E){let l=P.indexOf(s);return l>=0?(l+=E?1:-1,l<0?l=P.length-1:l%=P.length,P[l]):null}}t.BasicInplaceReplace=M,M.INSTANCE=new M}),G(Q[30],X([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var M;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(M=t.AccessibilitySupport||(t.AccessibilitySupport={}));var D;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(D=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var P;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(P=t.CompletionItemKind||(t.CompletionItemKind={}));var s;(function(e){e[e.Deprecated=1]="Deprecated"})(s=t.CompletionItemTag||(t.CompletionItemTag={}));var E;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(l=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var a;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(a=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var b;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(b=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var C;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(C=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var h;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=39]="fontFamily",e[e.fontInfo=40]="fontInfo",e[e.fontLigatures=41]="fontLigatures",e[e.fontSize=42]="fontSize",e[e.fontWeight=43]="fontWeight",e[e.formatOnPaste=44]="formatOnPaste",e[e.formatOnType=45]="formatOnType",e[e.glyphMargin=46]="glyphMargin",e[e.gotoLocation=47]="gotoLocation",e[e.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",e[e.hover=50]="hover",e[e.inDiffEditor=51]="inDiffEditor",e[e.letterSpacing=52]="letterSpacing",e[e.lightbulb=53]="lightbulb",e[e.lineDecorationsWidth=54]="lineDecorationsWidth",e[e.lineHeight=55]="lineHeight",e[e.lineNumbers=56]="lineNumbers",e[e.lineNumbersMinChars=57]="lineNumbersMinChars",e[e.linkedEditing=58]="linkedEditing",e[e.links=59]="links",e[e.matchBrackets=60]="matchBrackets",e[e.minimap=61]="minimap",e[e.mouseStyle=62]="mouseStyle",e[e.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=64]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",e[e.multiCursorModifier=66]="multiCursorModifier",e[e.multiCursorPaste=67]="multiCursorPaste",e[e.occurrencesHighlight=68]="occurrencesHighlight",e[e.overviewRulerBorder=69]="overviewRulerBorder",e[e.overviewRulerLanes=70]="overviewRulerLanes",e[e.padding=71]="padding",e[e.parameterHints=72]="parameterHints",e[e.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",e[e.quickSuggestions=75]="quickSuggestions",e[e.quickSuggestionsDelay=76]="quickSuggestionsDelay",e[e.readOnly=77]="readOnly",e[e.renameOnType=78]="renameOnType",e[e.renderControlCharacters=79]="renderControlCharacters",e[e.renderIndentGuides=80]="renderIndentGuides",e[e.renderFinalNewline=81]="renderFinalNewline",e[e.renderLineHighlight=82]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=84]="renderValidationDecorations",e[e.renderWhitespace=85]="renderWhitespace",e[e.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",e[e.roundedSelection=87]="roundedSelection",e[e.rulers=88]="rulers",e[e.scrollbar=89]="scrollbar",e[e.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=91]="scrollBeyondLastLine",e[e.scrollPredominantAxis=92]="scrollPredominantAxis",e[e.selectionClipboard=93]="selectionClipboard",e[e.selectionHighlight=94]="selectionHighlight",e[e.selectOnLineNumbers=95]="selectOnLineNumbers",e[e.showFoldingControls=96]="showFoldingControls",e[e.showUnused=97]="showUnused",e[e.snippetSuggestions=98]="snippetSuggestions",e[e.smartSelect=99]="smartSelect",e[e.smoothScrolling=100]="smoothScrolling",e[e.stickyTabStops=101]="stickyTabStops",e[e.stopRenderingLineAfter=102]="stopRenderingLineAfter",e[e.suggest=103]="suggest",e[e.suggestFontSize=104]="suggestFontSize",e[e.suggestLineHeight=105]="suggestLineHeight",e[e.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",e[e.suggestSelection=107]="suggestSelection",e[e.tabCompletion=108]="tabCompletion",e[e.tabIndex=109]="tabIndex",e[e.unusualLineTerminators=110]="unusualLineTerminators",e[e.useTabStops=111]="useTabStops",e[e.wordSeparators=112]="wordSeparators",e[e.wordWrap=113]="wordWrap",e[e.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=116]="wordWrapColumn",e[e.wordWrapOverride1=117]="wordWrapOverride1",e[e.wordWrapOverride2=118]="wordWrapOverride2",e[e.wrappingIndent=119]="wrappingIndent",e[e.wrappingStrategy=120]="wrappingStrategy",e[e.showDeprecated=121]="showDeprecated",e[e.inlineHints=122]="inlineHints",e[e.editorClassName=123]="editorClassName",e[e.pixelRatio=124]="pixelRatio",e[e.tabFocusMode=125]="tabFocusMode",e[e.layoutInfo=126]="layoutInfo",e[e.wrappingInfo=127]="wrappingInfo"})(h=t.EditorOption||(t.EditorOption={}));var c;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.EndOfLinePreference||(t.EndOfLinePreference={}));var g;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(g=t.EndOfLineSequence||(t.EndOfLineSequence={}));var L;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(L=t.IndentAction||(t.IndentAction={}));var S;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(S=t.InlineHintKind||(t.InlineHintKind={}));var _;(function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(_=t.KeyCode||(t.KeyCode={}));var n;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(n=t.MarkerSeverity||(t.MarkerSeverity={}));var i;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(i=t.MarkerTag||(t.MarkerTag={}));var r;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(r=t.MinimapPosition||(t.MinimapPosition={}));var o;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(o=t.MouseTargetType||(t.MouseTargetType={}));var f;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(f=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var v;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(v=t.OverviewRulerLane||(t.OverviewRulerLane={}));var d;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(d=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var m;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(m=t.RenderMinimap||(t.RenderMinimap={}));var w;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(w=t.ScrollType||(t.ScrollType={}));var N;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(N=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var p;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(p=t.SelectionDirection||(t.SelectionDirection={}));var I;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(I=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var R;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(R=t.SymbolKind||(t.SymbolKind={}));var y;(function(e){e[e.Deprecated=1]="Deprecated"})(y=t.SymbolTag||(t.SymbolTag={}));var q;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(q=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var j;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(j=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var J;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(J=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var V;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(V=t.WrappingIndent||(t.WrappingIndent={}))}),G(Q[31],X([0,1,21,10,17,14,3,6,24,25,30]),function(F,t,M,D,P,s,E,l,u,a,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class C{static chord(g,L){return(0,P.KeyChord)(g,L)}}t.KeyMod=C,C.CtrlCmd=2048,C.Shift=1024,C.Alt=512,C.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:D.Emitter,KeyCode:b.KeyCode,KeyMod:C,Position:E.Position,Range:l.Range,Selection:u.Selection,SelectionDirection:b.SelectionDirection,MarkerSeverity:b.MarkerSeverity,MarkerTag:b.MarkerTag,Uri:s.URI,Token:a.Token}}t.createMonacoBaseAPI=h}),G(Q[32],X([0,1,13]),function(F,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class D{constructor(E,l){this.index=E,this.remainder=l}}t.PrefixSumIndexOfResult=D;class P{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,l){E=(0,M.toUint32)(E);const u=this.values,a=this.prefixSum,b=l.length;return b===0?!1:(this.values=new Uint32Array(u.length+b),this.values.set(u.subarray(0,E),0),this.values.set(u.subarray(E),E+b),this.values.set(l,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,l){return E=(0,M.toUint32)(E),l=(0,M.toUint32)(l),this.values[E]===l?!1:(this.values[E]=l,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,l){E=(0,M.toUint32)(E),l=(0,M.toUint32)(l);const u=this.values,a=this.prefixSum;if(E>=u.length)return!1;let b=u.length-E;return l>=b&&(l=b),l===0?!1:(this.values=new Uint32Array(u.length-l),this.values.set(u.subarray(0,E),0),this.values.set(u.subarray(E+l),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=(0,M.toUint32)(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),E>=this.values.length&&(E=this.values.length-1);for(let u=l;u<=E;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let l=0,u=this.values.length-1,a=0,b=0,C=0;for(;l<=u;)if(a=l+(u-l)/2|0,b=this.prefixSum[a],C=b-this.values[a],E<C)u=a-1;else if(E>=b)l=a+1;else break;return new D(a,E-C)}}t.PrefixSumComputer=P}),G(Q[33],X([0,1,5,3,32]),function(F,t,M,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class s{constructor(l,u,a,b){this._uri=l,this._lines=u,this._eol=a,this._versionId=b,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(l){l.eol&&l.eol!==this._eol&&(this._eol=l.eol,this._lineStarts=null);const u=l.changes;for(const a of u)this._acceptDeleteRange(a.range),this._acceptInsertText(new D.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=l.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const l=this._eol.length,u=this._lines.length,a=new Uint32Array(u);for(let b=0;b<u;b++)a[b]=this._lines[b].length+l;this._lineStarts=new P.PrefixSumComputer(a)}}_setLineText(l,u){this._lines[l]=u,this._lineStarts&&this._lineStarts.changeValue(l,this._lines[l].length+this._eol.length)}_acceptDeleteRange(l){if(l.startLineNumber===l.endLineNumber){if(l.startColumn===l.endColumn)return;this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.startLineNumber-1].substring(l.endColumn-1));return}this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.endLineNumber-1].substring(l.endColumn-1)),this._lines.splice(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(l.startLineNumber,l.endLineNumber-l.startLineNumber)}_acceptInsertText(l,u){if(u.length!==0){let a=(0,M.splitLines)(u);if(a.length===1){this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]+this._lines[l.lineNumber-1].substring(l.column-1));return}a[a.length-1]+=this._lines[l.lineNumber-1].substring(l.column-1),this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]);let b=new Uint32Array(a.length-1);for(let C=1;C<a.length;C++)this._lines.splice(l.lineNumber+C-1,0,a[C]),b[C-1]=a[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(l.lineNumber,b)}}}t.MirrorTextModel=s}),G(Q[35],X([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(F,t,M,D,P,s,E,l,u,a,b,C,h,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class L extends u.MirrorTextModel{get uri(){return this._uri}get version(){return this._versionId}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let o=(0,a.getWordAtText)(i.column,(0,a.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return o?new E.Range(i.lineNumber,o.startColumn,i.lineNumber,o.endColumn):null}getWordUntilPosition(i,r){const o=this.getWordAtPosition(i,r);return o?{word:this._lines[i.lineNumber-1].substring(o.startColumn-1,i.column-1),startColumn:o.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,o=this._wordenize.bind(this);let f=0,v="",d=0,m=[];return{*[Symbol.iterator](){for(;;)if(d<m.length){const w=v.substring(m[d].start,m[d].end);d+=1,yield w}else if(f<r.length)v=r[f],m=o(v,i),d=0,f+=1;else break}}}getLineWords(i,r){let o=this._lines[i-1],f=this._wordenize(o,r),v=[];for(const d of f)v.push({word:o.substring(d.start,d.end),startColumn:d.start+1,endColumn:d.end+1});return v}_wordenize(i,r){const o=[];let f;for(r.lastIndex=0;(f=r.exec(i))&&f[0].length!==0;)o.push({start:f.index,end:f.index+f[0].length});return o}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,o=i.startLineNumber-1,f=i.endLineNumber-1,v=[];v.push(this._lines[o].substring(i.startColumn-1));for(let d=o+1;d<f;d++)v.push(this._lines[d]);return v.push(this._lines[f].substring(0,i.endColumn-1)),v.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),o=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,o)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),o=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||o.lineNumber!==i.endLineNumber||o.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:o.lineNumber,endColumn:o.column}:i}_validatePosition(i){if(!s.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:o}=i,f=!1;if(r<1)r=1,o=1,f=!0;else if(r>this._lines.length)r=this._lines.length,o=this._lines[r-1].length+1,f=!0;else{let v=this._lines[r-1].length+1;o<1?(o=1,f=!0):o>v&&(o=v,f=!0)}return f?{lineNumber:r,column:o}:i}}class S{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new L(P.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){!this._models[i]||this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,o,f){const v=this._getModel(i),d=this._getModel(r);if(!v||!d)return null;const m=v.getLinesContent(),w=d.getLinesContent(),p=new l.DiffComputer(m,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),I=p.changes.length>0?!1:this._modelsAreIdentical(v,d);return{quitEarly:p.quitEarly,identical:I,changes:p.changes}}_modelsAreIdentical(i,r){const o=i.getLineCount(),f=r.getLineCount();if(o!==f)return!1;for(let v=1;v<=o;v++){const d=i.getLineContent(v),m=r.getLineContent(v);if(d!==m)return!1}return!0}async computeDirtyDiff(i,r,o){let f=this._getModel(i),v=this._getModel(r);if(!f||!v)return null;let d=f.getLinesContent(),m=v.getLinesContent();return new l.DiffComputer(d,m,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const o=this._getModel(i);if(!o)return r;const f=[];let v;r=r.slice(0).sort((d,m)=>{if(d.range&&m.range)return E.Range.compareRangesUsingStarts(d.range,m.range);let w=d.range?0:1,N=m.range?0:1;return w-N});for(let{range:d,text:m,eol:w}of r)if(typeof w=="number"&&(v=w),!(E.Range.isEmpty(d)&&!m)){const N=o.getValueInRange(d);if(m=m.replace(/\r\n|\n|\r/g,o.eol),N!==m){if(Math.max(m.length,N.length)>S._diffLimit){f.push({range:d,text:m});continue}const p=(0,M.stringDiff)(N,m,!1),I=o.offsetAt(E.Range.lift(d).getStartPosition());for(const R of p){const y=o.positionAt(I+R.originalStart),q=o.positionAt(I+R.originalStart+R.originalLength),j={text:m.substr(R.modifiedStart,R.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:q.lineNumber,endColumn:q.column}};o.getValueInRange(j.range)!==j.text&&f.push(j)}}}return typeof v=="number"&&f.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f}async computeLinks(i){let r=this._getModel(i);return r?(0,b.computeLinks)(r):null}async textualSuggest(i,r,o,f){const v=new g.StopWatch(!0),d=new RegExp(o,f),m=new Set;e:for(let w of i){const N=this._getModel(w);if(!!N){for(let p of N.words(d))if(!(p===r||!isNaN(Number(p)))&&(m.add(p),m.size>S._suggestionsLimit))break e}}return{words:Array.from(m),duration:v.elapsed()}}async computeWordRanges(i,r,o,f){let v=this._getModel(i);if(!v)return Object.create(null);const d=new RegExp(o,f),m=Object.create(null);for(let w=r.startLineNumber;w<r.endLineNumber;w++){let N=v.getLineWords(w,d);for(const p of N)if(!!isNaN(Number(p.word))){let I=m[p.word];I||(I=[],m[p.word]=I),I.push({startLineNumber:w,startColumn:p.startColumn,endLineNumber:w,endColumn:p.endColumn})}}return m}async navigateValueSet(i,r,o,f,v){let d=this._getModel(i);if(!d)return null;let m=new RegExp(f,v);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let w=d.getValueInRange(r),N=d.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},m);if(!N)return null;let p=d.getValueInRange(N);return C.BasicInplaceReplace.INSTANCE.navigateValueSet(r,w,N,p,o)}loadForeignModule(i,r,o){const f=(m,w)=>this._host.fhr(m,w);let d={host:c.createProxyObject(o,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(d,r),Promise.resolve(c.getAllMethodNames(this._foreignModule))):new Promise((m,w)=>{F([i],N=>{this._foreignModule=N.create(d,r),m(c.getAllMethodNames(this._foreignModule))},w)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(o){return Promise.reject(o)}}}t.EditorSimpleWorker=S,S._diffLimit=1e5,S._suggestionsLimit=1e4;function _(n){return new S(n,null)}t.create=_,typeof importScripts=="function"&&(D.globals.monaco=(0,h.createMonacoBaseAPI)())});"use strict";(function(){var F,t;const M=self.MonacoEnvironment,D=M&&M.baseUrl?M.baseUrl:"../../../",P=typeof((F=self.trustedTypes)===null||F===void 0?void 0:F.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:a=>a,createScript:(a,...b)=>{const C=b.slice(0,-1).join(","),h=b.pop().toString();return`(function anonymous(${C}) {
${h}
})`}}):void 0;function s(){return new Promise((a,b)=>{if(typeof self.define=="function"&&self.define.amd)return a();const C=D+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(C)&&C.substring(0,self.origin.length)!==self.origin)){fetch(C).then(c=>{if(c.status!==200)throw new Error(c.statusText);return c.text()}).then(c=>{c=`${c}
//# sourceURL=${C}`,(P?self.eval(P.createScript("",c)):new Function(c)).call(self),a()}).then(void 0,b);return}P?importScripts(P.createScriptURL(C)):importScripts(C),a()})}const E=function(a){s().then(()=>{require.config({baseUrl:D,catchError:!0,trustedTypesPolicy:P}),require([a],function(b){setTimeout(function(){let C=b.create((h,c)=>{self.postMessage(h,c)},null);for(self.onmessage=h=>C.onmessage(h.data);u.length>0;)self.onmessage(u.shift())},0)})})};let l=!0,u=[];self.onmessage=a=>{if(!l){u.push(a);return}l=!1,E(a.data)}})()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c71be15869a673c5ed7bfd3fe171757d2ba48142/core/vs/base/worker/workerMain.js.map
