/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/process","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Z){for(var e=[],b=0,A=Z.length;b<A;b++)e[b]=ge[Z[b]];return e};define(ge[52],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(A,R){if(!A)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=b}),define(ge[53],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function A(T){const k=[];for(let _ in T)b.call(T,_)&&k.push(T[_]);return k}e.values=A;function R(T,k){for(let _ in T)if(b.call(T,_)&&k({key:_,value:T[_]},function(){delete T[_]})===!1)return}e.forEach=R;function I(T,k){const _=Object.create(null);for(const g of T){const a=k(g);let h=_[a];h||(h=_[a]=[]),h.push(g)}return _}e.groupBy=I;function D(T){const k=Object.create(null);return T&&T.forEach((_,g)=>{k[g]=_}),k}e.fromMap=D;function P(T,k){const _=[],g=[];for(let a of T)k.has(a)||_.push(a);for(let a of k)T.has(a)||g.push(a);return{removed:_,added:g}}e.diffSets=P;function y(T,k){const _=[],g=[];for(let[a,h]of T)k.has(a)||_.push(h);for(let[a,h]of k)T.has(a)||g.push(h);return{removed:_,added:g}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,_){let g=this.map.get(k);g||(g=new Set,this.map.set(k,g)),g.add(_)}delete(k,_){const g=this.map.get(k);!g||(g.delete(_),g.size===0&&this.map.delete(k))}forEach(k,_){const g=this.map.get(k);!g||g.forEach(_)}}e.SetMap=n}),define(ge[68],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(y){return(n,T,k)=>{let _=null,g=null;if(typeof k.value=="function"?(_="value",g=k.value):typeof k.get=="function"&&(_="get",g=k.get),!g)throw new Error("not supported");k[_]=y(g,T)}}e.createDecorator=b;let A=0;function R(){const y=`$memoize${A++}`;let n;const T=function(_,g,a){let h=null,S=null;if(typeof a.value=="function"?(h="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(h="get",S=a.get),!S)throw new Error("not supported");const v=`${y}:${g}`;a[h]=function(...E){return n=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,E)}),this[v]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},T}e.createMemoizer=R;function I(y,n,T){return R()(y,n,T)}e.memoize=I;function D(y,n,T){return b((k,_)=>{const g=`$debounce$${_}`,a=`$debounce$result$${_}`;return function(...h){this[a]||(this[a]=T?T():void 0),clearTimeout(this[g]),n&&(this[a]=n(this[a],...h),h=[this[a]]),this[g]=setTimeout(()=>{k.apply(this,h),this[a]=T?T():void 0},y)}})}e.debounce=D;function P(y,n,T){return b((k,_)=>{const g=`$throttle$timer$${_}`,a=`$throttle$result$${_}`,h=`$throttle$lastRun$${_}`,S=`$throttle$pending$${_}`;return function(...v){if(this[a]||(this[a]=T?T():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),n&&(this[a]=n(this[a],...v)),!this[S]){const E=this[h]+y;E<=Date.now()?(this[h]=Date.now(),k.apply(this,[this[a]]),this[a]=T?T():void 0):(this[S]=!0,this[g]=setTimeout(()=>{this[S]=!1,this[h]=Date.now(),k.apply(this,[this[a]]),this[a]=T?T():void 0},E-Date.now()))}}})}e.throttle=P}),define(ge[16],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function A(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=A;function R(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=R;function I(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=I;function D(s){if(s instanceof Error){let{name:t,message:i}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:o}}return s}e.transformErrorForSerialization=D;const P="Canceled";function y(s){return s instanceof Error&&s.name===P&&s.message===P}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=n;function T(){const s=new Error(P);return s.name=s.message,s}e.canceled=T;function k(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=k;function _(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=_;function g(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function a(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function h(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function u(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=u}),define(ge[14],pe([0,1,16]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(F,U=0){return F[F.length-(1+U)]}e.tail=A;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=R;function I(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=I;function D(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const V=(N+O)/2|0,q=M(F[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=D;function P(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=P;function y(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let X of U){const fe=M(X,N);fe<0?O.push(X):fe>0?V.push(X):q.push(X)}return F<O.length?y(F,O,M):F<O.length+q.length?q[0]:y(F-(O.length+q.length),V,M)}e.quickSelect=y;function n(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=n;function T(F,U,M){const N=[];function O(X,fe,ve){if(!(fe===0&&ve.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===X?(Ae.deleteCount+=fe,Ae.toInsert.push(...ve)):N.push({start:X,deleteCount:fe,toInsert:ve})}}let V=0,q=0;for(;;){if(V===F.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,F.length-V,[]);break}const X=F[V],fe=U[q],ve=M(X,fe);ve===0?(V+=1,q+=1):ve<0?(O(V,1,[]),V+=1):ve>0&&(O(V,0,[fe]),q+=1)}return N}e.sortedDiff=T;function k(F,U,M){const N=T(F,U,M),O=[],V=[];for(const q of N)O.push(...F.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=k;function _(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return a(F,U,N,M,F.length),N}e.top=_;function g(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const X=F.length,fe=F.slice(0,M).sort(U);for(let ve=M,Ae=Math.min(M+N,X);ve<X;ve=Ae,Ae=Math.min(Ae+N,X)){if(ve>M&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,b.canceled)();a(F,U,fe,ve,Ae)}return fe})().then(V,q)})}e.topAsync=g;function a(F,U,M,N,O){for(const V=M.length;N<O;N++){const q=F[N];if(U(q,M[V-1])<0){M.pop();const X=P(M,fe=>U(q,fe)<0);M.splice(X,0,q)}}}function h(F){return F.filter(U=>!!U)}e.coalesce=h;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function v(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=v;function E(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=E;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function u(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function s(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=s;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function i(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=i;function o(F,U){return F.length>0?F[0]:U}e.firstOrDefault=o;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(F.length,U.length);O<V&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function l(F){return[].concat(...F)}e.flatten=l;function f(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=f;function p(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=p;function w(F,U){return F.push(U),()=>d(F,U)}e.insert=w;function d(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=d;function m(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=m;function C(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),V=F[N];F[N]=F[O],F[O]=V}}e.shuffle=C;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function B(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=B;function ee(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=ee;function H(F){return Array.isArray(F)?F:[F]}e.asArray=H;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function W(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=W}),define(ge[69],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(A){const R=this;let I=!1,D;return function(){return I||(I=!0,D=A.apply(R,arguments)),D}}e.once=b}),define(ge[70],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(ge[71],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(A){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}A.is=R;const I=Object.freeze([]);function D(){return I}A.empty=D;function*P(s){yield s}A.single=P;function y(s){return s||I}A.from=y;function n(s){return!s||s[Symbol.iterator]().next().done===!0}A.isEmpty=n;function T(s){return s[Symbol.iterator]().next().value}A.first=T;function k(s,t){for(const i of s)if(t(i))return!0;return!1}A.some=k;function _(s,t){for(const i of s)if(t(i))return i}A.find=_;function*g(s,t){for(const i of s)t(i)&&(yield i)}A.filter=g;function*a(s,t){for(const i of s)yield t(i)}A.map=a;function*h(...s){for(const t of s)for(const i of t)yield i}A.concat=h;function*S(s){for(const t of s)for(const i of t)yield i}A.concatNested=S;function v(s,t,i){let o=i;for(const r of s)o=t(o,r);return o}A.reduce=v;function*E(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}A.slice=E;function c(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const o=s[Symbol.iterator]();for(let r=0;r<t;r++){const l=o.next();if(l.done)return[i,A.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=c;function u(s,t,i=(o,r)=>o===r){const o=s[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=o.next(),f=r.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!i(l.value,f.value))return!1}}A.equals=u})(b=e.Iterable||(e.Iterable={}))}),define(ge[54],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function D(t,i=!1){let o=0,r=t.length,l="",f=0,p=16,w=0;function d(x){let W=0,F=0;for(;W<x;){const U=t.charCodeAt(o);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;o++,W++}return W<x&&(F=-1),F}function m(x){o=x,l="",f=0,p=16,w=0}function C(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return w=3,t.substring(x,o);let W=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;W=o}else w=3;return t.substring(x,W)}function L(){let x="",W=o;for(;;){if(o>=r){x+=t.substring(W,o),w=2;break}const F=t.charCodeAt(o);if(F===34){x+=t.substring(W,o),o++;break}if(F===92){if(x+=t.substring(W,o),o++,o>=r){w=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=d(4);M>=0?x+=String.fromCharCode(M):w=4;break;default:w=5}W=o;continue}if(F>=0&&F<=31)if(y(F)){x+=t.substring(W,o),w=2;break}else w=6;o++}return x}function B(){if(l="",w=0,f=o,o>=r)return f=r,p=17;let x=t.charCodeAt(o);if(P(x)){do o++,l+=String.fromCharCode(x),x=t.charCodeAt(o);while(P(x));return p=15}if(y(x))return o++,l+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,l+=`
`),p=14;switch(x){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,l=L(),p=10;case 47:const W=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!y(t.charCodeAt(o));)o++;return l=t.substring(W,o),p=12}if(t.charCodeAt(o+1)===42){o+=2;const F=r-1;let U=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,w=1),l=t.substring(W,o),p=13}return l+=String.fromCharCode(x),o++,p=16;case 45:if(l+=String.fromCharCode(x),o++,o===r||!n(t.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),p=11;default:for(;o<r&&ee(x);)o++,x=t.charCodeAt(o);if(f!==o){switch(l=t.substring(f,o),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(x),o++,p=16}}function ee(x){if(P(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:m,getPosition:()=>o,scan:i?H:B,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>w}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const o=[],r=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function w(d,m,C,L){f.value=d,f.offset=m,f.length=C,f.type=L,f.colonOffset=void 0,l=f}try{c(t,{onObjectBegin:(d,m)=>{if(i<=d)throw r;l=void 0,p=i>d,o.push("")},onObjectProperty:(d,m,C)=>{if(i<m||(w(d,m,C,"property"),o[o.length-1]=d,i<=m+C))throw r},onObjectEnd:(d,m)=>{if(i<=d)throw r;l=void 0,o.pop()},onArrayBegin:(d,m)=>{if(i<=d)throw r;l=void 0,o.push(0)},onArrayEnd:(d,m)=>{if(i<=d)throw r;l=void 0,o.pop()},onLiteralValue:(d,m,C)=>{if(i<m||(w(d,m,C,s(d)),i<=m+C))throw r},onSeparator:(d,m,C)=>{if(i<=m)throw r;if(d===":"&&l&&l.type==="property")l.colonOffset=m,p=!1,l=void 0;else if(d===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(p=!0,o[o.length-1]=""),l=void 0}}})}catch(d){if(d!==r)throw d}return{path:o,previousNode:l,isAtPropertyKey:p,matches:d=>{let m=0;for(let C=0;m<d.length&&C<o.length;C++)if(d[m]===o[C]||d[m]==="*")m++;else if(d[m]!=="**")return!1;return m===d.length}}}e.getLocation=k;function _(t,i=[],o=I.DEFAULT){let r=null,l=[];const f=[];function p(d){Array.isArray(l)?l.push(d):r!==null&&(l[r]=d)}return c(t,{onObjectBegin:()=>{const d={};p(d),f.push(l),l=d,r=null},onObjectProperty:d=>{r=d},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const d=[];p(d),f.push(l),l=d,r=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:p,onError:(d,m,C)=>{i.push({error:d,offset:m,length:C})}},o),l[0]}e.parse=_;function g(t,i=[],o=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(d){r.type==="property"&&(r.length=d-r.offset,r=r.parent)}function f(d){return r.children.push(d),d}c(t,{onObjectBegin:d=>{r=f({type:"object",offset:d,length:-1,parent:r,children:[]})},onObjectProperty:(d,m,C)=>{r=f({type:"property",offset:m,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:d,offset:m,length:C,parent:r})},onObjectEnd:(d,m)=>{r.length=d+m-r.offset,r=r.parent,l(d+m)},onArrayBegin:(d,m)=>{r=f({type:"array",offset:d,length:-1,parent:r,children:[]})},onArrayEnd:(d,m)=>{r.length=d+m-r.offset,r=r.parent,l(d+m)},onLiteralValue:(d,m,C)=>{f({type:s(d),offset:m,length:C,parent:r,value:d}),l(m+C)},onSeparator:(d,m,C)=>{r.type==="property"&&(d===":"?r.colonOffset=m:d===","&&l(m))},onError:(d,m,C)=>{i.push({error:d,offset:m,length:C})}},o);const w=r.children[0];return w&&delete w.parent,w}e.parseTree=g;function a(t,i){if(!!t){let o=t;for(let r of i)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let l=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===r){o=f.children[1],l=!0;break}if(!l)return}else{const l=r;if(o.type!=="array"||l<0||!Array.isArray(o.children)||l>=o.children.length)return;o=o.children[l]}return o}}e.findNodeAtLocation=a;function h(t){if(!t.parent||!t.parent.children)return[];const i=h(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(i[o.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=v;function E(t,i,o=!1){if(v(t,i,o)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const f=E(r[l],i,o);if(f)return f}return t}}e.findNodeAtOffset=E;function c(t,i,o=I.DEFAULT){const r=D(t,!1);function l(fe){return fe?()=>fe(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(fe){return fe?ve=>fe(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=l(i.onObjectBegin),w=f(i.onObjectProperty),d=l(i.onObjectEnd),m=l(i.onArrayBegin),C=l(i.onArrayEnd),L=f(i.onLiteralValue),B=f(i.onSeparator),ee=l(i.onComment),H=f(i.onError),x=o&&o.disallowComments,W=o&&o.allowTrailingComma;function F(){for(;;){const fe=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(fe){case 12:case 13:x?U(10):ee();break;case 16:U(1);break;case 15:case 14:break;default:return fe}}}function U(fe,ve=[],Ae=[]){if(H(fe),ve.length+Ae.length>0){let Ie=r.getToken();for(;Ie!==17;){if(ve.indexOf(Ie)!==-1){F();break}else if(Ae.indexOf(Ie)!==-1)break;Ie=F()}}}function M(fe){const ve=r.getTokenValue();return fe?L(ve):w(ve),F(),!0}function N(){switch(r.getToken()){case 11:let fe=0;try{fe=JSON.parse(r.getTokenValue()),typeof fe!="number"&&(U(2),fe=0)}catch(ve){U(2)}L(fe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(B(":"),F(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){p(),F();let fe=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(fe||U(4,[],[]),B(","),F(),r.getToken()===2&&W)break}else fe&&U(6,[],[]);O()||U(4,[],[2,5]),fe=!0}return d(),r.getToken()!==2?U(7,[2],[]):F(),!0}function q(){m(),F();let fe=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(fe||U(4,[],[]),B(","),F(),r.getToken()===4&&W)break}else fe&&U(6,[],[]);X()||U(4,[],[4,5]),fe=!0}return C(),r.getToken()!==4?U(8,[4],[]):F(),!0}function X(){switch(r.getToken()){case 3:return q();case 1:return V();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function u(t,i){let o=D(t),r=[],l,f=0,p;do switch(p=o.getPosition(),l=o.scan(),l){case 12:case 13:case 17:f!==p&&r.push(t.substring(f,p)),i!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,i)),f=o.getPosition();break}while(l!==17);return r.join("")}e.stripComments=u;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(ge[131],pe([0,1,54]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(y,n,T){let k,_,g,a,h;if(n){for(a=n.offset,h=a+n.length,g=a;g>0&&!P(y,g-1);)g--;let f=h;for(;f<y.length&&!P(y,f);)f++;_=y.substring(g,f),k=I(_,T)}else _=y,k=0,g=0,a=0,h=y.length;const S=D(T,y);let v=!1,E=0,c;T.insertSpaces?c=R(" ",T.tabSize||4):c="	";const u=(0,b.createScanner)(_,!1);let s=!1;function t(){return S+R(c,k+E)}function i(){let f=u.scan();for(v=!1;f===15||f===14;)v=v||f===14,f=u.scan();return s=f===16||u.getTokenError()!==0,f}const o=[];function r(f,p,w){!s&&p<h&&w>a&&y.substring(p,w)!==f&&o.push({offset:p,length:w-p,content:f})}let l=i();if(l!==17){const f=u.getTokenOffset()+g,p=R(c,k);r(p,g,f)}for(;l!==17;){let f=u.getTokenOffset()+u.getTokenLength()+g,p=i(),w="";for(;!v&&(p===12||p===13);){const m=u.getTokenOffset()+g;r(" ",f,m),f=u.getTokenOffset()+u.getTokenLength()+g,w=p===12?t():"",p=i()}if(p===2)l!==1&&(E--,w=t());else if(p===4)l!==3&&(E--,w=t());else{switch(l){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:v?w=t():w=" ";break;case 6:w=" ";break;case 10:if(p===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?w=" ":p!==5&&p!==17&&(s=!0);break;case 16:s=!0;break}v&&(p===12||p===13)&&(w=t())}const d=u.getTokenOffset()+g;r(w,f,d),l=p}return o}e.format=A;function R(y,n){let T="";for(let k=0;k<n;k++)T+=y;return T}function I(y,n){let T=0,k=0;const _=n.tabSize||4;for(;T<y.length;){const g=y.charAt(T);if(g===" ")k++;else if(g==="	")k+=_;else break;T++}return Math.floor(k/_)}function D(y,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function P(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=P}),define(ge[132],pe([0,1,54,131]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(n,T,k){return I(n,T,void 0,k)}e.removeProperty=R;function I(n,T,k,_,g){const a=T.slice(),h=[],S=(0,b.parseTree)(n,h);let v,E;for(;a.length>0&&(E=a.pop(),v=(0,b.findNodeAtLocation)(S,a),v===void 0&&k!==void 0);)typeof E=="string"?k={[E]:k}:k=[k];if(v)if(v.type==="object"&&typeof E=="string"&&Array.isArray(v.children)){const c=(0,b.findNodeAtLocation)(v,[E]);if(c!==void 0)if(k===void 0){if(!c.parent)throw new Error("Malformed AST");const u=v.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(u>0){const i=v.children[u-1];s=i.offset+i.length}else s=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return D(n,{offset:s,length:t-s,content:""},_)}else return D(n,{offset:c.offset,length:c.length,content:JSON.stringify(k)},_);else{if(k===void 0)return[];const u=`${JSON.stringify(E)}: ${JSON.stringify(k)}`,s=g?g(v.children.map(i=>i.children[0].value)):v.children.length;let t;if(s>0){const i=v.children[s-1];t={offset:i.offset+i.length,length:0,content:","+u}}else v.children.length===0?t={offset:v.offset+1,length:0,content:u}:t={offset:v.offset+1,length:0,content:u+","};return D(n,t,_)}}else if(v.type==="array"&&typeof E=="number"&&Array.isArray(v.children))if(k!==void 0){const c=`${JSON.stringify(k)}`;let u;if(v.children.length===0||E===0)u={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const s=E===-1||E>v.children.length?v.children.length:E,t=v.children[s-1];u={offset:t.offset+t.length,length:0,content:","+c}}return D(n,u,_)}else{const c=E,u=v.children[c];let s;if(v.children.length===1)s={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const t=v.children[c-1],i=t.offset+t.length,o=v.offset+v.length;s={offset:i,length:o-2-i,content:""}}else s={offset:u.offset,length:v.children[c+1].offset-u.offset,content:""};return D(n,s,_)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(n,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(k)},_)}}e.setProperty=I;function D(n,T,k){let _=P(n,T),g=T.offset,a=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;g>0&&!(0,A.isEOL)(_,g-1);)g--;for(;a<_.length&&!(0,A.isEOL)(_,a);)a++}const h=(0,A.format)(_,{offset:g,length:a-g},k);for(let v=h.length-1;v>=0;v--){const E=h[v];_=P(_,E),g=Math.min(g,E.offset),a=Math.max(a,E.offset+E.length),a+=E.content.length-E.length}const S=n.length-(_.length-a)-g;return[{offset:g,length:S,content:_.substring(g,a)}]}e.withFormatting=D;function P(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=P;function y(n,T){let k=T.slice(0).sort((g,a)=>{const h=g.offset-a.offset;return h===0?g.length-a.length:h}),_=n.length;for(let g=k.length-1;g>=0;g--){let a=k[g];if(a.offset+a.length<=_)n=P(n,a);else throw new Error("Overlapping edit");_=a.offset}return n}e.applyEdits=y}),define(ge[133],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new b(()=>R(this.getValue()))}}e.Lazy=b}),define(ge[6],pe([0,1,69,71]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let I=null;function D(c){I=c}if(e.setDisposableTracker=D,R){const c="__is_disposable_tracked__";I=new class{trackDisposable(u){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[c]||console.log(s)},3e3)}markTracked(u){if(u&&u!==h.None)try{u[c]=!0}catch(s){}}}}function P(c){!I||I.markTracked(c)}function y(c){return I&&I.trackDisposable(c),c}e.trackDisposable=y;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function T(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=T;function k(c){if(A.Iterable.is(c)){let u=[];for(const s of c)if(s){P(s);try{s.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(c)?[]:c}else if(c)return P(c),c.dispose(),c}e.dispose=k;function _(...c){return c.forEach(P),g(()=>k(c))}e.combinedDisposable=_;function g(c){const u=y({dispose:()=>{P(u),c()}});return u}e.toDisposable=g;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return P(u),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new a,y(this)}dispose(){P(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var s;this._isDisposed||u===this._value||((s=this._value)===null||s===void 0||s.dispose(),u&&P(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,P(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(u,...s){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...s)},this.references.set(u,t));const{object:i}=t,o=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=v;class E{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=E}),define(ge[55],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(I){this.element=I,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class A{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,D){const P=new b(I);if(this._first===b.Undefined)this._first=P,this._last=P;else if(D){const n=this._last;this._last=P,P.prev=n,n.next=P}else{const n=this._first;this._first=P,P.next=n,n.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==b.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==b.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==b.Undefined&&I.next!==b.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===b.Undefined&&I.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):I.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):I.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==b.Undefined;)yield I.element,I=I.next}}e.LinkedList=A}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(K,se){for(var de=0;de<se.length;de++){var Y=se[de];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(K,Y.key,Y)}}function e(K,se,de){return se&&Z(K.prototype,se),de&&Z(K,de),K}function b(K,se){if(!!K){if(typeof K=="string")return A(K,se);var de=Object.prototype.toString.call(K).slice(8,-1);if(de==="Object"&&K.constructor&&(de=K.constructor.name),de==="Map"||de==="Set")return Array.from(K);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return A(K,se)}}function A(K,se){(se==null||se>K.length)&&(se=K.length);for(var de=0,Y=new Array(se);de<se;de++)Y[de]=K[de];return Y}function R(K,se){var de;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(de=b(K))||se&&K&&typeof K.length=="number"){de&&(K=de);var Y=0;return function(){return Y>=K.length?{done:!0}:{done:!1,value:K[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=K[Symbol.iterator](),de.next.bind(de)}function I(K){var se={exports:{}};return K(se,se.exports),se.exports}var D=I(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(Y){K.exports.defaults=Y}K.exports={defaults:se(),getDefaults:se,changeDefaults:de}}),P=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(se){return k[se]};function g(K,se){if(se){if(P.test(K))return K.replace(y,_)}else if(n.test(K))return K.replace(T,_);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(K){return K.replace(a,function(se,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(K,se){K=K.source||K,se=se||"";var de={replace:function(ne,le){return le=le.source||le,le=le.replace(S,"$1"),K=K.replace(ne,le),de},getRegex:function(){return new RegExp(K,se)}};return de}var E=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(K,se,de){if(K){var Y;try{Y=decodeURIComponent(h(de)).replace(E,"").toLowerCase()}catch(ne){return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}se&&!c.test(de)&&(de=r(se,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(ne){return null}return de}var s={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,se){s[" "+K]||(t.test(K)?s[" "+K]=K+"/":s[" "+K]=w(K,"/",!0)),K=s[" "+K];var de=K.indexOf(":")===-1;return se.substring(0,2)==="//"?de?se:K.replace(i,"$1")+se:se.charAt(0)==="/"?de?se:K.replace(o,"$1")+se:K+se}var l={exec:function(){}};function f(K){for(var se=1,de,Y;se<arguments.length;se++){de=arguments[se];for(Y in de)Object.prototype.hasOwnProperty.call(de,Y)&&(K[Y]=de[Y])}return K}function p(K,se){var de=K.replace(/\|/g,function(le,me,_e){for(var He=!1,$e=me;--$e>=0&&_e[$e]==="\\";)He=!He;return He?"|":" |"}),Y=de.split(/ \|/),ne=0;if(Y.length>se)Y.splice(se);else for(;Y.length<se;)Y.push("");for(;ne<Y.length;ne++)Y[ne]=Y[ne].trim().replace(/\\\|/g,"|");return Y}function w(K,se,de){var Y=K.length;if(Y===0)return"";for(var ne=0;ne<Y;){var le=K.charAt(Y-ne-1);if(le===se&&!de)ne++;else if(le!==se&&de)ne++;else break}return K.substr(0,Y-ne)}function d(K,se){if(K.indexOf(se[1])===-1)return-1;for(var de=K.length,Y=0,ne=0;ne<de;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===se[0])Y++;else if(K[ne]===se[1]&&(Y--,Y<0))return ne;return-1}function m(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(K,se){if(se<1)return"";for(var de="";se>1;)se&1&&(de+=K),se>>=1,K+=K;return de+K}var L={escape:g,unescape:h,edit:v,cleanUrl:u,resolveUrl:r,noopTest:l,merge:f,splitCells:p,rtrim:w,findClosingBracket:d,checkSanitizeDeprecation:m,repeatString:C},B=D.defaults,ee=L.rtrim,H=L.splitCells,x=L.escape,W=L.findClosingBracket;function F(K,se,de){var Y=se.href,ne=se.title?x(se.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:de,href:Y,title:ne,text:le}:{type:"image",raw:de,href:Y,title:ne,text:x(le)}}function U(K,se){var de=K.match(/^(\s+)(?:```)/);if(de===null)return se;var Y=de[1];return se.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var me=le[0];return me.length>=Y.length?ne.slice(Y.length):ne}).join(`
`)}var M=function(){function K(de){this.options=de||B}var se=K.prototype;return se.space=function(Y){var ne=this.rules.block.newline.exec(Y);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},se.code=function(Y){var ne=this.rules.block.code.exec(Y);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:ee(le,`
`)}}},se.fences=function(Y){var ne=this.rules.block.fences.exec(Y);if(ne){var le=ne[0],me=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:me}}},se.heading=function(Y){var ne=this.rules.block.heading.exec(Y);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var me=ee(le,"#");(this.options.pedantic||!me||/ $/.test(me))&&(le=me.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},se.nptable=function(Y){var ne=this.rules.block.nptable.exec(Y);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var me=le.align.length,_e;for(_e=0;_e<me;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(me=le.cells.length,_e=0;_e<me;_e++)le.cells[_e]=H(le.cells[_e],le.header.length);return le}}},se.hr=function(Y){var ne=this.rules.block.hr.exec(Y);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(Y){var ne=this.rules.block.blockquote.exec(Y);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},se.list=function(Y){var ne=this.rules.block.list.exec(Y);if(ne){var le=ne[0],me=ne[2],_e=me.length>1,He={type:"list",raw:le,ordered:_e,start:_e?+me.slice(0,-1):"",loose:!1,items:[]},$e=ne[0].match(this.rules.block.item),Ke=!1,Je,Ze,ut,lt,it,qe,Ee,Ce,ce=$e.length;ut=this.rules.block.listItemStart.exec($e[0]);for(var G=0;G<ce;G++){if(Je=$e[G],le=Je,G!==ce-1){if(lt=this.rules.block.listItemStart.exec($e[G+1]),this.options.pedantic?lt[1].length>ut[1].length:lt[1].length>ut[0].length||lt[1].length>3){$e.splice(G,2,$e[G]+`
`+$e[G+1]),G--,ce--;continue}else(!this.options.pedantic||this.options.smartLists?lt[2][lt[2].length-1]!==me[me.length-1]:_e===(lt[2].length===1))&&(it=$e.slice(G+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-it.length),G=ce-1);ut=lt}Ze=Je.length,Je=Je.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Je.indexOf(`
 `)&&(Ze-=Je.length,Je=this.options.pedantic?Je.replace(/^ {1,4}/gm,""):Je.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),qe=Ke||/\n\n(?!\s*$)/.test(Je),G!==ce-1&&(Ke=Je.charAt(Je.length-1)===`
`,qe||(qe=Ke)),qe&&(He.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(Je),Ce=void 0,Ee&&(Ce=Je[1]!==" ",Je=Je.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:Ee,checked:Ce,loose:qe,text:Je})}return He}},se.html=function(Y){var ne=this.rules.block.html.exec(Y);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):x(ne[0]):ne[0]}},se.def=function(Y){var ne=this.rules.block.def.exec(Y);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(Y){var ne=this.rules.block.table.exec(Y);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var me=le.align.length,_e;for(_e=0;_e<me;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(me=le.cells.length,_e=0;_e<me;_e++)le.cells[_e]=H(le.cells[_e].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},se.lheading=function(Y){var ne=this.rules.block.lheading.exec(Y);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},se.paragraph=function(Y){var ne=this.rules.block.paragraph.exec(Y);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},se.text=function(Y){var ne=this.rules.block.text.exec(Y);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},se.escape=function(Y){var ne=this.rules.inline.escape.exec(Y);if(ne)return{type:"escape",raw:ne[0],text:x(ne[1])}},se.tag=function(Y,ne,le){var me=this.rules.inline.tag.exec(Y);if(me)return!ne&&/^<a /i.test(me[0])?ne=!0:ne&&/^<\/a>/i.test(me[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):x(me[0]):me[0]}},se.link=function(Y){var ne=this.rules.inline.link.exec(Y);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var me=ee(le.slice(0,-1),"\\");if((le.length-me.length)%2==0)return}else{var _e=W(ne[2],"()");if(_e>-1){var He=ne[0].indexOf("!")===0?5:4,$e=He+ne[1].length+_e;ne[2]=ne[2].substring(0,_e),ne[0]=ne[0].substring(0,$e).trim(),ne[3]=""}}var Ke=ne[2],Je="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);Ze&&(Ke=Ze[1],Je=Ze[3])}else Je=ne[3]?ne[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(le)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),F(ne,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},ne[0])}},se.reflink=function(Y,ne){var le;if((le=this.rules.inline.reflink.exec(Y))||(le=this.rules.inline.nolink.exec(Y))){var me=(le[2]||le[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var _e=le[0].charAt(0);return{type:"text",raw:_e,text:_e}}return F(le,me,le[0])}},se.emStrong=function(Y,ne,le){le===void 0&&(le="");var me=this.rules.inline.emStrong.lDelim.exec(Y);if(!!me&&!(me[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _e=me[1]||me[2]||"";if(!_e||_e&&(le===""||this.rules.inline.punctuation.exec(le))){var He=me[0].length-1,$e,Ke,Je=He,Ze=0,ut=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*Y.length+He);(me=ut.exec(ne))!=null;)if($e=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!$e){if(Ke=$e.length,me[3]||me[4]){Je+=Ke;continue}else if((me[5]||me[6])&&He%3&&!((He+Ke)%3)){Ze+=Ke;continue}if(Je-=Ke,!(Je>0)){if(Je+Ze-Ke<=0&&!ne.slice(ut.lastIndex).match(ut)&&(Ke=Math.min(Ke,Ke+Je+Ze)),Math.min(He,Ke)%2)return{type:"em",raw:Y.slice(0,He+me.index+Ke+1),text:Y.slice(1,He+me.index+Ke)};if(Math.min(He,Ke)%2==0)return{type:"strong",raw:Y.slice(0,He+me.index+Ke+1),text:Y.slice(2,He+me.index+Ke-1)}}}}}},se.codespan=function(Y){var ne=this.rules.inline.code.exec(Y);if(ne){var le=ne[2].replace(/\n/g," "),me=/[^ ]/.test(le),_e=/^ /.test(le)&&/ $/.test(le);return me&&_e&&(le=le.substring(1,le.length-1)),le=x(le,!0),{type:"codespan",raw:ne[0],text:le}}},se.br=function(Y){var ne=this.rules.inline.br.exec(Y);if(ne)return{type:"br",raw:ne[0]}},se.del=function(Y){var ne=this.rules.inline.del.exec(Y);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},se.autolink=function(Y,ne){var le=this.rules.inline.autolink.exec(Y);if(le){var me,_e;return le[2]==="@"?(me=x(this.options.mangle?ne(le[1]):le[1]),_e="mailto:"+me):(me=x(le[1]),_e=me),{type:"link",raw:le[0],text:me,href:_e,tokens:[{type:"text",raw:me,text:me}]}}},se.url=function(Y,ne){var le;if(le=this.rules.inline.url.exec(Y)){var me,_e;if(le[2]==="@")me=x(this.options.mangle?ne(le[0]):le[0]),_e="mailto:"+me;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);me=x(le[0]),le[1]==="www."?_e="http://"+me:_e=me}return{type:"link",raw:le[0],text:me,href:_e,tokens:[{type:"text",raw:me,text:me}]}}},se.inlineText=function(Y,ne,le){var me=this.rules.inline.text.exec(Y);if(me){var _e;return ne?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):x(me[0]):me[0]:_e=x(this.options.smartypants?le(me[0]):me[0]),{type:"text",raw:me[0],text:_e}}},K}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=O(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=O(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=O(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=O(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=O(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=O(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=O(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=O(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=O(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=V({},X),X.pedantic=V({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=V({},X.normal,{escape:O(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=O(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=V({},X.gfm,{br:O(X.br).replace("{2,}","*").getRegex(),text:O(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:q,inline:X},ve=D.defaults,Ae=fe.block,Ie=fe.inline,Fe=L.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var se="",de,Y,ne=K.length;for(de=0;de<ne;de++)Y=K.charCodeAt(de),Math.random()>.5&&(Y="x"+Y.toString(16)),se+="&#"+Y+";";return se}var te=function(){function K(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ve,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Y={block:Ae.normal,inline:Ie.normal};this.options.pedantic?(Y.block=Ae.pedantic,Y.inline=Ie.pedantic):this.options.gfm&&(Y.block=Ae.gfm,this.options.breaks?Y.inline=Ie.breaks:Y.inline=Ie.gfm),this.tokenizer.rules=Y}K.lex=function(Y,ne){var le=new K(ne);return le.lex(Y)},K.lexInline=function(Y,ne){var le=new K(ne);return le.inlineTokens(Y)};var se=K.prototype;return se.lex=function(Y){return Y=Y.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Y,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(Y,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(Y=Y.replace(/^ +$/gm,""));for(var me,_e,He,$e;Y;){if(me=this.tokenizer.space(Y)){Y=Y.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(Y)){Y=Y.substring(me.raw.length),$e=ne[ne.length-1],$e&&$e.type==="paragraph"?($e.raw+=`
`+me.raw,$e.text+=`
`+me.text):ne.push(me);continue}if(me=this.tokenizer.fences(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.nptable(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(Y)){Y=Y.substring(me.raw.length),me.tokens=this.blockTokens(me.text,[],le),ne.push(me);continue}if(me=this.tokenizer.list(Y)){for(Y=Y.substring(me.raw.length),He=me.items.length,_e=0;_e<He;_e++)me.items[_e].tokens=this.blockTokens(me.items[_e].text,[],!1);ne.push(me);continue}if(me=this.tokenizer.html(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.def(Y))){Y=Y.substring(me.raw.length),this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(Y)){Y=Y.substring(me.raw.length),ne.push(me);continue}if(le&&(me=this.tokenizer.paragraph(Y))){Y=Y.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.text(Y)){Y=Y.substring(me.raw.length),$e=ne[ne.length-1],$e&&$e.type==="text"?($e.raw+=`
`+me.raw,$e.text+=`
`+me.text):ne.push(me);continue}if(Y){var Ke="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return ne},se.inline=function(Y){var ne,le,me,_e,He,$e,Ke=Y.length;for(ne=0;ne<Ke;ne++)switch($e=Y[ne],$e.type){case"paragraph":case"text":case"heading":{$e.tokens=[],this.inlineTokens($e.text,$e.tokens);break}case"table":{for($e.tokens={header:[],cells:[]},_e=$e.header.length,le=0;le<_e;le++)$e.tokens.header[le]=[],this.inlineTokens($e.header[le],$e.tokens.header[le]);for(_e=$e.cells.length,le=0;le<_e;le++)for(He=$e.cells[le],$e.tokens.cells[le]=[],me=0;me<He.length;me++)$e.tokens.cells[le][me]=[],this.inlineTokens(He[me],$e.tokens.cells[le][me]);break}case"blockquote":{this.inline($e.tokens);break}case"list":{for(_e=$e.items.length,le=0;le<_e;le++)this.inline($e.items[le].tokens);break}}return Y},se.inlineTokens=function(Y,ne,le,me){ne===void 0&&(ne=[]),le===void 0&&(le=!1),me===void 0&&(me=!1);var _e,He,$e=Y,Ke,Je,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ut.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ke.index)+"["+Fe("a",Ke[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ke.index)+"["+Fe("a",Ke[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ke.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;){if(Je||(Ze=""),Je=!1,_e=this.tokenizer.escape(Y)){Y=Y.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.tag(Y,le,me)){Y=Y.substring(_e.raw.length),le=_e.inLink,me=_e.inRawBlock;var lt=ne[ne.length-1];lt&&_e.type==="text"&&lt.type==="text"?(lt.raw+=_e.raw,lt.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.link(Y)){Y=Y.substring(_e.raw.length),_e.type==="link"&&(_e.tokens=this.inlineTokens(_e.text,[],!0,me)),ne.push(_e);continue}if(_e=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(_e.raw.length);var it=ne[ne.length-1];_e.type==="link"?(_e.tokens=this.inlineTokens(_e.text,[],!0,me),ne.push(_e)):it&&_e.type==="text"&&it.type==="text"?(it.raw+=_e.raw,it.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.emStrong(Y,$e,Ze)){Y=Y.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,me),ne.push(_e);continue}if(_e=this.tokenizer.codespan(Y)){Y=Y.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.br(Y)){Y=Y.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.del(Y)){Y=Y.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,me),ne.push(_e);continue}if(_e=this.tokenizer.autolink(Y,J)){Y=Y.substring(_e.raw.length),ne.push(_e);continue}if(!le&&(_e=this.tokenizer.url(Y,J))){Y=Y.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.inlineText(Y,me,z)){Y=Y.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(Ze=_e.raw.slice(-1)),Je=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=_e.raw,He.text+=_e.text):ne.push(_e);continue}if(Y){var qe="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ie}}}]),K}(),ae=D.defaults,he=L.cleanUrl,De=L.escape,Me=function(){function K(de){this.options=de||ae}var se=K.prototype;return se.code=function(Y,ne,le){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var _e=this.options.highlight(Y,me);_e!=null&&_e!==Y&&(le=!0,Y=_e)}return Y=Y.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+De(me,!0)+'">'+(le?Y:De(Y,!0))+`</code></pre>
`:"<pre><code>"+(le?Y:De(Y,!0))+`</code></pre>
`},se.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},se.html=function(Y){return Y},se.heading=function(Y,ne,le,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(le)+'">'+Y+"</h"+ne+`>
`:"<h"+ne+">"+Y+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Y,ne,le){var me=ne?"ol":"ul",_e=ne&&le!==1?' start="'+le+'"':"";return"<"+me+_e+`>
`+Y+"</"+me+`>
`},se.listitem=function(Y){return"<li>"+Y+`</li>
`},se.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Y){return"<p>"+Y+`</p>
`},se.table=function(Y,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+ne+`</table>
`},se.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},se.tablecell=function(Y,ne){var le=ne.header?"th":"td",me=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return me+Y+"</"+le+`>
`},se.strong=function(Y){return"<strong>"+Y+"</strong>"},se.em=function(Y){return"<em>"+Y+"</em>"},se.codespan=function(Y){return"<code>"+Y+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Y){return"<del>"+Y+"</del>"},se.link=function(Y,ne,le){if(Y=he(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var me='<a href="'+De(Y)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+le+"</a>",me},se.image=function(Y,ne,le){if(Y=he(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var me='<img src="'+Y+'" alt="'+le+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},se.text=function(Y){return Y},K}(),we=function(){function K(){}var se=K.prototype;return se.strong=function(Y){return Y},se.em=function(Y){return Y},se.codespan=function(Y){return Y},se.del=function(Y){return Y},se.html=function(Y){return Y},se.text=function(Y){return Y},se.link=function(Y,ne,le){return""+le},se.image=function(Y,ne,le){return""+le},se.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Y,ne){var le=Y,me=0;if(this.seen.hasOwnProperty(le)){me=this.seen[Y];do me++,le=Y+"-"+me;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[Y]=me,this.seen[le]=0),le},se.slug=function(Y,ne){ne===void 0&&(ne={});var le=this.serialize(Y);return this.getNextSafeSlug(le,ne.dryrun)},K}(),Te=D.defaults,xe=L.unescape,Se=function(){function K(de){this.options=de||Te,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}K.parse=function(Y,ne){var le=new K(ne);return le.parse(Y)},K.parseInline=function(Y,ne){var le=new K(ne);return le.parseInline(Y)};var se=K.prototype;return se.parse=function(Y,ne){ne===void 0&&(ne=!0);var le="",me,_e,He,$e,Ke,Je,Ze,ut,lt,it,qe,Ee,Ce,ce,G,Ne,Re,et,Qe=Y.length;for(me=0;me<Qe;me++)switch(it=Y[me],it.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(it.tokens),it.depth,xe(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(ut="",Ze="",$e=it.header.length,_e=0;_e<$e;_e++)Ze+=this.renderer.tablecell(this.parseInline(it.tokens.header[_e]),{header:!0,align:it.align[_e]});for(ut+=this.renderer.tablerow(Ze),lt="",$e=it.cells.length,_e=0;_e<$e;_e++){for(Je=it.tokens.cells[_e],Ze="",Ke=Je.length,He=0;He<Ke;He++)Ze+=this.renderer.tablecell(this.parseInline(Je[He]),{header:!1,align:it.align[He]});lt+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,lt);continue}case"blockquote":{lt=this.parse(it.tokens),le+=this.renderer.blockquote(lt);continue}case"list":{for(qe=it.ordered,Ee=it.start,Ce=it.loose,$e=it.items.length,lt="",_e=0;_e<$e;_e++)G=it.items[_e],Ne=G.checked,Re=G.task,ce="",G.task&&(et=this.renderer.checkbox(Ne),Ce?G.tokens.length>0&&G.tokens[0].type==="text"?(G.tokens[0].text=et+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=et+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:et}):ce+=et),ce+=this.parse(G.tokens,Ce),lt+=this.renderer.listitem(ce,Re,Ne);le+=this.renderer.list(lt,qe,Ee);continue}case"html":{le+=this.renderer.html(it.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(lt=it.tokens?this.parseInline(it.tokens):it.text;me+1<Qe&&Y[me+1].type==="text";)it=Y[++me],lt+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);le+=ne?this.renderer.paragraph(lt):lt;continue}default:{var at='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return le},se.parseInline=function(Y,ne){ne=ne||this.renderer;var le="",me,_e,He=Y.length;for(me=0;me<He;me++)switch(_e=Y[me],_e.type){case"escape":{le+=ne.text(_e.text);break}case"html":{le+=ne.html(_e.text);break}case"link":{le+=ne.link(_e.href,_e.title,this.parseInline(_e.tokens,ne));break}case"image":{le+=ne.image(_e.href,_e.title,_e.text);break}case"strong":{le+=ne.strong(this.parseInline(_e.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(_e.tokens,ne));break}case"codespan":{le+=ne.codespan(_e.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(_e.tokens,ne));break}case"text":{le+=ne.text(_e.text);break}default:{var $e='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}return le},K}(),Ge=L.merge,Q=L.checkSanitizeDeprecation,ie=L.escape,be=D.getDefaults,Oe=D.changeDefaults,Ve=D.defaults;function We(K,se,de){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(de=se,se=null),se=Ge({},We.defaults,se||{}),Q(se),de){var Y=se.highlight,ne;try{ne=te.lex(K,se)}catch(He){return de(He)}var le=function($e){var Ke;if(!$e)try{Ke=Se.parse(ne,se)}catch(Je){$e=Je}return se.highlight=Y,$e?de($e):de(null,Ke)};if(!Y||Y.length<3||(delete se.highlight,!ne.length))return le();var me=0;We.walkTokens(ne,function(He){He.type==="code"&&(me++,setTimeout(function(){Y(He.text,He.lang,function($e,Ke){if($e)return le($e);Ke!=null&&Ke!==He.text&&(He.text=Ke,He.escaped=!0),me--,me===0&&le()})},0))}),me===0&&le();return}try{var _e=te.lex(K,se);return se.walkTokens&&We.walkTokens(_e,se.walkTokens),Se.parse(_e,se)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(He.message+"",!0)+"</pre>";throw He}}We.options=We.setOptions=function(K){return Ge(We.defaults,K),Oe(We.defaults),We},We.getDefaults=be,We.defaults=Ve,We.use=function(K){var se=Ge({},K);if(K.renderer&&function(){var Y=We.defaults.renderer||new Me,ne=function(_e){var He=Y[_e];Y[_e]=function(){for(var $e=arguments.length,Ke=new Array($e),Je=0;Je<$e;Je++)Ke[Je]=arguments[Je];var Ze=K.renderer[_e].apply(Y,Ke);return Ze===!1&&(Ze=He.apply(Y,Ke)),Ze}};for(var le in K.renderer)ne(le);se.renderer=Y}(),K.tokenizer&&function(){var Y=We.defaults.tokenizer||new M,ne=function(_e){var He=Y[_e];Y[_e]=function(){for(var $e=arguments.length,Ke=new Array($e),Je=0;Je<$e;Je++)Ke[Je]=arguments[Je];var Ze=K.tokenizer[_e].apply(Y,Ke);return Ze===!1&&(Ze=He.apply(Y,Ke)),Ze}};for(var le in K.tokenizer)ne(le);se.tokenizer=Y}(),K.walkTokens){var de=We.defaults.walkTokens;se.walkTokens=function(Y){K.walkTokens(Y),de&&de(Y)}}We.setOptions(se)},We.walkTokens=function(K,se){for(var de=R(K),Y;!(Y=de()).done;){var ne=Y.value;switch(se(ne),ne.type){case"table":{for(var le=R(ne.tokens.header),me;!(me=le()).done;){var _e=me.value;We.walkTokens(_e,se)}for(var He=R(ne.tokens.cells),$e;!($e=He()).done;)for(var Ke=$e.value,Je=R(Ke),Ze;!(Ze=Je()).done;){var ut=Ze.value;We.walkTokens(ut,se)}break}case"list":{We.walkTokens(ne.items,se);break}default:ne.tokens&&We.walkTokens(ne.tokens,se)}}},We.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=Ge({},We.defaults,se||{}),Q(se);try{var de=te.lexInline(K,se);return se.walkTokens&&We.walkTokens(de,se.walkTokens),Se.parseInline(de,se)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(Y.message+"",!0)+"</pre>";throw Y}},We.Parser=Se,We.parser=Se.parse,We.Renderer=Me,We.TextRenderer=we,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=M,We.Slugger=ke,We.parse=We;var tt=We;return tt}),define(ge[72],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(D,P,y){return Math.min(Math.max(D,P),y)}e.clamp=b;function A(D,P){return(P+D%P)%P}e.rot=A;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class I{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function Z(R){const I=[];typeof R=="number"&&I.push("code/timeOrigin",R);function D(y){I.push(y,Date.now())}function P(){const y=[];for(let n=0;n<I.length;n+=2)y.push({name:I[n],startTime:I[n+1]});return y}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(R+D.startTime)});return I}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function b(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=b(A))})(),define(ge[9],pe([0,1]),function(Z,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let R=!1,I=!1,D=!1,P=!1,y=!1,n=!1,T=!1,k,_=A,g,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof process!="undefined"?h=process:typeof e.globals.vscode!="undefined"&&(h=e.globals.vscode.process);const S=typeof((b=h==null?void 0:h.versions)===null||b===void 0?void 0:b.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=h==null?void 0:h.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)a=navigator.userAgent,R=a.indexOf("Windows")>=0,I=a.indexOf("Macintosh")>=0,T=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=a.indexOf("Linux")>=0,n=!0,k=navigator.language,_=k;else if(typeof h=="object"){R=h.platform==="win32",I=h.platform==="darwin",D=h.platform==="linux",P=D&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,k=A,_=A;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),f=l.availableLanguages["*"];k=l.locale,_=f||A,g=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let c=0;I?c=1:R?c=3:D&&(c=2),e.isWindows=R,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=P,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=c,e.userAgent=a,e.language=_;var u;(function(r){function l(){return e.language}r.value=l;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function p(){return e.language==="en"}r.isDefault=p})(u=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let d=0,m=f.length;d<m;d++){const C=f[d];if(C.id===w.data.vscodeSetImmediateId){f.splice(d,1),C.callback();return}}});let p=0;return w=>{const d=++p;f.push({id:d,callback:w}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const l=Promise.resolve();return f=>l.then(f)}();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:R?1:3;let t=!0,i=!1;function o(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[30],pe([0,1,9]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof process!="undefined")A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}};else if(typeof b.globals.vscode!="undefined"){const R=b.globals.vscode.process;A={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(I){return(0,b.setImmediate)(I)}}}else A={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(R){return(0,b.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(ge[8],pe([0,1,30]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,R=97,I=90,D=122,P=46,y=47,n=92,T=58,k=63;class _ extends Error{constructor(u,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const o=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${o} ${i} of type ${s}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(c,u){if(typeof c!="string")throw new _(u,"string",c)}function a(c){return c===y||c===n}function h(c){return c===y}function S(c){return c>=A&&c<=I||c>=R&&c<=D}function v(c,u,s,t){let i="",o=0,r=-1,l=0,f=0;for(let p=0;p<=c.length;++p){if(p<c.length)f=c.charCodeAt(p);else{if(t(f))break;f=y}if(t(f)){if(!(r===p-1||l===1))if(l===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const w=i.lastIndexOf(s);w===-1?(i="",o=0):(i=i.slice(0,w),o=i.length-1-i.lastIndexOf(s)),r=p,l=0;continue}else if(i.length!==0){i="",o=0,r=p,l=0;continue}}u&&(i+=i.length>0?`${s}..`:"..",o=2)}else i.length>0?i+=`${s}${c.slice(r+1,p)}`:i=c.slice(r+1,p),o=p-r-1;r=p,l=0}else f===P&&l!==-1?++l:l=-1}return i}function E(c,u){if(u===null||typeof u!="object")throw new _("pathObject","Object",u);const s=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let u="",s="",t=!1;for(let i=c.length-1;i>=-1;i--){let o;if(i>=0){if(o=c[i],g(o,"path"),o.length===0)continue}else u.length===0?o=b.cwd():(o=b.env[`=${u}`]||b.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${u}\\`));const r=o.length;let l=0,f="",p=!1;const w=o.charCodeAt(0);if(r===1)a(w)&&(l=1,p=!0);else if(a(w))if(p=!0,a(o.charCodeAt(1))){let d=2,m=d;for(;d<r&&!a(o.charCodeAt(d));)d++;if(d<r&&d!==m){const C=o.slice(m,d);for(m=d;d<r&&a(o.charCodeAt(d));)d++;if(d<r&&d!==m){for(m=d;d<r&&!a(o.charCodeAt(d));)d++;(d===r||d!==m)&&(f=`\\\\${C}\\${o.slice(m,d)}`,l=d)}}}else l=1;else S(w)&&o.charCodeAt(1)===T&&(f=o.slice(0,2),l=2,r>2&&a(o.charCodeAt(2))&&(p=!0,l=3));if(f.length>0)if(u.length>0){if(f.toLowerCase()!==u.toLowerCase())continue}else u=f;if(t){if(u.length>0)break}else if(s=`${o.slice(l)}\\${s}`,t=p,p&&u.length>0)break}return s=v(s,!t,"\\",a),t?`${u}\\${s}`:`${u}${s}`||"."},normalize(c){g(c,"path");const u=c.length;if(u===0)return".";let s=0,t,i=!1;const o=c.charCodeAt(0);if(u===1)return h(o)?"\\":c;if(a(o))if(i=!0,a(c.charCodeAt(1))){let l=2,f=l;for(;l<u&&!a(c.charCodeAt(l));)l++;if(l<u&&l!==f){const p=c.slice(f,l);for(f=l;l<u&&a(c.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&!a(c.charCodeAt(l));)l++;if(l===u)return`\\\\${p}\\${c.slice(f)}\\`;l!==f&&(t=`\\\\${p}\\${c.slice(f,l)}`,s=l)}}}else s=1;else S(o)&&c.charCodeAt(1)===T&&(t=c.slice(0,2),s=2,u>2&&a(c.charCodeAt(2))&&(i=!0,s=3));let r=s<u?v(c.slice(s),!i,"\\",a):"";return r.length===0&&!i&&(r="."),r.length>0&&a(c.charCodeAt(u-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(c){g(c,"path");const u=c.length;if(u===0)return!1;const s=c.charCodeAt(0);return a(s)||u>2&&S(s)&&c.charCodeAt(1)===T&&a(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let u,s;for(let o=0;o<c.length;++o){const r=c[o];g(r,"path"),r.length>0&&(u===void 0?u=s=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&a(s.charCodeAt(0))){++i;const o=s.length;o>1&&a(s.charCodeAt(1))&&(++i,o>2&&(a(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<u.length&&a(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(c,u){if(g(c,"from"),g(u,"to"),c===u)return"";const s=e.win32.resolve(c),t=e.win32.resolve(u);if(s===t||(c=s.toLowerCase(),u=t.toLowerCase(),c===u))return"";let i=0;for(;i<c.length&&c.charCodeAt(i)===n;)i++;let o=c.length;for(;o-1>i&&c.charCodeAt(o-1)===n;)o--;const r=o-i;let l=0;for(;l<u.length&&u.charCodeAt(l)===n;)l++;let f=u.length;for(;f-1>l&&u.charCodeAt(f-1)===n;)f--;const p=f-l,w=r<p?r:p;let d=-1,m=0;for(;m<w;m++){const L=c.charCodeAt(i+m);if(L!==u.charCodeAt(l+m))break;L===n&&(d=m)}if(m!==w){if(d===-1)return t}else{if(p>w){if(u.charCodeAt(l+m)===n)return t.slice(l+m+1);if(m===2)return t.slice(l+m)}r>w&&(c.charCodeAt(i+m)===n?d=m:m===2&&(d=3)),d===-1&&(d=0)}let C="";for(m=i+d+1;m<=o;++m)(m===o||c.charCodeAt(m)===n)&&(C+=C.length===0?"..":"\\..");return l+=d,C.length>0?`${C}${t.slice(l,f)}`:(t.charCodeAt(l)===n&&++l,t.slice(l,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const u=e.win32.resolve(c);if(u.length<=2)return c;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const s=u.charCodeAt(2);if(s!==k&&s!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return c},dirname(c){g(c,"path");const u=c.length;if(u===0)return".";let s=-1,t=0;const i=c.charCodeAt(0);if(u===1)return a(i)?c:".";if(a(i)){if(s=t=1,a(c.charCodeAt(1))){let l=2,f=l;for(;l<u&&!a(c.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&a(c.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&!a(c.charCodeAt(l));)l++;if(l===u)return c;l!==f&&(s=t=l+1)}}}}else S(i)&&c.charCodeAt(1)===T&&(s=u>2&&a(c.charCodeAt(2))?3:2,t=s);let o=-1,r=!0;for(let l=u-1;l>=t;--l)if(a(c.charCodeAt(l))){if(!r){o=l;break}}else r=!1;if(o===-1){if(s===-1)return".";o=s}return c.slice(0,o)},basename(c,u){u!==void 0&&g(u,"ext"),g(c,"path");let s=0,t=-1,i=!0,o;if(c.length>=2&&S(c.charCodeAt(0))&&c.charCodeAt(1)===T&&(s=2),u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,l=-1;for(o=c.length-1;o>=s;--o){const f=c.charCodeAt(o);if(a(f)){if(!i){s=o+1;break}}else l===-1&&(i=!1,l=o+1),r>=0&&(f===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=s;--o)if(a(c.charCodeAt(o))){if(!i){s=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){g(c,"path");let u=0,s=-1,t=0,i=-1,o=!0,r=0;c.length>=2&&c.charCodeAt(1)===T&&S(c.charCodeAt(0))&&(u=t=2);for(let l=c.length-1;l>=u;--l){const f=c.charCodeAt(l);if(a(f)){if(!o){t=l+1;break}continue}i===-1&&(o=!1,i=l+1),f===P?s===-1?s=l:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||i===-1||r===0||r===1&&s===i-1&&s===t+1?"":c.slice(s,i)},format:E.bind(null,"\\"),parse(c){g(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const s=c.length;let t=0,i=c.charCodeAt(0);if(s===1)return a(i)?(u.root=u.dir=c,u):(u.base=u.name=c,u);if(a(i)){if(t=1,a(c.charCodeAt(1))){let d=2,m=d;for(;d<s&&!a(c.charCodeAt(d));)d++;if(d<s&&d!==m){for(m=d;d<s&&a(c.charCodeAt(d));)d++;if(d<s&&d!==m){for(m=d;d<s&&!a(c.charCodeAt(d));)d++;d===s?t=d:d!==m&&(t=d+1)}}}}else if(S(i)&&c.charCodeAt(1)===T){if(s<=2)return u.root=u.dir=c,u;if(t=2,a(c.charCodeAt(2))){if(s===3)return u.root=u.dir=c,u;t=3}}t>0&&(u.root=c.slice(0,t));let o=-1,r=t,l=-1,f=!0,p=c.length-1,w=0;for(;p>=t;--p){if(i=c.charCodeAt(p),a(i)){if(!f){r=p+1;break}continue}l===-1&&(f=!1,l=p+1),i===P?o===-1?o=p:w!==1&&(w=1):o!==-1&&(w=-1)}return l!==-1&&(o===-1||w===0||w===1&&o===l-1&&o===r+1?u.base=u.name=c.slice(r,l):(u.name=c.slice(r,o),u.base=c.slice(r,l),u.ext=c.slice(o,l))),r>0&&r!==t?u.dir=c.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let u="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const i=t>=0?c[t]:b.cwd();g(i,"path"),i.length!==0&&(u=`${i}/${u}`,s=i.charCodeAt(0)===y)}return u=v(u,!s,"/",h),s?`/${u}`:u.length>0?u:"."},normalize(c){if(g(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===y,s=c.charCodeAt(c.length-1)===y;return c=v(c,!u,"/",h),c.length===0?u?"/":s?"./":".":(s&&(c+="/"),u?`/${c}`:c)},isAbsolute(c){return g(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let u;for(let s=0;s<c.length;++s){const t=c[s];g(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(c,u){if(g(c,"from"),g(u,"to"),c===u||(c=e.posix.resolve(c),u=e.posix.resolve(u),c===u))return"";const s=1,t=c.length,i=t-s,o=1,r=u.length-o,l=i<r?i:r;let f=-1,p=0;for(;p<l;p++){const d=c.charCodeAt(s+p);if(d!==u.charCodeAt(o+p))break;d===y&&(f=p)}if(p===l)if(r>l){if(u.charCodeAt(o+p)===y)return u.slice(o+p+1);if(p===0)return u.slice(o+p)}else i>l&&(c.charCodeAt(s+p)===y?f=p:p===0&&(f=0));let w="";for(p=s+f+1;p<=t;++p)(p===t||c.charCodeAt(p)===y)&&(w+=w.length===0?"..":"/..");return`${w}${u.slice(o+f)}`},toNamespacedPath(c){return c},dirname(c){if(g(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===y;let s=-1,t=!0;for(let i=c.length-1;i>=1;--i)if(c.charCodeAt(i)===y){if(!t){s=i;break}}else t=!1;return s===-1?u?"/":".":u&&s===1?"//":c.slice(0,s)},basename(c,u){u!==void 0&&g(u,"ext"),g(c,"path");let s=0,t=-1,i=!0,o;if(u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,l=-1;for(o=c.length-1;o>=0;--o){const f=c.charCodeAt(o);if(f===y){if(!i){s=o+1;break}}else l===-1&&(i=!1,l=o+1),r>=0&&(f===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===y){if(!i){s=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){g(c,"path");let u=-1,s=0,t=-1,i=!0,o=0;for(let r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===y){if(!i){s=r+1;break}continue}t===-1&&(i=!1,t=r+1),l===P?u===-1?u=r:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===s+1?"":c.slice(u,t)},format:E.bind(null,"/"),parse(c){g(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const s=c.charCodeAt(0)===y;let t;s?(u.root="/",t=1):t=0;let i=-1,o=0,r=-1,l=!0,f=c.length-1,p=0;for(;f>=t;--f){const w=c.charCodeAt(f);if(w===y){if(!l){o=f+1;break}continue}r===-1&&(l=!1,r=f+1),w===P?i===-1?i=f:p!==1&&(p=1):i!==-1&&(p=-1)}if(r!==-1){const w=o===0&&s?1:o;i===-1||p===0||p===1&&i===r-1&&i===o+1?u.base=u.name=c.slice(w,r):(u.name=c.slice(w,i),u.base=c.slice(w,r),u.ext=c.slice(i,r))}return o>0?u.dir=c.slice(0,o-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...D){const P=D.reduce((T,k)=>(T[k]=!0,T),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(T=>!P[T]).forEach(T=>{for(let k=0;k<y.length;k++)if(T.search(y[k])!==-1){delete I[T];break}})}e.sanitizeProcessEnvironment=R}),define(ge[46],pe([0,1,9]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=b.globals.performance&&typeof b.globals.performance.now=="function";class R{constructor(D){this._highResolution=A&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new R(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ge[3],pe([0,1,16,69,6,55,46]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>R.Disposable.None;function E(H){return(x,W=null,F)=>{let U=!1,M;return M=H(N=>{if(!U)return M?M.dispose():U=!0,x.call(W,N)},null,F),U&&M.dispose(),M}}v.once=E;function c(H,x){return r((W,F=null,U)=>H(M=>W.call(F,x(M)),null,U))}v.map=c;function u(H,x){return r((W,F=null,U)=>H(M=>{x(M),W.call(F,M)},null,U))}v.forEach=u;function s(H,x){return r((W,F=null,U)=>H(M=>x(M)&&W.call(F,M),null,U))}v.filter=s;function t(H){return H}v.signal=t;function i(...H){return(x,W=null,F)=>(0,R.combinedDisposable)(...H.map(U=>U(M=>x.call(W,M),null,F)))}v.any=i;function o(H,x,W){let F=W;return c(H,U=>(F=x(F,U),F))}v.reduce=o;function r(H){let x;const W=new _({onFirstListenerAdd(){x=H(W.fire,W)},onLastListenerRemove(){x.dispose()}});return W.event}v.snapshot=r;function l(H,x,W=100,F=!1,U){let M,N,O,V=0;const q=new _({leakWarningThreshold:U,onFirstListenerAdd(){M=H(X=>{V++,N=x(N,X),F&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const fe=N;N=void 0,O=void 0,(!F||V>1)&&q.fire(fe),V=0},W)})},onLastListenerRemove(){M.dispose()}});return q.event}v.debounce=l;function f(H){const x=new Date().getTime();return c(E(H),W=>new Date().getTime()-x)}v.stopwatch=f;function p(H){let x=!0,W;return s(H,F=>{const U=x||F!==W;return x=!1,W=F,U})}v.latch=p;function w(H,x=!1,W=[]){let F=W.slice(),U=H(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new _({onFirstListenerAdd(){U||(U=H(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}v.buffer=w;class d{constructor(x){this.event=x}map(x){return new d(c(this.event,x))}forEach(x){return new d(u(this.event,x))}filter(x){return new d(s(this.event,x))}reduce(x,W){return new d(o(this.event,x,W))}latch(){return new d(p(this.event))}debounce(x,W=100,F=!1,U){return new d(l(this.event,x,W,F,U))}on(x,W,F){return this.event(x,W,F)}once(x,W,F){return E(this.event)(x,W,F)}}function m(H){return new d(H)}v.chain=m;function C(H,x,W=F=>F){const F=(...O)=>N.fire(W(...O)),U=()=>H.on(x,F),M=()=>H.removeListener(x,F),N=new _({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromNodeEventEmitter=C;function L(H,x,W=F=>F){const F=(...O)=>N.fire(W(...O)),U=()=>H.addEventListener(x,F),M=()=>H.removeEventListener(x,F),N=new _({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromDOMEventEmitter=L;function B(H){const x=new _;let W=!1;return H.then(void 0,()=>null).then(()=>{W?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),W=!0,x.event}v.fromPromise=B;function ee(H){return new Promise(x=>E(H)(x))}v.toPromise=ee})(P=e.Event||(e.Event={}));class y{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${y._idPool++}`}start(E){this._stopWatch=new D.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(v){const E=n;return n=v,{dispose(){n=E}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(E,c=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let c=n;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||E<c)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(u)||0;if(this._stacks.set(u,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,i=0;for(const[o,r]of this._stacks)(!t||i<r)&&(t=o,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class _{constructor(E){var c;this._disposed=!1,this._options=E,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(E,c,u)=>{var s;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[E,c]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,c);const o=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=_._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof R.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(E){var c,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,E]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,b.onUnexpectedError)(i)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var E,c,u;(E=this._listeners)===null||E===void 0||E.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=_,_._noop=function(){};class g extends _{constructor(E){super(E);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new _({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const c={event:E,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const u=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,R.toDisposable)((0,A.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(c=>this.emitter.fire(c))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class h{constructor(){this.buffers=[]}wrapEvent(E){return(c,u,s)=>E(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>c.call(u,t)):c.call(u,t)},void 0,s)}bufferEvents(E){const c=[];this.buffers.push(c);const u=E();return this.buffers.pop(),c.forEach(s=>s()),u}}e.EventBufferer=h;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new _({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],pe([0,1,3]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,y){const n=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(n)}}});var R;(function(P){function y(n){return n===P.None||n===P.Cancelled||n instanceof I?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(R=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=R.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=D}),define(ge[47],pe([0,1,3]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new A;e.iconRegistry=R;function I(n,T){return new D(n,T)}e.registerCodicon=I;class D{constructor(T,k,_){this.id=T,this.definition=k,this.description=_,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function P(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=P;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(a){if(a instanceof D)return["codicon","codicon-"+a.id];const h=T.exec(a.id);if(!h)return k(D.error);let[,S,v]=h;const E=["codicon","codicon-"+S];return v&&E.push("codicon-modifier-"+v.substr(1)),E}n.asClassNameArray=k;function _(a){return k(a).join(" ")}n.asClassName=_;function g(a){return"."+k(a).join(".")}n.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,16,6]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(S){const v=S;return v&&[v.on,v.pause,v.resume,v.destroy].every(E=>typeof E=="function")}e.isReadableStream=R;function I(S){const v=S;return v&&R(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=I;function D(S,v){return new P(S,v)}e.newWriteableStream=D;class P{constructor(v,E){this.reducer=v,this.options=E,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var E;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((E=this.options)===null||E===void 0?void 0:E.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(E=>E(v))}emitError(v){this.listeners.error.length===0?(0,b.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(E=>E(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,E){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(E),this.resume();break;case"end":this.listeners.end.push(E),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(E),this.state.flowing&&this.flowErrors();break}}removeListener(v,E){if(!this.state.destroyed){let c;switch(v){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const u=c.indexOf(E);u>=0&&c.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const E=[...this.pendingWritePromises];this.pendingWritePromises.length=0,E.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,v){const E=[];let c;for(;(c=S.read())!==null;)E.push(c);return v(E)}e.consumeReadable=y;function n(S,v,E){const c=[];let u;for(;(u=S.read())!==null&&c.length<E;)c.push(u);return u===null&&c.length>0?v(c):{read:()=>{if(c.length>0)return c.shift();if(typeof u!="undefined"){const s=u;return u=void 0,s}return S.read()}}}e.peekReadable=n;function T(S,v){return new Promise((E,c)=>{const u=[];k(S,{onData:s=>{v&&u.push(s)},onError:s=>{v?c(s):E(void 0)},onEnd:()=>{E(v?v(u):void 0)}})})}e.consumeStream=T;function k(S,v){S.on("error",E=>v.onError(E)),S.on("end",()=>v.onEnd()),S.on("data",E=>v.onData(E))}e.listenStream=k;function _(S,v){return new Promise((E,c)=>{const u=new A.DisposableStore,s=[],t=r=>{if(s.push(r),s.length>v)return u.dispose(),S.pause(),E({stream:S,buffer:s,ended:!1})},i=r=>c(r),o=()=>E({stream:S,buffer:s,ended:!0});u.add((0,A.toDisposable)(()=>S.removeListener("error",i))),S.on("error",i),u.add((0,A.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),u.add((0,A.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=_;function g(S,v){const E=D(v);return E.end(S),E}e.toStream=g;function a(S){let v=!1;return{read:()=>v?null:(v=!0,S)}}e.toReadable=a;function h(S,v,E){const c=D(E);return k(S,{onData:u=>c.write(v.data(u)),onError:u=>c.error(v.error?v.error(u):u),onEnd:()=>c.end()}),c}e.transform=h}),define(ge[10],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=b;const A=/{(\d+)}/g;function R(K,...se){return se.length===0?K:K.replace(A,function(de,Y){const ne=parseInt(Y,10);return isNaN(ne)||ne<0||ne>=se.length?de:se[ne]})}e.format=R;function I(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=I;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function P(K,se){let de=0;const Y=se.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Y&&de++;return de}e.count=P;function y(K,se,de="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${de}`}e.truncate=y;function n(K,se=" "){const de=T(K,se);return k(de,se)}e.trim=n;function T(K,se){if(!K||!se)return K;const de=se.length;if(de===0||K.length===0)return K;let Y=0;for(;K.indexOf(se,Y)===Y;)Y=Y+de;return K.substring(Y)}e.ltrim=T;function k(K,se){if(!K||!se)return K;const de=se.length,Y=K.length;if(de===0||Y===0)return K;let ne=Y,le=-1;for(;le=K.lastIndexOf(se,ne-1),!(le===-1||le+de!==ne);){if(le===0)return"";ne=le}return K.substring(0,ne)}e.rtrim=k;function _(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=_;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function a(K,se,de={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=D(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Y="";return de.global&&(Y+="g"),de.matchCase||(Y+="i"),de.multiline&&(Y+="m"),de.unicode&&(Y+="u"),new RegExp(K,Y)}e.createRegExp=a;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function E(K){return K.split(/\r\n|\r|\n/)}e.splitLines=E;function c(K){for(let se=0,de=K.length;se<de;se++){const Y=K.charCodeAt(se);if(Y!==32&&Y!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function u(K,se=0,de=K.length){for(let Y=se;Y<de;Y++){const ne=K.charCodeAt(Y);if(ne!==32&&ne!==9)return K.substring(se,Y)}return K.substring(se,de)}e.getLeadingWhitespace=u;function s(K,se=K.length-1){for(let de=se;de>=0;de--){const Y=K.charCodeAt(de);if(Y!==32&&Y!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function i(K,se,de=0,Y=K.length,ne=0,le=se.length){for(;de<Y&&ne<le;de++,ne++){let He=K.charCodeAt(de),$e=se.charCodeAt(ne);if(He<$e)return-1;if(He>$e)return 1}const me=Y-de,_e=le-ne;return me<_e?-1:me>_e?1:0}e.compareSubstring=i;function o(K,se){return r(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function r(K,se,de=0,Y=K.length,ne=0,le=se.length){for(;de<Y&&ne<le;de++,ne++){let He=K.charCodeAt(de),$e=se.charCodeAt(ne);if(He!==$e){const Ke=He-$e;if(!(Ke===32&&f($e))&&!(Ke===-32&&f(He)))return l(He)&&l($e)?Ke:i(K.toLowerCase(),se.toLowerCase(),de,Y,ne,le)}}const me=Y-de,_e=le-ne;return me<_e?-1:me>_e?1:0}e.compareSubstringIgnoreCase=r;function l(K){return K>=97&&K<=122}e.isLowerAsciiLetter=l;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function p(K){return l(K)||f(K)}function w(K,se){return K.length===se.length&&d(K,se)}e.equalsIgnoreCase=w;function d(K,se,de=K.length){for(let Y=0;Y<de;Y++){const ne=K.charCodeAt(Y),le=se.charCodeAt(Y);if(ne!==le){if(p(ne)&&p(le)){const me=Math.abs(ne-le);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function m(K,se){const de=se.length;return se.length>K.length?!1:d(K,se,de)}e.startsWithIgnoreCase=m;function C(K,se){let de,Y=Math.min(K.length,se.length);for(de=0;de<Y;de++)if(K.charCodeAt(de)!==se.charCodeAt(de))return de;return Y}e.commonPrefixLength=C;function L(K,se){let de,Y=Math.min(K.length,se.length);const ne=K.length-1,le=se.length-1;for(de=0;de<Y;de++)if(K.charCodeAt(ne-de)!==se.charCodeAt(le-de))return de;return Y}e.commonSuffixLength=L;function B(K){return 55296<=K&&K<=56319}e.isHighSurrogate=B;function ee(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ee;function H(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=H;function x(K,se,de){const Y=K.charCodeAt(de);if(B(Y)&&de+1<se){const ne=K.charCodeAt(de+1);if(ee(ne))return H(Y,ne)}return Y}e.getNextCodePoint=x;function W(K,se){const de=K.charCodeAt(se-1);if(ee(de)&&se>1){const Y=K.charCodeAt(se-2);if(B(Y))return H(Y,de)}return de}function F(K,se){const de=We.getInstance(),Y=se,ne=K.length,le=x(K,ne,se);se+=le>=65536?2:1;let me=de.getGraphemeBreakType(le);for(;se<ne;){const _e=x(K,ne,se),He=de.getGraphemeBreakType(_e);if(Oe(me,He))break;se+=_e>=65536?2:1,me=He}return se-Y}e.nextCharLength=F;function U(K,se){const de=We.getInstance(),Y=se,ne=W(K,se);se-=ne>=65536?2:1;let le=de.getGraphemeBreakType(ne);for(;se>0;){const me=W(K,se),_e=de.getGraphemeBreakType(me);if(Oe(_e,le))break;se-=me>=65536?2:1,le=_e}return Y-se}e.prevCharLength=U;function M(K,se){const de=We.getInstance(),Y=K.length,ne=se,le=x(K,Y,se),me=de.getGraphemeBreakType(le);se+=le>=65536?2:1;let _e=me;for(;se<Y;){const $e=x(K,Y,se),Ke=de.getGraphemeBreakType($e);if(Oe(_e,Ke))break;se+=$e>=65536?2:1,_e=Ke}const He=se;for(se=ne,_e=me;se>0;){const $e=W(K,se),Ke=de.getGraphemeBreakType($e);if(Oe(Ke,_e))break;se-=$e>=65536?2:1,_e=Ke}return[se,He]}function N(K,se){return se>0&&ee(K.charCodeAt(se))?M(K,se-1):M(K,se)}e.getCharContainingOffset=N;function O(K){const se=K.length;let de=0,Y=0;for(;Y<se;){const me=x(K,se,Y);Y+=me>=65536?2:1,me<128?de+=1:me<2048?de+=2:me<65536?de+=3:de+=4}const ne=new Uint8Array(de);Y=0;let le=0;for(;Y<se;){const me=x(K,se,Y);Y+=me>=65536?2:1,me<128?ne[le++]=me:me<2048?(ne[le++]=192|(me&1984)>>>6,ne[le++]=128|(me&63)>>>0):me<65536?(ne[le++]=224|(me&61440)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0):(ne[le++]=240|(me&1835008)>>>18,ne[le++]=128|(me&258048)>>>12,ne[le++]=128|(me&4032)>>>6,ne[le++]=128|(me&63)>>>0)}return ne}e.encodeUTF8=O;function V(K){const se=K.byteLength,de=[];let Y=0;for(;Y<se;){const ne=K[Y];let le;if(ne>=240&&Y+3<se?le=(K[Y++]&7)<<18>>>0|(K[Y++]&63)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ne>=224&&Y+2<se?le=(K[Y++]&15)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ne>=192&&Y+1<se?le=(K[Y++]&31)<<6>>>0|(K[Y++]&63)<<0>>>0:le=K[Y++],le>=0&&le<=55295||le>=57344&&le<=65535)de.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const me=le-65536,_e=55296+((me&1047552)>>>10),He=56320+((me&1023)>>>0);de.push(String.fromCharCode(_e)),de.push(String.fromCharCode(He))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(K){return q.test(K)}e.containsRTL=X;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(K){return fe.test(K)}e.containsEmoji=ve;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ie(K){return Ae.test(K)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Fe;function z(K){for(let se=0,de=K.length;se<de;se++)if(J(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=z;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function ae(K,se){if(K.length<se)return K;const de=/\b/g;let Y=0;for(;de.test(K)&&!(K.length-de.lastIndex<se);)Y=de.lastIndex,de.lastIndex+=1;return K.substring(Y).replace(/^\s/,"")}e.lcut=ae;const he=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(he,""),K=K.replace(De,""),K=K.replace(Me,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Te;function xe(K,se){if(!K||!se||K.length<se.length)return!1;const de=se.length,Y=K.toLowerCase();let ne=0,le=-1;for(;ne<de;){const me=Y.indexOf(se[ne],le+1);if(me<0)return!1;le=me,ne++}return!0}e.fuzzyContains=xe;function Se(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function Ge(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ge;function Q(K,se=1){if(se===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),se--;while(se>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=Q;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function be(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=be;function Oe(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=Oe;var Ve;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=tt()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const de=this._data,Y=de.length/3;let ne=1;for(;ne<=Y;)if(se<de[3*ne])ne=2*ne;else if(se>de[3*ne+1])ne=2*ne+1;else return de[3*ne+2];return 0}}We._INSTANCE=null;function tt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[25],pe([0,1,10,91]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let P,y;class n{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return R?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&R?new n(Buffer.from(l)):I?(P||(P=new TextEncoder),new n(P.encode(l))):new n(b.encodeUTF8(l))}static concat(l,f){if(typeof f=="undefined"){f=0;for(let d=0,m=l.length;d<m;d++)f+=l[d].byteLength}const p=n.alloc(f);let w=0;for(let d=0,m=l.length;d<m;d++){const C=l[d];p.set(C,w),w+=C.byteLength}return p}toString(){return R?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(l,f){return new n(this.buffer.subarray(l,f))}set(l,f){l instanceof n?this.buffer.set(l.buffer,f):this.buffer.set(l,f)}readUInt32BE(l){return _(this.buffer,l)}writeUInt32BE(l,f){g(this.buffer,l,f)}readUInt32LE(l){return a(this.buffer,l)}writeUInt32LE(l,f){h(this.buffer,l,f)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,f){v(this.buffer,l,f)}}e.VSBuffer=n;function T(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=T;function k(r,l,f){r[f+0]=l&255,l=l>>>8,r[f+1]=l&255}e.writeUInt16LE=k;function _(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=_;function g(r,l,f){r[f+3]=l,l=l>>>8,r[f+2]=l,l=l>>>8,r[f+1]=l,l=l>>>8,r[f]=l}e.writeUInt32BE=g;function a(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=a;function h(r,l,f){r[f+0]=l&255,l=l>>>8,r[f+1]=l&255,l=l>>>8,r[f+2]=l&255,l=l>>>8,r[f+3]=l&255}e.writeUInt32LE=h;function S(r,l){return r[l]}e.readUInt8=S;function v(r,l,f){r[f]=l}e.writeUInt8=v;function E(r){return A.consumeReadable(r,l=>n.concat(l))}e.readableToBuffer=E;function c(r){return A.toReadable(r)}e.bufferToReadable=c;function u(r){return A.consumeStream(r,l=>n.concat(l))}e.streamToBuffer=u;async function s(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=s;function t(r){return A.toStream(r,l=>n.concat(l))}e.bufferToStream=t;function i(r){return A.transform(r,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=i;function o(r){return A.newWriteableStream(l=>n.concat(l),r)}e.newWriteableBufferStream=o}),define(ge[73],pe([0,1,10]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(v){return R(v,0)}e.hash=A;function R(v,E){switch(typeof v){case"object":return v===null?I(349,E):Array.isArray(v)?y(v,E):n(v,E);case"string":return P(v,E);case"boolean":return D(v,E);case"number":return I(v,E);case"undefined":return I(937,E);default:return I(617,E)}}e.doHash=R;function I(v,E){return(E<<5)-E+v|0}function D(v,E){return I(v?433:863,E)}function P(v,E){E=I(149417,E);for(let c=0,u=v.length;c<u;c++)E=I(v.charCodeAt(c),E);return E}e.stringHash=P;function y(v,E){return E=I(104579,E),v.reduce((c,u)=>R(u,c),E)}function n(v,E){return E=I(181387,E),Object.keys(v).sort().reduce((c,u)=>(c=P(u,c),R(v[u],c)),E)}class T{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=R(E,this._value),this._value}}e.Hasher=T;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function _(v,E,c=32){const u=c-E,s=~((1<<u)-1);return(v<<E|(s&v)>>>u)>>>0}function g(v,E=0,c=v.byteLength,u=0){for(let s=0;s<c;s++)v[E+s]=u}function a(v,E,c="0"){for(;v.length<E;)v=c+v;return v}function h(v,E=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):a((v>>>0).toString(16),E/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const c=E.length;if(c!==0){const u=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=E.charCodeAt(0),o=0);;){let r=i;if(b.isHighSurrogate(i))if(o+1<c){const l=E.charCodeAt(o+1);b.isLowSurrogate(l)?(o++,r=b.computeCodePoint(i,l)):r=65533}else{t=i;break}else b.isLowSurrogate(i)&&(r=65533);if(s=this._push(u,s,r),o++,o<c)i=E.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(E,c,u){return u<128?E[c++]=u:u<2048?(E[c++]=192|(u&1984)>>>6,E[c++]=128|(u&63)>>>0):u<65536?(E[c++]=224|(u&61440)>>>12,E[c++]=128|(u&4032)>>>6,E[c++]=128|(u&63)>>>0):(E[c++]=240|(u&1835008)>>>18,E[c++]=128|(u&258048)>>>12,E[c++]=128|(u&4032)>>>6,E[c++]=128|(u&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,c=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,c.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,_(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let u=this._h0,s=this._h1,t=this._h2,i=this._h3,o=this._h4,r,l,f;for(let p=0;p<80;p++)p<20?(r=s&t|~s&i,l=1518500249):p<40?(r=s^t^i,l=1859775393):p<60?(r=s&t|s&i|t&i,l=2400959708):(r=s^t^i,l=3395469782),f=_(u,5)+r+o+l+E.getUint32(p*4,!1)&4294967295,o=i,i=t,t=_(s,30),s=u,u=f;this._h0=this._h0+u&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[56],pe([0,1,10]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(A||(A={})),function(R){const I="error",D="warning",P="warn",y="info";function n(T){return T?b.equalsIgnoreCase(I,T)?R.Error:b.equalsIgnoreCase(D,T)||b.equalsIgnoreCase(P,T)?R.Warning:b.equalsIgnoreCase(y,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=n}(A||(A={})),e.default=A}),define(ge[15],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(f){return Array.isArray(f)}e.isArray=b;function A(f){return typeof f=="string"}e.isString=A;function R(f){return Array.isArray(f)&&f.every(p=>A(p))}e.isStringArray=R;function I(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=I;function D(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=D;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=P;function y(f){return f===!0||f===!1}e.isBoolean=y;function n(f){return typeof f=="undefined"}e.isUndefined=n;function T(f){return!k(f)}e.isDefined=T;function k(f){return n(f)||f===null}e.isUndefinedOrNull=k;function _(f,p){if(!f)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=_;function g(f){if(k(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=g;function a(...f){const p=[];for(let w=0;w<f.length;w++){const d=f[w];if(k(d))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);p.push(d)}return p}e.assertAllDefined=a;const h=Object.prototype.hasOwnProperty;function S(f){if(!I(f))return!1;for(let p in f)if(h.call(f,p))return!1;return!0}e.isEmptyObject=S;function v(f){return typeof f=="function"}e.isFunction=v;function E(...f){return f.length>0&&f.every(v)}e.areFunctions=E;function c(f,p){const w=Math.min(f.length,p.length);for(let d=0;d<w;d++)u(f[d],p[d])}e.validateConstraints=c;function u(f,p){if(A(p)){if(typeof f!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(v(p)){try{if(f instanceof p)return}catch(w){}if(!k(f)&&f.constructor===p||p.length===1&&p.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function s(f){let p=[],w=Object.getPrototypeOf(f);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=s;function t(f){const p=[];for(const w of s(f))typeof f[w]=="function"&&p.push(w);return p}e.getAllMethodNames=t;function i(f,p){const w=m=>function(){const C=Array.prototype.slice.call(arguments,0);return p(m,C)};let d={};for(const m of f)d[m]=w(m);return d}e.createProxyObject=i;function o(f){return f===null?void 0:f}e.withNullAsUndefined=o;function r(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=r;function l(f){return class{constructor(){return new Proxy({},{get(p,w){if(p[w])return p[w];throw new Error(`Not Implemented: ${f}->${String(w)}`)}})}}}e.NotImplementedProxy=l}),define(ge[31],pe([0,1,9,10,8,15]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function P(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function y(i,o=R.posix.sep){if(!i)return"";const r=i.length,l=i.charCodeAt(0);if(D(l)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let p=3;const w=p;for(;p<r&&!D(i.charCodeAt(p));p++);if(w!==p&&!D(i.charCodeAt(p+1))){for(p+=1;p<r;p++)if(D(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,o)}}return o}else if(S(l)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<r;f++)if(D(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=y;function n(i){if(!b.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let r=2;const l=r;for(;r<i.length&&(o=i.charCodeAt(r),o!==92);r++);return!(l===r||(o=i.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(i,o=b.isWindows){const r=o?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||o&&_.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=g;function a(i,o,r){const l=i===o;return!r||l?l:!i||!o?!1:(0,A.equalsIgnoreCase)(i,o)}e.isEqual=a;function h(i,o,r,l=R.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(r){if(!(0,A.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let p=o.length;return o.charAt(o.length-1)===l&&p--,i.charAt(p)===l}return o.charAt(o.length-1)!==l&&(o+=l),i.indexOf(o)===0}e.isEqualOrParent=h;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function v(i,o){return b.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(o,i)),i=(0,R.normalize)(i),b.isWindows?(i=(0,A.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,A.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=v;function E(i){const o=(0,R.normalize)(i);return b.isWindows?i.length>3?!1:c(o)&&(i.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=E;function c(i){return b.isWindows?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(i){return c(i)?i[0]:void 0}e.getDriveLetter=u;function s(i,o,r){return o.length>i.length?-1:i===o?0:(r&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=s;function t(i){const o=i.split(":");let r,l,f;if(o.forEach(p=>{const w=Number(p);(0,I.isNumber)(w)?l===void 0?l=w:f===void 0&&(f=w):r=r?[r,p].join(":"):p}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[22],pe([0,1,15]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const h=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?h[S]=A(a[S]):h[S]=a[S]}),h}e.deepClone=A;function R(a){if(!a||typeof a!="object")return a;const h=[a];for(;h.length>0;){const S=h.shift();Object.freeze(S);for(const v in S)if(I.call(S,v)){const E=S[v];typeof E=="object"&&!Object.isFrozen(E)&&h.push(E)}}return a}e.deepFreeze=R;const I=Object.prototype.hasOwnProperty;function D(a,h){return P(a,h,new Set)}e.cloneAndChange=D;function P(a,h,S){if((0,b.isUndefinedOrNull)(a))return a;const v=h(a);if(typeof v!="undefined")return v;if((0,b.isArray)(a)){const E=[];for(const c of a)E.push(P(c,h,S));return E}if((0,b.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const E={};for(let c in a)I.call(a,c)&&(E[c]=P(a[c],h,S));return S.delete(a),E}return a}function y(a,h,S=!0){return(0,b.isObject)(a)?((0,b.isObject)(h)&&Object.keys(h).forEach(v=>{v in a?S&&((0,b.isObject)(a[v])&&(0,b.isObject)(h[v])?y(a[v],h[v],S):a[v]=h[v]):a[v]=h[v]}),a):h}e.mixin=y;function n(a,h){if(a===h)return!0;if(a==null||h===null||h===void 0||typeof a!=typeof h||typeof a!="object"||Array.isArray(a)!==Array.isArray(h))return!1;let S,v;if(Array.isArray(a)){if(a.length!==h.length)return!1;for(S=0;S<a.length;S++)if(!n(a[S],h[S]))return!1}else{const E=[];for(v in a)E.push(v);E.sort();const c=[];for(v in h)c.push(v);if(c.sort(),!n(E,c))return!1;for(S=0;S<E.length;S++)if(!n(a[E[S]],h[E[S]]))return!1}return!0}e.equals=n;function T(a){const h=new Set;return JSON.stringify(a,(S,v)=>{if((0,b.isObject)(v)||Array.isArray(v)){if(h.has(v))return"[Circular]";h.add(v)}return v})}e.safeStringify=T;function k(a,h,S){const v=h(a);return typeof v=="undefined"?S:v}e.getOrDefault=k;function _(a,h){const S=Object.create(null);return!a||!h||Object.keys(h).forEach(E=>{const c=a[E],u=h[E];n(c,u)||(S[E]=u)}),S}e.distinct=_;function g(a,h){const S=h.toLowerCase(),v=Object.keys(a).find(E=>E.toLowerCase()===S);return v?a[v]:a[h]}e.getCaseInsensitive=g}),define(ge[92],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function A(I){return I<0?0:I>255?255:I|0}e.toUint8=A;function R(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=R}),define(ge[2],pe([0,1,9,8]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function P(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!R.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!I.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,r){return!o&&!r?"file":o}function n(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const T="",k="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,l,f,p,w,d=!1){typeof r=="object"?(this.scheme=r.scheme||T,this.authority=r.authority||T,this.path=r.path||T,this.query=r.query||T,this.fragment=r.fragment||T):(this.scheme=y(r,d),this.authority=l||T,this.path=n(this.scheme,f||T),this.query=p||T,this.fragment=w||T,P(this,d))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:f,path:p,query:w,fragment:d}=r;return l===void 0?l=this.scheme:l===null&&(l=T),f===void 0?f=this.authority:f===null&&(f=T),p===void 0?p=this.path:p===null&&(p=T),w===void 0?w=this.query:w===null&&(w=T),d===void 0?d=this.fragment:d===null&&(d=T),l===this.scheme&&f===this.authority&&p===this.path&&w===this.query&&d===this.fragment?this:new h(l,f,p,w,d)}static parse(r,l=!1){const f=_.exec(r);return f?new h(f[2]||T,i(f[4]||T),i(f[5]||T),i(f[7]||T),i(f[9]||T),l):new h(T,T,T,T,T)}static file(r){let l=T;if(b.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const f=r.indexOf(k,2);f===-1?(l=r.substring(2),r=k):(l=r.substring(2,f),r=r.substring(f)||k)}return new h("file",l,r,T,T)}static from(r){return new h(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return b.isWindows&&r.scheme==="file"?f=g.file(A.win32.join(c(r,!0),...l)).path:f=A.posix.join(r.path,...l),r.with({path:f})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const l=new h(r);return l._formatted=r.external,l._fsPath=r._sep===a?r.fsPath:null,l}}else return r}}e.URI=g;const a=b.isWindows?1:void 0;class h extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,r){let l,f=-1;for(let p=0;p<o.length;p++){const w=o.charCodeAt(p);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||r&&w===47)f!==-1&&(l+=encodeURIComponent(o.substring(f,p)),f=-1),l!==void 0&&(l+=o.charAt(p));else{l===void 0&&(l=o.substr(0,p));const d=S[w];d!==void 0?(f!==-1&&(l+=encodeURIComponent(o.substring(f,p)),f=-1),l+=d):f===-1&&(f=p)}}return f!==-1&&(l+=encodeURIComponent(o.substring(f))),l!==void 0?l:o}function E(o){let r;for(let l=0;l<o.length;l++){const f=o.charCodeAt(l);f===35||f===63?(r===void 0&&(r=o.substr(0,l)),r+=S[f]):r!==void 0&&(r+=o[l])}return r!==void 0?r:o}function c(o,r){let l;return o.authority&&o.path.length>1&&o.scheme==="file"?l=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?l=o.path.substr(1):l=o.path[1].toLowerCase()+o.path.substr(2):l=o.path,b.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function u(o,r){const l=r?E:v;let f="",{scheme:p,authority:w,path:d,query:m,fragment:C}=o;if(p&&(f+=p,f+=":"),(w||p==="file")&&(f+=k,f+=k),w){let L=w.indexOf("@");if(L!==-1){const B=w.substr(0,L);w=w.substr(L+1),L=B.indexOf(":"),L===-1?f+=l(B,!1):(f+=l(B.substr(0,L),!1),f+=":",f+=l(B.substr(L+1),!1)),f+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?f+=l(w,!1):(f+=l(w.substr(0,L),!1),f+=w.substr(L))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const L=d.charCodeAt(1);L>=65&&L<=90&&(d=`/${String.fromCharCode(L+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const L=d.charCodeAt(0);L>=65&&L<=90&&(d=`${String.fromCharCode(L+32)}:${d.substr(2)}`)}f+=l(d,!0)}return m&&(f+="?",f+=l(m,!1)),C&&(f+="#",f+=r?C:v(C,!1)),f}function s(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,r=>s(r)):o}}),define(ge[23],pe([0,1,2,10]),function(Z,e,b,A){"use strict";var R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(u,s,t){let i=u.get(s);return i===void 0&&(i=t,u.set(s,i)),i}e.getOrSet=D;function P(u){const s=[];return u.forEach((t,i)=>{s.push(`${i} => ${t}`)}),`Map(${u.size}) {${s.join(", ")}}`}e.mapToString=P;function y(u){const s=[];return u.forEach(t=>{s.push(t)}),`Set(${u.size}) {${s.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,A.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,A.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var _;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(_||(_={}));class g{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,A.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class h{constructor(s){this._iter=s}static forUris(s=()=>!1){return new h(new g(s))}static forPaths(){return new h(new k)}static forStrings(){return new h(new n)}static forConfigKeys(){return new h(new T)}clear(){this._root=void 0}set(s,t){const i=this._iter.reset(s);let o;for(this._root||(this._root=new a,this._root.segment=i.value()),o=this._root;;){const l=i.cmp(o.segment);if(l>0)o.left||(o.left=new a,o.left.segment=i.value()),o=o.left;else if(l<0)o.right||(o.right=new a,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new a,o.mid.segment=i.value()),o=o.mid;else break}const r=o.value;return o.value=t,o.key=s,r}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const i=this._iter.reset(s),o=[];let r=this._root;for(;r;){const l=i.cmp(r.segment);if(l>0)o.push([1,r]),r=r.left;else if(l<0)o.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),o.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;o.length>0&&r.isEmpty();){let[f,p]=o.pop();switch(f){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}r=p}break}}}findSubstr(s){const t=this._iter.reset(s);let i=this._root,o;for(;i;){const r=t.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(t.hasNext())t.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(s){for(const[t,i]of this)s(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=h;class S{constructor(s,t){this[R]="ResourceMap",s instanceof S?(this.map=new Map(s.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:S.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[i,o]of this.map)s(o,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield b.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[b.URI.parse(s[0]),s[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[b.URI.parse(s[0]),s[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const i=this._map.get(s);if(!!i)return t!==0&&this.touch(i,t),i.value}set(s,t,i=0){let o=this._map.get(s);if(o)o.value=t,i!==0&&this.touch(o,i);else{switch(o={key:s,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(s,o),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const i=this._state;let o=this._head;for(;o;){if(t?s.bind(t)(o.value,o.key,this):s(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}values(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}entries(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>s;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,i=s.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const i=s.next,o=s.previous;s===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const i=s.next,o=s.previous;s===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,i)=>{s.push([i,t])}),s}fromJSON(s){this.clear();for(const[t,i]of s)this.set(t,i)}}e.LinkedMap=E;class c extends E{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(ge[93],pe([0,1,23,10]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...we){return function(ke,Te){for(let xe=0,Se=we.length;xe<Se;xe++){const Ge=we[xe](ke,Te);if(Ge)return Ge}return null}}e.or=R,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(we,ke,Te){if(!Te||Te.length<ke.length)return null;let xe;return we?xe=A.startsWithIgnoreCase(Te,ke):xe=Te.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(we,ke){const Te=ke.toLowerCase().indexOf(we.toLowerCase());return Te===-1?null:[{start:Te,end:Te+we.length}]}e.matchesContiguousSubString=D;function P(we,ke){return y(we.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=P;function y(we,ke,Te,xe){if(Te===we.length)return[];if(xe===ke.length)return null;if(we[Te]===ke[xe]){let Se=null;return(Se=y(we,ke,Te+1,xe+1))?v({start:xe,end:xe+1},Se):null}return y(we,ke,Te,xe+1)}function n(we){return 97<=we&&we<=122}function T(we){return 65<=we&&we<=90}e.isUpper=T;function k(we){return 48<=we&&we<=57}function _(we){return we===32||we===9||we===10||we===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>g.add(we.charCodeAt(0)));function a(we){return _(we)||g.has(we)}function h(we,ke){return we===ke||a(we)&&a(ke)}function S(we){return n(we)||T(we)||k(we)}function v(we,ke){return ke.length===0?ke=[we]:we.end===ke[0].start?ke[0].start=we.start:ke.unshift(we),ke}function E(we,ke){for(let Te=ke;Te<we.length;Te++){const xe=we.charCodeAt(Te);if(T(xe)||k(xe)||Te>0&&!S(we.charCodeAt(Te-1)))return Te}return we.length}function c(we,ke,Te,xe){if(Te===we.length)return[];if(xe===ke.length)return null;if(we[Te]!==ke[xe].toLowerCase())return null;{let Se=null,Ge=xe+1;for(Se=c(we,ke,Te+1,xe+1);!Se&&(Ge=E(ke,Ge))<ke.length;)Se=c(we,ke,Te+1,Ge),Ge++;return Se===null?null:v({start:xe,end:xe+1},Se)}}function u(we){let ke=0,Te=0,xe=0,Se=0,Ge=0;for(let Ve=0;Ve<we.length;Ve++)Ge=we.charCodeAt(Ve),T(Ge)&&ke++,n(Ge)&&Te++,S(Ge)&&xe++,k(Ge)&&Se++;const Q=ke/we.length,ie=Te/we.length,be=xe/we.length,Oe=Se/we.length;return{upperPercent:Q,lowerPercent:ie,alphaPercent:be,numericPercent:Oe}}function s(we){const{upperPercent:ke,lowerPercent:Te}=we;return Te===0&&ke>.6}function t(we){const{upperPercent:ke,lowerPercent:Te,alphaPercent:xe,numericPercent:Se}=we;return Te>.2&&ke<.8&&xe>.6&&Se<.2}function i(we){let ke=0,Te=0,xe=0,Se=0;for(let Ge=0;Ge<we.length;Ge++)xe=we.charCodeAt(Ge),T(xe)&&ke++,n(xe)&&Te++,_(xe)&&Se++;return(ke===0||Te===0)&&Se===0?we.length<=30:ke<=5}function o(we,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(we)||ke.length>60)return null;const Te=u(ke);if(!t(Te)){if(!s(Te))return null;ke=ke.toLowerCase()}let xe=null,Se=0;for(we=we.toLowerCase();Se<ke.length&&(xe=c(we,ke,0,Se))===null;)Se=E(ke,Se+1);return xe}e.matchesCamelCase=o;function r(we,ke,Te=!1){if(!ke||ke.length===0)return null;let xe=null,Se=0;for(we=we.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(xe=l(we,ke,0,Se,Te))===null;)Se=f(ke,Se+1);return xe}e.matchesWords=r;function l(we,ke,Te,xe,Se){if(Te===we.length)return[];if(xe===ke.length)return null;if(h(we.charCodeAt(Te),ke.charCodeAt(xe))){let Ge=null,Q=xe+1;if(Ge=l(we,ke,Te+1,xe+1,Se),!Se)for(;!Ge&&(Q=f(ke,Q))<ke.length;)Ge=l(we,ke,Te+1,Q,Se),Q++;return Ge===null?null:v({start:xe,end:xe+1},Ge)}else return null}function f(we,ke){for(let Te=ke;Te<we.length;Te++)if(a(we.charCodeAt(Te))||Te>0&&a(we.charCodeAt(Te-1)))return Te;return we.length}const p=R(e.matchesPrefix,o,D),w=R(e.matchesPrefix,o,P),d=new b.LRUCache(1e4);function m(we,ke,Te=!1){if(typeof we!="string"||typeof ke!="string")return null;let xe=d.get(we);xe||(xe=new RegExp(A.convertSimple2RegExpPattern(we),"i"),d.set(we,xe));const Se=xe.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Te?w(we,ke):p(we,ke)}e.matchesFuzzy=m;function C(we,ke){const Te=z(we,we.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?B(Te):null}e.matchesFuzzy2=C;function L(we,ke,Te,xe,Se,Ge){const Q=Math.min(13,we.length);for(;Te<Q;Te++){const ie=z(we,ke,Te,xe,Se,Ge,!1);if(ie)return ie}return[0,Ge]}e.anyScore=L;function B(we){if(typeof we=="undefined")return[];const ke=[],Te=we[1];for(let xe=we.length-1;xe>1;xe--){const Se=we[xe]+Te,Ge=ke[ke.length-1];Ge&&Ge.end===Se?Ge.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=B;const ee=128;function H(){const we=[],ke=[];for(let Te=0;Te<=ee;Te++)ke[Te]=0;for(let Te=0;Te<=ee;Te++)we.push(ke.slice(0));return we}function x(we){const ke=[];for(let Te=0;Te<=we;Te++)ke[Te]=0;return ke}const W=x(2*ee),F=x(2*ee),U=H(),M=H(),N=H(),O=!1;function V(we,ke,Te,xe,Se){function Ge(ie,be,Oe=" "){for(;ie.length<be;)ie=Oe+ie;return ie}let Q=` |   |${xe.split("").map(ie=>Ge(ie,3)).join("|")}
`;for(let ie=0;ie<=Te;ie++)ie===0?Q+=" |":Q+=`${ke[ie-1]}|`,Q+=we[ie].slice(0,Se+1).map(be=>Ge(be.toString(),3)).join("|")+`
`;return Q}function q(we,ke,Te,xe){we=we.substr(ke),Te=Te.substr(xe),console.log(V(M,we,we.length,Te,Te.length)),console.log(V(N,we,we.length,Te,Te.length)),console.log(V(U,we,we.length,Te,Te.length))}function X(we,ke){if(ke<0||ke>=we.length)return!1;const Te=we.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(Te)}}function fe(we,ke){if(ke<0||ke>=we.length)return!1;switch(we.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function ve(we,ke,Te){return ke[we]!==Te[we]}function Ae(we,ke,Te,xe,Se,Ge,Q=!1){for(;ke<Te&&Se<Ge;)we[ke]===xe[Se]&&(Q&&(W[ke]=Se),ke+=1),Se+=1;return ke===Te}e.isPatternInWord=Ae;var Ie;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Fe;(function(we){we.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}we.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function z(we,ke,Te,xe,Se,Ge,Q){const ie=we.length>ee?ee:we.length,be=xe.length>ee?ee:xe.length;if(!(Te>=ie||Ge>=be||ie-Te>be-Ge)&&!!Ae(ke,Te,ie,Se,Ge,be,!0)){J(ie,be,Te,Ge,ke,Se);let Oe=1,Ve=1,We=Te,tt=Ge;const K=[!1];for(Oe=1,We=Te;We<ie;Oe++,We++){const le=W[We],me=F[We],_e=We+1<ie?F[We+1]:be;for(Ve=le-Ge+1,tt=le;tt<_e;Ve++,tt++){let He=Number.MIN_SAFE_INTEGER,$e=!1;tt<=me&&(He=te(we,ke,We,Te,xe,Se,tt,be,Ge,U[Oe-1][Ve-1]===0,K));let Ke=0;He!==Number.MAX_SAFE_INTEGER&&($e=!0,Ke=He+M[Oe-1][Ve-1]);const Je=tt>le,Ze=Je?M[Oe][Ve-1]+(U[Oe][Ve-1]>0?-5:0):0,ut=tt>le+1&&U[Oe][Ve-1]>0,lt=ut?M[Oe][Ve-2]+(U[Oe][Ve-2]>0?-5:0):0;if(ut&&(!Je||lt>=Ze)&&(!$e||lt>=Ke))M[Oe][Ve]=lt,N[Oe][Ve]=3,U[Oe][Ve]=0;else if(Je&&(!$e||Ze>=Ke))M[Oe][Ve]=Ze,N[Oe][Ve]=2,U[Oe][Ve]=0;else if($e)M[Oe][Ve]=Ke,N[Oe][Ve]=1,U[Oe][Ve]=U[Oe-1][Ve-1]+1;else throw new Error("not possible")}}if(O&&q(we,Te,xe,Ge),!(!K[0]&&!Q)){Oe--,Ve--;const se=[M[Oe][Ve],Ge];let de=0,Y=0;for(;Oe>=1;){let le=Ve;do{const me=N[Oe][le];if(me===3)le=le-2;else if(me===2)le=le-1;else break}while(le>=1);de>1&&ke[Te+Oe-1]===Se[Ge+Ve-1]&&!ve(le+Ge-1,xe,Se)&&de+1>U[Oe][le]&&(le=Ve),le===Ve?de++:de=1,Y||(Y=le),Oe--,Ve=le-1,se.push(Ve)}be===ie&&(se[0]+=2);const ne=Y-ie;return se[0]-=ne,se}}}e.fuzzyScore=z;function J(we,ke,Te,xe,Se,Ge){let Q=we-1,ie=ke-1;for(;Q>=Te&&ie>=xe;)Se[Q]===Ge[ie]&&(F[Q]=ie,Q--),ie--}function te(we,ke,Te,xe,Se,Ge,Q,ie,be,Oe,Ve){if(ke[Te]!==Ge[Q])return Number.MIN_SAFE_INTEGER;let We=1,tt=!1;return Q===Te-xe?We=we[Te]===Se[Q]?7:5:ve(Q,Se,Ge)&&(Q===0||!ve(Q-1,Se,Ge))?(We=we[Te]===Se[Q]?7:5,tt=!0):X(Ge,Q)&&(Q===0||!X(Ge,Q-1))?We=5:(X(Ge,Q-1)||fe(Ge,Q-1))&&(We=5,tt=!0),We>1&&Te===xe&&(Ve[0]=!0),tt||(tt=ve(Q,Se,Ge)||X(Ge,Q-1)||fe(Ge,Q-1)),Te===xe?Q>be&&(We-=tt?3:5):Oe?We+=tt?2:0:We+=tt?0:1,Q+1===ie&&(We-=tt?3:5),We}function ae(we,ke,Te,xe,Se,Ge,Q){return De(we,ke,Te,xe,Se,Ge,!0,Q)}e.fuzzyScoreGracefulAggressive=ae;function he(we,ke,Te,xe,Se,Ge,Q){return De(we,ke,Te,xe,Se,Ge,!1,Q)}e.fuzzyScoreGraceful=he;function De(we,ke,Te,xe,Se,Ge,Q,ie){let be=z(we,ke,Te,xe,Se,Ge,ie);if(be&&!Q)return be;if(we.length>=3){const Oe=Math.min(7,we.length-1);for(let Ve=Te+1;Ve<Oe;Ve++){const We=Me(we,Ve);if(We){const tt=z(We,We.toLowerCase(),Te,xe,Se,Ge,ie);tt&&(tt[0]-=3,(!be||tt[0]>be[0])&&(be=tt))}}}return be}function Me(we,ke){if(!(ke+1>=we.length)){const Te=we[ke],xe=we[ke+1];if(Te!==xe)return we.slice(0,ke)+xe+Te+we.slice(ke+2)}}}),define(ge[135],pe([0,1,47,93,10]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${I.source}`,"g");function P(h){return h.replace(D,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=P;const y=new RegExp(`\\\\${I.source}`,"g");function n(h){return h.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function k(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(T,(S,v,E,c)=>E?S:v||c||"")}e.stripIcons=k;function _(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:g(h,S)}e.parseLabelWithIcons=_;function g(h,S){const v=[];let E="";function c(f){if(f){E+=f;for(const p of f)v.push(t)}}let u=-1,s="",t=0,i,o,r=S;const l=h.length;for(c(h.substr(0,S));r<l;)i=h[r],o=h[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=r,c(s),s=e.iconStartMarker,r++):i===")"&&u!==-1?(t+=r-u+1,u=-1,s=""):u!==-1?/^[a-z0-9\-]$/i.test(i)?s+=i:(c(s),u=-1,s=""):c(i),r++;return c(s),{text:E,iconOffsets:v}}function a(h,S,v=!1){const{text:E,iconOffsets:c}=S;if(!c||c.length===0)return(0,A.matchesFuzzy)(h,E,v);const u=(0,R.ltrim)(E," "),s=E.length-u.length,t=(0,A.matchesFuzzy)(h,u,v);if(t)for(const i of t){const o=c[i.start+s]+s;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=a}),define(ge[94],pe([0,1,14,135,16]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(h="",S=!1){var v,E;if(this.value=h,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(E=S.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(h,S=0){return this.value+=k(this.supportThemeIcons?(0,A.escapeIcons)(h):h).replace(/([ \t]+)/g,(v,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,S){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function P(a){return y(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function y(a){return a instanceof D?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(a,h){return!a&&!h?!0:!a||!h?!1:Array.isArray(a)&&Array.isArray(h)?(0,b.equals)(a,h,T):y(a)&&y(h)?T(a,h):!1}e.markedStringsEquals=n;function T(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons}function k(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function _(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=_;function g(a){const h=[],S=a.split("|").map(E=>E.trim());a=S[0];const v=S[1];if(v){const E=/height=(\d+)/.exec(v),c=/width=(\d+)/.exec(v),u=E?E[1]:"",s=c?c[1]:"",t=isFinite(parseInt(s)),i=isFinite(parseInt(u));t&&h.push(`width="${s}"`),i&&h.push(`height="${u}"`)}return{href:a,dimensions:h}}e.parseHrefAndDimensions=g}),define(ge[57],pe([0,1,25,10,2]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(n){return JSON.stringify(n,P)}e.stringify=I;function D(n){let T=JSON.parse(n);return T=y(T),T}e.parse=D;function P(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,A.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof b.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],T+1))}return n}e.revive=y}),define(ge[11],pe([0,1,2,9]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.vscodeWebviewResource="vscode-webview-resource",P.extension="extension",P.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],_=this._connectionTokens[n];let g=`path=${encodeURIComponent(y.path)}`;return typeof _=="string"&&(g+=`&tkn=${encodeURIComponent(_)}`),b.URI.from({scheme:A.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new I;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const k=this.toUri(y,n);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):A.isNative&&(T||A.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return b.URI.isUri(y)?y:b.URI.parse(n.toUrl(y))}}e.FileAccess=new D}),define(ge[74],pe([0,1,23]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new b.LRUCache(1e4);function R(n){return y(n,"NFC",A)}e.normalizeNFC=R;const I=new b.LRUCache(1e4);function D(n){return y(n,"NFD",I)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function y(n,T,k){if(!e.canNormalize||!n)return n;const _=k.get(n);if(_)return _;let g;return P.test(n)?g=n.normalize(T):g=n,k.set(n,g),g}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(T){return D(T).replace(n,"")}}else return function(n){return n}}()}),define(ge[24],pe([0,1,31,8,2,10,11,9]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,R.uriToFsPath)(g,!0)}e.originalFSPath=y;class n{constructor(a){this._ignorePathCasing=a}compare(a,h,S=!1){return a===h?0:(0,I.compare)(this.getComparisonKey(a,S),this.getComparisonKey(h,S))}isEqual(a,h,S=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,S)===this.getComparisonKey(h,S)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,S=!1){if(a.scheme===h.scheme){if(a.scheme===D.Schemas.file)return b.isEqualOrParent(y(a),y(h),this._ignorePathCasing(a))&&a.query===h.query&&(S||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return b.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(S||a.fragment===h.fragment)}return!1}joinPath(a,...h){return R.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return A.posix.basename(a.path)}extname(a){return A.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===D.Schemas.file?h=R.URI.file(A.dirname(y(a))).path:(h=A.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===D.Schemas.file?h=R.URI.file(A.normalize(y(a))).path:h=A.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(!(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))){if(a.scheme===D.Schemas.file){const E=A.relative(y(a),y(h));return P.isWindows?b.toSlashes(E):E}let S=a.path||"/",v=h.path||"/";if(this._ignorePathCasing(a)){let E=0;for(const c=Math.min(S.length,v.length);E<c&&!(S.charCodeAt(E)!==v.charCodeAt(E)&&S.charAt(E).toLowerCase()!==v.charAt(E).toLowerCase());E++);S=v.substr(0,E)+S.substr(E)}return A.posix.relative(S,v)}}resolvePath(a,h){if(a.scheme===D.Schemas.file){const S=R.URI.file(A.resolve(y(a),h));return a.with({authority:S.authority,path:S.path})}return h.indexOf("/")===-1&&(h=b.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),a.with({path:A.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||(0,I.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=A.sep){if(a.scheme===D.Schemas.file){const S=y(a);return S.length>b.getRoot(S).length&&S[S.length-1]===h}else{const S=a.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=A.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=A.sep){let S=!1;if(a.scheme===D.Schemas.file){const v=y(a);S=v!==void 0&&v.length===b.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=a.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(g=>g.scheme===D.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new n(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(g,a){const h=[];for(let S=0;S<g.length;S++){const v=a(g[S]);g.some((E,c)=>c===S?!1:(0,e.isEqualOrParent)(v,a(E)))||h.push(g[S])}return h}e.distinctParents=T;var k;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(c=>{const[u,s]=c.split(":");u&&s&&S.set(u,s)});const E=h.path.substring(0,h.path.indexOf(";"));return E&&S.set(g.META_DATA_MIME,E),S}g.parseMetaData=a})(k=e.DataUri||(e.DataUri={}));function _(g,a,h){if(a){let S=g.path;return S&&S[0]!==A.posix.sep&&(S=A.posix.sep+S),g.with({scheme:h,authority:a,path:S})}return g.with({scheme:h})}e.toLocalResource=_}),define(ge[17],pe([0,1,21,16,3,6,55,24]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function n(M){const N=new b.CancellationTokenSource,O=M(N.token),V=new Promise((q,X)=>{N.token.onCancellationRequested(()=>{X((0,A.canceled)())}),Promise.resolve(O).then(fe=>{N.dispose(),q(fe)},fe=>{N.dispose(),X(fe)})});return new class{cancel(){N.cancel()}then(q,X){return V.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=n;function T(M,N,O){return Promise.race([M,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=T;async function k(M){let N=-1;const O=M.map((q,X)=>q.then(fe=>(N=X,fe))),V=await Promise.race(O);return M.forEach((q,X)=>{X!==N&&q.cancel()}),V}e.raceCancellablePromises=k;function _(M,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(X=>V=X)])}e.raceTimeout=_;function g(M){return new Promise((N,O)=>{const V=M();y(V)?V.then(N,O):N(V)})}e.asPromise=g;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(N,O){var V;const X=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===X&&this.promiseMap.delete(N)});return this.promiseMap.set(N,X),X}}e.SequencerByKey=S;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class E{constructor(N){this.delayer=new v(N),this.throttler=new a}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class c{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class u extends c{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(M,N){return N?new Promise((O,V)=>{const q=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(q),V((0,A.canceled)())})}):n(O=>s(M,O))}e.timeout=s;function t(M,N=0){const O=setTimeout(M,N);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(M){return M.then(void 0,N=>{})}e.ignoreErrors=i;function o(M){const N=[];let O=0;const V=M.length;function q(){return O<V?M[O++]():null}function X(fe){fe!=null&&N.push(fe);const ve=q();return ve?ve.then(X):Promise.resolve(N)}return Promise.resolve(null).then(X)}e.sequence=o;function r(M,N=V=>!!V,O=null){let V=0;const q=M.length,X=()=>{if(V>=q)return Promise.resolve(O);const fe=M[V++];return Promise.resolve(fe()).then(Ae=>N(Ae)?Promise.resolve(Ae):X())};return X()}e.first=r;function l(M,N=V=>!!V,O=null){if(M.length===0)return Promise.resolve(O);let V=M.length;const q=()=>{var X,fe;V=-1;for(const ve of M)(fe=(X=ve).cancel)===null||fe===void 0||fe.call(X)};return new Promise((X,fe)=>{for(const ve of M)ve.then(Ae=>{--V>=0&&N(Ae)?(q(),X(Ae)):V===0&&X(O)}).catch(Ae=>{--V>=0&&(q(),fe(Ae))})})}e.firstParallel=l;class f{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class p extends f{constructor(){super(1)}}e.Queue=p;class w{constructor(){this.queues=new Map}queueFor(N,O=P.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new p,R.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=w;class d{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=d;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=m;class C{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=C;class L extends C{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class B{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function ee(M,N,O){let V;for(let q=0;q<O;q++)try{return await M()}catch(X){V=X,await s(N)}throw V}e.retry=ee;class H{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((X,fe)=>{O=X,V=fe});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=H;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=W;class F extends R.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,X]=this._asyncDeliveryQueue.shift(),fe=[],ve=Object.assign(Object.assign({},X),{waitUntil:Ae=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");V&&(Ae=V(Ae,typeof q=="function"?q:q[0])),fe.push(Ae)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Ae){(0,A.onUnexpectedError)(Ae);continue}Object.freeze(fe),await U.settled(fe).catch(Ae=>(0,A.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(X){return typeof Promise.allSettled=="function"?O(X):V(X)}M.allSettled=N;async function O(X){return Promise.allSettled(X)}async function V(X){return Promise.all(X.map(fe=>fe.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(X){let fe;const ve=await Promise.all(X.map(Ae=>Ae.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe!="undefined")throw fe;return ve}M.settled=q})(U=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,8,17]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new A.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),I=new A.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new A.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,s,t=!1){const i=u||"",o=s||"",r=R.value.collator.compare(i,o);return R.value.collatorIsNumeric&&r===0&&i!==o?i<o?-1:1:r}e.compareFileNames=P;function y(u,s){const t=I.value.collator;return u=u||"",s=s||"",h(t,u,s)}e.compareFileNamesDefault=y;function n(u,s,t=!1){t||(u=u&&u.toLowerCase(),s=s&&s.toLowerCase());const[i,o]=g(u),[r,l]=g(s);return i!==r?i<r?-1:1:o===l?0:o<l?-1:1}e.noIntlCompareFileNames=n;function T(u,s){const[t,i]=g(u),[o,r]=g(s);let l=R.value.collator.compare(i,r);if(l===0){if(R.value.collatorIsNumeric&&i!==r)return i<r?-1:1;if(l=R.value.collator.compare(t,o),R.value.collatorIsNumeric&&l===0&&t!==o)return t<o?-1:1}return l}e.compareFileExtensions=T;function k(u,s){u=u||"",s=s||"";const t=a(u),i=a(s),o=I.value.collator,r=D.value.collator;let l;return l=h(r,t,i),l!==0?l:h(o,u,s)}e.compareFileExtensionsDefault=k;const _=/^(.*?)(\.([^.]*))?$/;function g(u,s=!1){const t=u?_.exec(u):[];let i=[t&&t[1]||"",t&&t[3]||""];return s&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function a(u){const s=u?_.exec(u):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function h(u,s,t){let i=u.compare(s,t);return i!==0?i:s.length!==t.length?s.length<t.length?-1:1:0}function S(u,s,t=!1){return t||(u=u&&u.toLowerCase(),s=s&&s.toLowerCase()),u===s?0:u<s?-1:1}function v(u,s,t=!1){const i=u.split(b.sep),o=s.split(b.sep),r=i.length-1,l=o.length-1;let f,p;for(let w=0;;w++){if(f=r===w,p=l===w,f&&p)return P(i[w],o[w],t);if(f)return-1;if(p)return 1;const d=S(i[w],o[w],t);if(d!==0)return d}}e.comparePaths=v;function E(u,s,t){const i=u.toLowerCase(),o=s.toLowerCase(),r=c(u,s,t);if(r)return r;const l=i.endsWith(t),f=o.endsWith(t);if(l!==f)return l?-1:1;const p=P(i,o);return p!==0?p:i.localeCompare(o)}e.compareAnything=E;function c(u,s,t){const i=u.toLowerCase(),o=s.toLowerCase(),r=i.startsWith(t),l=o.startsWith(t);if(r!==l)return r?-1:1;if(r&&l){if(i.length<o.length)return-1;if(i.length>o.length)return 1}return 0}e.compareByPrefix=c}),define(ge[96],pe([0,1,95,93,8,9,10]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,y=[P,[]];function n(x,W,F,U){if(!x||!W)return y;const M=x.length,N=W.length;if(M<N)return y;const O=x.toLowerCase();return!U&&!O.includes(F)?y:T(W,F,N,x,O,M)}e.scoreFuzzy=n;function T(x,W,F,U,M,N){const O=[],V=[];for(let ve=0;ve<F;ve++){const Ae=ve*N,Ie=Ae-N,Fe=ve>0,z=x[ve],J=W[ve];for(let te=0;te<N;te++){const ae=te>0,he=Ae+te,De=he-1,Me=Ie+te-1,we=ae?O[De]:0,ke=Fe&&ae?O[Me]:0,Te=Fe&&ae?V[Me]:0;let xe;!ke&&Fe?xe=0:xe=k(z,J,U,M,te,Te),xe&&ke+xe>=we?(V[he]=Te+1,O[he]=ke+xe):(V[he]=P,O[he]=we)}}const q=[];let X=F-1,fe=N-1;for(;X>=0&&fe>=0;){const ve=X*N+fe;V[ve]===P||(q.push(fe),X--),fe--}return[O[F*N-1],q.reverse()]}function k(x,W,F,U,M,N){let O=0;if(!_(W,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const V=g(F.charCodeAt(M-1));V?O+=V:(0,A.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function _(x,W){return x===W?!0:x==="/"||x==="\\"?W==="/"||W==="\\":!1}function g(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function h(x,W,F=0,U=0){const M=W;return M.values&&M.values.length>1?S(x,M.values,F,U):v(x,W,F,U)}e.scoreFuzzy2=h;function S(x,W,F,U){let M=0;const N=[];for(const O of W){const[V,q]=v(x,O,F,U);if(typeof V!="number")return a;M+=V,N.push(...q)}return[M,f(N)]}function v(x,W,F,U){const M=(0,A.fuzzyScore)(W.original,W.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,A.createMatches)(M)]:a}const E=Object.freeze({score:0}),c=1<<18,u=1<<17,s=1<<16;function t(x,W,F,U,M){if(!x||!W.normalized)return E;const N=U.getItemLabel(x);if(!N)return E;const O=U.getItemDescription(x);let V;O?V=`${N}${O}${W.normalized}${Array.isArray(W.values)?W.values.length:""}${F}`:V=`${N}${W.normalized}${Array.isArray(W.values)?W.values.length:""}${F}`;const q=M[V];if(q)return q;const X=i(N,O,U.getItemPath(x),W,F);return M[V]=X,X}e.scoreItemFuzzy=t;function i(x,W,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(I.isLinux?U.pathNormalized===F:(0,D.equalsIgnoreCase)(U.pathNormalized,F))?{score:c,labelMatch:[{start:0,end:x.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:U.values&&U.values.length>1?o(x,W,F,U.values,N,M):r(x,W,F,U,N,M)}function o(x,W,F,U,M,N){let O=0;const V=[],q=[];for(const X of U){const{score:fe,labelMatch:ve,descriptionMatch:Ae}=r(x,W,F,X,M,N);if(fe===P)return E;O+=fe,ve&&V.push(...ve),Ae&&q.push(...Ae)}return{score:O,labelMatch:f(V),descriptionMatch:f(q)}}function r(x,W,F,U,M,N){if(M||!W){const[O,V]=n(x,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,A.matchesPrefix)(U.normalized,x);let X;return q?(X=u,X+=Math.round(U.normalized.length/x.length*100)):X=s,{score:X+O,labelMatch:q||l(V)}}}if(W){let O=W;F&&(O=`${W}${R.sep}`);const V=O.length,q=`${O}${x}`,[X,fe]=n(q,U.normalized,U.normalizedLowercase,N);if(X){const ve=l(fe),Ae=[],Ie=[];return ve.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Ae.push({start:0,end:Fe.end-V}),Ie.push({start:Fe.start,end:V})):Fe.start>=V?Ae.push({start:Fe.start-V,end:Fe.end-V}):Ie.push(Fe)}),{score:X,labelMatch:Ae,descriptionMatch:Ie}}}return E}function l(x){const W=[];if(!x)return W;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},W.push(F));return W}function f(x){const W=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of W)!U||!p(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function p(x,W){return!(x.end<W.start||W.end<x.start)}function w(x,W,F,U,M,N){const O=t(x,F,U,M,N),V=t(W,F,U,M,N),q=O.score,X=V.score;if((q===c||X===c)&&q!==X)return q===c?-1:1;if(q>s||X>s){if(q!==X)return q>X?-1:1;if(q<u&&X<u){const J=m(O.labelMatch,V.labelMatch);if(J!==0)return J}const Fe=M.getItemLabel(x)||"",z=M.getItemLabel(W)||"";if(Fe.length!==z.length)return Fe.length-z.length}if(q!==X)return q>X?-1:1;const fe=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ve=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(fe&&!ve)return-1;if(ve&&!fe)return 1;const Ae=d(x,O,M),Ie=d(W,V,M);return Ae&&Ie&&Ae!==Ie?Ie>Ae?-1:1:C(x,W,F,M)}e.compareItemsByFuzzyScore=w;function d(x,W,F){let U=-1,M=-1;if(W.descriptionMatch&&W.descriptionMatch.length?U=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(U=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(M=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(M=W.descriptionMatch[W.descriptionMatch.length-1].end);return M-U}function m(x,W){if(!x&&!W||(!x||!x.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=W[0].start,V=W[W.length-1].end-N;return M===V?0:V<M?1:-1}function C(x,W,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel(W)||"",O=U.getItemDescription(x),V=U.getItemDescription(W),q=M.length+(O?O.length:0),X=N.length+(V?V.length:0);if(q!==X)return q-X;const fe=U.getItemPath(x),ve=U.getItemPath(W);return fe&&ve&&fe.length!==ve.length?fe.length-ve.length:M!==N?(0,b.compareAnything)(M,N,F.normalized):O&&V&&O!==V?(0,b.compareAnything)(O,V,F.normalized):fe&&ve&&fe!==ve?(0,b.compareAnything)(fe,ve,F.normalized):0}const L=" ";function B(x){typeof x!="string"&&(x="");const W=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=ee(x),N=F.indexOf(R.sep)>=0;let O;const V=x.split(L);if(V.length>1)for(const q of V){const{pathNormalized:X,normalized:fe,normalizedLowercase:ve}=ee(q);fe&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:X,normalized:fe,normalizedLowercase:ve}))}return{original:x,originalLowercase:W,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=B;function ee(x){let W;I.isWindows?W=x.replace(/\//g,R.sep):W=x.replace(/\\/g,R.sep);const F=(0,D.stripWildcards)(W).replace(/\s/g,"");return{pathNormalized:W,normalized:F,normalizedLowercase:F.toLowerCase()}}function H(x){return Array.isArray(x)?B(x.map(W=>W.original).join(L)):B(x.original)}e.pieceToQuery=H}),define(ge[34],pe([0,1,10,31,8,23,17]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",n="/",T="[/\\\\]",k="[^/\\\\]",_=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function a(O,V){if(!O)return[];const q=[];let X=!1,fe=!1,ve="";for(const Ae of O){switch(Ae){case V:if(!X&&!fe){q.push(ve),ve="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ve+=Ae}return ve&&q.push(ve),q}e.splitGlobAware=a;function h(O){if(!O)return"";let V="";const q=a(O,n);if(q.every(X=>X===y))V=".*";else{let X=!1;q.forEach((fe,ve)=>{if(fe===y){X||(V+=g(2),X=!0);return}let Ae=!1,Ie="",Fe=!1,z="";for(const J of fe){if(J!=="}"&&Ae){Ie+=J;continue}if(Fe&&(J!=="]"||!z)){let te;J==="-"?te=J:(J==="^"||J==="!")&&!z?te="^":J===n?te="":te=b.escapeRegExpCharacters(J),z+=te;continue}switch(J){case"{":Ae=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${a(Ie,",").map(he=>h(he)).join("|")})`,Ae=!1,Ie="";break;case"]":V+="["+z+"]",Fe=!1,z="";break;case"?":V+=k;continue;case"*":V+=g(1);continue;default:V+=b.escapeRegExpCharacters(J)}}ve<q.length-1&&(q[ve+1]!==y||ve+2<q.length)&&(V+=T),X=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),i=function(){return!1},o=function(){return null};function r(O,V){if(!O)return o;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const X=`${q}_${!!V.trimForExclusions}`;let fe=t.get(X);if(fe)return l(fe,O);let ve;if(S.test(q)){const Ae=q.substr(4);fe=function(Ie,Fe){return typeof Ie=="string"&&Ie.endsWith(Ae)?q:null}}else(ve=v.exec(f(q,V)))?fe=p(ve[1],q):(V.trimForExclusions?c:E).test(q)?fe=w(q,V):(ve=u.exec(f(q,V)))?fe=d(ve[1].substr(1),q,!0):(ve=s.exec(f(q,V)))?fe=d(ve[1],q,!1):fe=m(q);return t.set(X,fe),l(fe,O)}function l(O,V){return typeof V=="string"?O:function(q,X){return A.isEqualOrParent(q,V.base)?O(R.relative(V.base,q),X):null}}function f(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,V){const q=`/${O}`,X=`\\${O}`,fe=function(Ae,Ie){return typeof Ae!="string"?null:Ie?Ie===O?V:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(X)?V:null},ve=[O];return fe.basenames=ve,fe.patterns=[V],fe.allBasenames=ve,fe}function w(O,V){const q=N(O.slice(1,-1).split(",").map(Ie=>r(Ie,V)).filter(Ie=>Ie!==o),O),X=q.length;if(!X)return o;if(X===1)return q[0];const fe=function(Ie,Fe){for(let z=0,J=q.length;z<J;z++)if(q[z](Ie,Fe))return O;return null},ve=q.find(Ie=>!!Ie.allBasenames);ve&&(fe.allBasenames=ve.allBasenames);const Ae=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Ae.length&&(fe.allPaths=Ae),fe}function d(O,V,q){const X=R.sep===R.posix.sep,fe=X?O:O.replace(_,R.sep),ve=R.sep+fe,Ae=R.posix.sep+O,Ie=q?function(Fe,z){return typeof Fe=="string"&&(Fe===fe||Fe.endsWith(ve)||!X&&(Fe===O||Fe.endsWith(Ae)))?V:null}:function(Fe,z){return typeof Fe=="string"&&(Fe===fe||!X&&Fe===O)?V:null};return Ie.allPaths=[(q?"*/":"./")+O],Ie}function m(O){try{const V=new RegExp(`^${h(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return o}}function C(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=C;function L(O,V={}){if(!O)return i;if(typeof O=="string"||x(O)){const q=r(O,V);if(q===o)return i;const X=function(fe,ve){return!!q(fe,ve)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return U(O,V)}e.parse=L;function B(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(X=>X?H(X):{})),V.then(X=>!!X[q]))}}e.hasSiblingPromiseFn=B;function ee(O){if(!!O){let V;return q=>{if(!V){const X=O();V=X?H(X):{}}return!!V[q]}}}e.hasSiblingFn=ee;function H(O){const V={};for(const q of O)V[q]=!0;return V}function x(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=x;function W(O){return O.allBasenames||[]}e.getBasenameTerms=W;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Ie=>M(Ie,O[Ie],V)).filter(Ie=>Ie!==o)),X=q.length;if(!X)return o;if(!q.some(Ie=>!!Ie.requiresSiblings)){if(X===1)return q[0];const Ie=function(J,te){for(let ae=0,he=q.length;ae<he;ae++){const De=q[ae](J,te);if(De)return De}return null},Fe=q.find(J=>!!J.allBasenames);Fe&&(Ie.allBasenames=Fe.allBasenames);const z=q.reduce((J,te)=>te.allPaths?J.concat(te.allPaths):J,[]);return z.length&&(Ie.allPaths=z),Ie}const fe=function(Ie,Fe,z){let J;for(let te=0,ae=q.length;te<ae;te++){const he=q[te];he.requiresSiblings&&z&&(Fe||(Fe=R.basename(Ie)),J||(J=Fe.substr(0,Fe.length-R.extname(Ie).length)));const De=he(Ie,Fe,J,z);if(De)return De}return null},ve=q.find(Ie=>!!Ie.allBasenames);ve&&(fe.allBasenames=ve.allBasenames);const Ae=q.reduce((Ie,Fe)=>Fe.allPaths?Ie.concat(Fe.allPaths):Ie,[]);return Ae.length&&(fe.allPaths=Ae),fe}function M(O,V,q){if(V===!1)return o;const X=r(O,q);if(X===o)return o;if(typeof V=="boolean")return X;if(V){const fe=V.when;if(typeof fe=="string"){const ve=(Ae,Ie,Fe,z)=>{if(!z||!X(Ae,Ie))return null;const J=fe.replace("$(basename)",Fe),te=z(J);return(0,D.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return ve.requiresSiblings=!0,ve}}return X}function N(O,V){const q=O.filter(Ie=>!!Ie.basenames);if(q.length<2)return O;const X=q.reduce((Ie,Fe)=>{const z=Fe.basenames;return z?Ie.concat(z):Ie},[]);let fe;if(V){fe=[];for(let Ie=0,Fe=X.length;Ie<Fe;Ie++)fe.push(V)}else fe=q.reduce((Ie,Fe)=>{const z=Fe.patterns;return z?Ie.concat(z):Ie},[]);const ve=function(Ie,Fe){if(typeof Ie!="string")return null;if(!Fe){let J;for(J=Ie.length;J>0;J--){const te=Ie.charCodeAt(J-1);if(te===47||te===92)break}Fe=Ie.substr(J)}const z=X.indexOf(Fe);return z!==-1?fe[z]:null};ve.basenames=X,ve.patterns=fe,ve.allBasenames=X;const Ae=O.filter(Ie=>!Ie.basenames);return Ae.push(ve),Ae}}),define(ge[75],pe([0,1,2,8,10,11,9,24,31]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(r,l,f){if(typeof r=="string"&&(r=b.URI.file(r)),f){const w=f.getWorkspaceFolder(r);if(w){const d=f.getWorkspace().folders.length>1;let m;if((0,P.isEqual)(w.uri,r)?m="":m=(0,P.relativePath)(w.uri,r),d){const C=w.name?w.name:(0,P.basename)(w.uri);m=m?C+" \u2022 "+m:C}return m}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,A.normalize)(k(r.fsPath));let p=(0,A.normalize)(r.fsPath);return!D.isWindows&&(l==null?void 0:l.userHome)&&(p=g(p,l.userHome.fsPath)),p}e.getPathLabel=n;function T(r){if(!!r){typeof r=="string"&&(r=b.URI.file(r));const l=(0,P.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(l)?k(l):l}}e.getBaseLabel=T;function k(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=k;let _=Object.create(null);function g(r,l){if(D.isWindows||!r||!l)return r;let f=_.original===l?_.normalized:void 0;return f||(f=`${(0,R.rtrim)(l,A.posix.sep)}${A.posix.sep}`,_={original:l,normalized:f}),(D.isLinux?r.startsWith(f):(0,R.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=g;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=a;const h="\u2026",S="\\\\",v="~";function E(r,l=A.sep){const f=new Array(r.length);let p=!1;for(let w=0;w<r.length;w++){let d=r[w];if(d===""){f[w]=`.${l}`;continue}if(!d){f[w]=d;continue}p=!0;let m="";d.indexOf(S)===0?(m=d.substr(0,d.indexOf(S)+S.length),d=d.substr(d.indexOf(S)+S.length)):d.indexOf(l)===0?(m=d.substr(0,d.indexOf(l)+l.length),d=d.substr(d.indexOf(l)+l.length)):d.indexOf(v)===0&&(m=d.substr(0,d.indexOf(v)+v.length),d=d.substr(d.indexOf(v)+v.length));const C=d.split(l);for(let L=1;p&&L<=C.length;L++)for(let B=C.length-L;p&&B>=0;B--){p=!1;let ee=C.slice(B,B+L).join(l);for(let H=0;!p&&H<r.length;H++)if(H!==w&&r[H]&&r[H].indexOf(ee)>-1){const x=B+L===C.length,W=B>0&&r[H].indexOf(l)>-1?l+ee:ee,F=r[H].endsWith(W);p=!x||F}if(!p){let H="";(C[0].endsWith(":")||m!=="")&&(B===1&&(B=0,L++,ee=C[0]+l+ee),B>0&&(H=C[0]+l),H=m+H),B>0&&(H=H+h+l),H=H+ee,B+L<C.length&&(H=H+l+h),f[w]=H}}p&&(f[w]=d)}return f}e.shorten=E;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(r,l=Object.create(null)){const f=[];let p=!1,w="";for(const d of r)if(d==="$"||p&&d==="{")w&&f.push({value:w,type:c.TEXT}),w="",p=!0;else if(d==="}"&&p){const m=l[w];if(typeof m=="string")m.length&&f.push({value:m,type:c.VARIABLE});else if(m){const C=f[f.length-1];(!C||C.type!==c.SEPARATOR)&&f.push({value:m.label,type:c.SEPARATOR})}w="",p=!1}else w+=d;return w&&!p&&f.push({value:w,type:c.TEXT}),f.filter((d,m)=>{if(d.type===c.SEPARATOR){const C=f[m-1],L=f[m+1];return[C,L].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=u;function s(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(r){const l=r.indexOf("/")!==-1?A.posix:A.win32,f=l.basename(r),p=l.dirname(r);return f.length?{name:f,parentPath:p}:{name:p,parentPath:""}}e.splitName=o}),define(ge[97],pe([0,1,2]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const _=this._uriTransformer.transformIncoming(k);return _===k?k:A(b.URI.from(_))}transformOutgoing(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:A(b.URI.from(_))}transformOutgoingURI(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:b.URI.from(_)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,k,_){if(!T||_>200)return null;if(typeof T=="object"){if(T instanceof b.URI)return k.transformOutgoing(T);for(let g in T)if(Object.hasOwnProperty.call(T,g)){const a=I(T[g],k,_+1);a!==null&&(T[g]=a)}}return null}function D(T,k){const _=I(T,k,0);return _===null?T:_}e.transformOutgoingURIs=D;function P(T,k,_,g){if(!T||g>200)return null;if(typeof T=="object"){if(T.$mid===1)return _?b.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let a in T)if(Object.hasOwnProperty.call(T,a)){const h=P(T[a],k,_,g+1);h!==null&&(T[a]=h)}}return null}function y(T,k){const _=P(T,k,!1,0);return _===null?T:_}e.transformIncomingURIs=y;function n(T,k){const _=P(T,k,!0,0);return _===null?T:_}e.transformAndReviveIncomingURIs=n}),define(ge[28],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(y){return b.test(y)}e.isUUID=A;const R=new Uint8Array(16),I=[];for(let y=0;y<256;y++)I.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function P(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,n="";return n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n+="-",n+=I[R[y++]],n+=I[R[y++]],n+="-",n+=I[R[y++]],n+=I[R[y++]],n+="-",n+=I[R[y++]],n+=I[R[y++]],n+="-",n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n+=I[R[y++]],n}e.generateUuid=P}),define(ge[136],pe([0,1,98]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(I="utf8"){this.stringDecoder=new b.StringDecoder(I),this.remaining=null}write(I){const D=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return D;let y=0,n,T=y;for(;T<P.length;)if(n=P.charCodeAt(T),n===13||n===10){if(D.push(P.substring(y,T)),T++,T<P.length){const k=n;n=P.charCodeAt(T),(k===13&&n===10||k===10&&n===13)&&T++}y=T}else T++;return this.remaining=y<P.length?P.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=A}),define(ge[26],pe([0,1,37,48,8,17,9,31,28,74,24,2]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var _;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function g(W,F=_.UNLINK){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return F===_.UNLINK?h(W):a(W)}e.rimraf=g;async function a(W){try{const F=(0,R.join)((0,A.tmpdir)(),(0,y.generateUuid)());try{await b.promises.rename(W,F)}catch(U){return h(W)}h(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function h(W){return b.promises.rmdir(W,{recursive:!0,maxRetries:3})}function S(W){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync(W,{recursive:!0})}e.rimrafSync=S;async function v(W,F){return u(await(F?E(W):b.promises.readdir(W)))}e.readdir=v;async function E(W){try{return await b.promises.readdir(W,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await v(W);for(const M of U){let N=!1,O=!1,V=!1;try{const q=await b.promises.lstat((0,R.join)(W,M));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return F}function c(W){return u(b.readdirSync(W))}e.readdirSync=c;function u(W){return W.map(F=>typeof F=="string"?D.isMacintosh?(0,n.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,n.normalizeNFC)(F.name):F.name,F))}async function s(W){const F=await v(W),U=[];for(const M of F)await i.existsDirectory((0,R.join)(W,M))&&U.push(M);return U}e.readDirsInDir=s;function t(W,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,b.access(W,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var i;(function(W){async function F(N){let O;try{if(O=await b.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await b.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}W.stat=F;async function U(N){try{const{stat:O,symbolicLink:V}=await W.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}W.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:V}=await W.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}W.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new I.ResourceQueue;function r(W,F,U){return o.queueFor(k.URI.file(W),T.extUriBiasedIgnorePathCase).queue(()=>{const M=w(U);return new Promise((N,O)=>f(W,F,M,V=>V?O(V):N()))})}e.writeFile=r;let l=!0;function f(W,F,U,M){if(!l)return b.writeFile(W,F,{mode:U.mode,flag:U.flag},M);b.open(W,U.flag,U.mode,(N,O)=>{if(N)return M(N);b.writeFile(O,F,V=>{if(V)return b.close(O,()=>M(V));b.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l=!1),b.close(O,X=>M(X))))})})}function p(W,F,U){const M=w(U);if(!l)return b.writeFileSync(W,F,{mode:M.mode,flag:M.flag});const N=b.openSync(W,M.flag,M.mode);try{b.writeFileSync(N,F);try{b.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{b.closeSync(N)}}e.writeFileSync=p;function w(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function d(W,F){if(W!==F){async function U(M){try{const N=await b.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await b.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await b.promises.rename(W,F),await U(F)}catch(M){if(W.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||W.endsWith("."))await m(W,F,{preserveSymlinks:!1}),await g(W,_.MOVE),await U(F);else throw M}}}e.move=d;async function m(W,F,U){return L(W,F,{root:{source:W,target:F},options:U,handledSourcePaths:new Set})}e.copy=m;const C=511;async function L(W,F,U){if(!U.handledSourcePaths.has(W)){U.handledSourcePaths.add(W);const{stat:M,symbolicLink:N}=await i.stat(W);if(N){if(U.options.preserveSymlinks)try{return await H(W,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?B(W,F,M.mode&C,U):ee(W,F,M.mode&C)}}async function B(W,F,U,M){await b.promises.mkdir(F,{recursive:!0,mode:U});const N=await v(W);for(const O of N)await L((0,R.join)(W,O),(0,R.join)(F,O),M)}async function ee(W,F,U){await b.promises.copyFile(W,F),await b.promises.chmod(F,U)}async function H(W,F,U){let M=await b.promises.readlink(W);(0,P.isEqualOrParent)(M,U.root.source,!D.isLinux)&&(M=(0,R.join)(U.root.target,M.substr(U.root.source.length+1))),await b.promises.symlink(M,F)}async function x(W){try{return await b.promises.access(W),!0}catch(F){return!1}}e.exists=x}),define(ge[99],pe([0,1,37,280,10,8,26]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(k){const _=(0,I.dirname)(k);if(k===_)return k;const g=((0,I.basename)(k)||k).toLowerCase();try{const h=(0,D.readdirSync)(_).filter(S=>S.toLowerCase()===g);if(h.length===1){const S=P(_);if(S)return(0,I.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(g);if(S>=0){const v=P(_);if(v)return(0,I.join)(v,h[S])}}}catch(a){}return null}e.realcaseSync=P;async function y(k){try{return await(0,A.promisify)(b.realpath)(k)}catch(_){const g=T(k);return await b.promises.access(g,b.constants.R_OK),g}}e.realpath=y;function n(k){try{return b.realpathSync(k)}catch(_){const g=T(k);return b.accessSync(g,b.constants.R_OK),g}}e.realpathSync=n;function T(k){return(0,R.rtrim)((0,I.normalize)(k),I.sep)}});var _t=this&&this.__await||function(Z){return this instanceof _t?(this.v=Z,this):new _t(Z)},Tn=this&&this.__asyncGenerator||function(Z,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=b.apply(Z,e||[]),R,I=[];return R={},D("next"),D("throw"),D("return"),R[Symbol.asyncIterator]=function(){return this},R;function D(_){A[_]&&(R[_]=function(g){return new Promise(function(a,h){I.push([_,g,a,h])>1||P(_,g)})})}function P(_,g){try{y(A[_](g))}catch(a){k(I[0][3],a)}}function y(_){_.value instanceof _t?Promise.resolve(_.value.v).then(n,T):k(I[0][2],_)}function n(_){P("next",_)}function T(_){P("throw",_)}function k(_,g){_(g),I.shift(),I.length&&P(I[0][0],I[0][1])}},rn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],b;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),b={},A("next"),A("throw"),A("return"),b[Symbol.asyncIterator]=function(){return this},b);function A(I){b[I]=Z[I]&&function(D){return new Promise(function(P,y){D=Z[I](D),R(P,y,D.done,D.value)})}}function R(I,D,P,y){Promise.resolve(y).then(function(n){I({value:n,done:P})},D)}};define(ge[100],pe([0,1,26,48,8]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(y||(y={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class k{constructor(s,t,i){this.exePath=s,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function _({useAlternateBitness:u=!1}={}){return u?n===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:s=!1}={}){const t=_({useAlternateBitness:u});if(!t)return null;const i=R.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(i))return null;let o=-1,r=null;for(const p of await b.readdir(i)){let w=-1;if(s){const m=p.indexOf("-");if(m<0)continue;const C=p.substring(0,m);if(!I.test(C)||p.substring(m+1)!=="preview")continue;w=parseInt(C,10)}else{if(!I.test(p))continue;w=parseInt(p,10)}if(!(w<=o)){const d=R.join(i,p,"pwsh.exe");!await b.SymlinkSupport.existsFile(d)||(r=d,o=w)}}if(!r)return null;const l=t.includes("x86")?" (x86)":"",f=s?" Preview":"";return new k(r,`PowerShell${f}${l}`,!0)}async function a({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=u?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await b.readdir(s))if(t.test(o)){const r=R.join(s,o,"pwsh.exe");return new k(r,i)}return null}function h(){const u=R.join(A.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function S(){const u=R.join(process.env.windir,n===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}function v(){return Tn(this,arguments,function*(){let s=yield _t(g());s&&(yield yield _t(s)),s=yield _t(g({useAlternateBitness:!0})),s&&(yield yield _t(s)),s=yield _t(a()),s&&(yield yield _t(s)),s=h(),s&&(yield yield _t(s)),s=yield _t(g({findPreview:!0})),s&&(yield yield _t(s)),s=yield _t(a({findPreview:!0})),s&&(yield yield _t(s)),s=yield _t(g({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield _t(s)),s=S(),s&&(yield yield _t(s))})}function E(){return Tn(this,arguments,function*(){var s,t;try{for(var i=rn(v()),o;o=yield _t(i.next()),!o.done;){const r=o.value;(yield _t(r.exists()))&&(yield yield _t(r))}}catch(r){s={error:r}}finally{try{o&&!o.done&&(t=i.return)&&(yield _t(t.call(i)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=E;async function c(){var u,s;try{for(var t=rn(E()),i;i=await t.next(),!i.done;)return i.value}catch(o){u={error:o}}finally{try{i&&!i.done&&(s=t.return)&&await s.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(ge[101],pe([0,1,3,6,17,21,16,25,14,15,57,10]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var _;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(_=e.RequestType||(e.RequestType={}));function g(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function h(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class E{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var c;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(c||(c={}));function u(M){const N=P.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function s(M){return M.read(4).readUInt32BE(0)}function t(M){const N=P.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const i={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},o=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(i.Undefined);else if(typeof N=="string"){const O=P.VSBuffer.fromString(N);M.write(i.String),M.write(u(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(N)){const O=P.VSBuffer.wrap(N);M.write(i.Buffer),M.write(u(O.byteLength)),M.write(O)}else if(N instanceof P.VSBuffer)M.write(i.VSBuffer),M.write(u(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(i.Array),M.write(u(N.length));for(const O of N)r(M,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(N));M.write(i.Object),M.write(u(O.byteLength)),M.write(O)}}function l(M){switch(M.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return M.read(s(M)).toString();case c.Buffer:return M.read(s(M)).buffer;case c.VSBuffer:return M.read(s(M));case c.Array:{const O=s(M),V=[];for(let q=0;q<O;q++)V.push(l(M));return V}case c.Object:return JSON.parse(M.read(s(M)).toString())}}class f{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,h(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,h(N.type),N.data);return}}}send(N,O=void 0){const V=new E;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),V=l(O),q=l(O),X=V[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${g(X)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${g(X)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(ve){q=Promise.reject(ve)}const X=N.id;q.then(ve=>{this.sendResponse({id:X,data:ve,type:201}),this.activeRequests.delete(N.id)},ve=>{ve instanceof Error?this.sendResponse({id:X,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:X,data:ve,type:203}),this.activeRequests.delete(N.id)});const fe=(0,A.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,X=O.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:V,data:fe,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var p;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,X){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(N,V,q,X)},listen(V,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=I.CancellationToken.None){const X=this.lastRequestId++,ve={id:X,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Ae;return new Promise((Fe,z)=>{if(q.isCancellationRequested)return z(D.canceled());const J=()=>{const De=Me=>{switch(Me.type){case 201:this.handlers.delete(X),Fe(Me.data);break;case 202:this.handlers.delete(X);const we=new Error(Me.data.message);we.stack=Me.data.stack,we.name=Me.data.name,z(we);break;case 203:this.handlers.delete(X),z(Me.data);break}};this.handlers.set(X,De),this.sendRequest(ve)};let te=null;this.state===S.Idle?J():(te=(0,R.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,J()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:X,type:101}),z(D.canceled())},he=q.onCancellationRequested(ae);Ae=(0,A.combinedDisposable)((0,A.toDisposable)(ae),he),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,V){const q=this.lastRequestId++,fe={id:q,type:102,channelName:N,name:O,arg:V};let ve=null;const Ae=new b.Emitter({onFirstListenerAdd:()=>{ve=(0,R.createCancelablePromise)(Fe=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(Ae),this.sendRequest(fe)})},onLastListenerRemove:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Ie=Fe=>Ae.fire(Fe.data);return this.handlers.set(q,Ie),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${g(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,g(N.type));return}}}send(N,O=void 0){const V=new E;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),V=l(O),q=l(O),X=V[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,h(X)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,h(X),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():b.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=w;class d{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{b.Event.once(O.onMessage)(X=>{const fe=new v(X),ve=l(fe),Ae=new f(O,ve),Ie=new w(O);this.channels.forEach((z,J)=>Ae.registerChannel(J,z));const Fe={channelServer:Ae,channelClient:Ie,ctx:ve};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Ae.dispose(),Ie.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,X,fe){let ve;if((0,n.isFunction)(O)){let Ie=(0,y.getRandomElement)(V.connections.filter(O));ve=Ie?Promise.resolve(Ie):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,O))}else ve=O.routeCall(V,q,X);const Ae=ve.then(Ie=>Ie.channelClient.getChannel(N));return C(Ae).call(q,X,fe)},listen(q,X){if((0,n.isFunction)(O))return V.getMulticastEvent(N,O,q,X);const fe=O.routeEvent(V,q,X).then(ve=>ve.channelClient.getChannel(N));return C(fe).listen(q,X)}}}getMulticastEvent(N,O,V,q){const X=this;let fe=new A.DisposableStore;const ve=new b.Emitter({onFirstListenerAdd:()=>{fe=new A.DisposableStore;const Ae=new b.EventMultiplexer,Ie=new Map,Fe=J=>{const ae=J.channelClient.getChannel(N).listen(V,q),he=Ae.add(ae);Ie.set(J,he)},z=J=>{const te=Ie.get(J);!te||(te.dispose(),Ie.delete(J))};X.connections.filter(O).forEach(Fe),b.Event.filter(X.onDidAddConnection,O)(Fe,void 0,fe),X.onDidRemoveConnection(z,void 0,fe),Ae.event(ve.fire,ve,fe),fe.add(Ae)},onLastListenerRemove:()=>{fe.dispose()}});return ve.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class m{constructor(N,O,V=null){const q=new E;r(q,O),N.send(q.buffer),this.channelClient=new w(N,V),this.channelServer=new f(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=m;function C(M){return{call(N,O,V){return M.then(q=>q.call(N,O,V))},listen(N,O){const V=new b.Relay;return M.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=C;function L(M){let N=!1;return{call(O,V,q){return N?M.call(O,V,q):(0,R.timeout)(0).then(()=>N=!0).then(()=>M.call(O,V,q))},listen(O,V){if(N)return M.listen(O,V);const q=new b.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>q.input=M.listen(O,V)),q.event}}}e.getNextTickChannel=L;class B{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await b.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=B;var ee;(function(M){function N(q,X){const fe=q,ve=X&&X.disableMarshalling,Ae=new Map;for(const Ie in fe)V(Ie)&&Ae.set(Ie,b.Event.buffer(fe[Ie],!0));return new class{listen(Ie,Fe){const z=Ae.get(Fe);if(z)return z;throw new Error(`Event not found: ${Fe}`)}call(Ie,Fe,z){const J=fe[Fe];if(typeof J=="function"){if(!ve&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,T.revive)(z[te]);return J.apply(fe,z)}throw new Error(`Method not found: ${Fe}`)}}}M.fromService=N;function O(q,X){const fe=X&&X.disableMarshalling;return new Proxy({},{get(ve,Ae){var Ie;if(typeof Ae=="string")return((Ie=X==null?void 0:X.properties)===null||Ie===void 0?void 0:Ie.has(Ae))?X.properties.get(Ae):V(Ae)?q.listen(Ae):async function(...Fe){let z;X&&!(0,n.isUndefinedOrNull)(X.context)?z=[X.context,...Fe]:z=Fe;const J=await q.call(Ae,z);return fe?J:(0,T.revive)(J)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&k.isUpperAsciiLetter(q.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function W(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,V,q,X,fe){fe=W(fe);const ve=H[q],Ae=ve[V%ve.length];let Ie=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(X)?(Ie=Ie.concat(fe),Ie.push(")")):Ie.push(fe),console.log.apply(console,Ie)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,X){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,X)}logIncoming(N,O,V,q,X){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,V,q,X)}}e.IPCLogger=U}),define(ge[102],pe([0,1,3,101,6,25,9,30]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function n(){return y||(y=I.VSBuffer.alloc(0)),y}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const w=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),w}if(this._chunks[0].byteLength>o){const w=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),w}let l=I.VSBuffer.alloc(o),f=0,p=0;for(;o>0;){const w=this._chunks[p];if(w.byteLength>o){const d=w.slice(0,o);l.set(d,f),f+=o,r&&(this._chunks[p]=w.slice(o),this._totalLength-=o),o-=o}else l.set(w,f),f+=w.byteLength,r?(this._chunks.shift(),this._totalLength-=w.byteLength):p++,o-=w.byteLength}return l}}e.ChunkStream=T;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var _;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(_=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,r,l,f){this.type=o,this.id=r,this.ack=l,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends R.Disposable{constructor(o){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const l=this._state.messageType,f=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(l,f,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const l=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,l}_bufferTake(){const o=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends R.Disposable{constructor(o){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=S;class v extends A.IPCClient{constructor(o,r,l=null){super(o,r,l);this.protocol=o}static fromSocket(o,r){return new v(new S(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class c{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,l=this._first;for(;l;)o[r++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new c(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<s._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=s._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),r=(1+s._HISTORY_LENGTH)*1e3;let l=0;for(let f=0;f<s._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=r&&l++;return 1-l/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new g(4,0,0,n());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,l=o.length;r<l;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let l=0,f=r.length;l<f;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new g(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const r=new g(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[103],pe([0,1,92]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){let y=(0,b.toUint8)(P);this._defaultValue=y,this._asciiMap=A._createAsciiMap(y),this._map=new Map}static _createAsciiMap(P){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=P;return y}set(P,y){let n=(0,b.toUint8)(y);P>=0&&P<256?this._asciiMap[P]=n:this._map.set(P,n)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=A;var R;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(R||(R={}));class I{constructor(){this._actual=new A(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=I}),define(ge[137],pe([0,1,103]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends b.CharacterClassifier{constructor(P){super(0);for(let y=0,n=P.length;y<n;y++)this.set(P.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function I(D){let P={};return y=>(P.hasOwnProperty(y)||(P[y]=D(y)),P[y])}e.getMapForWordSeparators=I(D=>new R(D))}),define(ge[49],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(R,I){this.lineNumber=R,this.column=I}with(R=this.lineNumber,I=this.column){return R===this.lineNumber&&I===this.column?this:new b(R,I)}delta(R=0,I=0){return this.with(this.lineNumber+R,this.column+I)}equals(R){return b.equals(this,R)}static equals(R,I){return!R&&!I?!0:!!R&&!!I&&R.lineNumber===I.lineNumber&&R.column===I.column}isBefore(R){return b.isBefore(this,R)}static isBefore(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<I.column}isBeforeOrEqual(R){return b.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<=I.column}static compare(R,I){let D=R.lineNumber|0,P=I.lineNumber|0;if(D===P){let y=R.column|0,n=I.column|0;return y-n}return D-P}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new b(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=b}),define(ge[43],pe([0,1,49]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(I,D,P,y){I>P||I===P&&D>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return A.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return A.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}containsRange(I){return A.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return A.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return A.plusRange(this,I)}static plusRange(I,D){let P,y,n,T;return D.startLineNumber<I.startLineNumber?(P=D.startLineNumber,y=D.startColumn):D.startLineNumber===I.startLineNumber?(P=D.startLineNumber,y=Math.min(D.startColumn,I.startColumn)):(P=I.startLineNumber,y=I.startColumn),D.endLineNumber>I.endLineNumber?(n=D.endLineNumber,T=D.endColumn):D.endLineNumber===I.endLineNumber?(n=D.endLineNumber,T=Math.max(D.endColumn,I.endColumn)):(n=I.endLineNumber,T=I.endColumn),new A(P,y,n,T)}intersectRanges(I){return A.intersectRanges(this,I)}static intersectRanges(I,D){let P=I.startLineNumber,y=I.startColumn,n=I.endLineNumber,T=I.endColumn,k=D.startLineNumber,_=D.startColumn,g=D.endLineNumber,a=D.endColumn;return P<k?(P=k,y=_):P===k&&(y=Math.max(y,_)),n>g?(n=g,T=a):n===g&&(T=Math.min(T,a)),P>n||P===n&&y>T?null:new A(P,y,n,T)}equalsRange(I){return A.equalsRange(this,I)}static equalsRange(I,D){return!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(I){return new b.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(I){return new b.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new A(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new A(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(I){return new A(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,D=I){return new A(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new A(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const n=I.startLineNumber|0,T=D.startLineNumber|0;if(n===T){const k=I.startColumn|0,_=D.startColumn|0;if(k===_){const g=I.endLineNumber|0,a=D.endLineNumber|0;if(g===a){const h=I.endColumn|0,S=D.endColumn|0;return h-S}return g-a}return k-_}return n-T}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=A}),define(ge[138],pe([0,1,49,43]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class I extends A.Range{constructor(P,y,n,T){super(P,y,n,T);this.selectionStartLineNumber=P,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return I.selectionsEqual(this,P)}static selectionsEqual(P,y){return P.selectionStartLineNumber===y.selectionStartLineNumber&&P.selectionStartColumn===y.selectionStartColumn&&P.positionLineNumber===y.positionLineNumber&&P.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,y){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,P,y):new I(P,y,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,y){return this.getDirection()===0?new I(P,y,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,P,y)}static fromPositions(P,y=P){return new I(P.lineNumber,P.column,y.lineNumber,y.column)}static liftSelection(P){return new I(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,y){if(P&&!y||!P&&y)return!1;if(!P&&!y)return!0;if(P.length!==y.length)return!1;for(let n=0,T=P.length;n<T;n++)if(!this.selectionsEqual(P[n],y[n]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,y,n,T,k){return k===0?new I(P,y,n,T):new I(n,T,P,y)}}e.Selection=I}),define(ge[104],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var A;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(A=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class y{constructor(a,h){this.range=a,this.matches=h}}e.FindMatch=y;var n;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(a,h,S,v,E,c){this.identifier=a,this.range=h,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=E,this._isTracked=c}}e.ValidAnnotatedEditOperation=k;class _{constructor(a,h,S){this.reverseEdits=a,this.changes=h,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=_}),define(ge[139],pe([0,1,10,137,49,43,104]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class y{constructor(c,u,s,t){this.searchString=c,this.isRegex=u,this.matchCase=s,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=n(this.searchString):c=this.searchString.indexOf(`
`)>=0;let u=null;try{u=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let s=!this.isRegex&&!c;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new T(u,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}e.SearchParams=y;function n(E){if(!E||E.length===0)return!1;for(let c=0,u=E.length;c<u;c++)if(E.charCodeAt(c)===92){if(c++,c>=u)break;const t=E.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(c,u,s){this.regex=c,this.wordSeparators=u,this.simpleSearch=s}}e.SearchData=T;function k(E,c,u){if(!u)return new D.FindMatch(E,null);let s=[];for(let t=0,i=c.length;t<i;t++)s[t]=c[t];return new D.FindMatch(E,s)}e.createFindMatch=k;class _{constructor(c){let u=[],s=0;for(let t=0,i=c.length;t<i;t++)c.charCodeAt(t)===10&&(u[s++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(c){const u=this._lineFeedsOffsets;let s=0,t=u.length-1;if(t===-1||c<=u[0])return 0;for(;s<t;){const i=s+((t-s)/2>>0);u[i]>=c?t=i-1:u[i+1]>=c?(s=i,t=i):s=i+1}return s+1}}class g{static findMatches(c,u,s,t,i){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,s,new v(o.wordSeparators,o.regex),t,i):this._doFindMatchesLineByLine(c,s,o,t,i):[]}static _getMultilineMatchRange(c,u,s,t,i,o){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),r=u+i+l):r=u+i;let f;if(t){let m=t.findLineFeedCountBeforeOffset(i+o.length)-l;f=r+o.length+m}else f=r+o.length;const p=c.getPositionAt(r),w=c.getPositionAt(f);return new I.Range(p.lineNumber,p.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(c,u,s,t,i){const o=c.getOffsetAt(u.getStartPosition()),r=c.getValueInRange(u,1),l=c.getEOL()===`\r
`?new _(r):null,f=[];let p=0,w;for(s.reset(0);w=s.next(r);)if(f[p++]=k(this._getMultilineMatchRange(c,o,r,l,w.index,w[0]),w,t),p>=i)return f;return f}static _doFindMatchesLineByLine(c,u,s,t,i){const o=[];let r=0;if(u.startLineNumber===u.endLineNumber){const f=c.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(s,f,u.startLineNumber,u.startColumn-1,r,o,t,i),o}const l=c.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(s,l,u.startLineNumber,u.startColumn-1,r,o,t,i);for(let f=u.startLineNumber+1;f<u.endLineNumber&&r<i;f++)r=this._findMatchesInLine(s,c.getLineContent(f),f,0,r,o,t,i);if(r<i){const f=c.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(s,f,u.endLineNumber,0,r,o,t,i)}return o}static _findMatchesInLine(c,u,s,t,i,o,r,l){const f=c.wordSeparators;if(!r&&c.simpleSearch){const d=c.simpleSearch,m=d.length,C=u.length;let L=-m;for(;(L=u.indexOf(d,L+m))!==-1;)if((!f||S(f,u,C,L,m))&&(o[i++]=new D.FindMatch(new I.Range(s,L+1+t,s,L+1+m+t),null),i>=l))return i;return i}const p=new v(c.wordSeparators,c.regex);let w;p.reset(0);do if(w=p.next(u),w&&(o[i++]=k(new I.Range(s,w.index+1+t,s,w.index+1+w[0].length+t),w,r),i>=l))return i;while(w);return i}static findNextMatch(c,u,s,t){const i=u.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(c,s,o,t):this._doFindNextMatchLineByLine(c,s,o,t)}static _doFindNextMatchMultiline(c,u,s,t){const i=new R.Position(u.lineNumber,1),o=c.getOffsetAt(i),r=c.getLineCount(),l=c.getValueInRange(new I.Range(i.lineNumber,i.column,r,c.getLineMaxColumn(r)),1),f=c.getEOL()===`\r
`?new _(l):null;s.reset(u.column-1);let p=s.next(l);return p?k(this._getMultilineMatchRange(c,o,l,f,p.index,p[0]),p,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(c,new R.Position(1,1),s,t):null}static _doFindNextMatchLineByLine(c,u,s,t){const i=c.getLineCount(),o=u.lineNumber,r=c.getLineContent(o),l=this._findFirstMatchInLine(s,r,o,u.column,t);if(l)return l;for(let f=1;f<=i;f++){const p=(o+f-1)%i,w=c.getLineContent(p+1),d=this._findFirstMatchInLine(s,w,p+1,1,t);if(d)return d}return null}static _findFirstMatchInLine(c,u,s,t,i){c.reset(t-1);const o=c.next(u);return o?k(new I.Range(s,o.index+1,s,o.index+1+o[0].length),o,i):null}static findPreviousMatch(c,u,s,t){const i=u.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(c,s,o,t):this._doFindPreviousMatchLineByLine(c,s,o,t)}static _doFindPreviousMatchMultiline(c,u,s,t){const i=this._doFindMatchesMultiline(c,new I.Range(1,1,u.lineNumber,u.column),s,t,10*P);if(i.length>0)return i[i.length-1];const o=c.getLineCount();return u.lineNumber!==o||u.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new R.Position(o,c.getLineMaxColumn(o)),s,t):null}static _doFindPreviousMatchLineByLine(c,u,s,t){const i=c.getLineCount(),o=u.lineNumber,r=c.getLineContent(o).substring(0,u.column-1),l=this._findLastMatchInLine(s,r,o,t);if(l)return l;for(let f=1;f<=i;f++){const p=(i+o-f-1)%i,w=c.getLineContent(p+1),d=this._findLastMatchInLine(s,w,p+1,t);if(d)return d}return null}static _findLastMatchInLine(c,u,s,t){let i=null,o;for(c.reset(0);o=c.next(u);)i=k(new I.Range(s,o.index+1,s,o.index+1+o[0].length),o,t);return i}}e.TextModelSearch=g;function a(E,c,u,s,t){if(s===0)return!0;const i=c.charCodeAt(s-1);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=c.charCodeAt(s);if(E.get(o)!==0)return!0}return!1}function h(E,c,u,s,t){if(s+t===u)return!0;const i=c.charCodeAt(s+t);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=c.charCodeAt(s+t-1);if(E.get(o)!==0)return!0}return!1}function S(E,c,u,s,t){return a(E,c,u,s,t)&&h(E,c,u,s,t)}e.isValidMatch=S;class v{constructor(c,u){this._wordSeparators=c,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const u=c.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(s=this._searchRegex.exec(c),!s))return null;const t=s.index,i=s[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){b.getNextCodePoint(c,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,c,u,t,i))return s}while(s);return null}}e.Searcher=v}),define(ge[105],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(P=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)P.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=b();function A(P){let y=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)y=P;else{let n="g";P.ignoreCase&&(n+="i"),P.multiline&&(n+="m"),P.unicode&&(n+="u"),y=new RegExp(P.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=A;const R={maxLen:1e3,windowSize:15,timeBudget:150};function I(P,y,n,T,k=R){if(n.length>k.maxLen){let S=P-k.maxLen/2;return S<0?S=0:T+=S,n=n.substring(S,P+k.maxLen/2),I(P,y,n,T,k)}const _=Date.now(),g=P-1-T;let a=-1,h=null;for(let S=1;!(Date.now()-_>=k.timeBudget);S++){const v=g-k.windowSize*S;y.lastIndex=Math.max(0,v);const E=D(y,n,g,a);if(!E&&h||(h=E,v<=0))break;a=v}if(h){let S={word:h[0],startColumn:T+1+h.index,endColumn:T+1+h.index+h[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=I;function D(P,y,n,T){let k;for(;k=P.exec(y);){const _=k.index||0;if(_<=n&&P.lastIndex>=n)return k;if(T>0&&_>T)return null}return null}}),define(ge[140],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let y=0,n=P.notIn.length;y<n;y++)switch(P.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=A;class R{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of P)I(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),I(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),I(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),I(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&I(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=R;function I(D,P,y){D.has(P)?D.get(P).push(y):D.set(P,[y])}}),define(ge[76],pe([0,1,34,8]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(I,D,P,y){if(Array.isArray(I)){let n=0;for(const T of I){const k=R(T,D,P,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof I=="string")return y?I==="*"?5:I===P?10:0:0;if(I){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:_}=I;if(!y&&!_)return 0;let g=0;if(k)if(k===D.scheme)g=10;else if(k==="*")g=5;else return 0;if(n)if(n===P)g=10;else if(n==="*")g=Math.max(g,5);else return 0;if(T){let a;if(typeof T=="string"?a=T:a=Object.assign(Object.assign({},T),{base:(0,A.normalize)(T.base)}),a===D.fsPath||(0,b.match)(a,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=R}),define(ge[141],pe([0,1,103]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var A;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class R{constructor(a,h,S){const v=new Uint8Array(a*h);for(let E=0,c=a*h;E<c;E++)v[E]=S;this._data=v,this.rows=a,this.cols=h}get(a,h){return this._data[a*this.cols+h]}set(a,h,S){this._data[a*this.cols+h]=S}}e.Uint8Matrix=R;class I{constructor(a){let h=0,S=0;for(let E=0,c=a.length;E<c;E++){let[u,s,t]=a[E];s>h&&(h=s),u>S&&(S=u),t>S&&(S=t)}h++,S++;let v=new R(S,h,0);for(let E=0,c=a.length;E<c;E++){let[u,s,t]=a[E];v.set(u,s,t)}this._states=v,this._maxCharCode=h}nextState(a,h){return h<0||h>=this._maxCharCode?0:this._states.get(a,h)}}e.StateMachine=I;let D=null;function P(){return D===null&&(D=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new b.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<g.length;h++)n.set(g.charCodeAt(h),1);const a=".,;";for(let h=0;h<a.length;h++)n.set(a.charCodeAt(h),2)}return n}class k{static _createLink(a,h,S,v,E){let c=E-1;do{const u=h.charCodeAt(c);if(a.get(u)!==2)break;c--}while(c>v);if(v>0){const u=h.charCodeAt(v-1),s=h.charCodeAt(c);(u===40&&s===41||u===91&&s===93||u===123&&s===125)&&c--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:c+2},url:h.substring(v,c+1)}}static computeLinks(a,h=P()){const S=T();let v=[];for(let E=1,c=a.getLineCount();E<=c;E++){const u=a.getLineContent(E),s=u.length;let t=0,i=0,o=0,r=1,l=!1,f=!1,p=!1,w=!1;for(;t<s;){let d=!1;const m=u.charCodeAt(t);if(r===13){let C;switch(m){case 40:l=!0,C=0;break;case 41:C=l?0:1;break;case 91:p=!0,f=!0,C=0;break;case 93:p=!1,C=f?0:1;break;case 123:w=!0,C=0;break;case 125:C=w?0:1;break;case 39:C=o===34||o===96?0:1;break;case 34:C=o===39||o===96?0:1;break;case 96:C=o===39||o===34?0:1;break;case 42:C=o===42?1:0;break;case 124:C=o===124?1:0;break;case 32:C=p?0:1;break;default:C=S.get(m)}C===1&&(v.push(k._createLink(S,u,E,i,t)),d=!0)}else if(r===12){let C;m===91?(f=!0,C=0):C=S.get(m),C===1?d=!0:r=13}else r=h.nextState(r,m),r===0&&(d=!0);d&&(r=1,l=!1,f=!1,w=!1,i=t+1,o=m),t++}r===13&&v.push(k._createLink(S,u,E,i,s))}return v}}e.LinkComputer=k;function _(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:k.computeLinks(g)}e.computeLinks=_}),define(ge[142],pe([0,1,3,6]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,P){return this._map.set(D,P),this.fire([D]),(0,A.toDisposable)(()=>{this._map.get(D)===P&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,P){let y=null,n=!1;return this._promises.set(D,P.then(T=>{this._promises.delete(D),!(n||!T)&&(y=this.register(D,T))})),(0,A.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(D){const P=this.get(D);if(P)return Promise.resolve(P);const y=this._promises.get(D);return y?y.then(n=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(ge[106],pe([0,1,25,9]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function I(k){for(let _=0,g=k.length;_<g;_+=4){const a=k[_+0],h=k[_+1],S=k[_+2],v=k[_+3];k[_+0]=v,k[_+1]=S,k[_+2]=h,k[_+3]=a}}function D(k){const _=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||I(_),b.VSBuffer.wrap(_)}function P(k){const _=k.buffer;if(A.isLittleEndian()||I(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const g=new Uint8Array(_.byteLength);return g.set(_),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(k){const _=new Uint32Array(n(k));let g=0;if(_[g++]=k.id,k.type==="full")_[g++]=1,_[g++]=k.data.length,_.set(k.data,g),g+=k.data.length;else{_[g++]=2,_[g++]=k.deltas.length;for(const a of k.deltas)_[g++]=a.start,_[g++]=a.deleteCount,a.data?(_[g++]=a.data.length,_.set(a.data,g),g+=a.data.length):_[g++]=0}return D(_)}e.encodeSemanticTokensDto=y;function n(k){let _=0;if(_+=1+1,k.type==="full")_+=1+k.data.length;else{_+=1,_+=(1+1+1)*k.deltas.length;for(const g of k.deltas)g.data&&(_+=g.data.length)}return _}function T(k){const _=P(k);let g=0;const a=_[g++];if(_[g++]===1){const E=_[g++],c=_.subarray(g,g+E);return g+=E,{id:a,type:"full",data:c}}const S=_[g++];let v=[];for(let E=0;E<S;E++){const c=_[g++],u=_[g++],s=_[g++];let t;s>0&&(t=_.subarray(g,g+s),g+=s),v[E]={start:c,deleteCount:u,data:t}}return{id:a,type:"delta",deltas:v}}e.decodeSemanticTokensDto=T}),define(ge[107],pe([0,1,92]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class A{constructor(D,P){this.index=D,this.remainder=P}}e.PrefixSumIndexOfResult=A;class R{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,P){D=(0,b.toUint32)(D);const y=this.values,n=this.prefixSum,T=P.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+T),this.values.set(P,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,P){return D=(0,b.toUint32)(D),P=(0,b.toUint32)(P),this.values[D]===P?!1:(this.values[D]=P,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,P){D=(0,b.toUint32)(D),P=(0,b.toUint32)(P);const y=this.values,n=this.prefixSum;if(D>=y.length)return!1;let T=y.length-D;return P>=T&&(P=T),P===0?!1:(this.values=new Uint32Array(y.length-P),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+P),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,b.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),D>=this.values.length&&(D=this.values.length-1);for(let y=P;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let P=0,y=this.values.length-1,n=0,T=0,k=0;for(;P<=y;)if(n=P+(y-P)/2|0,T=this.prefixSum[n],k=T-this.values[n],D<k)y=n-1;else if(D>=T)P=n+1;else break;return new A(n,D-k)}}e.PrefixSumComputer=R}),define(ge[143],pe([0,1,10,49,107]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(P,y,n,T){this._uri=P,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const y=P.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new A.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+P;this._lineStarts=new R.PrefixSumComputer(n)}}_setLineText(P,y){this._lines[P]=y,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,y){if(y.length!==0){let n=(0,b.splitLines)(y);if(n.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+n[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}n[n.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(P.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,T)}}}e.MirrorTextModel=I}),define(ge[144],pe([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ge[145],pe([0,1,144]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,R=A*60,I=R*24,D=I*7,P=I*30,y=I*365;function n(k,_){typeof k!="number"&&(k=k.getTime());const g=Math.round((new Date().getTime()-k)/1e3);if(g<-30)return(0,b.localize)(0,null,n(new Date().getTime()+g*1e3,!1));if(g<30)return(0,b.localize)(1,null);let a;return g<A?(a=g,_?a===1?(0,b.localize)(2,null,a):(0,b.localize)(3,null,a):a===1?(0,b.localize)(4,null,a):(0,b.localize)(5,null,a)):g<R?(a=Math.floor(g/A),_?a===1?(0,b.localize)(6,null,a):(0,b.localize)(7,null,a):a===1?(0,b.localize)(8,null,a):(0,b.localize)(9,null,a)):g<I?(a=Math.floor(g/R),_?a===1?(0,b.localize)(10,null,a):(0,b.localize)(11,null,a):a===1?(0,b.localize)(12,null,a):(0,b.localize)(13,null,a)):g<D?(a=Math.floor(g/I),_?a===1?(0,b.localize)(14,null,a):(0,b.localize)(15,null,a):a===1?(0,b.localize)(16,null,a):(0,b.localize)(17,null,a)):g<P?(a=Math.floor(g/D),_?a===1?(0,b.localize)(18,null,a):(0,b.localize)(19,null,a):a===1?(0,b.localize)(20,null,a):(0,b.localize)(21,null,a)):g<y?(a=Math.floor(g/P),_?a===1?(0,b.localize)(22,null,a):(0,b.localize)(23,null,a):a===1?(0,b.localize)(24,null,a):(0,b.localize)(25,null,a)):(a=Math.floor(g/y),_?a===1?(0,b.localize)(26,null,a):(0,b.localize)(27,null,a):a===1?(0,b.localize)(28,null,a):(0,b.localize)(29,null,a))}e.fromNow=n;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ge[146],pe([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ge[58],pe([0,1,146,15,14]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(n,T){return T&&(n.stack||n.stacktrace)?b.localize(0,null,P(n),D(n.stack)||D(n.stacktrace)):P(n)}function D(n){return Array.isArray(n)?n.join(`
`):n}function P(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?b.localize(1,null,n.message):n.message||b.localize(2,null)}function y(n=null,T=!1){if(!n)return b.localize(3,null);if(Array.isArray(n)){const k=R.coalesce(n),_=y(k[0],T);return k.length>1?b.localize(4,null,_,k.length):_}if(A.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return I(k.error,T);if(k.exception)return I(k.exception,T)}return n.stack?I(n,T):n.message?n.message:b.localize(5,null)}e.toErrorMessage=y}),define(ge[147],pe([18,19]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(ge[77],pe([0,1,8,37,26,38,147,30,15,22,31,9,136,11]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,t){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const o=I.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{o.once("error",l=>{r({success:!1,error:l})}),o.once("exit",(l,f)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(o=>{I.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,l,f)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function S(s=P.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,i,o,r){if(i!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=o,this.options=r;else{const l=t;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(P.env).forEach(f=>{l[f]=P.env[f]}),Object.keys(this.options.env).forEach(f=>{l[f]=this.options.env[f]}),this.options.env=l}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(b.sep);return i!==-1&&(t=t.substring(i+1)),v.WellKnowCommands[t]?t:"other"}start(t){return k.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(P.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(i=>{let o,r;const l=new Promise((f,p)=>{o=f,r=p});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=I.exec(f,this.options,(p,w,d)=>{this.childProcess=null;const m=p;m&&m.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:d.toString()}):this.handleExec(o,t,p,w,d)})}else{let f=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,o,t,r);const d={terminated:this.terminateRequested};y.isNumber(w)&&(d.cmdCode=w),o(d)};if(this.shell&&k.isWindows){const w=n.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let d=!1,m=!1;const C=[];let L=this.ensureQuotes(this.cmd);C.push(L.value),d=L.quoted,this.args&&this.args.forEach(ee=>{L=this.ensureQuotes(ee),C.push(L.value),m=m&&L.quoted});const B=["/s","/c"];d?m?B.push('"'+C.join(" ")+'"'):C.length>1?B.push('"'+C[0]+'" '+C.slice(1).join(" ")):B.push('"'+C[0]+'"'):B.push(C.join(" ")),f=I.spawn(S(),B,w)}else this.cmd&&(f=I.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(y.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),f.pid&&(this.childProcess.on("close",p),this.handleSpawn(f,o,t,r,!0)))}return l})}handleClose(t,i,o,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,h(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!k.isWindows)return t(!1);const i=I.spawn(S(),["/s","/c"]);i.on("error",o=>t(!0)),i.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class E extends v{constructor(t,i,o,r){super(t,i,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,o,r,l){[r,l].forEach((f,p)=>{const w=new _.LineDecoder;w.write(f).forEach(C=>{i({line:C,source:p===0?0:1})});const m=w.end();m&&i({line:m,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,i,o,r,l){const f=new _.LineDecoder,p=new _.LineDecoder;t.stdout.on("data",w=>{f.write(w).forEach(m=>o({line:m,source:0}))}),t.stderr.on("data",w=>{p.write(w).forEach(m=>o({line:m,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=p}handleClose(t,i,o,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&o({line:l,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&o({line:f,source:1})}}e.LineProcess=E;function c(s){let t=[],i=!1;const o=function(r){if(i){t.push(r);return}(!s.send(r,f=>{if(f&&console.error(f),i=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(w=>o(w))}})||k.isWindows)&&(i=!0)};return{send:o}}e.createQueuedSender=c;var u;(function(s){async function t(i,o,r){if(b.isAbsolute(i))return i;if(o===void 0&&(o=P.cwd()),b.dirname(i)!=="."||(r===void 0&&y.isString(P.env.PATH)&&(r=P.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(o,i);async function f(p){return await R.exists(p)?!(await A.promises.stat(p)).isDirectory():!1}for(let p of r){let w;if(b.isAbsolute(p)?w=b.join(p,i):w=b.join(o,p,i),await f(w))return w;let d=w+".com";if(await f(d)||(d=w+".exe",await f(d)))return d}return b.join(o,i)}s.findExecutable=t})(u=e.win32||(e.win32={}))}),define(ge[148],pe([0,1,48,9,100,77]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,a){return g===3?A.isWindows?k():I.getWindowsShell(a):n(g,a)}e.getSystemShell=D;function P(g,a){return g===3?A.isWindows?_(a):I.getWindowsShell(a):n(g,a)}e.getSystemShellSync=P;let y=null;function n(g,a){if(A.isLinux&&g===1||A.isMacintosh&&g===2)return"/bin/bash";if(!y){let h;if(A.isWindows)h="/bin/bash";else{if(h=a.SHELL,!h)try{h=b.userInfo().shell}catch(S){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}y=h}return y}let T=null;async function k(){return T||(T=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),T}function _(g){if(T)return T;const a=A.isWindows&&parseFloat(b.release())>=10,h=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:I.getWindowsShell(g)}}),define(ge[149],pe([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,9,105]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=D;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,be){this._values[ie]=be}}e.ValidatedEditorOptions=P;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(ie,be,Oe,Ve){this.id=ie,this.name=be,this.defaultValue=Oe,this.schema=Ve}compute(ie,be,Oe){return Oe}}class T{constructor(ie,be=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=be}validate(ie){return this.defaultValue}}class k{constructor(ie,be,Oe,Ve){this.id=ie,this.name=be,this.defaultValue=Oe,this.schema=Ve}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,be,Oe){return Oe}}function _(Q,ie){return typeof Q=="undefined"?ie:Q==="false"?!1:Boolean(Q)}e.boolean=_;class g extends k{constructor(ie,be,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Oe),super(ie,be,Oe,Ve)}validate(ie){return _(ie,this.defaultValue)}}class a extends k{constructor(ie,be,Oe,Ve,We,tt=void 0){typeof tt!="undefined"&&(tt.type="integer",tt.default=Oe,tt.minimum=Ve,tt.maximum=We),super(ie,be,Oe,tt),this.minimum=Ve,this.maximum=We}static clampedInt(ie,be,Oe,Ve){if(typeof ie=="undefined")return be;let We=parseInt(ie,10);return isNaN(We)?be:(We=Math.max(Oe,We),We=Math.min(Ve,We),We|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class h extends k{constructor(ie,be,Oe,Ve,We){typeof We!="undefined"&&(We.type="number",We.default=Oe),super(ie,be,Oe,We),this.validationFn=Ve}static clamp(ie,be,Oe){return ie<be?be:ie>Oe?Oe:ie}static float(ie,be){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return be;const Oe=parseFloat(ie);return isNaN(Oe)?be:Oe}validate(ie){return this.validationFn(h.float(ie,this.defaultValue))}}class S extends k{static string(ie,be){return typeof ie!="string"?be:ie}constructor(ie,be,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Oe),super(ie,be,Oe,Ve)}validate(ie){return S.string(ie,this.defaultValue)}}function v(Q,ie,be){return typeof Q!="string"||be.indexOf(Q)===-1?ie:Q}e.stringSet=v;class E extends k{constructor(ie,be,Oe,Ve,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Ve,We.default=Oe),super(ie,be,Oe,We),this._allowedValues=Ve}validate(ie){return v(ie,this.defaultValue,this._allowedValues)}}class c extends n{constructor(ie,be,Oe,Ve,We,tt,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=We,K.default=Ve),super(ie,be,Oe,K),this._allowedValues=We,this._convert=tt}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,be,Oe){return Oe===0?ie.accessibilitySupport:Oe}}class t extends n{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{insertSpace:_(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:_(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(Q){switch(Q){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function f(Q){switch(Q){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends T{constructor(){super(123,[62,31])}compute(ie,be,Oe){const Ve=["monaco-editor"];return be.get(31)&&Ve.push(be.get(31)),ie.extraEditorClassName&&Ve.push(ie.extraEditorClassName),be.get(62)==="default"?Ve.push("mouse-default"):be.get(62)==="copy"&&Ve.push("mouse-copy"),be.get(97)&&Ve.push("showUnused"),be.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class w extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ie,be,Oe){return Oe&&ie.emptySelectionClipboard}}class d extends n{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:b.localize(13,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:b.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{cursorMoveOnType:_(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:_(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":v(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:_(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:_(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:_(be.loop,this.defaultValue.loop)}}}class m extends n{constructor(){super(41,"fontLigatures",m.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?m.OFF:ie==="true"?m.ON:ie:Boolean(ie)?m.ON:m.OFF}}e.EditorFontLigatures=m,m.OFF='"liga" off, "calt" off',m.ON='"liga" on, "calt" on';class C extends T{constructor(){super(40)}compute(ie,be,Oe){return ie.fontInfo}}class L extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ie){let be=h.float(ie,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(be,6,100)}compute(ie,be,Oe){return ie.fontInfo.fontSize}}class B extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class ee extends n{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]};super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},be),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},be),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},be),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},be),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},be),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:b.localize(35,null)}})}validate(ie){var be,Oe,Ve,We,tt;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(be=K.multipleDefinitions)!==null&&be!==void 0?be:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Oe=K.multipleTypeDefinitions)!==null&&Oe!==void 0?Oe:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=K.multipleDeclarations)!==null&&Ve!==void 0?Ve:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=K.multipleImplementations)!==null&&We!==void 0?We:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(tt=K.multipleReferences)!==null&&tt!==void 0?tt:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:b.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:_(be.enabled,this.defaultValue.enabled),delay:a.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:_(be.sticky,this.defaultValue.sticky)}}}var x;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class W extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,be,Oe){return W.computeLayout(be,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const be=ie.height/ie.lineHeight,Oe=ie.scrollBeyondLastLine?be-1:0,Ve=(ie.viewLineCount+Oe)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/Ve);return{typicalViewportLineCount:be,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:We}}static _computeMinimapLayout(ie,be){const Oe=ie.outerWidth,Ve=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const tt=be.stableMinimapLayoutInput,K=tt&&ie.outerHeight===tt.outerHeight&&ie.lineHeight===tt.lineHeight&&ie.typicalHalfwidthCharacterWidth===tt.typicalHalfwidthCharacterWidth&&ie.pixelRatio===tt.pixelRatio&&ie.scrollBeyondLastLine===tt.scrollBeyondLastLine&&ie.minimap.enabled===tt.minimap.enabled&&ie.minimap.side===tt.minimap.side&&ie.minimap.size===tt.minimap.size&&ie.minimap.showSlider===tt.minimap.showSlider&&ie.minimap.renderCharacters===tt.minimap.renderCharacters&&ie.minimap.maxColumn===tt.minimap.maxColumn&&ie.minimap.scale===tt.minimap.scale&&ie.verticalScrollbarWidth===tt.verticalScrollbarWidth&&ie.isViewportWrapping===tt.isViewportWrapping,se=ie.lineHeight,de=ie.typicalHalfwidthCharacterWidth,Y=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let le=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const me=ie.minimap.maxColumn,_e=ie.minimap.size,He=ie.minimap.side,$e=ie.verticalScrollbarWidth,Ke=ie.viewLineCount,Je=ie.remainingWidth,Ze=ie.isViewportWrapping,ut=ne?2:3;let lt=Math.floor(We*Ve);const it=lt/We;let qe=!1,Ee=!1,Ce=ut*le,ce=le/We,G=1;if(_e==="fill"||_e==="fit"){const{typicalViewportLineCount:Ye,extraLinesBeyondLastLine:st,desiredRatio:vt,minimapLineCount:mt}=W.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Y,height:Ve,lineHeight:se,pixelRatio:We});if(Ke/mt>1)qe=!0,Ee=!0,le=1,Ce=1,ce=le/We;else{let wt=!1,St=le+1;if(_e==="fit"){const pt=Math.ceil((Ke+st)*Ce);Ze&&K&&Je<=be.stableFitRemainingWidth?(wt=!0,St=be.stableFitMaxMinimapScale):(wt=pt>lt,Ze&&wt?(be.stableMinimapLayoutInput=ie,be.stableFitRemainingWidth=Je):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0))}if(_e==="fill"||wt){qe=!0;const pt=le;Ce=Math.min(se*We,Math.max(1,Math.floor(1/vt))),le=Math.min(St,Math.max(1,Math.floor(Ce/ut))),le>pt&&(G=Math.min(2,le/pt)),ce=le/We/G,lt=Math.ceil(Math.max(Ye,Ke+st)*Ce),Ze&&wt&&(be.stableFitMaxMinimapScale=le)}}}const Ne=Math.floor(me*ce),Re=Math.min(Ne,Math.max(0,Math.floor((Je-$e-2)*ce/(de+ce)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(We*Re);const Qe=et/We;et=Math.floor(et*G);const at=ne?1:2,rt=He==="left"?0:Oe-Re-$e;return{renderMinimap:at,minimapLeft:rt,minimapWidth:Re,minimapHeightIsEditorHeight:qe,minimapIsSampling:Ee,minimapScale:le,minimapLineHeight:Ce,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:it}}static computeLayout(ie,be){const Oe=be.outerWidth|0,Ve=be.outerHeight|0,We=be.lineHeight|0,tt=be.lineNumbersDigitCount|0,K=be.typicalHalfwidthCharacterWidth,se=be.maxDigitWidth,de=be.pixelRatio,Y=be.viewLineCount,ne=ie.get(118),le=ne==="inherit"?ie.get(117):ne,me=le==="inherit"?ie.get(113):le,_e=ie.get(116),He=ie.get(2),$e=be.isDominatedByLongLines,Ke=ie.get(46),Je=ie.get(56).renderType!==0,Ze=ie.get(57),ut=ie.get(91),lt=ie.get(61),it=ie.get(89),qe=it.verticalScrollbarSize,Ee=it.verticalHasArrows,Ce=it.arrowSize,ce=it.horizontalScrollbarSize,G=ie.get(54),Ne=ie.get(35);let Re;if(typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)){const ft=parseFloat(G.substr(0,G.length-2));Re=a.clampedInt(ft*K,0,0,1e3)}else Re=a.clampedInt(G,0,0,1e3);Ne&&(Re+=16);let et=0;if(Je){const ft=Math.max(tt,Ze);et=Math.round(ft*se)}let Qe=0;Ke&&(Qe=We);let at=0,rt=at+Qe,Ye=rt+et,st=Ye+Re;const vt=Oe-Qe-et-Re;let mt=!1,Ct=!1,wt=-1;He!==2&&(le==="inherit"&&$e?(mt=!0,Ct=!0):me==="on"||me==="bounded"?Ct=!0:me==="wordWrapColumn"&&(wt=_e));const St=W._computeMinimapLayout({outerWidth:Oe,outerHeight:Ve,lineHeight:We,typicalHalfwidthCharacterWidth:K,pixelRatio:de,scrollBeyondLastLine:ut,minimap:lt,verticalScrollbarWidth:qe,viewLineCount:Y,remainingWidth:vt,isViewportWrapping:Ct},be.memory||new y);St.renderMinimap!==0&&St.minimapLeft===0&&(at+=St.minimapWidth,rt+=St.minimapWidth,Ye+=St.minimapWidth,st+=St.minimapWidth);const pt=vt-St.minimapWidth,Ft=Math.max(1,Math.floor((pt-qe-2)/K)),Mt=Ee?Ce:0;return Ct&&(wt=Math.max(1,Ft),me==="bounded"&&(wt=Math.min(wt,_e))),{width:Oe,height:Ve,glyphMarginLeft:at,glyphMarginWidth:Qe,lineNumbersLeft:rt,lineNumbersWidth:et,decorationsLeft:Ye,decorationsWidth:Re,contentLeft:st,contentWidth:pt,minimap:St,viewportColumn:Ft,isWordWrapMinified:mt,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:qe,horizontalScrollbarHeight:ce,overviewRuler:{top:Mt,width:qe,height:Ve-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=W;class F extends n{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:b.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:_(ie.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:b.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:_(be.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(be.fontFamily,this.defaultValue.fontFamily)}}}class M extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ie,be,Oe){return ie.fontInfo.lineHeight}}class N extends n{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ie.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:b.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:_(be.enabled,this.defaultValue.enabled),size:v(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(be.side,this.defaultValue.side,["right","left"]),showSlider:v(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:_(be.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(be.scale,1,1,3),maxColumn:a.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(Q){return Q==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{top:a.clampedInt(be.top,0,0,1e3),bottom:a.clampedInt(be.bottom,0,0,1e3)}}}class q extends n{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:b.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{enabled:_(be.enabled,this.defaultValue.enabled),cycle:_(be.cycle,this.defaultValue.cycle)}}}class X extends T{constructor(){super(124)}compute(ie,be,Oe){return ie.pixelRatio}}class fe extends n{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:b.localize(59,null)},other:{type:"boolean",default:ie.other,description:b.localize(60,null)}}}],default:ie,description:b.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const be=ie,Oe={other:_(be.other,this.defaultValue.other),comments:_(be.comments,this.defaultValue.comments),strings:_(be.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var ve;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ie){let be=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(be=4,Oe=ie):ie==="interval"?be=3:ie==="relative"?be=2:ie==="on"?be=1:be=0),{renderType:be,renderFn:Oe}}}function Ie(Q){const ie=Q.get(84);return ie==="editable"?Q.get(77):ie!=="on"}e.filterValidationDecorations=Ie;class Fe extends n{constructor(){const ie=[],be={type:"number",description:b.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ie,description:b.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let be=[];for(let Oe of ie)if(typeof Oe=="number")be.push({column:a.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ve=Oe;be.push({column:a.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return be.sort((Oe,Ve)=>Oe.column-Ve.column),be}return this.defaultValue}}function z(Q,ie){if(typeof Q!="string")return ie;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie,Oe=a.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=a.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(be.vertical,this.defaultValue.vertical),horizontal:z(be.horizontal,this.defaultValue.horizontal),useShadows:_(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:_(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:_(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:_(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:_(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:a.clampedInt(be.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:a.clampedInt(be.verticalSliderSize,Ve,0,1e3),scrollByPage:_(be.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ie.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{insertMode:v(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:_(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:_(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:_(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:_(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:_(be.showIcons,this.defaultValue.showIcons),showStatusBar:_(be.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:_(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:_(be.showMethods,this.defaultValue.showMethods),showFunctions:_(be.showFunctions,this.defaultValue.showFunctions),showConstructors:_(be.showConstructors,this.defaultValue.showConstructors),showFields:_(be.showFields,this.defaultValue.showFields),showVariables:_(be.showVariables,this.defaultValue.showVariables),showClasses:_(be.showClasses,this.defaultValue.showClasses),showStructs:_(be.showStructs,this.defaultValue.showStructs),showInterfaces:_(be.showInterfaces,this.defaultValue.showInterfaces),showModules:_(be.showModules,this.defaultValue.showModules),showProperties:_(be.showProperties,this.defaultValue.showProperties),showEvents:_(be.showEvents,this.defaultValue.showEvents),showOperators:_(be.showOperators,this.defaultValue.showOperators),showUnits:_(be.showUnits,this.defaultValue.showUnits),showValues:_(be.showValues,this.defaultValue.showValues),showConstants:_(be.showConstants,this.defaultValue.showConstants),showEnums:_(be.showEnums,this.defaultValue.showEnums),showEnumMembers:_(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:_(be.showKeywords,this.defaultValue.showKeywords),showWords:_(be.showWords,this.defaultValue.showWords),showColors:_(be.showColors,this.defaultValue.showColors),showFiles:_(be.showFiles,this.defaultValue.showFiles),showReferences:_(be.showReferences,this.defaultValue.showReferences),showFolders:_(be.showFolders,this.defaultValue.showFolders),showTypeParameters:_(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:_(be.showSnippets,this.defaultValue.showSnippets),showUsers:_(be.showUsers,this.defaultValue.showUsers),showIssues:_(be.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:_(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends T{constructor(){super(125,[77])}compute(ie,be,Oe){return be.get(77)?!0:ie.tabFocusMode}}var De;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Me(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends T{constructor(){super(127,[126])}compute(ie,be,Oe){const Ve=be.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?Te:A.isLinux?xe:ke,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Ge;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.letterSpacing=52]="letterSpacing",Q[Q.lightbulb=53]="lightbulb",Q[Q.lineDecorationsWidth=54]="lineDecorationsWidth",Q[Q.lineHeight=55]="lineHeight",Q[Q.lineNumbers=56]="lineNumbers",Q[Q.lineNumbersMinChars=57]="lineNumbersMinChars",Q[Q.linkedEditing=58]="linkedEditing",Q[Q.links=59]="links",Q[Q.matchBrackets=60]="matchBrackets",Q[Q.minimap=61]="minimap",Q[Q.mouseStyle=62]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=64]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=66]="multiCursorModifier",Q[Q.multiCursorPaste=67]="multiCursorPaste",Q[Q.occurrencesHighlight=68]="occurrencesHighlight",Q[Q.overviewRulerBorder=69]="overviewRulerBorder",Q[Q.overviewRulerLanes=70]="overviewRulerLanes",Q[Q.padding=71]="padding",Q[Q.parameterHints=72]="parameterHints",Q[Q.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=75]="quickSuggestions",Q[Q.quickSuggestionsDelay=76]="quickSuggestionsDelay",Q[Q.readOnly=77]="readOnly",Q[Q.renameOnType=78]="renameOnType",Q[Q.renderControlCharacters=79]="renderControlCharacters",Q[Q.renderIndentGuides=80]="renderIndentGuides",Q[Q.renderFinalNewline=81]="renderFinalNewline",Q[Q.renderLineHighlight=82]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=84]="renderValidationDecorations",Q[Q.renderWhitespace=85]="renderWhitespace",Q[Q.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",Q[Q.roundedSelection=87]="roundedSelection",Q[Q.rulers=88]="rulers",Q[Q.scrollbar=89]="scrollbar",Q[Q.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=91]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=92]="scrollPredominantAxis",Q[Q.selectionClipboard=93]="selectionClipboard",Q[Q.selectionHighlight=94]="selectionHighlight",Q[Q.selectOnLineNumbers=95]="selectOnLineNumbers",Q[Q.showFoldingControls=96]="showFoldingControls",Q[Q.showUnused=97]="showUnused",Q[Q.snippetSuggestions=98]="snippetSuggestions",Q[Q.smartSelect=99]="smartSelect",Q[Q.smoothScrolling=100]="smoothScrolling",Q[Q.stickyTabStops=101]="stickyTabStops",Q[Q.stopRenderingLineAfter=102]="stopRenderingLineAfter",Q[Q.suggest=103]="suggest",Q[Q.suggestFontSize=104]="suggestFontSize",Q[Q.suggestLineHeight=105]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",Q[Q.suggestSelection=107]="suggestSelection",Q[Q.tabCompletion=108]="tabCompletion",Q[Q.tabIndex=109]="tabIndex",Q[Q.unusualLineTerminators=110]="unusualLineTerminators",Q[Q.useTabStops=111]="useTabStops",Q[Q.wordSeparators=112]="wordSeparators",Q[Q.wordWrap=113]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=116]="wordWrapColumn",Q[Q.wordWrapOverride1=117]="wordWrapOverride1",Q[Q.wordWrapOverride2=118]="wordWrapOverride2",Q[Q.wrappingIndent=119]="wrappingIndent",Q[Q.wrappingStrategy=120]="wrappingStrategy",Q[Q.showDeprecated=121]="showDeprecated",Q[Q.inlineHints=122]="inlineHints",Q[Q.editorClassName=123]="editorClassName",Q[Q.pixelRatio=124]="pixelRatio",Q[Q.tabFocusMode=125]="tabFocusMode",Q[Q.layoutInfo=126]="layoutInfo",Q[Q.wrappingInfo=127]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:Se(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:Se(new s),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null),deprecationMessage:b.localize(115,null)})),ariaLabel:Se(new S(4,"ariaLabel",b.localize(116,null))),autoClosingBrackets:Se(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(117,null),b.localize(118,null),""],description:b.localize(119,null)})),autoClosingDelete:Se(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(120,null),""],description:b.localize(121,null)})),autoClosingOvertype:Se(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(122,null),""],description:b.localize(123,null)})),autoClosingQuotes:Se(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(124,null),b.localize(125,null),""],description:b.localize(126,null)})),autoIndent:Se(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null),b.localize(131,null)],description:b.localize(132,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(133,null),b.localize(134,null),b.localize(135,null),""],description:b.localize(136,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:b.localize(137,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:b.localize(138,null)})),codeLensFontFamily:Se(new S(13,"codeLensFontFamily","",{description:b.localize(139,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(140,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:b.localize(141,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:b.localize(142,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(143,null)})),cursorBlinking:Se(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:b.localize(144,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(145,null)})),cursorStyle:Se(new c(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:b.localize(146,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(147,null)})),cursorSurroundingLinesStyle:Se(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(148,null),b.localize(149,null)],description:b.localize(150,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(151,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:b.localize(152,null)})),emptySelectionClipboard:Se(new w),extraEditorClassName:Se(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new h(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:b.localize(153,null)})),find:Se(new d),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:b.localize(154,null)})),foldingStrategy:Se(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(155,null),b.localize(156,null)],description:b.localize(157,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:b.localize(158,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(159,null)})),fontFamily:Se(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(160,null)})),fontInfo:Se(new C),fontLigatures2:Se(new m),fontSize:Se(new L),fontWeight:Se(new B),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:b.localize(161,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:b.localize(162,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:b.localize(163,null)})),gotoLocation:Se(new ee),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:b.localize(164,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:b.localize(165,null)})),hover:Se(new H),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>h.clamp(Q,-5,20),{description:b.localize(166,null)})),lightbulb:Se(new F),lineDecorationsWidth:Se(new k(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:b.localize(167,null)})),links:Se(new g(59,"links",!0,{description:b.localize(168,null)})),matchBrackets:Se(new E(60,"matchBrackets","always",["always","near","never"],{description:b.localize(169,null)})),minimap:Se(new N),mouseStyle:Se(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new h(63,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:b.localize(170,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(171,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:b.localize(172,null)})),multiCursorModifier:Se(new c(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[b.localize(173,null),b.localize(174,null)],markdownDescription:b.localize(175,null)})),multiCursorPaste:Se(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(176,null),b.localize(177,null)],markdownDescription:b.localize(178,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:b.localize(179,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:b.localize(180,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new V),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(181,null),b.localize(182,null)],description:b.localize(183,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:b.localize(184,null)})),quickSuggestions:Se(new fe),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(185,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:b.localize(186,null),markdownDeprecationMessage:b.localize(187,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:b.localize(188,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:b.localize(189,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:b.localize(190,null)})),renderLineHighlight:Se(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(191,null)],description:b.localize(192,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(193,null)})),renderValidationDecorations:Se(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(194,null),b.localize(195,null),b.localize(196,null),""],description:b.localize(197,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:b.localize(198,null)})),rulers:Se(new Fe),scrollbar:Se(new J),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(199,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:b.localize(200,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:b.localize(201,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:b.localize(202,null),included:A.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:b.localize(203,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(204,null),b.localize(205,null)],description:b.localize(206,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:b.localize(207,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:b.localize(208,null)})),inlineHints:Se(new U),snippetSuggestions:Se(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(209,null),b.localize(210,null),b.localize(211,null),b.localize(212,null)],description:b.localize(213,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:b.localize(214,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new te),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(216,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:b.localize(217,null)})),suggestSelection:Se(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(218,null),b.localize(219,null),b.localize(220,null)],description:b.localize(221,null)})),tabCompletion:Se(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null)],description:b.localize(229,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:b.localize(230,null)})),wordSeparators:Se(new S(112,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:b.localize(231,null)})),wordWrap:Se(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(232,null),b.localize(233,null),b.localize(234,null),b.localize(235,null)],description:b.localize(236,null)})),wordWrapBreakAfterCharacters:Se(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(237,null)})),wordWrapOverride1:Se(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new c(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[b.localize(238,null),b.localize(239,null),b.localize(240,null),b.localize(241,null)],description:b.localize(242,null)})),wrappingStrategy:Se(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(243,null),b.localize(244,null)],description:b.localize(245,null)})),editorClassName:Se(new p),pixelRatio:Se(new X),tabFocusMode:Se(new he),layoutInfo:Se(new W),wrappingInfo:Se(new we)}}),define(ge[151],pe([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([18,19]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ge[154],pe([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ge[155],pe([18,19]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[156],pe([18,19]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[157],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[158],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[160],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[161],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[162],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[163],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[164],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[165],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[166],pe([18,19]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[167],pe([18,19]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(ge[168],pe([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[169],pe([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[170],pe([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[171],pe([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[172],pe([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[173],pe([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[174],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var A;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(A=e.EditorOverride||(e.EditorOverride={}));var R;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[108],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(I,D=[],P=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=b;const A=(R,...I)=>new b(R,I);e.createSyncDescriptor=A}),define(ge[78],pe([0,1,108]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function R(D,P,y){P instanceof b.SyncDescriptor||(P=new b.SyncDescriptor(P,[],y)),A.push([D,P])}e.registerSingleton=R;function I(){return A}e.getSingletonServiceDescriptors=I}),define(ge[175],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=b;class A{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let D of this._nodes.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const P=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(D);P.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(I),P)}removeNode(I){const D=this._hashFn(I);this._nodes.delete(D);for(let P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(I){const D=this._hashFn(I);let P=this._nodes.get(D);return P||(P=new b(I),this._nodes.set(D,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[D,P]of this._nodes)I.push(`${D}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}}e.Graph=A}),define(ge[4],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(b=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function A(P,y,n,T){y[b.DI_TARGET]===y?y[b.DI_DEPENDENCIES].push({id:P,index:n,optional:T}):(y[b.DI_DEPENDENCIES]=[{id:P,index:n,optional:T}],y[b.DI_TARGET]=y)}function R(P){if(b.serviceIds.has(P))return b.serviceIds.get(P);const y=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(y,n,k,!1)};return y.toString=()=>P,b.serviceIds.set(P,y),y}e.createDecorator=R;function I(P){return P}e.refineServiceDecorator=I;function D(P){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(P,y,T,!0)}}e.optional=D}),define(ge[176],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function A(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=A}),define(ge[177],pe([0,1,3,73,6,23,72,76,176]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(_){return typeof _=="string"?!1:Array.isArray(_)?_.every(n):!!_.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(g,a){let h={selector:g,provider:a,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const a=[];for(let h of this._entries)h._score>0&&a.push(h.provider);return a}ordered(g){const a=[];return this._orderedForEach(g,h=>a.push(h.provider)),a}orderedGroups(g){const a=[];let h,S;return this._orderedForEach(g,v=>{h&&S===v._score?h.push(v.provider):(S=v._score,h=[v.provider],a.push(h))}),a}_orderedForEach(g,a){if(!!g){this._updateScores(g);for(const h of this._entries)h._score>0&&a(h)}}_updateScores(g){let a={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let h of this._entries)if(h._score=(0,P.score)(h.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),n(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(g,a){return g._score<a._score?1:g._score>a._score?-1:g._time<a._time?1:g._time>a._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(g,a,h=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=a,this.max=h,this._cache=new I.LRUCache(50,.7)}_key(g){return g.id+(0,A.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const a=this._key(g),h=this._cache.get(a);return this._clamp(h==null?void 0:h.value)}update(g,a){const h=this._key(g);let S=this._cache.get(h);return S||(S=new D.MovingAverage,this._cache.set(h,S)),S.update(a),this.get(g)}}e.LanguageFeatureRequestDelays=k}),define(ge[79],pe([0,1,2,43,177,142,47]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class y{constructor(m,C){this.language=m,this.id=C}}e.LanguageIdentifier=y;var n;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(m){return(m&255)>>>0}static getTokenType(m){return(m&1792)>>>8}static getFontStyle(m){return(m&14336)>>>11}static getForeground(m){return(m&8372224)>>>14}static getBackground(m){return(m&4286578688)>>>23}static getClassNameFromMetadata(m){let C=this.getForeground(m),L="mtk"+C,B=this.getFontStyle(m);return B&1&&(L+=" mtki"),B&2&&(L+=" mtkb"),B&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(m,C){const L=this.getForeground(m),B=this.getFontStyle(m);let ee=`color: ${C[L]};`;return B&1&&(ee+="font-style: italic;"),B&2&&(ee+="font-weight: bold;"),B&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=g;var a;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(m){const C=d[m];let L=C&&D.iconRegistry.get(C);return L||(console.info("No codicon found for CompletionItemKind "+m),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(m,C){let L=d[m];return typeof L=="undefined"&&!C&&(L=9),L}}();var h;(function(d){d[d.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(d){return d&&b.URI.isUri(d.uri)&&A.Range.isIRange(d.range)&&(A.Range.isIRange(d.originSelectionRange)||A.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=s;var t;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(d){d[d.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(d){const m=new Map;m.set("file",0),m.set("module",1),m.set("namespace",2),m.set("package",3),m.set("class",4),m.set("method",5),m.set("property",6),m.set("field",7),m.set("constructor",8),m.set("enum",9),m.set("interface",10),m.set("function",11),m.set("variable",12),m.set("constant",13),m.set("string",14),m.set("number",15),m.set("boolean",16),m.set("array",17),m.set("object",18),m.set("key",19),m.set("null",20),m.set("enum-member",21),m.set("struct",22),m.set("event",23),m.set("operator",24),m.set("type-parameter",25);const C=new Map;C.set(0,"file"),C.set(1,"module"),C.set(2,"namespace"),C.set(3,"package"),C.set(4,"class"),C.set(5,"method"),C.set(6,"property"),C.set(7,"field"),C.set(8,"constructor"),C.set(9,"enum"),C.set(10,"interface"),C.set(11,"function"),C.set(12,"variable"),C.set(13,"constant"),C.set(14,"string"),C.set(15,"number"),C.set(16,"boolean"),C.set(17,"array"),C.set(18,"object"),C.set(19,"key"),C.set(20,"null"),C.set(21,"enum-member"),C.set(22,"struct"),C.set(23,"event"),C.set(24,"operator"),C.set(25,"type-parameter");function L(H){return m.get(H)}d.fromString=L;function B(H){return C.get(H)}d.toString=B;function ee(H,x){const W=C.get(H);let F=W&&D.iconRegistry.get("symbol-"+W);return F||(console.info("No codicon found for SymbolKind "+H),F=D.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}d.toCssClassName=ee})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(m){this.value=m}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var p;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var w;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[178],pe([0,1,6,15,4,3,55,71]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const a=[];for(let S of y.description.args)a.push(S.constraint);const h=y.handler;y.handler=function(S,...v){return(0,A.validateConstraints)(v,a),h(S,...v)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new D.LinkedList,this._commands.set(T,k));let _=k.unshift(y),g=(0,b.toDisposable)(()=>{_();const a=this._commands.get(T);(a==null?void 0:a.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),g}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return P.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],pe([0,1,10,4,9]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=R.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",R.isMacintosh),D.set("isLinux",R.isLinux),D.set("isWindows",R.isWindows),D.set("isWeb",R.isWeb),D.set("isMacNative",R.isMacintosh&&!R.isWeb),D.set("isEdge",I.indexOf("Edg/")>=0),D.set("isFirefox",I.indexOf("Firefox")>=0),D.set("isChrome",I.indexOf("Chrome")>=0),D.set("isSafari",I.indexOf("Safari")>=0),D.set("isIPad",I.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(d){d[d.False=0]="False",d[d.True=1]="True",d[d.Defined=2]="Defined",d[d.Not=3]="Not",d[d.Equals=4]="Equals",d[d.NotEquals=5]="NotEquals",d[d.And=6]="And",d[d.Regex=7]="Regex",d[d.NotRegex=8]="NotRegex",d[d.Or=9]="Or",d[d.In=10]="In",d[d.NotIn=11]="NotIn",d[d.Greater=12]="Greater",d[d.GreaterEquals=13]="GreaterEquals",d[d.Smaller=14]="Smaller",d[d.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return _.INSTANCE}static has(m){return g.create(m)}static equals(m,C){return a.create(m,C)}static notEquals(m,C){return v.create(m,C)}static regex(m,C){return i.create(m,C)}static in(m,C){return h.create(m,C)}static not(m){return E.create(m)}static and(...m){return r.create(m)}static or(...m){return l.create(m)}static greater(m,C){return c.create(m,C)}static less(m,C){return s.create(m,C)}static deserialize(m,C=!1){if(!!m)return this._deserializeOrExpression(m,C)}static _deserializeOrExpression(m,C){let L=m.split("||");return l.create(L.map(B=>this._deserializeAndExpression(B,C)))}static _deserializeAndExpression(m,C){let L=m.split("&&");return r.create(L.map(B=>this._deserializeOne(B,C)))}static _deserializeOne(m,C){if(m=m.trim(),m.indexOf("!=")>=0){let L=m.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],C))}if(m.indexOf("==")>=0){let L=m.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],C))}if(m.indexOf("=~")>=0){let L=m.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],C))}if(m.indexOf(" in ")>=0){let L=m.split(" in ");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const L=m.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const L=m.split(">");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const L=m.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const L=m.split("<");return s.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(m)?E.create(m.substr(1).trim()):g.create(m)}static _deserializeValue(m,C){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let L=/^'([^']*)'$/.exec(m);return L?L[1].trim():m}static _deserializeRegexValue(m,C){if((0,b.isFalsyOrWhitespace)(m)){if(C)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=m.indexOf("/"),B=m.lastIndexOf("/");if(L===B||L<0){if(C)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let ee=m.slice(L+1,B),H=m[B+1]==="i"?"i":"";try{return new RegExp(ee,H)}catch(x){if(C)throw new Error(`bad regexp-value '${m}', parse error: ${x}`);return console.warn(`bad regexp-value '${m}', parse error: ${x}`),null}}}e.ContextKeyExpr=n;function T(d,m){return d.cmp(m)}class k{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class _{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class g{constructor(m){this.key=m,this.type=2}static create(m){const C=D.get(m);return typeof C=="boolean"?C?_.INSTANCE:k.INSTANCE:new g(m)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class a{constructor(m,C){this.key=m,this.value=C,this.type=4}static create(m,C){if(typeof C=="boolean")return C?g.create(m):E.create(m);const L=D.get(m);return typeof L=="boolean"?C===(L?"true":"false")?_.INSTANCE:k.INSTANCE:new a(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class h{constructor(m,C){this.key=m,this.valueKey=C,this.type=10}static create(m,C){return new h(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const C=m.getValue(this.valueKey),L=m.getValue(this.key);return Array.isArray(C)?C.indexOf(L)>=0:typeof L=="string"&&typeof C=="object"&&C!==null?P.call(C,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(m){this._actual=m,this.type=11}static create(m){return new S(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new S(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(m,C){this.key=m,this.value=C,this.type=5}static create(m,C){if(typeof C=="boolean")return C?E.create(m):g.create(m);const L=D.get(m);return typeof L=="boolean"?C===(L?"true":"false")?k.INSTANCE:_.INSTANCE:new v(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class E{constructor(m){this.key=m,this.type=3}static create(m){const C=D.get(m);return typeof C=="boolean"?C?k.INSTANCE:_.INSTANCE:new E(m)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class c{constructor(m,C){this.key=m,this.value=C,this.type=12}static create(m,C){return new c(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class u{constructor(m,C){this.key=m,this.value=C,this.type=13}static create(m,C){return new u(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class s{constructor(m,C){this.key=m,this.value=C,this.type=14}static create(m,C){return new s(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(m,C){this.key=m,this.value=C,this.type=15}static create(m,C){return new t(m,C)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(m,C){this.key=m,this.regexp=C,this.type=7}static create(m,C){return new i(m,C)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const C=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return C<L?-1:C>L?1:0}equals(m){if(m.type===this.type){const C=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return this.key===m.key&&C===L}return!1}evaluate(m){let C=m.getValue(this.key);return this.regexp?this.regexp.test(C):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(m){this._actual=m,this.type=8}static create(m){return new o(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new o(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(m){this.expr=m,this.type=6}static create(m){return r._normalizeArr(m)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let C=0,L=this.expr.length;C<L;C++){const B=T(this.expr[C],m.expr[C]);if(B!==0)return B}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let C=0,L=this.expr.length;C<L;C++)if(!this.expr[C].equals(m.expr[C]))return!1;return!0}return!1}evaluate(m){for(let C=0,L=this.expr.length;C<L;C++)if(!this.expr[C].evaluate(m))return!1;return!0}static _normalizeArr(m){const C=[];let L=!1;for(const B of m)if(!!B){if(B.type===1){L=!0;continue}if(B.type===0)return k.INSTANCE;if(B.type===6){C.push(...B.expr);continue}C.push(B)}if(C.length===0&&L)return _.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];for(C.sort(T);C.length>1;){const B=C[C.length-1];if(B.type!==9)break;C.pop();const ee=C.pop(),H=l.create(B.expr.map(x=>r.create([x,ee])));H&&(C.push(H),C.sort(T))}return C.length===1?C[0]:new r(C)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let C of this.expr)m.push(...C.keys());return m}map(m){return new r(this.expr.map(C=>C.map(m)))}negate(){let m=[];for(let C of this.expr)m.push(C.negate());return l.create(m)}}e.ContextKeyAndExpr=r;class l{constructor(m){this.expr=m,this.type=9}static create(m){const C=l._normalizeArr(m);if(C.length!==0)return C.length===1?C[0]:new l(C)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let C=0,L=this.expr.length;C<L;C++){const B=T(this.expr[C],m.expr[C]);if(B!==0)return B}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let C=0,L=this.expr.length;C<L;C++)if(!this.expr[C].equals(m.expr[C]))return!1;return!0}return!1}evaluate(m){for(let C=0,L=this.expr.length;C<L;C++)if(this.expr[C].evaluate(m))return!0;return!1}static _normalizeArr(m){let C=[],L=!1;if(m){for(let B=0,ee=m.length;B<ee;B++){const H=m[B];if(!!H){if(H.type===0){L=!0;continue}if(H.type===1)return[_.INSTANCE];if(H.type===9){C=C.concat(H.expr);continue}C.push(H)}}if(C.length===0&&L)return[k.INSTANCE];C.sort(T)}return C}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let C of this.expr)m.push(...C.keys());return m}map(m){return new l(this.expr.map(C=>C.map(m)))}negate(){let m=[];for(let L of this.expr)m.push(L.negate());const C=L=>L.type===9?L.expr:[L];for(;m.length>1;){const L=m.shift(),B=m.shift(),ee=[];for(const H of C(L))for(const x of C(B))ee.push(n.and(H,x));m.unshift(n.or(...ee))}return m[0]}}e.ContextKeyOrExpr=l;class f extends g{constructor(m,C,L){super(m);this.key=m,this._defaultValue=C,typeof L=="object"?f._info.push(Object.assign(Object.assign({},L),{key:m})):L!==!0&&f._info.push({key:m,description:L,type:C!=null?typeof C:void 0})}static all(){return f._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(m){return n.equals(this.key,m)}notEqualsTo(m){return n.notEquals(this.key,m)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(d,m){return d<m?-1:d>m?1:0}function w(d,m,C,L){return d<C?-1:d>C?1:m<L?-1:m>L?1:0}}),define(ge[179],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[180],pe([0,1,152,4,11]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=I;var D;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var P;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var y;(function(k){k.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var n;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(_,g){super(_);this.code=g}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,10,4]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let _=typeof T=="string"?T:T.value,g=typeof k=="string"?k:k.value;return b.equalsIgnoreCase(_,g)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=D;function P(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[181],pe([0,1,10,29]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(g,a){return g.uuid&&a.uuid?g.uuid===a.uuid:g.id===a.id?!0:(0,b.compareIgnoreCase)(g.id,a.id)===0}e.areSameExtensions=R;class I{constructor(a,h){this.version=h,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof I?R(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=I;function D(g,a){return`${g}.${a}`}e.getExtensionId=D;function P(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(g,a){return P(D(g,a))}e.getGalleryExtensionId=y;function n(g,a){const h=[],S=v=>{for(const E of h)if(E.some(c=>R(a(c),a(v))))return E;return null};for(const v of g){const E=S(v);E?E.push(v):h.push([v])}return h}e.groupByExtension=n;function T(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function _(g){const a=new Set;for(const h of g)h.malicious&&a.add(h.id.id);return a}e.getMaliciousExtensionsSet=_}),define(ge[44],pe([0,1,153,8,2,4,10,15,23]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=_;function g(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=g;function a(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function h(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=h;var S;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(x,W){super(x);this.code=W}}e.FileSystemProviderError=v;function E(H,x){const W=new v(H.toString(),x);return u(W,x),W}e.createFileSystemProviderError=E;function c(H){return H||E((0,b.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function u(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=u;function s(H){if(!H)return S.Unknown;if(H instanceof v)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function t(H){if(H instanceof p)return H.fileOperationResult;switch(s(H)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(x,W,F){this.resource=x,this.operation=W,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var r;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...W){return this.doContains(x,{includeChildren:!1},...W)}affects(x,...W){return this.doContains(x,{includeChildren:!0},...W)}doContains(x,W,...F){var U,M,N,O,V,q;if(!x)return!1;const X=F.length>0;return!!((!X||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||W.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!X||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||W.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!X||F.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(x))||W.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const W=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)W.push(U);return W}filter(x){return new l(this.changes.filter(W=>x(W)),this.ignorePathCasing)}}e.FileChangesEvent=l;function f(H,x,W){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==A.sep&&(x+=A.sep),W?(0,D.startsWithIgnoreCase)(H,x):H.indexOf(x)===0)}e.isParent=f;class p extends Error{constructor(x,W,F){super(x);this.fileOperationResult=W,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,P.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=p;var w;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=m;async function C(H,x){if(!x.canHandleResource(R.URI.from({scheme:H.scheme})))return new Promise(W=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(F.dispose(),W())})})}e.whenProviderRegistered=C,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,P.isNumber)(x)||(x=0),x<L.KB?(0,b.localize)(1,null,x.toFixed(0)):x<L.MB?(0,b.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,b.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,b.localize)(4,null,(x/L.GB).toFixed(2)):(0,b.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function ee(H){return{maxFileSize:H===0?300*L.MB:16*L.GB,maxHeapSize:H===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ee}),define(ge[81],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...R){this._entries=new Map;for(let[I,D]of R)this.set(I,D)}set(R,I){const D=this._entries.get(R);return this._entries.set(R,I),D}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=b}),define(ge[182],pe([0,1,16,175,108,4,81,17]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class T{constructor(a=new D.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=S,this._services.set(I.IInstantiationService,this)}createChild(a){return new T(a,this._strict,this)}invokeFunction(a,...h){let S=_.traceInvocation(a),v=!1;try{return a({get:(c,u)=>{if(v)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,S);if(!s&&u!==I.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...h)}finally{v=!0,S.stop()}}createInstance(a,...h){let S,v;return a instanceof R.SyncDescriptor?(S=_.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(h),S)):(S=_.traceCreation(a),v=this._createInstance(a,h,S)),S.stop(),v}_createInstance(a,h=[],S){let v=I._util.getServiceDependencies(a).sort((u,s)=>u.index-s.index),E=[];for(const u of v){let s=this._getOrCreateServiceInstance(u.id,S);if(!s&&this._strict&&!u.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${u.id}.`);E.push(s)}let c=v.length>0?v[0].index:h.length;if(h.length!==c){console.warn(`[createInstance] First service dependency of ${a.name} at position ${c+1} conflicts with ${h.length} static arguments`);let u=c-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,c)}return new a(...[...h,...E])}_setServiceInstance(a,h){if(this._services.get(a)instanceof R.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,h.branch(a,!0)):(h.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,h,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,S){const v=new A.Graph(u=>u.id.toString());let E=0;const c=[{id:a,desc:h,_trace:S}];for(;c.length;){const u=c.pop();if(v.lookupOrInsertNode(u),E++>1e3)throw new n(v);for(let s of I._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const i={id:s.id,desc:t,_trace:u._trace.branch(s.id,!0)};v.insertEdge(u,i),c.push(i)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new n(v);break}for(const{data:s}of u){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,S=[],v,E){if(this._services.get(a)instanceof R.SyncDescriptor)return this._createServiceInstance(h,S,v,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,S,v,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],S,v){if(S){const E=new P.IdleValue(()=>this._createInstance(a,h,v));return new Proxy(Object.create(null),{get(c,u){if(u in c)return c[u];let s=E.value,t=s[u];return typeof t!="function"||(t=t.bind(s),c[u]=t),t},set(c,u,s){return E.value[u]=s,!0}})}else return this._createInstance(a,h,v)}}e.InstantiationService=T;var k;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(k||(k={}));class _{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return y?new _(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(a){return y?new _(0,a.name):_._None}branch(a,h){let S=new _(2,a.toString());return this._dep.push([a,h,S]),S}stop(){let a=Date.now()-this._start;_._totals+=a;let h=!1;function S(E,c){let u=[],s=new Array(E+1).join("	");for(const[t,i,o]of c._dep)if(i&&o){h=!0,u.push(`${s}CREATES -> ${t}`);let r=S(E+1,o);r&&u.push(r)}else u.push(`${s}uses -> ${t}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(v.join(`
`))}}_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(ge[12],pe([0,1,4,6,9,3,58]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(y.Error))if(s instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=s.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let i=0;i<s.length;i++){let o=s[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(r){}t+=(i>0?" ":"")+o}return t}}e.AbstractMessageLogger=T;class k extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!R.isWindows}trace(s,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...t):console.log(`[main ${P()}]`,s,...t))}debug(s,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...t):console.log(`[main ${P()}]`,s,...t))}info(s,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...t):console.log(`[main ${P()}]`,s,...t))}warn(s,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,s,...t):console.warn(`[main ${P()}]`,s,...t))}error(s,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,s,...t):console.error(`[main ${P()}]`,s,...t))}critical(s,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,s,...t):console.error(`[main ${P()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class _ extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=_;class g extends n{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,D.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class a extends n{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const i of this.logServices)i.trace(s,...t)}debug(s,...t){for(const i of this.logServices)i.debug(s,...t)}info(s,...t){for(const i of this.logServices)i.info(s,...t)}warn(s,...t){for(const i of this.logServices)i.warn(s,...t)}error(s,...t){for(const i of this.logServices)i.error(s,...t)}critical(s,...t){for(const i of this.logServices)i.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=a;class h extends A.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=h;class S{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=S;function v(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const s=E(u.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function E(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=E;function c(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(ge[109],pe([0,1,12,44]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(y,n,T,k){try{const _=await new Promise((g,a)=>{Z(["spdlog"],g,a)});return _.setAsyncMode(8192,500),_.createRotatingLoggerAsync(y,n,T,k)}catch(_){console.error(_)}return null}function I(y,n,T,k){return Z.__$__nodeRequire("spdlog").createRotatingLogger(y,n,T,k)}e.createRotatingLogger=I;function D(y,n,T){switch(n){case b.LogLevel.Trace:y.trace(T);break;case b.LogLevel.Debug:y.debug(T);break;case b.LogLevel.Info:y.info(T);break;case b.LogLevel.Warning:y.warn(T);break;case b.LogLevel.Error:y.error(T);break;case b.LogLevel.Critical:y.critical(T);break;default:throw new Error("Invalid log level")}}class P extends b.AbstractMessageLogger{constructor(n,T,k,_){super();this.name=n,this.filepath=T,this.rotating=k,this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const n=this.rotating?6:1,T=30/n*A.ByteSize.MB;return R(this.name,this.filepath,T,n).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:_,message:g}of this.buffer)D(this._logger,_,g);this.buffer=[]}})}log(n,T){this._logger?D(this._logger,n,T):this.getLevel()<=n&&this.buffer.push({level:n,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[110],pe([0,1,4,154,56]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(a,h){return h-a}y.compare=n;const T=Object.create(null);T[y.Error]=(0,A.localize)(0,null),T[y.Warning]=(0,A.localize)(1,null),T[y.Info]=(0,A.localize)(2,null);function k(a){return T[a]||""}y.toString=k;function _(a){switch(a){case R.default.Error:return y.Error;case R.default.Warning:return y.Warning;case R.default.Info:return y.Info;case R.default.Ignore:return y.Hint}}y.fromSeverity=_;function g(a){switch(a){case y.Error:return R.default.Error;case y.Warning:return R.default.Warning;case y.Info:return R.default.Info;case y.Hint:return R.default.Ignore}}y.toSeverity=g}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(y){const n="";function T(_){return k(_,!0)}y.makeKey=T;function k(_,g){let a=[n];return _.source?a.push(_.source.replace("\xA6","\\\xA6")):a.push(n),_.code?typeof _.code=="string"?a.push(_.code.replace("\xA6","\\\xA6")):a.push(_.code.value.replace("\xA6","\\\xA6")):a.push(n),_.severity!==void 0&&_.severity!==null?a.push(D.toString(_.severity)):a.push(n),_.message&&g?a.push(_.message.replace("\xA6","\\\xA6")):a.push(n),_.startLineNumber!==void 0&&_.startLineNumber!==null?a.push(_.startLineNumber.toString()):a.push(n),_.startColumn!==void 0&&_.startColumn!==null?a.push(_.startColumn.toString()):a.push(n),_.endLineNumber!==void 0&&_.endLineNumber!==null?a.push(_.endLineNumber.toString()):a.push(n),_.endColumn!==void 0&&_.endColumn!==null?a.push(_.endColumn.toString()):a.push(n),a.push(n),a.join("\xA6")}y.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ge[183],pe([0,1,56,4,3]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,A.createDecorator)("notificationService");var I;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new y,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=P;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y}),define(ge[184],pe([0,1,11,9,30,24]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(A.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function")D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.55.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const P=(0,I.dirname)(b.FileAccess.asFileUri("",Z));D=Z.__$__nodeRequire((0,I.joinPath)(P,"product.json").fsPath);const y=Z.__$__nodeRequire((0,I.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}e.default=D});var je=this&&this.__decorate||function(Z,e,b,A){var R=arguments.length,I=R<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,b):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Z,e,b,A);else for(var P=Z.length-1;P>=0;P--)(D=Z[P])&&(I=(R<3?D(I):R>3?D(e,b,I):D(e,b))||I);return R>3&&I&&Object.defineProperty(e,b,I),I},Ue=this&&this.__param||function(Z,e){return function(b,A){e(b,A,Z)}};define(ge[111],pe([0,1,4,21,6,17]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var D;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let y=class extends R.Disposable{constructor(k,_){super();this.deferred=new I.DeferredPromise,_.withProgress(k,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,R.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends R.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(k){this.stop();const _=++this.currentOperationId,g=new A.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:g.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,15,52]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(D,P){A.ok(b.isString(D)),A.ok(b.isObject(P)),A.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new R}),define(ge[112],pe([0,1,40,3]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[R(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new I;b.Registry.add(e.Extensions.JSONContribution,D)}),define(ge[82],pe([0,1,151,3,40,15,112]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=R.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,E=!0){this.registerConfigurations([v],E)}registerConfigurations(v,E=!0){const c=[];v.forEach(u=>{c.push(...this.validateAndRegisterProperties(u,E)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const E=[],c=u=>{if(u.properties)for(const s in u.properties)E.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,u.properties[s]);u.allOf&&u.allOf.forEach(s=>c(s))};for(const u of v){c(u);const s=this.configurationContributors.indexOf(u);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(v){const E=[],c=[];for(const u of v)for(const s in u)if(E.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),u[s]);const t={type:"object",default:this.defaultValues[s],description:b.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(k(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=u[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(v){const E=[];for(const c of v)for(const u in c)if(E.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const s=this.configurationProperties[u];s&&(this.updatePropertyDefaultValue(u,s),this.updateSchema(u,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const E of v)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,E=!0,c=3){c=I.isUndefinedOrNull(v.scope)?c:v.scope;let u=[],s=v.properties;if(s)for(let i in s){if(E&&a(i)){delete s[i];continue}const o=s[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:o.scope=I.isUndefinedOrNull(o.scope)?c:o.scope,s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),u.push(i)}let t=v.allOf;if(t)for(let i of t)u.push(...this.validateAndRegisterProperties(i,E,c));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const E=c=>{let u=c.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let s=c.allOf;s&&s.forEach(E)};E(v)}updateSchema(v,E){switch(e.allSettings.properties[v]=E,E.scope){case 1:e.applicationSettings.properties[v]=E;break;case 2:e.machineSettings.properties[v]=E;break;case 6:e.machineOverridableSettings.properties[v]=E;break;case 3:e.windowSettings.properties[v]=E;break;case 4:e.resourceSettings.properties[v]=E;break;case 5:e.resourceSettings.properties[v]=E,this.resourceLanguageSettingsSchema.properties[v]=E;break}}removeFromSchema(v,E){switch(delete e.allSettings.properties[v],E.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const E=`[${v}]`,c={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,c),e.allSettings.properties[E]=c,e.applicationSettings.properties[E]=c,e.machineSettings.properties[E]=c,e.machineOverridableSettings.properties[E]=c,e.windowSettings.properties[E]=c,e.resourceSettings.properties[E]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,E){let c=this.defaultValues[v];I.isUndefined(c)&&(c=E.default),I.isUndefined(c)&&(c=_(E.type)),E.default=c}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=k;function _(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const g=new n;R.Registry.add(e.Extensions.Configuration,g);function a(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?b.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?b.localize(6,null,S):null:b.localize(4,null)}e.validateProperty=a;function h(){const S=[],v=g.getConfigurationProperties();for(const E of Object.keys(v))S.push([E,v[E].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=h}),define(ge[83],pe([0,1,22,15,2,40,4,82]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,o){const r=o?i?o.keys.filter(C=>i.keys.indexOf(C)===-1):[...o.keys]:[],l=i?o?i.keys.filter(C=>o.keys.indexOf(C)===-1):[...i.keys]:[],f=[];if(o&&i){for(const C of i.keys)if(o.keys.indexOf(C)!==-1){const L=v(i.contents,C),B=v(o.contents,C);b.equals(L,B)||f.push(C)}}const p=[],w=C=>{const L={};for(const B of C)for(const ee of B.identifiers)L[s(ee)]=B;return L},d=o?w(o.overrides):{},m=i?w(i.overrides):{};if(Object.keys(d).length)for(const C of r){const L=d[C];L&&p.push([(0,P.overrideIdentifierFromKey)(C),L.keys])}if(Object.keys(m).length)for(const C of l){const L=m[C];L&&p.push([(0,P.overrideIdentifierFromKey)(C),L.keys])}if(Object.keys(d).length&&Object.keys(m).length)for(const C of f){const L=m[C],B=d[C];if(L&&B){const ee=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});p.push([(0,P.overrideIdentifierFromKey)(C),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:l,updated:f,overrides:p}}e.compare=k;function _(i,o){const r=[];for(const l of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const p in i[l])f[p]=i[l][p];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:g(f,o)})}return r}e.toOverrides=_;function g(i,o){const r=Object.create(null);for(let l in i)a(r,l,i[l],o);return r}e.toValuesTree=g;function a(i,o,r,l){const f=o.split("."),p=f.pop();let w=i;for(let d=0;d<f.length;d++){let m=f[d],C=w[m];switch(typeof C){case"undefined":C=w[m]=Object.create(null);break;case"object":break;default:l(`Ignoring ${o} as ${f.slice(0,d+1).join(".")} is ${JSON.stringify(C)}`);return}w=C}if(typeof w=="object"&&w!==null)try{w[p]=r}catch(d){l(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(w)}`)}else l(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=a;function h(i,o){const r=o.split(".");S(i,r)}e.removeFromValueTree=h;function S(i,o){const r=o.shift();if(o.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(S(l,o),Object.keys(l).length===0&&delete i[r])}}function v(i,o,r){function l(w,d){let m=w;for(const C of d){if(typeof m!="object"||m===null)return;m=m[C]}return m}const f=o.split("."),p=l(i,f);return typeof p=="undefined"?r:p}e.getConfigurationValue=v;function E(i,o,r){Object.keys(o).forEach(l=>{l!=="__proto__"&&(l in i?A.isObject(i[l])&&A.isObject(o[l])?E(i[l],o[l],r):r&&(i[l]=o[l]):i[l]=o[l])})}e.merge=E;function c(){const i=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=c;function u(){const i=Object.create(null),o=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in o){let l=o[r].default;a(i,r,l,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=u;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,o,r){const l=i.inspect(o),f=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=t}),define(ge[185],pe([0,1,54,23,14,15,22,2,82,83,40,6,3]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],f=i[r];f&&(typeof l=="object"&&typeof f=="object"?(l=D.deepClone(l),this.mergeContents(l,f)):l=f),o[r]=l}return new g(o,this.keys,this.overrides)}merge(...t){const i=D.deepClone(this.contents),o=D.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const f of l.overrides){const[p]=o.filter(w=>R.equals(w.identifiers,f.identifiers));p?this.mergeContents(p.contents,f.contents):o.push(D.deepClone(f))}for(const f of l.keys)r.indexOf(f)===-1&&r.push(f)}return new g(i,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&I.isObject(t[o])&&I.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=D.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,o)}}e.DefaultConfigurationModel=a;class h{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get errors(){return this._parseErrors}parseContent(t){if(!I.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new g(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},o=null,r=[],l=[],f=[];function p(d){Array.isArray(r)?r.push(d):o&&(r[o]=d)}let w={onObjectBegin:()=>{let d={};p(d),l.push(r),r=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let d=[];p(d),l.push(r),r=d,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:p,onError:(d,m,C)=>{f.push({error:d,offset:m,length:C})}};if(t)try{b.visit(t,w),i=r[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return i}doParseRaw(t){if(this._scopes){const l=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,l,!0,this._scopes)}const i=(0,n.toValuesTree)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),o=Object.keys(t),r=(0,n.toOverrides)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:i,keys:o,overrides:r}}filterByScope(t,i,o,r){const l={};for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&o)l[f]=this.filterByScope(t[f],i,!1,r);else{const p=this.getScope(f,i);(p===void 0||r.indexOf(p)!==-1)&&(l[f]=t[f])}return l}getScope(t,i){const o=i[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=h;class S extends k.Disposable{constructor(t,i,o,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new g}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class v{constructor(t,i,o=new g,r=new g,l=new A.ResourceMap,f=new g,p=new A.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=p,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new g,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const r=this.getConsolidateConfigurationModel(i,o),l=this.getFolderConfigurationModelForResource(i.resource,o),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),C=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,B=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),ee=r.getValue(t),H=R.distinct(R.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:p,userValue:w,userLocalValue:d,userRemoteValue:m,workspaceValue:C,workspaceFolderValue:L,memoryValue:B,value:ee,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,y.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),p=t.getKeysForOverrideIdentifier(l),w=[...p.filter(d=>f.indexOf(d)===-1),...f.filter(d=>p.indexOf(d)===-1),...f.filter(d=>!D.equals(this._defaultConfiguration.override(l).getValue(d),t.override(l).getValue(d)))];return[l,w]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),f=[...i,...o,...r];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...i,...o,...r];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...i,...o,...r];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:r,updated:l,removed:f,overrides:p}=(0,n.compare)(o,i);let w=[...r,...l,...f];return(w.length||!o)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:l,overrides:f}=(0,n.compare)(i,void 0);return{keys:[...o,...r,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const l=this._memoryConfigurationByResource.get(t);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:r,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((f,p)=>(f.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),f),new A.ResourceMap);return new v(i,o,new g,r,l,new g,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const r of s)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,f])=>{const p=(0,A.getOrSet)(i,l,new Set);f.forEach(w=>p.add(w))});const o=[];return i.forEach((r,l)=>o.push([l,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=E;class c{constructor(t,i,o,r){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(p=>l.add(p)),t.overrides.forEach(([,p])=>p.forEach(w=>l.add(w))),this.affectedKeys=[...l.values()];const f=new g;this.affectedKeys.forEach(p=>f.setValue(p,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!D.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=(0,n.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=c;class u extends c{constructor(t,i,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(ge[113],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var A;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(D,P=A.Unknown,y){super(D);this._message=D,this._code=P,this._detail=y,this.isHandled=P===A.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(D){return D instanceof R&&D._code===A.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof R&&D._code===A.NoResolverFound}static isHandled(D){return D instanceof R&&D.isHandled}}e.RemoteAuthorityResolverError=R}),define(ge[114],pe([0,1,11]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function A(I){return I.scheme===b.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=A;function R(I){if(!!I){const D=I.indexOf("+");return D<0?I:I.substr(0,D)}}e.getRemoteName=R}),define(ge[186],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((R,I)=>Z(["vsda"],R,I))}async sign(R){try{const I=await this.vsda(),D=new I.signer;if(D)return D.sign(R)}catch(I){}return R}}e.SignService=b}),define(ge[187],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,I,D=5){let P;return P=I(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(n);return}const k=setTimeout(()=>this.flushBuffer(R),D);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(R),P.dispose()}},this._terminalBufferMap.set(R,T)}),P}stopBuffering(R){const I=this._terminalBufferMap.get(R);I&&I.dispose()}flushBuffer(R){const I=this._terminalBufferMap.get(R);I&&(this._terminalBufferMap.delete(R),this._callback(R,I.data.join("")))}}e.TerminalDataBufferer=b}),define(ge[188],pe([0,1,48,8,30,26,15,22,9]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let _=0;return k&&k.length===4&&(_=parseInt(k[3])),_}e.getWindowsBuildNumber=n;async function T(k,_,g,a=R.env){if(A.isAbsolute(k))return await(0,I.exists)(k)?k:void 0;if(_===void 0&&(_=R.cwd()),A.dirname(k)!=="."){const E=A.join(_,k);return await(0,I.exists)(E)?E:void 0}const S=(0,P.getCaseInsensitive)(a,"PATH");if(g===void 0&&(0,D.isString)(S)&&(g=S.split(A.delimiter)),g===void 0||g.length===0){const E=A.join(_,k);return await(0,I.exists)(E)?E:void 0}for(let E of g){let c;if(A.isAbsolute(E)?c=A.join(E,k):c=A.join(_,E,k),await(0,I.exists)(c))return c;if(y.isWindows){let u=c+".com";if(await(0,I.exists)(u)||(u=c+".exe",await(0,I.exists)(u)))return u}}const v=A.join(_,k);return await(0,I.exists)(v)?v:void 0}e.findExecutable=T}),define(ge[189],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(ge[190],pe([0,1,4,6,40,3,189,47]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var y;(function(S){function v(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function n(S){return{id:S}}e.themeColorFromId=n;var T;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const E=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const i=E.exec(t);if(!!i){let[,o]=i;return{id:o}}}S.fromString=c;function u(t,i){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),i&&(o=`${o}~${i}`),{id:o}}S.modify=u;function s(t,i){var o,r;return t.id===i.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=i.color)===null||r===void 0?void 0:r.id)}S.isEqual=s,S.asClassNameArray=P.CSSIcon.asClassNameArray,S.asClassName=P.CSSIcon.asClassName,S.asCSSSelector=P.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function k(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,A.toDisposable)(()=>{const E=this.themingParticipants.indexOf(v);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new _;R.Registry.add(e.Extensions.ThemingContribution,g);function a(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=a;class h extends A.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,E){let c=this.theme.getColor(v);return c&&E&&(c=E(c,this.theme)),c?c.toString():null}}e.Themable=h}),define(ge[191],pe([0,1,40,190,3,155,112,17,47]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,E,c,u){const s=this.iconsById[v];if(s){if(c&&!s.description){s.description=c,this.iconSchema.properties[v].markdownDescription=`${c} $(${v})`;const o=this.iconReferenceSchema.enum.indexOf(v);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return s}let t={id:v,description:c,defaults:E,deprecationMessage:u};this.iconsById[v]=t;let i={$ref:"#/definitions/icons"};return u&&(i.deprecationMessage=u),c&&(i.markdownDescription=`${c}: $(${v})`),this.iconSchema.properties[v]=i,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const E=this.iconReferenceSchema.enum.indexOf(v);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,E){const c=this.iconFontsById[v];if(c)return c;let u={id:v,definition:E};return this.iconFontsById[v]=u,this._onDidChange.fire(),u}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(s,t)=>s.id.localeCompare(t.id),E=s=>{for(;A.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of u.filter(t=>!!t.description).sort(v))c.push(`|<i class="${E(s)}"></i>|${s.id}|${A.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const s of u.filter(t=>!A.ThemeIcon.isThemeIcon(t.defaults)).sort(v))c.push(`|<i class="${E(s)}"></i>|${s.id}|`);return c.join(`
`)}}const T=new n;b.Registry.add(e.Extensions.IconContribution,T);function k(S,v,E,c){return T.registerIcon(S,v,E,c)}e.registerIcon=k;function _(){return T}e.getIconRegistry=_;function g(){for(const S of y.iconRegistry.all)T.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>T.registerIcon(S.id,S.definition,S.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(D.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,T.getIconSchema());const h=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=A.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ge[59],pe([0,1,2,24,4,23]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var D;(function(_){_[_.EMPTY=1]="EMPTY",_[_.FOLDER=2]="FOLDER",_[_.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function P(_){const g=_;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=P;function y(_){const g=_;return!!(g&&typeof g=="object"&&b.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(g,a,h,S){this._id=g,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(g,a){this.raw=a,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,A.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(_){return new T({uri:_,index:0,name:(0,A.basenameOrAuthority)(_)},{uri:_.toString()})}e.toWorkspaceFolder=k}),define(ge[115],pe([0,1,4,156,59,2,9,8,24,132,54,11,75,31,114]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(W){return(typeof W=="string"?(0,P.extname)(W):(0,y.extname)(W))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function v(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function E(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=E;function c(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=c;function u(W){const F=W;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=u;function s(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(W){const F=W;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function i(W){const F=W;if(F==null?void 0:F.uri)return{id:F.id,uri:I.URI.revive(F.uri)};const U=W;if(U==null?void 0:U.configPath)return{id:U.id,configPath:I.URI.revive(U.configPath)};if(W==null?void 0:W.id)return{id:W.id}}e.reviveIdentifier=i;function o(W,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent(W,F.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r(W){return l(W)||f(W)}e.isStoredWorkspaceFolder=r;function l(W){const F=W;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=l;function f(W){const F=W;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=f;function p(W,F,U,M,N=!D.isWindows,O){if(W.scheme!==M.scheme)return{name:U,uri:W.toString(!0)};let V=F?void 0:O.relativePath(M,W);if(V!==void 0)V.length===0?V=".":D.isWindows&&W.scheme===k.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if(W.scheme===k.Schemas.file)V=W.fsPath,D.isWindows&&(V=(0,_.normalizeDriveLetter)(V),N&&(V=(0,g.toSlashes)(V)));else{if(!O.isEqualAuthority(W.authority,M.authority))return{name:U,uri:W.toString(!0)};V=W.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=p;function w(W,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let V of W){let q=null;if(l(V))V.path&&(q=U.resolvePath(O,V.path));else if(f(V))try{q=I.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(X){console.warn(X)}if(q){let X=U.getComparisonKey(q);if(!N.has(X)){N.add(X);const fe=V.name||U.basenameOrAuthority(q);M.push(new R.WorkspaceFolder({uri:q,name:fe,index:M.length},V))}}}return M}e.toWorkspaceFolders=w;function d(W,F,U,M,N){let O=m(F,W);const V=N.dirname(F),q=N.dirname(M),X=[],fe=C(O.folders);for(const Fe of O.folders){const z=l(Fe)?N.resolvePath(V,Fe.path):I.URI.parse(Fe.uri);let J;U?J=!1:J=!l(Fe)||(0,P.isAbsolute)(Fe.path),X.push(p(z,J,Fe.name,q,fe,N))}const ve={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Ae=n.setProperty(W,["folders"],X,ve);let Ie=n.applyEdits(W,Ae);return O.remoteAuthority===(0,a.getRemoteAuthority)(M)&&(Ie=n.applyEdits(Ie,n.removeProperty(Ie,["remoteAuthority"],ve))),Ie}e.rewriteWorkspaceFileForNewLocation=d;function m(W,F){let U=T.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${W} looks like an invalid workspace file.`);return U}function C(W){return D.isWindows?W.some(F=>l(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function L(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function B(W){return typeof W.folderUri=="string"}function ee(W){return typeof W.fileUri=="string"}function H(W,F){const U={workspaces:[],files:[]};if(W){const M=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(X){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${X.toString()}. Skip entry.`)}},N=W;if(Array.isArray(N.entries))M(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):B(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):ee(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=W;Array.isArray(O.workspaces3)&&M(O.workspaces3,(V,q)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:V.id,configPath:I.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:X,folderUri:I.URI.parse(V)})}),Array.isArray(O.files2)&&M(O.files2,(V,q)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:X,fileUri:I.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=H;function x(W){const F={entries:[]};for(const U of W.workspaces)E(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of W.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(ge[116],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const I=this._idPool++;return this._data.set(I,R),this.logDebugInfo(),I}get(R,I){return this._data.has(R)?this._data.get(R)[I]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(ge[192],pe([0,1,2,3]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(P=>({name:P.name,group:P.group,resource:b.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(ge[60],pe([0,1,11,4]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,P){P===null?this._providerInfo.delete(D):this._providerInfo.set(D,P)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,A.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(ge[193],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class b{constructor(I,D,P){this._id=I,this._shared=D,this._storage=P,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(I,D){let P=this._value[I];return typeof P=="undefined"&&(P=D),P}update(I,D){return this._value[I]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=b;class A extends b{constructor(I,D){super(I.identifier.value,!0,D);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=A}),define(ge[13],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class A{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=A});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[194],pe([0,1,29,3]),function(Z,e,b,A){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(P,y){R.set(this,void 0),this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(P.identifier),nt(this,R,y),Be(this,R).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(P){return Be(this,R).get(this._id,P)}store(P,y){return Be(this,R).store(this._id,P,y)}delete(P){return Be(this,R).delete(this._id,P)}}e.ExtensionSecrets=I,R=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new A.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(ge[50],pe([0,1,4,3,13]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(P){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}P.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}P.fromServiceTunnel=n})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new A.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,k,_){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Ue(0,R.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[7],pe([0,1,14,16,94,23,15,2,28,44,113]),function(Z,e,b,A,R,I,D,P,y,n,T){"use strict";var k,_,g,a,h,S,v,E,c,u,s,t,i,o,r,l,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function w(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let d=h=class{constructor($){k.set(this,void 0),nt(this,k,$)}static from(...$){let oe=$;return new h(function(){if(oe){for(const ye of oe)ye&&typeof ye.dispose=="function"&&ye.dispose();oe=void 0}})}dispose(){typeof Be(this,k)=="function"&&(Be(this,k).call(this),nt(this,k,void 0))}};k=new WeakMap,d=h=je([w],d),e.Disposable=d;let m=S=class{constructor($,oe){if($<0)throw(0,A.illegalArgument)("line must be non-negative");if(oe<0)throw(0,A.illegalArgument)("character must be non-negative");this._line=$,this._character=oe}static Min(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ye=1;ye<$.length;ye++){const ze=$[ye];ze.isBefore(oe)&&(oe=ze)}return oe}static Max(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ye=1;ye<$.length;ye++){const ze=$[ye];ze.isAfter(oe)&&(oe=ze)}return oe}static isPosition($){if(!$)return!1;if($ instanceof S)return!0;let{line:oe,character:ye}=$;return typeof oe=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,oe=0){if($===null||oe===null)throw(0,A.illegalArgument)();let ye;return typeof $=="undefined"?ye=0:typeof $=="number"?ye=$:(ye=typeof $.lineDelta=="number"?$.lineDelta:0,oe=typeof $.characterDelta=="number"?$.characterDelta:0),ye===0&&oe===0?this:new S(this.line+ye,this.character+oe)}with($,oe=this.character){if($===null||oe===null)throw(0,A.illegalArgument)();let ye;return typeof $=="undefined"?ye=this.line:typeof $=="number"?ye=$:(ye=typeof $.line=="number"?$.line:this.line,oe=typeof $.character=="number"?$.character:this.character),ye===this.line&&oe===this.character?this:new S(ye,oe)}toJSON(){return{line:this.line,character:this.character}}};m=S=je([w],m),e.Position=m;let C=v=class{constructor($,oe,ye,ze){let Xe,ot;if(typeof $=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new m($,oe),ot=new m(ye,ze)):$ instanceof m&&oe instanceof m&&(Xe=$,ot=oe),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this._start=Xe,this._end=ot):(this._start=ot,this._end=Xe)}static isRange($){return $ instanceof v?!0:$?m.isPosition($.start)&&m.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof v?this.contains($._start)&&this.contains($._end):$ instanceof m?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const oe=m.Max($.start,this._start),ye=m.Min($.end,this._end);if(!oe.isAfter(ye))return new v(oe,ye)}union($){if(this.contains($))return this;if($.contains(this))return $;const oe=m.Min($.start,this._start),ye=m.Max($.end,this.end);return new v(oe,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,oe=this.end){if($===null||oe===null)throw(0,A.illegalArgument)();let ye;return $?m.isPosition($)?ye=$:(ye=$.start||this.start,oe=$.end||this.end):ye=this.start,ye.isEqual(this._start)&&oe.isEqual(this.end)?this:new v(ye,oe)}toJSON(){return[this.start,this.end]}};C=v=je([w],C),e.Range=C;let L=E=class extends C{constructor($,oe,ye,ze){let Xe,ot;if(typeof $=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new m($,oe),ot=new m(ye,ze)):$ instanceof m&&oe instanceof m&&(Xe=$,ot=oe),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot);this._anchor=Xe,this._active=ot}static isSelection($){return $ instanceof E?!0:$?C.isRange($)&&m.isPosition($.anchor)&&m.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=E=je([w],L),e.Selection=L;class B{constructor($,oe,ye){if(typeof $!="string"||$.length===0)throw(0,A.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,A.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,A.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(oe),this.connectionToken=ye}}e.ResolvedAuthority=B;class ee extends Error{constructor($,oe=T.RemoteAuthorityResolverErrorCode.Unknown,ye){super($);this._message=$,this._code=oe,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable($,oe){return new ee($,T.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable($){return new ee($,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var H;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var x;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=c=class{constructor($,oe){this._range=$,this._newText=oe}static isTextEdit($){return $ instanceof c?!0:$?C.isRange($)&&typeof $.newText=="string":!1}static replace($,oe){return new c($,oe)}static insert($,oe){return c.replace(new C($,$),oe)}static delete($){return c.replace($,"")}static setEndOfLine($){const oe=new c(new C(new m(0,0),new m(0,0)),"");return oe.newEol=$,oe}get range(){return this._range}set range($){if($&&!C.isRange($))throw(0,A.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,A.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,A.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=c=je([w],W),e.TextEdit=W;var F;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,oe,ye,ze){this._edits.push({_type:1,from:$,to:oe,options:ye,metadata:ze})}createFile($,oe,ye){this._edits.push({_type:1,from:void 0,to:$,options:oe,metadata:ye})}deleteFile($,oe,ye){this._edits.push({_type:1,from:$,to:void 0,options:oe,metadata:ye})}replaceNotebookMetadata($,oe,ye){this._edits.push({_type:3,metadata:ye,uri:$,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells($,oe,ye,ze,Xe){(oe!==ye||ze.length>0)&&this._edits.push({_type:5,uri:$,index:oe,count:ye-oe,cells:ze,metadata:Xe})}replaceNotebookCellOutput($,oe,ye,ze){this._editNotebookCellOutput($,oe,!1,ye,ze)}appendNotebookCellOutput($,oe,ye,ze){this._editNotebookCellOutput($,oe,!0,ye,ze)}replaceNotebookCellOutputItems($,oe,ye,ze,Xe){this._editNotebookCellOutputItems($,oe,ye,!1,ze,Xe)}appendNotebookCellOutputItems($,oe,ye,ze,Xe){this._editNotebookCellOutputItems($,oe,ye,!0,ze,Xe)}_editNotebookCellOutputItems($,oe,ye,ze,Xe,ot){this._edits.push({_type:6,metadata:ot,uri:$,index:oe,outputId:ye,append:ze,newOutputItems:Xe})}_editNotebookCellOutput($,oe,ye,ze,Xe){this._edits.push({_type:4,metadata:Xe,uri:$,index:oe,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata($,oe,ye,ze){this._edits.push({_type:3,metadata:ze,uri:$,edit:{editType:11,index:oe,metadata:ye}})}replace($,oe,ye,ze){this._edits.push({_type:2,uri:$,edit:new W(oe,ye),metadata:ze})}insert($,oe,ye,ze){this.replace($,new C(oe,oe),ye,ze)}delete($,oe,ye){this.replace($,oe,"",ye)}has($){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===$.toString())}set($,oe){if(oe)for(const ye of oe)ye&&this._edits.push({_type:2,uri:$,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===$.toString()&&(this._edits[ye]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get($){const oe=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===$.toString()&&oe.push(ye.edit);return oe}entries(){const $=new I.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ye=$.get(oe.uri);ye||(ye=[oe.uri,[]],$.set(oe.uri,ye)),ye[1].push(oe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([w],U),e.WorkspaceEdit=U;let M=u=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof u?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=u._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,oe=this._tabstop++){if(typeof $=="function"){const ye=new u;ye._tabstop=this._tabstop,$(ye),this._tabstop=ye._tabstop,$=ye.value}else $=u._escape($);return this.value+="${",this.value+=oe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,oe=this._tabstop++){const ye=$.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable($,oe){if(typeof oe=="function"){const ye=new u;ye._tabstop=this._tabstop,oe(ye),this._tabstop=ye._tabstop,oe=ye.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};M=u=je([w],M),e.SnippetString=M;var N;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=s=class{constructor($,oe){if(this.uri=$,oe)if(oe instanceof C)this.range=oe;else if(oe instanceof m)this.range=new C(oe,oe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof s?!0:$?C.isRange($.range)&&P.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=s=je([w],V),e.Location=V;let q=class{constructor($,oe){this.location=$,this.message=oe}static is($){return $?typeof $.message=="string"&&$.location&&C.isRange($.location.range)&&P.URI.isUri($.location.uri):!1}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.location.range.isEqual(oe.location.range)&&$.location.uri.toString()===oe.location.uri.toString()}};q=je([w],q),e.DiagnosticRelatedInformation=q;let X=class{constructor($,oe,ye=O.Error){if(!C.isRange($))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=$,this.message=oe,this.severity=ye}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.severity===oe.severity&&$.code===oe.code&&$.severity===oe.severity&&$.source===oe.source&&$.range.isEqual(oe.range)&&(0,b.equals)($.tags,oe.tags)&&(0,b.equals)($.relatedInformation,oe.relatedInformation,q.isEqual)}};X=je([w],X),e.Diagnostic=X;let fe=class{constructor($,oe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:(0,R.isMarkdownString)($)?this.contents=[$]:this.contents=[$],this.range=oe}};fe=je([w],fe),e.Hover=fe;var ve;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor($,oe=ve.Text){this.range=$,this.kind=oe}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Ae=je([w],Ae),e.DocumentHighlight=Ae;var Ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var Fe;(function(j){j[j.Deprecated=1]="Deprecated"})(Fe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor($,oe,ye,ze,Xe){this.name=$,this.kind=oe,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),ze instanceof V?this.location=ze:ye instanceof C&&(this.location=new V(ze,ye)),t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};z=t=je([w],z),e.SymbolInformation=z;let J=i=class{constructor($,oe,ye,ze,Xe){this.name=$,this.detail=oe,this.kind=ye,this.range=ze,this.selectionRange=Xe,this.children=[],i.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(i.validate)}};J=i=je([w],J),e.DocumentSymbol=J;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor($,oe){this.title=$,this.kind=oe}};ae=je([w],ae),e.CodeAction=ae;let he=o=class{constructor($){this.value=$}append($){return new o(this.value?this.value+o.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+o.sep)}};he.sep=".",he=o=je([w],he),e.CodeActionKind=he,he.Empty=new he(""),he.QuickFix=he.Empty.append("quickfix"),he.Refactor=he.Empty.append("refactor"),he.RefactorExtract=he.Refactor.append("extract"),he.RefactorInline=he.Refactor.append("inline"),he.RefactorRewrite=he.Refactor.append("rewrite"),he.Source=he.Empty.append("source"),he.SourceOrganizeImports=he.Source.append("organizeImports"),he.SourceFixAll=he.Source.append("fixAll");let De=class{constructor($,oe){if(this.range=$,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([w],De),e.SelectionRange=De;class Me{constructor($,oe,ye,ze,Xe,ot){this.kind=$,this.name=oe,this.detail=ye,this.uri=ze,this.range=Xe,this.selectionRange=ot}}e.CallHierarchyItem=Me;class we{constructor($,oe){this.fromRanges=oe,this.from=$}}e.CallHierarchyIncomingCall=we;class ke{constructor($,oe){this.fromRanges=oe,this.to=$}}e.CallHierarchyOutgoingCall=ke;let Te=class{constructor($,oe){this.range=$,this.command=oe}get isResolved(){return!!this.command}};Te=je([w],Te),e.CodeLens=Te;let xe=r=class{constructor($,oe=!1){_.set(this,void 0),nt(this,_,new R.MarkdownString($,{supportThemeIcons:oe}))}static isMarkdownString($){return $ instanceof r?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Be(this,_).value}set value($){Be(this,_).value=$}get isTrusted(){return Be(this,_).isTrusted}set isTrusted($){Be(this,_).isTrusted=$}get supportThemeIcons(){return Be(this,_).supportThemeIcons}appendText($){return Be(this,_).appendText($),this}appendMarkdown($){return Be(this,_).appendMarkdown($),this}appendCodeblock($,oe){return Be(this,_).appendCodeblock(oe!=null?oe:"",$),this}};_=new WeakMap,xe=r=je([w],xe),e.MarkdownString=xe;let Se=class{constructor($,oe){this.label=$,this.documentation=oe}};Se=je([w],Se),e.ParameterInformation=Se;let Ge=class{constructor($,oe){this.label=$,this.documentation=oe,this.parameters=[]}};Ge=je([w],Ge),e.SignatureInformation=Ge;let Q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Q=je([w],Q),e.SignatureHelp=Q;var ie;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var be;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(be=e.InlineHintKind||(e.InlineHintKind={}));let Oe=class{constructor($,oe,ye){this.text=$,this.range=oe,this.kind=ye}};Oe=je([w],Oe),e.InlineHint=Oe;var Ve;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(We=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(j){j[j.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor($,oe){this.label=$,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&We[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([w],K),e.CompletionItem=K;let se=class{constructor($=[],oe=!1){this.items=$,this.isIncomplete=oe}};se=je([w],se),e.CompletionList=se;var de;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var Y;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Y=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var me;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(me=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _e;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var He;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(He=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $e=class{constructor($,oe){if(oe&&!P.URI.isUri(oe))throw(0,A.illegalArgument)("target");if(!C.isRange($)||$.isEmpty)throw(0,A.illegalArgument)("range");this.range=$,this.target=oe}};$e=je([w],$e),e.DocumentLink=$e;let Ke=class{constructor($,oe,ye,ze){this.red=$,this.green=oe,this.blue=ye,this.alpha=ze}};Ke=je([w],Ke),e.Color=Ke;let Je=class{constructor($,oe){if(oe&&!(oe instanceof Ke))throw(0,A.illegalArgument)("color");if(!C.isRange($)||$.isEmpty)throw(0,A.illegalArgument)("range");this.range=$,this.color=oe}};Je=je([w],Je),e.ColorInformation=Je;let Ze=class{constructor($){if(!$||typeof $!="string")throw(0,A.illegalArgument)("label");this.label=$}};Ze=je([w],Ze),e.ColorPresentation=Ze;var ut;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var lt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var qe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ee=l=class{constructor($,oe){if(typeof $!="string"||typeof oe!="string")throw(0,A.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ee.Clean=new l("clean","Clean"),Ee.Build=new l("build","Build"),Ee.Rebuild=new l("rebuild","Rebuild"),Ee.Test=new l("test","Test"),Ee=l=je([w],Ee),e.TaskGroup=Ee;function Ce(j){let $="";for(let oe=0;oe<j.length;oe++)$+=j[oe].replace(/,/g,",,")+",";return $}let ce=class{constructor($,oe,ye){if(typeof $!="string")throw(0,A.illegalArgument)("process");this._args=[],this._process=$,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ye):this._options=oe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,A.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)$.push(oe);return Ce($)}};ce=je([w],ce),e.ProcessExecution=ce;let G=class{constructor($,oe,ye){if(this._args=[],Array.isArray(oe)){if(!$)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,A.illegalArgument)("command");this._command=$,this._args=oe,this._options=ye}else{if(typeof $!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=$,this._options=oe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,A.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,A.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)$.push(typeof oe=="string"?oe:oe.value);return Ce($)}};G=je([w],G),e.ShellExecution=G;var Ne;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ne=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class et{constructor($){this._callback=$}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=et;let Qe=f=class{constructor($,oe,ye,ze,Xe,ot){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ye,this.execution=ze,dt=Xe,this.__deprecated=!0):oe===Re.Global||oe===Re.Workspace?(this.target=oe,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=ot):(this.target=oe,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof G?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,A.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const oe=this._definition.type;(f.EmptyType===oe||f.ProcessType===oe||f.ShellType===oe||f.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=f=je([w],Qe),e.Task=Qe;var at;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor($,oe=Ye.None){this.collapsibleState=oe,P.URI.isUri($)?this.resourceUri=$:this.label=$}};rt=je([w],rt),e.TreeItem=rt;var Ye;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ye=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor($,oe){this.id=$,this.color=oe}};st=je([w],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let vt=class{constructor($){this.id=$}};vt=je([w],vt),e.ThemeColor=vt;var mt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(mt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor($,oe){if(typeof $!="string"&&(!$||!P.URI.isUri($)&&!P.URI.isUri($.uri)))throw(0,A.illegalArgument)("base");if(typeof oe!="string")throw(0,A.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=P.URI.file($),this.base=$):P.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=oe}};Ct=je([w],Ct),e.RelativePattern=Ct;let wt=class{constructor($,oe,ye,ze){this.enabled=typeof $=="boolean"?$:!0,typeof oe=="string"&&(this.condition=oe),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};wt=je([w],wt),e.Breakpoint=wt;let St=class extends wt{constructor($,oe,ye,ze,Xe){super(oe,ye,ze,Xe);if($===null)throw(0,A.illegalArgument)("location");this.location=$}};St=je([w],St),e.SourceBreakpoint=St;let pt=class extends wt{constructor($,oe,ye,ze,Xe){super(oe,ye,ze,Xe);this.functionName=$}};pt=je([w],pt),e.FunctionBreakpoint=pt;let Ft=class extends wt{constructor($,oe,ye,ze,Xe,ot,dt){super(ze,Xe,ot,dt);if(!oe)throw(0,A.illegalArgument)("dataId");this.label=$,this.dataId=oe,this.canPersist=ye}};Ft=je([w],Ft),e.DataBreakpoint=Ft;let Mt=class{constructor($,oe,ye){this.command=$,this.args=oe||[],this.options=ye}};Mt=je([w],Mt),e.DebugAdapterExecutable=Mt;let ft=class{constructor($,oe){this.port=$,this.host=oe}};ft=je([w],ft),e.DebugAdapterServer=ft;let yt=class{constructor($){this.path=$}};yt=je([w],yt),e.DebugAdapterNamedPipeServer=yt;let jt=class{constructor($){this.implementation=$}};jt=je([w],jt),e.DebugAdapterInlineImplementation=jt;let Qt=class{constructor($,oe){this.range=$,this.expression=oe}};Qt=je([w],Qt),e.EvaluatableExpression=Qt;let Ot=class{constructor($,oe){this.range=$,this.text=oe}};Ot=je([w],Ot),e.InlineValueText=Ot;let ht=class{constructor($,oe,ye=!0){this.range=$,this.variableName=oe,this.caseSensitiveLookup=ye}};ht=je([w],ht),e.InlineValueVariableLookup=ht;let Xt=class{constructor($,oe){this.range=$,this.expression=oe}};Xt=je([w],Xt),e.InlineValueEvaluatableExpression=Xt;let It=class{constructor($,oe){this.frameId=$,this.stoppedLocation=oe}};It=je([w],It),e.InlineValueContext=It;var Ut;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ut=e.FileChangeType||(e.FileChangeType={}));let qt=p=class extends Error{constructor($,oe=n.FileSystemProviderErrorCode.Unknown,ye){var ze;super(P.URI.isUri($)?$.toString(!0):$);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists($){return new p($,n.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound($){return new p($,n.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory($){return new p($,n.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory($){return new p($,n.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions($){return new p($,n.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable($){return new p($,n.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};qt=p=je([w],qt),e.FileSystemError=qt;let Jt=class{constructor($,oe,ye){this.start=$,this.end=oe,this.kind=ye}};Jt=je([w],Jt),e.FoldingRange=Jt;var sn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(pn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class Nt{constructor($,oe=[]){this.tokenTypes=$,this.tokenModifiers=oe}}e.SemanticTokensLegend=Nt;function vn(j){return typeof j=="undefined"||(0,D.isStringArray)(j)}class xt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let oe=0,ye=$.tokenTypes.length;oe<ye;oe++)this._tokenTypeStrToInt.set($.tokenTypes[oe],oe);for(let oe=0,ye=$.tokenModifiers.length;oe<ye;oe++)this._tokenModifierStrToInt.set($.tokenModifiers[oe],oe)}}push($,oe,ye,ze,Xe){if(typeof $=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded($,oe,ye,ze,Xe);if(C.isRange($)&&typeof oe=="string"&&vn(ye))return this._push($,oe,ye);throw(0,A.illegalArgument)()}_push($,oe,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const ze=$.start.line,Xe=$.start.character,ot=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(oe);let Et=0;if(ye)for(const kt of ye){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(kt);Et|=1<<Pt>>>0}this._pushEncoded(ze,Xe,ot,dt,Et)}_pushEncoded($,oe,ye,ze,Xe){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Et=this._data.length/5|0;let kt=0,Pt=0;for(let At=0;At<Et;At++){let Rt=this._data[5*At],tn=this._data[5*At+1];Rt===0?(Rt=kt,tn+=Pt):Rt+=kt,this._data[5*At]=Rt,this._data[5*At+1]=tn,kt=Rt,Pt=tn}}let ot=$,dt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Xe,this._prevLine=$,this._prevChar=oe}static _sortAndDeltaEncode($){let oe=[];const ye=$.length/5|0;for(let dt=0;dt<ye;dt++)oe[dt]=dt;oe.sort((dt,Et)=>{const kt=$[5*dt],Pt=$[5*Et];if(kt===Pt){const At=$[5*dt+1],Rt=$[5*Et+1];return At-Rt}return kt-Pt});const ze=new Uint32Array($.length);let Xe=0,ot=0;for(let dt=0;dt<ye;dt++){const Et=5*oe[dt],kt=$[Et+0],Pt=$[Et+1],At=$[Et+2],Rt=$[Et+3],tn=$[Et+4],Rn=kt-Xe,Nn=Rn===0?Pt-ot:Pt,nn=5*dt;ze[nn+0]=Rn,ze[nn+1]=Nn,ze[nn+2]=At,ze[nn+3]=Rt,ze[nn+4]=tn,Xe=kt,ot=Pt}return ze}build($){return this._dataIsSortedAndDeltaEncoded?new Wt(new Uint32Array(this._data),$):new Wt(xt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=xt;class Wt{constructor($,oe){this.resultId=oe,this.data=$}}e.SemanticTokens=Wt;class wn{constructor($,oe,ye){this.start=$,this.deleteCount=oe,this.data=ye}}e.SemanticTokensEdit=wn;class _n{constructor($,oe){this.resultId=oe,this.edits=$}}e.SemanticTokensEdits=_n;var Tt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Tt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new st("arrow-left")},Kt=je([w],Kt),e.QuickInputButtons=Kt;var En;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(En=e.ExtensionKind||(e.ExtensionKind={}));class Sn{constructor($,oe,ye){this.badge=$,this.tooltip=oe,this.color=ye}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Sn;let $t=class{constructor($){this.kind=$}};$t=je([w],$t),e.ColorTheme=$t;var an;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class ln{constructor($,oe){if($<0)throw(0,A.illegalArgument)("start must be positive");if(oe<$)throw(0,A.illegalArgument)("end cannot be smaller than start");this._start=$,this._end=oe}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=ln;class Bt{constructor($,oe,ye,ze,Xe,ot,dt){this.editable=$,this.breakpointMargin=oe,this.hasExecutionOrder=ye,this.statusMessage=ze,this.inputCollapsed=Xe,this.outputCollapsed=ot,this.custom=dt}with($){let{editable:oe,breakpointMargin:ye,hasExecutionOrder:ze,statusMessage:Xe,inputCollapsed:ot,outputCollapsed:dt,custom:Et}=$;return oe===void 0?oe=this.editable:oe===null&&(oe=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.statusMessage:Xe===null&&(Xe=void 0),ot===void 0?ot=this.inputCollapsed:ot===null&&(ot=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),Et===void 0?Et=this.custom:Et===null&&(Et=void 0),oe===this.editable&&ye===this.breakpointMargin&&ze===this.hasExecutionOrder&&Xe===this.statusMessage&&ot===this.inputCollapsed&&dt===this.outputCollapsed&&Et===this.custom?this:new Bt(oe,ye,ze,Xe,ot,dt,Et)}}e.NotebookCellMetadata=Bt;class Le{constructor($=!0,oe=!0,ye=!0,ze={},Xe=!0){this.editable=$,this.cellEditable=oe,this.cellHasExecutionOrder=ye,this.custom=ze,this.trusted=Xe}with($){let{editable:oe,cellEditable:ye,cellHasExecutionOrder:ze,custom:Xe,trusted:ot}=$;return oe===void 0?oe=this.editable:oe===null&&(oe=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.custom:Xe===null&&(Xe=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),oe===this.editable&&ye===this.cellEditable&&ze===this.cellHasExecutionOrder&&Xe===this.custom&&ot===this.trusted?this:new Le(oe,ye,ze,Xe,ot)}}e.NotebookDocumentMetadata=Le;class Yt{constructor($,oe,ye,ze,Xe,ot){this.kind=$,this.source=oe,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Xe,this.latestExecutionSummary=ot}}e.NotebookCellData=Yt;class Zt{constructor($,oe){this.cells=$,this.metadata=oe!=null?oe:new Le}}e.NotebookData=Zt;class gt{constructor($,oe,ye){this.mime=$,this.value=oe,this.metadata=ye}static isNotebookCellOutputItem($){return $ instanceof gt}}e.NotebookCellOutputItem=gt;class yn{constructor($,oe,ye){this.outputs=$,typeof oe=="string"?(this.id=oe,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=oe!=null?oe:ye)}}e.NotebookCellOutput=yn;var Dn;(function(j){j[j.Markdown=1]="Markdown",j[j.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var un;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(un=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let en=class{constructor($,oe){this.label=$,this.timestamp=oe}};en=je([w],en),e.TimelineItem=en;var kn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var dn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(dn=e.StandardTokenType||(e.StandardTokenType={}));class Pn{constructor($,oe){this.ranges=$,this.wordPattern=oe}}e.LinkedEditingRanges=Pn;var An;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(An=e.TestResult||(e.TestResult={}));var hn;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(hn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Gt=(j,$,oe)=>{let ye=oe;return{enumerable:!0,configurable:!1,get(){return ye},set(ze){var Xe;(Xe=j[e.TestItemHookProperty])===null||Xe===void 0||Xe.setProp($,ze),ye=ze}}};class fn{constructor($){g.set(this,new Map),a.set(this,void 0),nt(this,a,$)}get size(){return Be(this,g).size}add($){const oe=Be(this,g),ye=Be(this,a).call(this),ze=oe.get($.id);ze!==$&&(ze&&(ye==null||ye.delete($.id)),oe.set($.id,$),ye==null||ye.created($))}get($){return Be(this,g).get($)}clear(){for(const $ of Be(this,g).keys())this.delete($)}delete($){var oe;const ye=typeof $=="string"?$:$.id;Be(this,g).has(ye)&&(Be(this,g).delete(ye),(oe=Be(this,a).call(this))===null||oe===void 0||oe.delete(ye))}toJSON(){return[...Be(this,g).values()]}[(g=new WeakMap,a=new WeakMap,Symbol.iterator)](){return Be(this,g).values()}}e.TestChildrenCollection=fn;class re{constructor($,oe,ye,ze){this.label=oe,this.expandable=ze,Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},children:{value:new fn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:Gt(this,"range",void 0),description:Gt(this,"description",void 0),runnable:Gt(this,"runnable",!0),debuggable:Gt(this,"debuggable",!0)})}invalidate(){var $;($=this[e.TestItemHookProperty])===null||$===void 0||$.invalidate(this.id)}discoverChildren($,oe){$.report({busy:!1})}}e.TestItem=re;class ue{constructor($){this.state=$,this.messages=[]}}e.TestState=ue;class Pe{constructor($){this.message=$,this.severity=hn.Error}static diff($,oe,ye){const ze=new Pe($);return ze.expectedOutput=oe,ze.actualOutput=ye,ze}}e.TestMessage=Pe;var ct;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ct=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unknown=2]="Unknown"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,52,11,10,143,105,7,14]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(a,h){h?n.set(a,h):n.delete(a)}e.setWordDefinitionFor=T;function k(a){return n.get(a)}e.getWordDefinitionFor=k;class _ extends I.MirrorTextModel{constructor(h,S,v,E,c,u,s,t){super(S,v,E,c);this._proxy=h,this._languageId=u,this._isDirty=s,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,y.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===A.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(S){return S?h._getTextInRange(S):h.getText()},get eol(){return h._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(S){return h._lineAt(S)},offsetAt(S){return h._offsetAt(S)},positionAt(S){return h._positionAt(S)},validateRange(S){return h._validateRange(S)},validatePosition(S){return h._validatePosition(S)},getWordRangeAtPosition(S,v){return h._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,b.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,b.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const S=this._validateRange(h);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,E=S.start.line,c=S.end.line,u=[];u.push(this._lines[E].substring(S.start.character));for(let s=E+1;s<c;s++)u.push(this._lines[s]);return u.push(this._lines[c].substring(0,S.end.character)),u.join(v)}_lineAt(h){let S;if(h instanceof P.Position?S=h.line:typeof h=="number"&&(S=h),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(h),v=this._lines[S.index].length;return new P.Position(S.index,Math.min(S.remainder,v))}_validateRange(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const S=this._validatePosition(h.start),v=this._validatePosition(h.end);return S===h.start&&v===h.end?h:new P.Range(S.line,S.character,v.line,v.character)}_validatePosition(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:S,character:v}=h,E=!1;if(S<0)S=0,v=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,E=!0;else{const c=this._lines[S].length;v<0?(v=0,E=!0):v>c&&(v=c,E=!0)}return E?new P.Position(S,v):h}_getWordRangeAtPosition(h,S){const v=this._validatePosition(h);if(!S)S=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,D.getWordAtText)(v.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[v.line],0);if(E)return new P.Range(v.line,E.startColumn-1,v.line,E.endColumn-1)}}e.ExtHostDocumentData=_;class g{constructor(h,S,v){this._line=h,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[195],pe([0,1,7,3,107,6,76,23,2,28]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(_,g,a,h){this._notebook=a,this._selector=h,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(v=>{const E=this._cellUris.get(v.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(_.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const _=[],g=[];for(const a of this._notebook.cells)a.kind===b.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),_.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(_)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(_){var g,a;if(!_){let c="";for(const u of this._cells)c+=u.document.getText()+`
`;return c=c.slice(0,-1),c}if(_.isEmpty)return"";const h=this.locationAt(_.start),S=this.locationAt(_.end),v=this._cells[(g=this._cellUris.get(h.uri))!==null&&g!==void 0?g:-1],E=this._cells[(a=this._cellUris.get(S.uri))!==null&&a!==void 0?a:-1];if(!v||!E)return"";if(v===E)return v.document.getText(new b.Range(h.range.start,S.range.end));{const c=v.document.getText(new b.Range(h.range.start,new b.Position(v.document.lineCount,0))),u=E.document.getText(new b.Range(new b.Position(0,0),S.range.end));return c+`
`+u}}offsetAt(_){const g=this._cellLines.getIndexOf(_.line),a=this._cellLengths.getAccumulatedValue(g.index-1),h=this._cells[g.index].document.offsetAt(_.with(g.remainder));return a+h}positionAt(_){if(typeof _=="number"){const a=this._cellLengths.getIndexOf(_),h=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const g=this._cellUris.get(_.uri);if(g!==void 0){const a=this._cellLines.getAccumulatedValue(g-1);return new b.Position(a+_.range.start.line,_.range.start.character)}return new b.Position(0,0)}locationAt(_){b.Range.isRange(_)||(_=new b.Range(_,_));const g=this._cellLines.getIndexOf(_.start.line);let a=g;_.isEmpty||(a=this._cellLines.getIndexOf(_.end.line));const h=new b.Position(g.remainder,_.start.character),S=new b.Position(a.remainder,_.end.character),v=new b.Range(h,S),E=this._cells[g.index];return new b.Location(E.document.uri,E.document.validateRange(v))}contains(_){return this._cellUris.has(_)}validateRange(_){const g=this.validatePosition(_.start),a=this.validatePosition(_.end);return _.with(g,a)}validatePosition(_){const g=this._cellLines.getIndexOf(_.line),a=new b.Position(g.remainder,_.character),h=this._cells[g.index].document.validatePosition(a),S=this._cellLines.getAccumulatedValue(g.index-1);return new b.Position(S+h.line,h.character)}}e.ExtHostNotebookConcatDocument=T}),define(ge[196],pe([0,1,7,13,3]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(P){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let y=P==="light"?b.ColorThemeKind.Light:P==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([Ue(0,A.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(ge[61],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class A{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=A}),define(ge[84],pe([0,1,2]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function A(I,D,P){const y=I.webviewResourceRoot.replace("{{resource}}",P.scheme+R(P)).replace("{{uuid}}",D);return b.URI.parse(y)}e.asWebviewUri=A;function R(I){return I.toString().replace(/^\S+?:/,"")}}),define(ge[197],pe([0,1,3,6,84,28]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new A.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const _ of this._insets.values())k.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,k,_){let g;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){g=u;break}if(!g)throw new Error("not a visible editor");const a=this,h=this._handlePool++,S=new b.Emitter,v=new b.Emitter,E=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,R.asWebviewUri)(a._initData,this._uuid,u)}get cspSource(){return a._initData.webviewCspSource}set options(u){this._options=u,a._proxy.$setOptions(h,u)}get options(){return this._options}set html(u){this._html=u,a._proxy.$setHtml(h,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return a._proxy.$postMessage(h,u)}},c=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=E,this.onDidDispose=v.event}dispose(){a._insets.has(h)&&(a._insets.delete(h),a._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(h,g.id,g.value.document.uri,n+1,T,k||{},_.identifier,_.extensionLocation),this._insets.set(h,{editor:y,inset:c,onDidReceiveMessage:S}),c}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=D}),define(ge[198],pe([0,1,3,80,167,4,6,23,40,14,53,22,47,191]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",_.Codicon.window,(0,R.localize)(0,null));var a;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=v;class E extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(f,p,w){var d;const m=this.get(f.id);if(m)return m;const C=f;return C.openCommandActionDescriptor=(w==null?void 0:w.donotRegisterOpenCommand)?void 0:(d=C.openCommandActionDescriptor)!==null&&d!==void 0?d:{id:C.id},(0,P.getOrSet)(this.viewContainers,p,[]).push(C),(w==null?void 0:w.isDefault)&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:p}),C}deregisterViewContainer(f){for(const p of this.viewContainers.keys()){const w=this.viewContainers.get(p),d=w==null?void 0:w.indexOf(f);if(d!==-1){w==null||w.splice(d,1),w.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:p});return}}}get(f){return this.all.filter(p=>p.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(w=>(w==null?void 0:w.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===f)}}y.Registry.add(a.ViewContainersRegistry,new E);var c;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function u(l,f){var p,w,d,m;const C=(p=l.group)!==null&&p!==void 0?p:c.More,L=(w=f.group)!==null&&w!==void 0?w:c.More;return C!==L?C.localeCompare(L):((d=l.order)!==null&&d!==void 0?d:5)-((m=f.order)!==null&&m!==void 0?m:5)}class s extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(f,p){this.registerViews2([{views:f,viewContainer:p}])}registerViews2(f){f.forEach(({views:p,viewContainer:w})=>this.addViews(p,w)),this._onViewsRegistered.fire(f)}deregisterViews(f,p){const w=this.removeViews(f,p);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:p})}moveViews(f,p){for(const w of this._views.keys())if(w!==p){const d=this.removeViews(f,w);d.length&&(this.addViews(d,p),this._onDidChangeContainer.fire({views:d,from:w,to:p}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const p of this._viewContainers){const w=(this._views.get(p)||[]).filter(d=>d.id===f)[0];if(w)return w}return null}getViewContainer(f){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(d=>d.id===f)[0])return p;return null}registerViewWelcomeContent(f,p){return this._viewWelcomeContents.add(f,p),this._onDidChangeViewWelcomeContent.fire(f),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(f,p),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,p){const w=new Map;for(const[d,m]of p)this._viewWelcomeContents.add(f,m),w.set(d,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),w}getViewWelcomeContent(f){const p=[];return this._viewWelcomeContents.forEach(f,w=>p.push(w)),p.sort(u)}addViews(f,p){let w=this._views.get(p);w||(w=[],this._views.set(p,w),this._viewContainers.push(p));for(const d of f){if(this.getView(d.id)!==null)throw new Error((0,R.localize)(1,null,d.id));w.push(d)}}removeViews(f,p){const w=this._views.get(p);if(!w)return[];const d=[],m=[];for(const C of w)f.includes(C)?d.push(C):m.push(C);return d.length&&(m.length?this._views.set(p,m):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),d}}y.Registry.add(a.ViewsRegistry,new s),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new A.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(f,p){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,f),this._hasResolve=!!p,this.resolve=async w=>{var d,m;if(p&&!this.resolved){const C=await p(w);C&&(this.tooltip=(d=this.tooltip)!==null&&d!==void 0?d:C.tooltip,this.command=(m=this.command)!==null&&m!==void 0?m:C.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[199],pe([0,1,2,178,115,12,179,198]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(h){return(S,...v)=>h(S.get(A.ICommandService),...v)}class n{static execute(S,v){const E={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",A.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),A.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,S){return h.get(R.IWorkspacesService).removeRecentlyOpened([S])});class T{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?b.URI.parse(v):b.URI.file(v):v=b.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",A.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(S,v){const E=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",A.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,S){const v=h.get(R.IWorkspacesService);let E;const c=S.uri,u=S.label,s=S.remoteAuthority;return S.type==="workspace"?E={workspace:await v.getWorkspaceIdentifier(c),label:u,remoteAuthority:s}:S.type==="folder"?E={folderUri:c,label:u,remoteAuthority:s}:E={fileUri:c,label:u,remoteAuthority:s},v.addRecentlyOpened([E])}),A.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(R.IWorkspacesService).getRecentlyOpened()}),A.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,S){const v=h.get(I.ILogService),E=h.get(D.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&v.setLevel(S)}),A.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(I.ILogService).getLevel()}),A.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,S){const v=h.get(P.IViewDescriptorService),E=v.getViewContainerById(S.destinationId);if(!!E){for(const c of S.viewIds){const u=v.getViewDescriptorById(c);(u==null?void 0:u.canMoveView)&&v.moveViewsToContainer([u],E,P.ViewVisibilityState.Default)}await h.get(P.IViewsService).openViewContainer(E.id,!0)}});class _{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=_,_.ID="vscode.moveViews",A.CommandsRegistry.registerCommand({id:_.ID,handler:y(_.execute),description:{description:"Move Views",args:[]}});class g{static execute(S,v){return S.executeCommand("_workbench.open",v)}}g.ID="vscode.open",A.CommandsRegistry.registerCommand(g.ID,y(g.execute));class a{static execute(S,v,E,c,u){return S.executeCommand("_workbench.diff",[v,E,c])}}a.ID="vscode.diff",A.CommandsRegistry.registerCommand(a.ID,y(a.execute))}),define(ge[119],pe([0,1,3,17,168]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,y,n,T){const k={command:P};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const _=setTimeout(()=>{clearTimeout(_);const g=this.pendingRequests.get(k.seq);if(g){this.pendingRequests.delete(k.seq);const a={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,R.localize)(0,null,T,P)};g(a)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,y){return P.type!=="event"||y.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,A.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const y=P,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(P,y){y.type=P,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((y,n)=>P.set(n,y)),await(0,A.timeout)(500),P.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(ge[200],pe([0,1,10,2,8,22,11]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function y(i,o,r){return i.replace(P,function(l,f){return o&&f.length>0&&f[0]!=="_"?l:r&&r.hasOwnProperty(f)?r[f]:l})}e.formatPII=y;function n(i){const o={};for(const r of Object.keys(i))r.startsWith("!")||(o[r]=i[r]);return o}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(o,"extensionhost")||(0,b.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function _(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=_;function g(i,o,r){let l,f=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=p.exec(i);){let d=w.index+1,m=d+w[0].length;if(d<=o&&m>=r){l=w[0],f=d;break}}if(l){let d=/\w+/g,m=null;for(;(m=d.exec(l))&&!(m.index+1+f+m[0].length>=r););m&&(l=l.substring(0,d.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(i){return!!(i&&i.match(a))}e.isUri=h;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(h(i.path))return A.URI.parse(i.path);if((0,R.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function v(i){if(typeof i.path=="object"){const o=A.URI.revive(i.path);if(o)return o.scheme===D.Schemas.file?o.fsPath:o.toString()}return i.path}function E(i,o){const r=o?S:v,l=(0,I.deepClone)(i);return u(l,(f,p)=>{f&&p&&(p.path=r(p))}),l}e.convertToDAPaths=E;function c(i,o){const r=o?S:v,l=(0,I.deepClone)(i);return u(l,(f,p)=>{!f&&p&&(p.path=r(p))}),l}e.convertToVSCPaths=c;function u(i,o){switch(i.type){case"event":const r=i;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":o(!0,l.arguments.source);break;case"breakpointLocations":o(!0,l.arguments.source);break;case"source":o(!0,l.arguments.source);break;case"gotoTargets":o(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(p=>o(!1,p));break;default:break}break;case"response":const f=i;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(p=>o(!1,p.source));break;case"loadedSources":f.body.sources.forEach(p=>o(!1,p));break;case"scopes":f.body.scopes.forEach(p=>o(!1,p.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(p=>o(!1,p.source));break;case"setBreakpoints":f.body.breakpoints.forEach(p=>o(!1,p.source));break;default:break}break}}function s(i){return i.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=s;function t(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}}),define(ge[201],pe([0,1,26,38,169,120,8,10,22,9,180,119]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",u=>this.handleData(u))}sendMessage(E){if(this.outputStream){const c=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${_.TWO_CRLF}${c}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+c))}continue}}else{const c=this.rawData.indexOf(_.TWO_CRLF);if(c!==-1){const s=this.rawData.toString("utf8",0,c).split(_.HEADER_LINESEPARATOR);for(const t of s){const i=t.split(_.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(c+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class g extends _{startSession(){return new Promise((E,c)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",s=>{u?this._onError.fire(s):c(s)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class a extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=a;class h extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return I.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=h;class S extends _{constructor(E,c,u){super();this.adapterExecutable=E,this.debugType=c,this.outputService=u}async startSession(){const E=this.adapterExecutable.command,c=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(E)if(D.isAbsolute(E)){if(!await(0,b.exists)(E))throw new Error(R.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let s=process.env;if(u.env&&Object.keys(u.env).length>0&&(s=y.mixin(y.deepClone(process.env),u.env)),E==="node")if(Array.isArray(c)&&c.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(o.cwd=u.cwd);const r=A.fork(c[0],c.slice(1),o);if(!r.pid)throw new Error(R.localize(2,null,c[0]));this.serverProcess=r}else throw new Error(R.localize(3,null));else{const i={env:s};u.cwd&&(i.cwd=u.cwd),this.serverProcess=A.spawn(E,c,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,o)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(T.ExtensionsChannelId);r&&r.append(i(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(s){this._onError.fire(s)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((E,c)=>{const u=A.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(s,t,i){if(s)return c(s)});u.on("exit",E),u.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,c){if(!!E){const u=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?u.runtime=D.join(c,E.runtime):u.runtime=E.runtime),E.runtimeArgs&&(u.runtimeArgs=E.runtimeArgs),E.program&&(D.isAbsolute(E.program)?u.program=E.program:u.program=D.join(c,E.program)),E.args&&(u.args=E.args);const s=E;return s.win&&(u.win=S.extract(s.win,c)),s.winx86&&(u.winx86=S.extract(s.winx86,c)),s.windows&&(u.windows=S.extract(s.windows,c)),s.osx&&(u.osx=S.extract(s.osx,c)),s.linux&&(u.linux=S.extract(s.linux,c)),u}}static platformAdapterExecutable(E,c){let u=Object.create(null);c=c.toLowerCase();for(const l of E)if(l.contributes){const f=l.contributes.debuggers;f&&f.length>0&&f.filter(p=>typeof p.type=="string"&&P.equalsIgnoreCase(p.type,c)).forEach(p=>{const w=S.extract(p,l.extensionLocation.fsPath);u=y.mixin(u,w,l.isBuiltin)})}let s;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=u.winx86||u.win||u.windows:n.isWindows?s=u.win||u.windows:n.isMacintosh?s=u.osx:n.isLinux&&(s=u.linux),s=s||u;let t=s.program||u.program;const i=s.args||u.args;let o=s.runtime||u.runtime;const r=s.runtimeArgs||u.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(ge[202],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[203],pe([0,1,38,8,77,170,26,9,83,4,202,11]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const _=I.localize(0,null);let g=class Ht{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(b,u,R.getWindowsShell(),c)}}runInTerminal(c,u,s,t,i){const o=i.windowsExec||Ht.getDefaultTerminalWindows();return new Promise((r,l)=>{const f=`"${u} - ${_}"`,p=`""${s.join('" "')}" & pause"`,w=["/c","start",f,"/wait",o,"/c",p],d=Object.assign({},process.env,t);Object.keys(d).filter(L=>d[L]===null).forEach(L=>delete d[L]);const m={cwd:u,env:d,windowsVerbatimArguments:!0};b.spawn(Ht.CMD,w,m).on("error",L=>{l(S(L))}),r(void 0)})}spawnTerminal(c,u,s,t){const o=u.terminal.external.windowsExec||Ht.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=A.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return c.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return o.indexOf(" ")>=0&&l.push('""'),l.push(o),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((f,p)=>{const w=t?{cwd:t}:void 0,d=c.spawn(s,l,w);d.on("error",p),d.on("exit",()=>f())})}static getDefaultTerminalWindows(){if(!Ht._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ht._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return Ht._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=je([Ue(0,(0,n.optional)(y.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let a=class Ln{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(b,u,c)}}runInTerminal(c,u,s,t,i){const o=i.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===T.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const f=o===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,Z).fsPath,"-t",c||_,"-w",u];for(let C of s)w.push("-a"),w.push(C);if(t)for(let C in t){const L=t[C];L===null?(w.push("-u"),w.push(C)):(w.push("-e"),w.push(`${C}=${L}`))}let d="";const m=b.spawn(Ln.OSASCRIPT,w);m.on("error",C=>{l(S(C))}),m.stderr.on("data",C=>{d+=C.toString()}),m.on("exit",C=>{if(C===0)r(void 0);else if(d){const L=d.split(`
`,1);l(new Error(L[0]))}else l(new Error(I.localize(1,null,f,C)))})}else l(new Error(I.localize(2,null,o)))})}spawnTerminal(c,u,s){const i=u.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const l=["-a",i];s&&l.push(s);const f=c.spawn("/usr/bin/open",l);f.on("error",r),f.on("exit",()=>o())})}};a.OSASCRIPT="/usr/bin/osascript",a=je([Ue(0,(0,n.optional)(y.IConfigurationService))],a),e.MacExternalTerminalService=a;let h=class zt{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(b,u,c)}}runInTerminal(c,u,s,t,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let f=[];o.then(p=>{p.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const w=`${v(s)}; echo; read -p "${zt.WAIT_MESSAGE}" -n1;`;f.push(`''${w}''`);const d=Object.assign({},process.env,t);Object.keys(d).filter(B=>d[B]===null).forEach(B=>delete d[B]);const m={cwd:u,env:d};let C="";const L=b.spawn(p,f,m);L.on("error",B=>{l(S(B))}),L.stderr.on("data",B=>{C+=B.toString()}),L.on("exit",B=>{if(B===0)r(void 0);else if(C){const ee=C.split(`
`,1);l(new Error(ee[0]))}else l(new Error(I.localize(4,null,p,B)))})})})}spawnTerminal(c,u,s){const t=u.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{i.then(l=>{const f=s?{cwd:s}:void 0,p=c.spawn(l,[],f);p.on("error",r),p.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return zt._DEFAULT_TERMINAL_LINUX_READY||(zt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async c=>{P.isLinux?await D.exists("/etc/debian_version")?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm"):c("xterm")})),zt._DEFAULT_TERMINAL_LINUX_READY}};h.WAIT_MESSAGE=I.localize(3,null),h=je([Ue(0,(0,n.optional)(y.IConfigurationService))],h),e.LinuxExternalTerminalService=h;function S(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(I.localize(5,null,E.path)):E}function v(E){let c="";for(let u of E)u.indexOf(" ")>=0?c+='"'+u+'"':c+=u,c+=" ";return c}}),define(ge[204],pe([0,1,38,9,203,31]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function P(_,g){if(!D)if(A.isWindows)D=new R.WindowsExternalTerminalService(void 0);else if(A.isMacintosh)D=new R.MacExternalTerminalService(void 0);else if(A.isLinux)D=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=g.getConfiguration("terminal");return D.runInTerminal(_.title,_.cwd,_.args,_.env||{},a.external||{})}e.runInExternalTerminal=P;function y(_,g){return new Promise((a,h)=>{let S="";const v=b.spawn(_,g);v.pid&&v.stdout.on("data",E=>{S+=E.toString()}),v.on("error",E=>{h(E)}),v.on("close",E=>{a(S)})})}function n(_){return _?A.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(h=>parseInt(h)===_),g=>!0):y("/usr/bin/pgrep",["-lP",String(_)]).then(g=>{const a=g.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var T;(function(_){_[_.cmd=0]="cmd",_[_.powershell=1]="powershell",_[_.bash=2]="bash"})(T||(T={}));function k(_,g,a,h){_=_.trim().toLowerCase();let S;_.indexOf("powershell")>=0||_.indexOf("pwsh")>=0?S=1:_.indexOf("cmd.exe")>=0?S=0:_.indexOf("bash")>=0?S=2:A.isWindows?S=0:S=2;let v,E=" ";switch(S){case 1:if(v=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),a){const u=(0,I.getDriveLetter)(a);u&&(E+=`${u}:; `),E+=`cd ${v(a)}; `}if(h)for(let u in h){const s=h[u];s===null?E+=`Remove-Item env:${u}; `:E+=`\${env:${u}}='${s}'; `}if(g.length>0){const u=v(g.shift());E+=u[0]==="'"?`& ${u} `:`${u} `;for(let s of g)E+=`${v(s)} `}break;case 0:if(v=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),a){const u=(0,I.getDriveLetter)(a);u&&(E+=`${u}: && `),E+=`cd ${v(a)} && `}if(h){E+='cmd /C "';for(let u in h){let s=h[u];s===null?E+=`set "${u}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${u}=${s}" && `)}}for(let u of g)E+=`${v(u)} `;h&&(E+='"');break;case 2:v=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const c=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(a&&(E+=`cd ${v(a)} ; `),h){E+="/usr/bin/env";for(let u in h){const s=h[u];s===null?E+=` -u ${c(u)}`:E+=` ${c(`${u}=${s}`)}`}E+=" "}for(let u of g)E+=`${v(u)} `;break}return E}e.prepareCommand=k}),define(ge[85],pe([0,1,34,11,8,9,80]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(C){C[C.Markdown=1]="Markdown",C[C.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(C){C[C.Idle=1]="Idle",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.OutputsSplice=6]="OutputsSplice",C[C.Move=7]="Move",C[C.Unknown=8]="Unknown",C[C.CellContent=9]="CellContent",C[C.OutputItems=10]="OutputItems",C[C.PartialMetadata=11]="PartialMetadata"})(_=e.CellEditType||(e.CellEditType={}));function g(C){const L=a.parse(C);return L?L.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=g;var a;(function(C){C.scheme=A.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function B(W,F){return W.with({scheme:C.scheme,fragment:`ch${F.toString().padStart(7,"0")}${W.scheme!==A.Schemas.file?W.scheme:""}`})}C.generate=B;function ee(W){if(W.scheme===C.scheme){const F=L.exec(W.fragment);if(!!F)return{handle:Number(F[1]),notebook:W.with({scheme:W.fragment.substr(F[0].length)||A.Schemas.file,fragment:null})}}}C.parse=ee;function H(W,F){return W.with({scheme:A.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${W.scheme!==A.Schemas.file?W.scheme:""}`})}C.generateCellMetadataUri=H;function x(W){if(W.scheme===A.Schemas.vscodeNotebookCellMetadata){const F=L.exec(W.fragment);if(!!F)return{handle:Number(F[1]),notebook:W.with({scheme:W.fragment.substr(F[0].length)||A.Schemas.file,fragment:null})}}}C.parseCellMetadataUri=x})(a=e.CellUri||(e.CellUri={}));const h=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(C){var L,B;return(B=(L=h.get(C))===null||L===void 0?void 0:L.alwaysSecure)!==null&&B!==void 0?B:!1}e.mimeTypeIsAlwaysSecure=S;function v(C){var L,B;return(B=(L=h.get(C))===null||L===void 0?void 0:L.supportedByCore)!==null&&B!==void 0?B:!1}e.mimeTypeSupportedByCore=v;function E(C){var L,B;return(B=(L=h.get(C))===null||L===void 0?void 0:L.mergeable)!==null&&B!==void 0?B:!1}e.mimeTypeIsMergeable=E;function c(C,L){return I.isWindows&&(C=C.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),b.match(C,L)}function u(C,L,B){let ee=0;for(let H=0;H<L.length;H++){if(c(L[H],C))return ee;ee++}for(let H=0;H<B.length;H++){if(c(B[H],C))return ee;ee++}return ee}function s(C,L,B){return C.sort((ee,H)=>u(ee,L,B)-u(H,L,B))}e.sortMimeTypes=s;function t(C,L,B,ee=(H,x)=>H===x){const H=[];function x(U,M,N){if(!(M===0&&N.length===0)){const O=H[H.length-1];O&&O.start+O.deleteCount===U?(O.deleteCount+=M,O.toInsert.push(...N)):H.push({start:U,deleteCount:M,toInsert:N})}}let W=0,F=0;for(;;){if(W===C.length){x(W,0,L.slice(F));break}if(F===L.length){x(W,C.length-W,[]);break}const U=C[W],M=L[F];if(ee(U,M)){W+=1,F+=1;continue}B(M)?(x(W,1,[]),W+=1):(x(W,0,[M]),F+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new D.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(C){C.default="default",C.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(C){const L=C;return!!((typeof L.include=="string"||b.isRelativePattern(L.include))&&(typeof L.exclude=="string"||b.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=o;function r(C,L,B){if(Array.isArray(C.viewType)&&C.viewType.indexOf(L)>=0||C.viewType===L)return!0;if(C.filenamePattern){let ee=o(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,H=o(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(b.match(ee,(0,R.basename)(B.fsPath).toLowerCase()))return!(H&&b.match(H,(0,R.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r;class l{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let B=0;B<this.textModel.cells.length;B++)L[B]=this.textModel.cells[B].getHashValue();return L}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var f;(function(C){C[C.LEFT=0]="LEFT",C[C.RIGHT=1]="RIGHT"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function p(C){C.sort((B,ee)=>B-ee);const L=C.shift();return L===void 0?[]:C.reduce(function(B,ee){return ee<=B[0][1]?B[0][1]=ee+1:B.unshift([ee,ee+1]),B},[[L,L+1]]).reverse().map(B=>({start:B[0],end:B[1]}))}e.cellIndexesToRanges=p;function w(C){return C.reduce((B,ee)=>{for(let H=ee.start;H<ee.end;H++)B.push(H);return B},[])}e.cellRangesToIndexes=w;function d(C){const L=C.sort((ee,H)=>ee.start-H.start),B=L[0];return B?L.reduce((ee,H)=>{const x=ee[ee.length-1];return x.end>=H.start?x.end=Math.max(x.end,H.end):ee.push(H),ee},[B]):[]}e.reduceRanges=d;function m(C,L){return L.start>=C.start&&L.end<=C.end}e.cellRangeContains=m}),define(ge[205],pe([0,1,172,4,80]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,A.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[206],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=b;function A(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=A}),define(ge[207],pe([0,1,8,9,134]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(s,t){if(!!t)if(A.isWindows)for(const i in t){let o=i;for(const l in s)if(i.toLowerCase()===l.toLowerCase()){o=l;break}const r=t[i];D(s,o,r)}else Object.keys(t).forEach(i=>{const o=t[i];D(s,i,o)})}e.mergeEnvironments=I;function D(s,t,i){typeof i=="string"?s[t]=i:delete s[t]}function P(s,t,i,o){s.TERM_PROGRAM="vscode",t&&(s.TERM_PROGRAM_VERSION=t),T(s,o)&&(s.LANG=k(i)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function y(s,t){if(!!t)for(const i of Object.keys(t)){const o=t[i];o&&(s[i]=o)}}function n(s,t){return Object.keys(t).forEach(i=>{const o=t[i];if(typeof o=="string")try{t[i]=s(o)}catch(r){t[i]=o}}),t}function T(s,t){if(t==="on")return!0;if(t==="auto"){const i=s.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function k(s){const t=s?s.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=k;function _(s,t,i,o,r,l){if(s.cwd){const p=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,w=g(p,i);return a(w||p)}let f;return!s.ignoreConfigurationCwd&&r&&(i&&(r=g(r,i,l)),r&&(b.isAbsolute(r)?f=r:o&&(f=b.join(o.fsPath,r)))),f||(f=o?o.fsPath:t||""),a(f)}e.getCwd=_;function g(s,t,i){if(t)try{return t(s)}catch(o){i==null||i.error("Could not resolve terminal cwd",o);return}return s}function a(s){return A.platform===3&&s&&s[1]===":"?s[0].toUpperCase()+s.substr(1):s}function h(s){let t=s;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=h;function S(s,t){if(!!t)return i=>t.resolve(s,i)}e.createVariableResolver=S;function v(s,t,i,o,r,l,f,p,w=A.platform){let d=null;p&&(d=c(s,t,"automationShell",w)),d||(d=c(s,t,"shell",w));let m=d||i;if(w===3&&!o&&r){const C=b.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();m&&m.toLowerCase().indexOf(C)===0&&(m=b.join(r,"System32",m.substr(C.length+1)))}if(m&&w===3&&(m=m.replace(/\//g,"\\")),l)try{m=l(m)}catch(C){f.error("Could not resolve shell",C)}return m}e.getDefaultShell=v;function E(s,t,i,o,r,l=A.platform){if(i&&c(s,t,"automationShell",l))return[];const f=l===3?"windows":l===1?"osx":"linux",p=s(`terminal.integrated.shellArgs.${f}`);let w=(t?p.value:p.userValue)||p.defaultValue;if(!w)return[];if(typeof w=="string"&&l===3)return o?o(w):w;if(o){const d=[];for(const m of w)try{d.push(o(m))}catch(C){r.error(`Could not resolve terminal.integrated.shellArgs.${f}`,C),d.push(m)}w=d}return w}e.getDefaultShellArgs=E;function c(s,t,i,o=A.platform){const l=s(`terminal.integrated.${i}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?l.value:l.userValue)||l.defaultValue}function u(s,t,i,o,r,l,f){let p={};if(s.strictEnv)y(p,s.env);else{y(p,f);const w=Object.assign({},o?t.value:t.userValue);i&&(w&&n(i,w),s.env&&n(i,s.env)),(0,R.sanitizeProcessEnvironment)(p,"VSCODE_IPC_HOOK_CLI"),I(p,w),I(p,s.env),P(p,r,A.locale,l)}return p}e.createTerminalEnvironment=u});var rn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],b;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),b={},A("next"),A("throw"),A("return"),b[Symbol.asyncIterator]=function(){return this},b);function A(I){b[I]=Z[I]&&function(D){return new Promise(function(P,y){D=Z[I](D),R(P,y,D.done,D.value)})}}function R(I,D,P,y){Promise.resolve(y).then(function(n){I({value:n,done:P})},D)}};define(ge[208],pe([0,1,37,9,8,100,188,38,26]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function T(c,u,s,t,i,o,r){return A.isWindows?k(c,o,u,s==null?void 0:s.useWslProfiles,s==null?void 0:s.profiles.windows,t,i):S(o,u,c,A.isMacintosh?s==null?void 0:s.profiles.osx:s==null?void 0:s.profiles.linux,r,t,i)}e.detectAvailableProfiles=T;async function k(c,u,s,t,i,o,r){const l=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${process.env.windir}\\${l?"Sysnative":"System32"}`;let p=!1;(0,D.getWindowsBuildNumber)()>=16299&&(p=!0),await g();const w=new Map;c||(w.set("PowerShell",{source:"PowerShell",isAutoDetected:!0}),w.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),w.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),w.set("Command Prompt",{path:[`${f}\\cmd.exe`],isAutoDetected:!0})),v(i,w);const d=await _(w.entries(),s,u,o,r);if(!c||c&&t)try{const m=await h(`${f}\\${p?"wsl.exe":"bash.exe"}`,t);m&&d.push(...m)}catch(m){s==null||s.info("WSL is not installed, so could not detect WSL profiles")}return d}async function _(c,u,s,t,i){const o=[];for(const[r,l]of c)if(l!==null){let f,p;if("source"in l){const m=n==null?void 0:n.get(l.source);if(!m)continue;f=m.paths,p=l.args||m.args}else f=Array.isArray(l.path)?l.path:[l.path],p=A.isWindows||Array.isArray(l.args)?l.args:void 0;const w=f.slice();for(let m=0;m<w.length;m++)w[m]=(t==null?void 0:t.resolve(i,w[m]))||w[m];const d=await E(r,w,s,p,l.overrideName,l.isAutoDetected,u);d?(d.isAutoDetected=l.isAutoDetected,o.push(d)):u==null||u.trace("profile not validated",r,f)}return o}async function g(){n||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),n.set("Cygwin",{profileName:"Cygwin",paths:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:await a()}))}async function a(){var c,u;const s=[];try{for(var t=rn((0,I.enumeratePowerShellInstallations)()),i;i=await t.next(),!i.done;){const o=i.value;s.push(o.exePath)}}catch(o){c={error:o}}finally{try{i&&!i.done&&(u=t.return)&&await u.call(t)}finally{if(c)throw c.error}}return s}async function h(c,u){const s=[];if(u){const t=await new Promise((i,o)=>{P.exec("wsl.exe -l",{encoding:"utf16le"},(r,l)=>{if(r)return o("Problem occurred when getting wsl distros");i(l)})});if(t){const i=new RegExp(/[\r?\n]/),o=t.split(i).filter(r=>r.trim().length>0&&r!=="");o.shift();for(let r of o)r=r.replace(/ \(Default\)$/,""),r!==""&&(r.startsWith("docker-desktop")||s.push({profileName:`${r} (WSL)`,path:c,args:["-d",`${r}`]}));return s}}return[]}async function S(c,u,s,t,i,o,r){const l=new Map;if(!s){const f=await b.promises.readFile("/etc/shells","utf8"),p=i||f.split(`
`).filter(d=>d.trim().indexOf("#")!==0&&d.trim().length>0),w=new Map;for(const d of p){let m=(0,R.basename)(d),C=w.get(m)||0;C++,C>1&&(m=`${m} (${C})`),w.set(m,C),l.set(m,{path:d,isAutoDetected:!0})}}return v(t,l),await _(l.entries(),u,c,o,r)}function v(c,u){if(!!c)for(const[s,t]of Object.entries(c))t===null||!("path"in t)&&!("source"in t)?u.delete(s):u.set(s,t)}async function E(c,u,s,t,i,o,r){if(u.length===0)return Promise.resolve(void 0);const l=u.shift();if(l==="")return E(c,u,s,t,i,o);const f={profileName:c,path:l,args:t,overrideName:i,isAutoDetected:o};if((0,R.basename)(l)===l){const w=process.env.PATH?process.env.PATH.split(R.delimiter):void 0;return await(0,D.findExecutable)(l,void 0,w)?f:E(c,u,s,t)}return(s?await s.existsFile(l):await y.SymlinkSupport.existsFile((0,R.normalize)(l)))?f:E(c,u,s,t,i,o)}}),define(ge[121],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=A;var R;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(R=e.TestDiffOpType||(e.TestDiffOpType={}));const I=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=I;class D{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=D;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const _=k[1];if(_.parent){if(this.items.has(_.parent)){const g=this.items.get(_.parent);g.children.add(_.item.extId);const a=this.createItem(_,g);this.items.set(_.item.extId,a),T.add(a)}}else{this.roots.add(_.item.extId);const g=this.createItem(_);this.items.set(_.item.extId,g),T.add(g)}_.expand===2&&this.updateBusyProviders(1);break}case 1:{const _=k[1],g=this.items.get(_.extId);if(!g)break;(0,e.applyTestItemUpdate)(g,_),T.update(g),_.expand!==void 0&&g.expand===2&&_.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const _=this.items.get(k[1]);if(!_)break;_.parent?this.items.get(_.parent).children.delete(_.item.extId):this.roots.delete(_.item.extId);const g=[[k[1]]];for(;g.length;)for(const a of g.pop()){const h=this.items.get(a);h&&(g.push(h.children),this.items.delete(a),T.remove(h,h!==_),h.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=P}),define(ge[209],pe([0,1,8,30,15,22,9,75,173]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,_,g){if(this._contributedVariables=new Map,this._context=k,this._labelService=_,g)if(D.isWindows){const a=Object.create(null);this._envVariables=a,Object.keys(g).forEach(h=>{a[h.toLowerCase()]=g[h]})}else this._envVariables=g}resolve(k,_){return this.recursiveResolve(k?k.uri:void 0,_)}resolveAnyBase(k,_,g,a){const h=I.deepClone(_);return D.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):D.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):D.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(k?k.uri:void 0,h,g,a)}resolveAny(k,_,g){return this.resolveAnyBase(k,_,g)}resolveAnyMap(k,_,g){const a=new Map;return{newConfig:this.resolveAnyBase(k,_,g,a),resolvedVariables:a}}resolveWithInteractionReplace(k,_,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,_,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,_){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,_)}recursiveResolve(k,_,g,a){if(R.isString(_))return this.resolveString(k,_,g,a);if(R.isArray(_))return _.map(h=>this.recursiveResolve(k,h,g,a));if(R.isObject(_)){let h=Object.create(null);return Object.keys(_).forEach(S=>{const v=this.resolveString(k,S,g,a);h[v]=this.recursiveResolve(k,_[S],g,a)}),h}return _}resolveString(k,_,g,a){return _.replace(n.VARIABLE_REGEXP,(S,v)=>{if(v.includes(n.VARIABLE_LHS))return S;let E=this.evaluateSingleVariable(S,v,k,g);return a&&a.set(v,E),E})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,_,g,a){let h;const S=_.split(":");S.length>1&&(_=S[0],h=S[1]);const v=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,k))},E=()=>{const u=v();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,y.localize)(1,null,k,b.basename(u)))},c=()=>{if(h){const u=this._context.getFolderUri(h);if(u)return u;throw new Error((0,y.localize)(2,null,k,h))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,k)):new Error((0,y.localize)(4,null,k))};switch(_){case"env":if(h){if(this._envVariables){const u=this._envVariables[D.isWindows?h.toLowerCase():h];if(R.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,k));case"config":if(h){const u=this._context.getConfigurationValue(g,h);if(R.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,k,h));if(R.isObject(u))throw new Error((0,y.localize)(7,null,k,h));return u}throw new Error((0,y.localize)(8,null,k));case"command":return this.resolveFromMap(k,h,a,"command");case"input":return this.resolveFromMap(k,h,a,"input");default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return g||h?(0,P.normalizeDriveLetter)(this.fsPath(c())):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(c()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,k));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,y.localize)(10,null,k));case"file":return v();case"fileWorkspaceFolder":return E();case"relativeFile":return g||h?b.relative(this.fsPath(c()),v()):v();case"relativeFileDirname":const t=b.dirname(v());if(g||h){const l=b.relative(this.fsPath(c()),t);return l.length===0?".":l}return t;case"fileDirname":return b.dirname(v());case"fileExtname":return b.extname(v());case"fileBasename":return b.basename(v());case"fileBasenameNoExtension":const i=b.basename(v());return i.slice(0,i.length-b.extname(i).length);case"fileDirnameBasename":return b.basename(b.dirname(v()));case"execPath":const o=this._context.getExecPath();return o||k;case"execInstallFolder":const r=this._context.getAppRoot();return r||k;case"pathSeparator":return b.sep;default:try{const l=h?`${_}:${h}`:_;return this.resolveFromMap(k,l,a,void 0)}catch(l){return k}}}}resolveFromMap(k,_,g,a){if(_&&g){const h=a===void 0?g[_]:g[a+":"+_];if(typeof h=="string")return h;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[210],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var A;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(A=e.GroupDirection||(e.GroupDirection={}));var R;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var D;(function(_){_[_.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.EDITOR_OPEN=2]="EDITOR_OPEN",_[_.EDITOR_CLOSE=3]="EDITOR_CLOSE",_[_.EDITOR_MOVE=4]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=6]="EDITOR_LABEL",_[_.EDITOR_PIN=7]="EDITOR_PIN",_[_.EDITOR_STICKY=8]="EDITOR_STICKY",_[_.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ge[211],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,14,94,281,57,22,15,2,43,79,174,110,85,211,7]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(Ee){function Ce(G){const{selectionStartLineNumber:Ne,selectionStartColumn:Re,positionLineNumber:et,positionColumn:Qe}=G,at=new h.Position(Ne-1,Re-1),rt=new h.Position(et-1,Qe-1);return new h.Selection(at,rt)}Ee.to=Ce;function ce(G){const{anchor:Ne,active:Re}=G;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}Ee.from=ce})(S=e.Selection||(e.Selection={}));var v;(function(Ee){function Ce(G){if(!!G){const{start:Ne,end:Re}=G;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}}Ee.from=Ce;function ce(G){if(!!G){const{startLineNumber:Ne,startColumn:Re,endLineNumber:et,endColumn:Qe}=G;return new h.Range(Ne-1,Re-1,et-1,Qe-1)}}Ee.to=ce})(v=e.Range||(e.Range={}));var E;(function(Ee){function Ce(ce){switch(ce){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Ee.to=Ce})(E=e.TokenType||(e.TokenType={}));var c;(function(Ee){function Ce(G){return new h.Position(G.lineNumber-1,G.column-1)}Ee.to=Ce;function ce(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=ce})(c=e.Position||(e.Position={}));var u;(function(Ee){function Ce(G){switch(G){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function ce(G){switch(G){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Ee){function Ce(G){let Ne;return G.code&&((0,P.isString)(G.code)||(0,P.isNumber)(G.code)?Ne=String(G.code):Ne={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},v.from(G.range)),{message:G.message,source:G.source,code:Ne,severity:i.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?(0,b.coalesce)(G.tags.map(u.from)):void 0})}Ee.from=Ce;function ce(G){var Ne;const Re=new h.Diagnostic(v.to(G),G.message,i.to(G.severity));return Re.source=G.source,Re.code=(0,P.isString)(G.code)?G.code:(Ne=G.code)===null||Ne===void 0?void 0:Ne.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Re.tags=G.tags&&(0,b.coalesce)(G.tags.map(u.to)),Re}Ee.to=ce})(s=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function Ce(G){return Object.assign(Object.assign({},v.from(G.location.range)),{message:G.message,resource:G.location.uri})}Ee.from=Ce;function ce(G){return new h.DiagnosticRelatedInformation(new h.Location(G.resource,v.to(G)),G.message)}Ee.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function Ce(G){switch(G){case h.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Ee.from=Ce;function ce(G){switch(G){case _.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Ee.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(Ee){function Ce(G){return typeof G=="number"&&G>=h.ViewColumn.One?G-1:G===h.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=Ce;function ce(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(o=e.ViewColumn||(e.ViewColumn={}));function r(Ee){return typeof Ee.range!="undefined"}function l(Ee){return Ee.length===0?!0:!!r(Ee[0])}e.isDecorationOptionsArr=l;var f;(function(Ee){function Ce(Qe){return Qe.map(Ee.from)}Ee.fromMany=Ce;function ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function G(Qe){let at;if(ce(Qe)){const{language:vt,value:mt}=Qe;at={value:"```"+vt+`
`+mt+"\n```\n"}}else h.MarkdownString.isMarkdownString(Qe)?at={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons}:typeof Qe=="string"?at={value:Qe}:at={value:""};const rt=Object.create(null);at.uris=rt;const Ye=vt=>{try{let mt=y.URI.parse(vt,!0);mt=mt.with({query:Ne(mt.query,rt)}),rt[vt]=mt}catch(mt){}return""},st=new R.Renderer;return st.link=Ye,st.image=vt=>Ye(A.parseHrefAndDimensions(vt).href),R(at.value,{renderer:st}),at}Ee.from=G;function Ne(Qe,at){if(!Qe)return Qe;let rt;try{rt=(0,I.parse)(Qe)}catch(st){}if(!rt)return Qe;let Ye=!1;return rt=(0,D.cloneAndChange)(rt,st=>{if(y.URI.isUri(st)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[vt]=st,Ye=!0,vt}else return}),Ye?JSON.stringify(rt):Qe}function Re(Qe){const at=new h.MarkdownString(Qe.value,Qe.supportThemeIcons);return at.isTrusted=Qe.isTrusted,at}Ee.to=Re;function et(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Ee.from(Qe)}Ee.fromStrict=et})(f=e.MarkdownString||(e.MarkdownString={}));function p(Ee){return l(Ee)?Ee.map(Ce=>({range:v.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?f.fromMany(Ce.hoverMessage):Ce.hoverMessage?f.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:v.from(Ce)}))}e.fromRangeOrRangeWithMessage=p;function w(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?y.URI.file(Ee):Ee}e.pathOrURIToURI=w;var d;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?w(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=Ce})(d=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var m;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?d.from(ce.before):void 0,after:ce.after?d.from(ce.after):void 0}}Ee.from=Ce})(m=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var C;(function(Ee){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(C=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Ee){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?C.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?m.from(ce.light):void 0,dark:ce.dark?m.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?d.from(ce.before):void 0,after:ce.after?d.from(ce.after):void 0}}Ee.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(Ee){function Ce(G){return{text:G.newText,eol:G.newEol&&ie.from(G.newEol),range:v.from(G.range)}}Ee.from=Ce;function ce(G){const Ne=new h.TextEdit(v.to(G.range),G.text);return Ne.newEol=typeof G.eol=="undefined"?void 0:ie.to(G.eol),Ne}Ee.to=ce})(B=e.TextEdit||(e.TextEdit={}));var ee;(function(Ee){function Ce(G,Ne,Re){var et,Qe,at;const rt={edits:[]};if(G instanceof h.WorkspaceEdit)for(let Ye of G._allEntries())if(Ye._type===1)rt.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const st=Ne==null?void 0:Ne.getDocument(Ye.uri);rt.edits.push({_type:2,resource:Ye.uri,edit:B.from(Ye.edit),modelVersionId:st==null?void 0:st.version,metadata:Ye.metadata})}else Ye._type===3?rt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(et=Re==null?void 0:Re.lookupNotebookDocument(Ye.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Ye._type===4?(Ye.newOutputs&&rt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(He.from)}}),Ye.newMetadata&&rt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:11,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?rt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Qe=Re==null?void 0:Re.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.notebookDocument.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(me.from)}}):Ye._type===6&&rt.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:10,outputId:Ye.outputId,items:((at=Ye.newOutputItems)===null||at===void 0?void 0:at.map(_e.from))||[],append:Ye.append}});return rt}Ee.from=Ce;function ce(G){const Ne=new h.WorkspaceEdit;for(const Re of G.edits)Re.edit?Ne.replace(y.URI.revive(Re.resource),v.to(Re.edit.range),Re.edit.text):Ne.renameFile(y.URI.revive(Re.oldUri),y.URI.revive(Re.newUri),Re.options);return Ne}Ee.to=ce})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(Ee){const Ce=Object.create(null);Ce[h.SymbolKind.File]=0,Ce[h.SymbolKind.Module]=1,Ce[h.SymbolKind.Namespace]=2,Ce[h.SymbolKind.Package]=3,Ce[h.SymbolKind.Class]=4,Ce[h.SymbolKind.Method]=5,Ce[h.SymbolKind.Property]=6,Ce[h.SymbolKind.Field]=7,Ce[h.SymbolKind.Constructor]=8,Ce[h.SymbolKind.Enum]=9,Ce[h.SymbolKind.Interface]=10,Ce[h.SymbolKind.Function]=11,Ce[h.SymbolKind.Variable]=12,Ce[h.SymbolKind.Constant]=13,Ce[h.SymbolKind.String]=14,Ce[h.SymbolKind.Number]=15,Ce[h.SymbolKind.Boolean]=16,Ce[h.SymbolKind.Array]=17,Ce[h.SymbolKind.Object]=18,Ce[h.SymbolKind.Key]=19,Ce[h.SymbolKind.Null]=20,Ce[h.SymbolKind.EnumMember]=21,Ce[h.SymbolKind.Struct]=22,Ce[h.SymbolKind.Event]=23,Ce[h.SymbolKind.Operator]=24,Ce[h.SymbolKind.TypeParameter]=25;function ce(Ne){return typeof Ce[Ne]=="number"?Ce[Ne]:6}Ee.from=ce;function G(Ne){for(const Re in Ce)if(Ce[Re]===Ne)return Number(Re);return h.SymbolKind.Property}Ee.to=G})(H=e.SymbolKind||(e.SymbolKind={}));var x;(function(Ee){function Ce(G){switch(G){case h.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function ce(G){switch(G){case 1:return h.SymbolTag.Deprecated}}Ee.to=ce})(x=e.SymbolTag||(e.SymbolTag={}));var W;(function(Ee){function Ce(G){return{name:G.name,kind:H.from(G.kind),tags:G.tags&&G.tags.map(x.from),containerName:G.containerName,location:O.from(G.location)}}Ee.from=Ce;function ce(G){const Ne=new h.SymbolInformation(G.name,H.to(G.kind),G.containerName,O.to(G.location));return Ne.tags=G.tags&&G.tags.map(x.to),Ne}Ee.to=ce})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(Ee){function Ce(G){var Ne,Re;const et={name:G.name||"!!MISSING: name!!",detail:G.detail,range:v.from(G.range),selectionRange:v.from(G.selectionRange),kind:H.from(G.kind),tags:(Re=(Ne=G.tags)===null||Ne===void 0?void 0:Ne.map(x.from))!==null&&Re!==void 0?Re:[]};return G.children&&(et.children=G.children.map(Ce)),et}Ee.from=Ce;function ce(G){const Ne=new h.DocumentSymbol(G.name,G.detail,H.to(G.kind),v.to(G.range),v.to(G.selectionRange));return(0,b.isNonEmptyArray)(G.tags)&&(Ne.tags=G.tags.map(x.to)),G.children&&(Ne.children=G.children.map(ce)),Ne}Ee.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(Ee){function Ce(ce){const G=new h.CallHierarchyItem(H.to(ce.kind),ce.name,ce.detail||"",y.URI.revive(ce.uri),v.to(ce.range),v.to(ce.selectionRange));return G._sessionId=ce._sessionId,G._itemId=ce._itemId,G}Ee.to=Ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(Ee){function Ce(ce){return new h.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(G=>v.to(G)))}Ee.to=Ce})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(Ee){function Ce(ce){return new h.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(G=>v.to(G)))}Ee.to=Ce})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Ee){function Ce(G){return{range:G.range&&v.from(G.range),uri:G.uri}}Ee.from=Ce;function ce(G){return new h.Location(y.URI.revive(G.uri),v.to(G.range))}Ee.to=ce})(O=e.location||(e.location={}));var V;(function(Ee){function Ce(G){const Ne=G,Re=G;return{originSelectionRange:Ne.originSelectionRange?v.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Re.uri,range:v.from(Ne.targetRange?Ne.targetRange:Re.range),targetSelectionRange:Ne.targetSelectionRange?v.from(Ne.targetSelectionRange):void 0}}Ee.from=Ce;function ce(G){return{targetUri:y.URI.revive(G.uri),targetRange:v.to(G.range),targetSelectionRange:G.targetSelectionRange?v.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?v.to(G.originSelectionRange):void 0}}Ee.to=ce})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(Ee){function Ce(G){return{range:v.from(G.range),contents:f.fromMany(G.contents)}}Ee.from=Ce;function ce(G){return new h.Hover(G.contents.map(f.to),v.to(G.range))}Ee.to=ce})(q=e.Hover||(e.Hover={}));var X;(function(Ee){function Ce(G){return{range:v.from(G.range),expression:G.expression}}Ee.from=Ce;function ce(G){return new h.EvaluatableExpression(v.to(G.range),G.expression)}Ee.to=ce})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Ee){function Ce(G){if(G instanceof h.InlineValueText)return{type:"text",range:v.from(G.range),text:G.text};if(G instanceof h.InlineValueVariableLookup)return{type:"variable",range:v.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function ce(G){switch(G.type){case"text":return{range:v.to(G.range),text:G.text};case"variable":return{range:v.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:v.to(G.range),expression:G.expression}}}Ee.to=ce})(fe=e.InlineValue||(e.InlineValue={}));var ve;(function(Ee){function Ce(G){return{frameId:G.frameId,stoppedLocation:v.from(G.stoppedLocation)}}Ee.from=Ce;function ce(G){return new h.InlineValueContext(G.frameId,v.to(G.stoppedLocation))}Ee.to=ce})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(Ee){function Ce(G){return{range:v.from(G.range),kind:G.kind}}Ee.from=Ce;function ce(G){return new h.DocumentHighlight(v.to(G.range),G.kind)}Ee.to=ce})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(Ee){function Ce(ce){switch(ce){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Ee.to=Ce})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(Ee){function Ce(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=Ce})(Fe=e.CompletionContext||(e.CompletionContext={}));var z;(function(Ee){function Ce(G){switch(G){case h.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function ce(G){switch(G){case 1:return h.CompletionItemTag.Deprecated}}Ee.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(Ee){const Ce=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ce(Re){var et;return(et=Ce.get(Re))!==null&&et!==void 0?et:9}Ee.from=ce;const G=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ne(Re){var et;return(et=G.get(Re))!==null&&et!==void 0?et:h.CompletionItemKind.Property}Ee.to=Ne})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function Ce(ce,G){var Ne;const Re=new h.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Re.label2=ce.label),Re.insertText=ce.insertText,Re.kind=J.to(ce.kind),Re.tags=(Ne=ce.tags)===null||Ne===void 0?void 0:Ne.map(z.to),Re.detail=ce.detail,Re.documentation=A.isMarkdownString(ce.documentation)?f.to(ce.documentation):ce.documentation,Re.sortText=ce.sortText,Re.filterText=ce.filterText,Re.preselect=ce.preselect,Re.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Re.range=v.to(ce.range):typeof ce.range=="object"&&(Re.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Re.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Re.insertText=new h.SnippetString(ce.insertText):(Re.insertText=ce.insertText,Re.textEdit=Re.range instanceof h.Range?new h.TextEdit(Re.range,Re.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Re.additionalTextEdits=ce.additionalTextEdits.map(et=>B.to(et))),Re.command=G&&ce.command?G.fromInternal(ce.command):void 0,Re}Ee.to=Ce})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(Ee){function Ce(G){return{label:G.label,documentation:G.documentation?f.fromStrict(G.documentation):void 0}}Ee.from=Ce;function ce(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?f.to(G.documentation):G.documentation}}Ee.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Ee){function Ce(G){return{label:G.label,documentation:G.documentation?f.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(ae.from):[],activeParameter:G.activeParameter}}Ee.from=Ce;function ce(G){return{label:G.label,documentation:A.isMarkdownString(G.documentation)?f.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(ae.to):[],activeParameter:G.activeParameter}}Ee.to=ce})(he=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(Ee){function Ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(he.from):[]}}Ee.from=Ce;function ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(he.to):[]}}Ee.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(Ee){function Ce(G){var Ne;return{text:G.text,range:v.from(G.range),kind:we.from((Ne=G.kind)!==null&&Ne!==void 0?Ne:h.InlineHintKind.Other),description:G.description&&f.fromStrict(G.description),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}Ee.from=Ce;function ce(G){const Ne=new h.InlineHint(G.text,v.to(G.range),we.to(G.kind));return Ne.whitespaceAfter=G.whitespaceAfter,Ne.whitespaceBefore=G.whitespaceBefore,Ne.description=A.isMarkdownString(G.description)?f.to(G.description):G.description,Ne}Ee.to=ce})(Me=e.InlineHint||(e.InlineHint={}));var we;(function(Ee){function Ce(G){return G}Ee.from=Ce;function ce(G){return G}Ee.to=ce})(we=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(Ee){function Ce(G){return{range:v.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Ce;function ce(G){let Ne;if(G.url)try{Ne=typeof G.url=="string"?y.URI.parse(G.url,!0):y.URI.revive(G.url)}catch(Re){}return new h.DocumentLink(v.to(G.range),Ne)}Ee.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Te;(function(Ee){function Ce(G){const Ne=new h.ColorPresentation(G.label);return G.textEdit&&(Ne.textEdit=B.to(G.textEdit)),G.additionalTextEdits&&(Ne.additionalTextEdits=G.additionalTextEdits.map(Re=>B.to(Re))),Ne}Ee.to=Ce;function ce(G){return{label:G.label,textEdit:G.textEdit?B.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ne=>B.from(Ne)):void 0}}Ee.from=ce})(Te=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Ee){function Ce(G){return new h.Color(G[0],G[1],G[2],G[3])}Ee.to=Ce;function ce(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=ce})(xe=e.Color||(e.Color={}));var Se;(function(Ee){function Ce(G){return{range:v.from(G.range)}}Ee.from=Ce;function ce(G){return new h.SelectionRange(v.to(G.range))}Ee.to=ce})(Se=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(Ee){function Ce(ce){switch(ce){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(Ee){function Ce(G){switch(G){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function ce(G){switch(G){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}Ee.to=ce})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(Ee){function Ce(G){if(G===h.EndOfLine.CRLF)return 1;if(G===h.EndOfLine.LF)return 0}Ee.from=Ce;function ce(G){if(G===1)return h.EndOfLine.CRLF;if(G===0)return h.EndOfLine.LF}Ee.to=ce})(ie=e.EndOfLine||(e.EndOfLine={}));var be;(function(Ee){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(be=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(Ee){function Ce(ce){const G={start:ce.start+1,end:ce.end+1};return ce.kind&&(G.kind=Ve.from(ce.kind)),G}Ee.from=Ce})(Oe=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(Ee){function Ce(ce){if(ce)switch(ce){case h.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}Ee.from=Ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Ee){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?k.EditorOverride.DISABLED:void 0}}Ee.from=Ce})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var tt;(function(Ee){function Ce(G){return G instanceof h.RelativePattern||typeof G=="string"?G:ce(G)?new h.RelativePattern(G.base,G.pattern):G}Ee.from=Ce;function ce(G){const Ne=G;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(tt=e.GlobPattern||(e.GlobPattern={}));var K;(function(Ee){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const G=ce;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:tt.from(G.pattern),exclusive:G.exclusive}}}else return}Ee.from=Ce})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(Ee){function Ce(G){return{start:G.start,end:G.end}}Ee.from=Ce;function ce(G){return new h.NotebookCellRange(G.start,G.end)}Ee.to=ce})(se=e.NotebookCellRange||(e.NotebookCellRange={}));var de;(function(Ee){function Ce(ce){return new h.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}Ee.to=Ce})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Y;(function(Ee){function Ce(G){return G}Ee.from=Ce;function ce(G){return new h.NotebookDocumentMetadata(G.editable,G.cellEditable,G.cellHasExecutionOrder,G.custom,G.trusted)}Ee.to=ce})(Y=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(Ee){function Ce(G){return{duration:G.lastRunDuration,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Ce;function ce(G){return{lastRunSuccess:G.success,lastRunDuration:G.duration,executionOrder:G.executionOrder}}Ee.from=ce})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(Ee){function Ce(G){switch(G){case h.NotebookCellKind.Markdown:return g.CellKind.Markdown;case h.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=Ce;function ce(G){switch(G){case g.CellKind.Markdown:return h.NotebookCellKind.Markdown;case g.CellKind.Code:default:return h.NotebookCellKind.Code}}Ee.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var me;(function(Ee){function Ce(G){var Ne;return{cellKind:le.from(G.kind),language:G.language,source:G.source,metadata:Object.assign(Object.assign({},G.metadata),ne.from((Ne=G.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:G.outputs?G.outputs.map(He.from):[]}}Ee.from=Ce;function ce(G){return new h.NotebookCellData(le.to(G.cellKind),G.source,G.language,G.outputs?G.outputs.map(He.to):void 0,G.metadata?de.to(G.metadata):void 0)}Ee.to=ce})(me=e.NotebookCellData||(e.NotebookCellData={}));var _e;(function(Ee){function Ce(G){return{mime:G.mime,value:G.value,metadata:G.metadata}}Ee.from=Ce;function ce(G){return new h.NotebookCellOutputItem(G.mime,G.value,G.metadata)}Ee.to=ce})(_e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var He;(function(Ee){function Ce(G){return{outputId:G.id,outputs:G.outputs.map(_e.from),metadata:G.metadata}}Ee.from=Ce;function ce(G){const Ne=G.outputs.map(_e.to);return new h.NotebookCellOutput(Ne,G.outputId,G.metadata)}Ee.to=ce})(He=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(Ee){function Ce(Re){if(Re!=null){if(Re instanceof h.RelativePattern||typeof Re=="string")return Re;if(Ne(Re))return new h.RelativePattern(Re.base,Re.pattern);if(G(Re))return{include:tt.from(Re.include)||void 0,exclude:tt.from(Re.exclude)||void 0}}}Ee.from=Ce;function ce(Re){return typeof Re=="string"?Re:Ne(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}Ee.to=ce;function G(Re){const et=Re,Qe=tt.from(et.include);if(!(Qe&&Qe instanceof h.RelativePattern||typeof Qe=="string"))return!1;const at=tt.from(et.exclude);return!!(at&&at instanceof h.RelativePattern||typeof at=="string")}function Ne(Re){const et=Re;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ke;(function(Ee){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?d.from(ce.top):void 0}}Ee.from=Ce})(Ke=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Je;(function(Ee){function Ce(ce){var G;return{transientOutputs:ce?ce.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(G=ce==null?void 0:ce.transientMetadata)!==null&&G!==void 0?G:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}Ee.from=Ce})(Je=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(Ee){function Ce(G){return{state:G.state,duration:G.duration,messages:G.messages.map(ut.from)}}Ee.from=Ce;function ce(G){const Ne=new h.TestState(G.state);return Ne.duration=G.duration,Ne.messages=G.messages.map(ut.to),Ne}Ee.to=ce})(Ze=e.TestState||(e.TestState={}));var ut;(function(Ee){function Ce(G){return{message:f.fromStrict(G.message)||"",severity:G.severity,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?O.from(G.location):void 0}}Ee.from=Ce;function ce(G){const Ne=new h.TestMessage(typeof G.message=="string"?G.message:f.to(G.message));return Ne.severity=G.severity,Ne.actualOutput=G.actualOutput,Ne.expectedOutput=G.expectedOutput,Ne}Ee.to=ce})(ut=e.TestMessage||(e.TestMessage={}));var lt;(function(Ee){function Ce(Re){var et,Qe;return{extId:Re.id,label:Re.label,uri:Re.uri,range:v.from(Re.range),debuggable:(et=Re.debuggable)!==null&&et!==void 0?et:!1,description:Re.description,runnable:(Qe=Re.runnable)!==null&&Qe!==void 0?Qe:!0,expandable:Re.expandable}}Ee.from=Ce;function ce(Re){return{extId:Re.id,label:Re.label,uri:Re.uri,range:v.from(Re.range),debuggable:!1,description:Re.description,runnable:!0,expandable:!0}}Ee.fromResultSnapshot=ce;function G(Re){return{id:Re.extId,label:Re.label,uri:y.URI.revive(Re.uri),range:v.to(Re.range),expandable:Re.expandable,debuggable:Re.debuggable,description:Re.description,runnable:Re.runnable}}Ee.toPlain=G;function Ne(Re){const et=new h.TestItem(Re.extId,Re.label,y.URI.revive(Re.uri),Re.expandable);return et.range=v.to(Re.range),et.debuggable=Re.debuggable,et.description=Re.description,et.runnable=Re.runnable,et}Ee.to=Ne})(lt=e.TestItem||(e.TestItem={}));var it;(function(Ee){function Ce(Ne,Re){var et,Qe,at;const rt={completedAt:Re.completedAt,id:Ne,items:[]},Ye=[[null,Re.results]];for(;Ye.length;){const[st,vt]=Ye.pop();for(const mt of vt){const Ct={children:(Qe=(et=mt.children)===null||et===void 0?void 0:et.map(wt=>wt.id))!==null&&Qe!==void 0?Qe:[],computedState:mt.result.state,item:lt.fromResultSnapshot(mt),state:Ze.from(mt.result),retired:void 0,expand:3,parent:(at=st==null?void 0:st.item.extId)!==null&&at!==void 0?at:null,src:{provider:"",tree:-1},direct:!st};rt.items.push(Ct),mt.children&&Ye.push([Ct,mt.children])}}return rt}Ee.from=Ce;const ce=(Ne,Re)=>Object.assign(Object.assign({},lt.toPlain(Ne.item)),{result:Ze.to(Ne.state),children:Ne.children.map(et=>Re.get(et)).filter(P.isDefined).map(et=>ce(et,Re))});function G(Ne){const Re=[],et=new Map;for(const Qe of Ne.items)et.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:Ne.completedAt,results:Re.map(Qe=>ce(Qe,et))}}Ee.to=G})(it=e.TestResults||(e.TestResults={}));var qe;(function(Ee){function Ce(ce){switch(ce){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[212],pe([0,1,2,16,7,20,55]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(n,T,k,_={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=_,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,_)=>{const a={dispose:this._callbacks.push([T,k,n])};return Array.isArray(_)&&_.push(a),a}}async $participateInSave(n,T){const k=b.URI.revive(n);let _=!1;const g=setTimeout(()=>_=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(_)break;const S=this._documents.getDocument(k),v=await this._deliverEventAsyncAndBlameBadListeners(h,{document:S,reason:I.TextDocumentSaveReason.to(T)});a.push(v)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([n,T,k],_){const g=this._badListeners.get(n);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,_).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(n);this._badListeners.set(n,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,_){const g=[],a=Date.now(),{document:h,reason:S}=_,{version:v}=h,E=Object.freeze({document:h,reason:S,waitUntil(c){if(Object.isFrozen(g))throw(0,A.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{T.apply(k,[E])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,u)=>{const s=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(s),c(t)}).catch(t=>{clearTimeout(s),u(t)})}).then(c=>{const u={edits:[]};for(const s of c)if(Array.isArray(s)&&s.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:i,range:o}of s)u.edits.push({_type:2,resource:h.uri,edit:{range:o&&I.Range.from(o),text:t,eol:i&&I.EndOfLine.from(i)}});if(u.edits.length!==0)return v===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[213],pe([0,1,3,17,34,2,20,7]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,_,g,a,h){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,g&&(this._config+=1),a&&(this._config+=2),h&&(this._config+=4);const S=(0,R.parse)(_),v=k(E=>{if(!g)for(let c of E.created){const u=I.URI.revive(c);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!a)for(let c of E.changed){const u=I.URI.revive(c);S(u.fsPath)&&this._onDidChange.fire(u)}if(!h)for(let c of E.deleted){const u=I.URI.revive(c);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,_,g){this._logService=_,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new A.AsyncEmitter,this._onWillCreateFile=new A.AsyncEmitter,this._onWillDeleteFile=new A.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,_,g,a){return new y(this._onFileSystemEvent.event,k,_,g,a)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,_){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(g=>I.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(g=>I.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,_){return(g,a,h)=>{const S=function(E){g.call(a,E)};return S.extension=k,_.event(S,void 0,h)}}async $onWillRunFileOperation(k,_,g,a){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},g,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(h=>I.URI.revive(h.target))},g,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(h=>I.URI.revive(h.target))},g,a)}}async _fireWillEvent(k,_,g,a){const h=new Set,S=[];if(await k.fireAsync(_,a,async(E,c)=>{var u;const s=Date.now(),t=await Promise.resolve(E);t instanceof P.WorkspaceEdit&&(S.push(t),h.add((u=c.extension.displayName)!==null&&u!==void 0?u:c.extension.identifier.value)),Date.now()-s>g&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!a.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let E of S){let{edits:c}=D.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(c)}return{edit:v,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=n}),define(ge[214],pe([0,1,3,6,11,22,2,20,7,85]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(a,h,S,v){this.start=a,this.deletedCount=h,this.deletedItems=S,this.items=v}static asApiEvents(a){return a.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(S=>S.cell)}))}}class k{constructor(a,h,S){var v;this._notebook=a,this._extHostDocument=h,this._cellData=S,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=D.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=P.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=P.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(a,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:a}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const a=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return a._notebook.getCellIndex(a)},notebook:a._notebook.notebookDocument,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get latestExecutionSummary(){return a._previousResult}})}return this._cell}setOutputs(a){this._outputs=a.map(P.NotebookCellOutput.to)}setOutputItems(a,h,S){const v=S.map(P.NotebookCellOutputItem.to),E=this._outputs.find(c=>c.id===a);E&&(h||(E.outputs.length=0),E.outputs.push(...v))}setMetadata(a){this._internalMetadata=a,this._metadata=P.NotebookCellMetadata.to(a),this._previousResult=P.NotebookCellPreviousExecutionResult.to(a)}}e.ExtHostCell=k;class _ extends A.Disposable{constructor(a,h,S,v,E,c,u){super();this._proxy=a,this._textDocumentsAndEditors=h,this._textDocuments=S,this._emitter=v,this._viewType=E,this._metadata=c,this.uri=u,this.handle=_._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,A.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const a=this;this._notebook=Object.freeze({get uri(){return a.uri},get version(){return a._versionId},get fileName(){return a.uri.fsPath},get viewType(){return a._viewType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===R.Schemas.untitled},get cells(){return a._cells.map(h=>h.cell)},get metadata(){return a._metadata},set metadata(h){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return a._save()}})}return this._notebook}updateBackup(a){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=a}disposeBackup(){var a;(a=this._backup)===null||a===void 0||a.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=this._metadata.with(a.metadata))}acceptModelChanged(a,h){this._versionId=a.versionId,this._isDirty=h;for(const S of a.rawEvents)S.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===n.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(a,h){if(!this._disposed){const S=[],v=[],E=[];a.reverse().forEach(c=>{var u;const t=c[2].map(r=>{const l=new k(this,this._textDocumentsAndEditors,r);if(h||v.push(k.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(l.handle)){const f=new A.DisposableStore;f.add(l),this._cellDisposableMapping.set(l.handle,f)}return l});for(let r=c[0];r<c[0]+c[1];r++)(u=this._cellDisposableMapping.get(this._cells[r].handle))===null||u===void 0||u.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const i=new T(c[0],c[1],[],t),o=this._cells.splice(c[0],c[1],...t);for(let r of o)E.push(r.uri),i.deletedItems.push(r.cell);S.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:E}),h||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(S)}))}}_moveCell(a,h){const S=this._cells.splice(a,1);this._cells.splice(h,0,...S);const v=[new T(a,1,S.map(E=>E.cell),[]),new T(h,0,[],S)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(v)}))}_setCellOutputs(a,h){const S=this._cells[a];S.setOutputs(h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(a,h,S,v){const E=this._cells[a];E.setOutputItems(h,S,v),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[E.cell]}))}_changeCellLanguage(a,h){const S=this._cells[a];S.cell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(S.uri,h)}_changeCellMetadata(a,h){var S;const v=this._cells[a],E=v.internalMetadata,c=v.cell.metadata;v.setMetadata(h);const u=v.cell.metadata;if((0,I.equals)(c,u)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell})),E.runState!==h.runState){const s=(S=h.runState)!==null&&S!==void 0?S:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:s}))}}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(h=>h.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=_,_._handlePool=0}),define(ge[215],pe([0,1,3,7,20]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(T=>R.NotebookCellOutput.from(T))})}replaceCells(y,n,T){this._throwIfFinalized(),!(y===n&&T.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:T.map(R.NotebookCellData.from)})}}class D{constructor(y,n,T,k,_,g,a){this.id=y,this._viewType=n,this._proxy=T,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=g,this._visibleRanges=_,this._viewColumn=a}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const T=y._selections[0];return T&&((n=y.notebookData.getCellFromIndex(T.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,T){y._proxy.$tryRevealRange(y.id,R.NotebookCellRange.from(n),T!=null?T:A.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const T=new I(this.document.version);return n(T),y._applyEdit(T.finalize())},get kernel(){return y._kernel},setDecorations(n,T){return y.setDecorations(n,T)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let T=-1;for(let k=0;k<y.cellEdits.length;k++){if(T<0){n.push(y.cellEdits[k]),T++;continue}const g=n[T],a=y.cellEdits[k];if(g.editType===1&&a.editType===1&&g.index===a.index){g.cells.push(...y.cellEdits[k].cells),g.count+=y.cellEdits[k].count;continue}n.push(y.cellEdits[k]),T++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=D}),define(ge[216],pe([0,1,20,111,161,21,68]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,_,g){const a=this._handles++,{title:h,location:S,cancellable:v}=_,E={label:(0,R.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(S),title:h,source:E,cancellable:v},k),this._withProgress(a,g,!!v)}_withProgress(k,_,g){let a;g&&(a=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,a));const h=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let S;try{S=_(new n(this._proxy,k),g&&a?a.token:I.CancellationToken.None)}catch(v){throw h(k),v}return S.then(v=>h(k),v=>h(k)),S}$acceptProgressCanceled(k){const _=this._mapHandleToCancellationSource.get(k);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=P;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends A.Progress{constructor(k,_){super(g=>this.throttledReport(g));this._proxy=k,this._handle=_}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,D.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ge[122],pe([0,1,52,16,70,20,7]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(_,g){const a=P._Keys.nextId();_.$registerTextEditorDecorationType(a,I.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:a,dispose(){_.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new R.IdGenerator("TextEditorDecorationType");class y{constructor(_,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,g){this._throwIfFinalized();let a=null;if(_ instanceof D.Position)a=new D.Range(_,_);else if(_ instanceof D.Range)a=_;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(_,g){this._throwIfFinalized(),this._pushEdit(new D.Range(_,_),g,!0)}delete(_){this._throwIfFinalized();let g=null;if(_ instanceof D.Range)g=_;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(_,g,a){const h=this._document.validateRange(_);this._collectedEdits.push({range:h,text:g,forceMoveMarkers:a})}setEndOfLine(_){if(this._throwIfFinalized(),_!==D.EndOfLine.LF&&_!==D.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=y;class n{constructor(_,g,a,h){this._proxy=_,this._id=g,this._accept(a),this._logService=h;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const g=Math.floor(_);return g>0?g:null}if(typeof _=="string"){const g=parseInt(_,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(_){const g=this._validateTabSize(_);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const g=this._validateInsertSpaces(_);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(_)})))}assign(_){const g={};let a=!1;if(typeof _.tabSize!="undefined"){const h=this._validateTabSize(_.tabSize);h==="auto"?(a=!0,g.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,g.tabSize=h)}if(typeof _.insertSpaces!="undefined"){const h=this._validateInsertSpaces(_.insertSpaces);h==="auto"?(a=!0,g.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,g.insertSpaces=h)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,a=!0,g.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,a=!0,g.lineNumbers=I.TextEditorLineNumbersStyle.from(_.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(_){_.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=n;class T{constructor(_,g,a,h,S,v,E,c){this.id=_,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new n(this._proxy,this.id,v,a),this._visibleRanges=E,this._viewColumn=c;const u=this;this.value=Object.freeze({get document(){return h.getValue()},set document(s){throw(0,A.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(s){if(!(s instanceof D.Selection))throw(0,A.illegalArgument)("selection");u._selections=[s],u._trySetSelection()},get selections(){return u._selections},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof D.Selection)))throw(0,A.illegalArgument)("selections");u._selections=s,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(s){throw(0,A.readonly)("visibleRanges")},get options(){return u._options.value},set options(s){u._disposed||u._options.assign(s)},get viewColumn(){return u._viewColumn},set viewColumn(s){throw(0,A.readonly)("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(h.getValue(),t);return s(i),u._applyEdit(i)},insertSnippet(s,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(r=>I.Range.from(r));else if(t instanceof D.Position){const{lineNumber:r,column:l}=I.Position.from(t);o=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof D.Range)o=[I.Range.from(t)];else{o=[];for(const r of t)if(r instanceof D.Range)o.push(I.Range.from(r));else{const{lineNumber:l,column:f}=I.Position.from(r);o.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return g.$tryInsertSnippet(_,s.value,o,i)},setDecorations(s,t){const i=t.length===0;i&&!u._hasDecorationsForKey.has(s.key)||(i?u._hasDecorationsForKey.delete(s.key):u._hasDecorationsForKey.add(s.key),u._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return g.$trySetDecorations(_,s.key,I.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const f=t[r];o[4*r]=f.start.line+1,o[4*r+1]=f.start.character+1,o[4*r+2]=f.end.line+1,o[4*r+3]=f.end.character+1}return g.$trySetDecorationsFast(_,s.key,o)}}))},revealRange(s,t){u._runOnProxy(()=>g.$tryRevealRange(_,I.Range.from(s),t||D.TextEditorRevealType.Default))},show(s){g.$tryShowEditor(_,I.ViewColumn.from(s))},hide(){g.$tryHideEditor(_)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,b.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,b.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,b.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,b.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const g=_.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(S=>S.range);a.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=a.length-1;S<v;S++){const E=a[S].end;if(a[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=g.edits.map(S=>({range:I.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,h,{setEndOfLine:typeof g.setEndOfLine=="number"?I.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=T}),define(ge[217],pe([0,1,164,24,2,3,6,17,7,15,14,20,21]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,v){if((0,n.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let E;return Array.isArray(S.highlights)&&(E=S.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),E=E.length?E:void 0),{label:S.label,highlights:E}}}class a{constructor(v,E,c){this._proxy=v,this.commands=E,this.logService=c,this.treeViews=new Map;function u(s){return s&&s.$treeViewId&&s.$treeItemHandle}E.registerArgumentProcessor({processArgument:s=>u(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(t=>u(t)?this.convertArgument(t):t):s})}registerTreeDataProvider(v,E,c){const u=this.createTreeView(v,{treeDataProvider:E},c);return{dispose:()=>u.dispose()}}createTreeView(v,E,c){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany}),s=this.createExtHostTreeView(v,E,c);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(t){s.message=t},get title(){return s.title},set title(t){s.title=t},get description(){return s.description},set description(t){s.description=t},reveal:(t,i)=>s.reveal(t,i),dispose:async()=>{await u,this.treeViews.delete(v),s.dispose()}}}$getChildren(v,E){const c=this.treeViews.get(v);return c?c.getChildren(E):Promise.reject(new Error((0,b.localize)(0,null,v)))}async $hasResolve(v){const E=this.treeViews.get(v);if(!E)throw new Error((0,b.localize)(1,null,v));return E.hasResolve}$resolve(v,E,c){const u=this.treeViews.get(v);if(!u)throw new Error((0,b.localize)(2,null,v));return u.resolveTreeItem(E,c)}$setExpanded(v,E,c){const u=this.treeViews.get(v);if(!u)throw new Error((0,b.localize)(3,null,v));u.setExpanded(E,c)}$setSelection(v,E){const c=this.treeViews.get(v);if(!c)throw new Error((0,b.localize)(4,null,v));c.setSelection(E)}$setVisible(v,E){const c=this.treeViews.get(v);if(!c)throw new Error((0,b.localize)(5,null,v));c.setVisible(E)}createExtHostTreeView(v,E,c){const u=new h(v,E,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(v,u),u}convertArgument(v){const E=this.treeViews.get(v.$treeViewId);return E?E.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=a;class h extends D.Disposable{constructor(v,E,c,u,s,t){super();if(this.viewId=v,this.proxy=c,this.commands=u,this.logService=s,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===v&&(this._title=l.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,o;this._register(I.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(f=>o=f),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=o;return i=null,this.refresh(l).then(()=>f())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,n.isUndefinedOrNull)(v))}getChildren(v){const E=v?this.getExtensionElement(v):void 0;if(v&&!E)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(v);return(c?Promise.resolve(c):this.fetchChildrenNodes(E)).then(u=>u.map(s=>s.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,E){E=E||{select:!0,focus:!1};const c=(0,n.isUndefinedOrNull)(E.select)?!0:E.select,u=(0,n.isUndefinedOrNull)(E.focus)?!1:E.focus,s=(0,n.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(o=>o.item)},{select:c,focus:u,expand:s})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:u,expand:s})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,E){const c=this.getExtensionElement(v);c&&(E?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(v){(0,T.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,E){var c;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(v);if(u){const s=this.nodes.get(u);if(s){const t=(c=await this.dataProvider.resolveTreeItem(s.extensionItem,u,E))!==null&&c!==void 0?c:s.extensionItem;return s.item.tooltip=this.getTooltip(t.tooltip),s.item.command=this.getCommand(s.disposableStore,t.command),s.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(E=>E?this.resolveUnknownParentChain(E).then(c=>this.resolveTreeNode(E,c[c.length-1]).then(u=>(c.push(u),c))):Promise.resolve([]))}resolveParent(v){const E=this.nodes.get(v);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,E){const c=this.nodes.get(v);return c?Promise.resolve(c):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>this.createHandle(v,u,E,!0)).then(u=>this.getChildren(E?E.item.handle:void 0).then(()=>{const s=this.getExtensionElement(u);if(s){const t=this.nodes.get(s);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(v){if(v){let E;if(typeof v=="string"){const c=this.getExtensionElement(v);E=c?this.nodes.get(c):void 0}else E=v;return E&&E.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const E=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=v?this.nodes.get(v):void 0,u=await this.dataProvider.getChildren(v);if(E.token.isCancellationRequested)return[];const s=await Promise.all((0,T.coalesce)(u||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,c):null}));return E.token.isCancellationRequested?[]:(0,T.coalesce)(s)}finally{E.dispose()}}refresh(v){if(v.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(v);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const E=new Set;for(const u of v){const s=this.nodes.get(u);if(s&&!E.has(s.item.handle)){let t=s;for(;t&&t.parent&&!E.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&E.add(s.item.handle)}}const c=[];return E.forEach(u=>{const s=this.elements.get(u);if(s){const t=this.nodes.get(s);t&&(!t.parent||!E.has(t.parent.item.handle))&&c.push(u)}}),c}refreshHandles(v){const E={};return Promise.all(v.map(c=>this.refreshNode(c).then(u=>{u&&(E[c]=u.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(v){const E=this.getExtensionElement(v);if(E){const c=this.nodes.get(E);if(c)return this.clearChildren(E),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(u=>{if(u){const s=this.createTreeNode(E,u,c.parent);return this.updateNodeCache(E,s,c,c.parent),c.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,E,c){const u=this.createTreeNode(v,E,c);if(E.id&&this.elements.has(u.item.handle))throw new Error((0,b.localize)(6,null,E.id));return this.addNodeToCache(v,u),this.addNodeToParentCache(u,c),u}getTooltip(v){return y.MarkdownString.isMarkdownString(v)?k.MarkdownString.from(v):v}getCommand(v,E){return E?this.commands.toInternal(E,v):void 0}createTreeNode(v,E,c){const u=new D.DisposableStore,s=this.createHandle(v,E,c),t=this.getLightIconPath(E);return{item:{handle:s,parentHandle:c?c.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(u,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,n.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:c,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(v){return v.iconPath instanceof y.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:E,label:c,resourceUri:u},s,t){if(E)return`${h.ID_HANDLE_PREFIX}/${E}`;const i=g(c,this.extension),o=s?s.item.handle:h.LABEL_HANDLE_PREFIX;let r=i?i.label:u?(0,A.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,f=this.getChildrenNodes(s)||[];let p,w=0;do{if(p=`${o}/${w}:${r}`,t||!this.elements.has(p)||l===p)break;w++}while(w<=f.length);return p}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon))return typeof v.iconPath=="string"||R.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return R.URI.isUri(v)?v:R.URI.file(v)}addNodeToCache(v,E){this.elements.set(E.item.handle,v),this.nodes.set(v,E)}updateNodeCache(v,E,c,u){this.elements.delete(E.item.handle),this.nodes.delete(v),E.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(v,E);const s=this.getChildrenNodes(u)||[],t=s.filter(i=>i.item.handle===c.item.handle)[0];t&&s.splice(s.indexOf(t),1,E)}addNodeToParentCache(v,E){E?(E.children||(E.children=[]),E.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const E=this.nodes.get(v);if(E){if(E.children)for(const c of E.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}E.children=void 0}}else this.clearAll()}clear(v){const E=this.nodes.get(v);if(E){if(E.children)for(const c of E.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}this.nodes.delete(v),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(ge[218],pe([0,1,14,17,21,20,7,121]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(a,h){if(h!==void 0){const S=this.testIdsToInternal.get(h),v=S==null?void 0:S.get(a);if(v)return[S,v]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(a);return v&&[S,v]})}createForHierarchy(a=()=>{}){return new _(this.createIdMap(T++),a)}createIdMap(a){const h=new k(a);return this.testIdsToInternal.set(h.id,h),{object:h,dispose:()=>this.testIdsToInternal.delete(h.id)}}}e.OwnedTestCollection=y;var n;(function(g){g[g.Disconnected=0]="Disconnected",g[g.IsChild=1]="IsChild",g[g.IsParent=2]="IsParent",g[g.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class k{constructor(a){this.id=a,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(a){if(this.map.has(a.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${a.item.extId}`);this.map.set(a.item.extId,a),a.parent||this._roots.add(a)}has(a){return this.map.has(a)}delete(a){const h=this.map.get(a);return h?(this.map.delete(a),this._roots.delete(h),!0):!1}get(a){return this.map.get(a)}comparePositions(a,h){const S=typeof a=="string"?this.map.get(a):a,v=typeof h=="string"?this.map.get(h):h;if(!S||!v)return 0;if(S===v)return 3;for(let E=this.map.get(v.parent);E;E=this.map.get(E.parent))if(E===S)return 1;for(let E=this.map.get(S.parent);E;E=this.map.get(E.parent))if(E===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=k;class _{constructor(a,h){this.testIdToInternal=a,this.publishDiff=h,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new A.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(a,h){this.addItem(a,h,null)}getTestByReference(a){return this.testItemToInternal.get(a)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const h=this.diff[this.diff.length-1];if(h&&a[0]===1){if(h[0]===1&&h[1].extId===a[1].extId){(0,P.applyTestItemUpdate)(h[1],a[1]);return}if(h[0]===0&&h[1].item.extId===a[1].extId){(0,P.applyTestItemUpdate)(h[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,h){var S;const v=this.testIdToInternal.object.get(a);if(!!v){if((v.expandLevels===void 0||h>v.expandLevels)&&(v.expandLevels=h),v.expand===1){const E=this.refreshChildren(v);return E.isSettled?this.expandChildren(v,h-1):E.p.then(()=>this.expandChildren(v,h-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,h-1)):this.expandChildren(v,h-1)}}dispose(){var a;for(const h of this.testItemToInternal.values())(a=h.discoverCts)===null||a===void 0||a.dispose(!0),h.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(a,h,S){if(!(a instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);if(this.testItemToInternal.has(a))throw new Error(`Attempted to add a single TestItem ${a.id} multiple times to the tree`);if(this.testIdToInternal.object.has(a.id))throw new Error(`Attempted to insert a duplicate test item ID ${a.id}`);const v=S?S.item.extId:null,E=a.expandable?1:0,c=S==null?void 0:S.expandLevels,u={provider:h,tree:this.testIdToInternal.object.id},s={actual:a,parent:v,item:I.TestItem.from(a),expandLevels:c&&E===1?c-1:void 0,expand:E,src:u};this.testIdToInternal.object.add(s),this.testItemToInternal.set(a,s),this.pushDiff([0,{parent:v,src:u,expand:E,item:s.item}]),a[D.TestItemHookProperty]={created:t=>this.addItem(t,h,s),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:a.id,item:{[t]:t==="range"?I.Range.from(i):i}}])};for(const t of a.children)this.addItem(t,h,s)}expandChildren(a,h){if(!(h<0)){const S=[...a.actual.children].map(v=>this.expand(v.id,h-1)).filter(A.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(a){a.discoverCts&&a.discoverCts.dispose(!0),a.expand=2,a.discoverCts=new R.CancellationTokenSource,this.pushExpandStateUpdate(a);const h=new A.DeferredPromise;return a.initialExpand=h,a.actual.discoverChildren({report:S=>{S.busy?(a.expand=2,this.pushExpandStateUpdate(a)):(a.expand=3,h.isSettled||h.complete(),this.pushExpandStateUpdate(a))}},a.discoverCts.token),h}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.actual.id,expand:a.expand}])}removeItembyId(a){var h;this.pushDiff([2,a]);const S=[this.testIdToInternal.object.get(a)];for(;S.length;){const v=S.pop();if(!!v){(h=v.discoverCts)===null||h===void 0||h.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const E of v.actual.children)S.push(this.testIdToInternal.object.get(E.id))}}}flushDiff(){const a=this.collectDiff();a.length&&this.publishDiff(a)}}e.SingleUseTestCollection=_}),define(ge[219],pe([0,1,29,3,8]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=I;class D{constructor(T){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${b.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(_=>k.add(b.ExtensionIdentifier.toKey(_))),this._extensionDescriptions=this._extensionDescriptions.filter(_=>k.has(b.ExtensionIdentifier.toKey(_.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const _=D._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(_.map(g=>g.identifier)),k.length>0){const g=new Set;k.forEach(a=>g.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(_)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const E=k.getArcs(S);for(let c=0;c<E.length;c++)if(!v.has(E[c]))return!1;return!0}getNodes(){return this._nodesArr}};let _=new Map;for(let S of T){const v=b.ExtensionIdentifier.toKey(S.identifier);if(_.set(v,S),S.extensionDependencies)for(let E of S.extensionDependencies){const c=b.ExtensionIdentifier.toKey(E);k.addArc(v,c)}}let g=new Set;k.getNodes().filter(S=>k.getArcs(S).length===0).forEach(S=>g.add(S));let a=k.getNodes().filter(S=>!g.has(S)),h;do{h=!1;for(let S=0;S<a.length;S++){const v=a[S];k.hasOnlyGoodArcs(v,g)&&(a.splice(S,1),S--,g.add(v),h=!0)}}while(h);return a.map(S=>_.get(S))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(b.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=D;var P;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(P||(P={}));function y(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,_=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==_)return k-_;const g=R.posix.basename(n.extensionLocation.path),a=R.posix.basename(T.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(ge[220],pe([0,1,25]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var A;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(A=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(P){const y=b.VSBuffer.alloc(1);switch(P){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=I;function D(P,y){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(ge[41],pe([0,1,3,2,4,29,181]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class P{constructor(u){this.dependency=u}}e.MissingDependencyError=P;var y;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(u,s,t,i){this.codeLoadingTime=u,this.activateCallTime=s,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class T{constructor(u,s){this.description=u,this.value=s}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function _(c){c.enableProposedApi||g(c)}e.checkProposedApiEnabled=_;function g(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=g;function a(c){var u;((u=c.workspaceTrust)===null||u===void 0?void 0:u.required)||h(c)}e.checkRequiresWorkspaceTrust=a;function h(c){throw new Error(`[${c.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=h;function S(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=S;function v(c){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!1,extensionLocation:c.location},c.manifest),{uuid:c.identifier.uuid})}e.toExtensionDescription=v;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,s){}_activateById(u,s){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,s,t,i,o){}_onExtensionRuntimeError(u,s){}_onExtensionHostExit(u){}}e.NullExtensionService=E}),define(ge[221],pe([0,1,159,29,41,12]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class P{constructor(h,S,v,E){this.startup=h,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=E}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class y{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,S){return h===-1||S===-1?-1:S-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(h,S,v,E,c,u){this.activationFailed=h,this.activationFailedError=S,this.activationTimes=v,this.module=E,this.exports=c,this.subscriptions=u}}e.ActivatedExtension=n;class T extends n{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class _ extends n{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let g=class{constructor(h,S,v,E,c){this._logService=c,this._registry=h,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(A.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,v.forEach(u=>this._hostExtensionsMap.set(A.ExtensionIdentifier.toKey(u),u)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const S=A.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(S)}getActivatedExtension(h){const S=A.ExtensionIdentifier.toKey(h),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+h.value+"` is not known or not activated");return v}activateByEvent(h,S){if(this._alreadyActivatedEvents[h])return D;const v=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(v.map(E=>({id:E.identifier,reason:{startup:S,extensionId:E.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,S){const v=this._registry.getExtensionDescription(h);if(!v)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(h,S,v){if(this._hostExtensionsMap.has(A.ExtensionIdentifier.toKey(h.id))){S[A.ExtensionIdentifier.toKey(h.id)]=h;return}const E=this._registry.getExtensionDescription(h.id);if(!E){this._host.onExtensionActivationError(h.id,new R.MissingDependencyError(h.id.value));const s=new Error(`Unknown dependency '${h.id.value}'`);this._activatedExtensions.set(A.ExtensionIdentifier.toKey(h.id),new _(s));return}const c=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let u=!0;for(let s=0,t=c.length;s<t;s++){const i=c[s];if(!this._resolvedExtensionsSet.has(A.ExtensionIdentifier.toKey(i))){const o=this._activatedExtensions.get(A.ExtensionIdentifier.toKey(i));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(E.identifier,b.localize(0,null,E.displayName||E.identifier.value,i));const f=new Error(`Dependency ${i} failed to activate`);f.detail=o.activationFailedError,this._activatedExtensions.set(A.ExtensionIdentifier.toKey(E.identifier),new _(f));return}if(this._hostExtensionsMap.has(A.ExtensionIdentifier.toKey(i))){u=!1,S[A.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(A.ExtensionIdentifier.toKey(i)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){u=!1,S[A.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:h.reason};continue}this._host.onExtensionActivationError(E.identifier,new R.MissingDependencyError(i));const l=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(A.ExtensionIdentifier.toKey(E.identifier),new _(l));return}}}u?S[A.ExtensionIdentifier.toKey(E.identifier)]=h:v.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(c=>!this._activatedExtensions.has(A.ExtensionIdentifier.toKey(c.id))),h.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let c=0,u=h.length;c<u;c++)this._handleActivateRequest(h[c],S,v);for(let c=0,u=v.length;c<u;c++){const s=A.ExtensionIdentifier.toKey(v[c].id);S[s]&&delete S[s]}const E=Object.keys(S).map(c=>S[c]);return v.length===0?Promise.all(E.map(c=>this._activateExtension(c.id,c.reason))).then(c=>{}):this._activateExtensions(E).then(c=>this._activateExtensions(v))}_activateExtension(h,S){const v=A.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const E=this._activatingExtensions.get(v);if(E)return E;const c=this._host.actualActivateExtension(h,S).then(void 0,u=>(this._host.onExtensionActivationError(h,b.localize(1,null,h.value,u.message)),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(u),new _(u))).then(u=>{this._activatedExtensions.set(v,u),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,c),c}};g=je([Ue(4,I.ILogService)],g),e.ExtensionsActivator=g}),define(ge[222],pe([0,1,12,41,27,11,109]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends b.LogService{constructor(n){if(n.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(A.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};P=je([Ue(0,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[223],pe([0,1,16]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class A{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,D)=>{this._actualOk=I,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,b.onUnexpectedError)(I))}then(I,D){return this._ensureActual().then(I,D)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=A}),define(ge[123],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const A=[];function R(P){const y=new b(!0,P);return A[y.nid]=y,y}e.createMainContextProxyIdentifier=R;function I(P){const y=new b(!1,P);return A[y.nid]=y,y}e.createExtHostContextProxyIdentifier=I;function D(P){return A[P].sid}e.getStringIdentifierForProxy=D}),define(ge[5],pe([0,1,2,123,57]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var D;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(y=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var _;(function(c){c.name="$ident";function u(t,i){return Object.defineProperty(t,c.name,{value:i,enumerable:!0}),t}c.mixin=u;function s(t){return t[c.name]}c.of=s})(_=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(u){return u._id=g._n++,u}}e.IdObject=g,g._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(c){if(c&&c.edits)for(const u of c.edits)typeof u.resource=="object"?u.resource=b.URI.revive(u.resource):(u.newUri=b.URI.revive(u.newUri),u.oldUri=b.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,R.revive)(u.metadata));return c}e.reviveWorkspaceEditDto=v;var E;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,A.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,A.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,A.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,A.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,A.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,A.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,A.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,A.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,A.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,A.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,A.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,A.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,A.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,A.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,A.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,A.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,A.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,A.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,A.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,A.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,A.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,A.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,A.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,A.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,A.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,A.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,A.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,A.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,A.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,A.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,A.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,A.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,A.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,A.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,A.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,A.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,A.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,A.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,A.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,A.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,A.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,A.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,A.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,A.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,A.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,A.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,A.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,A.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,A.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,A.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,A.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,A.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,A.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,A.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,A.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,A.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,A.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,A.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,A.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,A.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,A.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,A.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,A.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,A.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,A.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,A.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,A.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,A.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,A.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,A.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,A.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,A.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,A.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,A.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,A.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,A.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,A.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,A.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,A.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,A.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,A.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,A.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,A.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,A.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,A.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,A.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,A.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,A.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,A.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,A.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,A.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,A.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,A.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,A.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,A.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,A.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(P){this._onDidChangePassword=new A.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,y){return this._proxy.$getPassword(P,y)}store(P,y,n){return this._proxy.$setPassword(P,y,n)}delete(P,y){return this._proxy.$deletePassword(P,y)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(ge[62],pe([0,1,4,12,5,13]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(R.MainContext.MainThreadTelemetry)}report(y,n,T){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};D=je([Ue(0,I.IExtHostRpcService),Ue(1,A.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(P,y,n){}})}),define(ge[224],pe([0,1,3,5,7,29]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,k={}){const _=I.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(_)||[],a=T.sort().join(" ");let h=g.find(S=>S.scopes===a);if(h)return h.result;{const S=this._getSession(y,_,n,T,k);h={scopes:a,result:S},g.push(h),this._inFlightRequests.set(_,g);try{await S}finally{const v=g.findIndex(E=>E.scopes===a);v>-1&&(g.splice(v),this._inFlightRequests.set(_,g))}return S}}async _getSession(y,n,T,k,_={}){await this._proxy.$ensureProvider(T);const g=y.displayName||y.name;return this._proxy.$getSession(T,k,n,g,_)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,k){var _;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===y)||this._providers.push({id:y,label:n});const g=T.onDidChangeSessions(a=>{var h,S,v;this._proxy.$sendDidChangeSessions(y,{added:(h=a.added)!==null&&h!==void 0?h:[],changed:(S=a.changed)!==null&&S!==void 0?S:[],removed:(v=a.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(_=k==null?void 0:k.supportsMultipleAccounts)!==null&&_!==void 0?_:!1),new R.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const a=this._providers.findIndex(h=>h.id===y);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(_=>_.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ge[225],pe([0,1,5,13,20]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(P,y){this._extHostDocumentsAndEditors=y,this._proxy=P.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const y=R.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};I=je([Ue(0,A.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(ge[226],pe([0,1,5]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(I){const D=I.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(P){return D.$writeText(P)}})}}e.ExtHostClipboard=A}),define(ge[51],pe([0,1,15,7,20,22,5,14,12,57,43,49,2,6,4,13]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=i,this.converter=new v(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===c.Void?r:void 0},i),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,I.cloneAndChange)(o,function(r){if(T.Range.isIRange(r))return R.Range.to(r);if(k.Position.isIPosition(r))return R.Position.to(r);if(T.Range.isIRange(r.range)&&_.URI.isUri(r.uri))return R.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((f,p)=>{if(!f.validate(o[p]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${o[p]}`);return f.convert(o[p])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new A.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:r,description:l}),t&&this._proxy.$registerCommand(i),new A.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=(0,I.cloneAndChange)(i,function(l){if(l instanceof A.Position)return R.Position.from(l);if(l instanceof A.Range)return R.Range.from(l);if(l instanceof A.Location)return R.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,o);return(0,n.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:l,description:f}=o;if(f)for(let p=0;p<f.args.length;p++)try{(0,b.validateConstraint)(i[p],f.args[p].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[p].name}' - ${f.args[p].description}`)}try{return await r.apply(l,i)}catch(p){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...i);w&&(t=w.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:r}=o;r&&(t[i]=r)}return Promise.resolve(t)}};S=je([Ue(0,h.IExtHostRpcService),Ue(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class v{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((l,f)=>l.convert(t.arguments&&t.arguments[f]));else if((0,P.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add((0,g.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),o.$ident=l,o.id=this.delegatingCommandId,o.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return o}}fromInternal(t){const i=D.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class E{constructor(t,i,o,r){this.name=t,this.description=i,this.validate=o,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new E(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",s=>_.URI.isUri(s),s=>s),E.Position=new E("position","A position in a text document",s=>A.Position.isPosition(s),R.Position.from),E.Range=new E("range","A range in a text document",s=>A.Range.isRange(s),R.Range.from),E.Selection=new E("selection","A selection in a text document",s=>A.Selection.isSelection(s),R.Selection.from),E.Number=new E("number","",s=>typeof s=="number",s=>s),E.String=new E("string","",s=>typeof s=="string",s=>s),E.CallHierarchyItem=new E("item","A call hierarchy item",s=>s instanceof A.CallHierarchyItem,R.CallHierarchyItem.to);class c{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=c,c.Void=new c("no result",s=>s);class u{constructor(t,i,o,r,l){this.id=t,this.internalId=i,this.description=o,this.args=r,this.result=l}}e.ApiCommand=u}),define(ge[227],pe([0,1,6,20,7,79,51,199,14,106]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",_(A.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(a,h)=>{if(!(0,y.isFalsyOrEmpty)(a)){class S extends R.SymbolInformation{static to(E){const c=new S(E.name,A.SymbolKind.to(E.kind),E.containerName||"",new R.Location(h[0],A.Range.to(E.range)));return c.detail=E.detail,c.range=c.location.range,c.selectionRange=A.Range.to(E.selectionRange),c.children=E.children?E.children.map(S.to):[],c}}return a.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(A.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(A.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(A.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(A.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(A.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(h=>R.Position.isPosition(h)),a=>a.map(A.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(h=>{let S;for(const v of h.reverse())S=new R.SelectionRange(A.Range.to(v),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const h=[];if(Array.isArray(a))for(let S of a)h.push(...S[1].map(A.WorkspaceSymbol.to));return h})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(A.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(A.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(A.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return A.WorkspaceEdit.to(a)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(A.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,n.decodeSemanticTokensDto)(a);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,n.decodeSemanticTokensDto)(a);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,h,S)=>{if(!a)return new R.CompletionList([]);const v=a.suggestions.map(E=>A.CompletionItem.to(E,S));return new R.CompletionList(v,a.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return A.SignatureHelp.to(a)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,h,S)=>_(v=>new R.CodeLens(A.Range.to(v.range),v.command&&S.fromInternal(v.command)))(a))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>R.Range.isRange(a),a=>R.Selection.isSelection(a)?A.Selection.from(a):A.Range.from(a)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,h,S)=>_(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const E=new R.CodeAction(v.title,v.kind?new R.CodeActionKind(v.kind):void 0);return v.edit&&(E.edit=A.WorkspaceEdit.to(v.edit)),v.command&&(E.command=S.fromInternal(v.command)),E.isPreferred=v.isPreferred,E}})(a))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(h=>new R.ColorInformation(A.Range.to(h.range),A.Color.to(h.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",a=>a instanceof R.Color,A.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:A.Range.from(a.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(A.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(A.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientMetadata},filenamePattern:a.filenamePattern.map(h=>A.NotebookExclusiveDocumentPattern.to(h))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(A.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[A.ViewColumn.from(a.viewColumn),A.TextEditorOpenOptions.from(a)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[A.ViewColumn.from(a.viewColumn),A.TextEditorOpenOptions.from(a)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[A.ViewColumn.from(a.viewColumn),A.TextEditorOpenOptions.from(a)]).optional()],D.ApiCommandResult.Void)];class k{constructor(h){this._disposables=new b.DisposableStore,this._commands=h}static register(h){return T.forEach(h.registerApiCommand,h),new k(h).registerCommands()}registerCommands(){const h=S=>(...v)=>S(this._commands,...v);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,h(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(P.OpenIssueReporter.ID,h(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(h,S,v){const E=this._commands.registerCommand(!1,h,S,this,v);this._disposables.add(E)}}e.ExtHostApiCommands=k;function _(a){return h=>{if(Array.isArray(h))return h.map(a)}}function g(a){if(!!Array.isArray(a)){const h=[];for(const S of a)I.isLocationLink(S)?h.push(A.DefinitionLink.to(S)):h.push(A.location.to(S));return h}}}),define(ge[228],pe([0,1,17,68,3,6,2,79,29,20,7,5]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class _{constructor(u,s,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadComments),s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.commentUniqueId,f=r.getCommentByUniqueId(l);return f||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.text,f=i.commentUniqueId,p=r.getCommentByUniqueId(f);return p?(p.body=l,p):i}return i}})}createCommentController(u,s,t){const i=_.handlePool++,o=new a(u,i,this._proxy,s,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(o),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),r),o}$createCommentThreadTemplate(u,s,t){const i=this._commentControllers.get(u);!i||i.$createCommentThreadTemplate(s,t)}async $updateCommentThreadTemplate(u,s,t){const i=this._commentControllers.get(u);!i||i.$updateCommentThreadTemplate(s,t)}$deleteCommentThread(u,s){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(s)}$provideCommentingRanges(u,s,t){const i=this._commentControllers.get(u);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(D.URI.revive(s));return(0,b.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(l=>n.Range.from(l)):void 0)}$toggleReaction(u,s,t,i,o){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const l=r.getCommentThread(s);if(l){const f=l.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&f&&r.reactionHandler)return r.reactionHandler(f,v(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=_,_.handlePool=0;class g{constructor(u,s,t,i,o,r,l){this._proxy=u,this._commentController=s,this._id=t,this._uri=i,this._range=o,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${s.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),s={};u("range")&&(s.range=n.Range.from(this._range)),u("label")&&(s.label=this.label),u("contextValue")&&(s.contextValue=this.contextValue),u("comments")&&(s.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(s.collapseState=E(this._collapseState)),u("canReply")&&(s.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,s)}}getCommentByUniqueId(u){for(let s of this._commentsMap){let t=s[0],i=s[1];if(u===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,A.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class a{constructor(u,s,t,i,o){this._extension=u,this._handle=s,this._proxy=t,this._id=i,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,s,t,i){if(typeof u=="string"){const o=new g(this._proxy,this,u,s,t,i,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new g(this._proxy,this,void 0,u,s,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,s){const t=new g(this._proxy,this,void 0,D.URI.revive(u),n.Range.to(s),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,s){let t=this._threads.get(u);t&&(t.range=n.Range.to(s))}$deleteCommentThread(u){let s=this._threads.get(u);s&&s.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(c,u,s,t){let i=t.get(s);i||(i=++c.commentHandle,t.set(s,i));const o=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(s.body),userName:s.author.name,userIconPath:o,label:s.label,commentReactions:s.reactions?s.reactions.map(r=>S(r)):void 0}}function S(c){return{label:c.label,iconPath:c.iconPath?n.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function v(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?D.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function E(c){if(c!==void 0)switch(c){case T.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[124],pe([0,1,2,5,7,4,13,12,14,10,8]),function(Z,e,b,A,R,I,D,P,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class mn{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const h=mn._handlePool++;this._provider.set(h,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(h,null);return}let E=(0,y.asArray)(v);if(E.length<=mn._maxEventSize){this._proxy.$onDidChange(h,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,E.length);const c=E.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,y.groupBy)(c,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let s=[];e:for(let t of u){let i;for(let o of t){let r=(0,T.dirname)(o.uri.path);if(i!==r&&(i=r,s.push(o.uri)>=mn._maxEventSize))break e}}this._proxy.$onDidChange(h,s)});return new R.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(g,a,h){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:E}=this._provider.get(g);return await Promise.all(a.map(async c=>{try{const{uri:u,id:s}=c,t=await Promise.resolve(v.provideFileDecoration(b.URI.revive(u),h));if(!t)return;try{R.FileDecoration.validate(t),S[s]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${E.value}': ${i}`)}}catch(u){this._logService.error(u)}})),S}};k._handlePool=0,k._maxEventSize=250,k=je([Ue(0,D.IExtHostRpcService),Ue(1,P.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(ge[229],pe([0,1,158,110,2,5,7,20,3,12,23]),function(Z,e,b,A,R,I,D,P,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(a,h,S,v,E){this._name=a,this._owner=h,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,h){if(!a){this.clear();return}this._checkDisposed();let S=[];if(R.URI.isUri(a)){if(!h){this.delete(a);return}this._data.set(a,h.slice()),S=[a]}else if(Array.isArray(a)){S=[];let E;a=[...a].sort(k._compareIndexedTuplesByUri);for(const c of a){const[u,s]=c;if((!E||u.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=u,S.push(u),this._data.set(u,[])),s){const t=this._data.get(u);t&&t.push(...s)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let E of S){let c=[];const u=this._data.get(E);if(u)if(u.length>this._maxDiagnosticsPerFile){c=[];const s=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of u)if(i.severity===s[t]&&c.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;c.push({severity:A.MarkerSeverity.Info,message:(0,b.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=u.map(s=>P.Diagnostic.from(s));v.push([E,c])}this._proxy.$changeMany(this._owner,v)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,h){this._checkDisposed();for(let S of this._data.keys())a.apply(h,[S,this.get(S),this])}get(a){this._checkDisposed();const h=this._data.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=k;let _=class Vt{constructor(a,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=a.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(a,h){return a?a.concat(h):h}static _mapper(a){const h=[],S=new Set;for(const v of a)typeof v=="string"?S.has(v)||(S.add(v),h.push(R.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),h.push(v));return Object.freeze(h),{uris:h}}createDiagnosticCollection(a,h){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:E,_logService:c}=this,u=new class{$changeMany(i,o){v.$changeMany(i,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,i,o.length===0?"CLEARING":o)}$clear(i){v.$clear(i),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,i)}dispose(){v.dispose()}};let s;if(!h)h="_generated_diagnostic_collection_name_#"+Vt._idPool++,s=h;else if(!S.has(h))s=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do s=h+Vt._idPool++;while(S.has(s))}return new class extends k{constructor(){super(h,s,Vt._maxDiagnosticsPerFile,u,E);S.set(s,this)}dispose(){super.dispose(),S.delete(s)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const h=new Map,S=[];for(const v of this._collections.values())v.forEach((E,c)=>{let u=h.get(E.toString());typeof u=="undefined"&&(u=S.length,h.set(E.toString(),u),S.push([E,[]])),S[u][1]=S[u][1].concat(...c)});return S}}_getDiagnostics(a){let h=[];for(let S of this._collections.values())S.has(a)&&(h=h.concat(S.get(a)));return h}$acceptMarkersChange(a){if(!this._mirrorCollection){const h="_generated_mirror",S=new k(h,h,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,S),this._mirrorCollection=S}for(const[h,S]of a)this._mirrorCollection.set(R.URI.revive(h),S.map(P.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=je([Ue(1,n.ILogService)],_),e.ExtHostDiagnostics=_}),define(ge[230],pe([0,1,2,5]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(D){this._proxy=D.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(P=>P?P.map(y=>b.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(P=>P?b.URI.revive(P):void 0)}}e.ExtHostDialogs=R}),define(ge[231],pe([0,1,16,2,7,5,11,21,10]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,_,g){this._documentsAndEditors=_,this._logService=g,this._documentContentProviders=new Map,this._proxy=k.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,_){if(Object.keys(D.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const g=n._handlePool++;this._documentContentProviders.set(g,_),this._proxy.$registerTextContentProvider(g,k);let a;return typeof _.onDidChange=="function"&&(a=_.onDidChange(h=>{if(h.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(g,h).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(h);if(!!v){const E=(0,y.splitLines)(S);if(!v.equalLines(E))return this._proxy.$onVirtualDocumentChange(h,S)}}},b.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(k,_){const g=this._documentContentProviders.get(k);return g?Promise.resolve(g.provideTextDocumentContent(A.URI.revive(_),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ge[232],pe([0,1,3,6,2,5,118,20,15,22]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(_,g){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new A.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const h of a)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const h of a)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!!_){const g=this._documentsAndEditors.getDocument(_);if(g)return g}}getDocument(_){const g=this.getDocumentData(_);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${_}'`);return g.document}ensureDocumentData(_){const g=this._documentsAndEditors.getDocument(_);if(g)return Promise.resolve(g);let a=this._documentLoader.get(_.toString());return a||(a=this._proxy.$tryOpenDocument(_).then(h=>{this._documentLoader.delete(_.toString());const S=R.URI.revive(h);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(_.toString()),Promise.reject(h))),this._documentLoader.set(_.toString(),a)),a}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(g=>R.URI.revive(g))}$acceptModelModeChanged(_,g){const a=R.URI.revive(_),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(g),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(_){const g=R.URI.revive(_),a=this._documentsAndEditors.getDocument(g);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(_,g){const a=R.URI.revive(_),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(g),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(_,g,a){const h=R.URI.revive(_),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(a),S.onEvents(g),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:S.document,contentChanges:g.changes.map(v=>({range:P.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(_,g){(0,D.setWordDefinitionFor)(_,g)}}e.ExtHostDocuments=T}),define(ge[39],pe([0,1,52,3,6,2,4,5,118,13,122,20,12,23,11,71,133]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(u,s){this._extHostRpc=u,this._logService=s,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new A.Emitter,this._onDidRemoveDocuments=new A.Emitter,this._onDidChangeVisibleTextEditors=new A.Emitter,this._onDidChangeActiveTextEditor=new A.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const s=[],t=[],i=[];if(u.removedDocuments)for(const o of u.removedDocuments){const r=I.URI.revive(o),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),s.push(l.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const r=I.URI.revive(o.uri);let l=this._documents.get(r);if(l&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new v(new y.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(u.removedEditors)for(const o of u.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&i.push(r)}if(u.addedEditors)for(const o of u.addedEditors){const r=I.URI.revive(o.documentUri);b.ok(this._documents.has(r),`document '${r}' does not exist`),b.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const l=this._documents.get(r).value,f=new T.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(p=>k.Range.to(p)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,f)}u.newActiveEditor!==void 0&&(b.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,R.dispose)(s),(0,R.dispose)(i),u.removedDocuments&&this._onDidRemoveDocuments.fire(s),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var s;return(s=this._documents.get(u))===null||s===void 0?void 0:s.value}allDocuments(){return h.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const s=this._editors.get(this._activeEditorId);return u?s:s==null?void 0:s.value}}allEditors(){return[...this._editors.values()]}};E=je([Ue(0,n.IExtHostRpcService),Ue(1,_.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[233],pe([0,1,2,5,6,7,20,141,10,25]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const a=this._schemes.indexOf(g);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),a=[];let h,S,v=14,E=14;for(const c of g){let u=h?(0,y.commonPrefixLength)(h,c):0;for(u===0?S=1:S=E;u<c.length;u++)u+1===c.length?(v=E,E=9):E+=1,a.push([S,c.toUpperCase().charCodeAt(u),E]),a.push([S,c.toLowerCase().charCodeAt(u),E]),S=E;h=c,E=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(g){this._initStateMachine();const a=[],h=P.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of h){const v=D.DocumentLink.to(S);v.target&&a.push(v)}return a}}class k{constructor(g,a){this._extHostLanguageFeatures=a,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,a,h,S={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,h);let E=2;S.isCaseSensitive&&(E+=1024),S.isReadonly&&(E+=2048),typeof h.copy=="function"&&(E+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(v,a,E).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${a}`),console.error(u)});const c=h.onDidChangeFile(u=>{const s=[];for(const t of u){let{uri:i,type:o}=t;if(i.scheme===a){let r;switch(o){case I.FileChangeType.Changed:r=0;break;case I.FileChangeType.Created:r=1;break;case I.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:i,type:r})}}this._proxy.$onFileSystemChange(v,s)});return(0,R.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(g){const{type:a,ctime:h,mtime:S,size:v}=g;return{type:a,ctime:h,mtime:S,size:v}}$stat(g,a){return Promise.resolve(this._getFsProvider(g).stat(b.URI.revive(a))).then(k._asIStat)}$readdir(g,a){return Promise.resolve(this._getFsProvider(g).readDirectory(b.URI.revive(a)))}$readFile(g,a){return Promise.resolve(this._getFsProvider(g).readFile(b.URI.revive(a))).then(h=>n.VSBuffer.wrap(h))}$writeFile(g,a,h,S){return Promise.resolve(this._getFsProvider(g).writeFile(b.URI.revive(a),h.buffer,S))}$delete(g,a,h){return Promise.resolve(this._getFsProvider(g).delete(b.URI.revive(a),h))}$rename(g,a,h,S){return Promise.resolve(this._getFsProvider(g).rename(b.URI.revive(a),b.URI.revive(h),S))}$copy(g,a,h,S){const v=this._getFsProvider(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(b.URI.revive(a),b.URI.revive(h),S))}$mkdir(g,a){return Promise.resolve(this._getFsProvider(g).createDirectory(b.URI.revive(a)))}$watch(g,a,h,S){const v=this._getFsProvider(g).watch(b.URI.revive(h),S);this._watches.set(a,v)}$unwatch(g,a){const h=this._watches.get(a);h&&(h.dispose(),this._watches.delete(a))}$open(g,a,h){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(b.URI.revive(a),h))}$close(g,a){const h=this._getFsProvider(g);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(a))}$read(g,a,h,S){const v=this._getFsProvider(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=n.VSBuffer.alloc(S);return Promise.resolve(v.read(a,h,E.buffer,0,S)).then(c=>E.slice(0,c))}$write(g,a,h,S){const v=this._getFsProvider(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,h,S.buffer,0,S.byteLength))}_getFsProvider(g){const a=this._fsProvider.get(g);if(!a){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return a}}e.ExtHostFileSystem=k}),define(ge[87],pe([0,1,5,44,7,25,4,13,60]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Lt{constructor(k,_){const g=k.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return g.$stat(a).catch(Lt._handleError)},readDirectory(a){return g.$readdir(a).catch(Lt._handleError)},createDirectory(a){return g.$mkdir(a).catch(Lt._handleError)},async readFile(a){return g.$readFile(a).then(h=>h.buffer).catch(Lt._handleError)},writeFile(a,h){return g.$writeFile(a,I.VSBuffer.wrap(h)).catch(Lt._handleError)},delete(a,h){return g.$delete(a,Object.assign({recursive:!1,useTrash:!1},h)).catch(Lt._handleError)},rename(a,h,S){return g.$rename(a,h,Object.assign({overwrite:!1},S)).catch(Lt._handleError)},copy(a,h,S){return g.$copy(a,h,Object.assign({overwrite:!1},S)).catch(Lt._handleError)},isWritableFileSystem(a){const h=_.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case A.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case A.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case A.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case A.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};n=je([Ue(0,P.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[234],pe([0,1,6,5]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(D){this._handlePool=0,this._proxy=D.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,D),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=R}),define(ge[235],pe([0,1,2,22,20,7,17,5,10,43,14,15,138,6,106,70,116,46,16]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(z,J){this._documents=z,this._provider=J}provideDocumentSymbols(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,J)).then(ae=>{if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof I.DocumentSymbol?ae.map(R.DocumentSymbol.from):c._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var J;z=z.slice(0).sort((he,De)=>{let Me=he.location.range.start.compareTo(De.location.range.start);return Me===0&&(Me=De.location.range.end.compareTo(he.location.range.end)),Me});const te=[],ae=[];for(const he of z){const De={name:he.name||"!!MISSING: name!!",kind:R.SymbolKind.from(he.kind),tags:((J=he.tags)===null||J===void 0?void 0:J.map(R.SymbolTag.from))||[],detail:"",containerName:he.containerName,range:R.Range.from(he.location.range),selectionRange:R.Range.from(he.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Me=ae[ae.length-1];if(n.Range.containsRange(Me.range,De.range)&&!n.Range.equalsRange(Me.range,De.range)){Me.children&&Me.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(z,J,te){this._documents=z,this._commands=J,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,J){const te=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(te,J);if(!(!ae||J.isCancellationRequested)){const he=this._cache.add(ae),De=new g.DisposableStore;this._disposables.set(he,De);const Me={cacheId:he,lenses:[]};for(let we=0;we<ae.length;we++)Me.lenses.push({cacheId:[he,we],range:R.Range.from(ae[we].range),command:this._commands.toInternal(ae[we].command,De)});return Me}}async resolveCodeLens(z,J){var te;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let he;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?he=ae:he=await this._provider.resolveCodeLens(ae,J),he||(he=ae),!J.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((te=he.command)!==null&&te!==void 0?te:u._badCmd,De),z}}}releaseCodeLenses(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(Fe){return Array.isArray(Fe)?Fe.map(R.DefinitionLink.from):Fe?[R.DefinitionLink.from(Fe)]:[]}class t{constructor(z,J){this._documents=z,this._provider=J}provideDefinition(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,he,te)).then(s)}}class i{constructor(z,J){this._documents=z,this._provider=J}provideDeclaration(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,he,te)).then(s)}}class o{constructor(z,J){this._documents=z,this._provider=J}provideImplementation(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,he,te)).then(s)}}class r{constructor(z,J){this._documents=z,this._provider=J}provideTypeDefinition(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,he,te)).then(s)}}class l{constructor(z,J){this._documents=z,this._provider=J}provideHover(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideHover(ae,he,te)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(he)),De.range||(De.range=new I.Range(he,he)),R.Hover.from(De)})}}class f{constructor(z,J){this._documents=z,this._provider=J}provideEvaluatableExpression(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,he,te)).then(De=>{if(De)return R.EvaluatableExpression.from(De)})}}class p{constructor(z,J){this._documents=z,this._provider=J}provideInlineValues(z,J,te,ae){const he=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineValues(he,R.Range.to(J),R.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Me=>R.InlineValue.from(Me))})}}class w{constructor(z,J){this._documents=z,this._provider=J}provideDocumentHighlights(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,he,te)).then(De=>{if(Array.isArray(De))return De.map(R.DocumentHighlight.from)})}}class d{constructor(z,J){this._documents=z,this._provider=J}provideLinkedEditingRanges(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,he,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(R.Range.from)),wordPattern:De.wordPattern}})}}class m{constructor(z,J){this._documents=z,this._provider=J}provideReferences(z,J,te,ae){const he=this._documents.getDocument(z),De=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideReferences(he,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(R.location.from)})}}class C{constructor(z,J,te,ae,he,De,Me){this._documents=z,this._commands=J,this._diagnostics=te,this._provider=ae,this._logService=he,this._extension=De,this._apiDeprecation=Me,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,J,te,ae){const he=this._documents.getDocument(z),De=_.Selection.isISelection(J)?R.Selection.to(J):R.Range.to(J),Me=[];for(const ke of this._diagnostics.getDiagnostics(z))if(De.intersection(ke.range)&&Me.push(ke)>C._maxCodeActionsPerFile)break;const we={diagnostics:Me,only:te.only?new I.CodeActionKind(te.only):void 0,triggerKind:R.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(he,De,we,ae)).then(ke=>{var Te;if(!(!(0,T.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),Se=new g.DisposableStore;this._disposables.set(xe,Se);const Ge=[];for(let Q=0;Q<ke.length;Q++){const ie=ke[Q];!ie||(C._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(we.only&&(ie.kind?we.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[xe,Q],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(R.Diagnostic.from),edit:ie.edit&&R.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Te=ie.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:xe,actions:Ge}}})}async resolveCodeAction(z,J){var te;const[ae,he]=z,De=this._cache.get(ae,he);if(!(!De||C._isCommand(De))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(De,J))!==null&&te!==void 0?te:De;return(Me==null?void 0:Me.edit)?R.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}C._maxCodeActionsPerFile=1e3;class L{constructor(z,J){this._documents=z,this._provider=J}provideDocumentFormattingEdits(z,J,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,J,te)).then(he=>{if(Array.isArray(he))return he.map(R.TextEdit.from)})}}class B{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeFormattingEdits(z,J,te,ae){const he=this._documents.getDocument(z),De=R.Range.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(he,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(R.TextEdit.from)})}}class ee{constructor(z,J){this._documents=z,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,J,te,ae,he){const De=this._documents.getDocument(z),Me=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Me,te,ae,he)).then(we=>{if(Array.isArray(we))return we.map(R.TextEdit.from)})}}class H{constructor(z,J){this._provider=z,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,J){const te=P.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,J)).then(ae=>{if((0,T.isNonEmptyArray)(ae)){for(const he of ae)if(!!he){if(!he.name){this._logService.warn("INVALID SymbolInformation, lacks name",he);continue}const De=P.IdObject.mixin(R.WorkspaceSymbol.from(he));this._symbolCache.set(De._id,he),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,J));return ae&&(0,A.mixin)(z,R.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const J=this._resultCache.get(z);if(J){for(let[te,ae]=J;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class x{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,J,te,ae){const he=this._documents.getDocument(z),De=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(he,De,te,ae)).then(Me=>{if(!!Me)return R.WorkspaceEdit.from(Me)},Me=>{const we=x._asMessage(Me);return we?{rejectReason:we,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(z,J,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),he=R.Position.to(J);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,he,te)).then(De=>{let Me,we;if(I.Range.isRange(De)?(Me=De,we=ae.getText(De)):(0,k.isObject)(De)&&(Me=De.range,we=De.placeholder),!!Me){if(Me.start.line>he.line||Me.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Me),text:we}}},De=>{const Me=x._asMessage(De);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class W{constructor(z,J){this.resultId=z,this.tokens=J}}class F{constructor(z,J){this._documents=z,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,J,te){const ae=this._documents.getDocument(z),he=J!==0?this._previousResults.get(J):null;return(0,D.asPromise)(()=>he&&typeof he.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,he.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(he&&this._previousResults.delete(J),De?(De=F._fixProvidedSemanticTokens(De),this._send(F._convertToEdits(he,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return F._isSemanticTokens(z)?F._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):F._isSemanticTokensEdits(z)?F._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(J=>new I.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,J){if(!F._isSemanticTokens(J)||!z||!z.tokens)return J;const te=z.tokens,ae=te.length,he=J.data,De=he.length;let Me=0;const we=Math.min(ae,De);for(;Me<we&&te[Me]===he[Me];)Me++;if(Me===ae&&Me===De)return new I.SemanticTokensEdits([],J.resultId);let ke=0;const Te=we-Me;for(;ke<Te&&te[ae-ke-1]===he[De-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Me,deleteCount:ae-Me-ke,data:he.subarray(Me,De-ke)}],J.resultId)}_send(z,J){if(F._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new W(z.resultId,z.data)),(0,a.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(F._isSemanticTokensEdits(z)){const te=this._nextResultId++;return F._isSemanticTokens(J)?this._previousResults.set(te,new W(J.resultId,J.data)):this._previousResults.set(te,new W(z.resultId)),(0,a.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeSemanticTokens(z,J,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,R.Range.to(J),te)).then(he=>he?this._send(he):null)}_send(z){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(z,J,te,ae,he){this._documents=z,this._commands=J,this._provider=te,this._apiDeprecation=ae,this._extension=he,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,J,te,ae){const he=this._documents.getDocument(z),De=R.Position.to(J),Me=he.getWordRangeAtPosition(De)||new I.Range(De,De),we=Me.with({end:De}),ke=new v.StopWatch(!0),Te=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(he,De,ae,R.CompletionContext.to(te)));if(!!Te&&!ae.isCancellationRequested){const xe=Array.isArray(Te)?new I.CompletionList(Te):Te,Se=M.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new g.DisposableStore;this._disposables.set(Se,Ge);const Q=[],ie={x:Se,b:Q,a:{replace:R.Range.from(Me),insert:R.Range.from(we)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let be=0;be<xe.items.length;be++){const Oe=xe.items[be],Ve=this._convertCompletionItem(Oe,[Se,be],we,Me);Q.push(Ve)}return ie}}async resolveCompletionItem(z,J){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,J));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,J,te,ae){var he;const De=this._disposables.get(J[0]);if(!De)throw Error("DisposableStore is missing...");const Me={x:J,a:(he=z.label)!==null&&he!==void 0?he:"",o:z.label2,b:z.kind!==void 0?R.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(R.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=z.textEdit.newText):typeof z.insertText=="string"?Me.h=z.insertText:z.insertText instanceof I.SnippetString&&(Me.h=z.insertText.value,Me.i|=4);let we;return z.textEdit?we=z.textEdit.range:z.range&&(we=z.range),I.Range.isRange(we)?Me.j=R.Range.from(we):we&&(!(te==null?void 0:te.isEqual(we.inserting))||!(ae==null?void 0:ae.isEqual(we.replacing)))&&(Me.j={insert:R.Range.from(we.inserting),replace:R.Range.from(we.replacing)}),Me}}class N{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(z,J,te,ae){const he=this._documents.getDocument(z),De=R.Position.to(J),Me=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(he,De,ae,Me)).then(we=>{if(we){const ke=this._cache.add([we]);return Object.assign(Object.assign({},R.SignatureHelp.from(we)),{id:ke})}})}reviveContext(z){let J;if(z.activeSignatureHelp){const te=R.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=te.activeSignature,J.activeParameter=te.activeParameter):J=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:J})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,J){this._documents=z,this._provider=J}provideInlineHints(z,J,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,R.Range.to(J),te)).then(he=>he?{hints:he.map(R.InlineHint.from)}:void 0)}}class V{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("DocumentLink")}provideLinks(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(R.DocumentLink.from)};{const he=this._cache.add(ae),De={links:[],id:he};for(let Me=0;Me<ae.length;Me++){const we=R.DocumentLink.from(ae[Me]);we.cacheId=[he,Me],De.links.push(we)}return De}}})}resolveLink(z,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,J)).then(ae=>ae&&R.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,J){this._documents=z,this._provider=J}provideColors(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,J)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:R.Color.from(De.color),range:R.Range.from(De.range)})):[])}provideColorPresentations(z,J,te){const ae=this._documents.getDocument(z),he=R.Range.to(J.range),De=R.Color.to(J.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:he},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(R.ColorPresentation.from)})}}class X{constructor(z,J){this._documents=z,this._provider=J}provideFoldingRanges(z,J,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,J,te)).then(he=>{if(!!Array.isArray(he))return he.map(R.FoldingRange.from)})}}class fe{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}provideSelectionRanges(z,J,te){const ae=this._documents.getDocument(z),he=J.map(R.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,he,te)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let we=0;we<he.length;we++){const ke=[];Me.push(ke);let Te=he[we],xe=De[we];for(;;){if(!xe.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(R.SelectionRange.from(xe)),!xe.parent)break;Te=xe.range,xe=xe.parent}}return Me})}}class ve{constructor(z,J){this._documents=z,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(z,J,te){const ae=this._documents.getDocument(z),he=R.Position.to(J),De=await this._provider.prepareCallHierarchy(ae,he,te);if(!!De){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(De)?De.map(we=>this._cacheAndConvertItem(Me,we)):[this._cacheAndConvertItem(Me,De)]}}async provideCallsTo(z,J,te){const ae=this._itemFromCache(z,J);if(!ae)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!he)return he.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Me=>R.Range.from(Me))}))}async provideCallsFrom(z,J,te){const ae=this._itemFromCache(z,J);if(!ae)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!he)return he.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Me=>R.Range.from(Me))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,J){var te;const ae=this._cache.get(z),he={_sessionId:z,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:R.SymbolKind.from(J.kind),uri:J.uri,range:R.Range.from(J.range),selectionRange:R.Range.from(J.selectionRange),tags:(te=J.tags)===null||te===void 0?void 0:te.map(R.SymbolTag.from)};return ae.set(he._itemId,J),he}_itemFromCache(z,J){const te=this._cache.get(z);return te==null?void 0:te.get(J)}}class Ae{constructor(z,J){this.adapter=z,this.extension=J}}class Ie{constructor(z,J,te,ae,he,De,Me){this._adapter=new Map,this._uriTransformer=J,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=he,this._logService=De,this._apiDeprecation=Me}_transformDocumentSelector(z){return(0,T.coalesce)((0,T.asArray)(z).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:R.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ie._handlePool++}_withAdapter(z,J,te,ae,he=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(ae);if(De.adapter instanceof J){let Me;De.extension&&(Me=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${J.name}'`));const we=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(we).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Te=>{he&&Te instanceof E.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Te))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,J){const te=this._nextHandle();return this._adapter.set(te,new Ae(z,J)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,te,ae){const he=this._addNewAdapter(new c(this._documents,te),z),De=ae&&ae.label||Ie._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(J),De),this._createDisposable(he)}$provideDocumentSymbols(z,J,te){return this._withAdapter(z,c,ae=>ae.provideDocumentSymbols(b.URI.revive(J),te),void 0)}registerCodeLensProvider(z,J,te){const ae=this._nextHandle(),he=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new u(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),he);let De=this._createDisposable(ae);if(he!==void 0){const Me=te.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(he));De=I.Disposable.from(De,Me)}return De}$provideCodeLenses(z,J,te){return this._withAdapter(z,u,ae=>ae.provideCodeLenses(b.URI.revive(J),te),void 0)}$resolveCodeLens(z,J,te){return this._withAdapter(z,u,ae=>ae.resolveCodeLens(J,te),void 0)}$releaseCodeLenses(z,J){this._withAdapter(z,u,te=>Promise.resolve(te.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(z,J,te){const ae=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(z,J,te,ae){return this._withAdapter(z,t,he=>he.provideDefinition(b.URI.revive(J),te,ae),[])}registerDeclarationProvider(z,J,te){const ae=this._addNewAdapter(new i(this._documents,te),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(z,J,te,ae){return this._withAdapter(z,i,he=>he.provideDeclaration(b.URI.revive(J),te,ae),[])}registerImplementationProvider(z,J,te){const ae=this._addNewAdapter(new o(this._documents,te),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(z,J,te,ae){return this._withAdapter(z,o,he=>he.provideImplementation(b.URI.revive(J),te,ae),[])}registerTypeDefinitionProvider(z,J,te){const ae=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(z,J,te,ae){return this._withAdapter(z,r,he=>he.provideTypeDefinition(b.URI.revive(J),te,ae),[])}registerHoverProvider(z,J,te,ae){const he=this._addNewAdapter(new l(this._documents,te),z);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideHover(z,J,te,ae){return this._withAdapter(z,l,he=>he.provideHover(b.URI.revive(J),te,ae),void 0)}registerEvaluatableExpressionProvider(z,J,te,ae){const he=this._addNewAdapter(new f(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideEvaluatableExpression(z,J,te,ae){return this._withAdapter(z,f,he=>he.provideEvaluatableExpression(b.URI.revive(J),te,ae),void 0)}registerInlineValuesProvider(z,J,te,ae){const he=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new p(this._documents,te),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(J),he);let Me=this._createDisposable(De);if(he!==void 0){const we=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(he));Me=I.Disposable.from(Me,we)}return Me}$provideInlineValues(z,J,te,ae,he){return this._withAdapter(z,p,De=>De.provideInlineValues(b.URI.revive(J),te,ae,he),void 0)}registerDocumentHighlightProvider(z,J,te){const ae=this._addNewAdapter(new w(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(z,J,te,ae){return this._withAdapter(z,w,he=>he.provideDocumentHighlights(b.URI.revive(J),te,ae),void 0)}registerLinkedEditingRangeProvider(z,J,te){const ae=this._addNewAdapter(new d(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,J,te,ae){return this._withAdapter(z,d,async he=>{const De=await he.provideLinkedEditingRanges(b.URI.revive(J),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,J,te){const ae=this._addNewAdapter(new m(this._documents,te),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(z,J,te,ae,he){return this._withAdapter(z,m,De=>De.provideReferences(b.URI.revive(J),te,ae,he),void 0)}registerCodeActionProvider(z,J,te,ae){var he,De;const Me=new g.DisposableStore,we=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(J),{providedKinds:(he=ae==null?void 0:ae.providedCodeActionKinds)===null||he===void 0?void 0:he.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Me)}))},Ie._extLabel(z),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(we)),Me}$provideCodeActions(z,J,te,ae,he){return this._withAdapter(z,C,De=>De.provideCodeActions(b.URI.revive(J),te,ae,he),void 0)}$resolveCodeAction(z,J,te){return this._withAdapter(z,C,ae=>ae.resolveCodeAction(J,te),void 0)}$releaseCodeActions(z,J){this._withAdapter(z,C,te=>Promise.resolve(te.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(z,J,te){const ae=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,J,te,ae){return this._withAdapter(z,L,he=>he.provideDocumentFormattingEdits(b.URI.revive(J),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,J,te){const ae=this._addNewAdapter(new B(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,J,te,ae,he){return this._withAdapter(z,B,De=>De.provideDocumentRangeFormattingEdits(b.URI.revive(J),te,ae,he),void 0)}registerOnTypeFormattingEditProvider(z,J,te,ae){const he=this._addNewAdapter(new ee(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(J),ae,z.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(z,J,te,ae,he,De){return this._withAdapter(z,ee,Me=>Me.provideOnTypeFormattingEdits(b.URI.revive(J),te,ae,he,De),void 0)}registerWorkspaceSymbolProvider(z,J){const te=this._addNewAdapter(new H(J,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,J,te){return this._withAdapter(z,H,ae=>ae.provideWorkspaceSymbols(J,te),{symbols:[]})}$resolveWorkspaceSymbol(z,J,te){return this._withAdapter(z,H,ae=>ae.resolveWorkspaceSymbol(J,te),void 0)}$releaseWorkspaceSymbols(z,J){this._withAdapter(z,H,te=>te.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(z,J,te){const ae=this._addNewAdapter(new x(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),x.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(z,J,te,ae,he){return this._withAdapter(z,x,De=>De.provideRenameEdits(b.URI.revive(J),te,ae,he),void 0)}$resolveRenameLocation(z,J,te,ae){return this._withAdapter(z,x,he=>he.resolveRenameLocation(b.URI.revive(J),te,ae),void 0)}registerDocumentSemanticTokensProvider(z,J,te,ae){const he=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(he,new Ae(new F(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(J),ae,De);let Me=this._createDisposable(he);if(De){const we=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Me=I.Disposable.from(Me,we)}return Me}$provideDocumentSemanticTokens(z,J,te,ae){return this._withAdapter(z,F,he=>he.provideDocumentSemanticTokens(b.URI.revive(J),te,ae),null,!0)}$releaseDocumentSemanticTokens(z,J){this._withAdapter(z,F,te=>te.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(z,J,te,ae){const he=this._addNewAdapter(new U(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(J),ae),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(z,J,te,ae){return this._withAdapter(z,U,he=>he.provideDocumentRangeSemanticTokens(b.URI.revive(J),te,ae),null,!0)}registerCompletionItemProvider(z,J,te,ae){const he=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(he,this._transformDocumentSelector(J),ae,M.supportsResolving(te),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(he)}$provideCompletionItems(z,J,te,ae,he){return this._withAdapter(z,M,De=>De.provideCompletionItems(b.URI.revive(J),te,ae,he),void 0)}$resolveCompletionItem(z,J,te){return this._withAdapter(z,M,ae=>ae.resolveCompletionItem(J,te),void 0)}$releaseCompletionItems(z,J){this._withAdapter(z,M,te=>te.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(z,J,te,ae){const he=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(J),he),this._createDisposable(De)}$provideSignatureHelp(z,J,te,ae,he){return this._withAdapter(z,N,De=>De.provideSignatureHelp(b.URI.revive(J),te,ae,he),void 0)}$releaseSignatureHelp(z,J){this._withAdapter(z,N,te=>te.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(z,J,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(he,this._transformDocumentSelector(J),ae);let De=this._createDisposable(he);if(ae!==void 0){const Me=te.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(ae));De=I.Disposable.from(De,Me)}return De}$provideInlineHints(z,J,te,ae){return this._withAdapter(z,O,he=>he.provideInlineHints(b.URI.revive(J),te,ae),void 0)}registerDocumentLinkProvider(z,J,te){const ae=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,J,te){return this._withAdapter(z,V,ae=>ae.provideLinks(b.URI.revive(J),te),void 0)}$resolveDocumentLink(z,J,te){return this._withAdapter(z,V,ae=>ae.resolveLink(J,te),void 0)}$releaseDocumentLinks(z,J){this._withAdapter(z,V,te=>te.releaseLinks(J),void 0)}registerColorProvider(z,J,te){const ae=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(z,J,te){return this._withAdapter(z,q,ae=>ae.provideColors(b.URI.revive(J),te),[])}$provideColorPresentations(z,J,te,ae){return this._withAdapter(z,q,he=>he.provideColorPresentations(b.URI.revive(J),te,ae),void 0)}registerFoldingRangeProvider(z,J,te){const ae=this._nextHandle(),he=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new X(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),he);let De=this._createDisposable(ae);if(he!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));De=I.Disposable.from(De,Me)}return De}$provideFoldingRanges(z,J,te,ae){return this._withAdapter(z,X,he=>he.provideFoldingRanges(b.URI.revive(J),te,ae),void 0)}registerSelectionRangeProvider(z,J,te){const ae=this._addNewAdapter(new fe(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(z,J,te,ae){return this._withAdapter(z,fe,he=>he.provideSelectionRanges(b.URI.revive(J),te,ae),[])}registerCallHierarchyProvider(z,J,te){const ae=this._addNewAdapter(new ve(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(z,J,te,ae){return this._withAdapter(z,ve,he=>Promise.resolve(he.prepareSession(b.URI.revive(J),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,J,te,ae){return this._withAdapter(z,ve,he=>he.provideCallsTo(J,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,J,te,ae){return this._withAdapter(z,ve,he=>he.provideCallsFrom(J,te,ae),void 0)}$releaseCallHierarchy(z,J){this._withAdapter(z,ve,te=>Promise.resolve(te.releaseSession(J)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,y.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ie._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ie._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ie._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ie._serializeRegExp(z.beforeText),afterText:z.afterText?Ie._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ie._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(z,J,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const he=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ie._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ie._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ie._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,J,De),this._createDisposable(he)}$setWordDefinitions(z){for(const J of z)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(ge[236],pe([0,1,5,20,7]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,y){this._proxy=P.getProxy(b.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,y){await this._proxy.$changeLanguage(P,y);const n=this._documents.getDocumentData(P);if(!n)throw new Error(`document '${P.toString}' NOT found`);return n.document}async tokenAtPosition(P,y){var n;const T=P.version,k=A.Position.from(y),_=await this._proxy.$tokensAtPosition(P.uri,k),g={type:R.StandardTokenType.Other,range:(n=P.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new R.Range(y.line,y.character,y.line,y.character)};if(!_)return g;const a={range:A.Range.to(_.range),type:A.TokenType.to(_.type)};return!a.range.contains(y)||T!==P.version?g:a}}e.ExtHostLanguages=I}),define(ge[237],pe([0,1,5,12,41]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(P){return P&&P.title}let D=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(b.MainContext.MainThreadMessageService)}showMessage(y,n,T,k,_){const g={extension:y};let a;typeof k=="string"||I(k)?a=[k,..._]:(g.modal=k&&k.modal,g.useCustom=k&&k.useCustom,a=_),g.useCustom&&(0,R.checkProposedApiEnabled)(y);const h=[];for(let S=0;S<a.length;S++){const v=a[S];if(typeof v=="string")h.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:E,isCloseAffordance:c}=v;h.push({title:E,isCloseAffordance:!!c,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(n,T,g,h).then(S=>{if(typeof S=="number")return a[S]})}};D=je([Ue(1,A.ILogService)],D),e.ExtHostMessageService=D}),define(ge[238],pe([0,1,21,3,6,2,28,5,20,7,84,85,23,214,215,70,15,25,73]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends R.Disposable{constructor(p,w,d,m,C){super();this._editorId=p,this.uri=w,this._proxy=d,this._webviewInitData=m,this.document=C,this._onDidReceiveDocumentMessage=new A.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:L=>this._proxy.$postMessage(this._editorId,void 0,L),asWebviewUri:L=>this._asWebviewUri(L)}}onDidReceiveMessage(p,w){var d;this._onDidReceiveDocumentMessage.fire(w),p!==void 0&&((d=this._rendererIdToEmitters.get(p))===null||d===void 0||d.fire(w))}getRendererComm(p){const w=new A.Emitter;return this._rendererIdToEmitters.set(p,w),{editorId:this._editorId,onDidReceiveMessage:w.event,postMessage:d=>this._proxy.$postMessage(this._editorId,p,d),asWebviewUri:d=>this._asWebviewUri(d)}}_asWebviewUri(p){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,p)}}class u extends R.Disposable{constructor(p,w,d,m){super();this._proxy=p,this._handle=w,this._extension=d,this._provider=m,this._kernelToFriendlyId=new _.ResourceMap,this._friendlyIdToKernel=new _.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(C=>{const L=C==null?void 0:C.uri;this._proxy.$onNotebookKernelChange(this._handle,L)}))}async provideKernels(p,w){const d=await this._provider.provideKernels(p.notebookDocument,w)||[],m=new Map;let C=0;const L=new Set,B=this._kernelToFriendlyId.get(p.uri),ee=d.map(x=>{let W=B==null?void 0:B.get(x);return W===void 0&&(x.id&&L.has(x.id)?W=`${this._extension.identifier.value}_${x.id}_${C++}`:W=`${this._extension.identifier.value}_${x.id||D.generateUuid()}`),m.set(x,W),{id:x.id,friendlyId:W,label:x.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:x.description,detail:x.detail,isPreferred:x.isPreferred,preloads:x.preloads,supportedLanguages:x.supportedLanguages,implementsInterrupt:!!x.interrupt}});this._kernelToFriendlyId.set(p.uri,m);const H=new Map;return m.forEach((x,W)=>{H.set(x,W)}),this._friendlyIdToKernel.set(p.uri,H),ee}getKernelByFriendlyId(p,w){var d;return(d=this._friendlyIdToKernel.get(p))===null||d===void 0?void 0:d.get(w)}async resolveNotebook(p,w,d,m){var C;const L=(C=this._friendlyIdToKernel.get(w.uri))===null||C===void 0?void 0:C.get(p);if(L&&this._provider.resolveKernel)return this._provider.resolveKernel(L,w.notebookDocument,d,m)}async executeNotebook(p,w,d){var m;const C=(m=this._friendlyIdToKernel.get(w.uri))===null||m===void 0?void 0:m.get(p);if(!!C){const L=d.map(B=>y.NotebookCellRange.to(B));return C.executeCellsRequest(w.notebookDocument,L)}}async interruptNotebookExecution(p,w){var d;const m=(d=this._friendlyIdToKernel.get(w.uri))===null||d===void 0?void 0:d.get(p);if(!(!m||!m.interrupt))return m.interrupt(w.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=u;class s{constructor(p,w){const d=s._Keys.nextId();p.$registerNotebookEditorDecorationType(d,y.NotebookDecorationRenderOptions.from(w)),this.value={key:d,dispose(){p.$removeNotebookEditorDecorationType(d)}}}}e.NotebookEditorDecorationType=s,s._Keys=new h.IdGenerator("NotebookEditorDecorationType");class t{constructor(p,w,d,m,C,L,B){this._textDocumentsAndEditors=d,this._textDocuments=m,this._webviewInitData=C,this.logService=L,this._extensionStoragePaths=B,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new A.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new A.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new A.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new A.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new A.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new A.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new A.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new A.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new _.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._proxy=p.getProxy(P.MainContext.MainThreadNotebook),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:ee=>{var H;if(ee&&ee.$mid===12){const x=(H=ee.notebookEditor)===null||H===void 0?void 0:H.notebookUri,W=ee.cell.handle,F=this._documents.get(x),U=F==null?void 0:F.getCell(W);if(U)return U.cell}return ee}})}get activeNotebookEditor(){var p;return(p=this._activeNotebookEditor)===null||p===void 0?void 0:p.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(p=>p.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(p){return this._documents.get(p)}_getNotebookDocument(p){const w=this._documents.get(p);if(!w)throw new Error(`NO notebook document for '${p}'`);return w}_getProviderData(p){const w=this._notebookContentProviders.get(p);if(!w)throw new Error(`NO provider for '${p}'`);return w}registerNotebookContentProvider(p,w,d,m){var C,L,B;if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:p,provider:d});let ee;d.onDidChangeNotebookContentOptions&&(ee=d.onDidChangeNotebookContentOptions(()=>{const W=y.NotebookDocumentContentOptions.from(d.options);this._proxy.$updateNotebookProviderOptions(w,W)}));const H=(C=m==null?void 0:m.viewOptions)===null||C===void 0?void 0:C.filenamePattern.map(W=>y.NotebookExclusiveDocumentPattern.from(W)).filter(W=>W!==void 0);((L=m==null?void 0:m.viewOptions)===null||L===void 0?void 0:L.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${(B=m==null?void 0:m.viewOptions)===null||B===void 0?void 0:B.filenamePattern}`);const x=y.NotebookDocumentContentOptions.from(m);return this._proxy.$registerNotebookProvider({id:p.identifier,location:p.extensionLocation,description:p.description},w,{transientOutputs:x.transientOutputs,transientMetadata:x.transientMetadata,viewOptions:(m==null?void 0:m.viewOptions)&&H?{displayName:m.viewOptions.displayName,filenamePattern:H,exclusive:m.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{ee==null||ee.dispose(),this._notebookContentProviders.delete(w),this._proxy.$unregisterNotebookProvider(w)})}registerNotebookKernelProvider(p,w,d){const m=t._notebookKernelProviderHandlePool++,C=new u(this._proxy,m,p,d);return this._notebookKernelProviders.set(m,C),this._proxy.$registerNotebookKernelProvider({id:p.identifier,location:p.extensionLocation,description:p.description},m,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0}),new n.Disposable(()=>{C.dispose(),this._notebookKernelProviders.delete(m),this._proxy.$unregisterNotebookKernelProvider(m)})}createNotebookEditorDecorationType(p){return new s(this._proxy,p).value}async openNotebookDocument(p){const w=this._documents.get(p);if(w)return w.notebookDocument;const d=await this._proxy.$tryOpenDocument(p),m=this._documents.get(I.URI.revive(d));return(0,S.assertIsDefined)(m==null?void 0:m.notebookDocument)}_withAdapter(p,w,d){const m=this._documents.get(I.URI.revive(w));if(!m)return[];const C=this._notebookKernelProviders.get(p);return C?d(C,m):[]}async showNotebookDocument(p,w){var d;I.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let m;typeof w=="object"?m={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:w.selection&&y.NotebookCellRange.from(w.selection),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:m={preserveFocus:!1};const C=await this._proxy.$tryShowNotebookDocument(p.uri,p.viewType,m),L=C&&((d=this._editors.get(C))===null||d===void 0?void 0:d.editor);if(L)return L.editor;throw C?new Error(`Could NOT open editor for "${p.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.toString()}".`)}async $provideNotebookKernels(p,w,d){return this._withAdapter(p,w,(m,C)=>m.provideKernels(C,d))}async $resolveNotebookKernel(p,w,d,m,C){await this._withAdapter(p,d,async(L,B)=>{const ee=this._webviewComm.get(w);ee&&await L.resolveNotebook(m,B,ee.contentProviderComm,C)})}async $resolveNotebookEditor(p,w,d){const m=this._notebookContentProviders.get(p),C=I.URI.revive(w),L=this._documents.get(C);if(!(!L||!m)){let B=this._webviewComm.get(d);B||(B=new c(d,C,this._proxy,this._webviewInitData,L),this._webviewComm.set(d,B)),!!m.provider.resolveNotebook&&await m.provider.resolveNotebook(L.notebookDocument,B.contentProviderComm)}}async $executeNotebookKernelFromProvider(p,w,d,m){await this._withAdapter(p,w,async(C,L)=>C.executeNotebook(d,L,m))}registerNotebookSerializer(p,w,d,m){const C=this._handlePool++;this._notebookSerializer.set(C,d);const L=y.NotebookDocumentContentOptions.from(m);return this._proxy.$registerNotebookSerializer(C,{id:p.identifier,location:p.extensionLocation,description:p.description},w,L),(0,R.toDisposable)(()=>{this._proxy.$unregisterNotebookSerializer(C)})}async $dataToNotebook(p,w){const d=this._notebookSerializer.get(p);if(!d)throw new Error("NO serializer found");const m=await d.dataToNotebook(w.buffer);return{metadata:y.NotebookDocumentMetadata.from(m.metadata),cells:m.cells.map(y.NotebookCellData.from)}}async $notebookToData(p,w){const d=this._notebookSerializer.get(p);if(!d)throw new Error("NO serializer found");const m=await d.notebookToData({metadata:y.NotebookDocumentMetadata.to(w.metadata),cells:w.cells.map(y.NotebookCellData.to)});return v.VSBuffer.wrap(m)}async $cancelNotebookCellExecution(p,w,d,m){await this._withAdapter(p,w,async(L,B)=>L.interruptNotebookExecution(d,B));const C=this._documents.get(I.URI.revive(w));if(!!C)for(let L of m)for(let B=L.start;B<L.end;B++){const ee=C.getCellFromIndex(B);ee&&this.cancelOneNotebookCellExecution(ee)}}cancelOneNotebookCellExecution(p){const w=this._activeExecutions.get(p.uri);w==null||w.cancel()}async $openNotebook(p,w,d,m,C){const{provider:L}=this._getProviderData(p),B=await L.openNotebook(I.URI.revive(w),{backupId:d,untitledDocumentData:m==null?void 0:m.buffer},C);return{metadata:y.NotebookDocumentMetadata.from(B.metadata),cells:B.cells.map(y.NotebookCellData.from)}}async $saveNotebook(p,w,d){const m=this._getNotebookDocument(I.URI.revive(w)),{provider:C}=this._getProviderData(p);return await C.saveNotebook(m.notebookDocument,d),!0}async $saveNotebookAs(p,w,d,m){const C=this._getNotebookDocument(I.URI.revive(w)),{provider:L}=this._getProviderData(p);return await L.saveNotebookAs(I.URI.revive(d),C.notebookDocument,m),!0}async $backupNotebook(p,w,d){var m;const C=this._getNotebookDocument(I.URI.revive(w)),L=this._getProviderData(p),B=(m=this._extensionStoragePaths.workspaceValue(L.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(L.extension),ee=String((0,E.hash)([C.uri.toString(),this._backupIdPool++])),H=I.URI.joinPath(B,ee),x=await L.provider.backupNotebook(C.notebookDocument,{destination:H},d);return C.updateBackup(x),x.id}$acceptNotebookActiveKernelChange(p){p.providerHandle!==void 0&&this._withAdapter(p.providerHandle,p.uri,async(w,d)=>{const m=p.kernelFriendlyId?w.getKernelByFriendlyId(I.URI.revive(p.uri),p.kernelFriendlyId):void 0;this._editors.forEach(C=>{C.editor.notebookData===d&&C.editor._acceptKernel(m)}),this._onDidChangeActiveNotebookKernel.fire({document:d.notebookDocument,kernel:m})})}$onDidReceiveMessage(p,w,d){var m;(m=this._webviewComm.get(p))===null||m===void 0||m.onDidReceiveMessage(w,d)}$acceptModelChanged(p,w,d){this._getNotebookDocument(I.URI.revive(p)).acceptModelChanged(w,d)}$acceptDirtyStateChanged(p,w){const d=this._getNotebookDocument(I.URI.revive(p));d.acceptModelChanged({rawEvents:[],versionId:d.notebookDocument.version},w)}$acceptModelSaved(p){const w=this._getNotebookDocument(I.URI.revive(p));this._onDidSaveNotebookDocument.fire(w.notebookDocument)}$acceptEditorPropertiesChanged(p,w){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,w);const d=this._editors.get(p);if(!d)throw new Error(`unknown text editor: ${p}`);w.visibleRanges&&d.editor._acceptVisibleRanges(w.visibleRanges.ranges.map(y.NotebookCellRange.to)),w.selections&&d.editor._acceptSelections(w.selections.selections.map(y.NotebookCellRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.editor.editor,visibleRanges:d.editor.editor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.editor.editor,selections:d.editor.editor.selections}))}$acceptDocumentPropertiesChanged(p,w){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",p.path,w);const d=this._getNotebookDocument(I.URI.revive(p));d.acceptDocumentPropertiesChanged(w),w.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:d.notebookDocument})}_createExtHostEditor(p,w,d){var m;const C=p.uri;let L=this._webviewComm.get(w);L||(L=new c(w,C,this._proxy,this._webviewInitData,p),this._webviewComm.set(w,L));const B=new a.ExtHostNotebookEditor(w,p.notebookDocument.viewType,this._proxy,p,d.visibleRanges.map(y.NotebookCellRange.to),d.selections.map(y.NotebookCellRange.to),typeof d.viewColumn=="number"?y.ViewColumn.to(d.viewColumn):void 0);(m=this._editors.get(w))===null||m===void 0||m.editor.dispose(),this._editors.set(w,{editor:B})}$acceptDocumentAndEditorsDelta(p){var w,d,m,C;let L=!1;if(p.removedDocuments)for(const ee of p.removedDocuments){const H=I.URI.revive(ee),x=this._documents.get(H);x&&(x.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.cells.map(W=>W.document.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const W of this._editors.values())W.editor.notebookData.uri.toString()===H.toString()&&(W.editor.dispose(),this._editors.delete(W.editor.id),L=!0)}if(p.addedDocuments){const ee=[];for(const H of p.addedDocuments){const x=I.URI.revive(H.uri),W=H.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x}`);const F=this,U=new g.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){F._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){F._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){F._onDidChangeCellMetadata.fire(M)},emitCellExecutionStateChange(M){F._onDidChangeCellExecutionState.fire(M)}},W,H.metadata?y.NotebookDocumentMetadata.to(H.metadata):new n.NotebookDocumentMetadata,x);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),ee.push(...H.cells.map(M=>g.ExtHostCell.asModelAddData(U.notebookDocument,M))),(w=this._documents.get(x))===null||w===void 0||w.dispose(),this._documents.set(x,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:ee}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(p.addedEditors)for(const ee of p.addedEditors){if(this._editors.has(ee.id))return;const H=I.URI.revive(ee.documentUri),x=this._documents.get(H);x&&(this._createExtHostEditor(x,ee.id,ee),L=!0)}const B=[];if(p.removedEditors)for(const ee of p.removedEditors){const H=this._editors.get(ee);H&&(L=!0,this._editors.delete(ee),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===H.editor.id&&(this._activeNotebookEditor=void 0),B.push(H))}if(L&&B.forEach(ee=>{ee.editor.dispose()}),p.visibleEditors){this._visibleNotebookEditors=p.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const ee=new Set;this._visibleNotebookEditors.forEach(H=>ee.add(H.id));for(const H of this._editors.values()){const x=ee.has(H.editor.id);H.editor._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}p.newActiveEditor===null?this._activeNotebookEditor=void 0:p.newActiveEditor&&(this._activeNotebookEditor=(m=this._editors.get(p.newActiveEditor))===null||m===void 0?void 0:m.editor),p.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((C=this._activeNotebookEditor)===null||C===void 0?void 0:C.editor)}createNotebookCellStatusBarItemInternal(p,w,d){const m=new i(this._proxy,this._commandsConverter,p,w,d),C=k.CellUri.parse(p.document.uri);if(C){const L=this._documents.get(C.notebook);if(L){const B=L.getCell(C.handle);B&&A.Event.once(B.onDidDispose)(()=>m.dispose())}}return m}createNotebookCellExecution(p,w,d){const m=this.lookupNotebookDocument(p);if(!m)throw new Error(`Invalid cell uri/index: ${p}, ${w}`);const C=m.getCellFromIndex(w);if(!C)throw new Error(`Invalid cell uri/index: ${p}, ${w}`);if(!this._activeExecutions.has(C.uri)){const L=new l(p,m,C,this._proxy);this._activeExecutions.set(C.uri,L);const B=L.onDidChangeState(()=>{L.state===r.Resolved&&(L.dispose(),B.dispose(),this._activeExecutions.delete(C.uri))});return L.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends R.Disposable{constructor(p,w,d,m,C){super();this._proxy=p,this._commands=w,this._cell=d,this._priority=C,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=m!=null?m:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(p){this._alignment=p,this.update()}get priority(){return this._priority}set priority(p){this._priority=p,this.update()}get text(){return this._text}set text(p){this._text=p,this.update()}get tooltip(){return this._tooltip}set tooltip(p){this._tooltip=p,this.update()}get command(){var p;return(p=this._command)===null||p===void 0?void 0:p.fromApi}set command(p){var w;((w=this._command)===null||w===void 0?void 0:w.fromApi)!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:this._commands.toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:this._commands.toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var p;if(!this._isDisposed){const w={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(p=this._command)===null||p===void 0?void 0:p.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,w)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function o(f){return Object.freeze({cell:f.cell,get alignment(){return f.alignment},set alignment(p){f.alignment=p},get priority(){return f.priority},set priority(p){f.priority=p},get text(){return f.text},set text(p){f.text=p},get tooltip(){return f.tooltip},set tooltip(p){f.tooltip=p},get command(){return f.command},set command(p){f.command=p},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(p){f.accessibilityInformation=p},show(){f.show()},hide(){f.hide()},dispose(){f.dispose()}})}var r;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(r||(r={}));class l extends R.Disposable{constructor(p,w,d,m){super();this._uri=p,this._document=w,this._cell=d,this._proxy=m,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._executionOrder=d.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(p){return this._proxy.$applyEdits(this._uri,p,!1)}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(p){const w=[{editType:11,handle:this._cell.handle,metadata:p}];this.applyEdits(w)}cellIndexToHandle(p){const w=typeof p=="number"?this._document.getCellFromIndex(p):this._cell;if(!!w)return w.handle}asApiObject(){const p=this;return Object.freeze({get document(){return p._document.notebookDocument},get cell(){return p._cell.cell},get executionOrder(){return p._executionOrder},set executionOrder(w){p._executionOrder=w,p.mixinMetadata({executionOrder:w})},start(w){if(p._state===r.Resolved||p._state===r.Started)throw new Error("Cannot call start again");p._state=r.Started,p._onDidChangeState.fire(),p.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:w==null?void 0:w.startTime})},end(w){var d,m;if(p._state===r.Resolved)throw new Error("Cannot call resolve twice");p._state=r.Resolved,p._onDidChangeState.fire(),p.mixinMetadata({runState:k.NotebookCellExecutionState.Idle,lastRunSuccess:(d=w==null?void 0:w.success)!==null&&d!==void 0?d:null,lastRunDuration:(m=w==null?void 0:w.duration)!==null&&m!==void 0?m:null})},clearOutput(w){return p.verifyStateForOutput(),this.replaceOutput([],w)},async appendOutput(w,d){p.verifyStateForOutput();const m=p.cellIndexToHandle(d);if(typeof m=="number")return w=Array.isArray(w)?w:[w],p.applyEdits([{editType:2,handle:m,append:!0,outputs:w.map(y.NotebookCellOutput.from)}])},async replaceOutput(w,d){p.verifyStateForOutput();const m=p.cellIndexToHandle(d);if(typeof m=="number")return w=Array.isArray(w)?w:[w],p.applyEdits([{editType:2,handle:m,outputs:w.map(y.NotebookCellOutput.from)}])},async appendOutputItems(w,d){return p.verifyStateForOutput(),w=Array.isArray(w)?w:[w],p.applyEdits([{editType:10,append:!0,items:w.map(y.NotebookCellOutputItem.from),outputId:d}])},async replaceOutputItems(w,d){return p.verifyStateForOutput(),w=Array.isArray(w)?w:[w],p.applyEdits([{editType:10,items:w.map(y.NotebookCellOutputItem.from),outputId:d}])},token:p._tokenSource.token})}}}),define(ge[63],pe([0,1,5,3,6,25,4,13]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends R.Disposable{constructor(a,h,S,v){super();this._onDidAppend=this._register(new A.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=v,this._id=v.$register(this.name,h,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?I.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(h=>this._proxy.$clear(h,a))}show(a,h){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof a=="boolean"?a:h)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(a,h){super(a,!1,void 0,h)}append(a){super.append(a),this._id.then(h=>this._proxy.$append(h,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(a,h,S){super(a,!0,h,S)}append(a){throw new Error("Not supported")}}class k{constructor(a,h){this.name=a,this._channel=h}append(a){this._channel.then(h=>h.append(a))}appendLine(a){this._channel.then(h=>h.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,h){this._channel.then(S=>S.show(a,h))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=k;let _=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new n(a,this._proxy)}createOutputChannelFromLogFile(a,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new T(a,h,this._proxy)}};_=je([Ue(0,P.IExtHostRpcService)],_),e.ExtHostOutputService=_,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[239],pe([0,1,17,21,3,6,5,2,7,16,14,56]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(g,a,h){const S=g.getProxy(D.MainContext.MainThreadQuickOpen);class v{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,f,p=A.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(r),d=++this._instances,m=S.$show(d,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},p),C={},L=m.then(()=>C);return Promise.race([L,w]).then(B=>{if(B!==C)return w.then(ee=>{const H=[];for(let x=0;x<ee.length;x++){const W=ee[x];let F,U,M,N,O;typeof W=="string"?F=W:(F=W.label,U=W.description,M=W.detail,N=W.picked,O=W.alwaysShow),H.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{f.onDidSelectItem(ee[x])}),S.$setItems(d,H),m.then(x=>{if(typeof x=="number")return ee[x];if(Array.isArray(x))return x.map(W=>ee[W])})})}).then(void 0,B=>{if(!(0,n.isPromiseCanceledError)(B))return S.$setError(d,B),Promise.reject(B)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=A.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,n.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(r){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=A.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!f){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(w=>w.uri.toString()===f.uri.toString())}}createQuickPick(r,l){const f=new t(r,l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(r){const l=new i(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const f=this._sessions.get(r);f&&f._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const f=this._sessions.get(r);f instanceof t&&f._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const f=this._sessions.get(r);f instanceof t&&f._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const f=this._sessions.get(r);f&&f._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class E{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,f)=>{const p=l===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(p,l)}),this.update({buttons:r.map((l,f)=>({iconPath:c(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const f=r[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function c(o){if(o instanceof y.ThemeIcon)return{id:o.id};const r=s(o),l=u(o);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof l=="string"?P.URI.file(l):l}}function u(o){return typeof o=="object"&&"light"in o?o.light:o}function s(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends E{constructor(r,l,f){super(r,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:r.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,T.coalesce)(r.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,T.coalesce)(r.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends E{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?k.default.Error:k.default.Ignore})}}return new v(a,h)}e.createExtHostQuickOpen=_}),define(ge[240],pe([0,1,2,3,68,6,17,5,14,95,12,29,41]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?b.URI.file(r.iconPath):r.iconPath}function a(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const f=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,n.comparePaths)(f,p)}function h(r,l){let f=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(f=a(r,l),f!==0)return f;if(r.light&&l.light)f=a(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(f!==0)return f;if(r.dark&&l.dark)f=a(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return f}function S(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let f=0;f<r.arguments.length;f++){const p=r.arguments[f],w=l.arguments[f];if(p!==w)return p<w?-1:1}return 0}function v(r,l){let f=(0,n.comparePaths)(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(f!==0)return f;if(r.command&&l.command)f=S(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(f!==0)return f;if(r.decorations&&l.decorations)f=h(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return f}function E(r,l){for(let f=0;f<r.length;f++)if(r[f]!==l[f])return!1;return!0}function c(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?E(r.arguments,l.arguments):r.arguments===l.arguments)}function u(r,l){return(0,y.equals)(r,l,c)}class s{constructor(l,f,p){this._extension=l,this._proxy=f,this._sourceControlHandle=p,this._value="",this._onDidChange=new A.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,_.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=s;class t{constructor(l,f,p,w,d){this._proxy=l,this._commands=f,this._sourceControlHandle=p,this._id=w,this._label=d,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new A.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,f){const p=this._resourceStatesCommandsMap.get(l);return p?(0,D.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const f=[...this._resourceStates].sort(v),w=(0,y.sortedDiff)(this._resourceSnapshot,f,v).map(C=>{const L=C.toInsert.map(B=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,B);const H=B.resourceUri,x=g(B.decorations),W=B.decorations&&g(B.decorations.light)||x,F=B.decorations&&g(B.decorations.dark)||x,U=[];let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const fe=new I.DisposableStore;M=this._commands.converter.toInternal(B.command,fe),this._resourceStatesDisposablesMap.set(ee,fe)}else this._resourceStatesCommandsMap.set(ee,B.command);W&&U.push(W),F&&F.toString()!==(W==null?void 0:W.toString())&&U.push(F);const N=B.decorations&&B.decorations.tooltip||"",O=B.decorations&&!!B.decorations.strikeThrough,V=B.decorations&&!!B.decorations.faded,q=B.contextValue||"";return{rawResource:[ee,H,U,N,O,V,q,M],handle:ee}});return{start:C.start,deleteCount:C.deleteCount,toInsert:L}}),d=w.map(({start:C,deleteCount:L,toInsert:B})=>[C,L,B.map(ee=>ee.rawResource)]),m=w.reverse();for(const{start:C,deleteCount:L,toInsert:B}of m){const ee=B.map(x=>x.handle),H=this._handlesSnapshot.splice(C,L,...ee);for(const x of H)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(l=this._resourceStatesDisposablesMap.get(x))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=f,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,f,p,w,d,m){this._proxy=f,this._commands=p,this._id=w,this._label=d,this._rootUri=m,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new A.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,w,d,m)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=l;const f=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&u(this._statusBarCommands,l))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=l;const f=(l||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(l,f){const p=new t(this._proxy,this._commands,this.handle,l,f),w=A.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,w),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const l=[],f=[];for(const[p,w]of this.createdResourceGroups){w.dispose();const d=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});A.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),d.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),l.push([p.handle,p.id,p.label,p.features]);const m=p._takeResourceStateSnapshot();m.length>0&&f.push([p.handle,m]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,l,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(f=>{const p=f._takeResourceStateSnapshot();p.length!==0&&l.push([f.handle,p])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,R.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,R.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Fn{constructor(l,f,p){this._commands=f,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new A.Emitter,this._proxy=l.getProxy(P.MainContext.MainThreadSCM),this._telemetry=l.getProxy(P.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===3){const d=this._sourceControls.get(w.sourceControlHandle);if(!d)return w;const m=d.getResourceGroup(w.groupHandle);return m?m.getResourceState(w.handle):w}else if(w&&w.$mid===4){const d=this._sourceControls.get(w.sourceControlHandle);return d?d.getResourceGroup(w.groupHandle):w}else if(w&&w.$mid===5){const d=this._sourceControls.get(w.handle);return d||w}return w}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,f,p,w){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,f,p,w),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const d=Fn._handlePool++,m=new i(l,this._proxy,this._commands,f,p,w);this._sourceControls.set(d,m);const C=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier))||[];return C.push(m),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(l.identifier),C),m}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const f=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier)),p=f&&f[f.length-1];return p&&p.inputBox}$provideOriginalResource(l,f,p){const w=b.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,w.toString());const d=this._sourceControls.get(l);return!d||!d.quickDiffProvider||!d.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>d.quickDiffProvider.provideOriginalResource(w,p)).then(m=>m||null)}$onInputBoxValueChange(l,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const p=this._sourceControls.get(l);return p&&p.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(l,f,p,w){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,f,p);const d=this._sourceControls.get(l);if(!d)return Promise.resolve(void 0);const m=d.getResourceGroup(f);return m?m.$executeResourceCommand(p,w):Promise.resolve(void 0)}$validateInput(l,f,p){this.logService.trace("ExtHostSCM#$validateInput",l);const w=this._sourceControls.get(l);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>w.inputBox.validateInput(f,p)).then(d=>d?Promise.resolve([d.message,d.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var f,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((f=this._sourceControls.get(l))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};o._handlePool=0,o=je([Ue(2,T.ILogService)],o),e.ExtHostSCM=o});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[241],pe([0,1,7,5,162,6]),function(Z,e,b,A,R,I){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(_,g,a,h,S=b.StatusBarAlignment.Left,v,E){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,nt(this,D,_),nt(this,P,g),this._id=y.ID_GEN++,this._statusId=a,this._statusName=h,this._alignment=S,this._priority=v,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var _;return(_=this._command)===null||_===void 0?void 0:_.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!y.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:Be(this,P).toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:Be(this,P).toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,D).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var _;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,D).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(_=this._command)===null||_===void 0?void 0:_.internal,g,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,P=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(_){this._messages=[],this._item=_.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const g={message:_};return this._messages.unshift(g),this._update(),new b.Disposable(()=>{const a=this._messages.indexOf(g);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(_,g){this._proxy=_.getProxy(A.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new n(this)}createStatusBarEntry(_,g,a,h,S){return new y(this._proxy,this._commands,_,g,a,h,S)}setStatusBarMessage(_,g){const a=this._statusMessage.setMessage(_);let h;return typeof g=="number"?h=setTimeout(()=>a.dispose(),g):typeof g!="undefined"&&g.then(()=>a.dispose(),()=>a.dispose()),new b.Disposable(()=>{a.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=T}),define(ge[88],pe([0,1,5,3,4]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(P){this._onDidChangeStorage=new A.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,y){this._proxy.$registerExtensionStorageKeysToSync(P,y)}getValue(P,y,n){return this._proxy.$getValue(P,y).then(T=>T||n)}setValue(P,y,n){return this._proxy.$setValue(P,y,n)}$acceptValue(P,y,n){this._onDidChangeStorage.fire({shared:P,key:y,value:n})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,12,87,2]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let P=class{constructor(n,T,k){var _;this._logService=T,this._extHostFileSystem=k,this._workspace=(_=n.workspace)!==null&&_!==void 0?_:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=D.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(_){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=D.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(n){if(this._value)return D.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return D.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};P=je([Ue(0,A.IExtHostInitDataService),Ue(1,R.ILogService),Ue(2,I.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[35],pe([0,1,3,5,4,2,13,6,7,163,16,206,21,28,187]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class h{constructor(t,i,o,r){this._proxy=t,this._id=i,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(f,p=!0){l._checkDisposed(),l._proxy.$sendText(l._id,f,p)},show(f){l._checkDisposed(),l._proxy.$show(l._id,f)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,i,o,r,l,f,p,w,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:o,env:r,waitOnExit:l,strictEnv:f,hideFromUser:p,isFeatureTerminal:w,isExtensionOwnedTerminal:d})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,E=class extends P.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=i.getProxy(A.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new h(this._proxy,(0,g.generateUuid)(),t,t.name),o=new S(t.pty);return i.createExtensionTerminal().then(r=>{const l=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=l}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(i),l=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:i})}async $acceptTerminalDimensions(t,i,o){const r=this._getTerminalById(t);r&&r.setDimensions(i,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}async $acceptTerminalTitleChange(t,i){const o=this._getTerminalById(t);o&&(o.name=i)}async $acceptTerminalClosed(t,i){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(i),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,i,o,r){if(i){const p=this._getTerminalObjectIndexById(this._terminals,i);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const l={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:I.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},f=new h(this._proxy,t,l,o);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,i){const o=this._getTerminalById(t);o&&o._setProcessId(i)}async $startExtensionTerminal(t,i){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(l=>{const f=this.onDidOpenTerminal(async p=>{p===o.value&&(f.dispose(),l())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const o=new P.DisposableStore;o.add(i.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),o.add(i.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,i.onProcessData),o.add(i.onProcessExit(l=>this._onProcessExit(t,l))),i.onProcessOverrideDimensions&&o.add(i.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,i);const r=this._extensionTerminalAwaitingStart[t];return r&&i instanceof S&&(i.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(i)}$acceptProcessResize(t,i,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const l=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const f=[],p={terminal:o.value,line:i},w=[];for(const C of this._linkProviders)w.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:C,links:[]}));const B=await C.provideTerminalLinks(p,l.token)||[];l.token.isCancellationRequested||L({provider:C,links:B})}));const d=await Promise.all(w);if(l.token.isCancellationRequested)return[];const m=new Map;for(const C of d)C&&C.links.length>0&&f.push(...C.links.map(L=>{const B={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return m.set(B.id,{provider:C.provider,link:L}),B}));return this._terminalLinkCache.set(t,m),f}$activateLink(t,i){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(i);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const o=this._getTerminalObjectIndexById(t,i);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,i){let o=null;return t.some((r,l)=>r._id===i?(o=l,!0):!1),o}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new c,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const o=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const o=i[0],r=new c(i[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};E=je([Ue(1,D.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const o=this.map.get(t);(!o||o.value!==i.value||o.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((o,r)=>t.call(i,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let u=class extends E{constructor(t){super(!1,t)}createTerminal(t,i,o){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=je([Ue(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[242],pe([0,1,3,14,5,122,20,7]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(_=>_.value)}async showTextDocument(T,k,_){let g;typeof k=="number"?g={position:D.ViewColumn.from(k),preserveFocus:_}:typeof k=="object"?g={position:D.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?D.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(T.uri,g),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new I.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const _=this._extHostDocumentsAndEditors.getEditor(T);if(!_)throw new Error("unknown text editor");if(k.options&&_._acceptOptions(k.options),k.selections){const g=k.selections.selections.map(D.Selection.to);_._acceptSelections(g)}if(k.visibleRanges){const g=A.coalesce(k.visibleRanges.map(D.Range.to));_._acceptVisibleRanges(g)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const g=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),a=k.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:a,kind:g})}if(k.visibleRanges){const g=A.coalesce(k.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:g})}}$acceptEditorPositionData(T){for(const k in T){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("Unknown text editor");const g=D.ViewColumn.to(T[k]);_.value.viewColumn!==g&&(_._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:g}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var gn=this&&this.__rest||function(Z,e){var b={};for(var A in Z)Object.prototype.hasOwnProperty.call(Z,A)&&e.indexOf(A)<0&&(b[A]=Z[A]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,A=Object.getOwnPropertySymbols(Z);R<A.length;R++)e.indexOf(A[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,A[R])&&(b[A[R]]=Z[A[R]]);return b};define(ge[243],pe([0,1,2,4,5,6,7]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class P{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:_=>{var g,a;if(_&&_.$mid===11){const h=_.uri===void 0?void 0:b.URI.revive(_.uri);return(a=(g=this._itemsBySourceAndUriMap.get(_.source))===null||g===void 0?void 0:g.get(y(h)))===null||a===void 0?void 0:a.get(_.handle)}return _}})}async $getTimeline(T,k,_,g,a){const h=this._providers.get(T);return h==null?void 0:h.provideTimeline(b.URI.revive(k),_,g,a)}registerTimelineProvider(T,k,_,g){const a=new I.DisposableStore,h=this.convertTimelineItem(k.id,g,a).bind(this);let S;k.onDidChange&&(S=k.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:k.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(E,c,u,s){var t;(s==null?void 0:s.resetCache)&&(a.clear(),(t=v.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(E,c,u);if(i!=null){const o=h(E,s);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(o)})}},dispose(){var E;for(const c of v.values())(E=c.get(k.id))===null||E===void 0||E.clear();S==null||S.dispose(),a.dispose()}}))}convertTimelineItem(T,k,_){return(g,a)=>{let h;if(a==null?void 0:a.cacheResults){let S=this._itemsBySourceAndUriMap.get(T);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(T,S));const v=y(g);h=S.get(v),h===void 0&&(h=new Map,S.set(v,h))}return S=>{var v,E;const{iconPath:c}=S,u=gn(S,["iconPath"]),s=`${T}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;h==null||h.set(s,S);let t,i,o;return S.iconPath&&(c instanceof D.ThemeIcon?o={id:c.id}:b.URI.isUri(c)?(t=c,i=c):{light:t,dark:i}=c),Object.assign(Object.assign({},u),{id:(E=u.id)!==null&&E!==void 0?E:void 0,handle:s,source:T,command:S.command?k.toInternal(S.command,_):void 0,icon:t,iconDark:i,themeIcon:o,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,I.toDisposable)(()=>{var _;for(const g of this._itemsBySourceAndUriMap.values())(_=g.get(T.id))===null||_===void 0||_.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=P;function y(n){return n==null?void 0:n.toString()}}),define(ge[244],pe([0,1,6,11,2,5]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const _=k.schemes.find(g=>!D.supportedSchemes.has(g));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,b.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const _=R.URI.revive(n);return k.canOpenExternalUri(_,T)}async $openUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(R.URI.revive(n.resolvedUri),{sourceUri:R.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([A.Schemas.http,A.Schemas.https])}),define(ge[245],pe([0,1,5,2,6,16,29]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(D.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=P.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,R.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(T))}catch(_){(0,I.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(n){return A.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=P,P.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[64],pe([0,1,3,2,84,5]),function(Z,e,b,A,R,I){"use strict";var D,P,y,n,T,k,_,g,a,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class v{constructor(o,r,l,f,p,w,d){D.set(this,void 0),P.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),_.set(this,""),g.set(this,void 0),a.set(this,!1),h.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,S.set(this,new b.Emitter),this._onDidDispose=Be(this,S).event,nt(this,D,o),nt(this,P,r),nt(this,g,l),nt(this,n,f),nt(this,T,p),nt(this,k,w),nt(this,y,d)}dispose(){nt(this,a,!0),Be(this,S).fire(),Be(this,S).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return nt(this,h,!0),(0,R.asWebviewUri)(Be(this,n),Be(this,D),o)}get cspSource(){return Be(this,n).webviewCspSource.replace("{{uuid}}",Be(this,D))}get html(){return this.assertNotDisposed(),Be(this,_)}set html(o){this.assertNotDisposed(),Be(this,_)!==o&&(nt(this,_,o),!Be(this,h)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(nt(this,h,!0),Be(this,y).report("Webview vscode-resource: uris",Be(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,P).$setHtml(Be(this,D),o))}get options(){return this.assertNotDisposed(),Be(this,g)}set options(o){this.assertNotDisposed(),Be(this,P).$setOptions(Be(this,D),u(Be(this,k),Be(this,T),o)),nt(this,g,o)}async postMessage(o){return Be(this,a)?!1:Be(this,P).$postMessage(Be(this,D),o)}assertNotDisposed(){if(Be(this,a))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,D=new WeakMap,P=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,_=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap;class E{constructor(o,r,l,f,p){this.initData=r,this.workspace=l,this._logService=f,this._deprecationService=p,this._webviews=new Map,this._webviewProxy=o.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(o,r){const l=this.getWebview(o);l&&l._onMessageEmitter.fire(r)}$onMissingCsp(o,r){this._logService.warn(`${r} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,r,l){const f=new v(o,this._webviewProxy,s(r),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(o,f),f._onDidDispose(()=>{this._webviews.delete(o)}),f}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=E;function c(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=c;function u(i,o,r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots||t(i,o)}}e.serializeWebviewOptions=u;function s(i){var o;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(o=i.localResourceRoots)===null||o===void 0?void 0:o.map(r=>A.URI.from(r))}}e.reviveOptions=s;function t(i,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(r=>r.uri),i.extensionLocation]}}),define(ge[246],pe([0,1,21,73,6,11,24,2,20,64,116,5,7]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class a{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,o){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new g(i,o);return this._documents.set(r,l),l}delete(t,i){const o=this.key(t,i.uri);this._documents.delete(o)}key(t,i){return`${t}@@@${i}`}}var h;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(h||(h={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,o){return this.add(0,t,i,o)}addCustomProvider(t,i,o){return this.add(1,t,i,o)}get(t){return this._providers.get(t)}add(t,i,o,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:o,provider:r}),new _.Disposable(()=>this._providers.delete(i))}}class v{constructor(t,i,o,r,l){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new a,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,o,r){const l=new R.DisposableStore;return E(o)?(l.add(this._editorProviders.addTextProvider(i,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(l.add(this._editorProviders.addCustomProvider(i,t,o)),this.supportEditing(o)&&l.add(o.onDidChangeCustomDocument(f=>{const p=this.getCustomDocumentEntry(i,f.document.uri);if(c(f)){const w=p.addEdit(f);this._proxy.$onDidEdit(f.document.uri,i,w,f.label)}else this._proxy.$onContentChange(f.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument)),_.Disposable.from(l,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,o,r,l){var f;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const w=P.URI.revive(t),d=await p.provider.openCustomDocument(w,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},l);let m;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(m=(f=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,d,m),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=P.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,o,r,l,f){const p=this._editorProviders.get(o);if(!p)throw new Error(`No provider found for '${o}'`);const w=y.ViewColumn.to(l),d=this._extHostWebview.createNewWebview(i,r.webviewOptions,p.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(i,o,r.title,w,r.panelOptions,d),C=P.URI.revive(t);switch(p.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,C);return p.provider.resolveCustomEditor(L,m,f)}case 0:{const L=this._extHostDocuments.getDocument(C);return p.provider.resolveCustomTextEditor(L,m,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,o){this.getCustomDocumentEntry(i,t).disposeEdits(o)}async $onMoveCustomEditor(t,i,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const f=P.URI.revive(i),p=this._extHostDocuments.getDocument(f);await r.provider.moveCustomTextEditor(p,l,b.CancellationToken.None)}async $undo(t,i,o,r){return this.getCustomDocumentEntry(i,t).undo(o,r)}async $redo(t,i,o,r){return this.getCustomDocumentEntry(i,t).redo(o,r)}async $revert(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,i,o,r){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,P.URI.revive(o),r)}async $backup(t,i,o){const r=this.getCustomDocumentEntry(i,t),f=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(f),f.id}getCustomDocumentEntry(t,i){const o=this._documents.get(t,P.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const i=this._editorProviders.get(t),o=i==null?void 0:i.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function E(s){return typeof s.resolveCustomTextEditor=="function"}function c(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function u(s){const t=s.scheme===I.Schemas.file||s.scheme===I.Schemas.untitled?s.fsPath:s.toString();return(0,A.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[247],pe([0,1,3,6,2,28,20,64,5,7]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";var T,k,_,g,a,h,S,v,E,c,u,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends A.Disposable{constructor(f,p,w,d,m,C,L){super();T.set(this,void 0),k.set(this,void 0),_.set(this,void 0),g.set(this,void 0),a.set(this,void 0),h.set(this,void 0),S.set(this,void 0),v.set(this,void 0),E.set(this,!0),c.set(this,!0),u.set(this,!1),s.set(this,this._register(new b.Emitter)),this.onDidDispose=Be(this,s).event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Be(this,t).event,nt(this,T,f),nt(this,k,p),nt(this,_,w),nt(this,a,C),nt(this,v,m),nt(this,h,d),nt(this,g,L)}dispose(){Be(this,u)||(nt(this,u,!0),Be(this,s).fire(),Be(this,k).$disposeWebview(Be(this,T)),Be(this,g).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,g)}get viewType(){return this.assertNotDisposed(),Be(this,_)}get title(){return this.assertNotDisposed(),Be(this,h)}set title(f){this.assertNotDisposed(),Be(this,h)!==f&&(nt(this,h,f),Be(this,k).$setTitle(Be(this,T),f))}get iconPath(){return this.assertNotDisposed(),Be(this,S)}set iconPath(f){this.assertNotDisposed(),Be(this,S)!==f&&(nt(this,S,f),Be(this,k).$setIconPath(Be(this,T),R.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Be(this,a)}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,v)=="number"&&Be(this,v)<0))return Be(this,v)}get active(){return this.assertNotDisposed(),Be(this,c)}get visible(){return this.assertNotDisposed(),Be(this,E)}_updateViewState(f){Be(this,u)||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,c,f.active),nt(this,E,f.visible),nt(this,v,f.viewColumn),Be(this,t).fire({webviewPanel:this}))}reveal(f,p){this.assertNotDisposed(),Be(this,k).$reveal(Be(this,T),{viewColumn:f?D.ViewColumn.from(f):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,u))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,_=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap,v=new WeakMap,E=new WeakMap,c=new WeakMap,u=new WeakMap,s=new WeakMap,t=new WeakMap;class o{constructor(f,p,w){this.webviews=p,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(f,p,w,d,m={}){const C=typeof d=="object"?d.viewColumn:d,L={viewColumn:D.ViewColumn.from(C),preserveFocus:typeof d=="object"&&!!d.preserveFocus},B=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(f),B,p,{title:w,panelOptions:r(m),webviewOptions:(0,P.serializeWebviewOptions)(f,this.workspace,m)},L);const ee=this.webviews.createNewWebview(B,m,f);return this.createNewWebviewPanel(B,p,w,C,m,ee)}$onDidChangeWebviewPanelViewStates(f){const p=Object.keys(f);p.sort((w,d)=>{const m=f[w],C=f[d];return m.active?1:C.active?-1:+m.visible-+C.visible});for(const w of p){const d=this.getWebviewPanel(w);if(!!d){const m=f[w];d._updateViewState({active:m.active,visible:m.visible,viewColumn:D.ViewColumn.to(m.position)})}}}async $onDidDisposeWebviewPanel(f){const p=this.getWebviewPanel(f);p==null||p.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,p,w){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:w,extension:f}),this._proxy.$registerSerializer(p),new n.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(f,p,w,d){const m=this._serializers.get(p);if(!m)throw new Error(`No serializer found for '${p}'`);const{serializer:C,extension:L}=m,B=this.webviews.createNewWebview(f,w.webviewOptions,L),ee=this.createNewWebviewPanel(f,p,w.title,d,w.panelOptions,B);await C.deserializeWebviewPanel(ee,w.state)}createNewWebviewPanel(f,p,w,d,m,C){const L=new i(f,this._proxy,p,w,d,m,C);return this._webviewPanels.set(f,L),L}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=o;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[248],pe([0,1,3,6,64,5,7]),function(Z,e,b,A,R,I,D){"use strict";var P,y,n,T,k,_,g,a,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends A.Disposable{constructor(u,s,t,i,o,r){super();P.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),_.set(this,void 0),g.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Be(this,h).event,S.set(this,this._register(new b.Emitter)),this.onDidDispose=Be(this,S).event,nt(this,n,t),nt(this,g,i),nt(this,P,u),nt(this,y,s),nt(this,T,o),nt(this,_,r)}dispose(){Be(this,k)||(nt(this,k,!0),Be(this,S).fire(),Be(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,g)}set title(u){this.assertNotDisposed(),Be(this,g)!==u&&(nt(this,g,u),Be(this,y).$setWebviewViewTitle(Be(this,P),u))}get description(){return this.assertNotDisposed(),Be(this,a)}set description(u){this.assertNotDisposed(),Be(this,a)!==u&&(nt(this,a,u),Be(this,y).$setWebviewViewDescription(Be(this,P),u))}get visible(){return Be(this,_)}get webview(){return Be(this,T)}get viewType(){return Be(this,n)}_setVisible(u){u===Be(this,_)||Be(this,k)||(nt(this,_,u),Be(this,h).fire())}show(u){this.assertNotDisposed(),Be(this,y).$show(Be(this,P),!!u)}assertNotDisposed(){if(Be(this,k))throw new Error("Webview is disposed")}}P=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,_=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap;class E{constructor(u,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,s,t,i){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(u),s,i),new D.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(u,s,t,i,o){const r=this._viewProviders.get(s);if(!r)throw new Error(`No view provider found for '${s}'`);const{provider:l,extension:f}=r,p=this._extHostWebview.createNewWebview(u,{},f),w=new v(u,this._proxy,s,t,p,!0);this._webviewViews.set(u,w),await l.resolveWebviewView(w,{state:i},o)}async $onDidChangeWebviewViewVisibility(u,s){this.getWebviewView(u)._setVisible(s)}async $disposeWebviewView(u){const s=this.getWebviewView(u);this._webviewViews.delete(u),s.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const s=this._webviewViews.get(u);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=E}),define(ge[125],pe([0,1,3,5,2,11,10,4,13]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Mn{constructor(k){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=k.getProxy(A.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,_){let g;if(typeof k=="string"){g=k;try{k=R.URI.parse(k)}catch(a){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,D.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,g,_)}async asExternalUri(k,_){if((0,D.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const g=await this._proxy.$asExternalUri(k,_);return R.URI.from(g)}};n.InitialState={focused:!0},n=je([Ue(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ge[249],pe([0,1,8,48,28,51,6,5,2,13]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends D.Disposable{constructor(_,g){super();const a=_.getProxy(P.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async h=>{const S=y.URI.file((0,b.join)((0,A.tmpdir)(),(0,R.generateUuid)()));return await a.$download(h,S),S})}};T=je([Ue(0,n.IExtHostRpcService),Ue(1,I.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(ge[250],pe([0,1,2,8,145,26,37,63,27,13,6,12,109,44]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(E,c){this.file=c,this.appender=(0,_.createRotatingLogger)(E,c,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(E){this.appender.critical(E)}flush(){this.appender.flush()}}class h extends P.AbstractExtHostOutputChannel{constructor(E,c,u){super(E,!1,b.URI.file(c.file),u);this._appender=c}append(E){super.append(E),this._appender.append(E),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(E,c){this._appender.flush(),super.show(E,c)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=h;let S=class extends P.ExtHostOutputService{constructor(E,c,u){super(E);this.logService=c,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(E){if(E){const c=this._channels.get(E);c&&(this._visibleChannelDisposable.value=c.onDidAppend(()=>c.update()))}}createOutputChannel(E){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(E);return c.then(u=>u._id.then(s=>this._channels.set(s,u))),new P.LazyOutputChannel(E,c)}async _doCreateOutChannel(E){try{const c=(0,A.join)(this._logsLocation.fsPath,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(c)||await D.promises.mkdir(c,{recursive:!0});const s=`${this._namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,A.join)(c,`${s}.log`)),i=new a(s,t.fsPath);return new h(E,i,this._proxy)}catch(c){return this.logService.error(c),new P.ExtHostPushOutputChannel(E,this._proxy)}}};S=je([Ue(0,n.IExtHostRpcService),Ue(1,k.ILogService),Ue(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(ge[251],pe([0,1,5,13,6,27,2,38,24,37,26,7,9,50,3,72,12,14]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(w,d,m){this.remoteAddress=w,this.localAddress=d,this._dispose=m,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function c(p){const w=p.trim().split(`
`),d=[];return w.forEach(C=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(C);L&&L.length>=3&&d.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),d.reduce((C,L)=>(C[L.socket]=L,C),{})}e.getSockets=c;function u(...p){const w=[].concat(...p.map(t));return[...new Map(w.filter(d=>d.st==="0A").map(d=>{const m=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:s(m[0]),port:parseInt(m[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=u;function s(p){let w="";if(p.length===8)for(let d=p.length-2;d>=0;d-=2)w+=parseInt(p.substr(d,2),16),d!==0&&(w+=".");else for(let d=p.length-4;d>=0;d-=4)w+=parseInt(p.substr(d,4),16).toString(16),d!==0&&(w+=":");return w}e.parseIpAddress=s;function t(p){const w=p.trim().split(`
`),d=w.shift().trim().split(/\s+/).filter(C=>C!=="rx_queue"&&C!=="tm->when");return w.map(C=>C.trim().split(/\s+/).reduce((L,B,ee)=>(L[d[ee]||ee]=B,L),{}))}e.loadConnectionTable=t;function i(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/vs/server/main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function o(p){const w=p.trim().split(`
`),d=[];return w.forEach(m=>{const C=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(m);C&&C.length>=4&&d.push({pid:parseInt(C[1],10),ppid:parseInt(C[2]),cmd:C[3]})}),d}e.getRootProcesses=o;async function r(p,w,d){const m=d.reduce((L,B)=>(L[B.pid]=B,L),{}),C=[];return p.forEach(({socket:L,ip:B,port:ee})=>{var H;const x=w[L]?w[L].pid:void 0,W=x?(H=m[x])===null||H===void 0?void 0:H.cmd:void 0;x&&W&&!i(W)&&C.push({host:B,port:ee,detail:W,pid:x})}),C}e.findPorts=r;function l(p,w,d){const m=new Map,C=o(w);for(const L of p){const B=d.get(L.port);if(B){m.set(L.port,B);continue}const ee=C.find(H=>H.cmd.includes(`${L.port}`));if(ee){let H=ee,x;do x=C.find(W=>W.ppid===H.pid),x&&(H=x);while(x);m.set(L.port,{host:L.ip,port:L.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else m.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return m}e.tryFindRootPorts=l;let f=class extends R.Disposable{constructor(w,d,m){super();this.logService=m,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=w.getProxy(b.MainContext.MainThreadTunnelService),_.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(w,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${w.identifier} called openTunnel API for ${d.remoteAddress.port}.`);const m=await this._proxy.$openTunnel(d,w.displayName);if(m){const C=new E(m.remoteAddress,m.localAddress,()=>this._proxy.$closeTunnel(m.remoteAddress));return this._register(C),C}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(w){return Math.max(w*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(w,d){const m=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(m,{selector:w,provider:d}),this._proxy.$registerPortsAttributesProvider(w,m),new k.Disposable(()=>{this._portAttributesProviders.delete(m),this._proxy.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(w,d,m,C,L){const ee=(await Promise.all(w.map(H=>{const x=this._portAttributesProviders.get(H);return x?x.provider.providePortAttributes(d,m,C,L):[]}))).filter(H=>!!H&&H.length>0);return ee.length>0?(0,v.flatten)(ee).map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(w){if(!(w&&this._candidateFindingEnabled)){this._candidateFindingEnabled=w;let d=new h.MovingAverage,m;for(;this._candidateFindingEnabled;){const C=new Date().getTime(),L=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(ee=>ee.port).join(", ")}`);const B=new Date().getTime()-C;d.update(B),(!m||JSON.stringify(m)!==JSON.stringify(L))&&(m=L,await this._proxy.$onFoundNewCandidates(m)),await new Promise(ee=>setTimeout(()=>ee(),this.calculateDelay(d.value)))}}}async setTunnelExtensionFunctions(w){var d;return w?(w.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(w.candidatePortSource),w.showCandidatePort&&(this._showCandidatePort=w.showCandidatePort,await this._proxy.$setCandidateFilter()),w.tunnelFactory&&(this._forwardPortProvider=w.tunnelFactory,await this._proxy.$setTunnelProvider((d=w.tunnelFeatures)!==null&&d!==void 0?d:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(w,d){if(this._extensionTunnels.has(w.host)){const m=this._extensionTunnels.get(w.host);m.has(w.port)&&(d&&m.get(w.port).disposeListener.dispose(),await m.get(w.port).tunnel.dispose(),m.delete(w.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(w,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this._forwardPortProvider(w,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const C=await m;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(w.remoteAddress.host)||this._extensionTunnels.set(w.remoteAddress.host,new Map);const L=this._register(C.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(C.remoteAddress))));return this._extensionTunnels.get(w.remoteAddress.host).set(w.remoteAddress.port,{tunnel:C,disposeListener:L}),g.TunnelDto.fromApiTunnel(C)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(m){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(w){const d=await Promise.all(w.map(C=>{var L;return this._showCandidatePort(C.host,C.port,(L=C.detail)!==null&&L!==void 0?L:"")})),m=w.filter((C,L)=>d[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${w.map(C=>C.port).join(", ")} to ${m.map(C=>C.port).join(", ")}`),m}async findCandidatePorts(){let w="",d="";try{w=await n.promises.readFile("/proc/net/tcp","utf8"),d=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const m=u(w,d),C=await new Promise(U=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,N,O)=>{U(N)})}),L=c(C),B=await T.readdir("/proc"),ee=[];for(let U of B)try{const M=Number(U),N=y.joinPath(D.URI.file("/proc"),U);if((await n.promises.stat(N.fsPath)).isDirectory()&&!isNaN(M)){const V=await n.promises.readlink(y.joinPath(N,"cwd").fsPath),q=await n.promises.readFile(y.joinPath(N,"cmdline").fsPath,"utf8");ee.push({pid:M,cwd:V,cmd:q})}}catch(M){}const H=[],x=m.filter(U=>{const M=L[U.socket];return M||H.push(U),M}),W=r(x,L,ee);let F;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const U=await new Promise(M=>{(0,P.exec)("ps -F -A -l | grep root",(N,O,V)=>{M(O)})});this._foundRootPorts=l(H,U,this._foundRootPorts),F=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${F.join(", ")}`)}return W.then(U=>F?U.concat(F):U)}};f=je([Ue(0,A.IExtHostRpcService),Ue(1,I.IExtHostInitDataService),Ue(2,S.ILogService)],f),e.ExtHostTunnelService=f}),define(ge[252],pe([0,1,17,21,16,3,6,97,223,123,25]),function(Z,e,b,A,R,I,D,P,y,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function _(r,l){try{return JSON.stringify(r,l)}catch(f){return"null"}}function g(r,l){return JSON.stringify(r,l)}function a(r){return r?(l,f)=>f&&f.$mid===1?r.transformOutgoing(f):f:null}var h;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},E=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends D.Disposable{constructor(l,f=null,p=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=f,this._uriTransformer=p,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,d=n.ProxyIdentifier.count;w<d;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,P.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:f,sid:p}=l;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,p)),this._proxies[f]}_createProxy(l,f){let p={get:(w,d)=>(typeof d=="string"&&!w[d]&&d.charCodeAt(0)===36&&(w[d]=(...m)=>this._remoteCall(l,d,m)),d===c?f:w[d])};return new Proxy(Object.create(null),p)}set(l,f){return this._locals[l.nid]=f,f}assertRegistered(l){for(let f=0,p=l.length;f<p;f++){const w=l[f];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const f=l.byteLength,p=s.read(l,0),w=p.readUInt8(),d=p.readUInt32();switch(w){case 1:case 2:{let{rpcId:m,method:C,args:L}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,d,m,C,L,w===2);break}case 3:case 4:{let{rpcId:m,method:C,args:L}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,d,m,C,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(f,d,0,"ack"),this._onDidReceiveAcknowledge(d);break}case 6:{this._receiveCancel(f,d);break}case 7:{this._receiveReply(f,d,void 0);break}case 9:{let m=t.deserializeReplyOKJSON(p);this._uriTransformer&&(m=(0,P.transformIncomingURIs)(m,this._uriTransformer)),this._receiveReply(f,d,m);break}case 8:{let m=t.deserializeReplyOKVSBuffer(p);this._receiveReply(f,d,m);break}case 10:{let m=t.deserializeReplyErrError(p);this._uriTransformer&&(m=(0,P.transformIncomingURIs)(m,this._uriTransformer)),this._receiveReplyErr(f,d,m);break}case 11:{this._receiveReplyErr(f,d,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,f,p,w,d,m){this._logger&&this._logger.logIncoming(l,f,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(p)}.${w}(`,d);const C=String(f);let L,B;if(m){const H=new A.CancellationTokenSource;d.push(H.token),L=this._invokeHandler(p,w,d),B=()=>H.cancel()}else L=this._invokeHandler(p,w,d),B=v;this._cancelInvokedHandlers[C]=B;const ee=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(ee.byteLength,f,1,"ack"),this._protocol.send(ee),L.then(H=>{delete this._cancelInvokedHandlers[C];const x=t.serializeReplyOK(f,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,f,1,"reply:",H),this._protocol.send(x)},H=>{delete this._cancelInvokedHandlers[C];const x=t.serializeReplyErr(f,H);this._logger&&this._logger.logOutgoing(x.byteLength,f,1,"replyErr:",H),this._protocol.send(x)})}_receiveCancel(l,f){this._logger&&this._logger.logIncoming(l,f,1,"receiveCancel");const p=String(f);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(l,f,p){this._logger&&this._logger.logIncoming(l,f,0,"receiveReply:",p);const w=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const d=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],d.resolveOk(p)}}_receiveReplyErr(l,f,p){this._logger&&this._logger.logIncoming(l,f,0,"receiveReplyErr:",p);const w=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const d=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let m;p&&(p.$isError?(m=new Error,m.name=p.name,m.message=p.message,m.stack=p.stack):m=p),d.resolveErr(m)}}_invokeHandler(l,f,p){try{return Promise.resolve(this._doInvokeHandler(l,f,p))}catch(w){return Promise.reject(w)}}_doInvokeHandler(l,f,p){const w=this._locals[l];if(!w)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(l));let d=w[f];if(typeof d!="function")throw new Error("Unknown method "+f+" on actor "+(0,n.getStringIdentifierForProxy)(l));return d.apply(w,p)}_remoteCall(l,f,p){if(this._isDisposed)return Promise.reject(R.canceled());let w=null;if(p.length>0&&A.CancellationToken.isCancellationToken(p[p.length-1])&&(w=p.pop()),w&&w.isCancellationRequested)return Promise.reject(R.canceled());const d=t.serializeRequestArguments(p,this._uriReplacer),m=++this._lastMessageId,C=String(m),L=new y.LazyPromise;w&&w.onCancellationRequested(()=>{const ee=t.serializeCancel(m);this._logger&&this._logger.logOutgoing(ee.byteLength,m,0,"cancel"),this._protocol.send(t.serializeCancel(m))}),this._pendingRPCReplies[C]=L,this._onWillSendRequest(m);const B=t.serializeRequest(m,l,f,d,!!w);return this._logger&&this._logger.logOutgoing(B.byteLength,m,0,`request: ${(0,n.getStringIdentifierForProxy)(l)}.${f}(`,p),this._protocol.send(B),L}}e.RPCProtocol=u,k=E,u.UNRESPONSIVE_TIME=3*1e3;class s{constructor(l,f){this._buff=l,this._offset=f}static alloc(l,f,p){let w=new s(T.VSBuffer.alloc(p+1+4),0);return w.writeUInt8(l),w.writeUInt32(f),w}static read(l,f){return new s(l,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,f}static sizeMixedArray(l,f){let p=0;p+=1;for(let w=0,d=l.length;w<d;w++){const m=l[w],C=f[w];switch(p+=1,C){case 1:p+=this.sizeLongString(m);break;case 2:p+=this.sizeVSBuffer(m);break;case 3:break}}return p}writeMixedArray(l,f){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let p=0,w=l.length;p<w;p++){const d=l[p];switch(f[p]){case 1:this.writeUInt8(1),this.writeLongString(d);break;case 2:this.writeUInt8(2),this.writeVSBuffer(d);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(l);for(let p=0;p<l;p++)switch(this.readUInt8()){case 1:f[p]=this.readLongString();break;case 2:f[p]=this.readVSBuffer();break;case 3:f[p]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(l){for(let f=0,p=l.length;f<p;f++)if(l[f]instanceof T.VSBuffer||typeof l[f]=="undefined")return!0;return!1}static serializeRequestArguments(l,f){if(this._arrayContainsBufferOrUndefined(l)){let p=[],w=[];for(let d=0,m=l.length;d<m;d++){const C=l[d];C instanceof T.VSBuffer?(p[d]=C,w[d]=2):typeof C=="undefined"?(p[d]=T.VSBuffer.alloc(0),w[d]=3):(p[d]=T.VSBuffer.fromString(g(C,f)),w[d]=1)}return{type:"mixed",args:p,argsType:w}}return{type:"simple",args:g(l,f)}}static serializeRequest(l,f,p,w,d){return w.type==="mixed"?this._requestMixedArgs(l,f,p,w.args,w.argsType,d):this._requestJSONArgs(l,f,p,w.args,d)}static _requestJSONArgs(l,f,p,w,d){const m=T.VSBuffer.fromString(p),C=T.VSBuffer.fromString(w);let L=0;L+=s.sizeUInt8(),L+=s.sizeShortString(m),L+=s.sizeLongString(C);let B=s.alloc(d?2:1,l,L);return B.writeUInt8(f),B.writeShortString(m),B.writeLongString(C),B.buffer}static deserializeRequestJSONArgs(l){const f=l.readUInt8(),p=l.readShortString(),w=l.readLongString();return{rpcId:f,method:p,args:JSON.parse(w)}}static _requestMixedArgs(l,f,p,w,d,m){const C=T.VSBuffer.fromString(p);let L=0;L+=s.sizeUInt8(),L+=s.sizeShortString(C),L+=s.sizeMixedArray(w,d);let B=s.alloc(m?4:3,l,L);return B.writeUInt8(f),B.writeShortString(C),B.writeMixedArray(w,d),B.buffer}static deserializeRequestMixedArgs(l){const f=l.readUInt8(),p=l.readShortString(),w=l.readMixedArray(),d=new Array(w.length);for(let m=0,C=w.length;m<C;m++){const L=w[m];typeof L=="string"?d[m]=JSON.parse(L):d[m]=L}return{rpcId:f,method:p,args:d}}static serializeAcknowledged(l){return s.alloc(5,l,0).buffer}static serializeCancel(l){return s.alloc(6,l,0).buffer}static serializeReplyOK(l,f,p){return typeof f=="undefined"?this._serializeReplyOKEmpty(l):f instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(l,f):this._serializeReplyOKJSON(l,_(f,p))}static _serializeReplyOKEmpty(l){return s.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,f){let p=0;p+=s.sizeVSBuffer(f);let w=s.alloc(8,l,p);return w.writeVSBuffer(f),w.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,f){const p=T.VSBuffer.fromString(f);let w=0;w+=s.sizeLongString(p);let d=s.alloc(9,l,w);return d.writeLongString(p),d.buffer}static deserializeReplyOKJSON(l){const f=l.readLongString();return JSON.parse(f)}static serializeReplyErr(l,f){return f?this._serializeReplyErrEror(l,f):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,f){const p=T.VSBuffer.fromString(_(R.transformErrorForSerialization(f),null));let w=0;w+=s.sizeLongString(p);let d=s.alloc(10,l,w);return d.writeLongString(p),d.buffer}static deserializeReplyErrError(l){const f=l.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(l){return s.alloc(11,l,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[253],pe([0,1,4]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(ge[254],pe([0,1,11,8,9,2,4,253]),function(Z,e,b,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const _=await this.remoteAgentService.getEnvironment();return(_==null?void 0:_.os)||R.OS})(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(_==null?void 0:_.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?A.win32:A.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const g=T.indexOf("/",2);g===-1?(k=T.substring(2),T="/"):(k=T.substring(2,g),T=T.substring(g)||"/")}return I.URI.from({scheme:b.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=je([Ue(1,P.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ge[32],pe([0,1,14,34,22,31,10,4,8,16]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",_=(T.length+k.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var g;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function h(F){return!!F.preview}e.resultIsMatch=h;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var E;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=c;class u{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&s(O)){U=(0,D.getNLines)(U,N.matchLines);let V="",q=0,X=0;const fe=Math.floor(N.charsPerLine/5),ve=[];for(const Ae of O){const Ie=Math.max(Ae.startColumn-fe,0),Fe=Ae.startColumn+N.charsPerLine;if(Ie>X+fe+_){const z=T+(Ie-X)+k;V+=z+U.slice(Ie,Fe),q+=Ie-(X+z.length)}else V+=U.slice(X,Fe);ve.push(new i(0,Ae.startColumn-q,Ae.endColumn-q)),X=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,b.mapArrayOrNot)(M,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function s(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=i;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=R.mixin(O,R.deepClone(M)),O=R.mixin(O,R.deepClone(N),!0),O}}e.getExcludes=r;function l(F,U){return F.excludePattern&&A.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&A.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(I.isEqualOrParent(U,N)){const O=y.relative(N,U);return!M.includePattern||!!A.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=p;function w(F){const U=F.message;if((0,n.isPromiseCanceledError)(F))return new p(U,f.canceled);try{const M=JSON.parse(U);return new p(M.message,M.code)}catch(M){return new p(U,f.other)}}e.deserializeSearchError=w;function d(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=d;function m(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=m;function C(F){return F.type==="success"}e.isSerializedSearchSuccess=C;function L(F){return!!F.path}e.isSerializedFileMatch=L;function B(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,D.fuzzyContains)(M,U)}e.isFilePatternMatch=B;class ee{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function H(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=H;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=A.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=A.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=x;function W(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(ge[33],pe([0,1,14,17,21,3,23,11,72,24,10,15,2,165,4,12,183,59,60,27,13,7,32,5]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c,u,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(C,L,B){return new n.ExtUri(ee=>p(ee,B)).isEqual(C,L)}function r(C,L,B){return o(C.uri,L.uri,B)?0:(0,T.compare)(C.uri.toString(),L.uri.toString())}function l(C,L,B){return C.index!==L.index?C.index<L.index?-1:1:o(C.uri,L.uri,B)?(0,T.compare)(C.name,L.name):(0,T.compare)(C.uri.toString(),L.uri.toString())}function f(C,L,B,ee){const H=C.slice(0).sort((W,F)=>B(W,F,ee)),x=L.slice(0).sort((W,F)=>B(W,F,ee));return(0,b.delta)(H,x,(W,F)=>B(W,F,ee))}function p(C,L){const B=L.getCapabilities(C.scheme);return!(B&&B&1024)}class w extends v.Workspace{constructor(L,B,ee,H,x,W){super(L,ee.map(F=>new v.WorkspaceFolder(F)),H,W);this._name=B,this._isUntitled=x,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(W),ee.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,B,ee,H){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:W,folders:F,configuration:U,isUntitled:M}=L,N=[],O=B;B?F.forEach((fe,ve)=>{const Ae=_.URI.revive(fe.uri),Ie=w._findFolder(ee||B,Ae,H);Ie?(Ie.name=fe.name,Ie.index=fe.index,N.push(Ie)):N.push({uri:Ae,name:fe.name,index:ve})}):N.push(...F.map(({uri:fe,name:ve,index:Ae})=>({uri:_.URI.revive(fe),name:ve,index:Ae}))),N.sort((fe,ve)=>fe.index<ve.index?-1:1);const V=new w(x,W,N,U?_.URI.revive(U):null,!!M,fe=>p(fe,H)),{added:q,removed:X}=f(O?O.workspaceFolders:[],V.workspaceFolders,r,H);return{workspace:V,added:q,removed:X}}static _findFolder(L,B,ee){for(let H=0;H<L.folders.length;H++){const x=L.workspaceFolders[H];if(o(x.uri,B,ee))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let d=class{constructor(L,B,ee,H){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new I.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=s.WorkspaceTrustState.Unknown,this._logService=H,this._extHostFileSystemInfo=ee,this._requestIdProvider=new y.Counter,this._barrier=new A.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new w(x.id,x.name,[],x.configuration?_.URI.revive(x.configuration):null,!!x.isUntitled,W=>p(W,ee)):void 0}$initializeWorkspace(L,B){this._workspaceTrustState=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:P.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,ee,...H){const x=[];if(Array.isArray(H)&&H.forEach(N=>{_.URI.isUri(N.uri)&&!x.some(O=>o(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[B,ee].some(N=>typeof N!="number"||N<0)||ee===0&&x.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+ee>W.length)return!1;const F=W.slice(0);F.splice(B,ee,...x.map(N=>({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((V,q)=>q!==N&&o(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=f(W,F,l,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,B,ee,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,g.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,B){let ee,H="";if(typeof L=="string"?(ee=_.URI.file(L),H=L):typeof L!="undefined"&&(ee=L,H=L.fsPath),!ee)return H;const x=this.getWorkspaceFolder(ee,!0);if(!x)return H;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let W=(0,n.relativePath)(x.uri,ee);return B&&x.name&&(W=`${x.name}/${W}`),W}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:ee,removed:H}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:H}))}findFiles(L,B,ee,H,x=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let W;if(B===null?W=!1:B&&(typeof B=="string"?W=B:W=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=m(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(F),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)(W),(0,k.withUndefinedAsNull)(ee),x).then(M=>Array.isArray(M)?M.map(N=>_.URI.revive(N)):[])}async findTextInFiles(L,B,ee,H,x=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),F=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:U,folder:M}=m(B.include),N=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:F,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[W]=q=>{if(!V){const X=_.URI.revive(q.resource);q.results.forEach(fe=>{(0,t.resultIsMatch)(fe)?ee({uri:X,preview:{text:fe.preview.text,matches:(0,b.mapArrayOrNot)(fe.preview.matches,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(fe.ranges,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ee({uri:X,text:fe.text,lineNumber:fe.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(M),O,W,x);return delete this._activeSearchCallbacks[W],q||{}}catch(q){throw delete this._activeSearchCallbacks[W],q}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(L){return this._proxy.$requireWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(L))}};d=je([Ue(0,u.IExtHostRpcService),Ue(1,c.IExtHostInitDataService),Ue(2,E.IExtHostFileSystemInfo),Ue(3,h.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function m(C){let L,B;return C&&(typeof C=="string"?L=C:(L=C.pattern,B=C.baseFolder||_.URI.file(C.base))),{includePattern:L,folder:B}}}),define(ge[36],pe([0,1,22,3,33,5,7,185,82,15,17,4,13,12,2]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(i,o){if(o){const r=o.split(".");let l=i;for(let f=0;l&&f<r.length;f++)l=l[r[f]];return l}}function S(i){return i instanceof a.URI}function v(i){return i&&i.uri instanceof a.URI&&i.languageId&&typeof i.languageId=="string"}function E(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof a.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function u(i){if(S(i))return{resource:i};if(v(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(E(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let s=class{constructor(o,r,l){this._proxy=o.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(o,r))}};s=je([Ue(0,_.IExtHostRpcService),Ue(1,R.IExtHostWorkspace),Ue(2,g.ILogService)],s),e.ExtHostConfiguration=s;class t{constructor(o,r,l,f){this._onDidChangeConfiguration=new A.Emitter,this._proxy=o,this._logService=f,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(o,r,l){const f=u(r)||{},p=this._toReadonlyValue(o?h(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,f,l==null?void 0:l.identifier);function w(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(m){return typeof h(p,m)!="undefined"},get:(m,C)=>{this._validateConfigurationAccess(o?`${o}.${m}`:m,f,l==null?void 0:l.identifier);let L=h(p,m);if(typeof L=="undefined")L=C;else{let B;const ee=(H,x)=>{let W;const F=()=>{B=B||(0,b.deepClone)(p),W=W||h(B,x)};return(0,n.isObject)(H)?new Proxy(H,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>W;if(B)return W=W||h(B,x),W[M];const N=U[M];return typeof M=="string"?ee(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),W&&(W[M]=N),!0),deleteProperty:(U,M)=>(F(),W&&delete W[M],!0),defineProperty:(U,M,N)=>(F(),W&&Object.defineProperty(W,M,N),!0)}):H};L=ee(L,m)}return L},update:(m,C,L,B)=>{m=o?`${o}.${m}`:m;const ee=w(L);return C!==void 0?this._proxy.$updateConfigurationOption(ee,m,C,f,B):this._proxy.$removeConfigurationOption(ee,m,f,B)},inspect:m=>{var C,L,B,ee,H,x,W,F;m=o?`${o}.${m}`:m;const U=(0,b.deepClone)(this._configuration.inspect(m,f,this._extHostWorkspace.workspace));if(U)return{key:m,defaultValue:(C=U.default)===null||C===void 0?void 0:C.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(B=U.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(ee=U.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(W=U.workspace)===null||W===void 0?void 0:W.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof p=="object"&&(0,b.mixin)(d,p,!1),Object.freeze(d)}_toReadonlyValue(o){const r=l=>(0,n.isObject)(l)?new Proxy(l,{get:(f,p)=>r(f[p]),set:(f,p,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(f,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(f,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(o)}_validateConfigurationAccess(o,r,l){const f=y.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),p=l?`[${l.value}] `:"";if(f===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const l=new P.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,p)=>l.affectsConfiguration(f,u(p))})}_toMap(o){return o.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[65],pe([0,1,2,17,3,5,7,33,39,36,21,35,13,27,4,11,9,12,62,205,16]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c,u){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function x(F){if(F!=null)return F}H.from=x;function W(F){if(F!=null)return F}H.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(H){function x(F){if(F!=null)return F}H.from=x;function W(F){if(F!=null)return F}H.to=W})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(H){function x(F){if(F!=null)return F}H.from=x;function W(F){if(F!=null)return F}H.to=W})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(H){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}H.is=x;function W(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=o.from(U.options)),M}}H.from=W;function F(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}H.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(H){function x(F){if(F!=null)return F}H.from=x;function W(F){if(F!=null)return F}H.to=W})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(H){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}H.is=x;function W(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=l.from(U.options)),M}}H.from=W;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=F})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(H){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}H.is=x;function W(U){return{customExecution:"customExecution"}}H.from=W;function F(U,M){return M.get(U)}H.to=F})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(H){function x(W,F){let U;return W.scope!==void 0&&typeof W.scope!="number"?U=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===D.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=c.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:U}}H.from=x})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(H){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const V=W(O,M);V&&N.push(V)}return N}H.fromMany=x;function W(U,M){if(U!=null){let N;U.execution instanceof D.ProcessExecution?N=r.from(U.execution):U.execution instanceof D.ShellExecution?N=f.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(N=p.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=D.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=W;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):f.is(U.execution)?O=f.to(U.execution):p.is(U.execution)&&(O=p.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await M.resolveWorkspaceFolder(b.URI.revive(U.source.scope)):q=D.TaskScope.Workspace),!(!V||!q)){const X=new D.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(X.isBackground=U.isBackground),U.group!==void 0&&(X.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(X.presentationOptions=i.to(U.presentationOptions)),U._id&&(X._id=U._id),U.detail&&(X.detail=U.detail),X}}}H.to=F})(d=e.TaskDTO||(e.TaskDTO={}));var m;(function(H){function x(F){return F}H.from=x;function W(F){if(!!F)return Object.assign(Object.create(null),F)}H.to=W})(m=e.TaskFilterDTO||(e.TaskFilterDTO={}));class C{constructor(x,W,F){this._id=W,this._task=F,s.set(this,void 0),nt(this,s,x)}get task(){return this._task}terminate(){Be(this,s).terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}s=new WeakMap;var L;(function(H){function x(W){return{id:W._id,task:void 0}}H.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(x,W,F,U,M,N,O,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=x.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,W,F){if(!F)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:W,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,W),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,W){this._proxy.$registerTaskSystem(x,W)}fetchTasks(x){return this._proxy.$fetchTasks(m.from(x)).then(async W=>{const F=[];for(let U of W){const M=await d.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(W=>x.push(W)),x}terminateTask(x){if(!(x instanceof C))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,W,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal(W,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const W=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const W=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:W,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const W=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:x.exitCode})}$provideTasks(x,W){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,A.asPromise)(()=>F.provider.provideTasks(T.CancellationToken.None)).then(N=>this.provideTasksInternal(W,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,W){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if(W.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await d.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,T.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=d.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,W,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,W.execution)}async getTaskExecution(x,W){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=W||await d.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new C(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,W){x._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};B=je([Ue(0,_.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,E.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let ee=class extends B{constructor(x,W,F,U,M,N,O,V){super(x,W,F,U,M,N,O,V);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(W,x);if(F===void 0)throw new Error("Task is not valid");if(p.is(F.execution))await this.addCustomExecution(F,W,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),W);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,W,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=d.from(N,F.extension);O&&p.is(O.execution)?(M.push(O),W.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(p.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,W){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,W,F){}};ee=je([Ue(0,_.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,E.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var gn=this&&this.__rest||function(Z,e){var b={};for(var A in Z)Object.prototype.hasOwnProperty.call(Z,A)&&e.indexOf(A)<0&&(b[A]=Z[A]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,A=Object.getOwnPropertySymbols(Z);R<A.length;R++)e.indexOf(A[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,A[R])&&(b[A[R]]=Z[A[R]]);return b};define(ge[255],pe([0,1,14,17,21,3,69,6,22,15,2,28,5,39,13,20,7,33,218,121]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(w,d)=>`${w}:${d.toString()}`;let s=class{constructor(d,m,C){this.documents=m,this.workspace=C,this.resultsChangedEmitter=new I.Emitter,this.providers=new Map,this.ownedTests=new E.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=d.getProxy(_.MainContext.MainThreadTesting),this.workspaceObservers=new f(this.proxy),this.textDocumentObservers=new p(this.proxy,m)}registerTestProvider(d){const m=(0,k.generateUuid)();this.providers.set(m,d),this.proxy.$registerTestProvider(m);const C=[...this.testSubscriptions.keys()];return setTimeout(()=>{var L;for(const B of C)(L=this.testSubscriptions.get(B))===null||L===void 0||L.subscribeFn(m,d)},0),new S.Disposable(()=>{this.providers.delete(m),this.proxy.$unregisterTestProvider(m)})}createTextDocumentTestObserver(d){return this.textDocumentObservers.checkout(d.uri)}createWorkspaceTestObserver(d){return this.workspaceObservers.checkout(d.uri)}async runTests(d,m=R.CancellationToken.None){const C=L=>L.map(this.getInternalTestForReference,this).filter(n.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:d.exclude?C(d.exclude).map(L=>L.testId):void 0,tests:C(d.tests),debug:d.debug},m)}publishExtensionProvidedResults(d,m){this.proxy.$publishExtensionProvidedResults(h.TestResults.from((0,k.generateUuid)(),d),m)}$publishTestResults(d){this.results=Object.freeze(d.map(m=>(0,y.deepFreeze)(h.TestResults.to(m))).concat(this.results).sort((m,C)=>C.completedAt-m.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(d,m){const C=T.URI.revive(m),L=u(d,C);if(!this.testSubscriptions.has(L)){const B=new R.CancellationTokenSource;let ee;if(d===1){let F=this.documents.getDocument(C);if(!F){const U=new P.DisposableStore;F=await new Promise(M=>{U.add((0,A.disposableTimeout)(()=>M(void 0),5e3)),U.add(this.documents.onDidAddDocuments(N=>{const O=N.find(V=>V.document.uri.toString()===C.toString());O&&M(O)}))}).finally(()=>U.dispose())}if(F){const U=await this.workspace.getWorkspaceFolder2(C,!1);ee=M=>M.provideDocumentTestRoot?M.provideDocumentTestRoot(F.document,B.token):(0,e.createDefaultDocumentTestRoot)(M,F.document,U,B.token)}}else{const F=await this.workspace.getWorkspaceFolder2(C,!1);F&&(ee=U=>U.provideWorkspaceTestRoot(F,B.token))}if(!!ee){const H=async(F,U)=>{try{const M=await ee(U);M&&W.addRoot(M,F)}catch(M){console.error(M)}},x=new P.DisposableStore,W=x.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(d,m,F)));x.add((0,P.toDisposable)(()=>B.dispose(!0)));for(const[F,U]of this.providers)H(F,U);W.pushDiff([3,-1]),this.testSubscriptions.set(L,{store:x,collection:W,subscribeFn:H})}}}async $expandTest(d,m){const C=(0,b.mapFind)(this.testSubscriptions.values(),L=>L.collection.treeId===d.src.tree?L:void 0);await(C==null?void 0:C.collection.expand(d.testId,m<0?Infinity:m)),this.flushCollectionDiffs()}$unsubscribeFromTests(d,m){var C;const L=T.URI.revive(m),B=u(d,L);(C=this.testSubscriptions.get(B))===null||C===void 0||C.store.dispose(),this.testSubscriptions.delete(B)}$acceptDiff(d,m,C){d===1?this.textDocumentObservers.acceptDiff(T.URI.revive(m),C):this.workspaceObservers.acceptDiff(T.URI.revive(m),C)}async $runTestsForProvider(d,m){const C=this.providers.get(d.tests[0].src.provider);if(!!C){const L=d.tests.map(({testId:ee,src:H})=>this.ownedTests.getTestById(ee,H.tree)).filter(n.isDefined).map(([ee,H])=>H),B=d.excludeExtIds.map(ee=>this.ownedTests.getTestById(ee)).filter(n.isDefined).filter(([ee,H])=>L.some(x=>ee.comparePositions(x,H)===1));if(!!L.length)try{await C.runTests({setState:(ee,H)=>{for(const[x,W]of B){const F=x.comparePositions(W,ee.id);if(F===1||F===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(d.runId,ee.id,h.TestState.from(H))},tests:L.map(ee=>i.unwrap(ee.actual)),exclude:B.map(([,ee])=>i.unwrap(ee.actual)),debug:d.debug},m);for(const{collection:ee}of this.testSubscriptions.values())ee.flushDiff();return}catch(ee){throw console.error(ee),ee}}}$lookupTest(d){const m=this.ownedTests.getTestById(d.testId);if(!m)return Promise.resolve(void 0);const C=m[1],{actual:L,discoverCts:B,expandLevels:ee}=C,H=gn(C,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:d}of this.testSubscriptions.values())d.flushDiff()}getInternalTestForReference(d){var m,C;return(C=(m=this.workspaceObservers.getMirroredTestDataByReference(d))!==null&&m!==void 0?m:(0,b.mapFind)(this.testSubscriptions.values(),L=>L.collection.getTestByReference(d)))!==null&&C!==void 0?C:this.textDocumentObservers.getMirroredTestDataByReference(d)}};s=je([Ue(0,a.IExtHostRpcService),Ue(1,g.IExtHostDocumentsAndEditors),Ue(2,v.IExtHostWorkspace)],s),e.ExtHostTesting=s;const t=async(w,d,m,C)=>{if(!!m){const L=await w.provideWorkspaceTestRoot(m,C);if(!!L)return C.onCancellationRequested(()=>{i.removeFilter(d)}),i.getWrapperForTestItem(L,d)}};e.createDefaultDocumentTestRoot=t;class i extends S.TestItem{constructor(d,m,C){super(d.id,d.label,d.uri,d.expandable);if(this.actual=d,this.filterDocument=m,this.parent=C,!(d instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);d[S.TestItemHookProperty]={setProp:(L,B)=>this[L]=B,created:L=>i.getWrapperForTestItem(L,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:L=>this.children.delete(L)}}static removeFilter(d){this.wrapperMap.delete(d)}static getWrapperForTestItem(d,m,C){let L=this.wrapperMap.get(m);if(L==null?void 0:L.has(d))return L.get(d);L||(L=new WeakMap,this.wrapperMap.set(m,L));const B=new i(d,m,C);return L.set(d,B),B}static unwrap(d){return d instanceof i?d.actual:d}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var d;const m=this._cachedMatchesFilter;for(const L of this.actual.children){const B=i.getWrapperForTestItem(L,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.add(B):this.children.delete(B)}const C=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=C,C!==m&&((d=this.parent)===null||d===void 0||d.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=i,i.wrapperMap=new WeakMap;class o extends c.IncrementalChangeCollector{constructor(d){super();this.emitter=d,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(d){this.added.add(d)}update(d){Object.assign(d.revived,h.TestItem.toPlain(d.item)),this.added.has(d)||this.updated.add(d)}remove(d){if(this.added.has(d)){this.added.delete(d);return}if(this.updated.delete(d),d.parent&&this.alreadyRemoved.has(d.parent)){this.alreadyRemoved.add(d.item.extId);return}this.removed.add(d)}getChangeEvent(){const{added:d,updated:m,removed:C}=this;return{get added(){return[...d].map(L=>L.revived)},get updated(){return[...m].map(L=>L.revived)},get removed(){return[...C].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(d){let m=[];for(const C of d){const L=this.items.get(C);L&&m.push(L.revived)}return m}getMirroredTestDataById(d){return this.items.get(d)}getMirroredTestDataByReference(d){return this.items.get(d.id)}createItem(d,m){return Object.assign(Object.assign({},d),{revived:h.TestItem.toPlain(d.item),depth:m?m.depth+1:0,children:new Set})}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=r;class l{constructor(){this.resources=new Map}checkout(d){var m,C;const L=d.toString(),B=(m=this.resources.get(L))!==null&&m!==void 0?m:this.createObserverData(d);return(C=B.pendingDeletion)===null||C===void 0||C.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new I.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,D.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(d))})}}getMirroredTestDataByReference(d){for(const{tests:m}of this.resources.values()){const C=m.getMirroredTestDataByReference(d);if(C)return C}}eventuallyDispose(d){return(0,A.disposableTimeout)(()=>this.unlisten(d),10*1e3)}createObserverData(d){const m=new r,C=this.listen(d,B=>m.apply(B)),L={observers:0,tests:m,listener:C};return this.resources.set(d.toString(),L),L}unlisten(d){var m;const C=d.toString(),L=this.resources.get(C);L&&(L.observers=-1,(m=L.pendingDeletion)===null||m===void 0||m.dispose(),L.listener.dispose(),this.resources.delete(C))}}class f extends l{constructor(d){super();this.proxy=d,this.diffListeners=new Map}acceptDiff(d,m){var C;(C=this.diffListeners.get(d.toString()))===null||C===void 0||C(m)}listen(d,m){this.proxy.$subscribeToDiffs(0,d);const C=d.toString();return this.diffListeners.set(C,m),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,d),this.diffListeners.delete(C)})}}class p extends l{constructor(d,m){super();this.proxy=d,this.documents=m,this.diffListeners=new Map}acceptDiff(d,m){var C;(C=this.diffListeners.get(d.toString()))===null||C===void 0||C(m)}listen(d,m){if(!this.documents.getDocument(d))return new S.Disposable(()=>{});const L=d.toString();return this.diffListeners.set(L,m),this.proxy.$subscribeToDiffs(1,d),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,d),this.diffListeners.delete(L)})}}}),define(ge[256],pe([0,1,14,53,34,75,23,11,8,24,10,15,2,139,171,83,59,210,254,32]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(w,d,m,C){this.configurationService=w,this.workspaceContextService=d,this.editorGroupsService=m,this.pathService=C}text(w,d,m={}){w=this.getContentPattern(w,m);const C=this.configurationService.getValue(),L=d&&d.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),B=this.commonQuery(d==null?void 0:d.map(S.toWorkspaceFolder),m);return Object.assign(Object.assign({},B),{type:2,contentPattern:w,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:C.search.usePCRE2||L||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles})}getContentPattern(w,d){const m=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const C=Object.assign(Object.assign({},w),{wordSeparators:m.editor.wordSeparators});return this.isCaseSensitive(w,d)&&(C.isCaseSensitive=!0),this.isMultiline(w)&&(C.isMultiline=!0),C}file(w,d={}){const m=this.commonQuery(w,d);return Object.assign(Object.assign({},m),{type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey})}handleIncludeExclude(w,d){return w?(w=Array.isArray(w)?w.map(r):r(w),d?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],d={}){const m=this.handleIncludeExclude(d.includePattern,d.expandPatterns),C=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),L=w.length>1,B=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,d,C)):w.map(x=>this.getFolderQueryForRoot(x,d,C,L))).filter(x=>!!x),ee={_reason:d._reason,folderQueries:B,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:C.pattern,includePattern:m.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const W=b.coalesce(b.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,c.pathIncludedInQuery)(ee,U.fsPath)),F=this.commonQueryFromFileList(W);return Object.assign(Object.assign({},ee),F)}const H=d.extraFileResources&&d.extraFileResources.filter(x=>(0,c.pathIncludedInQuery)(ee,x.fsPath));return ee.extraFileResources=H&&H.length?H:void 0,ee}commonQueryFromFileList(w){const d=[],m=new D.ResourceMap,C={};let L=!1;return w.forEach(B=>{var ee,H;if(B.scheme!==P.Schemas.walkThrough)if((0,n.isAbsolutePath)(B)){const W=(H=(ee=this.workspaceContextService.getWorkspaceFolder(B))===null||ee===void 0?void 0:ee.uri)!==null&&H!==void 0?H:B.with({path:y.dirname(B.fsPath)});let F=m.get(W);F||(L=!0,F={folder:W,includePattern:{}},d.push(F),m.set(W,F));const U=y.relative(W.fsPath,B.fsPath);(0,k.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else B.fsPath&&(L=!0,C[B.fsPath]=!0)}),{folderQueries:d,includePattern:C,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,d){if(d.isSmartCase){if(w.isRegExp){if(T.containsUppercaseCharacter(w.pattern,!0))return!0}else if(T.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,g.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const d=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),C=(Array.isArray(w)?w:i(w)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,I.untildify)(F,U.scheme===P.Schemas.file?U.fsPath:U.path):F}),L=A.groupBy(C,F=>d(F)?"searchPaths":"exprSegments"),B=(L.exprSegments||[]).map(F=>T.rtrim(F,"/")).map(F=>T.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),o(F))),ee={},H=this.expandSearchPathPatterns(L.searchPaths||[]);H&&H.length&&(ee.searchPaths=H);const x=b.flatten(B),W=t(...x);return W&&(ee.pattern=W),ee}getExcludesForFolder(w,d){return d.disregardExcludeSettings?void 0:(0,c.getExcludes)(w,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const d=b.flatten(w.map(C=>{let{pathPortion:L,globPortion:B}=s(C);B&&(B=l(B));const ee=this.expandOneSearchPath(L);return b.flatten(ee.map(H=>this.resolveOneSearchPathPattern(H,B)))})),m=new Map;return d.forEach(C=>{const L=C.searchPath.toString(),B=m.get(L);B?C.pattern&&(B.pattern=B.pattern||{},B.pattern[C.pattern]=!0):m.set(L,{searchPath:C.searchPath,pattern:C.pattern?t(C.pattern):void 0})}),Array.from(m.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==P.Schemas.file?[{searchPath:d[0].uri.with({path:w})}]:[{searchPath:_.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const C=y.posix.resolve(d.path,w);return[{searchPath:d.with({path:C})}]}const m=l(w);return[{searchPath:d,pattern:m}]}else{if(w==="./"||w===".\\")return[];{const d=w.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(d){const m=d[1],C=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===m);if(C.length)return C.map(L=>{const B=d[2];return{searchPath:L.uri,pattern:B&&l(B)}});{const L=a.localize(0,null,m);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(w,d){const m=w.pattern&&d?`${w.pattern}/${d}`:w.pattern||d,C=[{searchPath:w.searchPath,pattern:m}];return m&&!m.endsWith("**")&&C.push({searchPath:w.searchPath,pattern:m+"/**"}),C}getFolderQueryForSearchPath(w,d,m){const C=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(w.searchPath),d,m,!1);return C?Object.assign(Object.assign({},C),{includePattern:w.pattern}):null}getFolderQueryForRoot(w,d,m,C){let L;const B=_.URI.isUri(w)?w:w.uri;if(m.searchPaths){const F=m.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,B))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const ee=this.configurationService.getValue({resource:B}),H=this.getExcludesForFolder(ee,d),x=Object.assign(Object.assign({},H||{}),L||{}),W=_.URI.isUri(w)?(0,n.basename)(w):w.name;return{folder:B,folderName:C?W:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!ee.search.followSymlinks}}};u=je([Ue(0,h.IConfigurationService),Ue(1,S.IWorkspaceContextService),Ue(2,v.IEditorGroupsService),Ue(3,E.IPathService)],u),e.QueryBuilder=u;function s(p){const w=p.match(/[\*\{\}\(\)\[\]\?]/);if(w){const d=w.index,m=p.substr(0,d).match(/[/|\\][^/\\]*$/);if(m){let C=p.substr(0,m.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:p.substr((m.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((w,d)=>(w[d]=!0,w),Object.create(null)):void 0}function i(p){return R.splitGlobAware(p,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(p){return[`**/${p}/**`,`**/${p}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function l(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(p,w){p=b.distinct(p,C=>C.toString());const d=[],m=w.getWorkspace();return p&&p.forEach(C=>{let L;if(w.getWorkbenchState()===2)L=(0,n.relativePath)(m.folders[0].uri,C),L&&L!=="."&&(L="./"+L);else{const B=w.getWorkspaceFolder(C);if(B){const ee=B.name;if(m.folders.filter(x=>x.name===ee).length===1){const x=(0,n.relativePath)(B.uri,C);x===""?L=`./${B.name}`:L=`./${B.name}/${x}`}else L=C.fsPath}}L&&d.push(L)}),d}e.resolveResourcesForSearchIncludes=f}),define(ge[257],pe([0,1,24,2,21,16,4,256,32,59]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(h,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const E=[],c=[];for(const r of v)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||h.forceUsingSearch?c.push(l):E.push(l)}if(E.length===0&&c.length===0)return Promise.resolve(void 0);let u;const s=new Promise((r,l)=>{u=r}),t=r=>u({activationEvent:r}),i=Promise.all(E.map(r=>_(h,r,t))).then(()=>{}),o=g(h,S.identifier,c,t);return Promise.all([i,o]).then(()=>{u(void 0)}),s}e.checkActivateWorkspaceContainsExtension=k;async function _(h,S,v){for(const E of h.folders)if(await h.exists(b.joinPath(A.URI.revive(E),S))){v(`workspaceContains:${S}`);return}}async function g(h,S,v,E){if(v.length===0)return Promise.resolve(void 0);const c=new R.CancellationTokenSource,u=h.checkExists(h.folders,v,c.token),s=setTimeout(async()=>{c.cancel(),E(`workspaceContainsTimeout:${v.join(",")}`)},T);let t=!1;try{t=await u}catch(i){I.isPromiseCanceledError(i)||I.onUnexpectedError(i)}c.dispose(),clearTimeout(s),t&&E(`workspaceContains:${v.join(",")}`)}function a(h,S,v,E){const c=h.get(D.IInstantiationService),u=h.get(y.ISearchService),t=c.createInstance(P.QueryBuilder).file(S.map(i=>(0,n.toWorkspaceFolder)(A.URI.revive(i))),{_reason:"checkExists",includePattern:v,exists:!0});return u.fileSearch(t,E).then(i=>!!i.limitHit,i=>I.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(Z,e,b){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,b),b},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[42],pe([0,1,160,8,66,24,17,6,23,2,12,5,36,221,88,33,41,219,16,29,11,25,193,7,113,4,27,89,13,81,50,35,3,257,86,194]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c,u,s,t,i,o,r,l,f,p,w,d,m,C,L,B,ee){"use strict";var H,x,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class On extends P.Disposable{constructor(O,V,q,X,fe,ve,Ae,Ie,Fe,z){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Ae,this._extHostWorkspace=X,this._extHostConfiguration=fe,this._logService=ve,this._extHostTunnelService=Fe,this._extHostTerminalService=z,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new w.ServiceCollection([a.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(te=>J.add(c.ExtensionIdentifier.toKey(te))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(J.has(c.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new g.HostExtension;const he=this._registry.getExtensionDescription(te);return this._activateExtension(he,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){E.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(X=>O.set(n.URI.file(X).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,P.dispose)(q.subscriptions)}catch(X){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const X=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",X),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,X){const fe=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},fe),X||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const fe=new g.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,X),fe),this._loadExtensionContext(O)]).then(ve=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),On._callActivate(this._logService,O.identifier,ve[0],ve[1],fe))).then(ve=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ve))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),X=new ee.ExtensionSecrets(O,this._secretState),fe=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Ie;return Object.freeze({globalState:V,workspaceState:q,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return A.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Ae._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return A.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return fe},get extension(){return Ie===void 0&&(Ie=new M(Ae,O.identifier,O,ve)),Ie},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,X,fe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,X,fe).then(ve=>new g.ActivatedExtension(!1,null,fe.build(),q,ve,X.subscriptions))}static _callActivateOptional(O,V,q,X,fe){if(typeof q.activate=="function")try{fe.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const ve=typeof global=="object"?global:self,Ae=q.activate.apply(ve,[X]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Ae).then(Ie=>(fe.activateResolveStop(),Ie))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),X=Promise.all([O,q]).then(()=>{});return Promise.race([X,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Ae,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Ae,Ie)},fe=await(0,L.checkActivateWorkspaceContainsExtension)(X,V);if(!!fe)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:fe.activationEvent}).then(void 0,ve=>this._logService.error(ve))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(b.localize(0,null));const q=(0,I.originalFSPath)(V),X=await this._loadCommonJSModule(null,V,new g.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(b.localize(1,null,q));return new Promise((fe,ve)=>{const Ae=(Fe,z)=>{Fe?ve(Fe):fe(typeof z=="number"&&z>0?1:0)},Ie=X.run(q,Ae);Ie&&Ie.then&&Ie.then(()=>{fe(0)}).catch(Fe=>{ve(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,P.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const X=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const fe=this._resolvers[X];if(!fe)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${X}`);const ve=await fe.resolve(O,{resolveAttempt:V});R.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(fe));const Ae={authority:O,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Ie={extensionHostEnv:ve.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Ie,tunnelInformation:{environmentTunnels:ve.environmentTunnels}}}}catch(ve){if(R.mark(`code/extHost/didResolveAuthorityError/${X}`),ve instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(X=>X.extensionLocation=n.URI.revive(X.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async X=>{const fe=this._registry.getExtensionDescription(X);if(!!fe){const ve=await this._hostUtils.realpath(fe.extensionLocation.fsPath);q.delete(n.URI.file(ve).fsPath)}})),await Promise.all(O.map(async X=>{const fe=await this._hostUtils.realpath(X.extensionLocation.fsPath);q.set(n.URI.file(fe).fsPath,X)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=s.VSBuffer.alloc(O),q=Math.random()%256;for(let X=0;X<O;X++)V.writeUInt8(q,X);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,p.IExtHostRpcService),Ue(3,h.IExtHostWorkspace),Ue(4,_.IExtHostConfiguration),Ue(5,T.ILogService),Ue(6,l.IExtHostInitDataService),Ue(7,f.IExtensionStoragePaths),Ue(8,d.IExtHostTunnelService),Ue(9,m.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,V,q,X){H.set(this,void 0),x.set(this,void 0),W.set(this,void 0),nt(this,H,O),nt(this,x,V),nt(this,W,q.identifier),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=A.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=X}get isActive(){return Be(this,H).isActivated(Be(this,W))}get exports(){if(this.packageJSON.api!=="none")return Be(this,H).getExtensionExports(Be(this,W))}activate(){return Be(this,H).activateByIdWithErrors(Be(this,W),{startup:!1,extensionId:Be(this,x),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,H=new WeakMap,x=new WeakMap,W=new WeakMap}),define(ge[45],pe([0,1,8,2,3,17,5,7,119,33,42,39,209,36,200,13,4,15,30]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let c=class{constructor(f,p,w,d,m){this._workspaceService=p,this._extensionService=w,this._editorsService=d,this._configurationService=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=f.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(C=>{C.onDidChange(L=>{this.registerAllDebugTypes(C)}),this.registerAllDebugTypes(C)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,p){const w=f;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let d=`debug:${encodeURIComponent(w.path||"")}`,m="?";return p&&(d+=`${m}session=${encodeURIComponent(p.id)}`,m="&"),d+=`${m}ref=${w.sourceReference}`,A.URI.parse(d)}else{if(w.path)return A.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const p=[];for(const w of f.getAllExtensionDescriptions())if(w.contributes){const d=w.contributes.debuggers;if(d&&d.length>0)for(const m of d)(0,a.isDebuggerMainContribution)(m)&&p.push(m.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(p=>f.push(p)),f}addBreakpoints(f){this.startBreakpoints();const p=f.filter(m=>{const C=m.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,m),!0)});this.fireBreakpointChanges(p,[],[]);const w=[],d=new Map;for(const m of p)if(m instanceof P.SourceBreakpoint){let C=d.get(m.location.uri.toString());C||(C={type:"sourceMulti",uri:m.location.uri,lines:[]},d.set(m.location.uri.toString(),C),w.push(C)),C.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof P.FunctionBreakpoint&&w.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this._debugServiceProxy.$registerBreakpoints(w)}removeBreakpoints(f){this.startBreakpoints();const p=f.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],p,[]);const w=p.filter(C=>C instanceof P.SourceBreakpoint).map(C=>C.id),d=p.filter(C=>C instanceof P.FunctionBreakpoint).map(C=>C.id),m=p.filter(C=>C instanceof P.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(w,d,m)}startDebugging(f,p,w){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,p,{parentSessionID:w.parentSession?w.parentSession.id:void 0,repl:w.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,p,w){if(!p)return new P.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:d,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,w,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,d),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(m=>m.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(f,p,w){if(!w)return new P.Disposable(()=>{});if(!this.definesDebugType(f,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:d,factory:w}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,d),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(m=>m.factory!==w),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(f,p){if(!p)return new P.Disposable(()=>{});const w=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:w,factory:p}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==p)})}async $runInTerminal(f,p){return Promise.resolve(void 0)}async $substituteVariables(f,p){if(!this._variableResolver){const[m,C]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(m||[],this._editorsService,C)}let w;const d=await this.getFolder(f);return d&&(w={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(w,p)}createDebugAdapter(f,p){if(f.type==="implementation")return new o(f.implementation)}createSignService(){}async $startDASession(f,p){const w=this,d=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const C=this.convertToDto(m),L=this.createDebugAdapter(C,d);if(!L)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const B=L;return this._debugAdapters.set(f,B),this.getDebugAdapterTrackers(d).then(ee=>(ee&&this._debugAdaptersTrackers.set(f,ee),B.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const x=H,W={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);W.body={signature:F},B.sendResponse(W)}else throw new Error("no signer")}catch(F){W.success=!1,W.message=F.message,B.sendResponse(W)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(H),H=(0,a.convertToVSCPaths)(H,!0),w._debugServiceProxy.$acceptDAMessage(f,H)}),B.onError(H=>{ee&&ee.onError&&ee.onError(H),this._debugServiceProxy.$acceptDAError(f,H.name,H.message,H.stack)}),B.onExit(H=>{ee&&ee.onExit&&ee.onExit((0,v.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,v.withNullAsUndefined)(H),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),B.startSession()))})}$sendDAMessage(f,p){p=(0,a.convertToDAPaths)(p,!1);const w=this._debugAdaptersTrackers.get(f);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(p);const d=this._debugAdapters.get(f);d&&d.sendMessage(p)}$stopDASession(f){const p=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),p&&p.onWillStopSession&&p.onWillStopSession();const w=this._debugAdapters.get(f);return this._debugAdapters.delete(f),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const p=[],w=[],d=[];if(f.added)for(const m of f.added){const C=m.id;if(C&&!this._breakpoints.has(C)){let L;if(m.type==="function")L=new P.FunctionBreakpoint(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")L=new P.DataBreakpoint(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const B=A.URI.revive(m.uri);L=new P.SourceBreakpoint(new P.Location(B,new P.Position(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}L._id=C,this._breakpoints.set(C,L),p.push(L)}}if(f.removed)for(const m of f.removed){const C=this._breakpoints.get(m);C&&(this._breakpoints.delete(m),w.push(C))}if(f.changed){for(const m of f.changed)if(m.id){const C=this._breakpoints.get(m.id);if(C){if(C instanceof P.FunctionBreakpoint&&m.type==="function"){const L=C;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.functionName=m.functionName}else if(C instanceof P.SourceBreakpoint&&m.type==="source"){const L=C;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.location=new P.Location(A.URI.revive(m.uri),new P.Position(m.line,m.character))}d.push(C)}}}this.fireBreakpointChanges(p,w,d)}$provideDebugConfigurations(f,p,w){return(0,I.asPromise)(async()=>{const d=this.getConfigProviderByHandle(f);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.getFolder(p);return d.provideDebugConfigurations(m,w)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(f,p,w,d){return(0,I.asPromise)(async()=>{const m=this.getConfigProviderByHandle(f);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(p);return m.resolveDebugConfiguration(C,w,d)})}$resolveDebugConfigurationWithSubstitutedVariables(f,p,w,d){return(0,I.asPromise)(async()=>{const m=this.getConfigProviderByHandle(f);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(p);return m.resolveDebugConfigurationWithSubstitutedVariables(C,w,d)})}async $provideDebugAdapter(f,p){const w=this.getAdapterDescriptorFactoryByHandle(f);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(p);return this.getAdapterDescriptor(w,d).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(m)})}async $acceptDebugSessionStarted(f){const p=await this.getSession(f);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(f){const p=await this.getSession(f);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,p){const w=await this.getSession(f);w&&w._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(f,p){const d={session:await this.getSession(f),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(f){if(f instanceof P.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof P.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const p=this._adapterFactories.filter(w=>w.type===f);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(f){const p=this._adapterFactories.filter(w=>w.handle===f);if(p.length>0)return p[0].factory}getConfigProviderByHandle(f){const p=this._configProviders.filter(w=>w.handle===f);if(p.length>0)return p[0].provider}definesDebugType(f,p){if(f.contributes){const w=f.contributes.debuggers;if(w&&w.length>0){for(const d of w)if(d.label&&d.type&&d.type===p)return!0}}return!1}getDebugAdapterTrackers(f){const w=f.configuration.type,d=this._trackerFactories.filter(m=>m.type===w||m.type==="*").map(m=>(0,I.asPromise)(()=>m.factory.createDebugAdapterTracker(f)).then(C=>C,C=>null));return Promise.race([Promise.all(d).then(m=>{const C=m.filter(L=>!!L);if(C.length>0)return new i(C)}),new Promise((m,C)=>{const L=setTimeout(()=>{clearTimeout(L),C(new Error("timeout"))},1e3)})]).catch(m=>{})}async getAdapterDescriptor(f,p){const w=p.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new P.DebugAdapterServer(w));if(f){const m=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>f.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,m))).then(C=>{if(C)return C})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,d))}daExecutableFromPackage(f,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,p,w){(f.length>0||p.length>0||w.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:p,changed:w}))}async getSession(f){if(f)if(typeof f=="string"){const p=this._debugSessions.get(f);if(p)return p}else{let p=this._debugSessions.get(f.id);if(!p){const w=await this.getFolder(f.folderUri);p=new u(this._debugServiceProxy,f.id,f.type,f.name,w,f.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(f){if(f){const p=A.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};c=je([Ue(0,h.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],c),e.ExtHostDebugServiceBase=c;class u{constructor(f,p,w,d,m,C){this._debugServiceProxy=f,this._id=p,this._type=w,this._name=d,this._workspaceFolder=m,this._configuration=C}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,p)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=u;class s{constructor(f){this.value=Object.freeze({append(p){f.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=s;class t extends _.AbstractVariableResolverService{constructor(f,p,w,d){super({getFolderUri:m=>{const C=f.filter(L=>L.name===m);if(C&&C.length>0)return C[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(m,C)=>w.getConfiguration(void 0,m).get(C),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const m=p.activeEditor();if(m)return b.normalize(m.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&d){const m=p.activeEditor();if(m){const C=d.getWorkspaceFolder(m.document.uri);if(C)return b.normalize(C.uri.fsPath)}}},getSelectedText:()=>{if(p){const m=p.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(p){const m=p.activeEditor();if(m)return String(m.selection.end.line+1)}}},void 0,E.env)}}e.ExtHostVariableResolverService=t;class i{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(p=>p.onError?p.onError(f):void 0)}onExit(f,p){this.trackers.forEach(w=>w.onExit?w.onExit(f,p):void 0)}}class o extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(f,p,w,d,m){super(f,p,w,d,m)}createVariableResolver(f,p,w){return new t(f,p,w)}};r=je([Ue(0,h.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[258],pe([0,1,66,2,5,36,41,29,13,27,4,42,30,12]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(c,u,s,t,i,o,r){this._apiFactory=c,this._extensionRegistry=u,this._instaService=s,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,u,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,u,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let u of c.nodeModuleName)this._factories.set(u,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(u=>c.alternativeModuleName(u))}};a=je([Ue(2,T.IInstantiationService),Ue(3,I.IExtHostConfiguration),Ue(4,k.IExtHostExtensionService),Ue(5,n.IExtHostInitDataService),Ue(6,g.ILogService)],a),e.RequireInterceptor=a;class h{constructor(c,u,s,t,i){this._apiFactory=c,this._extensionPaths=u,this._extensionRegistry=s,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,u){const s=this._extensionPaths.findSubstr(u.fsPath);if(s){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(s.identifier));return t||(t=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(s.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,o)=>t+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(c,u){this.nodeModuleName="keytar";const{environment:s}=u,t=c.getProxy(R.MainContext.MainThreadKeytar);if(s.appRoot){let i=s.appRoot.fsPath;_.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,o)=>t.$getPassword(i,o),setPassword:(i,o,r)=>t.$setPassword(i,o,r),deletePassword:(i,o)=>t.$deletePassword(i,o),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(c,u){return this._impl}alternativeModuleName(c){const u=c.length;if(!(u<=7||!this.alternativeNames)){const s=u-7;if((c.charAt(s)==="/"||c.charAt(s)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};S=je([Ue(0,y.IExtHostRpcService),Ue(1,n.IExtHostInitDataService)],S);let v=class{constructor(c,u,s){this._extensionPaths=c,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(R.MainContext.MainThreadTelemetry);const t=s.getProxy(R.MainContext.MainThreadWindow);this._impl=(i,o)=>{const r=A.URI.parse(i);return o?this.callOriginal(i,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,o)}}load(c,u,s){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=s(c),this._impl}callOriginal(c,u){return this.sendNoForwardTelemetry(),this._original(c,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Ue(2,y.IExtHostRpcService)],v)}),define(ge[259],pe([0,1,166,9,7,201,33,42,39,36,35,13,45,186,204,17]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends _.ExtHostDebugServiceBase{constructor(c,u,s,t,i,o){super(c,u,s,t,i);this._terminalService=o,this._integratedTerminalInstances=new v}createDebugAdapter(c,u){switch(c.type){case"server":return new I.SocketDebugAdapter(c);case"pipeServer":return new I.NamedPipeDebugAdapter(c);case"executable":return new I.ExecutableDebugAdapter(c,u.type)}return super.createDebugAdapter(c,u)}daExecutableFromPackage(c,u){const s=I.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),c.type);if(s)return new R.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new g.SignService}async $runInTerminal(c,u){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(m=>{this._integratedTerminalInstances.onTerminalClosed(m)}));const s=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,s),i=this._terminalService.getDefaultShellArgs(!0,s),o=JSON.stringify({shell:t,shellArgs:i});let r=await this._integratedTerminalInstances.checkout(o),l,f=!1;if(r)l=c.cwd;else{const m={shellPath:t,shellArgs:i,cwd:c.cwd,name:c.title||b.localize(0,null)};f=!0,r=this._terminalService.createTerminalFromOptions(m,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const p=await r.processId;f?await new Promise(m=>setTimeout(m,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):A.isWindows?r.sendText("cls"):r.sendText("clear"));const w=(0,a.prepareCommand)(t,c.args,l,c.env);r.sendText(w);const d=this.onDidTerminateDebugSession(m=>{m.id===u&&(this._integratedTerminalInstances.free(r),d.dispose())});return p}else if(c.kind==="external")return(0,a.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,u)}createVariableResolver(c,u,s){return new _.ExtHostVariableResolverService(c,u,s,this._workspaceService)}};S=je([Ue(0,k.IExtHostRpcService),Ue(1,D.IExtHostWorkspace),Ue(2,P.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,T.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(c){const s=[...this._terminalInstances.entries()].map(([t,i])=>(0,h.createCancelablePromise)(async o=>{if(i.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const r=Date.now();return i.lastUsedAt+v.minUseDelay>r||o.isCancellationRequested||i.config!==c?null:(i.lastUsedAt=r,t)}));return await(0,h.firstParallel)(s,t=>!!t)}insert(c,u){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:u})}free(c){const u=this._terminalInstances.get(c);u&&(u.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}v.minUseDelay=1e3}),define(ge[260],pe([0,1,8,2,77,33,45,39,36,35,13,27,65,11,12,62]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends _.ExtHostTaskBase{constructor(E,c,u,s,t,i,o,r){super(E,c,u,s,t,i,o,r);this.workspaceService=u,c.remote.isRemote&&c.remote.authority&&this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(E,c){const u=c;if(!c.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=_.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(s);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,c);return this._proxy.$executeTask(s).catch(()=>{}),i}else{const s=_.TaskDTO.from(c,E);if(s===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,c,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),c);return this._proxy.$executeTask(s).catch(()=>{}),t}}provideTasksInternal(E,c,u,s){const t=[];if(s)for(let i of s){this.checkDeprecation(i,u),(!i.definition||!E[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const o=_.TaskDTO.from(i,u.extension);o&&(t.push(o),_.CustomExecutionDTO.is(o.execution)&&c.push(this.addCustomExecution(o,i,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(E){return E}async getVariableResolver(E){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(E,this._editorService,c,this.workspaceService)}return this._variableResolver}async $resolveVariables(E,c){const u=A.URI.revive(E),s={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(i),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let l of c.variables)s.variables[l]=o.resolve(r,l);if(c.process!==void 0){let l;if(c.process.path!==void 0){l=c.process.path.split(b.delimiter);for(let f=0;f<l.length;f++)l[f]=o.resolve(r,l[f])}s.process=await R.win32.findExecutable(o.resolve(r,c.process.name),c.process.cwd!==void 0?o.resolve(r,c.process.cwd):void 0,l)}return s}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(E,c,u){return R.win32.findExecutable(E,c,u)}};S=je([Ue(0,T.IExtHostRpcService),Ue(1,k.IExtHostInitDataService),Ue(2,I.IExtHostWorkspace),Ue(3,P.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,a.ILogService),Ue(7,h.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(ge[261],pe([0,1,9,15,28,148,12,36,45,39,13,35,33,207,208]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let h=class extends k.BaseExtHostTerminalService{constructor(v,E,c,u,s){super(!0,v);this._extHostConfiguration=E,this._extHostWorkspace=c,this._extHostDocumentsAndEditors=u,this._logService=s,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(b.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,E,c){const u=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:v,shellPath:E,shellArgs:c},v);return this._terminals.push(u),u.create(E,c),u.value}createTerminalFromOptions(v,E){const c=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),v,v.name);return this._terminals.push(c),c.create((0,A.withNullAsUndefined)(v.shellPath),(0,A.withNullAsUndefined)(v.shellArgs),(0,A.withNullAsUndefined)(v.cwd),(0,A.withNullAsUndefined)(v.env),void 0,(0,A.withNullAsUndefined)(v.strictEnv),(0,A.withNullAsUndefined)(v.hideFromUser),(0,A.withNullAsUndefined)(E),!0),c.value}getDefaultShell(v,E){var c;const u=s=>{const t=E.getConfiguration(s.substr(0,s.lastIndexOf("."))).inspect(s.substr(s.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return g.getDefaultShell(u,this._isWorkspaceShellAllowed,(c=this._defaultShell)!==null&&c!==void 0?c:(0,I.getSystemShellSync)(b.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,E){const c=u=>{const s=E.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(s)};return g.getDefaultShellArgs(c,this._isWorkspaceShellAllowed,v,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),E=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(E||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const E=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(v,this._logService,E,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const E=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,E),args:this.getDefaultShellArgs(v,E)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};h=je([Ue(0,T.IExtHostRpcService),Ue(1,P.IExtHostConfiguration),Ue(2,_.IExtHostWorkspace),Ue(3,n.IExtHostDocumentsAndEditors),Ue(4,D.ILogService)],h),e.ExtHostTerminalService=h}),define(ge[262],pe([0,1,17,16,66,6,2,5,252,12,78,81,27,182,13,61,42,35]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(u,s,t,i){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new y.RPCProtocol(u,null,i);s=E._transform(s,o);const r=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());r.set(_.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},s)),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(o)),r.set(h.IURITransformerService,new h.URITransformerService(i)),r.set(S.IHostUtils,t);const l=new g.InstantiationService(r,!0),f=l.invokeFunction(m=>m.get(v.IExtHostTerminalService));this._disposables.add(f),this._logService=l.invokeFunction(m=>m.get(n.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",s),this._extensionService=l.invokeFunction(m=>m.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(C,L)=>{let B="",ee,H;for(const x of L)B+=`
	at ${x.toString()}`,H=x.getFileName(),!ee&&H&&(ee=m.findSubstr(H));return p.set(C,ee),`${C.name||"Error"}: ${C.message||""}${B}`}});const w=o.getProxy(P.MainContext.MainThreadExtensionService),d=o.getProxy(P.MainContext.MainThreadErrors);A.setUnexpectedErrorHandler(m=>{const C=A.transformErrorForSerialization(m),L=p.get(m);L?w.$onExtensionRuntimeError(L.identifier,C):d.$onUnexpectedError(C)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),A.setUnexpectedErrorHandler(t=>{});const s=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),s]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,s){u.extensions.forEach(i=>i.extensionLocation=D.URI.revive(s.transformIncomingURIs(i.extensionLocation))),u.environment.appRoot=D.URI.revive(s.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(i=>D.URI.revive(s.transformIncomingURIs(i)))),u.environment.extensionTestsLocationURI=D.URI.revive(s.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=D.URI.revive(s.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=D.URI.revive(s.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=D.URI.revive(s.transformIncomingURIs(u.logsLocation)),u.logFile=D.URI.revive(s.transformIncomingURIs(u.logFile)),u.workspace=s.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=E}),define(ge[263],pe([0,1,8,21,58,34,24,46,32,30]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(g,a,h){this.config=g,this.provider=a,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&I.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&I.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const a=this.config.folderQueries||[];return new Promise((h,S)=>{const v=E=>{this.resultCount++,g(E)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(E=>{const c=E.toString(),u=b.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,u)||this.matchFile(v,{base:E,basename:u})}),Promise.all(a.map(E=>this.searchInFolder(E,v))).then(E=>{h({limitHit:this.isLimitHit,stats:E[0]||void 0})},E=>{S(new Error((0,R.toErrorMessage)(E)))})})}searchInFolder(g,a){const h=new A.CancellationTokenSource;return new Promise((S,v)=>{const E=this.getSearchOptionsForFolder(g),c=this.initDirectoryTree(),u=new y.QueryGlobTester(this.config,g),s=!u.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(h),t=P.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},E,h.token))).then(i=>{const o=t.elapsed(),r=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(l=>{const f=b.posix.relative(g.folder.path,l.path);if(s){const p=b.basename(l.path);this.matchFile(a,{base:g.folder,relativePath:f,basename:p});return}this.addDirectoryEntries(c,g.folder,f,a)}),this.activeCancellationTokens.delete(h),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,u,a),{providerTime:o,postProcessTime:r.elapsed()})}).then(i=>{h.dispose(),S(i)},i=>{h.dispose(),v(i)})})}getSearchOptionsForFolder(g){const a=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),h=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:h,includes:a,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},a,h,S){if(h===this.filePattern){const E=b.basename(this.filePattern);this.matchFile(S,{base:a,relativePath:this.filePattern,basename:E})}function v(E){const c=b.basename(E),u=b.dirname(E);let s=g[u];s||(s=g[u]=[],v(u)),s.push({base:a,relativePath:E,basename:c})}v(h)}matchDirectoryTree({rootEntries:g,pathToEntries:a},h,S){const v=this,E=this.filePattern;function c(u){const s=I.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,i=u.length;t<i;t++){const o=u[t],{relativePath:r,basename:l}=o;if(!!h.includedInQuerySync(r,l,E!==l?s:void 0)){const f=a[r];if(f)c(f);else{if(r===E)continue;v.matchFile(S,o)}if(v.isLimitHit)break}}}c(g)}matchFile(g,a){(!this.includePattern||a.relativePath&&this.includePattern(a.relativePath,a.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(a))}}class k{constructor(){this.sessions=new Map}fileSearch(g,a,h,S){const v=this.getSessionTokenSource(g.cacheKey),E=new T(g,a,v&&v.token);let c=0;const u=s=>{c+=s.length,h(s.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(E,k.BATCH_SIZE,u,S).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:s.stats}}))}clearCache(g){const a=this.getSessionTokenSource(g);a&&a.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new A.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:D.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,a,h,S){S.onCancellationRequested(()=>{g.cancel()});const v=c=>{c&&(E.push(c),a>0&&E.length>=a&&(h(E),E=[]))};let E=[];return g.search(v).then(c=>(E.length&&h(E),c),c=>(E.length&&h(E),Promise.reject(c)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(ge[126],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class b{constructor(I,D){this.line=I,this.character=D}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,D){return new b(0,0)}with(I){return new b(0,0)}}e.Position=b;class A{constructor(I,D,P,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(I,D),this.end=new b(P,y)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new A(0,0,0,0)}with(I){return new A(0,0,0,0)}}e.Range=A}),define(ge[127],pe([0,1,8,14,21,58,24,34,2,32,30,11]),function(Z,e,b,A,R,I,D,P,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(c,u,s){this.query=c,this.provider=u,this.fileUtils=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,u){const s=this.query.folderQueries||[],t=new R.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((i,o)=>{this.collector=new a(c);let r=!1;const l=(f,p)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(f);S(f)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const d=this.resultSize(f);this.resultCount+=d,(d>0||!S(f))&&this.collector.add(f,p)}};Promise.all(s.map((f,p)=>this.searchInFolder(f,w=>l(w,p),t.token))).then(f=>{t.dispose(),this.collector.flush();const p=f.some(w=>!!w&&!!w.limitHit);i({limitHit:this.isLimitHit||p,stats:{type:"textSearchProvider"}})},f=>{t.dispose();const p=(0,I.toErrorMessage)(f);o(new Error(p))})})}resultSize(c){return S(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,u){const s=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:s.slice(0,u),preview:{matches:t.slice(0,u),text:c.preview.text},uri:c.uri}}searchInFolder(c,u,s){const t=new n.QueryGlobTester(this.query,c),i=[],o={report:l=>{if(!!this.validateProviderResult(l)){const f=c.folder.scheme===k.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,p=D.relativePath(c.folder,l.uri);p&&i.push(t.includedInQuery(p,b.basename(p),f).then(w=>{w&&u(l)}))}}},r=this.getSearchOptionsForFolder(c);return new Promise(l=>(0,T.nextTick)(l)).then(()=>this.provider.provideTextSearchResults(g(this.query.contentPattern),r,o,s)).then(l=>Promise.all(i).then(()=>l))}validateProviderResult(c){if(S(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const u=(0,n.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),s=(0,n.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:y.URI.from(c.folder),excludes:s,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=_;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class a{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,u=>this.sendItems(u))}add(c,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!D.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(h(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=a;function h(E){return S(E)?{preview:{matches:(0,A.mapArrayOrNot)(E.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:E.preview.text},ranges:(0,A.mapArrayOrNot)(E.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class v{constructor(c,u){this.maxBatchSize=c,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,u){!c||this.addItemToBatch(c,u)}addItems(c,u){!c||this.addItemsToBatch(c,u)}addItemToBatch(c,u){this.batch.push(c),this.batchSize+=u,this.onUpdate()}addItemsToBatch(c,u){this.batch=this.batch.concat(c),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,263,13,61,12,2,127]),function(Z,e,b,A,R,I,D,P,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(h,S,v){this.extHostRpc=h,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(A.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,S){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(h,S){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(h,S,v,E){const c=_(v),u=this._fileSearchProvider.get(h);if(u)return this._fileSearchManager.fileSearch(c,u,s=>{this._proxy.$handleFileMatch(h,S,s.map(t=>t.resource))},E);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,S,v,E){const c=this._textSearchProvider.get(h);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const u=_(v);return this.createTextSearchManager(u,c).search(t=>this._proxy.$handleTextMatch(h,S,t),E)}createTextSearchManager(h,S){return new T.TextSearchManager(h,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};k=je([Ue(0,D.IExtHostRpcService),Ue(1,P.IURITransformerService),Ue(2,y.ILogService)],k),e.ExtHostSearch=k;function _(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>n.URI.revive(h))})}e.reviveQuery=_;function g(a){return Object.assign(Object.assign({},a),{folder:n.URI.revive(a.folder)})}}),define(ge[264],pe([0,1,157,21,16,3,56,2,150,104,140,76,44,5,227,226,51,228,36,229,230,231,212,232,39,42,233,213,235,236,237,63,216,239,240,241,88,35,242,217,20,7,245,64,125,33,41,53,197,234,114,124,65,45,67,12,61,13,27,238,196,50,62,224,243,195,89,87,248,246,247,225,60,255,244,86,192,117]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c,u,s,t,i,o,r,l,f,p,w,d,m,C,L,B,ee,H,x,W,F,U,M,N,O,V,q,X,fe,ve,Ae,Ie,Fe,z,J,te,ae,he,De,Me,we,ke,Te,xe,Se,Ge,Q,ie,be,Oe,Ve,We,tt,K,se,de,Y,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function me(_e){const He=_e.get(Me.IExtHostInitDataService),$e=_e.get(K.IExtHostFileSystemInfo),Ke=_e.get(be.IExtHostConsumerFileSystem),Je=_e.get(r.IExtHostExtensionService),Ze=_e.get(q.IExtHostWorkspace),ut=_e.get(le.IExtHostTelemetry),lt=_e.get(E.IExtHostConfiguration),it=_e.get(he.IURITransformerService),qe=_e.get(De.IExtHostRpcService),Ee=_e.get(H.IExtHostStorage),Ce=_e.get(ie.IExtensionStoragePaths),ce=_e.get(ae.ILogService),G=_e.get(Te.IExtHostTunnelService),Ne=_e.get(xe.IExtHostApiDeprecationService),Re=_e.get(V.IExtHostWindow),et=_e.get(Y.IExtHostSecretState);qe.set(g.ExtHostContext.ExtHostFileSystemInfo,$e),qe.set(g.ExtHostContext.ExtHostLogService,ce),qe.set(g.ExtHostContext.ExtHostWorkspace,Ze),qe.set(g.ExtHostContext.ExtHostConfiguration,lt),qe.set(g.ExtHostContext.ExtHostExtensionService,Je),qe.set(g.ExtHostContext.ExtHostStorage,Ee),qe.set(g.ExtHostContext.ExtHostTunnelService,G),qe.set(g.ExtHostContext.ExtHostWindow,Re),qe.set(g.ExtHostContext.ExtHostSecretState,et),qe.set(g.ExtHostContext.ExtHostTelemetry,ut);const Qe=qe.set(g.ExtHostContext.ExtHostDecorations,_e.get(Fe.IExtHostDecorations)),at=qe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,_e.get(o.IExtHostDocumentsAndEditors)),rt=qe.set(g.ExtHostContext.ExtHostCommands,_e.get(S.IExtHostCommands)),Ye=qe.set(g.ExtHostContext.ExtHostTerminalService,_e.get(x.IExtHostTerminalService)),st=qe.set(g.ExtHostContext.ExtHostDebugService,_e.get(J.IExtHostDebugService)),vt=qe.set(g.ExtHostContext.ExtHostSearch,_e.get(te.IExtHostSearch)),mt=qe.set(g.ExtHostContext.ExtHostTask,_e.get(z.IExtHostTask)),Ct=qe.set(g.ExtHostContext.ExtHostOutputService,_e.get(m.IExtHostOutputService)),wt=qe.set(g.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=qe.set(g.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(qe)),pt=qe.set(g.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(qe,at)),Ft=qe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(qe,at,ce)),Mt=qe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ce,pt,qe.getProxy(g.MainContext.MainThreadBulkEdits))),ft=qe.set(g.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(qe,rt,at,pt,He.environment,ce,Ce)),yt=qe.set(g.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(qe,at)),jt=qe.set(g.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(qe.getProxy(g.MainContext.MainThreadTreeViews),rt,ce)),Qt=qe.set(g.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(qe.getProxy(g.MainContext.MainThreadEditorInsets),yt,He.environment)),Ot=qe.set(g.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(qe,ce)),ht=qe.set(g.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(qe,it,pt,rt,Ot,ce,Ne)),Xt=qe.set(g.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(qe,ht)),It=qe.set(g.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(qe,ce,at)),Ut=qe.set(g.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(qe,Ze,rt)),qt=qe.set(g.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(qe,rt,ce)),Jt=qe.set(g.ExtHostContext.ExtHostComments,new v.ExtHostComments(qe,rt,pt)),sn=qe.set(g.ExtHostContext.ExtHostProgress,new C.ExtHostProgress(qe.getProxy(g.MainContext.MainThreadProgress))),pn=qe.set(g.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(qe)),on=qe.set(g.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(qe)),Nt=qe.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(qe)),vn=qe.set(g.ExtHostContext.ExtHostTimeline,new Ge.ExtHostTimeline(qe,rt)),xt=qe.set(g.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(qe,He.environment,Ze,ce,Ne)),Wt=qe.set(g.ExtHostContext.ExtHostWebviewPanels,new We.ExtHostWebviewPanels(qe,xt,Ze)),wn=qe.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(qe,pt,Ce,xt,Wt)),_n=qe.set(g.ExtHostContext.ExtHostWebviewViews,new Oe.ExtHostWebviewViews(qe,xt)),Tt=qe.set(g.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(qe,at,Ze)),bn=qe.set(g.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(qe)),Kt=(0,fe.values)(g.ExtHostContext);qe.assertRegistered(Kt);const En=new tt.ExtHostBulkEdits(qe,at),Sn=new h.ExtHostClipboard(qe),$t=new d.ExtHostMessageService(qe,ce),an=new u.ExtHostDialogs(qe),ln=new ee.ExtHostStatusBar(qe,rt.converter),Bt=new w.ExtHostLanguages(qe,pt);return a.ExtHostApiCommands.register(rt),function(Le,Yt,Zt){const gt=function(){let re=!Le.isUnderDevelopment;function ue(Pe){re||(ce.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Pe(ct){if(Array.isArray(ct))ct.forEach(Pe);else if(typeof ct=="string")ue(ct);else{const bt=ct;typeof bt.scheme=="undefined"&&ue(ct),!Le.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,X.throwProposedApiError)(Le)}return ct}}(),yn={getSession(re,ue,Pe){return Nt.getSession(Le,re,ue,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(re,ue,Pe,ct){return Nt.registerAuthenticationProvider(re,ue,Pe,ct)},get onDidChangeAuthenticationProviders(){return(0,X.checkProposedApiEnabled)(Le),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,X.checkProposedApiEnabled)(Le),Nt.providers},logout(re,ue){return(0,X.checkProposedApiEnabled)(Le),Nt.removeSession(re,ue)}},Dn={registerCommand(re,ue,Pe){return rt.registerCommand(!0,re,ue,Pe)},registerTextEditorCommand(re,ue,Pe){return rt.registerCommand(!0,re,(...ct)=>{const bt=yt.getActiveTextEditor();if(!bt){ce.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Dt=>{ue.apply(Pe,[bt,Dt,...ct])}).then(Dt=>{Dt||ce.warn("Edits from command "+re+" were not applied.")},Dt=>{ce.warn("An error occurred while running command "+re,Dt)})})},registerDiffInformationCommand:(re,ue,Pe)=>((0,X.checkProposedApiEnabled)(Le),rt.registerCommand(!0,re,async(...ct)=>{const bt=at.activeEditor(!0);if(!bt){ce.warn("Cannot execute "+re+" because there is no active text editor.");return}const Dt=await yt.getDiffInformation(bt.id);ue.apply(Pe,[Dt,...ct])})),executeCommand(re,...ue){return rt.executeCommand(re,...ue)},getCommands(re=!1){return rt.getCommands(re)}},cn={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var re,ue;return(ue=(re=He.environment.appRoot)===null||re===void 0?void 0:re.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return Ye.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,ue){return Re.openUri(re,{allowTunneling:!!He.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(re){return re.scheme===He.environment.appUriScheme?St.createAppUri(re):Re.asExternalUri(re,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(cn);const un=He.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Cn={registerTestProvider(re){return(0,X.checkProposedApiEnabled)(Le),Tt.registerTestProvider(re)},createDocumentTestObserver(re){return(0,X.checkProposedApiEnabled)(Le),Tt.createTextDocumentTestObserver(re)},createWorkspaceTestObserver(re){return(0,X.checkProposedApiEnabled)(Le),Tt.createWorkspaceTestObserver(re)},runTests(re){return(0,X.checkProposedApiEnabled)(Le),Tt.runTests(re)},publishTestResult(re,ue=!0){return(0,X.checkProposedApiEnabled)(Le),Tt.publishExtensionProvidedResults(re,ue)},get onDidChangeTestResults(){return(0,X.checkProposedApiEnabled)(Le),Tt.onResultsChanged},get testResults(){return(0,X.checkProposedApiEnabled)(Le),Tt.results}},en={getExtension(re){const ue=Yt.getExtensionDescription(re);if(ue)return new r.Extension(Je,Le.identifier,ue,un)},get all(){return Yt.getAllExtensionDescriptions().map(re=>new r.Extension(Je,Le.identifier,re,un))},get onDidChange(){return Yt.onDidChange}},kn={createDiagnosticCollection(re){return Ot.createDiagnosticCollection(Le.identifier,re)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:re=>Ot.getDiagnostics(re),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(re,ue){return Bt.changeLanguage(re.uri,ue)},match(re,ue){return(0,k.score)(U.LanguageSelector.from(re),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(re,ue,Pe){return ht.registerCodeActionProvider(Le,gt(re),ue,Pe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(Le,gt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(Le,gt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(Le,gt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(Le,gt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(Le,gt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(Le,gt(re),ue,Le.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(Le,gt(re),ue,Le.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(Le,gt(re),ue,Le.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(Le,gt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(Le,gt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(Le,gt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(Le,gt(re),ue)},registerDocumentSymbolProvider(re,ue,Pe){return ht.registerDocumentSymbolProvider(Le,gt(re),ue,Pe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Le,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(Le,gt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(Le,gt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Pe,...ct){return ht.registerOnTypeFormattingEditProvider(Le,gt(re),ue,[Pe].concat(ct))},registerDocumentSemanticTokensProvider(re,ue,Pe){return ht.registerDocumentSemanticTokensProvider(Le,gt(re),ue,Pe)},registerDocumentRangeSemanticTokensProvider(re,ue,Pe){return ht.registerDocumentRangeSemanticTokensProvider(Le,gt(re),ue,Pe)},registerSignatureHelpProvider(re,ue,Pe,...ct){return typeof Pe=="object"?ht.registerSignatureHelpProvider(Le,gt(re),ue,Pe):ht.registerSignatureHelpProvider(Le,gt(re),ue,typeof Pe=="undefined"?[]:[Pe,...ct])},registerCompletionItemProvider(re,ue,...Pe){return ht.registerCompletionItemProvider(Le,gt(re),ue,Pe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(Le,gt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(Le,gt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(Le,gt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(Le,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(Le,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(Le,re,ue),getTokenInformationAtPosition(re,ue){return(0,X.checkProposedApiEnabled)(Le),Bt.tokenAtPosition(re,ue)},registerInlineHintsProvider(re,ue){return(0,X.checkProposedApiEnabled)(Le),ht.registerInlineHintsProvider(Le,re,ue)}},In={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return Ye.activeTerminal},get terminals(){return Ye.terminals},async showTextDocument(re,ue,Pe){const ct=await(P.URI.isUri(re)?Promise.resolve(dn.openTextDocument(re)):Promise.resolve(re));return yt.showTextDocument(ct,ue,Pe)},createTextEditorDecorationType(re){return yt.createTextEditorDecorationType(re)},onDidChangeActiveTextEditor(re,ue,Pe){return yt.onDidChangeActiveTextEditor(re,ue,Pe)},onDidChangeVisibleTextEditors(re,ue,Pe){return yt.onDidChangeVisibleTextEditors(re,ue,Pe)},onDidChangeTextEditorSelection(re,ue,Pe){return yt.onDidChangeTextEditorSelection(re,ue,Pe)},onDidChangeTextEditorOptions(re,ue,Pe){return yt.onDidChangeTextEditorOptions(re,ue,Pe)},onDidChangeTextEditorVisibleRanges(re,ue,Pe){return yt.onDidChangeTextEditorVisibleRanges(re,ue,Pe)},onDidChangeTextEditorViewColumn(re,ue,Pe){return yt.onDidChangeTextEditorViewColumn(re,ue,Pe)},onDidCloseTerminal(re,ue,Pe){return Ye.onDidCloseTerminal(re,ue,Pe)},onDidOpenTerminal(re,ue,Pe){return Ye.onDidOpenTerminal(re,ue,Pe)},onDidChangeActiveTerminal(re,ue,Pe){return Ye.onDidChangeActiveTerminal(re,ue,Pe)},onDidChangeTerminalDimensions(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),Ye.onDidChangeTerminalDimensions(re,ue,Pe)},onDidWriteTerminalData(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),Ye.onDidWriteTerminalData(re,ue,Pe)},get state(){return Re.state},onDidChangeWindowState(re,ue,Pe){return Re.onDidChangeWindowState(re,ue,Pe)},showInformationMessage(re,...ue){return $t.showMessage(Le,D.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return $t.showMessage(Le,D.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return $t.showMessage(Le,D.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Pe){return Ut.showQuickPick(re,!!Le.enableProposedApi,ue,Pe)},showWorkspaceFolderPick(re){return Ut.showWorkspaceFolderPick(re)},showInputBox(re,ue){return Ut.showInput(re,ue)},showOpenDialog(re){return an.showOpenDialog(re)},showSaveDialog(re){return an.showSaveDialog(re)},createStatusBarItem(re,ue){let Pe,ct,bt,Dt;return re&&typeof re!="number"?(Pe=re.id,ct=re.name,bt=re.alignment,ue=re.priority,Dt=re.accessibilityInformation):(Pe=Le.identifier.value,ct=b.localize(0,null,Le.displayName||Le.name),bt=re),ln.createStatusBarEntry(Pe,ct,bt,ue,Dt)},setStatusBarMessage(re,ue){return ln.setStatusBarMessage(re,ue)},withScmProgress(re){return Ne.report("window.withScmProgress",Le,"Use 'withProgress' instead."),sn.withProgress(Le,{location:M.ProgressLocation.SourceControl},(ue,Pe)=>re({report(ct){}}))},withProgress(re,ue){return sn.withProgress(Le,re,ue)},createOutputChannel(re){return Ct.createOutputChannel(re)},createWebviewPanel(re,ue,Pe,ct){return Wt.createWebviewPanel(Le,re,ue,Pe,ct)},createWebviewTextEditorInset(re,ue,Pe,ct){return(0,X.checkProposedApiEnabled)(Le),Qt.createWebviewEditorInset(re,ue,Pe,ct,Le)},createTerminal(re,ue,Pe){return typeof re=="object"?"pty"in re?Ye.createExtensionTerminal(re):Ye.createTerminalFromOptions(re):Ye.createTerminal(re,ue,Pe)},registerTerminalLinkProvider(re){return Ye.registerLinkProvider(re)},registerTreeDataProvider(re,ue){return jt.registerTreeDataProvider(re,ue,Le)},createTreeView(re,ue){return jt.createTreeView(re,ue,Le)},registerWebviewPanelSerializer:(re,ue)=>Wt.registerWebviewPanelSerializer(Le,re,ue),registerCustomEditorProvider:(re,ue,Pe={})=>wn.registerCustomEditorProvider(Le,re,ue,Pe),registerFileDecorationProvider(re){return Qe.registerFileDecorationProvider(re,Le.identifier)},registerUriHandler(re){return St.registerUriHandler(Le.identifier,re)},createQuickPick(){return Ut.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Ut.createInputBox(Le.identifier)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Pe){return on.onDidChangeActiveColorTheme(re,ue,Pe)},registerWebviewViewProvider(re,ue,Pe){return _n.registerWebviewViewProvider(Le,re,ue,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,X.checkProposedApiEnabled)(Le),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookEditor(re,ue,Pe)},get visibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Le),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorSelection(re,ue,Pe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorVisibleRanges(re,ue,Pe)},showNotebookDocument(re,ue){return(0,X.checkProposedApiEnabled)(Le),ft.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),bn.registerExternalUriOpener(Le.identifier,re,ue,Pe)},get openEditors(){return(0,X.checkProposedApiEnabled)(Le),wt.tabs},get onDidChangeOpenEditors(){return(0,X.checkProposedApiEnabled)(Le),wt.onDidChangeTabs}},dn={get rootPath(){return Ne.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(re){throw R.readonly()},getWorkspaceFolder(re){return Ze.getWorkspaceFolder(re)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(re){throw R.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(re){throw R.readonly()},updateWorkspaceFolders:(re,ue,...Pe)=>Ze.updateWorkspaceFolders(Le,re,ue||0,...Pe),onDidChangeWorkspaceFolders:function(re,ue,Pe){return Ze.onDidChangeWorkspace(re,ue,Pe)},asRelativePath:(re,ue)=>Ze.getRelativePath(re,ue),findFiles:(re,ue,Pe,ct)=>Ze.findFiles(U.GlobPattern.from(re),U.GlobPattern.from(ue),Pe,Le.identifier,ct),findTextInFiles:(re,ue,Pe,ct)=>{let bt,Dt;return typeof ue=="object"?(bt=ue,Dt=Pe):(bt={},Dt=ue,ct=Pe),Ze.findTextInFiles(re,bt||{},Dt,Le.identifier,ct)},saveAll:re=>Ze.saveAll(re),applyEdit(re){return En.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,ue,Pe,ct)=>It.createFileSystemWatcher(U.GlobPattern.from(re),ue,Pe,ct),get textDocuments(){return pt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw R.readonly()},openTextDocument(re){let ue;const Pe=re;if(typeof re=="string")ue=Promise.resolve(P.URI.file(re));else if(P.URI.isUri(re))ue=Promise.resolve(re);else if(!Pe||typeof Pe=="object")ue=pt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ct=>pt.ensureDocumentData(ct).then(bt=>bt.document))},onDidOpenTextDocument:(re,ue,Pe)=>pt.onDidAddDocument(re,ue,Pe),onDidCloseTextDocument:(re,ue,Pe)=>pt.onDidRemoveDocument(re,ue,Pe),onDidChangeTextDocument:(re,ue,Pe)=>pt.onDidChangeDocument(re,ue,Pe),onDidSaveTextDocument:(re,ue,Pe)=>pt.onDidSaveDocument(re,ue,Pe),onWillSaveTextDocument:(re,ue,Pe)=>Mt.getOnWillSaveTextDocumentEvent(Le)(re,ue,Pe),onDidChangeConfiguration:(re,ue,Pe)=>Zt.onDidChangeConfiguration(re,ue,Pe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,Zt.getConfiguration(re,ue,Le)},registerTextDocumentContentProvider(re,ue){return Ft.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Ne.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Le,re,ue)),registerFileSystemProvider(re,ue,Pe){return Xt.registerFileSystemProvider(Le.identifier,re,ue,Pe)},get fs(){return Ke.value},registerFileSearchProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),vt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),vt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),Je.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,X.checkProposedApiEnabled)(Le),pn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,ue,Pe)=>It.onDidCreateFile(re,ue,Pe),onDidDeleteFiles:(re,ue,Pe)=>It.onDidDeleteFile(re,ue,Pe),onDidRenameFiles:(re,ue,Pe)=>It.onDidRenameFile(re,ue,Pe),onWillCreateFiles:(re,ue,Pe)=>It.getOnWillCreateFileEvent(Le)(re,ue,Pe),onWillDeleteFiles:(re,ue,Pe)=>It.getOnWillDeleteFileEvent(Le)(re,ue,Pe),onWillRenameFiles:(re,ue,Pe)=>It.getOnWillRenameFileEvent(Le)(re,ue,Pe),openTunnel:re=>((0,X.checkProposedApiEnabled)(Le),G.openTunnel(Le,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,X.checkProposedApiEnabled)(Le),G.getTunnels()},onDidChangeTunnels:(re,ue,Pe)=>((0,X.checkProposedApiEnabled)(Le),G.onDidChangeTunnels(re,ue,Pe)),registerPortAttributesProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),G.registerPortsAttributesProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),vn.registerTimelineProvider(re,ue,Le.identifier,rt.converter)),get trustState(){return(0,X.checkProposedApiEnabled)(Le),(0,X.checkRequiresWorkspaceTrust)(Le),Ze.trustState},requireWorkspaceTrust:re=>((0,X.checkProposedApiEnabled)(Le),(0,X.checkRequiresWorkspaceTrust)(Le),Ze.requireWorkspaceTrust(re)),onDidChangeWorkspaceTrustState:(re,ue,Pe)=>Ze.onDidChangeWorkspaceTrustState(re,ue,Pe)},Pn={get inputBox(){return Ne.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Le)},createSourceControl(re,ue,Pe){return qt.createSourceControl(Le,re,ue,Pe)}},An={createCommentController(re,ue){return Jt.createCommentController(Le,re,ue)}},hn={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(re,ue,Pe){return st.onDidStartDebugSession(re,ue,Pe)},onDidTerminateDebugSession(re,ue,Pe){return st.onDidTerminateDebugSession(re,ue,Pe)},onDidChangeActiveDebugSession(re,ue,Pe){return st.onDidChangeActiveDebugSession(re,ue,Pe)},onDidReceiveDebugSessionCustomEvent(re,ue,Pe){return st.onDidReceiveDebugSessionCustomEvent(re,ue,Pe)},onDidChangeBreakpoints(re,ue,Pe){return st.onDidChangeBreakpoints(re,ue,Pe)},registerDebugConfigurationProvider(re,ue,Pe){return st.registerDebugConfigurationProvider(re,ue,Pe||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return st.registerDebugAdapterDescriptorFactory(Le,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return st.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?st.startDebugging(re,ue,{parentSession:Pe}):st.startDebugging(re,ue,Pe||{})},stopDebugging(re){return st.stopDebugging(re)},addBreakpoints(re){return st.addBreakpoints(re)},removeBreakpoints(re){return st.removeBreakpoints(re)},asDebugSourceUri(re,ue){return st.asDebugSourceUri(re,ue)}},Gt={registerTaskProvider:(re,ue)=>mt.registerTaskProvider(Le,re,ue),fetchTasks:re=>mt.fetchTasks(re),executeTask:re=>mt.executeTask(Le,re),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(re,ue,Pe)=>mt.onDidStartTask(re,ue,Pe),onDidEndTask:(re,ue,Pe)=>mt.onDidEndTask(re,ue,Pe),onDidStartTaskProcess:(re,ue,Pe)=>mt.onDidStartTaskProcess(re,ue,Pe),onDidEndTaskProcess:(re,ue,Pe)=>mt.onDidEndTaskProcess(re,ue,Pe)},fn={openNotebookDocument:re=>((0,X.checkProposedApiEnabled)(Le),ft.openNotebookDocument(re)),get onDidOpenNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,X.checkProposedApiEnabled)(Le),ft.notebookDocuments.map(re=>re.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.registerNotebookSerializer(Le,re,ue,Pe)},registerNotebookContentProvider:(re,ue,Pe)=>((0,X.checkProposedApiEnabled)(Le),ft.registerNotebookContentProvider(Le,re,ue,Pe)),registerNotebookKernelProvider:(re,ue)=>((0,X.checkProposedApiEnabled)(Le),ft.registerNotebookKernelProvider(Le,re,ue)),createNotebookEditorDecorationType(re){return(0,X.checkProposedApiEnabled)(Le),ft.createNotebookEditorDecorationType(re)},onDidChangeNotebookDocumentMetadata(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookDocumentMetadata(re,ue,Pe)},onDidChangeNotebookCells(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCells(re,ue,Pe)},onDidChangeCellExecutionState(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCellExecutionState(re,ue,Pe)},onDidChangeCellOutputs(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeCellOutputs(re,ue,Pe)},onDidChangeCellMetadata(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeCellMetadata(re,ue,Pe)},createConcatTextDocument(re,ue){return(0,X.checkProposedApiEnabled)(Le),new Q.ExtHostNotebookConcatDocument(ft,pt,re,ue)},createCellStatusBarItem(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.createNotebookCellStatusBarItemInternal(re,ue,Pe)},createNotebookCellExecutionTask(re,ue,Pe){return(0,X.checkProposedApiEnabled)(Le),ft.createNotebookCellExecution(re,ue,Pe)}};return{version:He.version,authentication:yn,commands:Dn,comments:An,debug:hn,env:cn,extensions:en,languages:kn,notebook:fn,scm:Pn,tasks:Gt,test:Cn,window:In,workspace:dn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:A.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:_.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:T.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestState:M.TestState,TestResult:M.TestResult,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=me}),define(ge[265],pe([0,1,78,63,33,124,36,51,39,35,65,45,67,89,88,50,62,125,87,60,86,117]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E,c,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,b.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,b.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,b.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,b.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,b.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,b.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,b.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,b.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService),(0,b.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,b.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,b.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,b.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,b.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,b.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,b.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,b.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,b.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry)}),define(ge[90],pe([0,1,14,12,32,126]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=D;function P(k,_,g,a){const h=(0,b.mapArrayOrNot)(g,y),S=new R.TextSearchMatch(_,h,a),v=S.preview.matches;return{ranges:(0,b.mapArrayOrNot)(h,n),uri:k,preview:{text:S.preview.text,matches:(0,b.mapArrayOrNot)(v,n)}}}e.createTextSearchResult=P;function y(k){return new R.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function n(k){return new I.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(_,g){this.prefix=_,this.logService=g}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};T=je([Ue(1,A.ILogService)],T),e.OutputChannel=T}),define(ge[266],pe([0,1,91,25]),function(Z,e,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,D=512,P=512*8,y=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let o;if(i!==e.UTF8)o=(await new Promise((l,f)=>{Z(["iconv-lite-umd"],l,f)})).getDecoder(g(i));else{const r=new TextDecoder;o={write(l){return r.decode(l,{stream:!0})},end(){return r.decode()}}}return new n(o)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function T(t,i){var o;const r=((o=i.minBytesRequiredForDetection)!==null&&o!==void 0?o:i.guessEncoding)?P:D;return new Promise((l,f)=>{const p=(0,b.newWriteableStream)(L=>L.join("")),w=[];let d=0,m;const C=async()=>{try{const L=await s({buffer:A.VSBuffer.concat(w),bytesRead:d},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),m=await n.create(L.encoding);const B=m.write(A.VSBuffer.concat(w).buffer);p.write(B),w.length=0,d=0,l({stream:p,detected:L})}catch(L){f(L)}};(0,b.listenStream)(t,{onData:async L=>{m?p.write(m.write(L.buffer)):(w.push(L),d+=L.byteLength,d>=r&&(t.pause(),await C(),setTimeout(()=>t.resume())))},onError:L=>p.error(L),onEnd:async()=>{m||await C(),p.end(m==null?void 0:m.end())}})})}e.toDecodeStream=T;async function k(t,i,o){const l=(await new Promise((w,d)=>{Z(["iconv-lite-umd"],w,d)})).getEncoder(g(i),o);let f=!1,p=!1;return{read(){if(p)return null;const w=t.read();if(typeof w!="string"){if(p=!0,!f&&(o==null?void 0:o.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=l.end();return d&&d.length>0?(f=!0,A.VSBuffer.wrap(d)):null}return f=!0,A.VSBuffer.wrap(l.write(w))}}}e.toEncodeReadable=k;async function _(t){return(await new Promise((o,r)=>{Z(["iconv-lite-umd"],o,r)})).encodingExists(g(t))}e.encodingExists=_;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function a(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const h=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((p,w)=>{Z(["jschardet"],p,w)}),o=t.slice(0,y),r=c(o.buffer),l=i.detect(r);if(!l||!l.encoding)return null;const f=l.encoding.toLowerCase();return 0<=h.indexOf(f)?null:E(l.encoding)}const v={ibm866:"cp866",big5:"cp950"};function E(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[i]||i}function c(t){let i="";for(let o=0;o<t.length;o++)i+=String.fromCharCode(t[o]);return i}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=u;function s({buffer:t,bytesRead:i},o){let r=a(t,i),l=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let f=!0,p=!0,w=!1;for(let d=0;d<i&&d<I;d++){const m=d%2==1,C=t.readUInt8(d)===0;if(C&&(w=!0),f&&(m&&!C||!m&&C)&&(f=!1),p&&(m&&C||!m&&!C)&&(p=!1),C&&!f&&!p)break}w&&(f?r=e.UTF16le:p?r=e.UTF16be:l=!0)}return o&&!l&&!r&&t?S(t.slice(0,i)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:l,encoding:r}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],pe([0,1,266,26,127]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends R.TextSearchManager{constructor(P,y,n=A){super(P,y,{readdir:T=>n.readdir(T.fsPath),toCanonicalName:T=>(0,b.toCanonicalName)(T)})}}e.NativeTextSearchManager=I}),define(ge[267],pe([0,1,268,282,283,2,284]),function(Z,e,b,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,_,g,a,h,S){const v=S.environment.useHostProxy,E=typeof v=="boolean"?v:!S.remote.isRemote,c=(0,D.createProxyResolver)({resolveProxy:s=>k.resolveProxy(s),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(s,t,...i)=>{switch(s){case D.LogLevel.Trace:a.trace(t,...i);break;case D.LogLevel.Debug:a.debug(t,...i);break;case D.LogLevel.Info:a.info(t,...i);break;case D.LogLevel.Warning:a.warn(t,...i);break;case D.LogLevel.Error:a.error(t,...i);break;case D.LogLevel.Critical:a.critical(t,...i);break;case D.LogLevel.Off:break;default:o(s,t,i);break}function o(r,l,...f){a.error("Unknown log level",r),a.error(l,...f)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:s=>{h.$publicLog2("resolveProxy",s)},useHostProxy:E,env:process.env}),u=y(_,c);return T(g,u)}e.connectProxyResolver=P;function y(k,_){const g={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(h=>{g.config=k.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(h=>{a.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,D.createHttpPatch)(b,_,{config:"off"},a,!0)),on:Object.assign({},b,(0,D.createHttpPatch)(b,_,{config:"on"},a,!0)),override:Object.assign({},b,(0,D.createHttpPatch)(b,_,{config:"override"},a,!0)),onRequest:Object.assign({},b,(0,D.createHttpPatch)(b,_,g,a,!0)),default:Object.assign(b,(0,D.createHttpPatch)(b,_,g,a,!1))},https:{off:Object.assign({},A,(0,D.createHttpPatch)(A,_,{config:"off"},a,!0)),on:Object.assign({},A,(0,D.createHttpPatch)(A,_,{config:"on"},a,!0)),override:Object.assign({},A,(0,D.createHttpPatch)(A,_,{config:"override"},a,!0)),onRequest:Object.assign({},A,(0,D.createHttpPatch)(A,_,g,a,!0)),default:Object.assign(A,(0,D.createHttpPatch)(A,_,g,a,!1))},tls:Object.assign(R,(0,D.createTlsPatch)(R))}}const n=new Map;function T(k,_){return k.getExtensionPathIndex().then(g=>{const a=Z.__$__nodeRequire("module"),h=a._load;a._load=function(v,E,c){if(v==="tls")return _.tls;if(v!=="http"&&v!=="https")return h.apply(this,arguments);const u=_[v],s=g.findSubstr(I.URI.file(E.filename).fsPath);let t=n.get(s);if(t||n.set(s,t={}),!t[v]){let i=u.default;s&&s.enableProposedApi&&(i=u[s.proxySupport]||u.onRequest),t[v]=Object.assign({},i)}return t[v]}})}}),define(ge[269],pe([0,1,38,8,74,31,9,10,90,270]),function(Z,e,b,A,R,I,D,P,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,u,s,t){const i=_(c,u,s,t),o=u.folder.fsPath;return{cmd:b.spawn(T,i.args,{cwd:o}),rgDiskPath:T,siblingClauses:i.siblingClauses,rgArgs:i,cwd:o}}e.spawnRipgrepCmd=k;function _(c,u,s,t){const i=["--files","--hidden","--case-sensitive"];a([u],s,!1).forEach(r=>{const l=(0,y.anchorGlob)(r);if(i.push("-g",l),D.isMacintosh){const f=(0,R.normalizeNFD)(l);f!==l&&i.push("-g",f)}});const o=g([u],t,void 0,!1);return o.globArgs.forEach(r=>{const l=`!${(0,y.anchorGlob)(r)}`;if(i.push("-g",l),D.isMacintosh){const f=(0,R.normalizeNFD)(l);f!==l&&i.push("-g",f)}}),u.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),u.ignoreSymlinks||i.push("--follow"),c.exists&&i.push("--quiet"),i.push("--no-config"),u.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:o.siblingClauses}}function g(c,u,s,t=!0){const i=[];let o={};return c.forEach(r=>{const l=Object.assign({},r.excludePattern||{},u||{}),f=h(l,t?r.folder.fsPath:void 0,s);i.push(...f.globArgs),f.siblingClauses&&(o=Object.assign(o,f.siblingClauses))}),{globArgs:i,siblingClauses:o}}e.foldersToRgExcludeGlobs=g;function a(c,u,s=!0){const t=[];return c.forEach(i=>{const o=Object.assign({},u||{},i.includePattern||{}),r=h(o,s?i.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function h(c,u,s){const t=[],i={};return Object.keys(c).forEach(o=>{if(!(s&&s.has(o))&&!!o){const r=c[o];o=v(u?S(u,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(E(o))):r&&r.when&&(i[o]=r)}}),{globArgs:t,siblingClauses:i}}function S(c,u){return A.isAbsolute(u)?u:A.join(c,u)}e.getAbsoluteGlob=S;function v(c){return c=P.rtrim(c,"\\"),P.rtrim(c,"/")}function E(c){return I.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=E}),define(ge[271],pe([0,1,38,37,8,98,14,58,34,74,31,9,46,10,15,26,32,269,96]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(o=>o())});class u{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(l=>{const f=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),p=l.folder.fsPath;r.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==p).forEach(w=>{(0,T.isEqualOrParent)(w,p)&&(f[R.relative(p,w)]=!0)}),this.folderExcludePatterns.set(p,new t(f,p))})}cancel(){this.isCanceled=!0}walk(r,l,f,p,w){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);l.forEach(d=>{const m=R.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,m)||this.matchFile(f,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(r,(d,m)=>{this.call(this.cmdTraversal,this,d,f,p,C=>{if(C){const L=(0,P.toErrorMessage)(C);console.error(L),this.errors.push(L),m(C,void 0)}else m(null,void 0)})},(d,m)=>{this.fileWalkSW.stop();const C=d?D.coalesce(d)[0]:null;w(C,this.isLimitHit)})}parallel(r,l,f){const p=new Array(r.length),w=new Array(r.length);let d=!1,m=0;if(r.length===0)return f(null,[]);r.forEach((C,L)=>{l(C,(B,ee)=>{if(B?(d=!0,p[L]=null,w[L]=B):(p[L]=ee,w[L]=null),++m===r.length)return f(d?w:null,p)})})}call(r,l,...f){try{r.apply(l,f)}catch(p){f[f.length-1](p)}}cmdTraversal(r,l,f,p){const w=r.folder.fsPath,d=k.isMacintosh;let m;const C=()=>m&&m.kill();c.add(C);let L=U=>{c.delete(C),L=()=>{},p(U)},B="";const ee=this.initDirectoryTree();let H;const x=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);m=x.cmd,H=!Object.keys(x.siblingClauses).length;const W=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${W}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),f({message:F}),this.cmdResultCount=0,this.collectStdout(m,"utf8",f,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(B+(d?n.normalizeNFC(M||""):M)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else B=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,H){for(const q of V)if(this.matchFile(l,{base:w,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){C();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ee,w,V,l),N&&(this.matchDirectoryTree(ee,w,l),L())})}spawnFindCmd(r){const l=this.folderExcludePatterns.get(r.folder.fsPath),f=l.getBasenameTerms(),p=l.getPathTerms(),w=["-L","."];if(f.length||p.length){w.push("-not","(","(");for(const d of f)w.push("-name",d),w.push("-o");for(const d of p)w.push("-path",d),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),b.spawn("find",w,{cwd:r.folder.fsPath})}readStdout(r,l,f){let p="";this.collectStdout(r,l,()=>{},(w,d,m)=>{if(w){f(w);return}p+=d,m&&f(null,p)})}collectStdout(r,l,f,p){let w=(C,L,B)=>{(C||B)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),p(C,L,B)},d=!1;r.stdout?(this.forwardData(r.stdout,l,w),r.stdout.once("data",()=>d=!0)):f({message:"stdout is null"});let m;r.stderr?m=this.collectData(r.stderr):f({message:"stderr is null"}),r.on("error",C=>{w(C)}),r.on("close",C=>{let L;!d&&(L=this.decodeData(m,l))&&i(L)?w(new Error(`command failed with error code ${C}: ${this.decodeData(m,l)}`)):(this.exists&&C===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(r,l,f){const p=new I.StringDecoder(l);return r.on("data",w=>{f(null,p.write(w))}),p}collectData(r){const l=[];return r.on("data",f=>{l.push(f)}),l}decodeData(r,l){const f=new I.StringDecoder(l);return r.map(p=>f.write(p)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:l},f,p,w){p.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const d=m=>{const C=R.basename(m),L=R.dirname(m);let B=l[L];B||(B=l[L]=[],d(L)),B.push({base:f,relativePath:m,basename:C,searchPath:this.getSearchPath(r,m)})};p.forEach(d)}matchDirectoryTree({rootEntries:r,pathToEntries:l},f,p){const w=this,d=this.folderExcludePatterns.get(f),m=this.filePattern;function C(L){w.directoriesWalked++;const B=y.hasSiblingFn(()=>L.map(ee=>ee.basename));for(let ee=0,H=L.length;ee<H;ee++){const x=L[ee],{relativePath:W,basename:F}=x;if(!d.test(W,F,m!==F?B:void 0)){const U=l[W];if(U)C(U);else{if(w.filesWalked++,W===m)continue;w.matchFile(p,x)}if(w.isLimitHit)break}}}C(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,l,f,p,w){const d=r.folder,m=y.hasSiblingFn(()=>f);this.parallel(f,(C,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const B=l?[l,C].join(R.sep):C;if(this.folderExcludePatterns.get(r.folder.fsPath).test(B,C,this.config.filePattern!==C?m:void 0))return L(null);const ee=[d.fsPath,B].join(R.sep);A.lstat(ee,(H,x)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ee,x,(W,F)=>W||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,h.readdir)(ee).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,B,N,p,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&a.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(p,{base:d.fsPath,relativePath:B,searchPath:this.getSearchPath(r,B)}),L(null,void 0)))})},C=>{const L=C&&D.coalesce(C);return w(L&&L.length>0?L[0]:void 0)})}matchFile(r,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,R.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(l))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,l,f){return l.isSymbolicLink()?A.stat(r,f):f(null,l)}realPathIfNeeded(r,l,f){return l.isSymbolicLink()?A.realpath(r,(p,w)=>p?f(p):f(null,w)):f(null,r)}getSearchPath(r,l){return r.folderName?R.join(r.folderName,l):l}}e.FileWalker=u;class s{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new u(r)}search(r,l,f){this.walker.walk(this.folderQueries,this.extraFiles,r,l,(p,w)=>{f(p,{limitHit:w,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=s;class t{constructor(r,l){this.expression=r,this.root=l,this.init(r)}init(r){let l,f;Object.keys(r).filter(p=>r[p]).forEach(p=>{R.isAbsolute(p)?(l=l||y.getEmptyExpression(),l[p]=r[p]):(f=f||y.getEmptyExpression(),f[p]=r[p])}),this.absoluteParsedExpr=l&&y.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=f&&y.parse(f,{trimForExclusions:!0})}test(r,l,f){return this.relativeParsedExpr&&this.relativeParsedExpr(r,l,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,r),l,f)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function i(o){const r=o.trim().split(`
`),l=r[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=i}),define(ge[129],pe([0,1,38,285,98,14,53,34,8,10,2,32,126,286,270,90]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(d){this.outputChannel=d}provideTextSearchResults(d,m,C,L){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify(Object.assign(Object.assign({},m),{folder:m.folder.toString()}))}`),new Promise((B,ee)=>{L.onCancellationRequested(()=>O());const H=i(d,m),x=m.folder.fsPath,W=H.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${S} ${W}
 - cwd: ${x}`);let F=b.spawn(S,H,{cwd:x});F.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ee((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const M=new u(m.maxResults,x,m.previewOptions);M.on("result",ve=>{U=!0,q="",C.report(ve)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let V=!1;M.on("hitLimit",()=>{V=!0,O()});let q="";F.stdout.on("data",ve=>{M.handleData(ve),U||(q+=ve)});let X=!1;F.stdout.once("data",()=>X=!0);let fe="";F.stderr.on("data",ve=>{const Ae=ve.toString();this.outputChannel.appendLine(Ae),fe+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)B({limitHit:V});else{M.flush(),F=null;let ve;fe&&!X&&(ve=E(fe))?ee((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):B({limitHit:V})}})})}}e.RipgrepTextSearchEngine=v;function E(w){const d=w.split(`
`),m=d[0].trim();if(d.some(L=>L.startsWith("regex parse error")))return new k.SearchError(c(d),k.SearchErrorCode.regexParseError);const C=m.match(/grep config error: unknown encoding: (.*)/);if(C)return new k.SearchError(`Unknown encoding: ${C[1]}`,k.SearchErrorCode.unknownEncoding);if(m.startsWith("error parsing glob"))return new k.SearchError(m.charAt(0).toUpperCase()+m.substr(1),k.SearchErrorCode.globParseError);if(m.startsWith("the literal"))return new k.SearchError(m.charAt(0).toUpperCase()+m.substr(1),k.SearchErrorCode.invalidLiteral);if(m.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(m,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function c(w){const d=["Regex parse error"],m=w.filter(C=>C.startsWith("PCRE2:"));if(m.length>=1){const C=m[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const L=C.split(":")[1];d.push(":"+L)}}return d.join("")}e.buildRegexParseError=c;class u extends A.EventEmitter{constructor(d,m,C){super();this.maxResults=d,this.rootFolder=m,this.previewOptions=C,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,m){return super.on(d,m),this}handleData(d){if(!this.isDone){const m=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(m)}}handleDecodedData(d){let m=d.indexOf(`
`);const C=this.remainder+d;if(m>=0)m+=this.remainder.length;else{this.remainder=C;return}let L=0;for(;m>=0;)this.handleLine(C.substring(L,m).trim()),L=m+1,m=C.indexOf(`
`,L);this.remainder=C.substring(L)}handleLine(d){if(!(this.isDone||!d)){let m;try{m=JSON.parse(d)}catch(C){throw new Error(`malformed line from rg: ${d}`)}if(m.type==="match"){const C=s(m.data.path),L=T.URI.file(y.join(this.rootFolder,C)),B=this.createTextSearchMatch(m.data,L);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(m.type==="context"){const C=s(m.data.path),L=T.URI.file(y.join(this.rootFolder,C));this.createTextSearchContext(m.data,L).forEach(ee=>this.onResult(ee))}}}createTextSearchMatch(d,m){const C=d.line_number-1;let L=!1,B=s(d.lines);C===0&&(0,n.startsWithUTF8BOM)(B)&&(L=!0,B=(0,n.stripUTF8BOM)(B));const ee=Buffer.from(B);let H=0,x=0,W=C;d.submatches.length===0&&d.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,I.coalesce)(d.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=s(U.match);C===0&&M===0&&L&&(N=(0,n.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=ee.slice(H,U.start).toString().length,V=x+O,q=t(N),X=W,fe=q.numLines+X,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return H=U.end,x=ve,W=fe,new _.Range(X,V,fe,ve)}));return(0,h.createTextSearchResult)(m,B,F,this.previewOptions)}createTextSearchContext(d,m){const C=s(d.lines),L=d.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((B,ee)=>({text:B,uri:m,lineNumber:L+ee}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=u;function s(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const d=/\n/g;let m=0,C=-1,L;for(;L=d.exec(w);)m++,C=L.index;const B=C>=0?w.length-C-1:w.length;return{numLines:m,lastLineLength:B}}function i(w,d){const m=["--hidden"];m.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:L}=(0,D.groupBy)(d.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ee=new Set;L.forEach(H=>{ee.add(H)}),m.push("-g","!*"),ee.forEach(H=>{o(H).map(h.anchorGlob).forEach(x=>{m.push("-g",x)})})}C&&C.length&&C.forEach(ee=>{m.push("-g",ee)}),d.excludes.map(h.anchorGlob).forEach(ee=>m.push("-g",`!${ee}`)),d.maxFileSize&&m.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?m.push("--no-ignore-parent"):m.push("--no-ignore"),d.followSymlinks&&m.push("--follow"),d.encoding&&d.encoding!=="utf8"&&m.push("--encoding",d.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,n.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),d.usePCRE2&&m.push("--pcre2"),m.push("--crlf"),w.isRegExp&&(w.pattern=r(w.pattern),m.push("--auto-hybrid-regex"));let B;if(w.isWordMatch){const H=(0,n.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");m.push("--regexp",H)}else if(w.isRegExp){let ee=f(w.pattern);ee=p(ee),m.push("--regexp",ee)}else B=w.pattern,m.push("--fixed-strings");return m.push("--no-config"),d.useGlobalIgnoreFiles||m.push("--no-ignore-global"),m.push("--json"),w.isMultiline&&m.push("--multiline"),d.beforeContext&&m.push("--before-context",d.beforeContext+""),d.afterContext&&m.push("--after-context",d.afterContext+""),m.push("--"),B&&m.push(B),m.push("."),m}function o(w){const d=(0,P.splitGlobAware)(w,"/");return d.map((m,C)=>d.slice(0,C+1).join("/"))}e.spreadGlobComponents=o;function r(w){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(d);)w=w.replace(d,"$1\\x{$2}");const m=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(m);)w=w.replace(m,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=r;const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function f(w){let d;try{d=new g.RegExpParser().parsePattern(w)}catch(H){return w}let m="",C=0;const L=(H,x,W)=>{m+=w.slice(C,H)+W,C=x},B=[];return new g.RegExpVisitor({onCharacterEnter(H){if(H.raw==="\\n"){const x=B[0];if(!x)L(H.start,H.end,"\\r?\\n");else if(!B.some(l))if(x.type==="CharacterClass"){const W=w.slice(x.start+1,H.start)+w.slice(H.end,x.end-1);L(x.start,x.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")}},onQuantifierEnter(H){B.unshift(H)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(H){B.unshift(H)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(H){B.unshift(H)},onCharacterClassLeave(){B.shift()},onAssertionEnter(H){l(H)&&B.push(H)},onAssertionLeave(H){B[0]===H&&B.shift()}}).visit(d),m+=w.slice(C),m}e.fixRegexNewline=f;function p(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(ge[272],pe([0,1,21,129,111,11]),function(Z,e,b,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,T,k,_){const g=new A.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===I.Schemas.userData){const a=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:I.Schemas.file})}),h=new R.Progress(S=>k.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:T.folder.scheme})})));return this.withToken(_,S=>g.provideTextSearchResults(n,a,h,S))}else return this.withToken(_,a=>g.provideTextSearchResults(n,T,k,a))}async withToken(n,T){const k=P(n);this.inProgress.add(k);const _=await T(k.token);return this.inProgress.delete(k),_}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=D;function P(y){const n=new b.CancellationTokenSource;return y.onCancellationRequested(()=>n.cancel()),n}}),define(ge[273],pe([0,1,26,129,128]),function(Z,e,b,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(y){this.query=y}search(y,n,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(g){T({message:g})}},_=new R.NativeTextSearchManager(this.query,new A.RipgrepTextSearchEngine(k),b);return new Promise((g,a)=>_.search(h=>{n(h.map(D))},y).then(h=>g({limitHit:h.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=I;function D(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((y,n)=>{if(n.ranges){const T=n;return y+(Array.isArray(T.ranges)?T.ranges.length:1)}else return y+1},0)}}}),define(ge[274],pe([0,1,37,287,14,17,16,3,96,8,46,2,44,32,271,273]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,A.gracefulify(b);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const o=c(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(l=>this.doFileSearchWithEngine(a.Engine,o,f=>r.fire(f),l)),i.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}textSearch(t){let i;const o=c(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(l=>this.ripgrepTextSearch(o,f=>r.fire(f),l)),i.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}ripgrepTextSearch(t,i,o){return t.maxFileSize=(0,_.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(o,i,i)}doFileSearch(t,i,o){return this.doFileSearchWithEngine(a.Engine,t,i,o)}doFileSearchWithEngine(t,i,o,r,l=S.BATCH_SIZE){let f=0;const p=d=>{Array.isArray(d)?(f+=d.length,o(d.map(m=>this.rawMatchToSearchItem(m)))):d.relativePath?(f++,o(this.rawMatchToSearchItem(d))):o(d)};if(i.sortByScore){let d=this.trySortedSearchFromCache(i,p,r);if(!d){const m=i.maxResults?Object.assign({},i,{maxResults:null}):i,C=new t(m);d=this.doSortedSearch(C,i,o,p,r)}return new Promise((m,C)=>{d.then(([L,B])=>{const ee=B.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(ee,o,l),m(L)},C)})}const w=new t(i);return this.doSearch(w,p,l,r).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,o,r,l){const f=new P.Emitter;let p=(0,I.createCancelablePromise)(d=>{let m=[];const C=L=>{Array.isArray(L)?m=L:(r(L),f.fire(L))};return this.doSearch(t,C,-1,d).then(L=>[L,m])}),w;if(i.cacheKey){w=this.getOrCreateCache(i.cacheKey);const d={promise:p,event:f.event,resolved:!1};w.resultsToSearchCache[i.filePattern||""]=d,p.then(()=>{d.resolved=!0},m=>{delete w.resultsToSearchCache[i.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([d,m])=>{const C=w?w.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(i,m,C,l).then(B=>{const ee=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:B.length},limitHit:d.limitHit||typeof i.maxResults=="number"&&m.length>i.maxResults},B]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new v)}trySortedSearchFromCache(t,i,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const l=this.getResultsFromCache(r,t.filePattern||"",i,o);if(l)return l.then(([f,p,w])=>{const d=T.StopWatch.create(!1);return this.sortResults(t,p,r.scorerCache,o).then(m=>{const C=d.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:p.length,sortingTime:C};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:L},m]})})}}sortResults(t,i,o,r){const l=(0,y.prepareQuery)(t.filePattern||""),f=(w,d)=>(0,y.compareItemsByFuzzyScore)(w,d,l,!0,E,o),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(i,f,p,1e4,r)}sendProgress(t,i,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)i(t.slice(r,r+o));else i(t)}getResultsFromCache(t,i,o,r){const l=T.StopWatch.create(!1),f=i.indexOf(n.sep)>=0;let p;for(const C in t.resultsToSearchCache)if(i.startsWith(C)){if(f&&C.indexOf(n.sep)<0&&C!=="")continue;const L=t.resultsToSearchCache[C];p={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!p)return null;const w=l.elapsed(),d=T.StopWatch.create(!1),m=p.event(o);return r&&r.onCancellationRequested(()=>{m.dispose()}),p.promise.then(([C,L])=>{if(r&&r.isCancellationRequested)throw(0,D.canceled)();const B=[],ee=(0,y.prepareQuery)(i).normalizedLowercase;for(const H of L)!(0,g.isFilePatternMatch)(H,ee)||B.push(H);return[C,B,{cacheWasResolved:p.resolved,cacheLookupTime:w,cacheFilterTime:d.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,o,r){return new Promise((l,f)=>{let p=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(p.push(w),o>0&&p.length>=o&&(i(p),p=[])):i(w))},w=>{i(w)},(w,d)=>{p.length&&i(p),w?f(w):l(d)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,o){return t.then(i,o)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(s){return(0,n.basename)(s.relativePath)}getItemDescription(s){return(0,n.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function c(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(u),extraFileResources:s.extraFileResources&&s.extraFileResources.map(t=>k.URI.revive(t))})}function u(s){return Object.assign(Object.assign({},s),{folder:k.URI.revive(s.folder)})}}),define(ge[275],pe([0,1,6,2,26,12,32,274,272,90,13,61,27,67,11,128]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(E,c,u,s){super(E,u,s);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new y.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new y.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(E,c){const u=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(E)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(E,c,u,s){const t=(0,g.reviveQuery)(u);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,c,t,s):super.$provideFileSearchResults(E,c,u,s)}doInternalFileSearch(E,c,u,s){const t=i=>{if((0,D.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(E,c,i.map(o=>A.URI.file(o.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,s)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,c){return new h.NativeTextSearchManager(E,c)}};S=je([Ue(0,T.IExtHostRpcService),Ue(1,_.IExtHostInitDataService),Ue(2,k.IURITransformerService),Ue(3,I.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[130],pe([0,1,288,120,289,3,101,8,48,28,6,25,102,16,9]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(p){this.socket=p,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const w=d=>p(k.VSBuffer.wrap(d));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((p,w)=>{if(this.socket.bufferSize===0){p();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),p()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=h;var S;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(v||(v={}));class E extends T.Disposable{constructor(p,w,d,m){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=m,w?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,g.onUnexpectedError)(C),this._onClose.fire()}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,g.onUnexpectedError)(C),this._onClose.fire()}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new _.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(k.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,w){let d=2;p.byteLength<126?d+=0:p.byteLength<2**16?d+=2:d+=8;const m=k.VSBuffer.alloc(d);if(w?m.writeUInt8(194,0):m.writeUInt8(130,0),p.byteLength<126)m.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){m.writeUInt8(126,1);let C=1;m.writeUInt8(p.byteLength>>>8&255,++C),m.writeUInt8(p.byteLength>>>0&255,++C)}else{m.writeUInt8(127,1);let C=1;m.writeUInt8(0,++C),m.writeUInt8(0,++C),m.writeUInt8(0,++C),m.writeUInt8(0,++C),m.writeUInt8(p.byteLength>>>24&255,++C),m.writeUInt8(p.byteLength>>>16&255,++C),m.writeUInt8(p.byteLength>>>8&255,++C),m.writeUInt8(p.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=m.byteLength+p.byteLength,this.socket.write(k.VSBuffer.concat([m,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),m=(w.readUInt8(0)&128)>>>7,C=w.readUInt8(1),L=(C&128)>>>7,B=C&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=m,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),d=w.readUInt8(1),m=(d&128)>>>7;let C=d&127,L=1;C===126?C=w.readUInt8(++L)*2**8+w.readUInt8(++L):C===127&&(C=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let B=0;m&&(B=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=C,this._state.mask=B}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);c(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(k.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function c(f,p){if(p!==0){let w=f.byteLength>>>2;for(let ee=0;ee<w;ee++){const H=f.readUInt32BE(ee*4);f.writeUInt32BE(H^p,ee*4)}let d=w*4,m=f.byteLength-d;const C=p>>>24&255,L=p>>>16&255,B=p>>>8&255;m>=1&&f.writeUInt8(f.readUInt8(d)^C,d),m>=2&&f.writeUInt8(f.readUInt8(d+1)^L,d+1),m>=3&&f.writeUInt8(f.readUInt8(d+2)^B,d+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const f=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):p=(0,P.join)((0,y.tmpdir)(),`vscode-ipc-${f}.sock`),i(p),p}e.createRandomIPCHandle=s;function t(f,p,w){const d=(0,b.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${w}-${p}-sock`;let m;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?m=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${w}-${p}.sock`):m=(0,P.join)(f,`${w}-${p}.sock`),i(m),m}e.createStaticIPCHandle=t;function i(f){const p=u[a.platform];typeof p=="number"&&f.length>=p&&console.warn(`WARNING: IPC handle "${f}" is longer than ${p} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{constructor(p){super(o.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const w=I.Event.fromNodeEventEmitter(p,"connection");return I.Event.map(w,d=>({protocol:new _.Protocol(new h(d)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(f){return new Promise((p,w)=>{const d=(0,A.createServer)();d.on("error",w),d.listen(f,()=>{d.removeListener("error",w),p(new o(d))})})}e.serve=r;function l(f,p){return new Promise((w,d)=>{const m=(0,A.createConnection)(f,()=>{m.removeListener("error",d),w(_.Client.fromSocket(new h(m),p))});m.once("error",d)})}e.connect=l}),define(ge[276],pe([0,1,130,268,37,51,2,115,12]),function(Z,e,b,A,R,I,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(_,g,a){this._commands=_,this.logService=g,this._ipcHandlePath=a,this._server=A.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(g.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch(_){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,g){const a=[];_.setEncoding("utf8"),_.on("data",h=>a.push(h)),_.on("end",()=>{const h=JSON.parse(a.join(""));switch(h.type){case"open":this.open(h,g);break;case"openExternal":this.openExternal(h,g);break;case"status":this.getStatus(h,g);break;case"command":this.runCommand(h,g).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(h,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(_,g){let{fileURIs:a,folderURIs:h,forceNewWindow:S,diffMode:v,addMode:E,forceReuseWindow:c,gotoLineMode:u,waitMarkerFilePath:s}=_;const t=[];if(Array.isArray(h))for(const i of h)try{t.push({folderUri:D.URI.parse(i)})}catch(o){}if(Array.isArray(a))for(const i of a)try{(0,P.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:D.URI.parse(i)}):t.push({fileUri:D.URI.parse(i)})}catch(o){}if(t.length){const i=s?D.URI.file(s):void 0,r={forceNewWindow:S,diffMode:v,addMode:E,gotoLineMode:u,forceReuseWindow:c,preferNewWindow:!c&&!i&&!E,waitMarkerFileURI:i};this._commands.executeCommand("_files.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(_,g){for(const a of _.uris){const h=D.URI.parse(a),S=h.scheme==="file"?h:a;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(_,g){try{const a=v=>v==null?void 0:v.map(E=>/\.vsix$/i.test(E)?D.URI.parse(E):E),h={list:_.list,install:a(_.install),uninstall:a(_.uninstall),force:_.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);g.writeHead(200),g.write(S)}catch(a){g.writeHead(500),g.write(String(a),h=>{h&&this.logService.error(h)})}g.end()}async getStatus(_,g){try{const a=await this._commands.executeCommand("_issues.getSystemStatus");g.writeHead(200),g.write(a),g.end()}catch(a){g.writeHead(500),g.write(String(a),h=>{h&&this.logService.error(h)}),g.end()}}async runCommand(_,g){try{const{command:a,args:h}=_,S=await this._commands.executeCommand(a,...h);g.writeHead(200),g.write(JSON.stringify(S),v=>{v&&this.logService.error(v)}),g.end()}catch(a){g.writeHead(500),g.write(String(a),h=>{h&&this.logService.error(h)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let T=class extends n{constructor(_,g){super(_,g,(0,b.createRandomIPCHandle)())}};T=je([Ue(0,I.IExtHostCommands),Ue(1,y.ILogService)],T),e.CLIServer=T}),define(ge[277],pe([0,1,66,264,258,5,267,42,249,2,11,7,276,99]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends R.RequireInterceptor{_installInterceptor(){const v=this,E=Z.__$__nodeRequire("module"),c=E._load;E._load=function(s,t,i){for(let o of v._alternatives){let r=o(s);if(r){s=r;break}}return v._factories.has(s)?v._factories.get(s).load(s,n.URI.file((0,g.realpathSync)(t.filename)),o=>c.apply(this,[o,t,i])):c.apply(this,arguments)}}}class h extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(A.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(_.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,v,this._registry).install(),b.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const u=process.send,s=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(s.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,E,c){if(E.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let u=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{v&&b.mark(`code/extHost/willLoadExtensionCode/${v.value}`),u=Z.__$__nodeRequire(E.fsPath)}catch(s){return Promise.reject(s)}finally{v&&b.mark(`code/extHost/didLoadExtensionCode/${v.value}`),c.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const E in v){const c=v[E];c===null?delete process.env[E]:process.env[E]=c}}}e.ExtHostExtensionService=h}),define(ge[278],pe([0,1,78,250,261,260,259,275,277,222,251,45,42,63,67,65,35,50,12]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(_.IExtHostExtensionService,y.ExtHostExtensionService),(0,b.registerSingleton)(E.ILogService,n.ExtHostLogService),(0,b.registerSingleton)(k.IExtHostDebugService,D.ExtHostDebugService),(0,b.registerSingleton)(g.IExtHostOutputService,A.ExtHostOutputService2),(0,b.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,b.registerSingleton)(h.IExtHostTask,I.ExtHostTask),(0,b.registerSingleton)(S.IExtHostTerminalService,R.ExtHostTerminalService),(0,b.registerSingleton)(v.IExtHostTunnelService,T.ExtHostTunnelService)}),define(ge[279],pe([0,1,120,290,66,16,102,130,184,220,262,25,97,26,99,17,265,278]),function(Z,e,b,A,R,I,D,P,y,n,T,k,_,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=A(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=Z.__$__nodeRequire("module"),r=o._load;o._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function E(o){process.exit=function(r){if(o)v(r);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(o){v()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let l=null,f=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,w=3e5,d=new h.RunOnceScheduler(()=>c("renderer disconnected for too long (1)"),p),m=new h.RunOnceScheduler(()=>c("renderer disconnected for too long (2)"),w);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let H;if(L.skipWebSocketFrames)H=new P.NodeSocket(B);else{const x=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));H=new P.WebSocketNodeSocket(new P.NodeSocket(B),L.permessageDeflate,x,!1)}l?(d.cancel(),m.cancel(),l.beginAcceptReconnection(H,ee),l.endAcceptReconnection()):(clearTimeout(f),l=new D.PersistentProtocol(H,ee),l.onDidDispose(()=>c("renderer disconnected")),o(l),l.onSocketClose(()=>{d.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(m.isScheduled())return;d.isScheduled()&&m.schedule()}});const C={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(C)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,l)=>{const f=b.createConnection(o,()=>{f.removeListener("error",l),r(new D.PersistentProtocol(new P.NodeSocket(f)))});f.once("error",l)})}}async function s(){const o=await u();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,n.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const l=o.onMessage(f=>{l.dispose();const p=JSON.parse(f.toString()),w=p.commit,d=y.default.commit;w&&d&&w!==d&&v(55);const m=[];process.on("unhandledRejection",(B,ee)=>{m.push(ee),setTimeout(()=>{const H=m.indexOf(ee);H>=0&&ee.catch(x=>{m.splice(H,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,I.onUnexpectedError)(B)})},1e3)}),process.on("rejectionHandled",B=>{const ee=m.indexOf(B);ee>=0&&m.splice(ee,1)}),process.on("uncaughtException",function(B){(0,I.onUnexpectedError)(B)});let C=0;setInterval(function(){try{process.kill(p.parentPid,0),C=0}catch(B){B&&B.code==="EPERM"?(C++,C>=3&&c(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):c(`parent process ${p.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let L;try{L=Z.__$__nodeRequire("native-watchdog"),L.start(p.parentPid)}catch(B){(0,I.onUnexpectedError)(B)}o.send((0,n.createMessageOfType)(0)),r({protocol:o,initData:p})});o.send((0,n.createMessageOfType)(1))})}async function i(){R.mark("code/extHost/willConnectToRenderer");const o=await s();R.mark("code/extHost/didConnectToRenderer");const r=await t(o);R.mark("code/extHost/didWaitForInitData");const{initData:l}=r;E(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const f=new class{exit(m){v(m)}exists(m){return(0,g.exists)(m)}realpath(m){return(0,a.realpath)(m)}};let p=null;if(l.remote.authority&&S.uriTransformerPath)try{const m=Z.__$__nodeRequire(S.uriTransformerPath)(l.remote.authority);p=new _.URITransformer(m)}catch(d){console.error(d)}const w=new T.ExtensionHostMain(r.protocol,l,f,p);c=d=>w.terminate(d)}e.startExtensionHostProcess=i}),define(ge[291],pe([0,1,279]),function(Z,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(A=>console.log(A))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c71be15869a673c5ed7bfd3fe171757d2ba48142/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
