/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/process","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(le){for(var e=[],y=0,R=le.length;y<R;y++)e[y]=be[le[y]];return e};define(be[43],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(R,T){if(!R)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=y}),define(be[50],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const y=Object.prototype.hasOwnProperty;function R(A){const C=[];for(let b in A)y.call(A,b)&&C.push(A[b]);return C}e.values=R;function T(A,C){for(let b in A)if(y.call(A,b)&&C({key:b,value:A[b]},function(){delete A[b]})===!1)return}e.forEach=T;function P(A,C){const b=Object.create(null);for(const m of A){const r=C(m);let s=b[r];s||(s=b[r]=[]),s.push(m)}return b}e.groupBy=P;function S(A){const C=Object.create(null);return A&&A.forEach((b,m)=>{C[m]=b}),C}e.fromMap=S;function k(A,C){const b=[],m=[];for(let r of A)C.has(r)||b.push(r);for(let r of C)A.has(r)||m.push(r);return{removed:b,added:m}}e.diffSets=k;function E(A,C){const b=[],m=[];for(let[r,s]of A)C.has(r)||b.push(s);for(let[r,s]of C)A.has(r)||m.push(s);return{removed:b,added:m}}e.diffMaps=E;class n{constructor(){this.map=new Map}add(C,b){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(b)}delete(C,b){const m=this.map.get(C);!m||(m.delete(b),m.size===0&&this.map.delete(C))}forEach(C,b){const m=this.map.get(C);!m||m.forEach(b)}}e.SetMap=n}),define(be[51],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function y(E){return(n,A,C)=>{let b=null,m=null;if(typeof C.value=="function"?(b="value",m=C.value):typeof C.get=="function"&&(b="get",m=C.get),!m)throw new Error("not supported");C[b]=E(m,A)}}e.createDecorator=y;let R=0;function T(){const E=`$memoize${R++}`;let n;const A=function(b,m,r){let s=null,_=null;if(typeof r.value=="function"?(s="value",_=r.value,_.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(s="get",_=r.get),!_)throw new Error("not supported");const g=`${E}:${m}`;r[s]=function(...w){return n=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:_.apply(this,w)}),this[g]}};return A.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(E)===0&&delete n[C]})},A}e.createMemoizer=T;function P(E,n,A){return T()(E,n,A)}e.memoize=P;function S(E,n,A){return y((C,b)=>{const m=`$debounce$${b}`,r=`$debounce$result$${b}`;return function(...s){this[r]||(this[r]=A?A():void 0),clearTimeout(this[m]),n&&(this[r]=n(this[r],...s),s=[this[r]]),this[m]=setTimeout(()=>{C.apply(this,s),this[r]=A?A():void 0},E)}})}e.debounce=S;function k(E,n,A){return y((C,b)=>{const m=`$throttle$timer$${b}`,r=`$throttle$result$${b}`,s=`$throttle$lastRun$${b}`,_=`$throttle$pending$${b}`;return function(...g){if(this[r]||(this[r]=A?A():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...g)),!this[_]){const w=this[s]+E;w<=Date.now()?(this[s]=Date.now(),C.apply(this,[this[r]]),this[r]=A?A():void 0):(this[_]=!0,this[m]=setTimeout(()=>{this[_]=!1,this[s]=Date.now(),C.apply(this,[this[r]]),this[r]=A?A():void 0},w-Date.now()))}}})}e.throttle=k}),define(be[10],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=y,e.errorHandler=new y;function R(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=R;function T(o){E(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=T;function P(o){E(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=P;function S(o){if(o instanceof Error){let{name:t,message:i}=o;const u=o.stacktrace||o.stack;return{$isError:!0,name:t,message:i,stack:u}}return o}e.transformErrorForSerialization=S;const k="Canceled";function E(o){return o instanceof Error&&o.name===k&&o.message===k}e.isPromiseCanceledError=E;class n extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=n;function A(){const o=new Error(k);return o.name=o.message,o}e.canceled=A;function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=C;function b(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=b;function m(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function r(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function s(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=s;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function c(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function d(o,t=Object.create(null)){const i=new Error(o);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=d}),define(be[15],we([0,1,10]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(L,U=0){return L[L.length-(1+U)]}e.tail=R;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function P(L,U,x=(Q,$)=>Q===$){if(L===U)return!0;if(!L||!U||L.length!==U.length)return!1;for(let Q=0,$=L.length;Q<$;Q++)if(!x(L[Q],U[Q]))return!1;return!0}e.equals=P;function S(L,U,x){let Q=0,$=L.length-1;for(;Q<=$;){const Z=(Q+$)/2|0,ie=x(L[Z],U);if(ie<0)Q=Z+1;else if(ie>0)$=Z-1;else return Z}return-(Q+1)}e.binarySearch=S;function k(L,U){let x=0,Q=L.length;if(Q===0)return 0;for(;x<Q;){const $=Math.floor((x+Q)/2);U(L[$])?Q=$:x=$+1}return x}e.findFirstInSorted=k;function E(L,U,x){if(L=L|0,L>=U.length)throw new TypeError("invalid index");let Q=U[Math.floor(U.length*Math.random())],$=[],Z=[],ie=[];for(let re of U){const ye=x(re,Q);ye<0?$.push(re):ye>0?Z.push(re):ie.push(re)}return L<$.length?E(L,$,x):L<$.length+ie.length?ie[0]:E(L-($.length+ie.length),Z,x)}e.quickSelect=E;function n(L,U){const x=[];let Q;for(const $ of L.slice(0).sort(U))!Q||U(Q[0],$)!==0?(Q=[$],x.push(Q)):Q.push($);return x}e.groupBy=n;function A(L,U,x){const Q=[];function $(re,ye,Ie){if(!(ye===0&&Ie.length===0)){const Ue=Q[Q.length-1];Ue&&Ue.start+Ue.deleteCount===re?(Ue.deleteCount+=ye,Ue.toInsert.push(...Ie)):Q.push({start:re,deleteCount:ye,toInsert:Ie})}}let Z=0,ie=0;for(;;){if(Z===L.length){$(Z,0,U.slice(ie));break}if(ie===U.length){$(Z,L.length-Z,[]);break}const re=L[Z],ye=U[ie],Ie=x(re,ye);Ie===0?(Z+=1,ie+=1):Ie<0?($(Z,1,[]),Z+=1):Ie>0&&($(Z,0,[ye]),ie+=1)}return Q}e.sortedDiff=A;function C(L,U,x){const Q=A(L,U,x),$=[],Z=[];for(const ie of Q)$.push(...L.slice(ie.start,ie.start+ie.deleteCount)),Z.push(...ie.toInsert);return{removed:$,added:Z}}e.delta=C;function b(L,U,x){if(x===0)return[];const Q=L.slice(0,x).sort(U);return r(L,U,Q,x,L.length),Q}e.top=b;function m(L,U,x,Q,$){return x===0?Promise.resolve([]):new Promise((Z,ie)=>{(async()=>{const re=L.length,ye=L.slice(0,x).sort(U);for(let Ie=x,Ue=Math.min(x+Q,re);Ie<re;Ie=Ue,Ue=Math.min(Ue+Q,re)){if(Ie>x&&await new Promise(Re=>setTimeout(Re)),$&&$.isCancellationRequested)throw(0,y.canceled)();r(L,U,ye,Ie,Ue)}return ye})().then(Z,ie)})}e.topAsync=m;function r(L,U,x,Q,$){for(const Z=x.length;Q<$;Q++){const ie=L[Q];if(U(ie,x[Z-1])<0){x.pop();const re=k(x,ye=>U(ie,ye)<0);x.splice(re,0,ie)}}}function s(L){return L.filter(U=>!!U)}e.coalesce=s;function _(L){let U=0;for(let x=0;x<L.length;x++)L[x]&&(L[U]=L[x],U+=1);L.length=U}e.coalesceInPlace=_;function g(L,U,x){L.splice(x,0,L.splice(U,1)[0])}e.move=g;function w(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=w;function c(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=c;function d(L,U){if(!U)return L.filter((Q,$)=>L.indexOf(Q)===$);const x=Object.create(null);return L.filter(Q=>{const $=U(Q);return x[$]?!1:(x[$]=!0,!0)})}e.distinct=d;function o(L){const U=new Set;return L.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=o;function t(L){const U=Object.create(null);return x=>{const Q=L(x);return U[Q]?!1:(U[Q]=!0,!0)}}e.uniqueFilter=t;function i(L,U){for(let x=L.length-1;x>=0;x--){const Q=L[x];if(U(Q))return x}return-1}e.lastIndex=i;function u(L,U){return L.length>0?L[0]:U}e.firstOrDefault=u;function a(L,U,x=(Q,$)=>Q===$){let Q=0;for(let $=0,Z=Math.min(L.length,U.length);$<Z&&x(L[$],U[$]);$++)Q++;return Q}e.commonPrefixLength=a;function l(L){return[].concat(...L)}e.flatten=l;function f(L,U){let x=typeof U=="number"?L:0;typeof U=="number"?x=L:(x=0,U=L);const Q=[];if(x<=U)for(let $=x;$<U;$++)Q.push($);else for(let $=x;$>U;$--)Q.push($);return Q}e.range=f;function v(L,U,x){return L.reduce((Q,$)=>(Q[U($)]=x?x($):$,Q),Object.create(null))}e.index=v;function D(L,U){return L.push(U),()=>h(L,U)}e.insert=D;function h(L,U){const x=L.indexOf(U);if(x>-1)return L.splice(x,1),U}e.remove=h;function p(L,U,x){const Q=L.slice(0,U),$=L.slice(U);return Q.concat(x,$)}e.arrayInsert=p;function I(L,U){let x;if(typeof U=="number"){let Q=U;x=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else x=Math.random;for(let Q=L.length-1;Q>0;Q-=1){const $=Math.floor(x()*(Q+1)),Z=L[Q];L[Q]=L[$],L[$]=Z}}e.shuffle=I;function F(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.unshift(U))}e.pushToStart=F;function z(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.push(U))}e.pushToEnd=z;function ue(L,U){return Array.isArray(L)?L.map(U):U(L)}e.mapArrayOrNot=ue;function H(L){return Array.isArray(L)?L:[L]}e.asArray=H;function B(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=B;function K(L,U){for(const x of L){const Q=U(x);if(Q!==void 0)return Q}}e.mapFind=K}),define(be[52],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(R){const T=this;let P=!1,S;return function(){return P||(P=!0,S=R.apply(T,arguments)),S}}e.once=y}),define(be[53],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class y{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=y,e.defaultGenerator=new y("id#")}),define(be[54],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(R){function T(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}R.is=T;const P=Object.freeze([]);function S(){return P}R.empty=S;function*k(o){yield o}R.single=k;function E(o){return o||P}R.from=E;function n(o){return!o||o[Symbol.iterator]().next().done===!0}R.isEmpty=n;function A(o){return o[Symbol.iterator]().next().value}R.first=A;function C(o,t){for(const i of o)if(t(i))return!0;return!1}R.some=C;function b(o,t){for(const i of o)if(t(i))return i}R.find=b;function*m(o,t){for(const i of o)t(i)&&(yield i)}R.filter=m;function*r(o,t){for(const i of o)yield t(i)}R.map=r;function*s(...o){for(const t of o)for(const i of t)yield i}R.concat=s;function*_(o){for(const t of o)for(const i of t)yield i}R.concatNested=_;function g(o,t,i){let u=i;for(const a of o)u=t(u,a);return u}R.reduce=g;function*w(o,t,i=o.length){for(t<0&&(t+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);t<i;t++)yield o[t]}R.slice=w;function c(o,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,o];const u=o[Symbol.iterator]();for(let a=0;a<t;a++){const l=u.next();if(l.done)return[i,R.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return u}}]}R.consume=c;function d(o,t,i=(u,a)=>u===a){const u=o[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const l=u.next(),f=a.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!i(l.value,f.value))return!1}}R.equals=d})(y=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function S(t,i=!1){let u=0,a=t.length,l="",f=0,v=16,D=0;function h(B){let K=0,L=0;for(;K<B;){const U=t.charCodeAt(u);if(U>=48&&U<=57)L=L*16+U-48;else if(U>=65&&U<=70)L=L*16+U-65+10;else if(U>=97&&U<=102)L=L*16+U-97+10;else break;u++,K++}return K<B&&(L=-1),L}function p(B){u=B,l="",f=0,v=16,D=0}function I(){const B=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&n(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&n(t.charCodeAt(u)))for(u++;u<t.length&&n(t.charCodeAt(u));)u++;else return D=3,t.substring(B,u);let K=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&n(t.charCodeAt(u))){for(u++;u<t.length&&n(t.charCodeAt(u));)u++;K=u}else D=3;return t.substring(B,K)}function F(){let B="",K=u;for(;;){if(u>=a){B+=t.substring(K,u),D=2;break}const L=t.charCodeAt(u);if(L===34){B+=t.substring(K,u),u++;break}if(L===92){if(B+=t.substring(K,u),u++,u>=a){D=2;break}switch(t.charCodeAt(u++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const x=h(4);x>=0?B+=String.fromCharCode(x):D=4;break;default:D=5}K=u;continue}if(L>=0&&L<=31)if(E(L)){B+=t.substring(K,u),D=2;break}else D=6;u++}return B}function z(){if(l="",D=0,f=u,u>=a)return f=a,v=17;let B=t.charCodeAt(u);if(k(B)){do u++,l+=String.fromCharCode(B),B=t.charCodeAt(u);while(k(B));return v=15}if(E(B))return u++,l+=String.fromCharCode(B),B===13&&t.charCodeAt(u)===10&&(u++,l+=`
`),v=14;switch(B){case 123:return u++,v=1;case 125:return u++,v=2;case 91:return u++,v=3;case 93:return u++,v=4;case 58:return u++,v=6;case 44:return u++,v=5;case 34:return u++,l=F(),v=10;case 47:const K=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<a&&!E(t.charCodeAt(u));)u++;return l=t.substring(K,u),v=12}if(t.charCodeAt(u+1)===42){u+=2;const L=a-1;let U=!1;for(;u<L;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,U=!0;break}u++}return U||(u++,D=1),l=t.substring(K,u),v=13}return l+=String.fromCharCode(B),u++,v=16;case 45:if(l+=String.fromCharCode(B),u++,u===a||!n(t.charCodeAt(u)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=I(),v=11;default:for(;u<a&&ue(B);)u++,B=t.charCodeAt(u);if(f!==u){switch(l=t.substring(f,u),l){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return l+=String.fromCharCode(B),u++,v=16}}function ue(B){if(k(B)||E(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let B;do B=z();while(B>=12&&B<=15);return B}return{setPosition:p,getPosition:()=>u,scan:i?H:z,getToken:()=>v,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>D}}e.createScanner=S;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,i){const u=[],a=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function D(h,p,I,F){f.value=h,f.offset=p,f.length=I,f.type=F,f.colonOffset=void 0,l=f}try{c(t,{onObjectBegin:(h,p)=>{if(i<=h)throw a;l=void 0,v=i>h,u.push("")},onObjectProperty:(h,p,I)=>{if(i<p||(D(h,p,I,"property"),u[u.length-1]=h,i<=p+I))throw a},onObjectEnd:(h,p)=>{if(i<=h)throw a;l=void 0,u.pop()},onArrayBegin:(h,p)=>{if(i<=h)throw a;l=void 0,u.push(0)},onArrayEnd:(h,p)=>{if(i<=h)throw a;l=void 0,u.pop()},onLiteralValue:(h,p,I)=>{if(i<p||(D(h,p,I,o(h)),i<=p+I))throw a},onSeparator:(h,p,I)=>{if(i<=p)throw a;if(h===":"&&l&&l.type==="property")l.colonOffset=p,v=!1,l=void 0;else if(h===","){const F=u[u.length-1];typeof F=="number"?u[u.length-1]=F+1:(v=!0,u[u.length-1]=""),l=void 0}}})}catch(h){if(h!==a)throw h}return{path:u,previousNode:l,isAtPropertyKey:v,matches:h=>{let p=0;for(let I=0;p<h.length&&I<u.length;I++)if(h[p]===u[I]||h[p]==="*")p++;else if(h[p]!=="**")return!1;return p===h.length}}}e.getLocation=C;function b(t,i=[],u=P.DEFAULT){let a=null,l=[];const f=[];function v(h){Array.isArray(l)?l.push(h):a!==null&&(l[a]=h)}return c(t,{onObjectBegin:()=>{const h={};v(h),f.push(l),l=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const h=[];v(h),f.push(l),l=h,a=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:v,onError:(h,p,I)=>{i.push({error:h,offset:p,length:I})}},u),l[0]}e.parse=b;function m(t,i=[],u=P.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function f(h){return a.children.push(h),h}c(t,{onObjectBegin:h=>{a=f({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,p,I)=>{a=f({type:"property",offset:p,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:p,length:I,parent:a})},onObjectEnd:(h,p)=>{a.length=h+p-a.offset,a=a.parent,l(h+p)},onArrayBegin:(h,p)=>{a=f({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,p)=>{a.length=h+p-a.offset,a=a.parent,l(h+p)},onLiteralValue:(h,p,I)=>{f({type:o(h),offset:p,length:I,parent:a,value:h}),l(p+I)},onSeparator:(h,p,I)=>{a.type==="property"&&(h===":"?a.colonOffset=p:h===","&&l(p))},onError:(h,p,I)=>{i.push({error:h,offset:p,length:I})}},u);const D=a.children[0];return D&&delete D.parent,D}e.parseTree=m;function r(t,i){if(!!t){let u=t;for(let a of i)if(typeof a=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let l=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===a){u=f.children[1],l=!0;break}if(!l)return}else{const l=a;if(u.type!=="array"||l<0||!Array.isArray(u.children)||l>=u.children.length)return;u=u.children[l]}return u}}e.findNodeAtLocation=r;function s(t){if(!t.parent||!t.parent.children)return[];const i=s(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;i.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&i.push(u)}return i}e.getNodePath=s;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let u of t.children){const a=u.children[1];a&&(i[u.children[0].value]=_(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function g(t,i,u=!1){return i>=t.offset&&i<t.offset+t.length||u&&i===t.offset+t.length}e.contains=g;function w(t,i,u=!1){if(g(t,i,u)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=i;l++){const f=w(a[l],i,u);if(f)return f}return t}}e.findNodeAtOffset=w;function c(t,i,u=P.DEFAULT){const a=S(t,!1);function l(ye){return ye?()=>ye(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(ye){return ye?Ie=>ye(Ie,a.getTokenOffset(),a.getTokenLength()):()=>!0}const v=l(i.onObjectBegin),D=f(i.onObjectProperty),h=l(i.onObjectEnd),p=l(i.onArrayBegin),I=l(i.onArrayEnd),F=f(i.onLiteralValue),z=f(i.onSeparator),ue=l(i.onComment),H=f(i.onError),B=u&&u.disallowComments,K=u&&u.allowTrailingComma;function L(){for(;;){const ye=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:B||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ye){case 12:case 13:B?U(10):ue();break;case 16:U(1);break;case 15:case 14:break;default:return ye}}}function U(ye,Ie=[],Ue=[]){if(H(ye),Ie.length+Ue.length>0){let Re=a.getToken();for(;Re!==17;){if(Ie.indexOf(Re)!==-1){L();break}else if(Ue.indexOf(Re)!==-1)break;Re=L()}}}function x(ye){const Ie=a.getTokenValue();return ye?F(Ie):D(Ie),L(),!0}function Q(){switch(a.getToken()){case 11:let ye=0;try{ye=JSON.parse(a.getTokenValue()),typeof ye!="number"&&(U(2),ye=0)}catch(Ie){U(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function $(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),a.getToken()===6?(z(":"),L(),re()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Z(){v(),L();let ye=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ye||U(4,[],[]),z(","),L(),a.getToken()===2&&K)break}else ye&&U(6,[],[]);$()||U(4,[],[2,5]),ye=!0}return h(),a.getToken()!==2?U(7,[2],[]):L(),!0}function ie(){p(),L();let ye=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ye||U(4,[],[]),z(","),L(),a.getToken()===4&&K)break}else ye&&U(6,[],[]);re()||U(4,[],[4,5]),ye=!0}return I(),a.getToken()!==4?U(8,[4],[]):L(),!0}function re(){switch(a.getToken()){case 3:return ie();case 1:return Z();case 10:return x(!0);default:return Q()}}return L(),a.getToken()===17?u.allowEmptyContent?!0:(U(4,[],[]),!1):re()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function d(t,i){let u=S(t),a=[],l,f=0,v;do switch(v=u.getPosition(),l=u.scan(),l){case 12:case 13:case 17:f!==v&&a.push(t.substring(f,v)),i!==void 0&&a.push(u.getTokenValue().replace(/[^\r\n]/g,i)),f=u.getPosition();break}while(l!==17);return a.join("")}e.stripComments=d;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(be[104],we([0,1,44]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(E,n,A){let C,b,m,r,s;if(n){for(r=n.offset,s=r+n.length,m=r;m>0&&!k(E,m-1);)m--;let f=s;for(;f<E.length&&!k(E,f);)f++;b=E.substring(m,f),C=P(b,A)}else b=E,C=0,m=0,r=0,s=E.length;const _=S(A,E);let g=!1,w=0,c;A.insertSpaces?c=T(" ",A.tabSize||4):c="	";const d=(0,y.createScanner)(b,!1);let o=!1;function t(){return _+T(c,C+w)}function i(){let f=d.scan();for(g=!1;f===15||f===14;)g=g||f===14,f=d.scan();return o=f===16||d.getTokenError()!==0,f}const u=[];function a(f,v,D){!o&&v<s&&D>r&&E.substring(v,D)!==f&&u.push({offset:v,length:D-v,content:f})}let l=i();if(l!==17){const f=d.getTokenOffset()+m,v=T(c,C);a(v,m,f)}for(;l!==17;){let f=d.getTokenOffset()+d.getTokenLength()+m,v=i(),D="";for(;!g&&(v===12||v===13);){const p=d.getTokenOffset()+m;a(" ",f,p),f=d.getTokenOffset()+d.getTokenLength()+m,D=v===12?t():"",v=i()}if(v===2)l!==1&&(w--,D=t());else if(v===4)l!==3&&(w--,D=t());else{switch(l){case 3:case 1:w++,D=t();break;case 5:case 12:D=t();break;case 13:g?D=t():D=" ";break;case 6:D=" ";break;case 10:if(v===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?D=" ":v!==5&&v!==17&&(o=!0);break;case 16:o=!0;break}g&&(v===12||v===13)&&(D=t())}const h=d.getTokenOffset()+m;a(D,f,h),l=v}return u}e.format=R;function T(E,n){let A="";for(let C=0;C<n;C++)A+=E;return A}function P(E,n){let A=0,C=0;const b=n.tabSize||4;for(;A<E.length;){const m=E.charAt(A);if(m===" ")C++;else if(m==="	")C+=b;else break;A++}return Math.floor(C/b)}function S(E,n){for(let A=0;A<n.length;A++){const C=n.charAt(A);if(C==="\r")return A+1<n.length&&n.charAt(A+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=S;function k(E,n){return`\r
`.indexOf(E.charAt(n))!==-1}e.isEOL=k}),define(be[105],we([0,1,44,104]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,A,C){return P(n,A,void 0,C)}e.removeProperty=T;function P(n,A,C,b,m){const r=A.slice(),s=[],_=(0,y.parseTree)(n,s);let g,w;for(;r.length>0&&(w=r.pop(),g=(0,y.findNodeAtLocation)(_,r),g===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const c=(0,y.findNodeAtLocation)(g,[w]);if(c!==void 0)if(C===void 0){if(!c.parent)throw new Error("Malformed AST");const d=g.children.indexOf(c.parent);let o,t=c.parent.offset+c.parent.length;if(d>0){const i=g.children[d-1];o=i.offset+i.length}else o=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return S(n,{offset:o,length:t-o,content:""},b)}else return S(n,{offset:c.offset,length:c.length,content:JSON.stringify(C)},b);else{if(C===void 0)return[];const d=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,o=m?m(g.children.map(i=>i.children[0].value)):g.children.length;let t;if(o>0){const i=g.children[o-1];t={offset:i.offset+i.length,length:0,content:","+d}}else g.children.length===0?t={offset:g.offset+1,length:0,content:d}:t={offset:g.offset+1,length:0,content:d+","};return S(n,t,b)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(C!==void 0){const c=`${JSON.stringify(C)}`;let d;if(g.children.length===0||w===0)d={offset:g.offset+1,length:0,content:g.children.length===0?c:c+","};else{const o=w===-1||w>g.children.length?g.children.length:w,t=g.children[o-1];d={offset:t.offset+t.length,length:0,content:","+c}}return S(n,d,b)}else{const c=w,d=g.children[c];let o;if(g.children.length===1)o={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===c){const t=g.children[c-1],i=t.offset+t.length,u=g.offset+g.length;o={offset:i,length:u-2-i,content:""}}else o={offset:d.offset,length:g.children[c+1].offset-d.offset,content:""};return S(n,o,b)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(C)},b)}}e.setProperty=P;function S(n,A,C){let b=k(n,A),m=A.offset,r=A.offset+A.content.length;if(A.length===0||A.content.length===0){for(;m>0&&!(0,R.isEOL)(b,m-1);)m--;for(;r<b.length&&!(0,R.isEOL)(b,r);)r++}const s=(0,R.format)(b,{offset:m,length:r-m},C);for(let g=s.length-1;g>=0;g--){const w=s[g];b=k(b,w),m=Math.min(m,w.offset),r=Math.max(r,w.offset+w.length),r+=w.content.length-w.length}const _=n.length-(b.length-r)-m;return[{offset:m,length:_,content:b.substring(m,r)}]}e.withFormatting=S;function k(n,A){return n.substring(0,A.offset)+A.content+n.substring(A.offset+A.length)}e.applyEdit=k;function E(n,A){let C=A.slice(0).sort((m,r)=>{const s=m.offset-r.offset;return s===0?m.length-r.length:s}),b=n.length;for(let m=C.length-1;m>=0;m--){let r=C[m];if(r.offset+r.length<=b)n=k(n,r);else throw new Error("Overlapping edit");b=r.offset}return n}e.applyEdits=E}),define(be[106],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new y(()=>T(this.getValue()))}}e.Lazy=y}),define(be[6],we([0,1,52,54]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function S(c){P=c}if(e.setDisposableTracker=S,T){const c="__is_disposable_tracked__";P=new class{trackDisposable(d){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[c]||console.log(o)},3e3)}markTracked(d){if(d&&d!==s.None)try{d[c]=!0}catch(o){}}}}function k(c){!P||P.markTracked(c)}function E(c){return P&&P.trackDisposable(c),c}e.trackDisposable=E;class n extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=n;function A(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=A;function C(c){if(R.Iterable.is(c)){let d=[];for(const o of c)if(o){k(o);try{o.dispose()}catch(t){d.push(t)}}if(d.length===1)throw d[0];if(d.length>1)throw new n(d);return Array.isArray(c)?[]:c}else if(c)return k(c),c.dispose(),c}e.dispose=C;function b(...c){return c.forEach(k),m(()=>C(c))}e.combinedDisposable=b;function m(c){const d=E({dispose:()=>{k(d),c()}});return d}e.toDisposable=m;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new r,E(this)}dispose(){k(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var o;this._isDisposed||d===this._value||((o=this._value)===null||o===void 0||o.dispose(),d&&k(d),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,k(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}}e.MutableDisposable=_;class g{constructor(){this.references=new Map}acquire(d,...o){let t=this.references.get(d);t||(t={counter:0,object:this.createReferencedObject(d,...o)},this.references.set(d,t));const{object:i}=t,u=(0,y.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(d,t.object),this.references.delete(d))});return t.counter++,{object:i,dispose:u}}}e.ReferenceCollection=g;class w{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=w}),define(be[45],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(P){this.element=P,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class R{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,S){const k=new y(P);if(this._first===y.Undefined)this._first=k,this._last=k;else if(S){const n=this._last;this._last=k,k.prev=n,n.next=k}else{const n=this._first;this._first=k,k.next=n,n.prev=k}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(k))}}shift(){if(this._first!==y.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==y.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==y.Undefined&&P.next!==y.Undefined){const S=P.prev;S.next=P.next,P.next.prev=S}else P.prev===y.Undefined&&P.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):P.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):P.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==y.Undefined;)yield P.element,P=P.next}}e.LinkedList=R}),function(le,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(le=typeof globalThis!="undefined"?globalThis:le||self,le.marked=e())}(this,function(){"use strict";function le(W,te){for(var de=0;de<te.length;de++){var q=te[de];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(W,q.key,q)}}function e(W,te,de){return te&&le(W.prototype,te),de&&le(W,de),W}function y(W,te){if(!!W){if(typeof W=="string")return R(W,te);var de=Object.prototype.toString.call(W).slice(8,-1);if(de==="Object"&&W.constructor&&(de=W.constructor.name),de==="Map"||de==="Set")return Array.from(W);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return R(W,te)}}function R(W,te){(te==null||te>W.length)&&(te=W.length);for(var de=0,q=new Array(te);de<te;de++)q[de]=W[de];return q}function T(W,te){var de;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(de=y(W))||te&&W&&typeof W.length=="number"){de&&(W=de);var q=0;return function(){return q>=W.length?{done:!0}:{done:!1,value:W[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=W[Symbol.iterator](),de.next.bind(de)}function P(W){var te={exports:{}};return W(te,te.exports),te.exports}var S=P(function(W){function te(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(q){W.exports.defaults=q}W.exports={defaults:te(),getDefaults:te,changeDefaults:de}}),k=/[&<>"']/,E=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(te){return C[te]};function m(W,te){if(te){if(k.test(W))return W.replace(E,b)}else if(n.test(W))return W.replace(A,b);return W}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(W){return W.replace(r,function(te,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var _=/(^|[^\[])\^/g;function g(W,te){W=W.source||W,te=te||"";var de={replace:function(J,se){return se=se.source||se,se=se.replace(_,"$1"),W=W.replace(J,se),de},getRegex:function(){return new RegExp(W,te)}};return de}var w=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(W,te,de){if(W){var q;try{q=decodeURIComponent(s(de)).replace(w,"").toLowerCase()}catch(J){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}te&&!c.test(de)&&(de=a(te,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(J){return null}return de}var o={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(W,te){o[" "+W]||(t.test(W)?o[" "+W]=W+"/":o[" "+W]=D(W,"/",!0)),W=o[" "+W];var de=W.indexOf(":")===-1;return te.substring(0,2)==="//"?de?te:W.replace(i,"$1")+te:te.charAt(0)==="/"?de?te:W.replace(u,"$1")+te:W+te}var l={exec:function(){}};function f(W){for(var te=1,de,q;te<arguments.length;te++){de=arguments[te];for(q in de)Object.prototype.hasOwnProperty.call(de,q)&&(W[q]=de[q])}return W}function v(W,te){var de=W.replace(/\|/g,function(se,he,ge){for(var We=!1,Ne=he;--Ne>=0&&ge[Ne]==="\\";)We=!We;return We?"|":" |"}),q=de.split(/ \|/),J=0;if(q.length>te)q.splice(te);else for(;q.length<te;)q.push("");for(;J<q.length;J++)q[J]=q[J].trim().replace(/\\\|/g,"|");return q}function D(W,te,de){var q=W.length;if(q===0)return"";for(var J=0;J<q;){var se=W.charAt(q-J-1);if(se===te&&!de)J++;else if(se!==te&&de)J++;else break}return W.substr(0,q-J)}function h(W,te){if(W.indexOf(te[1])===-1)return-1;for(var de=W.length,q=0,J=0;J<de;J++)if(W[J]==="\\")J++;else if(W[J]===te[0])q++;else if(W[J]===te[1]&&(q--,q<0))return J;return-1}function p(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(W,te){if(te<1)return"";for(var de="";te>1;)te&1&&(de+=W),te>>=1,W+=W;return de+W}var F={escape:m,unescape:s,edit:g,cleanUrl:d,resolveUrl:a,noopTest:l,merge:f,splitCells:v,rtrim:D,findClosingBracket:h,checkSanitizeDeprecation:p,repeatString:I},z=S.defaults,ue=F.rtrim,H=F.splitCells,B=F.escape,K=F.findClosingBracket;function L(W,te,de){var q=te.href,J=te.title?B(te.title):null,se=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:de,href:q,title:J,text:se}:{type:"image",raw:de,href:q,title:J,text:B(se)}}function U(W,te){var de=W.match(/^(\s+)(?:```)/);if(de===null)return te;var q=de[1];return te.split(`
`).map(function(J){var se=J.match(/^\s+/);if(se===null)return J;var he=se[0];return he.length>=q.length?J.slice(q.length):J}).join(`
`)}var x=function(){function W(de){this.options=de||z}var te=W.prototype;return te.space=function(q){var J=this.rules.block.newline.exec(q);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},te.code=function(q){var J=this.rules.block.code.exec(q);if(J){var se=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?se:ue(se,`
`)}}},te.fences=function(q){var J=this.rules.block.fences.exec(q);if(J){var se=J[0],he=U(se,J[3]||"");return{type:"code",raw:se,lang:J[2]?J[2].trim():J[2],text:he}}},te.heading=function(q){var J=this.rules.block.heading.exec(q);if(J){var se=J[2].trim();if(/#$/.test(se)){var he=ue(se,"#");(this.options.pedantic||!he||/ $/.test(he))&&(se=he.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:se}}},te.nptable=function(q){var J=this.rules.block.nptable.exec(q);if(J){var se={type:"table",header:H(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(se.header.length===se.align.length){var he=se.align.length,ge;for(ge=0;ge<he;ge++)/^ *-+: *$/.test(se.align[ge])?se.align[ge]="right":/^ *:-+: *$/.test(se.align[ge])?se.align[ge]="center":/^ *:-+ *$/.test(se.align[ge])?se.align[ge]="left":se.align[ge]=null;for(he=se.cells.length,ge=0;ge<he;ge++)se.cells[ge]=H(se.cells[ge],se.header.length);return se}}},te.hr=function(q){var J=this.rules.block.hr.exec(q);if(J)return{type:"hr",raw:J[0]}},te.blockquote=function(q){var J=this.rules.block.blockquote.exec(q);if(J){var se=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:se}}},te.list=function(q){var J=this.rules.block.list.exec(q);if(J){var se=J[0],he=J[2],ge=he.length>1,We={type:"list",raw:se,ordered:ge,start:ge?+he.slice(0,-1):"",loose:!1,items:[]},Ne=J[0].match(this.rules.block.item),je=!1,Ye,Ze,ct,lt,it,Ve,ve,De,ae=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var V=0;V<ae;V++){if(Ye=Ne[V],se=Ye,V!==ae-1){if(lt=this.rules.block.listItemStart.exec(Ne[V+1]),this.options.pedantic?lt[1].length>ct[1].length:lt[1].length>ct[0].length||lt[1].length>3){Ne.splice(V,2,Ne[V]+`
`+Ne[V+1]),V--,ae--;continue}else(!this.options.pedantic||this.options.smartLists?lt[2][lt[2].length-1]!==he[he.length-1]:ge===(lt[2].length===1))&&(it=Ne.slice(V+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-it.length),V=ae-1);ct=lt}Ze=Ye.length,Ye=Ye.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ye.indexOf(`
 `)&&(Ze-=Ye.length,Ye=this.options.pedantic?Ye.replace(/^ {1,4}/gm,""):Ye.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),Ve=je||/\n\n(?!\s*$)/.test(Ye),V!==ae-1&&(je=Ye.charAt(Ye.length-1)===`
`,Ve||(Ve=je)),Ve&&(We.loose=!0),this.options.gfm&&(ve=/^\[[ xX]\] /.test(Ye),De=void 0,ve&&(De=Ye[1]!==" ",Ye=Ye.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:se,task:ve,checked:De,loose:Ve,text:Ye})}return We}},te.html=function(q){var J=this.rules.block.html.exec(q);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):B(J[0]):J[0]}},te.def=function(q){var J=this.rules.block.def.exec(q);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var se=J[1].toLowerCase().replace(/\s+/g," ");return{tag:se,raw:J[0],href:J[2],title:J[3]}}},te.table=function(q){var J=this.rules.block.table.exec(q);if(J){var se={type:"table",header:H(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=J[0];var he=se.align.length,ge;for(ge=0;ge<he;ge++)/^ *-+: *$/.test(se.align[ge])?se.align[ge]="right":/^ *:-+: *$/.test(se.align[ge])?se.align[ge]="center":/^ *:-+ *$/.test(se.align[ge])?se.align[ge]="left":se.align[ge]=null;for(he=se.cells.length,ge=0;ge<he;ge++)se.cells[ge]=H(se.cells[ge].replace(/^ *\| *| *\| *$/g,""),se.header.length);return se}}},te.lheading=function(q){var J=this.rules.block.lheading.exec(q);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},te.paragraph=function(q){var J=this.rules.block.paragraph.exec(q);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},te.text=function(q){var J=this.rules.block.text.exec(q);if(J)return{type:"text",raw:J[0],text:J[0]}},te.escape=function(q){var J=this.rules.inline.escape.exec(q);if(J)return{type:"escape",raw:J[0],text:B(J[1])}},te.tag=function(q,J,se){var he=this.rules.inline.tag.exec(q);if(he)return!J&&/^<a /i.test(he[0])?J=!0:J&&/^<\/a>/i.test(he[0])&&(J=!1),!se&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?se=!0:se&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(se=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:J,inRawBlock:se,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):B(he[0]):he[0]}},te.link=function(q){var J=this.rules.inline.link.exec(q);if(J){var se=J[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var he=ue(se.slice(0,-1),"\\");if((se.length-he.length)%2==0)return}else{var ge=K(J[2],"()");if(ge>-1){var We=J[0].indexOf("!")===0?5:4,Ne=We+J[1].length+ge;J[2]=J[2].substring(0,ge),J[0]=J[0].substring(0,Ne).trim(),J[3]=""}}var je=J[2],Ye="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);Ze&&(je=Ze[1],Ye=Ze[3])}else Ye=J[3]?J[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(se)?je=je.slice(1):je=je.slice(1,-1)),L(J,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Ye&&Ye.replace(this.rules.inline._escapes,"$1")},J[0])}},te.reflink=function(q,J){var se;if((se=this.rules.inline.reflink.exec(q))||(se=this.rules.inline.nolink.exec(q))){var he=(se[2]||se[1]).replace(/\s+/g," ");if(he=J[he.toLowerCase()],!he||!he.href){var ge=se[0].charAt(0);return{type:"text",raw:ge,text:ge}}return L(se,he,se[0])}},te.emStrong=function(q,J,se){se===void 0&&(se="");var he=this.rules.inline.emStrong.lDelim.exec(q);if(!!he&&!(he[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=he[1]||he[2]||"";if(!ge||ge&&(se===""||this.rules.inline.punctuation.exec(se))){var We=he[0].length-1,Ne,je,Ye=We,Ze=0,ct=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,J=J.slice(-1*q.length+We);(he=ct.exec(J))!=null;)if(Ne=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Ne){if(je=Ne.length,he[3]||he[4]){Ye+=je;continue}else if((he[5]||he[6])&&We%3&&!((We+je)%3)){Ze+=je;continue}if(Ye-=je,!(Ye>0)){if(Ye+Ze-je<=0&&!J.slice(ct.lastIndex).match(ct)&&(je=Math.min(je,je+Ye+Ze)),Math.min(We,je)%2)return{type:"em",raw:q.slice(0,We+he.index+je+1),text:q.slice(1,We+he.index+je)};if(Math.min(We,je)%2==0)return{type:"strong",raw:q.slice(0,We+he.index+je+1),text:q.slice(2,We+he.index+je-1)}}}}}},te.codespan=function(q){var J=this.rules.inline.code.exec(q);if(J){var se=J[2].replace(/\n/g," "),he=/[^ ]/.test(se),ge=/^ /.test(se)&&/ $/.test(se);return he&&ge&&(se=se.substring(1,se.length-1)),se=B(se,!0),{type:"codespan",raw:J[0],text:se}}},te.br=function(q){var J=this.rules.inline.br.exec(q);if(J)return{type:"br",raw:J[0]}},te.del=function(q){var J=this.rules.inline.del.exec(q);if(J)return{type:"del",raw:J[0],text:J[2]}},te.autolink=function(q,J){var se=this.rules.inline.autolink.exec(q);if(se){var he,ge;return se[2]==="@"?(he=B(this.options.mangle?J(se[1]):se[1]),ge="mailto:"+he):(he=B(se[1]),ge=he),{type:"link",raw:se[0],text:he,href:ge,tokens:[{type:"text",raw:he,text:he}]}}},te.url=function(q,J){var se;if(se=this.rules.inline.url.exec(q)){var he,ge;if(se[2]==="@")he=B(this.options.mangle?J(se[0]):se[0]),ge="mailto:"+he;else{var We;do We=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(We!==se[0]);he=B(se[0]),se[1]==="www."?ge="http://"+he:ge=he}return{type:"link",raw:se[0],text:he,href:ge,tokens:[{type:"text",raw:he,text:he}]}}},te.inlineText=function(q,J,se){var he=this.rules.inline.text.exec(q);if(he){var ge;return J?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):B(he[0]):he[0]:ge=B(this.options.smartypants?se(he[0]):he[0]),{type:"text",raw:he[0],text:ge}}},W}(),Q=F.noopTest,$=F.edit,Z=F.merge,ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=$(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ie.item=$(ie.item,"gm").replace(/bull/g,ie.bullet).getRegex(),ie.listItemStart=$(/^( *)(bull)/).replace("bull",ie.bullet).getRegex(),ie.list=$(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=$(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=$(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=$(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=Z({},ie),ie.gfm=Z({},ie.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.nptable=$(ie.gfm.nptable).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.table=$(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=Z({},ie.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:$(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=$(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=$(ie._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=$(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=$(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=$(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=$(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=$(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=$(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=$(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=$(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=Z({},re),re.pedantic=Z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=Z({},re.normal,{escape:$(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=$(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=Z({},re.gfm,{br:$(re.br).replace("{2,}","*").getRegex(),text:$(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:ie,inline:re},Ie=S.defaults,Ue=ye.block,Re=ye.inline,ze=F.repeatString;function N(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(W){var te="",de,q,J=W.length;for(de=0;de<J;de++)q=W.charCodeAt(de),Math.random()>.5&&(q="x"+q.toString(16)),te+="&#"+q+";";return te}var ee=function(){function W(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Ie,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:Ue.normal,inline:Re.normal};this.options.pedantic?(q.block=Ue.pedantic,q.inline=Re.pedantic):this.options.gfm&&(q.block=Ue.gfm,this.options.breaks?q.inline=Re.breaks:q.inline=Re.gfm),this.tokenizer.rules=q}W.lex=function(q,J){var se=new W(J);return se.lex(q)},W.lexInline=function(q,J){var se=new W(J);return se.inlineTokens(q)};var te=W.prototype;return te.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},te.blockTokens=function(q,J,se){J===void 0&&(J=[]),se===void 0&&(se=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var he,ge,We,Ne;q;){if(he=this.tokenizer.space(q)){q=q.substring(he.raw.length),he.type&&J.push(he);continue}if(he=this.tokenizer.code(q)){q=q.substring(he.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text):J.push(he);continue}if(he=this.tokenizer.fences(q)){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.heading(q)){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.nptable(q)){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.hr(q)){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.blockquote(q)){q=q.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],se),J.push(he);continue}if(he=this.tokenizer.list(q)){for(q=q.substring(he.raw.length),We=he.items.length,ge=0;ge<We;ge++)he.items[ge].tokens=this.blockTokens(he.items[ge].text,[],!1);J.push(he);continue}if(he=this.tokenizer.html(q)){q=q.substring(he.raw.length),J.push(he);continue}if(se&&(he=this.tokenizer.def(q))){q=q.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(q)){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.lheading(q)){q=q.substring(he.raw.length),J.push(he);continue}if(se&&(he=this.tokenizer.paragraph(q))){q=q.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.text(q)){q=q.substring(he.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+he.raw,Ne.text+=`
`+he.text):J.push(he);continue}if(q){var je="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return J},te.inline=function(q){var J,se,he,ge,We,Ne,je=q.length;for(J=0;J<je;J++)switch(Ne=q[J],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ge=Ne.header.length,se=0;se<ge;se++)Ne.tokens.header[se]=[],this.inlineTokens(Ne.header[se],Ne.tokens.header[se]);for(ge=Ne.cells.length,se=0;se<ge;se++)for(We=Ne.cells[se],Ne.tokens.cells[se]=[],he=0;he<We.length;he++)Ne.tokens.cells[se][he]=[],this.inlineTokens(We[he],Ne.tokens.cells[se][he]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ge=Ne.items.length,se=0;se<ge;se++)this.inline(Ne.items[se].tokens);break}}return q},te.inlineTokens=function(q,J,se,he){J===void 0&&(J=[]),se===void 0&&(se=!1),he===void 0&&(he=!1);var ge,We,Ne=q,je,Ye,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,je.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Ye||(Ze=""),Ye=!1,ge=this.tokenizer.escape(q)){q=q.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.tag(q,se,he)){q=q.substring(ge.raw.length),se=ge.inLink,he=ge.inRawBlock;var lt=J[J.length-1];lt&&ge.type==="text"&&lt.type==="text"?(lt.raw+=ge.raw,lt.text+=ge.text):J.push(ge);continue}if(ge=this.tokenizer.link(q)){q=q.substring(ge.raw.length),ge.type==="link"&&(ge.tokens=this.inlineTokens(ge.text,[],!0,he)),J.push(ge);continue}if(ge=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(ge.raw.length);var it=J[J.length-1];ge.type==="link"?(ge.tokens=this.inlineTokens(ge.text,[],!0,he),J.push(ge)):it&&ge.type==="text"&&it.type==="text"?(it.raw+=ge.raw,it.text+=ge.text):J.push(ge);continue}if(ge=this.tokenizer.emStrong(q,Ne,Ze)){q=q.substring(ge.raw.length),ge.tokens=this.inlineTokens(ge.text,[],se,he),J.push(ge);continue}if(ge=this.tokenizer.codespan(q)){q=q.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.br(q)){q=q.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.del(q)){q=q.substring(ge.raw.length),ge.tokens=this.inlineTokens(ge.text,[],se,he),J.push(ge);continue}if(ge=this.tokenizer.autolink(q,G)){q=q.substring(ge.raw.length),J.push(ge);continue}if(!se&&(ge=this.tokenizer.url(q,G))){q=q.substring(ge.raw.length),J.push(ge);continue}if(ge=this.tokenizer.inlineText(q,he,N)){q=q.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(Ze=ge.raw.slice(-1)),Ye=!0,We=J[J.length-1],We&&We.type==="text"?(We.raw+=ge.raw,We.text+=ge.text):J.push(ge);continue}if(q){var Ve="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return J},e(W,null,[{key:"rules",get:function(){return{block:Ue,inline:Re}}}]),W}(),oe=S.defaults,fe=F.cleanUrl,Se=F.escape,Le=function(){function W(de){this.options=de||oe}var te=W.prototype;return te.code=function(q,J,se){var he=(J||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(q,he);ge!=null&&ge!==q&&(se=!0,q=ge)}return q=q.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(se?q:Se(q,!0))+`</code></pre>
`:"<pre><code>"+(se?q:Se(q,!0))+`</code></pre>
`},te.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},te.html=function(q){return q},te.heading=function(q,J,se,he){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+he.slug(se)+'">'+q+"</h"+J+`>
`:"<h"+J+">"+q+"</h"+J+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(q,J,se){var he=J?"ol":"ul",ge=J&&se!==1?' start="'+se+'"':"";return"<"+he+ge+`>
`+q+"</"+he+`>
`},te.listitem=function(q){return"<li>"+q+`</li>
`},te.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(q){return"<p>"+q+`</p>
`},te.table=function(q,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+J+`</table>
`},te.tablerow=function(q){return`<tr>
`+q+`</tr>
`},te.tablecell=function(q,J){var se=J.header?"th":"td",he=J.align?"<"+se+' align="'+J.align+'">':"<"+se+">";return he+q+"</"+se+`>
`},te.strong=function(q){return"<strong>"+q+"</strong>"},te.em=function(q){return"<em>"+q+"</em>"},te.codespan=function(q){return"<code>"+q+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(q){return"<del>"+q+"</del>"},te.link=function(q,J,se){if(q=fe(this.options.sanitize,this.options.baseUrl,q),q===null)return se;var he='<a href="'+Se(q)+'"';return J&&(he+=' title="'+J+'"'),he+=">"+se+"</a>",he},te.image=function(q,J,se){if(q=fe(this.options.sanitize,this.options.baseUrl,q),q===null)return se;var he='<img src="'+q+'" alt="'+se+'"';return J&&(he+=' title="'+J+'"'),he+=this.options.xhtml?"/>":">",he},te.text=function(q){return q},W}(),me=function(){function W(){}var te=W.prototype;return te.strong=function(q){return q},te.em=function(q){return q},te.codespan=function(q){return q},te.del=function(q){return q},te.html=function(q){return q},te.text=function(q){return q},te.link=function(q,J,se){return""+se},te.image=function(q,J,se){return""+se},te.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var te=W.prototype;return te.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(q,J){var se=q,he=0;if(this.seen.hasOwnProperty(se)){he=this.seen[q];do he++,se=q+"-"+he;while(this.seen.hasOwnProperty(se))}return J||(this.seen[q]=he,this.seen[se]=0),se},te.slug=function(q,J){J===void 0&&(J={});var se=this.serialize(q);return this.getNextSafeSlug(se,J.dryrun)},W}(),Pe=S.defaults,xe=F.unescape,_e=function(){function W(de){this.options=de||Pe,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new Ce}W.parse=function(q,J){var se=new W(J);return se.parse(q)},W.parseInline=function(q,J){var se=new W(J);return se.parseInline(q)};var te=W.prototype;return te.parse=function(q,J){J===void 0&&(J=!0);var se="",he,ge,We,Ne,je,Ye,Ze,ct,lt,it,Ve,ve,De,ae,V,Me,Ae,et,Qe=q.length;for(he=0;he<Qe;he++)switch(it=q[he],it.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(it.tokens),it.depth,xe(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(ct="",Ze="",Ne=it.header.length,ge=0;ge<Ne;ge++)Ze+=this.renderer.tablecell(this.parseInline(it.tokens.header[ge]),{header:!0,align:it.align[ge]});for(ct+=this.renderer.tablerow(Ze),lt="",Ne=it.cells.length,ge=0;ge<Ne;ge++){for(Ye=it.tokens.cells[ge],Ze="",je=Ye.length,We=0;We<je;We++)Ze+=this.renderer.tablecell(this.parseInline(Ye[We]),{header:!1,align:it.align[We]});lt+=this.renderer.tablerow(Ze)}se+=this.renderer.table(ct,lt);continue}case"blockquote":{lt=this.parse(it.tokens),se+=this.renderer.blockquote(lt);continue}case"list":{for(Ve=it.ordered,ve=it.start,De=it.loose,Ne=it.items.length,lt="",ge=0;ge<Ne;ge++)V=it.items[ge],Me=V.checked,Ae=V.task,ae="",V.task&&(et=this.renderer.checkbox(Me),De?V.tokens.length>0&&V.tokens[0].type==="text"?(V.tokens[0].text=et+" "+V.tokens[0].text,V.tokens[0].tokens&&V.tokens[0].tokens.length>0&&V.tokens[0].tokens[0].type==="text"&&(V.tokens[0].tokens[0].text=et+" "+V.tokens[0].tokens[0].text)):V.tokens.unshift({type:"text",text:et}):ae+=et),ae+=this.parse(V.tokens,De),lt+=this.renderer.listitem(ae,Ae,Me);se+=this.renderer.list(lt,Ve,ve);continue}case"html":{se+=this.renderer.html(it.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(lt=it.tokens?this.parseInline(it.tokens):it.text;he+1<Qe&&q[he+1].type==="text";)it=q[++he],lt+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);se+=J?this.renderer.paragraph(lt):lt;continue}default:{var at='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return se},te.parseInline=function(q,J){J=J||this.renderer;var se="",he,ge,We=q.length;for(he=0;he<We;he++)switch(ge=q[he],ge.type){case"escape":{se+=J.text(ge.text);break}case"html":{se+=J.html(ge.text);break}case"link":{se+=J.link(ge.href,ge.title,this.parseInline(ge.tokens,J));break}case"image":{se+=J.image(ge.href,ge.title,ge.text);break}case"strong":{se+=J.strong(this.parseInline(ge.tokens,J));break}case"em":{se+=J.em(this.parseInline(ge.tokens,J));break}case"codespan":{se+=J.codespan(ge.text);break}case"br":{se+=J.br();break}case"del":{se+=J.del(this.parseInline(ge.tokens,J));break}case"text":{se+=J.text(ge.text);break}default:{var Ne='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return se},W}(),Ke=F.merge,j=F.checkSanitizeDeprecation,Y=F.escape,pe=S.getDefaults,Fe=S.changeDefaults,He=S.defaults;function Oe(W,te,de){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof te=="function"&&(de=te,te=null),te=Ke({},Oe.defaults,te||{}),j(te),de){var q=te.highlight,J;try{J=ee.lex(W,te)}catch(We){return de(We)}var se=function(Ne){var je;if(!Ne)try{je=_e.parse(J,te)}catch(Ye){Ne=Ye}return te.highlight=q,Ne?de(Ne):de(null,je)};if(!q||q.length<3||(delete te.highlight,!J.length))return se();var he=0;Oe.walkTokens(J,function(We){We.type==="code"&&(he++,setTimeout(function(){q(We.text,We.lang,function(Ne,je){if(Ne)return se(Ne);je!=null&&je!==We.text&&(We.text=je,We.escaped=!0),he--,he===0&&se()})},0))}),he===0&&se();return}try{var ge=ee.lex(W,te);return te.walkTokens&&Oe.walkTokens(ge,te.walkTokens),_e.parse(ge,te)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Y(We.message+"",!0)+"</pre>";throw We}}Oe.options=Oe.setOptions=function(W){return Ke(Oe.defaults,W),Fe(Oe.defaults),Oe},Oe.getDefaults=pe,Oe.defaults=He,Oe.use=function(W){var te=Ke({},W);if(W.renderer&&function(){var q=Oe.defaults.renderer||new Le,J=function(ge){var We=q[ge];q[ge]=function(){for(var Ne=arguments.length,je=new Array(Ne),Ye=0;Ye<Ne;Ye++)je[Ye]=arguments[Ye];var Ze=W.renderer[ge].apply(q,je);return Ze===!1&&(Ze=We.apply(q,je)),Ze}};for(var se in W.renderer)J(se);te.renderer=q}(),W.tokenizer&&function(){var q=Oe.defaults.tokenizer||new x,J=function(ge){var We=q[ge];q[ge]=function(){for(var Ne=arguments.length,je=new Array(Ne),Ye=0;Ye<Ne;Ye++)je[Ye]=arguments[Ye];var Ze=W.tokenizer[ge].apply(q,je);return Ze===!1&&(Ze=We.apply(q,je)),Ze}};for(var se in W.tokenizer)J(se);te.tokenizer=q}(),W.walkTokens){var de=Oe.defaults.walkTokens;te.walkTokens=function(q){W.walkTokens(q),de&&de(q)}}Oe.setOptions(te)},Oe.walkTokens=function(W,te){for(var de=T(W),q;!(q=de()).done;){var J=q.value;switch(te(J),J.type){case"table":{for(var se=T(J.tokens.header),he;!(he=se()).done;){var ge=he.value;Oe.walkTokens(ge,te)}for(var We=T(J.tokens.cells),Ne;!(Ne=We()).done;)for(var je=Ne.value,Ye=T(je),Ze;!(Ze=Ye()).done;){var ct=Ze.value;Oe.walkTokens(ct,te)}break}case"list":{Oe.walkTokens(J.items,te);break}default:J.tokens&&Oe.walkTokens(J.tokens,te)}}},Oe.parseInline=function(W,te){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");te=Ke({},Oe.defaults,te||{}),j(te);try{var de=ee.lexInline(W,te);return te.walkTokens&&Oe.walkTokens(de,te.walkTokens),_e.parseInline(de,te)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Y(q.message+"",!0)+"</pre>";throw q}},Oe.Parser=_e,Oe.parser=_e.parse,Oe.Renderer=Le,Oe.TextRenderer=me,Oe.Lexer=ee,Oe.lexer=ee.lex,Oe.Tokenizer=x,Oe.Slugger=Ce,Oe.parse=Oe;var tt=Oe;return tt}),define(be[78],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function y(S,k,E){return Math.min(Math.max(S,k),E)}e.clamp=y;function R(S,k){return(k+S%k)%k}e.rot=R;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function le(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function S(E){P.push(E,Date.now())}function k(){const E=[];for(let n=0;n<P.length;n+=2)E.push({name:P[n],startTime:P[n+1]});return E}return{mark:S,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const S of performance.getEntriesByType("mark"))P.push({name:S.name,startTime:Math.round(T+S.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function y(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))})(),define(be[21],we([0,1]),function(le,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let T=!1,P=!1,S=!1,k=!1,E=!1,n=!1,A=!1,C,b=R,m,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof process!="undefined"?s=process:typeof e.globals.vscode!="undefined"&&(s=e.globals.vscode.process);const _=typeof((y=s==null?void 0:s.versions)===null||y===void 0?void 0:y.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=_&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=s==null?void 0:s.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)r=navigator.userAgent,T=r.indexOf("Windows")>=0,P=r.indexOf("Macintosh")>=0,A=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,n=!0,C=navigator.language,b=C;else if(typeof s=="object"){T=s.platform==="win32",P=s.platform==="darwin",S=s.platform==="linux",k=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,C=R,b=R;const a=s.env.VSCODE_NLS_CONFIG;if(a)try{const l=JSON.parse(a),f=l.availableLanguages["*"];C=l.locale,b=f||R,m=l._translationsConfigFile}catch(l){}E=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let c=0;P?c=1:T?c=3:S&&(c=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=S,e.isLinuxSnap=k,e.isNative=E,e.isWeb=n,e.isIOS=A,e.platform=c,e.userAgent=r,e.language=b;var d;(function(a){function l(){return e.language}a.value=l;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function v(){return e.language==="en"}a.isDefault=v})(d=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let h=0,p=f.length;h<p;h++){const I=f[h];if(I.id===D.data.vscodeSetImmediateId){f.splice(h,1),I.callback();return}}});let v=0;return D=>{const h=++v;f.push({id:h,callback:D}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const l=Promise.resolve();return f=>l.then(f)}();var o;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||A?2:T?1:3;let t=!0,i=!1;function u(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=u}),define(be[32],we([0,1,21]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof process!="undefined")R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}};else if(typeof y.globals.vscode!="undefined"){const T=y.globals.vscode.process;R={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(P){return(0,y.setImmediate)(P)}}}else R={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},nextTick(T){return(0,y.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[11],we([0,1,32]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,T=97,P=90,S=122,k=46,E=47,n=92,A=58,C=63;class b extends Error{constructor(d,o,t){let i;typeof o=="string"&&o.indexOf("not ")===0?(i="must not be",o=o.replace(/^not /,"")):i="must be";const u=d.indexOf(".")!==-1?"property":"argument";let a=`The "${d}" ${u} ${i} of type ${o}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,d){if(typeof c!="string")throw new b(d,"string",c)}function r(c){return c===E||c===n}function s(c){return c===E}function _(c){return c>=R&&c<=P||c>=T&&c<=S}function g(c,d,o,t){let i="",u=0,a=-1,l=0,f=0;for(let v=0;v<=c.length;++v){if(v<c.length)f=c.charCodeAt(v);else{if(t(f))break;f=E}if(t(f)){if(!(a===v-1||l===1))if(l===2){if(i.length<2||u!==2||i.charCodeAt(i.length-1)!==k||i.charCodeAt(i.length-2)!==k){if(i.length>2){const D=i.lastIndexOf(o);D===-1?(i="",u=0):(i=i.slice(0,D),u=i.length-1-i.lastIndexOf(o)),a=v,l=0;continue}else if(i.length!==0){i="",u=0,a=v,l=0;continue}}d&&(i+=i.length>0?`${o}..`:"..",u=2)}else i.length>0?i+=`${o}${c.slice(a+1,v)}`:i=c.slice(a+1,v),u=v-a-1;a=v,l=0}else f===k&&l!==-1?++l:l=-1}return i}function w(c,d){if(d===null||typeof d!="object")throw new b("pathObject","Object",d);const o=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return o?o===d.root?`${o}${t}`:`${o}${c}${t}`:t}e.win32={resolve(...c){let d="",o="",t=!1;for(let i=c.length-1;i>=-1;i--){let u;if(i>=0){if(u=c[i],m(u,"path"),u.length===0)continue}else d.length===0?u=y.cwd():(u=y.env[`=${d}`]||y.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==d.toLowerCase()&&u.charCodeAt(2)===n)&&(u=`${d}\\`));const a=u.length;let l=0,f="",v=!1;const D=u.charCodeAt(0);if(a===1)r(D)&&(l=1,v=!0);else if(r(D))if(v=!0,r(u.charCodeAt(1))){let h=2,p=h;for(;h<a&&!r(u.charCodeAt(h));)h++;if(h<a&&h!==p){const I=u.slice(p,h);for(p=h;h<a&&r(u.charCodeAt(h));)h++;if(h<a&&h!==p){for(p=h;h<a&&!r(u.charCodeAt(h));)h++;(h===a||h!==p)&&(f=`\\\\${I}\\${u.slice(p,h)}`,l=h)}}}else l=1;else _(D)&&u.charCodeAt(1)===A&&(f=u.slice(0,2),l=2,a>2&&r(u.charCodeAt(2))&&(v=!0,l=3));if(f.length>0)if(d.length>0){if(f.toLowerCase()!==d.toLowerCase())continue}else d=f;if(t){if(d.length>0)break}else if(o=`${u.slice(l)}\\${o}`,t=v,v&&d.length>0)break}return o=g(o,!t,"\\",r),t?`${d}\\${o}`:`${d}${o}`||"."},normalize(c){m(c,"path");const d=c.length;if(d===0)return".";let o=0,t,i=!1;const u=c.charCodeAt(0);if(d===1)return s(u)?"\\":c;if(r(u))if(i=!0,r(c.charCodeAt(1))){let l=2,f=l;for(;l<d&&!r(c.charCodeAt(l));)l++;if(l<d&&l!==f){const v=c.slice(f,l);for(f=l;l<d&&r(c.charCodeAt(l));)l++;if(l<d&&l!==f){for(f=l;l<d&&!r(c.charCodeAt(l));)l++;if(l===d)return`\\\\${v}\\${c.slice(f)}\\`;l!==f&&(t=`\\\\${v}\\${c.slice(f,l)}`,o=l)}}}else o=1;else _(u)&&c.charCodeAt(1)===A&&(t=c.slice(0,2),o=2,d>2&&r(c.charCodeAt(2))&&(i=!0,o=3));let a=o<d?g(c.slice(o),!i,"\\",r):"";return a.length===0&&!i&&(a="."),a.length>0&&r(c.charCodeAt(d-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(c){m(c,"path");const d=c.length;if(d===0)return!1;const o=c.charCodeAt(0);return r(o)||d>2&&_(o)&&c.charCodeAt(1)===A&&r(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let d,o;for(let u=0;u<c.length;++u){const a=c[u];m(a,"path"),a.length>0&&(d===void 0?d=o=a:d+=`\\${a}`)}if(d===void 0)return".";let t=!0,i=0;if(typeof o=="string"&&r(o.charCodeAt(0))){++i;const u=o.length;u>1&&r(o.charCodeAt(1))&&(++i,u>2&&(r(o.charCodeAt(2))?++i:t=!1))}if(t){for(;i<d.length&&r(d.charCodeAt(i));)i++;i>=2&&(d=`\\${d.slice(i)}`)}return e.win32.normalize(d)},relative(c,d){if(m(c,"from"),m(d,"to"),c===d)return"";const o=e.win32.resolve(c),t=e.win32.resolve(d);if(o===t||(c=o.toLowerCase(),d=t.toLowerCase(),c===d))return"";let i=0;for(;i<c.length&&c.charCodeAt(i)===n;)i++;let u=c.length;for(;u-1>i&&c.charCodeAt(u-1)===n;)u--;const a=u-i;let l=0;for(;l<d.length&&d.charCodeAt(l)===n;)l++;let f=d.length;for(;f-1>l&&d.charCodeAt(f-1)===n;)f--;const v=f-l,D=a<v?a:v;let h=-1,p=0;for(;p<D;p++){const F=c.charCodeAt(i+p);if(F!==d.charCodeAt(l+p))break;F===n&&(h=p)}if(p!==D){if(h===-1)return t}else{if(v>D){if(d.charCodeAt(l+p)===n)return t.slice(l+p+1);if(p===2)return t.slice(l+p)}a>D&&(c.charCodeAt(i+p)===n?h=p:p===2&&(h=3)),h===-1&&(h=0)}let I="";for(p=i+h+1;p<=u;++p)(p===u||c.charCodeAt(p)===n)&&(I+=I.length===0?"..":"\\..");return l+=h,I.length>0?`${I}${t.slice(l,f)}`:(t.charCodeAt(l)===n&&++l,t.slice(l,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const d=e.win32.resolve(c);if(d.length<=2)return c;if(d.charCodeAt(0)===n){if(d.charCodeAt(1)===n){const o=d.charCodeAt(2);if(o!==C&&o!==k)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(_(d.charCodeAt(0))&&d.charCodeAt(1)===A&&d.charCodeAt(2)===n)return`\\\\?\\${d}`;return c},dirname(c){m(c,"path");const d=c.length;if(d===0)return".";let o=-1,t=0;const i=c.charCodeAt(0);if(d===1)return r(i)?c:".";if(r(i)){if(o=t=1,r(c.charCodeAt(1))){let l=2,f=l;for(;l<d&&!r(c.charCodeAt(l));)l++;if(l<d&&l!==f){for(f=l;l<d&&r(c.charCodeAt(l));)l++;if(l<d&&l!==f){for(f=l;l<d&&!r(c.charCodeAt(l));)l++;if(l===d)return c;l!==f&&(o=t=l+1)}}}}else _(i)&&c.charCodeAt(1)===A&&(o=d>2&&r(c.charCodeAt(2))?3:2,t=o);let u=-1,a=!0;for(let l=d-1;l>=t;--l)if(r(c.charCodeAt(l))){if(!a){u=l;break}}else a=!1;if(u===-1){if(o===-1)return".";u=o}return c.slice(0,u)},basename(c,d){d!==void 0&&m(d,"ext"),m(c,"path");let o=0,t=-1,i=!0,u;if(c.length>=2&&_(c.charCodeAt(0))&&c.charCodeAt(1)===A&&(o=2),d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let a=d.length-1,l=-1;for(u=c.length-1;u>=o;--u){const f=c.charCodeAt(u);if(r(f)){if(!i){o=u+1;break}}else l===-1&&(i=!1,l=u+1),a>=0&&(f===d.charCodeAt(a)?--a==-1&&(t=u):(a=-1,t=l))}return o===t?t=l:t===-1&&(t=c.length),c.slice(o,t)}for(u=c.length-1;u>=o;--u)if(r(c.charCodeAt(u))){if(!i){o=u+1;break}}else t===-1&&(i=!1,t=u+1);return t===-1?"":c.slice(o,t)},extname(c){m(c,"path");let d=0,o=-1,t=0,i=-1,u=!0,a=0;c.length>=2&&c.charCodeAt(1)===A&&_(c.charCodeAt(0))&&(d=t=2);for(let l=c.length-1;l>=d;--l){const f=c.charCodeAt(l);if(r(f)){if(!u){t=l+1;break}continue}i===-1&&(u=!1,i=l+1),f===k?o===-1?o=l:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===t+1?"":c.slice(o,i)},format:w.bind(null,"\\"),parse(c){m(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const o=c.length;let t=0,i=c.charCodeAt(0);if(o===1)return r(i)?(d.root=d.dir=c,d):(d.base=d.name=c,d);if(r(i)){if(t=1,r(c.charCodeAt(1))){let h=2,p=h;for(;h<o&&!r(c.charCodeAt(h));)h++;if(h<o&&h!==p){for(p=h;h<o&&r(c.charCodeAt(h));)h++;if(h<o&&h!==p){for(p=h;h<o&&!r(c.charCodeAt(h));)h++;h===o?t=h:h!==p&&(t=h+1)}}}}else if(_(i)&&c.charCodeAt(1)===A){if(o<=2)return d.root=d.dir=c,d;if(t=2,r(c.charCodeAt(2))){if(o===3)return d.root=d.dir=c,d;t=3}}t>0&&(d.root=c.slice(0,t));let u=-1,a=t,l=-1,f=!0,v=c.length-1,D=0;for(;v>=t;--v){if(i=c.charCodeAt(v),r(i)){if(!f){a=v+1;break}continue}l===-1&&(f=!1,l=v+1),i===k?u===-1?u=v:D!==1&&(D=1):u!==-1&&(D=-1)}return l!==-1&&(u===-1||D===0||D===1&&u===l-1&&u===a+1?d.base=d.name=c.slice(a,l):(d.name=c.slice(a,u),d.base=c.slice(a,l),d.ext=c.slice(u,l))),a>0&&a!==t?d.dir=c.slice(0,a-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let d="",o=!1;for(let t=c.length-1;t>=-1&&!o;t--){const i=t>=0?c[t]:y.cwd();m(i,"path"),i.length!==0&&(d=`${i}/${d}`,o=i.charCodeAt(0)===E)}return d=g(d,!o,"/",s),o?`/${d}`:d.length>0?d:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===E,o=c.charCodeAt(c.length-1)===E;return c=g(c,!d,"/",s),c.length===0?d?"/":o?"./":".":(o&&(c+="/"),d?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===E},join(...c){if(c.length===0)return".";let d;for(let o=0;o<c.length;++o){const t=c[o];m(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(c,d){if(m(c,"from"),m(d,"to"),c===d||(c=e.posix.resolve(c),d=e.posix.resolve(d),c===d))return"";const o=1,t=c.length,i=t-o,u=1,a=d.length-u,l=i<a?i:a;let f=-1,v=0;for(;v<l;v++){const h=c.charCodeAt(o+v);if(h!==d.charCodeAt(u+v))break;h===E&&(f=v)}if(v===l)if(a>l){if(d.charCodeAt(u+v)===E)return d.slice(u+v+1);if(v===0)return d.slice(u+v)}else i>l&&(c.charCodeAt(o+v)===E?f=v:v===0&&(f=0));let D="";for(v=o+f+1;v<=t;++v)(v===t||c.charCodeAt(v)===E)&&(D+=D.length===0?"..":"/..");return`${D}${d.slice(u+f)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===E;let o=-1,t=!0;for(let i=c.length-1;i>=1;--i)if(c.charCodeAt(i)===E){if(!t){o=i;break}}else t=!1;return o===-1?d?"/":".":d&&o===1?"//":c.slice(0,o)},basename(c,d){d!==void 0&&m(d,"ext"),m(c,"path");let o=0,t=-1,i=!0,u;if(d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let a=d.length-1,l=-1;for(u=c.length-1;u>=0;--u){const f=c.charCodeAt(u);if(f===E){if(!i){o=u+1;break}}else l===-1&&(i=!1,l=u+1),a>=0&&(f===d.charCodeAt(a)?--a==-1&&(t=u):(a=-1,t=l))}return o===t?t=l:t===-1&&(t=c.length),c.slice(o,t)}for(u=c.length-1;u>=0;--u)if(c.charCodeAt(u)===E){if(!i){o=u+1;break}}else t===-1&&(i=!1,t=u+1);return t===-1?"":c.slice(o,t)},extname(c){m(c,"path");let d=-1,o=0,t=-1,i=!0,u=0;for(let a=c.length-1;a>=0;--a){const l=c.charCodeAt(a);if(l===E){if(!i){o=a+1;break}continue}t===-1&&(i=!1,t=a+1),l===k?d===-1?d=a:u!==1&&(u=1):d!==-1&&(u=-1)}return d===-1||t===-1||u===0||u===1&&d===t-1&&d===o+1?"":c.slice(d,t)},format:w.bind(null,"/"),parse(c){m(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const o=c.charCodeAt(0)===E;let t;o?(d.root="/",t=1):t=0;let i=-1,u=0,a=-1,l=!0,f=c.length-1,v=0;for(;f>=t;--f){const D=c.charCodeAt(f);if(D===E){if(!l){u=f+1;break}continue}a===-1&&(l=!1,a=f+1),D===k?i===-1?i=f:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const D=u===0&&o?1:u;i===-1||v===0||v===1&&i===a-1&&i===u+1?d.base=d.name=c.slice(D,a):(d.name=c.slice(D,i),d.base=c.slice(D,a),d.ext=c.slice(i,a))}return u>0?d.dir=c.slice(0,u-1):o&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],we([0,1,21]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=y.globals.performance&&typeof y.globals.performance.now=="function";class T{constructor(S){this._highResolution=R&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new T(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=T}),define(be[3],we([0,1,10,52,6,45,55]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(g){g.None=()=>T.Disposable.None;function w(H){return(B,K=null,L)=>{let U=!1,x;return x=H(Q=>{if(!U)return x?x.dispose():U=!0,B.call(K,Q)},null,L),U&&x.dispose(),x}}g.once=w;function c(H,B){return a((K,L=null,U)=>H(x=>K.call(L,B(x)),null,U))}g.map=c;function d(H,B){return a((K,L=null,U)=>H(x=>{B(x),K.call(L,x)},null,U))}g.forEach=d;function o(H,B){return a((K,L=null,U)=>H(x=>B(x)&&K.call(L,x),null,U))}g.filter=o;function t(H){return H}g.signal=t;function i(...H){return(B,K=null,L)=>(0,T.combinedDisposable)(...H.map(U=>U(x=>B.call(K,x),null,L)))}g.any=i;function u(H,B,K){let L=K;return c(H,U=>(L=B(L,U),L))}g.reduce=u;function a(H){let B;const K=new b({onFirstListenerAdd(){B=H(K.fire,K)},onLastListenerRemove(){B.dispose()}});return K.event}g.snapshot=a;function l(H,B,K=100,L=!1,U){let x,Q,$,Z=0;const ie=new b({leakWarningThreshold:U,onFirstListenerAdd(){x=H(re=>{Z++,Q=B(Q,re),L&&!$&&(ie.fire(Q),Q=void 0),clearTimeout($),$=setTimeout(()=>{const ye=Q;Q=void 0,$=void 0,(!L||Z>1)&&ie.fire(ye),Z=0},K)})},onLastListenerRemove(){x.dispose()}});return ie.event}g.debounce=l;function f(H){const B=new Date().getTime();return c(w(H),K=>new Date().getTime()-B)}g.stopwatch=f;function v(H){let B=!0,K;return o(H,L=>{const U=B||L!==K;return B=!1,K=L,U})}g.latch=v;function D(H,B=!1,K=[]){let L=K.slice(),U=H($=>{L?L.push($):Q.fire($)});const x=()=>{L&&L.forEach($=>Q.fire($)),L=null},Q=new b({onFirstListenerAdd(){U||(U=H($=>Q.fire($)))},onFirstListenerDidAdd(){L&&(B?setTimeout(x):x())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Q.event}g.buffer=D;class h{constructor(B){this.event=B}map(B){return new h(c(this.event,B))}forEach(B){return new h(d(this.event,B))}filter(B){return new h(o(this.event,B))}reduce(B,K){return new h(u(this.event,B,K))}latch(){return new h(v(this.event))}debounce(B,K=100,L=!1,U){return new h(l(this.event,B,K,L,U))}on(B,K,L){return this.event(B,K,L)}once(B,K,L){return w(this.event)(B,K,L)}}function p(H){return new h(H)}g.chain=p;function I(H,B,K=L=>L){const L=(...$)=>Q.fire(K(...$)),U=()=>H.on(B,L),x=()=>H.removeListener(B,L),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}g.fromNodeEventEmitter=I;function F(H,B,K=L=>L){const L=(...$)=>Q.fire(K(...$)),U=()=>H.addEventListener(B,L),x=()=>H.removeEventListener(B,L),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}g.fromDOMEventEmitter=F;function z(H){const B=new b;let K=!1;return H.then(void 0,()=>null).then(()=>{K?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),K=!0,B.event}g.fromPromise=z;function ue(H){return new Promise(B=>w(H)(B))}g.toPromise=ue})(k=e.Event||(e.Event={}));class E{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${E._idPool++}`}start(w){this._stopWatch=new S.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let n=-1;function A(g){const w=n;return n=g,{dispose(){n=w}}}e.setGlobalLeakWarningThreshold=A;class C{constructor(w,c=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let c=n;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||w<c)){this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(d)||0;if(this._stacks.set(d,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,i=0;for(const[u,a]of this._stacks)(!t||i<a)&&(t=u,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}}class b{constructor(w){var c;this._disposed=!1,this._options=w,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(w,c,d)=>{var o;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[w,c]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,c);const u=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let a;return a={dispose:()=>{u&&u(),a.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof T.DisposableStore?d.add(a):Array.isArray(d)&&d.push(a),a}),this._event}fire(w){var c,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,w]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(i){(0,y.onUnexpectedError)(i)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var w,c,d;(w=this._listeners)===null||w===void 0||w.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(d=this._leakageMon)===null||d===void 0||d.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class m extends b{constructor(w){super(w);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=m;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const c={event:w,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const d=()=>{this.hasListeners&&this.unhook(c);const o=this.events.indexOf(c);this.events.splice(o,1)};return(0,T.toDisposable)((0,R.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(c=>this.emitter.fire(c))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(w){return(c,d,o)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>c.call(d,t)):c.call(d,t)},void 0,o)}bufferEvents(w){const c=[];this.buffers.push(c);const d=w();return this.buffers.pop(),c.forEach(o=>o()),d}}e.EventBufferer=s;class _{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(be[20],we([0,1,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(k,E){const n=setTimeout(k.bind(E),0);return{dispose(){clearTimeout(n)}}});var T;(function(k){function E(n){return n===k.None||n===k.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}k.isCancellationToken=E,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=S}),define(be[37],we([0,1,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(A){const C=this._icons.get(A.id);C?A.description?C.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new R;e.iconRegistry=T;function P(n,A){return new S(n,A)}e.registerCodicon=P;class S{constructor(A,C,b){this.id=A,this.definition=C,this.description=b,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function k(n,A){const C=["codicon","codicon-"+n];return A&&C.push("codicon-modifier-"+A),C}e.getClassNamesArray=k;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(r){if(r instanceof S)return["codicon","codicon-"+r.id];const s=A.exec(r.id);if(!s)return C(S.error);let[,_,g]=s;const w=["codicon","codicon-"+_];return g&&w.push("codicon-modifier-"+g.substr(1)),w}n.asClassNameArray=C;function b(r){return C(r).join(" ")}n.asClassName=b;function m(r){return"."+C(r).join(".")}n.asCSSSelector=m})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[107],we([0,1,10,6]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(_){const g=_;return g&&[g.on,g.pause,g.resume,g.destroy].every(w=>typeof w=="function")}e.isReadableStream=T;function P(_){const g=_;return g&&T(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=P;function S(_,g){return new k(_,g)}e.newWriteableStream=S;class k{constructor(g,w){this.reducer=g,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(w=>w(g))}emitError(g){this.listeners.error.length===0?(0,y.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(w=>w(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,w){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(g,w){if(!this.state.destroyed){let c;switch(g){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const d=c.indexOf(w);d>=0&&c.splice(d,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(_,g){const w=[];let c;for(;(c=_.read())!==null;)w.push(c);return g(w)}e.consumeReadable=E;function n(_,g,w){const c=[];let d;for(;(d=_.read())!==null&&c.length<w;)c.push(d);return d===null&&c.length>0?g(c):{read:()=>{if(c.length>0)return c.shift();if(typeof d!="undefined"){const o=d;return d=void 0,o}return _.read()}}}e.peekReadable=n;function A(_,g){return new Promise((w,c)=>{const d=[];C(_,{onData:o=>{g&&d.push(o)},onError:o=>{g?c(o):w(void 0)},onEnd:()=>{w(g?g(d):void 0)}})})}e.consumeStream=A;function C(_,g){_.on("error",w=>g.onError(w)),_.on("end",()=>g.onEnd()),_.on("data",w=>g.onData(w))}e.listenStream=C;function b(_,g){return new Promise((w,c)=>{const d=new R.DisposableStore,o=[],t=a=>{if(o.push(a),o.length>g)return d.dispose(),_.pause(),w({stream:_,buffer:o,ended:!1})},i=a=>c(a),u=()=>w({stream:_,buffer:o,ended:!0});d.add((0,R.toDisposable)(()=>_.removeListener("error",i))),_.on("error",i),d.add((0,R.toDisposable)(()=>_.removeListener("end",u))),_.on("end",u),d.add((0,R.toDisposable)(()=>_.removeListener("data",t))),_.on("data",t)})}e.peekStream=b;function m(_,g){const w=S(g);return w.end(_),w}e.toStream=m;function r(_){let g=!1;return{read:()=>g?null:(g=!0,_)}}e.toReadable=r;function s(_,g,w){const c=S(w);return C(_,{onData:d=>c.write(g.data(d)),onError:d=>c.error(g.error?g.error(d):d),onEnd:()=>c.end()}),c}e.transform=s}),define(be[8],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function y(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=y;const R=/{(\d+)}/g;function T(W,...te){return te.length===0?W:W.replace(R,function(de,q){const J=parseInt(q,10);return isNaN(J)||J<0||J>=te.length?de:te[J]})}e.format=T;function P(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function S(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function k(W,te){let de=0;const q=te.charCodeAt(0);for(let J=W.length-1;J>=0;J--)W.charCodeAt(J)===q&&de++;return de}e.count=k;function E(W,te,de="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${de}`}e.truncate=E;function n(W,te=" "){const de=A(W,te);return C(de,te)}e.trim=n;function A(W,te){if(!W||!te)return W;const de=te.length;if(de===0||W.length===0)return W;let q=0;for(;W.indexOf(te,q)===q;)q=q+de;return W.substring(q)}e.ltrim=A;function C(W,te){if(!W||!te)return W;const de=te.length,q=W.length;if(de===0||q===0)return W;let J=q,se=-1;for(;se=W.lastIndexOf(te,J-1),!(se===-1||se+de!==J);){if(se===0)return"";J=se}return W.substring(0,J)}e.rtrim=C;function b(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function m(W){return W.replace(/\*/g,"")}e.stripWildcards=m;function r(W,te,de={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=S(W)),de.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let q="";return de.global&&(q+="g"),de.matchCase||(q+="i"),de.multiline&&(q+="m"),de.unicode&&(q+="u"),new RegExp(W,q)}e.createRegExp=r;function s(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function _(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function g(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=g;function w(W){return W.split(/\r\n|\r|\n/)}e.splitLines=w;function c(W){for(let te=0,de=W.length;te<de;te++){const q=W.charCodeAt(te);if(q!==32&&q!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function d(W,te=0,de=W.length){for(let q=te;q<de;q++){const J=W.charCodeAt(q);if(J!==32&&J!==9)return W.substring(te,q)}return W.substring(te,de)}e.getLeadingWhitespace=d;function o(W,te=W.length-1){for(let de=te;de>=0;de--){const q=W.charCodeAt(de);if(q!==32&&q!==9)return de}return-1}e.lastNonWhitespaceIndex=o;function t(W,te){return W<te?-1:W>te?1:0}e.compare=t;function i(W,te,de=0,q=W.length,J=0,se=te.length){for(;de<q&&J<se;de++,J++){let We=W.charCodeAt(de),Ne=te.charCodeAt(J);if(We<Ne)return-1;if(We>Ne)return 1}const he=q-de,ge=se-J;return he<ge?-1:he>ge?1:0}e.compareSubstring=i;function u(W,te){return a(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=u;function a(W,te,de=0,q=W.length,J=0,se=te.length){for(;de<q&&J<se;de++,J++){let We=W.charCodeAt(de),Ne=te.charCodeAt(J);if(We!==Ne){const je=We-Ne;if(!(je===32&&f(Ne))&&!(je===-32&&f(We)))return l(We)&&l(Ne)?je:i(W.toLowerCase(),te.toLowerCase(),de,q,J,se)}}const he=q-de,ge=se-J;return he<ge?-1:he>ge?1:0}e.compareSubstringIgnoreCase=a;function l(W){return W>=97&&W<=122}e.isLowerAsciiLetter=l;function f(W){return W>=65&&W<=90}e.isUpperAsciiLetter=f;function v(W){return l(W)||f(W)}function D(W,te){return W.length===te.length&&h(W,te)}e.equalsIgnoreCase=D;function h(W,te,de=W.length){for(let q=0;q<de;q++){const J=W.charCodeAt(q),se=te.charCodeAt(q);if(J!==se){if(v(J)&&v(se)){const he=Math.abs(J-se);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(J).toLowerCase()!==String.fromCharCode(se).toLowerCase())return!1}}return!0}function p(W,te){const de=te.length;return te.length>W.length?!1:h(W,te,de)}e.startsWithIgnoreCase=p;function I(W,te){let de,q=Math.min(W.length,te.length);for(de=0;de<q;de++)if(W.charCodeAt(de)!==te.charCodeAt(de))return de;return q}e.commonPrefixLength=I;function F(W,te){let de,q=Math.min(W.length,te.length);const J=W.length-1,se=te.length-1;for(de=0;de<q;de++)if(W.charCodeAt(J-de)!==te.charCodeAt(se-de))return de;return q}e.commonSuffixLength=F;function z(W){return 55296<=W&&W<=56319}e.isHighSurrogate=z;function ue(W){return 56320<=W&&W<=57343}e.isLowSurrogate=ue;function H(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=H;function B(W,te,de){const q=W.charCodeAt(de);if(z(q)&&de+1<te){const J=W.charCodeAt(de+1);if(ue(J))return H(q,J)}return q}e.getNextCodePoint=B;function K(W,te){const de=W.charCodeAt(te-1);if(ue(de)&&te>1){const q=W.charCodeAt(te-2);if(z(q))return H(q,de)}return de}function L(W,te){const de=Oe.getInstance(),q=te,J=W.length,se=B(W,J,te);te+=se>=65536?2:1;let he=de.getGraphemeBreakType(se);for(;te<J;){const ge=B(W,J,te),We=de.getGraphemeBreakType(ge);if(Fe(he,We))break;te+=ge>=65536?2:1,he=We}return te-q}e.nextCharLength=L;function U(W,te){const de=Oe.getInstance(),q=te,J=K(W,te);te-=J>=65536?2:1;let se=de.getGraphemeBreakType(J);for(;te>0;){const he=K(W,te),ge=de.getGraphemeBreakType(he);if(Fe(ge,se))break;te-=he>=65536?2:1,se=ge}return q-te}e.prevCharLength=U;function x(W,te){const de=Oe.getInstance(),q=W.length,J=te,se=B(W,q,te),he=de.getGraphemeBreakType(se);te+=se>=65536?2:1;let ge=he;for(;te<q;){const Ne=B(W,q,te),je=de.getGraphemeBreakType(Ne);if(Fe(ge,je))break;te+=Ne>=65536?2:1,ge=je}const We=te;for(te=J,ge=he;te>0;){const Ne=K(W,te),je=de.getGraphemeBreakType(Ne);if(Fe(je,ge))break;te-=Ne>=65536?2:1,ge=je}return[te,We]}function Q(W,te){return te>0&&ue(W.charCodeAt(te))?x(W,te-1):x(W,te)}e.getCharContainingOffset=Q;function $(W){const te=W.length;let de=0,q=0;for(;q<te;){const he=B(W,te,q);q+=he>=65536?2:1,he<128?de+=1:he<2048?de+=2:he<65536?de+=3:de+=4}const J=new Uint8Array(de);q=0;let se=0;for(;q<te;){const he=B(W,te,q);q+=he>=65536?2:1,he<128?J[se++]=he:he<2048?(J[se++]=192|(he&1984)>>>6,J[se++]=128|(he&63)>>>0):he<65536?(J[se++]=224|(he&61440)>>>12,J[se++]=128|(he&4032)>>>6,J[se++]=128|(he&63)>>>0):(J[se++]=240|(he&1835008)>>>18,J[se++]=128|(he&258048)>>>12,J[se++]=128|(he&4032)>>>6,J[se++]=128|(he&63)>>>0)}return J}e.encodeUTF8=$;function Z(W){const te=W.byteLength,de=[];let q=0;for(;q<te;){const J=W[q];let se;if(J>=240&&q+3<te?se=(W[q++]&7)<<18>>>0|(W[q++]&63)<<12>>>0|(W[q++]&63)<<6>>>0|(W[q++]&63)<<0>>>0:J>=224&&q+2<te?se=(W[q++]&15)<<12>>>0|(W[q++]&63)<<6>>>0|(W[q++]&63)<<0>>>0:J>=192&&q+1<te?se=(W[q++]&31)<<6>>>0|(W[q++]&63)<<0>>>0:se=W[q++],se>=0&&se<=55295||se>=57344&&se<=65535)de.push(String.fromCharCode(se));else if(se>=65536&&se<=1114111){const he=se-65536,ge=55296+((he&1047552)>>>10),We=56320+((he&1023)>>>0);de.push(String.fromCharCode(ge)),de.push(String.fromCharCode(We))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=Z;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(W){return ie.test(W)}e.containsRTL=re;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(W){return ye.test(W)}e.containsEmoji=Ie;const Ue=/^[\t\n\r\x20-\x7E]*$/;function Re(W){return Ue.test(W)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ze;function N(W){for(let te=0,de=W.length;te<de;te++)if(G(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=N;function G(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=G;function ee(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ee;function oe(W,te){if(W.length<te)return W;const de=/\b/g;let q=0;for(;de.test(W)&&!(W.length-de.lastIndex<te);)q=de.lastIndex,de.lastIndex+=1;return W.substring(q).replace(/^\s/,"")}e.lcut=oe;const fe=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function me(W){return W&&(W=W.replace(fe,""),W=W.replace(Se,""),W=W.replace(Le,"")),W}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Pe;function xe(W,te){if(!W||!te||W.length<te.length)return!1;const de=te.length,q=W.toLowerCase();let J=0,se=-1;for(;J<de;){const he=q.indexOf(te[J],se+1);if(he<0)return!1;se=he,J++}return!0}e.fuzzyContains=xe;function _e(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=_e;function Ke(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Ke;function j(W,te=1){if(te===0)return"";let de=-1;do de=W.indexOf(`
`,de+1),te--;while(te>0&&de>=0);return de===-1?W:(W[de-1]==="\r"&&de--,W.substr(0,de))}e.getNLines=j;function Y(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=Y;function pe(W){return Oe.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=pe;function Fe(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=Fe;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=tt()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const de=this._data,q=de.length/3;let J=1;for(;J<=q;)if(te<de[3*J])J=2*J;else if(te>de[3*J+1])J=2*J+1;else return de[3*J+2];return 0}}Oe._INSTANCE=null;function tt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[26],we([0,1,8,107]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let k,E;class n{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return T?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return T&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(l)):P?(k||(k=new TextEncoder),new n(k.encode(l))):new n(y.encodeUTF8(l))}static concat(l,f){if(typeof f=="undefined"){f=0;for(let h=0,p=l.length;h<p;h++)f+=l[h].byteLength}const v=n.alloc(f);let D=0;for(let h=0,p=l.length;h<p;h++){const I=l[h];v.set(I,D),D+=I.byteLength}return v}toString(){return T?this.buffer.toString():S?(E||(E=new TextDecoder),E.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(l,f){return new n(this.buffer.subarray(l,f))}set(l,f){l instanceof n?this.buffer.set(l.buffer,f):this.buffer.set(l,f)}readUInt32BE(l){return b(this.buffer,l)}writeUInt32BE(l,f){m(this.buffer,l,f)}readUInt32LE(l){return r(this.buffer,l)}writeUInt32LE(l,f){s(this.buffer,l,f)}readUInt8(l){return _(this.buffer,l)}writeUInt8(l,f){g(this.buffer,l,f)}}e.VSBuffer=n;function A(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=A;function C(a,l,f){a[f+0]=l&255,l=l>>>8,a[f+1]=l&255}e.writeUInt16LE=C;function b(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=b;function m(a,l,f){a[f+3]=l,l=l>>>8,a[f+2]=l,l=l>>>8,a[f+1]=l,l=l>>>8,a[f]=l}e.writeUInt32BE=m;function r(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=r;function s(a,l,f){a[f+0]=l&255,l=l>>>8,a[f+1]=l&255,l=l>>>8,a[f+2]=l&255,l=l>>>8,a[f+3]=l&255}e.writeUInt32LE=s;function _(a,l){return a[l]}e.readUInt8=_;function g(a,l,f){a[f]=l}e.writeUInt8=g;function w(a){return R.consumeReadable(a,l=>n.concat(l))}e.readableToBuffer=w;function c(a){return R.toReadable(a)}e.bufferToReadable=c;function d(a){return R.consumeStream(a,l=>n.concat(l))}e.streamToBuffer=d;async function o(a){return a.ended?n.concat(a.buffer):n.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=o;function t(a){return R.toStream(a,l=>n.concat(l))}e.bufferToStream=t;function i(a){return R.transform(a,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=i;function u(a){return R.newWriteableStream(l=>n.concat(l),a)}e.newWriteableBufferStream=u}),define(be[56],we([0,1,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(g){return T(g,0)}e.hash=R;function T(g,w){switch(typeof g){case"object":return g===null?P(349,w):Array.isArray(g)?E(g,w):n(g,w);case"string":return k(g,w);case"boolean":return S(g,w);case"number":return P(g,w);case"undefined":return P(937,w);default:return P(617,w)}}e.doHash=T;function P(g,w){return(w<<5)-w+g|0}function S(g,w){return P(g?433:863,w)}function k(g,w){w=P(149417,w);for(let c=0,d=g.length;c<d;c++)w=P(g.charCodeAt(c),w);return w}e.stringHash=k;function E(g,w){return w=P(104579,w),g.reduce((c,d)=>T(d,c),w)}function n(g,w){return w=P(181387,w),Object.keys(g).sort().reduce((c,d)=>(c=k(d,c),T(g[d],c)),w)}class A{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=T(w,this._value),this._value}}e.Hasher=A;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function b(g,w,c=32){const d=c-w,o=~((1<<d)-1);return(g<<w|(o&g)>>>d)>>>0}function m(g,w=0,c=g.byteLength,d=0){for(let o=0;o<c;o++)g[w+o]=d}function r(g,w,c="0"){for(;g.length<w;)g=c+g;return g}function s(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(c=>c.toString(16).padStart(2,"0")).join(""):r((g>>>0).toString(16),w/4)}e.toHexString=s;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const c=w.length;if(c!==0){const d=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,i,u;for(t!==0?(i=t,u=-1,t=0):(i=w.charCodeAt(0),u=0);;){let a=i;if(y.isHighSurrogate(i))if(u+1<c){const l=w.charCodeAt(u+1);y.isLowSurrogate(l)?(u++,a=y.computeCodePoint(i,l)):a=65533}else{t=i;break}else y.isLowSurrogate(i)&&(a=65533);if(o=this._push(d,o,a),u++,u<c)i=w.charCodeAt(u);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(w,c,d){return d<128?w[c++]=d:d<2048?(w[c++]=192|(d&1984)>>>6,w[c++]=128|(d&63)>>>0):d<65536?(w[c++]=224|(d&61440)>>>12,w[c++]=128|(d&4032)>>>6,w[c++]=128|(d&63)>>>0):(w[c++]=240|(d&1835008)>>>18,w[c++]=128|(d&258048)>>>12,w[c++]=128|(d&4032)>>>6,w[c++]=128|(d&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=_._bigBlock32,c=this._buffDV;for(let v=0;v<64;v+=4)w.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)w.setUint32(v,b(w.getUint32(v-12,!1)^w.getUint32(v-32,!1)^w.getUint32(v-56,!1)^w.getUint32(v-64,!1),1),!1);let d=this._h0,o=this._h1,t=this._h2,i=this._h3,u=this._h4,a,l,f;for(let v=0;v<80;v++)v<20?(a=o&t|~o&i,l=1518500249):v<40?(a=o^t^i,l=1859775393):v<60?(a=o&t|o&i|t&i,l=2400959708):(a=o^t^i,l=3395469782),f=b(d,5)+a+u+l+w.getUint32(v*4,!1)&4294967295,u=i,i=t,t=b(o,30),o=d,d=f;this._h0=this._h0+d&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[46],we([0,1,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(R||(R={})),function(T){const P="error",S="warning",k="warn",E="info";function n(A){return A?y.equalsIgnoreCase(P,A)?T.Error:y.equalsIgnoreCase(S,A)||y.equalsIgnoreCase(k,A)?T.Warning:y.equalsIgnoreCase(E,A)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(R||(R={})),e.default=R}),define(be[12],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(f){return Array.isArray(f)}e.isArray=y;function R(f){return typeof f=="string"}e.isString=R;function T(f){return Array.isArray(f)&&f.every(v=>R(v))}e.isStringArray=T;function P(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=P;function S(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=S;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function E(f){return f===!0||f===!1}e.isBoolean=E;function n(f){return typeof f=="undefined"}e.isUndefined=n;function A(f){return!C(f)}e.isDefined=A;function C(f){return n(f)||f===null}e.isUndefinedOrNull=C;function b(f,v){if(!f)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=b;function m(f){if(C(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function r(...f){const v=[];for(let D=0;D<f.length;D++){const h=f[D];if(C(h))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);v.push(h)}return v}e.assertAllDefined=r;const s=Object.prototype.hasOwnProperty;function _(f){if(!P(f))return!1;for(let v in f)if(s.call(f,v))return!1;return!0}e.isEmptyObject=_;function g(f){return typeof f=="function"}e.isFunction=g;function w(...f){return f.length>0&&f.every(g)}e.areFunctions=w;function c(f,v){const D=Math.min(f.length,v.length);for(let h=0;h<D;h++)d(f[h],v[h])}e.validateConstraints=c;function d(f,v){if(R(v)){if(typeof f!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(g(v)){try{if(f instanceof v)return}catch(D){}if(!C(f)&&f.constructor===v||v.length===1&&v.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function o(f){let v=[],D=Object.getPrototypeOf(f);for(;Object.prototype!==D;)v=v.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return v}e.getAllPropertyNames=o;function t(f){const v=[];for(const D of o(f))typeof f[D]=="function"&&v.push(D);return v}e.getAllMethodNames=t;function i(f,v){const D=p=>function(){const I=Array.prototype.slice.call(arguments,0);return v(p,I)};let h={};for(const p of f)h[p]=D(p);return h}e.createProxyObject=i;function u(f){return f===null?void 0:f}e.withNullAsUndefined=u;function a(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=a;function l(f){return class{constructor(){return new Proxy({},{get(v,D){if(v[D])return v[D];throw new Error(`Not Implemented: ${f}->${String(D)}`)}})}}}e.NotImplementedProxy=l}),define(be[38],we([0,1,21,8,11,12]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function k(i){return i.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function E(i,u=T.posix.sep){if(!i)return"";const a=i.length,l=i.charCodeAt(0);if(S(l)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let v=3;const D=v;for(;v<a&&!S(i.charCodeAt(v));v++);if(D!==v&&!S(i.charCodeAt(v+1))){for(v+=1;v<a;v++)if(S(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,u)}}return u}else if(_(l)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+u:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(S(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=E;function n(i){if(!y.isWindows||!i||i.length<5)return!1;let u=i.charCodeAt(0);if(u!==92||(u=i.charCodeAt(1),u!==92))return!1;let a=2;const l=a;for(;a<i.length&&(u=i.charCodeAt(a),u!==92);a++);return!(l===a||(u=i.charCodeAt(a+1),isNaN(u)||u===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,u=y.isWindows){const a=u?A:C;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||u&&b.test(i)||i==="."||i===".."||u&&i[i.length-1]==="."||u&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function r(i,u,a){const l=i===u;return!a||l?l:!i||!u?!1:(0,R.equalsIgnoreCase)(i,u)}e.isEqual=r;function s(i,u,a,l=T.sep){if(i===u)return!0;if(!i||!u||u.length>i.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(i,u))return!1;if(u.length===i.length)return!0;let v=u.length;return u.charAt(u.length-1)===l&&v--,i.charAt(v)===l}return u.charAt(u.length-1)!==l&&(u+=l),i.indexOf(u)===0}e.isEqualOrParent=s;function _(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=_;function g(i,u){return y.isWindows&&i.endsWith(":")&&(i+=T.sep),(0,T.isAbsolute)(i)||(i=(0,T.join)(u,i)),i=(0,T.normalize)(i),y.isWindows?(i=(0,R.rtrim)(i,T.sep),i.endsWith(":")&&(i+=T.sep)):(i=(0,R.rtrim)(i,T.sep),i||(i=T.sep)),i}e.sanitizeFilePath=g;function w(i){const u=(0,T.normalize)(i);return y.isWindows?i.length>3?!1:c(u)&&(i.length===2||u.charCodeAt(2)===92):u===T.posix.sep}e.isRootOrDriveLetter=w;function c(i){return y.isWindows?_(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function d(i){return c(i)?i[0]:void 0}e.getDriveLetter=d;function o(i,u,a){return u.length>i.length?-1:i===u?0:(a&&(i=i.toLowerCase(),u=u.toLowerCase()),i.indexOf(u))}e.indexOfPath=o;function t(i){const u=i.split(":");let a,l,f;if(u.forEach(v=>{const D=Number(v);(0,P.isNumber)(D)?l===void 0?l=D:f===void 0&&(f=D):a=a?[a,v].join(":"):v}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[23],we([0,1,12]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const s=Array.isArray(r)?[]:{};return Object.keys(r).forEach(_=>{r[_]&&typeof r[_]=="object"?s[_]=R(r[_]):s[_]=r[_]}),s}e.deepClone=R;function T(r){if(!r||typeof r!="object")return r;const s=[r];for(;s.length>0;){const _=s.shift();Object.freeze(_);for(const g in _)if(P.call(_,g)){const w=_[g];typeof w=="object"&&!Object.isFrozen(w)&&s.push(w)}}return r}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function S(r,s){return k(r,s,new Set)}e.cloneAndChange=S;function k(r,s,_){if((0,y.isUndefinedOrNull)(r))return r;const g=s(r);if(typeof g!="undefined")return g;if((0,y.isArray)(r)){const w=[];for(const c of r)w.push(k(c,s,_));return w}if((0,y.isObject)(r)){if(_.has(r))throw new Error("Cannot clone recursive data-structure");_.add(r);const w={};for(let c in r)P.call(r,c)&&(w[c]=k(r[c],s,_));return _.delete(r),w}return r}function E(r,s,_=!0){return(0,y.isObject)(r)?((0,y.isObject)(s)&&Object.keys(s).forEach(g=>{g in r?_&&((0,y.isObject)(r[g])&&(0,y.isObject)(s[g])?E(r[g],s[g],_):r[g]=s[g]):r[g]=s[g]}),r):s}e.mixin=E;function n(r,s){if(r===s)return!0;if(r==null||s===null||s===void 0||typeof r!=typeof s||typeof r!="object"||Array.isArray(r)!==Array.isArray(s))return!1;let _,g;if(Array.isArray(r)){if(r.length!==s.length)return!1;for(_=0;_<r.length;_++)if(!n(r[_],s[_]))return!1}else{const w=[];for(g in r)w.push(g);w.sort();const c=[];for(g in s)c.push(g);if(c.sort(),!n(w,c))return!1;for(_=0;_<w.length;_++)if(!n(r[w[_]],s[w[_]]))return!1}return!0}e.equals=n;function A(r){const s=new Set;return JSON.stringify(r,(_,g)=>{if((0,y.isObject)(g)||Array.isArray(g)){if(s.has(g))return"[Circular]";s.add(g)}return g})}e.safeStringify=A;function C(r,s,_){const g=s(r);return typeof g=="undefined"?_:g}e.getOrDefault=C;function b(r,s){const _=Object.create(null);return!r||!s||Object.keys(s).forEach(w=>{const c=r[w],d=s[w];n(c,d)||(_[w]=d)}),_}e.distinct=b;function m(r,s){const _=s.toLowerCase(),g=Object.keys(r).find(w=>w.toLowerCase()===_);return g?r[g]:r[s]}e.getCaseInsensitive=m}),define(be[79],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var y;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y=e.Constants||(e.Constants={}));function R(P){return P<0?0:P>255?255:P|0}e.toUint8=R;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(be[2],we([0,1,21,11]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,S=/^\/\//;function k(u,a){if(!u.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!T.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!P.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,a){return!u&&!a?"file":u}function n(u,a){switch(u){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const A="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(a,l,f,v,D,h=!1){typeof a=="object"?(this.scheme=a.scheme||A,this.authority=a.authority||A,this.path=a.path||A,this.query=a.query||A,this.fragment=a.fragment||A):(this.scheme=E(a,h),this.authority=l||A,this.path=n(this.scheme,f||A),this.query=v||A,this.fragment=D||A,k(this,h))}static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return c(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:f,path:v,query:D,fragment:h}=a;return l===void 0?l=this.scheme:l===null&&(l=A),f===void 0?f=this.authority:f===null&&(f=A),v===void 0?v=this.path:v===null&&(v=A),D===void 0?D=this.query:D===null&&(D=A),h===void 0?h=this.fragment:h===null&&(h=A),l===this.scheme&&f===this.authority&&v===this.path&&D===this.query&&h===this.fragment?this:new s(l,f,v,D,h)}static parse(a,l=!1){const f=b.exec(a);return f?new s(f[2]||A,i(f[4]||A),i(f[5]||A),i(f[7]||A),i(f[9]||A),l):new s(A,A,A,A,A)}static file(a){let l=A;if(y.isWindows&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const f=a.indexOf(C,2);f===-1?(l=a.substring(2),a=C):(l=a.substring(2,f),a=a.substring(f)||C)}return new s("file",l,a,A,A)}static from(a){return new s(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return y.isWindows&&a.scheme==="file"?f=m.file(R.win32.join(c(a,!0),...l)).path:f=R.posix.join(a.path,...l),a.with({path:f})}toString(a=!1){return d(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const l=new s(a);return l._formatted=a.external,l._fsPath=a._sep===r?a.fsPath:null,l}}else return a}}e.URI=m;const r=y.isWindows?1:void 0;class s extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(a=!1){return a?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(u,a){let l,f=-1;for(let v=0;v<u.length;v++){const D=u.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47)f!==-1&&(l+=encodeURIComponent(u.substring(f,v)),f=-1),l!==void 0&&(l+=u.charAt(v));else{l===void 0&&(l=u.substr(0,v));const h=_[D];h!==void 0?(f!==-1&&(l+=encodeURIComponent(u.substring(f,v)),f=-1),l+=h):f===-1&&(f=v)}}return f!==-1&&(l+=encodeURIComponent(u.substring(f))),l!==void 0?l:u}function w(u){let a;for(let l=0;l<u.length;l++){const f=u.charCodeAt(l);f===35||f===63?(a===void 0&&(a=u.substr(0,l)),a+=_[f]):a!==void 0&&(a+=u[l])}return a!==void 0?a:u}function c(u,a){let l;return u.authority&&u.path.length>1&&u.scheme==="file"?l=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?a?l=u.path.substr(1):l=u.path[1].toLowerCase()+u.path.substr(2):l=u.path,y.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function d(u,a){const l=a?w:g;let f="",{scheme:v,authority:D,path:h,query:p,fragment:I}=u;if(v&&(f+=v,f+=":"),(D||v==="file")&&(f+=C,f+=C),D){let F=D.indexOf("@");if(F!==-1){const z=D.substr(0,F);D=D.substr(F+1),F=z.indexOf(":"),F===-1?f+=l(z,!1):(f+=l(z.substr(0,F),!1),f+=":",f+=l(z.substr(F+1),!1)),f+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?f+=l(D,!1):(f+=l(D.substr(0,F),!1),f+=D.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}f+=l(h,!0)}return p&&(f+="?",f+=l(p,!1)),I&&(f+="#",f+=a?I:g(I,!1)),f}function o(u){try{return decodeURIComponent(u)}catch(a){return u.length>3?u.substr(0,3)+o(u.substr(3)):u}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(u){return u.match(t)?u.replace(t,a=>o(a)):u}}),define(be[22],we([0,1,2,8]),function(le,e,y,R){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(d,o,t){let i=d.get(o);return i===void 0&&(i=t,d.set(o,i)),i}e.getOrSet=S;function k(d){const o=[];return d.forEach((t,i)=>{o.push(`${i} => ${t}`)}),`Map(${d.size}) {${o.join(", ")}}`}e.mapToString=k;function E(d){const o=[];return d.forEach(t=>{o.push(t)}),`Set(${d.size}) {${o.join(", ")}}`}e.setToString=E;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,R.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class C{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,R.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var b;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,R.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class r{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(o){this._iter=o}static forUris(o=()=>!1){return new s(new m(o))}static forPaths(){return new s(new C)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new A)}clear(){this._root=void 0}set(o,t){const i=this._iter.reset(o);let u;for(this._root||(this._root=new r,this._root.segment=i.value()),u=this._root;;){const l=i.cmp(u.segment);if(l>0)u.left||(u.left=new r,u.left.segment=i.value()),u=u.left;else if(l<0)u.right||(u.right=new r,u.right.segment=i.value()),u=u.right;else if(i.hasNext())i.next(),u.mid||(u.mid=new r,u.mid.segment=i.value()),u=u.mid;else break}const a=u.value;return u.value=t,u.key=o,a}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const u=t.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const i=this._iter.reset(o),u=[];let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)u.push([1,a]),a=a.left;else if(l<0)u.push([-1,a]),a=a.right;else if(i.hasNext())i.next(),u.push([0,a]),a=a.mid;else{for(t?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;u.length>0&&a.isEmpty();){let[f,v]=u.pop();switch(f){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}a=v}break}}}findSubstr(o){const t=this._iter.reset(o);let i=this._root,u;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),u=i.value||u,i=i.mid;else break}return i&&i.value||u}findSuperstr(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const u=t.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(o){for(const[t,i]of this)o(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=s;class _{constructor(o,t){this[T]="ResourceMap",o instanceof _?(this.map=new Map(o.map),this.toKey=t!=null?t:_.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:_.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[i,u]of this.map)o(u,y.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield y.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[y.URI.parse(o[0]),o[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[y.URI.parse(o[0]),o[1]]}}e.ResourceMap=_,_.defaultToKey=d=>d.toString();var g;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class w{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const i=this._map.get(o);if(!!i)return t!==0&&this.touch(i,t),i.value}set(o,t,i=0){let u=this._map.get(o);if(u)u.value=t,i!==0&&this.touch(u,i);else{switch(u={key:o,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(o,u),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const i=this._state;let u=this._head;for(;u;){if(t?o.bind(t)(u.value,u.key,this):o(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.key,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return u}values(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.value,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return u}entries(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:[i.key,i.value],done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return u}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>o;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,i=o.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const i=o.next,u=o.previous;o===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const i=o.next,u=o.previous;o===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,i)=>{o.push([i,t])}),o}fromJSON(o){this.clear();for(const[t,i]of o)this.set(t,i)}}e.LinkedMap=w;class c extends w{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(be[108],we([0,1,22,8]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...me){return function(Ce,Pe){for(let xe=0,_e=me.length;xe<_e;xe++){const Ke=me[xe](Ce,Pe);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(me,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let xe;return me?xe=R.startsWithIgnoreCase(Pe,Ce):xe=Pe.indexOf(Ce)===0,xe?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(me,Ce){const Pe=Ce.toLowerCase().indexOf(me.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+me.length}]}e.matchesContiguousSubString=S;function k(me,Ce){return E(me.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=k;function E(me,Ce,Pe,xe){if(Pe===me.length)return[];if(xe===Ce.length)return null;if(me[Pe]===Ce[xe]){let _e=null;return(_e=E(me,Ce,Pe+1,xe+1))?g({start:xe,end:xe+1},_e):null}return E(me,Ce,Pe,xe+1)}function n(me){return 97<=me&&me<=122}function A(me){return 65<=me&&me<=90}e.isUpper=A;function C(me){return 48<=me&&me<=57}function b(me){return me===32||me===9||me===10||me===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(me=>m.add(me.charCodeAt(0)));function r(me){return b(me)||m.has(me)}function s(me,Ce){return me===Ce||r(me)&&r(Ce)}function _(me){return n(me)||A(me)||C(me)}function g(me,Ce){return Ce.length===0?Ce=[me]:me.end===Ce[0].start?Ce[0].start=me.start:Ce.unshift(me),Ce}function w(me,Ce){for(let Pe=Ce;Pe<me.length;Pe++){const xe=me.charCodeAt(Pe);if(A(xe)||C(xe)||Pe>0&&!_(me.charCodeAt(Pe-1)))return Pe}return me.length}function c(me,Ce,Pe,xe){if(Pe===me.length)return[];if(xe===Ce.length)return null;if(me[Pe]!==Ce[xe].toLowerCase())return null;{let _e=null,Ke=xe+1;for(_e=c(me,Ce,Pe+1,xe+1);!_e&&(Ke=w(Ce,Ke))<Ce.length;)_e=c(me,Ce,Pe+1,Ke),Ke++;return _e===null?null:g({start:xe,end:xe+1},_e)}}function d(me){let Ce=0,Pe=0,xe=0,_e=0,Ke=0;for(let He=0;He<me.length;He++)Ke=me.charCodeAt(He),A(Ke)&&Ce++,n(Ke)&&Pe++,_(Ke)&&xe++,C(Ke)&&_e++;const j=Ce/me.length,Y=Pe/me.length,pe=xe/me.length,Fe=_e/me.length;return{upperPercent:j,lowerPercent:Y,alphaPercent:pe,numericPercent:Fe}}function o(me){const{upperPercent:Ce,lowerPercent:Pe}=me;return Pe===0&&Ce>.6}function t(me){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:xe,numericPercent:_e}=me;return Pe>.2&&Ce<.8&&xe>.6&&_e<.2}function i(me){let Ce=0,Pe=0,xe=0,_e=0;for(let Ke=0;Ke<me.length;Ke++)xe=me.charCodeAt(Ke),A(xe)&&Ce++,n(xe)&&Pe++,b(xe)&&_e++;return(Ce===0||Pe===0)&&_e===0?me.length<=30:Ce<=5}function u(me,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(me)||Ce.length>60)return null;const Pe=d(Ce);if(!t(Pe)){if(!o(Pe))return null;Ce=Ce.toLowerCase()}let xe=null,_e=0;for(me=me.toLowerCase();_e<Ce.length&&(xe=c(me,Ce,0,_e))===null;)_e=w(Ce,_e+1);return xe}e.matchesCamelCase=u;function a(me,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let xe=null,_e=0;for(me=me.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(xe=l(me,Ce,0,_e,Pe))===null;)_e=f(Ce,_e+1);return xe}e.matchesWords=a;function l(me,Ce,Pe,xe,_e){if(Pe===me.length)return[];if(xe===Ce.length)return null;if(s(me.charCodeAt(Pe),Ce.charCodeAt(xe))){let Ke=null,j=xe+1;if(Ke=l(me,Ce,Pe+1,xe+1,_e),!_e)for(;!Ke&&(j=f(Ce,j))<Ce.length;)Ke=l(me,Ce,Pe+1,j,_e),j++;return Ke===null?null:g({start:xe,end:xe+1},Ke)}else return null}function f(me,Ce){for(let Pe=Ce;Pe<me.length;Pe++)if(r(me.charCodeAt(Pe))||Pe>0&&r(me.charCodeAt(Pe-1)))return Pe;return me.length}const v=T(e.matchesPrefix,u,S),D=T(e.matchesPrefix,u,k),h=new y.LRUCache(1e4);function p(me,Ce,Pe=!1){if(typeof me!="string"||typeof Ce!="string")return null;let xe=h.get(me);xe||(xe=new RegExp(R.convertSimple2RegExpPattern(me),"i"),h.set(me,xe));const _e=xe.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Pe?D(me,Ce):v(me,Ce)}e.matchesFuzzy=p;function I(me,Ce){const Pe=N(me,me.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?z(Pe):null}e.matchesFuzzy2=I;function F(me,Ce,Pe,xe,_e,Ke){const j=Math.min(13,me.length);for(;Pe<j;Pe++){const Y=N(me,Ce,Pe,xe,_e,Ke,!1);if(Y)return Y}return[0,Ke]}e.anyScore=F;function z(me){if(typeof me=="undefined")return[];const Ce=[],Pe=me[1];for(let xe=me.length-1;xe>1;xe--){const _e=me[xe]+Pe,Ke=Ce[Ce.length-1];Ke&&Ke.end===_e?Ke.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=z;const ue=128;function H(){const me=[],Ce=[];for(let Pe=0;Pe<=ue;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=ue;Pe++)me.push(Ce.slice(0));return me}function B(me){const Ce=[];for(let Pe=0;Pe<=me;Pe++)Ce[Pe]=0;return Ce}const K=B(2*ue),L=B(2*ue),U=H(),x=H(),Q=H(),$=!1;function Z(me,Ce,Pe,xe,_e){function Ke(Y,pe,Fe=" "){for(;Y.length<pe;)Y=Fe+Y;return Y}let j=` |   |${xe.split("").map(Y=>Ke(Y,3)).join("|")}
`;for(let Y=0;Y<=Pe;Y++)Y===0?j+=" |":j+=`${Ce[Y-1]}|`,j+=me[Y].slice(0,_e+1).map(pe=>Ke(pe.toString(),3)).join("|")+`
`;return j}function ie(me,Ce,Pe,xe){me=me.substr(Ce),Pe=Pe.substr(xe),console.log(Z(x,me,me.length,Pe,Pe.length)),console.log(Z(Q,me,me.length,Pe,Pe.length)),console.log(Z(U,me,me.length,Pe,Pe.length))}function re(me,Ce){if(Ce<0||Ce>=me.length)return!1;const Pe=me.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Pe)}}function ye(me,Ce){if(Ce<0||Ce>=me.length)return!1;switch(me.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ie(me,Ce,Pe){return Ce[me]!==Pe[me]}function Ue(me,Ce,Pe,xe,_e,Ke,j=!1){for(;Ce<Pe&&_e<Ke;)me[Ce]===xe[_e]&&(j&&(K[Ce]=_e),Ce+=1),_e+=1;return Ce===Pe}e.isPatternInWord=Ue;var Re;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var ze;(function(me){me.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}me.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function N(me,Ce,Pe,xe,_e,Ke,j){const Y=me.length>ue?ue:me.length,pe=xe.length>ue?ue:xe.length;if(!(Pe>=Y||Ke>=pe||Y-Pe>pe-Ke)&&!!Ue(Ce,Pe,Y,_e,Ke,pe,!0)){G(Y,pe,Pe,Ke,Ce,_e);let Fe=1,He=1,Oe=Pe,tt=Ke;const W=[!1];for(Fe=1,Oe=Pe;Oe<Y;Fe++,Oe++){const se=K[Oe],he=L[Oe],ge=Oe+1<Y?L[Oe+1]:pe;for(He=se-Ke+1,tt=se;tt<ge;He++,tt++){let We=Number.MIN_SAFE_INTEGER,Ne=!1;tt<=he&&(We=ee(me,Ce,Oe,Pe,xe,_e,tt,pe,Ke,U[Fe-1][He-1]===0,W));let je=0;We!==Number.MAX_SAFE_INTEGER&&(Ne=!0,je=We+x[Fe-1][He-1]);const Ye=tt>se,Ze=Ye?x[Fe][He-1]+(U[Fe][He-1]>0?-5:0):0,ct=tt>se+1&&U[Fe][He-1]>0,lt=ct?x[Fe][He-2]+(U[Fe][He-2]>0?-5:0):0;if(ct&&(!Ye||lt>=Ze)&&(!Ne||lt>=je))x[Fe][He]=lt,Q[Fe][He]=3,U[Fe][He]=0;else if(Ye&&(!Ne||Ze>=je))x[Fe][He]=Ze,Q[Fe][He]=2,U[Fe][He]=0;else if(Ne)x[Fe][He]=je,Q[Fe][He]=1,U[Fe][He]=U[Fe-1][He-1]+1;else throw new Error("not possible")}}if($&&ie(me,Pe,xe,Ke),!(!W[0]&&!j)){Fe--,He--;const te=[x[Fe][He],Ke];let de=0,q=0;for(;Fe>=1;){let se=He;do{const he=Q[Fe][se];if(he===3)se=se-2;else if(he===2)se=se-1;else break}while(se>=1);de>1&&Ce[Pe+Fe-1]===_e[Ke+He-1]&&!Ie(se+Ke-1,xe,_e)&&de+1>U[Fe][se]&&(se=He),se===He?de++:de=1,q||(q=se),Fe--,He=se-1,te.push(He)}pe===Y&&(te[0]+=2);const J=q-Y;return te[0]-=J,te}}}e.fuzzyScore=N;function G(me,Ce,Pe,xe,_e,Ke){let j=me-1,Y=Ce-1;for(;j>=Pe&&Y>=xe;)_e[j]===Ke[Y]&&(L[j]=Y,j--),Y--}function ee(me,Ce,Pe,xe,_e,Ke,j,Y,pe,Fe,He){if(Ce[Pe]!==Ke[j])return Number.MIN_SAFE_INTEGER;let Oe=1,tt=!1;return j===Pe-xe?Oe=me[Pe]===_e[j]?7:5:Ie(j,_e,Ke)&&(j===0||!Ie(j-1,_e,Ke))?(Oe=me[Pe]===_e[j]?7:5,tt=!0):re(Ke,j)&&(j===0||!re(Ke,j-1))?Oe=5:(re(Ke,j-1)||ye(Ke,j-1))&&(Oe=5,tt=!0),Oe>1&&Pe===xe&&(He[0]=!0),tt||(tt=Ie(j,_e,Ke)||re(Ke,j-1)||ye(Ke,j-1)),Pe===xe?j>pe&&(Oe-=tt?3:5):Fe?Oe+=tt?2:0:Oe+=tt?0:1,j+1===Y&&(Oe-=tt?3:5),Oe}function oe(me,Ce,Pe,xe,_e,Ke,j){return Se(me,Ce,Pe,xe,_e,Ke,!0,j)}e.fuzzyScoreGracefulAggressive=oe;function fe(me,Ce,Pe,xe,_e,Ke,j){return Se(me,Ce,Pe,xe,_e,Ke,!1,j)}e.fuzzyScoreGraceful=fe;function Se(me,Ce,Pe,xe,_e,Ke,j,Y){let pe=N(me,Ce,Pe,xe,_e,Ke,Y);if(pe&&!j)return pe;if(me.length>=3){const Fe=Math.min(7,me.length-1);for(let He=Pe+1;He<Fe;He++){const Oe=Le(me,He);if(Oe){const tt=N(Oe,Oe.toLowerCase(),Pe,xe,_e,Ke,Y);tt&&(tt[0]-=3,(!pe||tt[0]>pe[0])&&(pe=tt))}}}return pe}function Le(me,Ce){if(!(Ce+1>=me.length)){const Pe=me[Ce],xe=me[Ce+1];if(Pe!==xe)return me.slice(0,Ce)+xe+Pe+me.slice(Ce+2)}}}),define(be[109],we([0,1,37,108,8]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${P.source}`,"g");function k(s){return s.replace(S,(_,g)=>g?_:`\\${_}`)}e.escapeIcons=k;const E=new RegExp(`\\\\${P.source}`,"g");function n(s){return s.replace(E,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=n;const A=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function C(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(A,(_,g,w,c)=>w?_:g||c||"")}e.stripIcons=C;function b(s){const _=s.indexOf(e.iconStartMarker);return _===-1?{text:s}:m(s,_)}e.parseLabelWithIcons=b;function m(s,_){const g=[];let w="";function c(f){if(f){w+=f;for(const v of f)g.push(t)}}let d=-1,o="",t=0,i,u,a=_;const l=s.length;for(c(s.substr(0,_));a<l;)i=s[a],u=s[a+1],i===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(d=a,c(o),o=e.iconStartMarker,a++):i===")"&&d!==-1?(t+=a-d+1,d=-1,o=""):d!==-1?/^[a-z0-9\-]$/i.test(i)?o+=i:(c(o),d=-1,o=""):c(i),a++;return c(o),{text:w,iconOffsets:g}}function r(s,_,g=!1){const{text:w,iconOffsets:c}=_;if(!c||c.length===0)return(0,R.matchesFuzzy)(s,w,g);const d=(0,T.ltrim)(w," "),o=w.length-d.length,t=(0,R.matchesFuzzy)(s,d,g);if(t)for(const i of t){const u=c[i.start+o]+o;i.start+=u,i.end+=u}return t}e.matchesFuzzyIconAware=r}),define(be[80],we([0,1,15,109,10]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",_=!1){var g,w;if(this.value=s,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1):(this.isTrusted=(g=_.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(w=_.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(s,_=0){return this.value+=C(this.supportThemeIcons?(0,R.escapeIcons)(s):s).replace(/([ \t]+)/g,(g,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,_){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}}e.MarkdownString=S;function k(r){return E(r)?!r.value:Array.isArray(r)?r.every(k):!0}e.isEmptyMarkdownString=k;function E(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function n(r,s){return!r&&!s?!0:!r||!s?!1:Array.isArray(r)&&Array.isArray(s)?(0,y.equals)(r,s,A):E(r)&&E(s)?A(r,s):!1}e.markedStringsEquals=n;function A(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons}function C(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function b(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function m(r){const s=[],_=r.split("|").map(w=>w.trim());r=_[0];const g=_[1];if(g){const w=/height=(\d+)/.exec(g),c=/width=(\d+)/.exec(g),d=w?w[1]:"",o=c?c[1]:"",t=isFinite(parseInt(o)),i=isFinite(parseInt(d));t&&s.push(`width="${o}"`),i&&s.push(`height="${d}"`)}return{href:r,dimensions:s}}e.parseHrefAndDimensions=m}),define(be[57],we([0,1,26,8,2]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,k)}e.stringify=P;function S(n){let A=JSON.parse(n);return A=E(A),A}e.parse=S;function k(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,R.regExpFlags)(A)}:A}function E(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof y.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=E(n[C],A+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=E(n[C],A+1))}return n}e.revive=E}),define(be[16],we([0,1,2,21]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.vscodeWebviewResource="vscode-webview-resource",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,n,A){this._hosts[E]=n,this._ports[E]=A}setConnectionToken(E,n){this._connectionTokens[E]=n}rewrite(E){if(this._delegate)return this._delegate(E);const n=E.authority;let A=this._hosts[n];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const C=this._ports[n],b=this._connectionTokens[n];let m=`path=${encodeURIComponent(E.path)}`;return typeof b=="string"&&(m+=`&tkn=${encodeURIComponent(b)}`),y.URI.from({scheme:R.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${A}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new P;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,n,A){const C=this.toUri(E,n);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):R.isNative&&(A||R.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(E,n){const A=this.toUri(E,n);return A.scheme===T.vscodeFileResource?A.with({scheme:T.file,authority:A.authority!==this.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(E,n){return y.URI.isUri(E)?E:y.URI.parse(n.toUrl(E))}}e.FileAccess=new S}),define(be[24],we([0,1,38,11,2,8,16,21]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=E;class n{constructor(r){this._ignorePathCasing=r}compare(r,s,_=!1){return r===s?0:(0,P.compare)(this.getComparisonKey(r,_),this.getComparisonKey(s,_))}isEqual(r,s,_=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,_)===this.getComparisonKey(s,_)}getComparisonKey(r,s=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,s,_=!1){if(r.scheme===s.scheme){if(r.scheme===S.Schemas.file)return y.isEqualOrParent(E(r),E(s),this._ignorePathCasing(r))&&r.query===s.query&&(_||r.fragment===s.fragment);if((0,e.isEqualAuthority)(r.authority,s.authority))return y.isEqualOrParent(r.path,s.path,this._ignorePathCasing(r),"/")&&r.query===s.query&&(_||r.fragment===s.fragment)}return!1}joinPath(r,...s){return T.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return R.posix.basename(r.path)}extname(r){return R.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===S.Schemas.file?s=T.URI.file(R.dirname(E(r))).path:(s=R.posix.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===S.Schemas.file?s=T.URI.file(R.normalize(E(r))).path:s=R.posix.normalize(r.path),r.with({path:s})}relativePath(r,s){if(!(r.scheme!==s.scheme||!(0,e.isEqualAuthority)(r.authority,s.authority))){if(r.scheme===S.Schemas.file){const w=R.relative(E(r),E(s));return k.isWindows?y.toSlashes(w):w}let _=r.path||"/",g=s.path||"/";if(this._ignorePathCasing(r)){let w=0;for(const c=Math.min(_.length,g.length);w<c&&!(_.charCodeAt(w)!==g.charCodeAt(w)&&_.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);_=g.substr(0,w)+_.substr(w)}return R.posix.relative(_,g)}}resolvePath(r,s){if(r.scheme===S.Schemas.file){const _=T.URI.file(R.resolve(E(r),s));return r.with({authority:_.authority,path:_.path})}return s.indexOf("/")===-1&&(s=y.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),r.with({path:R.posix.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||(0,P.equalsIgnoreCase)(r,s)}hasTrailingPathSeparator(r,s=R.sep){if(r.scheme===S.Schemas.file){const _=E(r);return _.length>y.getRoot(_).length&&_[_.length-1]===s}else{const _=r.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=R.sep){return(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=R.sep){let _=!1;if(r.scheme===S.Schemas.file){const g=E(r);_=g!==void 0&&g.length===y.getRoot(g).length&&g[g.length-1]===s}else{s="/";const g=r.path;_=g.length===1&&g.charCodeAt(g.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===S.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(m,r){const s=[];for(let _=0;_<m.length;_++){const g=r(m[_]);m.some((w,c)=>c===_?!1:(0,e.isEqualOrParent)(g,r(w)))||s.push(m[_])}return s}e.distinctParents=A;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function r(s){const _=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(c=>{const[d,o]=c.split(":");d&&o&&_.set(d,o)});const w=s.path.substring(0,s.path.indexOf(";"));return w&&_.set(m.META_DATA_MIME,w),_}m.parseMetaData=r})(C=e.DataUri||(e.DataUri={}));function b(m,r,s){if(r){let _=m.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),m.with({scheme:s,authority:r,path:_})}return m.with({scheme:s})}e.toLocalResource=b}),define(be[13],we([0,1,20,10,3,6,45,24]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(x){return!!x&&typeof x.then=="function"}e.isThenable=E;function n(x){const Q=new y.CancellationTokenSource,$=x(Q.token),Z=new Promise((ie,re)=>{Q.token.onCancellationRequested(()=>{re((0,R.canceled)())}),Promise.resolve($).then(ye=>{Q.dispose(),ie(ye)},ye=>{Q.dispose(),re(ye)})});return new class{cancel(){Q.cancel()}then(ie,re){return Z.then(ie,re)}catch(ie){return this.then(void 0,ie)}finally(ie){return Z.finally(ie)}}}e.createCancelablePromise=n;function A(x,Q,$){return Promise.race([x,new Promise(Z=>Q.onCancellationRequested(()=>Z($)))])}e.raceCancellation=A;async function C(x){let Q=-1;const $=x.map((ie,re)=>ie.then(ye=>(Q=re,ye))),Z=await Promise.race($);return x.forEach((ie,re)=>{re!==Q&&ie.cancel()}),Z}e.raceCancellablePromises=C;function b(x,Q,$){let Z;const ie=setTimeout(()=>{Z==null||Z(void 0),$==null||$()},Q);return Promise.race([x.finally(()=>clearTimeout(ie)),new Promise(re=>Z=re)])}e.raceTimeout=b;function m(x){return new Promise((Q,$)=>{const Z=x();E(Z)?Z.then(Q,$):Q(Z)})}e.asPromise=m;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then($,$).then(Z)})}return new Promise(($,Z)=>{this.queuedPromise.then($,Z)})}return this.activePromise=Q(),new Promise(($,Z)=>{this.activePromise.then(ie=>{this.activePromise=null,$(ie)},ie=>{this.activePromise=null,Z(ie)})})}}e.Throttler=r;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class _{constructor(){this.promiseMap=new Map}queue(Q,$){var Z;const re=((Z=this.promiseMap.get(Q))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(Q)===re&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,re),re}}e.SequencerByKey=_;class g{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,$=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,ie)=>{this.doResolve=Z,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class w{constructor(Q){this.delayer=new g(Q),this.throttler=new r}trigger(Q,$){return this.delayer.trigger(()=>this.throttler.queue(Q),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class c{constructor(){this._isOpen=!1,this._promise=new Promise((Q,$)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class d extends c{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function o(x,Q){return Q?new Promise(($,Z)=>{const ie=setTimeout($,x);Q.onCancellationRequested(()=>{clearTimeout(ie),Z((0,R.canceled)())})}):n($=>o(x,$))}e.timeout=o;function t(x,Q=0){const $=setTimeout(x,Q);return(0,P.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function i(x){return x.then(void 0,Q=>{})}e.ignoreErrors=i;function u(x){const Q=[];let $=0;const Z=x.length;function ie(){return $<Z?x[$++]():null}function re(ye){ye!=null&&Q.push(ye);const Ie=ie();return Ie?Ie.then(re):Promise.resolve(Q)}return Promise.resolve(null).then(re)}e.sequence=u;function a(x,Q=Z=>!!Z,$=null){let Z=0;const ie=x.length,re=()=>{if(Z>=ie)return Promise.resolve($);const ye=x[Z++];return Promise.resolve(ye()).then(Ue=>Q(Ue)?Promise.resolve(Ue):re())};return re()}e.first=a;function l(x,Q=Z=>!!Z,$=null){if(x.length===0)return Promise.resolve($);let Z=x.length;const ie=()=>{var re,ye;Z=-1;for(const Ie of x)(ye=(re=Ie).cancel)===null||ye===void 0||ye.call(re)};return new Promise((re,ye)=>{for(const Ie of x)Ie.then(Ue=>{--Z>=0&&Q(Ue)?(ie(),re(Ue)):Z===0&&re($)}).catch(Ue=>{--Z>=0&&(ie(),ye(Ue))})})}e.firstParallel=l;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise(($,Z)=>{this.outstandingPromises.push({factory:Q,c:$,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const $=Q.factory();$.then(Q.c,Q.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class D{constructor(){this.queues=new Map}queueFor(Q,$=k.extUri){const Z=$.getComparisonKey(Q);let ie=this.queues.get(Z);return ie||(ie=new v,T.Event.once(ie.onFinished)(()=>{ie==null||ie.dispose(),this.queues.delete(Z)}),this.queues.set(Z,ie)),ie}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=D;class h{constructor(Q,$){this._token=-1,typeof Q=="function"&&typeof $=="number"&&this.setIfNotSet(Q,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},$)}setIfNotSet(Q,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},$))}}e.TimeoutTimer=h;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setInterval(()=>{Q()},$)}}e.IntervalTimer=p;class I{constructor(Q,$){this.timeoutToken=-1,this.runner=Q,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class F extends I{constructor(Q,$){super(Q,$);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const $=setTimeout(()=>Q(x));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,Q)=>{const $=requestIdleCallback(x,typeof Q=="number"?{timeout:Q}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback($))}}}}();class z{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function ue(x,Q,$){let Z;for(let ie=0;ie<$;ie++)try{return await x()}catch(re){Z=re,await o(Q)}throw Z}e.retry=ue;class H{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,$,Z){return this._pending={taskId:Q,cancel:()=>Z==null?void 0:Z(),promise:$},$.then(()=>this.donePending(Q),()=>this.donePending(Q)),$}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let $,Z;const ie=new Promise((re,ye)=>{$=re,Z=ye});this._next={run:Q,promise:ie,promiseResolve:$,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=H;class B{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,$)=>{this.completeCallback=Q,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise($=>{this.completeCallback(Q),this.resolved=!0,$()})}error(Q){return new Promise($=>{this.errorCallback(Q),this.rejected=!0,$()})}cancel(){new Promise(Q=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=K;class L extends T.Emitter{async fireAsync(Q,$,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const ie of this._listeners)this._asyncDeliveryQueue.push([ie,Q]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[ie,re]=this._asyncDeliveryQueue.shift(),ye=[],Ie=Object.assign(Object.assign({},re),{waitUntil:Ue=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Ue=Z(Ue,typeof ie=="function"?ie:ie[0])),ye.push(Ue)}});try{typeof ie=="function"?ie.call(void 0,Ie):ie[0].call(ie[1],Ie)}catch(Ue){(0,R.onUnexpectedError)(Ue);continue}Object.freeze(ye),await U.settled(ye).catch(Ue=>(0,R.onUnexpectedError)(Ue))}}}}e.AsyncEmitter=L;var U;(function(x){async function Q(re){return typeof Promise.allSettled=="function"?$(re):Z(re)}x.allSettled=Q;async function $(re){return Promise.allSettled(re)}async function Z(re){return Promise.all(re.map(ye=>ye.then(Ie=>({status:"fulfilled",value:Ie}),Ie=>({status:"rejected",reason:Ie}))))}async function ie(re){let ye;const Ie=await Promise.all(re.map(Ue=>Ue.then(Re=>Re,Re=>{ye||(ye=Re)})));if(typeof ye!="undefined")throw ye;return Ie}x.settled=ie})(U=e.Promises||(e.Promises={}))}),define(be[110],we([0,1,11,13]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new R.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),P=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(d,o,t=!1){const i=d||"",u=o||"",a=T.value.collator.compare(i,u);return T.value.collatorIsNumeric&&a===0&&i!==u?i<u?-1:1:a}e.compareFileNames=k;function E(d,o){const t=P.value.collator;return d=d||"",o=o||"",s(t,d,o)}e.compareFileNamesDefault=E;function n(d,o,t=!1){t||(d=d&&d.toLowerCase(),o=o&&o.toLowerCase());const[i,u]=m(d),[a,l]=m(o);return i!==a?i<a?-1:1:u===l?0:u<l?-1:1}e.noIntlCompareFileNames=n;function A(d,o){const[t,i]=m(d),[u,a]=m(o);let l=T.value.collator.compare(i,a);if(l===0){if(T.value.collatorIsNumeric&&i!==a)return i<a?-1:1;if(l=T.value.collator.compare(t,u),T.value.collatorIsNumeric&&l===0&&t!==u)return t<u?-1:1}return l}e.compareFileExtensions=A;function C(d,o){d=d||"",o=o||"";const t=r(d),i=r(o),u=P.value.collator,a=S.value.collator;let l;return l=s(a,t,i),l!==0?l:s(u,d,o)}e.compareFileExtensionsDefault=C;const b=/^(.*?)(\.([^.]*))?$/;function m(d,o=!1){const t=d?b.exec(d):[];let i=[t&&t[1]||"",t&&t[3]||""];return o&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(d){const o=d?b.exec(d):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function s(d,o,t){let i=d.compare(o,t);return i!==0?i:o.length!==t.length?o.length<t.length?-1:1:0}function _(d,o,t=!1){return t||(d=d&&d.toLowerCase(),o=o&&o.toLowerCase()),d===o?0:d<o?-1:1}function g(d,o,t=!1){const i=d.split(y.sep),u=o.split(y.sep),a=i.length-1,l=u.length-1;let f,v;for(let D=0;;D++){if(f=a===D,v=l===D,f&&v)return k(i[D],u[D],t);if(f)return-1;if(v)return 1;const h=_(i[D],u[D],t);if(h!==0)return h}}e.comparePaths=g;function w(d,o,t){const i=d.toLowerCase(),u=o.toLowerCase(),a=c(d,o,t);if(a)return a;const l=i.endsWith(t),f=u.endsWith(t);if(l!==f)return l?-1:1;const v=k(i,u);return v!==0?v:i.localeCompare(u)}e.compareAnything=w;function c(d,o,t){const i=d.toLowerCase(),u=o.toLowerCase(),a=i.startsWith(t),l=u.startsWith(t);if(a!==l)return a?-1:1;if(a&&l){if(i.length<u.length)return-1;if(i.length>u.length)return 1}return 0}e.compareByPrefix=c}),define(be[28],we([0,1,8,38,11,22,13]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const E="**",n="/",A="[/\\\\]",C="[^/\\\\]",b=/\//g;function m($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}|${A}${C}+)*?`}}function r($,Z){if(!$)return[];const ie=[];let re=!1,ye=!1,Ie="";for(const Ue of $){switch(Ue){case Z:if(!re&&!ye){ie.push(Ie),Ie="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ie+=Ue}return Ie&&ie.push(Ie),ie}e.splitGlobAware=r;function s($){if(!$)return"";let Z="";const ie=r($,n);if(ie.every(re=>re===E))Z=".*";else{let re=!1;ie.forEach((ye,Ie)=>{if(ye===E){re||(Z+=m(2),re=!0);return}let Ue=!1,Re="",ze=!1,N="";for(const G of ye){if(G!=="}"&&Ue){Re+=G;continue}if(ze&&(G!=="]"||!N)){let ee;G==="-"?ee=G:(G==="^"||G==="!")&&!N?ee="^":G===n?ee="":ee=y.escapeRegExpCharacters(G),N+=ee;continue}switch(G){case"{":Ue=!0;continue;case"[":ze=!0;continue;case"}":Z+=`(?:${r(Re,",").map(fe=>s(fe)).join("|")})`,Ue=!1,Re="";break;case"]":Z+="["+N+"]",ze=!1,N="";break;case"?":Z+=C;continue;case"*":Z+=m(1);continue;default:Z+=y.escapeRegExpCharacters(G)}}Ie<ie.length-1&&(ie[Ie+1]!==E||Ie+2<ie.length)&&(Z+=A),re=!1})}return Z}const _=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},u=function(){return null};function a($,Z){if(!$)return u;let ie;typeof $!="string"?ie=$.pattern:ie=$,ie=ie.trim();const re=`${ie}_${!!Z.trimForExclusions}`;let ye=t.get(re);if(ye)return l(ye,$);let Ie;if(_.test(ie)){const Ue=ie.substr(4);ye=function(Re,ze){return typeof Re=="string"&&Re.endsWith(Ue)?ie:null}}else(Ie=g.exec(f(ie,Z)))?ye=v(Ie[1],ie):(Z.trimForExclusions?c:w).test(ie)?ye=D(ie,Z):(Ie=d.exec(f(ie,Z)))?ye=h(Ie[1].substr(1),ie,!0):(Ie=o.exec(f(ie,Z)))?ye=h(Ie[1],ie,!1):ye=p(ie);return t.set(re,ye),l(ye,$)}function l($,Z){return typeof Z=="string"?$:function(ie,re){return R.isEqualOrParent(ie,Z.base)?$(T.relative(Z.base,ie),re):null}}function f($,Z){return Z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function v($,Z){const ie=`/${$}`,re=`\\${$}`,ye=function(Ue,Re){return typeof Ue!="string"?null:Re?Re===$?Z:null:Ue===$||Ue.endsWith(ie)||Ue.endsWith(re)?Z:null},Ie=[$];return ye.basenames=Ie,ye.patterns=[Z],ye.allBasenames=Ie,ye}function D($,Z){const ie=Q($.slice(1,-1).split(",").map(Re=>a(Re,Z)).filter(Re=>Re!==u),$),re=ie.length;if(!re)return u;if(re===1)return ie[0];const ye=function(Re,ze){for(let N=0,G=ie.length;N<G;N++)if(ie[N](Re,ze))return $;return null},Ie=ie.find(Re=>!!Re.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const Ue=ie.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return Ue.length&&(ye.allPaths=Ue),ye}function h($,Z,ie){const re=T.sep===T.posix.sep,ye=re?$:$.replace(b,T.sep),Ie=T.sep+ye,Ue=T.posix.sep+$,Re=ie?function(ze,N){return typeof ze=="string"&&(ze===ye||ze.endsWith(Ie)||!re&&(ze===$||ze.endsWith(Ue)))?Z:null}:function(ze,N){return typeof ze=="string"&&(ze===ye||!re&&ze===$)?Z:null};return Re.allPaths=[(ie?"*/":"./")+$],Re}function p($){try{const Z=new RegExp(`^${s($)}$`);return function(ie){return Z.lastIndex=0,typeof ie=="string"&&Z.test(ie)?$:null}}catch(Z){return u}}function I($,Z,ie){return!$||typeof Z!="string"?!1:F($)(Z,void 0,ie)}e.match=I;function F($,Z={}){if(!$)return i;if(typeof $=="string"||B($)){const ie=a($,Z);if(ie===u)return i;const re=function(ye,Ie){return!!ie(ye,Ie)};return ie.allBasenames&&(re.allBasenames=ie.allBasenames),ie.allPaths&&(re.allPaths=ie.allPaths),re}return U($,Z)}e.parse=F;function z($){if(!!$){let Z;return ie=>(Z||(Z=($()||Promise.resolve([])).then(re=>re?H(re):{})),Z.then(re=>!!re[ie]))}}e.hasSiblingPromiseFn=z;function ue($){if(!!$){let Z;return ie=>{if(!Z){const re=$();Z=re?H(re):{}}return!!Z[ie]}}}e.hasSiblingFn=ue;function H($){const Z={};for(const ie of $)Z[ie]=!0;return Z}function B($){const Z=$;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=B;function K($){return $.allBasenames||[]}e.getBasenameTerms=K;function L($){return $.allPaths||[]}e.getPathTerms=L;function U($,Z){const ie=Q(Object.getOwnPropertyNames($).map(Re=>x(Re,$[Re],Z)).filter(Re=>Re!==u)),re=ie.length;if(!re)return u;if(!ie.some(Re=>!!Re.requiresSiblings)){if(re===1)return ie[0];const Re=function(G,ee){for(let oe=0,fe=ie.length;oe<fe;oe++){const Se=ie[oe](G,ee);if(Se)return Se}return null},ze=ie.find(G=>!!G.allBasenames);ze&&(Re.allBasenames=ze.allBasenames);const N=ie.reduce((G,ee)=>ee.allPaths?G.concat(ee.allPaths):G,[]);return N.length&&(Re.allPaths=N),Re}const ye=function(Re,ze,N){let G;for(let ee=0,oe=ie.length;ee<oe;ee++){const fe=ie[ee];fe.requiresSiblings&&N&&(ze||(ze=T.basename(Re)),G||(G=ze.substr(0,ze.length-T.extname(Re).length)));const Se=fe(Re,ze,G,N);if(Se)return Se}return null},Ie=ie.find(Re=>!!Re.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const Ue=ie.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return Ue.length&&(ye.allPaths=Ue),ye}function x($,Z,ie){if(Z===!1)return u;const re=a($,ie);if(re===u)return u;if(typeof Z=="boolean")return re;if(Z){const ye=Z.when;if(typeof ye=="string"){const Ie=(Ue,Re,ze,N)=>{if(!N||!re(Ue,Re))return null;const G=ye.replace("$(basename)",ze),ee=N(G);return(0,S.isThenable)(ee)?ee.then(oe=>oe?$:null):ee?$:null};return Ie.requiresSiblings=!0,Ie}}return re}function Q($,Z){const ie=$.filter(Re=>!!Re.basenames);if(ie.length<2)return $;const re=ie.reduce((Re,ze)=>{const N=ze.basenames;return N?Re.concat(N):Re},[]);let ye;if(Z){ye=[];for(let Re=0,ze=re.length;Re<ze;Re++)ye.push(Z)}else ye=ie.reduce((Re,ze)=>{const N=ze.patterns;return N?Re.concat(N):Re},[]);const Ie=function(Re,ze){if(typeof Re!="string")return null;if(!ze){let G;for(G=Re.length;G>0;G--){const ee=Re.charCodeAt(G-1);if(ee===47||ee===92)break}ze=Re.substr(G)}const N=re.indexOf(ze);return N!==-1?ye[N]:null};Ie.basenames=re,Ie.patterns=ye,Ie.allBasenames=re;const Ue=$.filter(Re=>!Re.basenames);return Ue.push(Ie),Ue}}),define(be[58],we([0,1,2,11,8,16,21,24,38]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(a,l,f){if(typeof a=="string"&&(a=y.URI.file(a)),f){const D=f.getWorkspaceFolder(a);if(D){const h=f.getWorkspace().folders.length>1;let p;if((0,k.isEqual)(D.uri,a)?p="":p=(0,k.relativePath)(D.uri,a),h){const I=D.name?D.name:(0,k.basename)(D.uri);p=p?I+" \u2022 "+p:I}return p}}if(a.scheme!==P.Schemas.file&&a.scheme!==P.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,E.hasDriveLetter)(a.fsPath))return(0,R.normalize)(C(a.fsPath));let v=(0,R.normalize)(a.fsPath);return!S.isWindows&&(l==null?void 0:l.userHome)&&(v=m(v,l.userHome.fsPath)),v}e.getPathLabel=n;function A(a){if(!!a){typeof a=="string"&&(a=y.URI.file(a));const l=(0,k.basename)(a)||(a.scheme===P.Schemas.file?a.fsPath:a.path);return S.isWindows&&(0,E.isRootOrDriveLetter)(l)?C(l):l}}e.getBaseLabel=A;function C(a){return(0,E.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=C;let b=Object.create(null);function m(a,l){if(S.isWindows||!a||!l)return a;let f=b.original===l?b.normalized:void 0;return f||(f=`${(0,T.rtrim)(l,R.posix.sep)}${R.posix.sep}`,b={original:l,normalized:f}),(S.isLinux?a.startsWith(f):(0,T.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=m;function r(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=r;const s="\u2026",_="\\\\",g="~";function w(a,l=R.sep){const f=new Array(a.length);let v=!1;for(let D=0;D<a.length;D++){let h=a[D];if(h===""){f[D]=`.${l}`;continue}if(!h){f[D]=h;continue}v=!0;let p="";h.indexOf(_)===0?(p=h.substr(0,h.indexOf(_)+_.length),h=h.substr(h.indexOf(_)+_.length)):h.indexOf(l)===0?(p=h.substr(0,h.indexOf(l)+l.length),h=h.substr(h.indexOf(l)+l.length)):h.indexOf(g)===0&&(p=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length));const I=h.split(l);for(let F=1;v&&F<=I.length;F++)for(let z=I.length-F;v&&z>=0;z--){v=!1;let ue=I.slice(z,z+F).join(l);for(let H=0;!v&&H<a.length;H++)if(H!==D&&a[H]&&a[H].indexOf(ue)>-1){const B=z+F===I.length,K=z>0&&a[H].indexOf(l)>-1?l+ue:ue,L=a[H].endsWith(K);v=!B||L}if(!v){let H="";(I[0].endsWith(":")||p!=="")&&(z===1&&(z=0,F++,ue=I[0]+l+ue),z>0&&(H=I[0]+l),H=p+H),z>0&&(H=H+s+l),H=H+ue,z+F<I.length&&(H=H+l+s),f[D]=H}}v&&(f[D]=h)}return f}e.shorten=w;var c;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function d(a,l=Object.create(null)){const f=[];let v=!1,D="";for(const h of a)if(h==="$"||v&&h==="{")D&&f.push({value:D,type:c.TEXT}),D="",v=!0;else if(h==="}"&&v){const p=l[D];if(typeof p=="string")p.length&&f.push({value:p,type:c.VARIABLE});else if(p){const I=f[f.length-1];(!I||I.type!==c.SEPARATOR)&&f.push({value:p.label,type:c.SEPARATOR})}D="",v=!1}else D+=h;return D&&!v&&f.push({value:D,type:c.TEXT}),f.filter((h,p)=>{if(h.type===c.SEPARATOR){const I=f[p-1],F=f[p+1];return[I,F].every(z=>z&&(z.type===c.VARIABLE||z.type===c.TEXT)&&z.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=d;function o(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):S.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(a){const l=a.indexOf("/")!==-1?R.posix:R.win32,f=l.basename(a),v=l.dirname(a);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=u}),define(be[111],we([0,1,2]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(A){return A.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const b=this._uriTransformer.transformIncoming(C);return b===C?C:R(y.URI.from(b))}transformOutgoing(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:R(y.URI.from(b))}transformOutgoingURI(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:y.URI.from(b)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,C,b){if(!A||b>200)return null;if(typeof A=="object"){if(A instanceof y.URI)return C.transformOutgoing(A);for(let m in A)if(Object.hasOwnProperty.call(A,m)){const r=P(A[m],C,b+1);r!==null&&(A[m]=r)}}return null}function S(A,C){const b=P(A,C,0);return b===null?A:b}e.transformOutgoingURIs=S;function k(A,C,b,m){if(!A||m>200)return null;if(typeof A=="object"){if(A.$mid===1)return b?y.URI.revive(C.transformIncoming(A)):C.transformIncoming(A);for(let r in A)if(Object.hasOwnProperty.call(A,r)){const s=k(A[r],C,b,m+1);s!==null&&(A[r]=s)}}return null}function E(A,C){const b=k(A,C,!1,0);return b===null?A:b}e.transformIncomingURIs=E;function n(A,C){const b=k(A,C,!0,0);return b===null?A:b}e.transformAndReviveIncomingURIs=n}),define(be[29],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return y.test(E)}e.isUUID=R;const T=new Uint8Array(16),P=[];for(let E=0;E<256;E++)P.push(E.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let n=0;n<E.length;n++)E[n]=Math.floor(Math.random()*256);return E};function k(){S(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let E=0,n="";return n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+="-",n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n+=P[T[E++]],n}e.generateUuid=k}),define(be[81],we([0,1,79]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(k){let E=(0,y.toUint8)(k);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(k){let E=new Uint8Array(256);for(let n=0;n<256;n++)E[n]=k;return E}set(k,E){let n=(0,y.toUint8)(E);k>=0&&k<256?this._asciiMap[k]=n:this._map.set(k,n)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=R;var T;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new R(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=P}),define(be[112],we([0,1,81]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends y.CharacterClassifier{constructor(k){super(0);for(let E=0,n=k.length;E<n;E++)this.set(k.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(S){let k={};return E=>(k.hasOwnProperty(E)||(k[E]=S(E)),k[E])}e.getMapForWordSeparators=P(S=>new T(S))}),define(be[39],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new y(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return y.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return y.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return y.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let S=T.lineNumber|0,k=P.lineNumber|0;if(S===k){let E=T.column|0,n=P.column|0;return E-n}return S-k}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new y(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=y}),define(be[33],we([0,1,39]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(P,S,k,E){P>k||P===k&&S>E?(this.startLineNumber=k,this.startColumn=E,this.endLineNumber=P,this.endColumn=S):(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=k,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return R.containsPosition(this,P)}static containsPosition(P,S){return!(S.lineNumber<P.startLineNumber||S.lineNumber>P.endLineNumber||S.lineNumber===P.startLineNumber&&S.column<P.startColumn||S.lineNumber===P.endLineNumber&&S.column>P.endColumn)}containsRange(P){return R.containsRange(this,P)}static containsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>P.endColumn)}strictContainsRange(P){return R.strictContainsRange(this,P)}static strictContainsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<=P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>=P.endColumn)}plusRange(P){return R.plusRange(this,P)}static plusRange(P,S){let k,E,n,A;return S.startLineNumber<P.startLineNumber?(k=S.startLineNumber,E=S.startColumn):S.startLineNumber===P.startLineNumber?(k=S.startLineNumber,E=Math.min(S.startColumn,P.startColumn)):(k=P.startLineNumber,E=P.startColumn),S.endLineNumber>P.endLineNumber?(n=S.endLineNumber,A=S.endColumn):S.endLineNumber===P.endLineNumber?(n=S.endLineNumber,A=Math.max(S.endColumn,P.endColumn)):(n=P.endLineNumber,A=P.endColumn),new R(k,E,n,A)}intersectRanges(P){return R.intersectRanges(this,P)}static intersectRanges(P,S){let k=P.startLineNumber,E=P.startColumn,n=P.endLineNumber,A=P.endColumn,C=S.startLineNumber,b=S.startColumn,m=S.endLineNumber,r=S.endColumn;return k<C?(k=C,E=b):k===C&&(E=Math.max(E,b)),n>m?(n=m,A=r):n===m&&(A=Math.min(A,r)),k>n||k===n&&E>A?null:new R(k,E,n,A)}equalsRange(P){return R.equalsRange(this,P)}static equalsRange(P,S){return!!P&&!!S&&P.startLineNumber===S.startLineNumber&&P.startColumn===S.startColumn&&P.endLineNumber===S.endLineNumber&&P.endColumn===S.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(P){return new y.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(P){return new y.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,S){return new R(this.startLineNumber,this.startColumn,P,S)}setStartPosition(P,S){return new R(P,S,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(P){return new R(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,S=P){return new R(P.lineNumber,P.column,S.lineNumber,S.column)}static lift(P){return P?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<P.startColumn)}static areIntersecting(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<=S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,S){if(P&&S){const n=P.startLineNumber|0,A=S.startLineNumber|0;if(n===A){const C=P.startColumn|0,b=S.startColumn|0;if(C===b){const m=P.endLineNumber|0,r=S.endLineNumber|0;if(m===r){const s=P.endColumn|0,_=S.endColumn|0;return s-_}return m-r}return C-b}return n-A}return(P?1:0)-(S?1:0)}static compareRangesUsingEnds(P,S){return P.endLineNumber===S.endLineNumber?P.endColumn===S.endColumn?P.startLineNumber===S.startLineNumber?P.startColumn-S.startColumn:P.startLineNumber-S.startLineNumber:P.endColumn-S.endColumn:P.endLineNumber-S.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=R}),define(be[113],we([0,1,39,33]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends R.Range{constructor(k,E,n,A){super(k,E,n,A);this.selectionStartLineNumber=k,this.selectionStartColumn=E,this.positionLineNumber=n,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return P.selectionsEqual(this,k)}static selectionsEqual(k,E){return k.selectionStartLineNumber===E.selectionStartLineNumber&&k.selectionStartColumn===E.selectionStartColumn&&k.positionLineNumber===E.positionLineNumber&&k.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,k,E):new P(k,E,this.startLineNumber,this.startColumn)}getPosition(){return new y.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,E){return this.getDirection()===0?new P(k,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,k,E)}static fromPositions(k,E=k){return new P(k.lineNumber,k.column,E.lineNumber,E.column)}static liftSelection(k){return new P(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,E){if(k&&!E||!k&&E)return!1;if(!k&&!E)return!0;if(k.length!==E.length)return!1;for(let n=0,A=k.length;n<A;n++)if(!this.selectionsEqual(k[n],E[n]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,E,n,A,C){return C===0?new P(k,E,n,A):new P(n,A,k,E)}}e.Selection=P}),define(be[82],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var y;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(y=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class E{constructor(r,s){this.range=r,this.matches=s}}e.FindMatch=E;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class C{constructor(r,s,_,g,w,c){this.identifier=r,this.range=s,this.text=_,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=w,this._isTracked=c}}e.ValidAnnotatedEditOperation=C;class b{constructor(r,s,_){this.reverseEdits=r,this.changes=s,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=b}),define(be[114],we([0,1,8,112,39,33,82]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class E{constructor(c,d,o,t){this.searchString=c,this.isRegex=d,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=n(this.searchString):c=this.searchString.indexOf(`
`)>=0;let d=null;try{d=y.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let o=!this.isRegex&&!c;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new A(d,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=E;function n(w){if(!w||w.length===0)return!1;for(let c=0,d=w.length;c<d;c++)if(w.charCodeAt(c)===92){if(c++,c>=d)break;const t=w.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class A{constructor(c,d,o){this.regex=c,this.wordSeparators=d,this.simpleSearch=o}}e.SearchData=A;function C(w,c,d){if(!d)return new S.FindMatch(w,null);let o=[];for(let t=0,i=c.length;t<i;t++)o[t]=c[t];return new S.FindMatch(w,o)}e.createFindMatch=C;class b{constructor(c){let d=[],o=0;for(let t=0,i=c.length;t<i;t++)c.charCodeAt(t)===10&&(d[o++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(c){const d=this._lineFeedsOffsets;let o=0,t=d.length-1;if(t===-1||c<=d[0])return 0;for(;o<t;){const i=o+((t-o)/2>>0);d[i]>=c?t=i-1:d[i+1]>=c?(o=i,t=i):o=i+1}return o+1}}class m{static findMatches(c,d,o,t,i){const u=d.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(c,o,new g(u.wordSeparators,u.regex),t,i):this._doFindMatchesLineByLine(c,o,u,t,i):[]}static _getMultilineMatchRange(c,d,o,t,i,u){let a,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),a=d+i+l):a=d+i;let f;if(t){let p=t.findLineFeedCountBeforeOffset(i+u.length)-l;f=a+u.length+p}else f=a+u.length;const v=c.getPositionAt(a),D=c.getPositionAt(f);return new P.Range(v.lineNumber,v.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(c,d,o,t,i){const u=c.getOffsetAt(d.getStartPosition()),a=c.getValueInRange(d,1),l=c.getEOL()===`\r
`?new b(a):null,f=[];let v=0,D;for(o.reset(0);D=o.next(a);)if(f[v++]=C(this._getMultilineMatchRange(c,u,a,l,D.index,D[0]),D,t),v>=i)return f;return f}static _doFindMatchesLineByLine(c,d,o,t,i){const u=[];let a=0;if(d.startLineNumber===d.endLineNumber){const f=c.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return a=this._findMatchesInLine(o,f,d.startLineNumber,d.startColumn-1,a,u,t,i),u}const l=c.getLineContent(d.startLineNumber).substring(d.startColumn-1);a=this._findMatchesInLine(o,l,d.startLineNumber,d.startColumn-1,a,u,t,i);for(let f=d.startLineNumber+1;f<d.endLineNumber&&a<i;f++)a=this._findMatchesInLine(o,c.getLineContent(f),f,0,a,u,t,i);if(a<i){const f=c.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);a=this._findMatchesInLine(o,f,d.endLineNumber,0,a,u,t,i)}return u}static _findMatchesInLine(c,d,o,t,i,u,a,l){const f=c.wordSeparators;if(!a&&c.simpleSearch){const h=c.simpleSearch,p=h.length,I=d.length;let F=-p;for(;(F=d.indexOf(h,F+p))!==-1;)if((!f||_(f,d,I,F,p))&&(u[i++]=new S.FindMatch(new P.Range(o,F+1+t,o,F+1+p+t),null),i>=l))return i;return i}const v=new g(c.wordSeparators,c.regex);let D;v.reset(0);do if(D=v.next(d),D&&(u[i++]=C(new P.Range(o,D.index+1+t,o,D.index+1+D[0].length+t),D,a),i>=l))return i;while(D);return i}static findNextMatch(c,d,o,t){const i=d.parseSearchRequest();if(!i)return null;const u=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(c,o,u,t):this._doFindNextMatchLineByLine(c,o,u,t)}static _doFindNextMatchMultiline(c,d,o,t){const i=new T.Position(d.lineNumber,1),u=c.getOffsetAt(i),a=c.getLineCount(),l=c.getValueInRange(new P.Range(i.lineNumber,i.column,a,c.getLineMaxColumn(a)),1),f=c.getEOL()===`\r
`?new b(l):null;o.reset(d.column-1);let v=o.next(l);return v?C(this._getMultilineMatchRange(c,u,l,f,v.index,v[0]),v,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(c,new T.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(c,d,o,t){const i=c.getLineCount(),u=d.lineNumber,a=c.getLineContent(u),l=this._findFirstMatchInLine(o,a,u,d.column,t);if(l)return l;for(let f=1;f<=i;f++){const v=(u+f-1)%i,D=c.getLineContent(v+1),h=this._findFirstMatchInLine(o,D,v+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(c,d,o,t,i){c.reset(t-1);const u=c.next(d);return u?C(new P.Range(o,u.index+1,o,u.index+1+u[0].length),u,i):null}static findPreviousMatch(c,d,o,t){const i=d.parseSearchRequest();if(!i)return null;const u=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(c,o,u,t):this._doFindPreviousMatchLineByLine(c,o,u,t)}static _doFindPreviousMatchMultiline(c,d,o,t){const i=this._doFindMatchesMultiline(c,new P.Range(1,1,d.lineNumber,d.column),o,t,10*k);if(i.length>0)return i[i.length-1];const u=c.getLineCount();return d.lineNumber!==u||d.column!==c.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(c,new T.Position(u,c.getLineMaxColumn(u)),o,t):null}static _doFindPreviousMatchLineByLine(c,d,o,t){const i=c.getLineCount(),u=d.lineNumber,a=c.getLineContent(u).substring(0,d.column-1),l=this._findLastMatchInLine(o,a,u,t);if(l)return l;for(let f=1;f<=i;f++){const v=(i+u-f-1)%i,D=c.getLineContent(v+1),h=this._findLastMatchInLine(o,D,v+1,t);if(h)return h}return null}static _findLastMatchInLine(c,d,o,t){let i=null,u;for(c.reset(0);u=c.next(d);)i=C(new P.Range(o,u.index+1,o,u.index+1+u[0].length),u,t);return i}}e.TextModelSearch=m;function r(w,c,d,o,t){if(o===0)return!0;const i=c.charCodeAt(o-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const u=c.charCodeAt(o);if(w.get(u)!==0)return!0}return!1}function s(w,c,d,o,t){if(o+t===d)return!0;const i=c.charCodeAt(o+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const u=c.charCodeAt(o+t-1);if(w.get(u)!==0)return!0}return!1}function _(w,c,d,o,t){return r(w,c,d,o,t)&&s(w,c,d,o,t)}e.isValidMatch=_;class g{constructor(c,d){this._wordSeparators=c,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const d=c.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(o=this._searchRegex.exec(c),!o))return null;const t=o.index,i=o[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){y.getNextCodePoint(c,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||_(this._wordSeparators,c,d,t,i))return o}while(o);return null}}e.Searcher=g}),define(be[83],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function y(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)k.indexOf(n)>=0||(E+="\\"+n);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=y();function R(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let n="g";k.ignoreCase&&(n+="i"),k.multiline&&(n+="m"),k.unicode&&(n+="u"),E=new RegExp(k.source,n)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(k,E,n,A,C=T){if(n.length>C.maxLen){let _=k-C.maxLen/2;return _<0?_=0:A+=_,n=n.substring(_,k+C.maxLen/2),P(k,E,n,A,C)}const b=Date.now(),m=k-1-A;let r=-1,s=null;for(let _=1;!(Date.now()-b>=C.timeBudget);_++){const g=m-C.windowSize*_;E.lastIndex=Math.max(0,g);const w=S(E,n,m,r);if(!w&&s||(s=w,g<=0))break;r=g}if(s){let _={word:s[0],startColumn:A+1+s.index,endColumn:A+1+s.index+s[0].length};return E.lastIndex=0,_}return null}e.getWordAtText=P;function S(k,E,n,A){let C;for(;C=k.exec(E);){const b=C.index||0;if(b<=n&&k.lastIndex>=n)return C;if(A>0&&b>A)return null}return null}}),define(be[115],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var y;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(y=e.IndentAction||(e.IndentAction={}));class R{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let E=0,n=k.notIn.length;E<n;E++)switch(k.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=R;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of k)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=T;function P(S,k,E){S.has(k)?S.get(k).push(E):S.set(k,[E])}}),define(be[59],we([0,1,28,11]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,S,k,E){if(Array.isArray(P)){let n=0;for(const A of P){const C=T(A,S,k,E);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof P=="string")return E?P==="*"?5:P===k?10:0:0;if(P){const{language:n,pattern:A,scheme:C,hasAccessToAllModels:b}=P;if(!E&&!b)return 0;let m=0;if(C)if(C===S.scheme)m=10;else if(C==="*")m=5;else return 0;if(n)if(n===k)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(A){let r;if(typeof A=="string"?r=A:r=Object.assign(Object.assign({},A),{base:(0,R.normalize)(A.base)}),r===S.fsPath||(0,y.match)(r,S.fsPath))m=10;else return 0}return m}else return 0}}e.score=T}),define(be[116],we([0,1,81]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class T{constructor(r,s,_){const g=new Uint8Array(r*s);for(let w=0,c=r*s;w<c;w++)g[w]=_;this._data=g,this.rows=r,this.cols=s}get(r,s){return this._data[r*this.cols+s]}set(r,s,_){this._data[r*this.cols+s]=_}}e.Uint8Matrix=T;class P{constructor(r){let s=0,_=0;for(let w=0,c=r.length;w<c;w++){let[d,o,t]=r[w];o>s&&(s=o),d>_&&(_=d),t>_&&(_=t)}s++,_++;let g=new T(_,s,0);for(let w=0,c=r.length;w<c;w++){let[d,o,t]=r[w];g.set(d,o,t)}this._states=g,this._maxCharCode=s}nextState(r,s){return s<0||s>=this._maxCharCode?0:this._states.get(r,s)}}e.StateMachine=P;let S=null;function k(){return S===null&&(S=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var E;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let n=null;function A(){if(n===null){n=new y.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<m.length;s++)n.set(m.charCodeAt(s),1);const r=".,;";for(let s=0;s<r.length;s++)n.set(r.charCodeAt(s),2)}return n}class C{static _createLink(r,s,_,g,w){let c=w-1;do{const d=s.charCodeAt(c);if(r.get(d)!==2)break;c--}while(c>g);if(g>0){const d=s.charCodeAt(g-1),o=s.charCodeAt(c);(d===40&&o===41||d===91&&o===93||d===123&&o===125)&&c--}return{range:{startLineNumber:_,startColumn:g+1,endLineNumber:_,endColumn:c+2},url:s.substring(g,c+1)}}static computeLinks(r,s=k()){const _=A();let g=[];for(let w=1,c=r.getLineCount();w<=c;w++){const d=r.getLineContent(w),o=d.length;let t=0,i=0,u=0,a=1,l=!1,f=!1,v=!1,D=!1;for(;t<o;){let h=!1;const p=d.charCodeAt(t);if(a===13){let I;switch(p){case 40:l=!0,I=0;break;case 41:I=l?0:1;break;case 91:v=!0,f=!0,I=0;break;case 93:v=!1,I=f?0:1;break;case 123:D=!0,I=0;break;case 125:I=D?0:1;break;case 39:I=u===34||u===96?0:1;break;case 34:I=u===39||u===96?0:1;break;case 96:I=u===39||u===34?0:1;break;case 42:I=u===42?1:0;break;case 124:I=u===124?1:0;break;case 32:I=v?0:1;break;default:I=_.get(p)}I===1&&(g.push(C._createLink(_,d,w,i,t)),h=!0)}else if(a===12){let I;p===91?(f=!0,I=0):I=_.get(p),I===1?h=!0:a=13}else a=s.nextState(a,p),a===0&&(h=!0);h&&(a=1,l=!1,f=!1,D=!1,i=t+1,u=p),t++}a===13&&g.push(C._createLink(_,d,w,i,o))}return g}}e.LinkComputer=C;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=b}),define(be[117],we([0,1,3,6]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,k){return this._map.set(S,k),this.fire([S]),(0,R.toDisposable)(()=>{this._map.get(S)===k&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,k){let E=null,n=!1;return this._promises.set(S,k.then(A=>{this._promises.delete(S),!(n||!A)&&(E=this.register(S,A))})),(0,R.toDisposable)(()=>{n=!0,E&&E.dispose()})}getPromise(S){const k=this.get(S);if(k)return Promise.resolve(k);const E=this._promises.get(S);return E?E.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(be[84],we([0,1,26,21]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function P(C){for(let b=0,m=C.length;b<m;b+=4){const r=C[b+0],s=C[b+1],_=C[b+2],g=C[b+3];C[b+0]=g,C[b+1]=_,C[b+2]=s,C[b+3]=r}}function S(C){const b=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return R.isLittleEndian()||P(b),y.VSBuffer.wrap(b)}function k(C){const b=C.buffer;if(R.isLittleEndian()||P(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const m=new Uint8Array(b.byteLength);return m.set(b),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function E(C){const b=new Uint32Array(n(C));let m=0;if(b[m++]=C.id,C.type==="full")b[m++]=1,b[m++]=C.data.length,b.set(C.data,m),m+=C.data.length;else{b[m++]=2,b[m++]=C.deltas.length;for(const r of C.deltas)b[m++]=r.start,b[m++]=r.deleteCount,r.data?(b[m++]=r.data.length,b.set(r.data,m),m+=r.data.length):b[m++]=0}return S(b)}e.encodeSemanticTokensDto=E;function n(C){let b=0;if(b+=1+1,C.type==="full")b+=1+C.data.length;else{b+=1,b+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(b+=m.data.length)}return b}function A(C){const b=k(C);let m=0;const r=b[m++];if(b[m++]===1){const w=b[m++],c=b.subarray(m,m+w);return m+=w,{id:r,type:"full",data:c}}const _=b[m++];let g=[];for(let w=0;w<_;w++){const c=b[m++],d=b[m++],o=b[m++];let t;o>0&&(t=b.subarray(m,m+o),m+=o),g[w]={start:c,deleteCount:d,data:t}}return{id:r,type:"delta",deltas:g}}e.decodeSemanticTokensDto=A}),define(be[85],we([0,1,79]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(S,k){this.index=S,this.remainder=k}}e.PrefixSumIndexOfResult=R;class T{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,k){S=(0,y.toUint32)(S);const E=this.values,n=this.prefixSum,A=k.length;return A===0?!1:(this.values=new Uint32Array(E.length+A),this.values.set(E.subarray(0,S),0),this.values.set(E.subarray(S),S+A),this.values.set(k,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,k){return S=(0,y.toUint32)(S),k=(0,y.toUint32)(k),this.values[S]===k?!1:(this.values[S]=k,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,k){S=(0,y.toUint32)(S),k=(0,y.toUint32)(k);const E=this.values,n=this.prefixSum;if(S>=E.length)return!1;let A=E.length-S;return k>=A&&(k=A),k===0?!1:(this.values=new Uint32Array(E.length-k),this.values.set(E.subarray(0,S),0),this.values.set(E.subarray(S+k),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,y.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),S>=this.values.length&&(S=this.values.length-1);for(let E=k;E<=S;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let k=0,E=this.values.length-1,n=0,A=0,C=0;for(;k<=E;)if(n=k+(E-k)/2|0,A=this.prefixSum[n],C=A-this.values[n],S<C)E=n-1;else if(S>=A)k=n+1;else break;return new R(n,S-C)}}e.PrefixSumComputer=T}),define(be[118],we([0,1,8,39,85]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(k,E,n,A){this._uri=k,this._lines=E,this._eol=n,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const E=k.changes;for(const n of E)this._acceptDeleteRange(n.range),this._acceptInsertText(new R.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,E=this._lines.length,n=new Uint32Array(E);for(let A=0;A<E;A++)n[A]=this._lines[A].length+k;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(k,E){this._lines[k]=E,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,E){if(E.length!==0){let n=(0,y.splitLines)(E);if(n.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}n[n.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]);let A=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(k.lineNumber+C-1,0,n[C]),A[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,A)}}}e.MirrorTextModel=P}),define(be[119],we([17,18]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(be[60],we([0,1,119,12,15]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,A){return A&&(n.stack||n.stacktrace)?y.localize(0,null,k(n),S(n.stack)||S(n.stacktrace)):k(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function k(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?y.localize(1,null,n.message):n.message||y.localize(2,null)}function E(n=null,A=!1){if(!n)return y.localize(3,null);if(Array.isArray(n)){const C=T.coalesce(n),b=E(C[0],A);return C.length>1?y.localize(4,null,b,C.length):b}if(R.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return P(C.error,A);if(C.exception)return P(C.exception,A)}return n.stack?P(n,A):n.message?n.message:y.localize(5,null)}e.toErrorMessage=E}),define(be[120],we([17,18]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(be[121],we([0,1,120,21,83]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=S;class k{constructor(){this._values=[]}_read(Y){return this._values[Y]}get(Y){return this._values[Y]}_write(Y,pe){this._values[Y]=pe}}e.ValidatedEditorOptions=k;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class n{constructor(Y,pe,Fe,He){this.id=Y,this.name=pe,this.defaultValue=Fe,this.schema=He}compute(Y,pe,Fe){return Fe}}class A{constructor(Y,pe=null){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Y){return this.defaultValue}}class C{constructor(Y,pe,Fe,He){this.id=Y,this.name=pe,this.defaultValue=Fe,this.schema=He}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,pe,Fe){return Fe}}function b(j,Y){return typeof j=="undefined"?Y:j==="false"?!1:Boolean(j)}e.boolean=b;class m extends C{constructor(Y,pe,Fe,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Fe),super(Y,pe,Fe,He)}validate(Y){return b(Y,this.defaultValue)}}class r extends C{constructor(Y,pe,Fe,He,Oe,tt=void 0){typeof tt!="undefined"&&(tt.type="integer",tt.default=Fe,tt.minimum=He,tt.maximum=Oe),super(Y,pe,Fe,tt),this.minimum=He,this.maximum=Oe}static clampedInt(Y,pe,Fe,He){if(typeof Y=="undefined")return pe;let Oe=parseInt(Y,10);return isNaN(Oe)?pe:(Oe=Math.max(Fe,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(Y){return r.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class s extends C{constructor(Y,pe,Fe,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Fe),super(Y,pe,Fe,Oe),this.validationFn=He}static clamp(Y,pe,Fe){return Y<pe?pe:Y>Fe?Fe:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return pe;const Fe=parseFloat(Y);return isNaN(Fe)?pe:Fe}validate(Y){return this.validationFn(s.float(Y,this.defaultValue))}}class _ extends C{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,Fe,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Fe),super(Y,pe,Fe,He)}validate(Y){return _.string(Y,this.defaultValue)}}function g(j,Y,pe){return typeof j!="string"||pe.indexOf(j)===-1?Y:j}e.stringSet=g;class w extends C{constructor(Y,pe,Fe,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Fe),super(Y,pe,Fe,Oe),this._allowedValues=He}validate(Y){return g(Y,this.defaultValue,this._allowedValues)}}class c extends n{constructor(Y,pe,Fe,He,Oe,tt,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=Oe,W.default=He),super(Y,pe,Fe,W),this._allowedValues=Oe,this._convert=tt}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function d(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[y.localize(0,null),y.localize(1,null),y.localize(2,null)],default:"auto",description:y.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,Fe){return Fe===0?Y.accessibilitySupport:Fe}}class t extends n{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:y.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:y.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:b(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(j){switch(j){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function f(j){switch(j){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class v extends A{constructor(){super(123,[62,31])}compute(Y,pe,Fe){const He=["monaco-editor"];return pe.get(31)&&He.push(pe.get(31)),Y.extraEditorClassName&&He.push(Y.extraEditorClassName),pe.get(62)==="default"?He.push("mouse-default"):pe.get(62)==="copy"&&He.push("mouse-copy"),pe.get(97)&&He.push("showUnused"),pe.get(121)&&He.push("showDeprecated"),He.join(" ")}}class D extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:y.localize(6,null)})}compute(Y,pe,Fe){return Fe&&Y.emptySelectionClipboard}}class h extends n{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:y.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Y.seedSearchStringFromSelection,description:y.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[y.localize(9,null),y.localize(10,null),y.localize(11,null)],description:y.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:y.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:y.localize(14,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:y.localize(15,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:b(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":g(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(pe.loop,this.defaultValue.loop)}}}class p extends n{constructor(){super(41,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:y.localize(16,null)},{type:"string",description:y.localize(17,null)}],description:y.localize(18,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?p.OFF:Y==="true"?p.ON:Y:Boolean(Y)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class I extends A{constructor(){super(40)}compute(Y,pe,Fe){return Y.fontInfo}}class F extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:y.localize(19,null)})}validate(Y){let pe=s.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(pe,6,100)}compute(Y,pe,Fe){return Y.fontInfo.fontSize}}class z extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:y.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:y.localize(21,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(r.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class ue extends n{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[y.localize(22,null),y.localize(23,null),y.localize(24,null)]};super(47,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:y.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:y.localize(26,null)},pe),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:y.localize(27,null)},pe),"editor.gotoLocation.multipleDeclarations":Object.assign({description:y.localize(28,null)},pe),"editor.gotoLocation.multipleImplementations":Object.assign({description:y.localize(29,null)},pe),"editor.gotoLocation.multipleReferences":Object.assign({description:y.localize(30,null)},pe),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,description:y.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,description:y.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,description:y.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,description:y.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,description:y.localize(35,null)}})}validate(Y){var pe,Fe,He,Oe,tt;if(!Y||typeof Y!="object")return this.defaultValue;const W=Y;return{multiple:g(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(pe=W.multipleDefinitions)!==null&&pe!==void 0?pe:g(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=W.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:g(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:g(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=W.multipleImplementations)!==null&&Oe!==void 0?Oe:g(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(tt=W.multipleReferences)!==null&&tt!==void 0?tt:g(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const Y={enabled:!0,delay:300,sticky:!0};super(50,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:y.localize(36,null)},"editor.hover.delay":{type:"number",default:Y.delay,description:y.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:y.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:b(pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:b(pe.sticky,this.defaultValue.sticky)}}}var B;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class K extends A{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(Y,pe,Fe){return K.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,Fe=Y.scrollBeyondLastLine?pe-1:0,He=(Y.viewLineCount+Fe)/(Y.pixelRatio*Y.height),Oe=Math.floor(Y.viewLineCount/He);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Fe,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(Y,pe){const Fe=Y.outerWidth,He=Y.outerHeight,Oe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const tt=pe.stableMinimapLayoutInput,W=tt&&Y.outerHeight===tt.outerHeight&&Y.lineHeight===tt.lineHeight&&Y.typicalHalfwidthCharacterWidth===tt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===tt.pixelRatio&&Y.scrollBeyondLastLine===tt.scrollBeyondLastLine&&Y.minimap.enabled===tt.minimap.enabled&&Y.minimap.side===tt.minimap.side&&Y.minimap.size===tt.minimap.size&&Y.minimap.showSlider===tt.minimap.showSlider&&Y.minimap.renderCharacters===tt.minimap.renderCharacters&&Y.minimap.maxColumn===tt.minimap.maxColumn&&Y.minimap.scale===tt.minimap.scale&&Y.verticalScrollbarWidth===tt.verticalScrollbarWidth&&Y.isViewportWrapping===tt.isViewportWrapping,te=Y.lineHeight,de=Y.typicalHalfwidthCharacterWidth,q=Y.scrollBeyondLastLine,J=Y.minimap.renderCharacters;let se=Oe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const he=Y.minimap.maxColumn,ge=Y.minimap.size,We=Y.minimap.side,Ne=Y.verticalScrollbarWidth,je=Y.viewLineCount,Ye=Y.remainingWidth,Ze=Y.isViewportWrapping,ct=J?2:3;let lt=Math.floor(Oe*He);const it=lt/Oe;let Ve=!1,ve=!1,De=ct*se,ae=se/Oe,V=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:st,desiredRatio:vt,minimapLineCount:mt}=K.computeContainedMinimapLineCount({viewLineCount:je,scrollBeyondLastLine:q,height:He,lineHeight:te,pixelRatio:Oe});if(je/mt>1)Ve=!0,ve=!0,se=1,De=1,ae=se/Oe;else{let _t=!1,Et=se+1;if(ge==="fit"){const pt=Math.ceil((je+st)*De);Ze&&W&&Ye<=pe.stableFitRemainingWidth?(_t=!0,Et=pe.stableFitMaxMinimapScale):(_t=pt>lt,Ze&&_t?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=Ye):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0))}if(ge==="fill"||_t){Ve=!0;const pt=se;De=Math.min(te*Oe,Math.max(1,Math.floor(1/vt))),se=Math.min(Et,Math.max(1,Math.floor(De/ct))),se>pt&&(V=Math.min(2,se/pt)),ae=se/Oe/V,lt=Math.ceil(Math.max(Xe,je+st)*De),Ze&&_t&&(pe.stableFitMaxMinimapScale=se)}}}const Me=Math.floor(he*ae),Ae=Math.min(Me,Math.max(0,Math.floor((Ye-Ne-2)*ae/(de+ae)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(Oe*Ae);const Qe=et/Oe;et=Math.floor(et*V);const at=J?1:2,rt=We==="left"?0:Fe-Ae-Ne;return{renderMinimap:at,minimapLeft:rt,minimapWidth:Ae,minimapHeightIsEditorHeight:Ve,minimapIsSampling:ve,minimapScale:se,minimapLineHeight:De,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:it}}static computeLayout(Y,pe){const Fe=pe.outerWidth|0,He=pe.outerHeight|0,Oe=pe.lineHeight|0,tt=pe.lineNumbersDigitCount|0,W=pe.typicalHalfwidthCharacterWidth,te=pe.maxDigitWidth,de=pe.pixelRatio,q=pe.viewLineCount,J=Y.get(118),se=J==="inherit"?Y.get(117):J,he=se==="inherit"?Y.get(113):se,ge=Y.get(116),We=Y.get(2),Ne=pe.isDominatedByLongLines,je=Y.get(46),Ye=Y.get(56).renderType!==0,Ze=Y.get(57),ct=Y.get(91),lt=Y.get(61),it=Y.get(89),Ve=it.verticalScrollbarSize,ve=it.verticalHasArrows,De=it.arrowSize,ae=it.horizontalScrollbarSize,V=Y.get(54),Me=Y.get(35);let Ae;if(typeof V=="string"&&/^\d+(\.\d+)?ch$/.test(V)){const ft=parseFloat(V.substr(0,V.length-2));Ae=r.clampedInt(ft*W,0,0,1e3)}else Ae=r.clampedInt(V,0,0,1e3);Me&&(Ae+=16);let et=0;if(Ye){const ft=Math.max(tt,Ze);et=Math.round(ft*te)}let Qe=0;je&&(Qe=Oe);let at=0,rt=at+Qe,Xe=rt+et,st=Xe+Ae;const vt=Fe-Qe-et-Ae;let mt=!1,Dt=!1,_t=-1;We!==2&&(se==="inherit"&&Ne?(mt=!0,Dt=!0):he==="on"||he==="bounded"?Dt=!0:he==="wordWrapColumn"&&(_t=ge));const Et=K._computeMinimapLayout({outerWidth:Fe,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:W,pixelRatio:de,scrollBeyondLastLine:ct,minimap:lt,verticalScrollbarWidth:Ve,viewLineCount:q,remainingWidth:vt,isViewportWrapping:Dt},pe.memory||new E);Et.renderMinimap!==0&&Et.minimapLeft===0&&(at+=Et.minimapWidth,rt+=Et.minimapWidth,Xe+=Et.minimapWidth,st+=Et.minimapWidth);const pt=vt-Et.minimapWidth,Ft=Math.max(1,Math.floor((pt-Ve-2)/W)),Lt=ve?De:0;return Dt&&(_t=Math.max(1,Ft),he==="bounded"&&(_t=Math.min(_t,ge))),{width:Fe,height:He,glyphMarginLeft:at,glyphMarginWidth:Qe,lineNumbersLeft:rt,lineNumbersWidth:et,decorationsLeft:Xe,decorationsWidth:Ae,contentLeft:st,contentWidth:pt,minimap:Et,viewportColumn:Ft,isWordWrapMinified:mt,isViewportWrapping:Dt,wrappingColumn:_t,verticalScrollbarWidth:Ve,horizontalScrollbarHeight:ae,overviewRuler:{top:Lt,width:Ve,height:He-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=K;class L extends n{constructor(){const Y={enabled:!0};super(53,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:y.localize(39,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:b(Y.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",Y,{"editor.inlineHints.enabled":{type:"boolean",default:Y.enabled,description:y.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Y.fontSize,description:y.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Y.fontFamily,description:y.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:b(pe.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class x extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:y.localize(43,null)})}compute(Y,pe,Fe){return Y.fontInfo.lineHeight}}class Q extends n{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:y.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[y.localize(45,null),y.localize(46,null),y.localize(47,null)],default:Y.size,description:y.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:y.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:y.localize(50,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:y.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:y.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:y.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:b(pe.enabled,this.defaultValue.enabled),size:g(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(pe.side,this.defaultValue.side,["right","left"]),showSlider:g(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(pe.scale,1,1,3),maxColumn:r.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(j){return j==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:y.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:y.localize(55,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:r.clampedInt(pe.top,0,0,1e3),bottom:r.clampedInt(pe.bottom,0,0,1e3)}}}class ie extends n{constructor(){const Y={enabled:!0,cycle:!1};super(72,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:y.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:y.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:b(pe.enabled,this.defaultValue.enabled),cycle:b(pe.cycle,this.defaultValue.cycle)}}}class re extends A{constructor(){super(124)}compute(Y,pe,Fe){return Y.pixelRatio}}class ye extends n{constructor(){const Y={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Y.strings,description:y.localize(58,null)},comments:{type:"boolean",default:Y.comments,description:y.localize(59,null)},other:{type:"boolean",default:Y.other,description:y.localize(60,null)}}}],default:Y,description:y.localize(61,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean")return Y;if(Y&&typeof Y=="object"){const pe=Y,Fe={other:b(pe.other,this.defaultValue.other),comments:b(pe.comments,this.defaultValue.comments),strings:b(pe.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var Ie;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ue extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[y.localize(62,null),y.localize(63,null),y.localize(64,null),y.localize(65,null)],default:"on",description:y.localize(66,null)})}validate(Y){let pe=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(pe=4,Fe=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:Fe}}}function Re(j){const Y=j.get(84);return Y==="editable"?j.get(77):Y!=="on"}e.filterValidationDecorations=Re;class ze extends n{constructor(){const Y=[],pe={type:"number",description:y.localize(67,null)};super(88,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:y.localize(68,null),format:"color-hex"}}}]},default:Y,description:y.localize(69,null)})}validate(Y){if(Array.isArray(Y)){let pe=[];for(let Fe of Y)if(typeof Fe=="number")pe.push({column:r.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const He=Fe;pe.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return pe.sort((Fe,He)=>Fe.column-He.column),pe}return this.defaultValue}}function N(j,Y){if(typeof j!="string")return Y;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,Fe=r.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(pe.vertical,this.defaultValue.vertical),horizontal:N(pe.horizontal,this.defaultValue.horizontal),useShadows:b(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:r.clampedInt(pe.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(pe.verticalSliderSize,He,0,1e3),scrollByPage:b(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends n{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[y.localize(70,null),y.localize(71,null)],default:Y.insertMode,description:y.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:y.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:y.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:y.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:y.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:y.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:y.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:y.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:y.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:y.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:y.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:y.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:y.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:y.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:y.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:y.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:y.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:y.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:y.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:y.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:y.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:y.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:y.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:y.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:y.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:y.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:y.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:y.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:y.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:y.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:y.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:y.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:y.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:y.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:y.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:y.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:y.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:y.localize(109,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:g(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(pe.showIcons,this.defaultValue.showIcons),showStatusBar:b(pe.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(pe.showMethods,this.defaultValue.showMethods),showFunctions:b(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:b(pe.showConstructors,this.defaultValue.showConstructors),showFields:b(pe.showFields,this.defaultValue.showFields),showVariables:b(pe.showVariables,this.defaultValue.showVariables),showClasses:b(pe.showClasses,this.defaultValue.showClasses),showStructs:b(pe.showStructs,this.defaultValue.showStructs),showInterfaces:b(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:b(pe.showModules,this.defaultValue.showModules),showProperties:b(pe.showProperties,this.defaultValue.showProperties),showEvents:b(pe.showEvents,this.defaultValue.showEvents),showOperators:b(pe.showOperators,this.defaultValue.showOperators),showUnits:b(pe.showUnits,this.defaultValue.showUnits),showValues:b(pe.showValues,this.defaultValue.showValues),showConstants:b(pe.showConstants,this.defaultValue.showConstants),showEnums:b(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:b(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(pe.showKeywords,this.defaultValue.showKeywords),showWords:b(pe.showWords,this.defaultValue.showWords),showColors:b(pe.showColors,this.defaultValue.showColors),showFiles:b(pe.showFiles,this.defaultValue.showFiles),showReferences:b(pe.showReferences,this.defaultValue.showReferences),showFolders:b(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:b(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(pe.showSnippets,this.defaultValue.showSnippets),showUsers:b(pe.showUsers,this.defaultValue.showUsers),showIssues:b(pe.showIssues,this.defaultValue.showIssues)}}}class oe extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:y.localize(110,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends A{constructor(){super(125,[77])}compute(Y,pe,Fe){return pe.get(77)?!0:Y.tabFocusMode}}var Se;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Le(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class me extends A{constructor(){super(127,[126])}compute(Y,pe,Fe){const He=pe.get(126);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Pe:R.isLinux?xe:Ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(j){return e.editorOptionsRegistry[j.id]=j,j}var Ke;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.letterSpacing=52]="letterSpacing",j[j.lightbulb=53]="lightbulb",j[j.lineDecorationsWidth=54]="lineDecorationsWidth",j[j.lineHeight=55]="lineHeight",j[j.lineNumbers=56]="lineNumbers",j[j.lineNumbersMinChars=57]="lineNumbersMinChars",j[j.linkedEditing=58]="linkedEditing",j[j.links=59]="links",j[j.matchBrackets=60]="matchBrackets",j[j.minimap=61]="minimap",j[j.mouseStyle=62]="mouseStyle",j[j.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=64]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",j[j.multiCursorModifier=66]="multiCursorModifier",j[j.multiCursorPaste=67]="multiCursorPaste",j[j.occurrencesHighlight=68]="occurrencesHighlight",j[j.overviewRulerBorder=69]="overviewRulerBorder",j[j.overviewRulerLanes=70]="overviewRulerLanes",j[j.padding=71]="padding",j[j.parameterHints=72]="parameterHints",j[j.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",j[j.quickSuggestions=75]="quickSuggestions",j[j.quickSuggestionsDelay=76]="quickSuggestionsDelay",j[j.readOnly=77]="readOnly",j[j.renameOnType=78]="renameOnType",j[j.renderControlCharacters=79]="renderControlCharacters",j[j.renderIndentGuides=80]="renderIndentGuides",j[j.renderFinalNewline=81]="renderFinalNewline",j[j.renderLineHighlight=82]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=84]="renderValidationDecorations",j[j.renderWhitespace=85]="renderWhitespace",j[j.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",j[j.roundedSelection=87]="roundedSelection",j[j.rulers=88]="rulers",j[j.scrollbar=89]="scrollbar",j[j.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=91]="scrollBeyondLastLine",j[j.scrollPredominantAxis=92]="scrollPredominantAxis",j[j.selectionClipboard=93]="selectionClipboard",j[j.selectionHighlight=94]="selectionHighlight",j[j.selectOnLineNumbers=95]="selectOnLineNumbers",j[j.showFoldingControls=96]="showFoldingControls",j[j.showUnused=97]="showUnused",j[j.snippetSuggestions=98]="snippetSuggestions",j[j.smartSelect=99]="smartSelect",j[j.smoothScrolling=100]="smoothScrolling",j[j.stickyTabStops=101]="stickyTabStops",j[j.stopRenderingLineAfter=102]="stopRenderingLineAfter",j[j.suggest=103]="suggest",j[j.suggestFontSize=104]="suggestFontSize",j[j.suggestLineHeight=105]="suggestLineHeight",j[j.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",j[j.suggestSelection=107]="suggestSelection",j[j.tabCompletion=108]="tabCompletion",j[j.tabIndex=109]="tabIndex",j[j.unusualLineTerminators=110]="unusualLineTerminators",j[j.useTabStops=111]="useTabStops",j[j.wordSeparators=112]="wordSeparators",j[j.wordWrap=113]="wordWrap",j[j.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=116]="wordWrapColumn",j[j.wordWrapOverride1=117]="wordWrapOverride1",j[j.wordWrapOverride2=118]="wordWrapOverride2",j[j.wrappingIndent=119]="wrappingIndent",j[j.wrappingStrategy=120]="wrappingStrategy",j[j.showDeprecated=121]="showDeprecated",j[j.inlineHints=122]="inlineHints",j[j.editorClassName=123]="editorClassName",j[j.pixelRatio=124]="pixelRatio",j[j.tabFocusMode=125]="tabFocusMode",j[j.layoutInfo=126]="layoutInfo",j[j.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:y.localize(111,null)})),acceptSuggestionOnEnter:_e(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",y.localize(112,null),""],markdownDescription:y.localize(113,null)})),accessibilitySupport:_e(new o),accessibilityPageSize:_e(new r(3,"accessibilityPageSize",10,1,1073741824,{description:y.localize(114,null),deprecationMessage:y.localize(115,null)})),ariaLabel:_e(new _(4,"ariaLabel",y.localize(116,null))),autoClosingBrackets:_e(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",y.localize(117,null),y.localize(118,null),""],description:y.localize(119,null)})),autoClosingDelete:_e(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",y.localize(120,null),""],description:y.localize(121,null)})),autoClosingOvertype:_e(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",y.localize(122,null),""],description:y.localize(123,null)})),autoClosingQuotes:_e(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",y.localize(124,null),y.localize(125,null),""],description:y.localize(126,null)})),autoIndent:_e(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[y.localize(127,null),y.localize(128,null),y.localize(129,null),y.localize(130,null),y.localize(131,null)],description:y.localize(132,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[y.localize(133,null),y.localize(134,null),y.localize(135,null),""],description:y.localize(136,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:y.localize(137,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:y.localize(138,null)})),codeLensFontFamily:_e(new _(13,"codeLensFontFamily","",{description:y.localize(139,null)})),codeLensFontSize:_e(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:y.localize(140,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:y.localize(141,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:y.localize(142,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:y.localize(143,null)})),cursorBlinking:_e(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:y.localize(144,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:y.localize(145,null)})),cursorStyle:_e(new c(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:y.localize(146,null)})),cursorSurroundingLines:_e(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:y.localize(147,null)})),cursorSurroundingLinesStyle:_e(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[y.localize(148,null),y.localize(149,null)],description:y.localize(150,null)})),cursorWidth:_e(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:y.localize(151,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:y.localize(152,null)})),emptySelectionClipboard:_e(new D),extraEditorClassName:_e(new _(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new s(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:y.localize(153,null)})),find:_e(new h),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:y.localize(154,null)})),foldingStrategy:_e(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[y.localize(155,null),y.localize(156,null)],description:y.localize(157,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:y.localize(158,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:y.localize(159,null)})),fontFamily:_e(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:y.localize(160,null)})),fontInfo:_e(new I),fontLigatures2:_e(new p),fontSize:_e(new F),fontWeight:_e(new z),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:y.localize(161,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:y.localize(162,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:y.localize(163,null)})),gotoLocation:_e(new ue),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:y.localize(164,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:y.localize(165,null)})),hover:_e(new H),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>s.clamp(j,-5,20),{description:y.localize(166,null)})),lightbulb:_e(new L),lineDecorationsWidth:_e(new C(54,"lineDecorationsWidth",10)),lineHeight:_e(new x),lineNumbers:_e(new Ue),lineNumbersMinChars:_e(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:y.localize(167,null)})),links:_e(new m(59,"links",!0,{description:y.localize(168,null)})),matchBrackets:_e(new w(60,"matchBrackets","always",["always","near","never"],{description:y.localize(169,null)})),minimap:_e(new Q),mouseStyle:_e(new w(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new s(63,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:y.localize(170,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:y.localize(171,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:y.localize(172,null)})),multiCursorModifier:_e(new c(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[y.localize(173,null),y.localize(174,null)],markdownDescription:y.localize(175,null)})),multiCursorPaste:_e(new w(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[y.localize(176,null),y.localize(177,null)],markdownDescription:y.localize(178,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:y.localize(179,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:y.localize(180,null)})),overviewRulerLanes:_e(new r(70,"overviewRulerLanes",3,0,3)),padding:_e(new Z),parameterHints:_e(new ie),peekWidgetDefaultFocus:_e(new w(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[y.localize(181,null),y.localize(182,null)],description:y.localize(183,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:y.localize(184,null)})),quickSuggestions:_e(new ye),quickSuggestionsDelay:_e(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:y.localize(185,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:y.localize(186,null),markdownDeprecationMessage:y.localize(187,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:y.localize(188,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:y.localize(189,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:y.localize(190,null)})),renderLineHighlight:_e(new w(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",y.localize(191,null)],description:y.localize(192,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:y.localize(193,null)})),renderValidationDecorations:_e(new w(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new w(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",y.localize(194,null),y.localize(195,null),y.localize(196,null),""],description:y.localize(197,null)})),revealHorizontalRightPadding:_e(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:y.localize(198,null)})),rulers:_e(new ze),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:y.localize(199,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:y.localize(200,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:y.localize(201,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:y.localize(202,null),included:R.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:y.localize(203,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new w(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[y.localize(204,null),y.localize(205,null)],description:y.localize(206,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:y.localize(207,null)})),showDeprecated:_e(new m(121,"showDeprecated",!0,{description:y.localize(208,null)})),inlineHints:_e(new U),snippetSuggestions:_e(new w(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[y.localize(209,null),y.localize(210,null),y.localize(211,null),y.localize(212,null)],description:y.localize(213,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:y.localize(214,null)})),stopRenderingLineAfter:_e(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),suggestFontSize:_e(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:y.localize(215,null)})),suggestLineHeight:_e(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:y.localize(216,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:y.localize(217,null)})),suggestSelection:_e(new w(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[y.localize(218,null),y.localize(219,null),y.localize(220,null)],description:y.localize(221,null)})),tabCompletion:_e(new w(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[y.localize(222,null),y.localize(223,null),y.localize(224,null)],description:y.localize(225,null)})),tabIndex:_e(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new w(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[y.localize(226,null),y.localize(227,null),y.localize(228,null)],description:y.localize(229,null)})),useTabStops:_e(new m(111,"useTabStops",!0,{description:y.localize(230,null)})),wordSeparators:_e(new _(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:y.localize(231,null)})),wordWrap:_e(new w(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[y.localize(232,null),y.localize(233,null),y.localize(234,null),y.localize(235,null)],description:y.localize(236,null)})),wordWrapBreakAfterCharacters:_e(new _(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new _(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:y.localize(237,null)})),wordWrapOverride1:_e(new w(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new w(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new c(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[y.localize(238,null),y.localize(239,null),y.localize(240,null),y.localize(241,null)],description:y.localize(242,null)})),wrappingStrategy:_e(new w(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[y.localize(243,null),y.localize(244,null)],description:y.localize(245,null)})),editorClassName:_e(new v),pixelRatio:_e(new re),tabFocusMode:_e(new fe),layoutInfo:_e(new K),wrappingInfo:_e(new me)}}),define(be[122],we([17,18]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[123],we([17,18]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(be[124],we([17,18]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(be[125],we([17,18]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(be[126],we([17,18]),function(le,e){return le.create("vs/platform/workspaces/common/workspaces",e)}),define(be[127],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[128],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[129],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[130],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[131],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostProgress",e)}),define(be[132],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[133],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[134],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[135],we([17,18]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[136],we([17,18]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(be[137],we([17,18]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[138],we([17,18]),function(le,e){return le.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[139],we([17,18]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[140],we([17,18]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[141],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var y;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(y=e.EditorActivation||(e.EditorActivation={}));var R;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var T;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[86],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class y{constructor(P,S=[],k=!1){this.ctor=P,this.staticArguments=S,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=y;const R=(T,...P)=>new y(T,P);e.createSyncDescriptor=R}),define(be[61],we([0,1,86]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function T(S,k,E){k instanceof y.SyncDescriptor||(k=new y.SyncDescriptor(k,[],E)),R.push([S,k])}e.registerSingleton=T;function P(){return R}e.getSingletonServiceDescriptors=P}),define(be[142],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=y;class R{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let S of this._nodes.values())S.outgoing.size===0&&P.push(S);return P}insertEdge(P,S){const k=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(S);k.outgoing.set(this._hashFn(S),E),E.incoming.set(this._hashFn(P),k)}removeNode(P){const S=this._hashFn(P);this._nodes.delete(S);for(let k of this._nodes.values())k.outgoing.delete(S),k.incoming.delete(S)}lookupOrInsertNode(P){const S=this._hashFn(P);let k=this._nodes.get(S);return k||(k=new y(P),this._nodes.set(S,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[S,k]of this._nodes)P.push(`${S}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=R}),define(be[4],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function E(n){return n[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=E})(y=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function R(k,E,n,A){E[y.DI_TARGET]===E?E[y.DI_DEPENDENCIES].push({id:k,index:n,optional:A}):(E[y.DI_DEPENDENCIES]=[{id:k,index:n,optional:A}],E[y.DI_TARGET]=E)}function T(k){if(y.serviceIds.has(k))return y.serviceIds.get(k);const E=function(n,A,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,n,C,!1)};return E.toString=()=>k,y.serviceIds.set(k,E),E}e.createDecorator=T;function P(k){return k}e.refineServiceDecorator=P;function S(k){return function(E,n,A){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(k,E,A,!0)}}e.optional=S}),define(be[143],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,y.createDecorator)("modelService");function R(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[144],we([0,1,3,56,6,22,78,59,143]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new y.Emitter}get onDidChange(){return this._onDidChange.event}register(m,r){let s={selector:m,provider:r,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(s){let _=this._entries.indexOf(s);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const r=[];for(let s of this._entries)s._score>0&&r.push(s.provider);return r}ordered(m){const r=[];return this._orderedForEach(m,s=>r.push(s.provider)),r}orderedGroups(m){const r=[];let s,_;return this._orderedForEach(m,g=>{s&&_===g._score?s.push(g.provider):(_=g._score,s=[g.provider],r.push(s))}),r}_orderedForEach(m,r){if(!!m){this._updateScores(m);for(const s of this._entries)s._score>0&&r(s)}}_updateScores(m){let r={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let s of this._entries)if(s._score=(0,k.score)(s.selector,m.uri,m.getLanguageIdentifier().language,(0,E.shouldSynchronizeModel)(m)),n(s.selector)&&s._score>0){for(let _ of this._entries)_._score=0;s._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(m,r){return m._score<r._score?1:m._score>r._score?-1:m._time<r._time?1:m._time>r._time?-1:0}}e.LanguageFeatureRegistry=A;class C{constructor(m,r,s=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=r,this.max=s,this._cache=new P.LRUCache(50,.7)}_key(m){return m.id+(0,R.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const r=this._key(m),s=this._cache.get(r);return this._clamp(s==null?void 0:s.value)}update(m,r){const s=this._key(m);let _=this._cache.get(s);return _||(_=new S.MovingAverage,this._cache.set(s,_)),_.update(r),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(be[62],we([0,1,2,33,144,117,37]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class E{constructor(p,I){this.language=p,this.id=I}}e.LanguageIdentifier=E;var n;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var A;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var C;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(p){return(p&255)>>>0}static getTokenType(p){return(p&1792)>>>8}static getFontStyle(p){return(p&14336)>>>11}static getForeground(p){return(p&8372224)>>>14}static getBackground(p){return(p&4286578688)>>>23}static getClassNameFromMetadata(p){let I=this.getForeground(p),F="mtk"+I,z=this.getFontStyle(p);return z&1&&(F+=" mtki"),z&2&&(F+=" mtkb"),z&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(p,I){const F=this.getForeground(p),z=this.getFontStyle(p);let ue=`color: ${I[F]};`;return z&1&&(ue+="font-style: italic;"),z&2&&(ue+="font-weight: bold;"),z&4&&(ue+="text-decoration: underline;"),ue}}e.TokenMetadata=m;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(p){const I=h[p];let F=I&&S.iconRegistry.get(I);return F||(console.info("No codicon found for CompletionItemKind "+p),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(p,I){let F=h[p];return typeof F=="undefined"&&!I&&(F=9),F}}();var s;(function(h){h[h.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(h){return h&&y.URI.isUri(h.uri)&&R.Range.isIRange(h.range)&&(R.Range.isIRange(h.originSelectionRange)||R.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=o;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(h){h[h.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var u;(function(h){const p=new Map;p.set("file",0),p.set("module",1),p.set("namespace",2),p.set("package",3),p.set("class",4),p.set("method",5),p.set("property",6),p.set("field",7),p.set("constructor",8),p.set("enum",9),p.set("interface",10),p.set("function",11),p.set("variable",12),p.set("constant",13),p.set("string",14),p.set("number",15),p.set("boolean",16),p.set("array",17),p.set("object",18),p.set("key",19),p.set("null",20),p.set("enum-member",21),p.set("struct",22),p.set("event",23),p.set("operator",24),p.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function F(H){return p.get(H)}h.fromString=F;function z(H){return I.get(H)}h.toString=z;function ue(H,B){const K=I.get(H);let L=K&&S.iconRegistry.get("symbol-"+K);return L||(console.info("No codicon found for SymbolKind "+H),L=S.Codicon.symbolProperty),`${B?"inline":"block"} ${L.classNames}`}h.toCssClassName=ue})(u=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(p){this.value=p}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var l;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var v;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(v=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var D;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[145],we([0,1,6,12,4,3,45,54]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(E,n){if(!E)throw new Error("invalid command");if(typeof E=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:E,handler:n})}if(E.description){const r=[];for(let _ of E.description.args)r.push(_.constraint);const s=E.handler;E.handler=function(_,...g){return(0,R.validateConstraints)(g,r),s(_,...g)}}const{id:A}=E;let C=this._commands.get(A);C||(C=new S.LinkedList,this._commands.set(A,C));let b=C.unshift(E),m=(0,y.toDisposable)(()=>{b();const r=this._commands.get(A);(r==null?void 0:r.isEmpty())&&this._commands.delete(A)});return this._onDidRegisterCommand.fire(A),m}registerCommandAlias(E,n){return e.CommandsRegistry.registerCommand(E,(A,...C)=>A.get(e.ICommandService).executeCommand(n,...C))}getCommand(E){const n=this._commands.get(E);if(!(!n||n.isEmpty()))return k.Iterable.first(n)}getCommands(){const E=new Map;for(const n of this._commands.keys()){const A=this.getCommand(n);A&&E.set(n,A)}return E}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>y.Disposable.None,onDidExecuteCommand:()=>y.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],we([0,1,8,4,21]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",T.isMacintosh),S.set("isLinux",T.isLinux),S.set("isWindows",T.isWindows),S.set("isWeb",T.isWeb),S.set("isMacNative",T.isMacintosh&&!T.isWeb),S.set("isEdge",P.indexOf("Edg/")>=0),S.set("isFirefox",P.indexOf("Firefox")>=0),S.set("isChrome",P.indexOf("Chrome")>=0),S.set("isSafari",P.indexOf("Safari")>=0),S.set("isIPad",P.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var E;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return b.INSTANCE}static has(p){return m.create(p)}static equals(p,I){return r.create(p,I)}static notEquals(p,I){return g.create(p,I)}static regex(p,I){return i.create(p,I)}static in(p,I){return s.create(p,I)}static not(p){return w.create(p)}static and(...p){return a.create(p)}static or(...p){return l.create(p)}static greater(p,I){return c.create(p,I)}static less(p,I){return o.create(p,I)}static deserialize(p,I=!1){if(!!p)return this._deserializeOrExpression(p,I)}static _deserializeOrExpression(p,I){let F=p.split("||");return l.create(F.map(z=>this._deserializeAndExpression(z,I)))}static _deserializeAndExpression(p,I){let F=p.split("&&");return a.create(F.map(z=>this._deserializeOne(z,I)))}static _deserializeOne(p,I){if(p=p.trim(),p.indexOf("!=")>=0){let F=p.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],I))}if(p.indexOf("==")>=0){let F=p.split("==");return r.create(F[0].trim(),this._deserializeValue(F[1],I))}if(p.indexOf("=~")>=0){let F=p.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],I))}if(p.indexOf(" in ")>=0){let F=p.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const F=p.split(">=");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const F=p.split(">");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const F=p.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const F=p.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(p)?w.create(p.substr(1).trim()):m.create(p)}static _deserializeValue(p,I){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let F=/^'([^']*)'$/.exec(p);return F?F[1].trim():p}static _deserializeRegexValue(p,I){if((0,y.isFalsyOrWhitespace)(p)){if(I)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=p.indexOf("/"),z=p.lastIndexOf("/");if(F===z||F<0){if(I)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let ue=p.slice(F+1,z),H=p[z+1]==="i"?"i":"";try{return new RegExp(ue,H)}catch(B){if(I)throw new Error(`bad regexp-value '${p}', parse error: ${B}`);return console.warn(`bad regexp-value '${p}', parse error: ${B}`),null}}}e.ContextKeyExpr=n;function A(h,p){return h.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class b{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class m{constructor(p){this.key=p,this.type=2}static create(p){const I=S.get(p);return typeof I=="boolean"?I?b.INSTANCE:C.INSTANCE:new m(p)}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=m;class r{constructor(p,I){this.key=p,this.value=I,this.type=4}static create(p,I){if(typeof I=="boolean")return I?m.create(p):w.create(p);const F=S.get(p);return typeof F=="boolean"?I===(F?"true":"false")?b.INSTANCE:C.INSTANCE:new r(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class s{constructor(p,I){this.key=p,this.valueKey=I,this.type=10}static create(p,I){return new s(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const I=p.getValue(this.valueKey),F=p.getValue(this.key);return Array.isArray(I)?I.indexOf(F)>=0:typeof F=="string"&&typeof I=="object"&&I!==null?k.call(I,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=s;class _{constructor(p){this._actual=p,this.type=11}static create(p){return new _(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new _(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class g{constructor(p,I){this.key=p,this.value=I,this.type=5}static create(p,I){if(typeof I=="boolean")return I?w.create(p):m.create(p);const F=S.get(p);return typeof F=="boolean"?I===(F?"true":"false")?C.INSTANCE:b.INSTANCE:new g(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class w{constructor(p){this.key=p,this.type=3}static create(p){const I=S.get(p);return typeof I=="boolean"?I?C.INSTANCE:b.INSTANCE:new w(p)}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=w;class c{constructor(p,I){this.key=p,this.value=I,this.type=12}static create(p,I){return new c(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class d{constructor(p,I){this.key=p,this.value=I,this.type=13}static create(p,I){return new d(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class o{constructor(p,I){this.key=p,this.value=I,this.type=14}static create(p,I){return new o(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(p,I){this.key=p,this.value=I,this.type=15}static create(p,I){return new t(p,I)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(p,I){this.key=p,this.regexp=I,this.type=7}static create(p,I){return new i(p,I)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const I=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return I<F?-1:I>F?1:0}equals(p){if(p.type===this.type){const I=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return this.key===p.key&&I===F}return!1}evaluate(p){let I=p.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=i;class u{constructor(p){this._actual=p,this.type=8}static create(p){return new u(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new u(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class a{constructor(p){this.expr=p,this.type=6}static create(p){return a._normalizeArr(p)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let I=0,F=this.expr.length;I<F;I++){const z=A(this.expr[I],p.expr[I]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].equals(p.expr[I]))return!1;return!0}return!1}evaluate(p){for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].evaluate(p))return!1;return!0}static _normalizeArr(p){const I=[];let F=!1;for(const z of p)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return C.INSTANCE;if(z.type===6){I.push(...z.expr);continue}I.push(z)}if(I.length===0&&F)return b.INSTANCE;if(I.length!==0){if(I.length===1)return I[0];for(I.sort(A);I.length>1;){const z=I[I.length-1];if(z.type!==9)break;I.pop();const ue=I.pop(),H=l.create(z.expr.map(B=>a.create([B,ue])));H&&(I.push(H),I.sort(A))}return I.length===1?I[0]:new a(I)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let I of this.expr)p.push(...I.keys());return p}map(p){return new a(this.expr.map(I=>I.map(p)))}negate(){let p=[];for(let I of this.expr)p.push(I.negate());return l.create(p)}}e.ContextKeyAndExpr=a;class l{constructor(p){this.expr=p,this.type=9}static create(p){const I=l._normalizeArr(p);if(I.length!==0)return I.length===1?I[0]:new l(I)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let I=0,F=this.expr.length;I<F;I++){const z=A(this.expr[I],p.expr[I]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let I=0,F=this.expr.length;I<F;I++)if(!this.expr[I].equals(p.expr[I]))return!1;return!0}return!1}evaluate(p){for(let I=0,F=this.expr.length;I<F;I++)if(this.expr[I].evaluate(p))return!0;return!1}static _normalizeArr(p){let I=[],F=!1;if(p){for(let z=0,ue=p.length;z<ue;z++){const H=p[z];if(!!H){if(H.type===0){F=!0;continue}if(H.type===1)return[b.INSTANCE];if(H.type===9){I=I.concat(H.expr);continue}I.push(H)}}if(I.length===0&&F)return[C.INSTANCE];I.sort(A)}return I}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let I of this.expr)p.push(...I.keys());return p}map(p){return new l(this.expr.map(I=>I.map(p)))}negate(){let p=[];for(let F of this.expr)p.push(F.negate());const I=F=>F.type===9?F.expr:[F];for(;p.length>1;){const F=p.shift(),z=p.shift(),ue=[];for(const H of I(F))for(const B of I(z))ue.push(n.and(H,B));p.unshift(n.or(...ue))}return p[0]}}e.ContextKeyOrExpr=l;class f extends m{constructor(p,I,F){super(p);this.key=p,this._defaultValue=I,typeof F=="object"?f._info.push(Object.assign(Object.assign({},F),{key:p})):F!==!0&&f._info.push({key:p,description:F,type:I!=null?typeof I:void 0})}static all(){return f._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(p){return n.equals(this.key,p)}notEqualsTo(p){return n.notEquals(this.key,p)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(h,p){return h<p?-1:h>p?1:0}function D(h,p,I,F){return h<I?-1:h>I?1:p<F?-1:p>F?1:0}}),define(be[146],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],we([0,1,8,4]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,C){if(typeof A=="undefined"||A===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof A=="string"||typeof C=="string"){let b=typeof A=="string"?A:A.value,m=typeof C=="string"?C:C.value;return y.equalsIgnoreCase(b,m)}return A._lower===C._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=S;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function E(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[147],we([0,1,8,25]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,r){return m.uuid&&r.uuid?m.uuid===r.uuid:m.id===r.id?!0:(0,y.compareIgnoreCase)(m.id,r.id)===0}e.areSameExtensions=T;class P{constructor(r,s){this.version=s,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof P?T(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=P;function S(m,r){return`${m}.${r}`}e.getExtensionId=S;function k(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function E(m,r){return k(S(m,r))}e.getGalleryExtensionId=E;function n(m,r){const s=[],_=g=>{for(const w of s)if(w.some(c=>T(r(c),r(g))))return w;return null};for(const g of m){const w=_(g);w?w.push(g):s.push([g])}return s}e.groupByExtension=n;function A(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function b(m){const r=new Set;for(const s of m)s.malicious&&r.add(s.id.id);return r}e.getMaliciousExtensionsSet=b}),define(be[64],we([0,1,123,11,2,4,8,12,22]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var A;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var C;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=b;function m(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=m;function r(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function s(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=s;var _;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(B,K){super(B);this.code=K}}e.FileSystemProviderError=g;function w(H,B){const K=new g(H.toString(),B);return d(K,B),K}e.createFileSystemProviderError=w;function c(H){return H||w((0,y.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=c;function d(H,B){return H.name=B?`${B} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=d;function o(H){if(!H)return _.Unknown;if(H instanceof g)return H.code;const B=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!B)return _.Unknown;switch(B[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=o;function t(H){if(H instanceof v)return H.fileOperationResult;switch(o(H)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class u{constructor(B,K,L){this.resource=B,this.operation=K,this.target=L}isOperation(B){return this.operation===B}}e.FileOperationEvent=u;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,K){this.ignorePathCasing=K,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const L of B)switch(L.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(B,...K){return this.doContains(B,{includeChildren:!1},...K)}affects(B,...K){return this.doContains(B,{includeChildren:!0},...K)}doContains(B,K,...L){var U,x,Q,$,Z,ie;if(!B)return!1;const re=L.length>0;return!!((!re||L.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(B))||K.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(B)))||(!re||L.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(B))||K.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(B)))||(!re||L.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(B))||K.includeChildren&&((ie=this.deleted)===null||ie===void 0?void 0:ie.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const K=[],L=B===1?this.added:B===0?this.updated:this.deleted;if(L)for(const[,U]of L)K.push(U);return K}filter(B){return new l(this.changes.filter(K=>B(K)),this.ignorePathCasing)}}e.FileChangesEvent=l;function f(H,B,K){return!H||!B||H===B||B.length>H.length?!1:(B.charAt(B.length-1)!==R.sep&&(B+=R.sep),K?(0,S.startsWithIgnoreCase)(H,B):H.indexOf(B)===0)}e.isParent=f;class v extends Error{constructor(B,K,L){super(B);this.fileOperationResult=K,this.options=L}static isFileOperationError(B){return B instanceof Error&&!(0,k.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=v;var D;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=p;async function I(H,B){if(!B.canHandleResource(T.URI.from({scheme:H.scheme})))return new Promise(K=>{const L=B.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(L.dispose(),K())})})}e.whenProviderRegistered=I,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<F.KB?(0,y.localize)(1,null,B.toFixed(0)):B<F.MB?(0,y.localize)(2,null,(B/F.KB).toFixed(2)):B<F.GB?(0,y.localize)(3,null,(B/F.MB).toFixed(2)):B<F.TB?(0,y.localize)(4,null,(B/F.GB).toFixed(2)):(0,y.localize)(5,null,(B/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function ue(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ue}),define(be[65],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...T){this._entries=new Map;for(let[P,S]of T)this.set(P,S)}set(T,P){const S=this._entries.get(T);return this._entries.set(T,P),S}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=y}),define(be[148],we([0,1,10,142,86,4,65,13]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class n extends Error{constructor(r){super("cyclic dependency between services");this.message=r.toString()}}class A{constructor(r=new S.ServiceCollection,s=!1,_){this._activeInstantiations=new Set,this._services=r,this._strict=s,this._parent=_,this._services.set(P.IInstantiationService,this)}createChild(r){return new A(r,this._strict,this)}invokeFunction(r,...s){let _=b.traceInvocation(r),g=!1;try{return r({get:(c,d)=>{if(g)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(c,_);if(!o&&d!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return o}},...s)}finally{g=!0,_.stop()}}createInstance(r,...s){let _,g;return r instanceof T.SyncDescriptor?(_=b.traceCreation(r.ctor),g=this._createInstance(r.ctor,r.staticArguments.concat(s),_)):(_=b.traceCreation(r),g=this._createInstance(r,s,_)),_.stop(),g}_createInstance(r,s=[],_){let g=P._util.getServiceDependencies(r).sort((d,o)=>d.index-o.index),w=[];for(const d of g){let o=this._getOrCreateServiceInstance(d.id,_);if(!o&&this._strict&&!d.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${d.id}.`);w.push(o)}let c=g.length>0?g[0].index:s.length;if(s.length!==c){console.warn(`[createInstance] First service dependency of ${r.name} at position ${c+1} conflicts with ${s.length} static arguments`);let d=c-s.length;d>0?s=s.concat(new Array(d)):s=s.slice(0,c)}return new r(...[...s,...w])}_setServiceInstance(r,s){if(this._services.get(r)instanceof T.SyncDescriptor)this._services.set(r,s);else if(this._parent)this._parent._setServiceInstance(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let s=this._services.get(r);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):s}_getOrCreateServiceInstance(r,s){let _=this._getServiceInstanceOrDescriptor(r);return _ instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,_,s.branch(r,!0)):(s.branch(r,!1),_)}_safeCreateAndCacheServiceInstance(r,s,_){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,s,_)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,s,_){const g=new R.Graph(d=>d.id.toString());let w=0;const c=[{id:r,desc:s,_trace:_}];for(;c.length;){const d=c.pop();if(g.lookupOrInsertNode(d),w++>1e3)throw new n(g);for(let o of P._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const i={id:o.id,desc:t,_trace:d._trace.branch(o.id,!0)};g.insertEdge(d,i),c.push(i)}}}for(;;){const d=g.roots();if(d.length===0){if(!g.isEmpty())throw new n(g);break}for(const{data:o}of d){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}g.removeNode(o)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,s,_=[],g,w){if(this._services.get(r)instanceof T.SyncDescriptor)return this._createServiceInstance(s,_,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,s,_,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(r,s=[],_,g){if(_){const w=new k.IdleValue(()=>this._createInstance(r,s,g));return new Proxy(Object.create(null),{get(c,d){if(d in c)return c[d];let o=w.value,t=o[d];return typeof t!="function"||(t=t.bind(o),c[d]=t),t},set(c,d,o){return w.value[d]=o,!0}})}else return this._createInstance(r,s,g)}}e.InstantiationService=A;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class b{constructor(r,s){this.type=r,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return E?new b(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(r){return E?new b(0,r.name):b._None}branch(r,s){let _=new b(2,r.toString());return this._dep.push([r,s,_]),_}stop(){let r=Date.now()-this._start;b._totals+=r;let s=!1;function _(w,c){let d=[],o=new Array(w+1).join("	");for(const[t,i,u]of c._dep)if(i&&u){s=!0,d.push(`${o}CREATES -> ${t}`);let a=_(w+1,u);a&&d.push(a)}else d.push(`${o}uses -> ${t}`);return d.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(r>2||s)&&console.log(g.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(be[19],we([0,1,4,6,21,3,60]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var E;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class n extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class A extends n{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(E.Error))if(o instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=o.stack,this.log(E.Error,this.format(i))}else this.log(E.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let i=0;i<o.length;i++){let u=o[i];if(typeof u=="object")try{u=JSON.stringify(u)}catch(a){}t+=(i>0?" ":"")+u}return t}}e.AbstractMessageLogger=A;class C extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}debug(o,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}info(o,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...t):console.log(`[main ${k()}]`,o,...t))}warn(o,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,o,...t):console.warn(`[main ${k()}]`,o,...t))}error(o,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,o,...t):console.error(`[main ${k()}]`,o,...t))}critical(o,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,o,...t):console.error(`[main ${k()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class b extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class m extends n{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,S.toErrorMessage)(o,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class r extends n{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const i of this.logServices)i.trace(o,...t)}debug(o,...t){for(const i of this.logServices)i.debug(o,...t)}info(o,...t){for(const i of this.logServices)i.info(o,...t)}warn(o,...t){for(const i of this.logServices)i.warn(o,...t)}error(o,...t){for(const i of this.logServices)i.error(o,...t)}critical(o,...t){for(const i of this.logServices)i.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=r;class s extends R.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=s;class _{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(o){}getLevel(){return E.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=_;function g(d){if(d.verbose)return E.Trace;if(typeof d.logLevel=="string"){const o=w(d.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function w(d){switch(d){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=w;function c(d){switch(d){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=c}),define(be[87],we([0,1,4,124,46]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var S;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function n(r,s){return s-r}E.compare=n;const A=Object.create(null);A[E.Error]=(0,R.localize)(0,null),A[E.Warning]=(0,R.localize)(1,null),A[E.Info]=(0,R.localize)(2,null);function C(r){return A[r]||""}E.toString=C;function b(r){switch(r){case T.default.Error:return E.Error;case T.default.Warning:return E.Warning;case T.default.Info:return E.Info;case T.default.Ignore:return E.Hint}}E.fromSeverity=b;function m(r){switch(r){case E.Error:return T.default.Error;case E.Warning:return T.default.Warning;case E.Info:return T.default.Info;case E.Hint:return T.default.Ignore}}E.toSeverity=m}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(E){const n="";function A(b){return C(b,!0)}E.makeKey=A;function C(b,m){let r=[n];return b.source?r.push(b.source.replace("\xA6","\\\xA6")):r.push(n),b.code?typeof b.code=="string"?r.push(b.code.replace("\xA6","\\\xA6")):r.push(b.code.value.replace("\xA6","\\\xA6")):r.push(n),b.severity!==void 0&&b.severity!==null?r.push(S.toString(b.severity)):r.push(n),b.message&&m?r.push(b.message.replace("\xA6","\\\xA6")):r.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?r.push(b.startLineNumber.toString()):r.push(n),b.startColumn!==void 0&&b.startColumn!==null?r.push(b.startColumn.toString()):r.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?r.push(b.endLineNumber.toString()):r.push(n),b.endColumn!==void 0&&b.endColumn!==null?r.push(b.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}E.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(be[149],we([0,1,46,4,3]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=(0,R.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new E,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=k;class E{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=E});var qe=this&&this.__decorate||function(le,e,y,R){var T=arguments.length,P=T<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(le,e,y,R);else for(var k=le.length-1;k>=0;k--)(S=le[k])&&(P=(T<3?S(P):T>3?S(e,y,P):S(e,y))||P);return T>3&&P&&Object.defineProperty(e,y,P),P},Ge=this&&this.__param||function(le,e){return function(y,R){e(y,R,le)}};define(be[150],we([0,1,4,20,6,13]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var S;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let E=class extends T.Disposable{constructor(C,b){super();this.deferred=new P.DeferredPromise,b.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};E=qe([Ge(1,e.IProgressService)],E),e.UnmanagedProgress=E;class n extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const b=++this.currentOperationId,m=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:m.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(be[30],we([0,1,12,43]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(S,k){R.ok(y.isString(S)),R.ok(y.isObject(k)),R.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,k)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new T}),define(be[88],we([0,1,30,3]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,n){this.schemasById[T(E)]=n,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new P;y.Registry.add(e.Extensions.JSONContribution,S)}),define(be[66],we([0,1,122,3,30,12,88]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=T.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,w=!0){this.registerConfigurations([g],w)}registerConfigurations(g,w=!0){const c=[];g.forEach(d=>{c.push(...this.validateAndRegisterProperties(d,w)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(g){const w=[],c=d=>{if(d.properties)for(const o in d.properties)w.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,d.properties[o]);d.allOf&&d.allOf.forEach(o=>c(o))};for(const d of g){c(d);const o=this.configurationContributors.indexOf(d);o!==-1&&this.configurationContributors.splice(o,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(g){const w=[],c=[];for(const d of g)for(const o in d)if(w.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),d[o]);const t={type:"object",default:this.defaultValues[o],description:y.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};c.push(C(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=d[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(g){const w=[];for(const c of g)for(const d in c)if(w.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const o=this.configurationProperties[d];o&&(this.updatePropertyDefaultValue(d,o),this.updateSchema(d,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const w of g)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,w=!0,c=3){c=P.isUndefinedOrNull(g.scope)?c:g.scope;let d=[],o=g.properties;if(o)for(let i in o){if(w&&r(i)){delete o[i];continue}const u=o[i];if(this.updatePropertyDefaultValue(i,u),e.OVERRIDE_PROPERTY_PATTERN.test(i)?u.scope=void 0:u.scope=P.isUndefinedOrNull(u.scope)?c:u.scope,o[i].hasOwnProperty("included")&&!o[i].included){this.excludedConfigurationProperties[i]=o[i],delete o[i];continue}else this.configurationProperties[i]=o[i];!o[i].deprecationMessage&&o[i].markdownDeprecationMessage&&(o[i].deprecationMessage=o[i].markdownDeprecationMessage),d.push(i)}let t=g.allOf;if(t)for(let i of t)d.push(...this.validateAndRegisterProperties(i,w,c));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const w=c=>{let d=c.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let o=c.allOf;o&&o.forEach(w)};w(g)}updateSchema(g,w){switch(e.allSettings.properties[g]=w,w.scope){case 1:e.applicationSettings.properties[g]=w;break;case 2:e.machineSettings.properties[g]=w;break;case 6:e.machineOverridableSettings.properties[g]=w;break;case 3:e.windowSettings.properties[g]=w;break;case 4:e.resourceSettings.properties[g]=w;break;case 5:e.resourceSettings.properties[g]=w,this.resourceLanguageSettingsSchema.properties[g]=w;break}}removeFromSchema(g,w){switch(delete e.allSettings.properties[g],w.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const w=`[${g}]`,c={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,c),e.allSettings.properties[w]=c,e.applicationSettings.properties[w]=c,e.machineSettings.properties[w]=c,e.machineOverridableSettings.properties[w]=c,e.windowSettings.properties[w]=c,e.resourceSettings.properties[w]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,w){let c=this.defaultValues[g];P.isUndefined(c)&&(c=w.default),P.isUndefined(c)&&(c=b(w.type)),w.default=c}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function C(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=C;function b(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const m=new n;T.Registry.add(e.Extensions.Configuration,m);function r(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?y.localize(5,null,_):m.getConfigurationProperties()[_]!==void 0?y.localize(6,null,_):null:y.localize(4,null)}e.validateProperty=r;function s(){const _=[],g=m.getConfigurationProperties();for(const w of Object.keys(g))_.push([w,g[w].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=s}),define(be[89],we([0,1,23,12,2,30,4,66]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function E(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.isConfigurationOverrides=E;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function A(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=A;function C(i,u){const a=u?i?u.keys.filter(I=>i.keys.indexOf(I)===-1):[...u.keys]:[],l=i?u?i.keys.filter(I=>u.keys.indexOf(I)===-1):[...i.keys]:[],f=[];if(u&&i){for(const I of i.keys)if(u.keys.indexOf(I)!==-1){const F=g(i.contents,I),z=g(u.contents,I);y.equals(F,z)||f.push(I)}}const v=[],D=I=>{const F={};for(const z of I)for(const ue of z.identifiers)F[o(ue)]=z;return F},h=u?D(u.overrides):{},p=i?D(i.overrides):{};if(Object.keys(h).length)for(const I of a){const F=h[I];F&&v.push([(0,k.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(p).length)for(const I of l){const F=p[I];F&&v.push([(0,k.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(h).length&&Object.keys(p).length)for(const I of f){const F=p[I],z=h[I];if(F&&z){const ue=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});v.push([(0,k.overrideIdentifierFromKey)(I),[...ue.added,...ue.removed,...ue.updated]])}}return{added:a,removed:l,updated:f,overrides:v}}e.compare=C;function b(i,u){const a=[];for(const l of Object.keys(i))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const v in i[l])f[v]=i[l][v];a.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:m(f,u)})}return a}e.toOverrides=b;function m(i,u){const a=Object.create(null);for(let l in i)r(a,l,i[l],u);return a}e.toValuesTree=m;function r(i,u,a,l){const f=u.split("."),v=f.pop();let D=i;for(let h=0;h<f.length;h++){let p=f[h],I=D[p];switch(typeof I){case"undefined":I=D[p]=Object.create(null);break;case"object":break;default:l(`Ignoring ${u} as ${f.slice(0,h+1).join(".")} is ${JSON.stringify(I)}`);return}D=I}if(typeof D=="object"&&D!==null)try{D[v]=a}catch(h){l(`Ignoring ${u} as ${f.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${u} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=r;function s(i,u){const a=u.split(".");_(i,a)}e.removeFromValueTree=s;function _(i,u){const a=u.shift();if(u.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const l=i[a];typeof l=="object"&&!Array.isArray(l)&&(_(l,u),Object.keys(l).length===0&&delete i[a])}}function g(i,u,a){function l(D,h){let p=D;for(const I of h){if(typeof p!="object"||p===null)return;p=p[I]}return p}const f=u.split("."),v=l(i,f);return typeof v=="undefined"?a:v}e.getConfigurationValue=g;function w(i,u,a){Object.keys(u).forEach(l=>{l!=="__proto__"&&(l in i?R.isObject(i[l])&&R.isObject(u[l])?w(i[l],u[l],a):a&&(i[l]=u[l]):i[l]=u[l])})}e.merge=w;function c(){const i=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=c;function d(){const i=Object.create(null),u=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let a in u){let l=u[a].default;r(i,a,l,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=d;function o(i){return`[${i}]`}e.keyFromOverrideIdentifier=o;function t(i,u,a){const l=i.inspect(u),f=i.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=t}),define(be[151],we([0,1,44,22,15,12,23,2,66,89,30,6,3]),function(le,e,y,R,T,P,S,k,E,n,A,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},i=[],u=[]){this._contents=t,this._keys=i,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const u=this.getContentsForOverrideIdentifer(i);return u?t?(0,n.getConfigurationValue)(u,t):u:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let u={};for(const a of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],f=i[a];f&&(typeof l=="object"&&typeof f=="object"?(l=S.deepClone(l),this.mergeContents(l,f)):l=f),u[a]=l}return new m(u,this.keys,this.overrides)}merge(...t){const i=S.deepClone(this.contents),u=S.deepClone(this.overrides),a=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const f of l.overrides){const[v]=u.filter(D=>T.equals(D.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):u.push(S.deepClone(f))}for(const f of l.keys)a.indexOf(f)===-1&&a.push(f)}return new m(i,a,u)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const u of Object.keys(i)){if(u in t&&P.isObject(t[u])&&P.isObject(i[u])){this.mergeContents(t[u],i[u]);continue}t[u]=S.deepClone(i[u])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,u=>{throw new Error(u)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let u=0;u<i;u++)t.indexOf(this.keys[u])===0&&(i=u);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class r extends m{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),u=[];for(const a of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(a)&&u.push({identifiers:[(0,E.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,n.toValuesTree)(t[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,u)}}e.DefaultConfigurationModel=r;class s{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new m(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},u=null,a=[],l=[],f=[];function v(h){Array.isArray(a)?a.push(h):u&&(a[u]=h)}let D={onObjectBegin:()=>{let h={};v(h),l.push(a),a=h,u=null},onObjectProperty:h=>{u=h},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let h=[];v(h),l.push(a),a=h,u=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:v,onError:(h,p,I)=>{f.push({error:h,offset:p,length:I})}};if(t)try{y.visit(t,D),i=a[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return i}doParseRaw(t){if(this._scopes){const l=A.Registry.as(E.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,l,!0,this._scopes)}const i=(0,n.toValuesTree)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),u=Object.keys(t),a=(0,n.toOverrides)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:i,keys:u,overrides:a}}filterByScope(t,i,u,a){const l={};for(let f in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(f)&&u)l[f]=this.filterByScope(t[f],i,!1,a);else{const v=this.getScope(f,i);(v===void 0||a.indexOf(v)!==-1)&&(l[f]=t[f])}return l}getScope(t,i){const u=i[t];return u?typeof u.scope!="undefined"?u.scope:3:void 0}}e.ConfigurationModelParser=s;class _ extends C.Disposable{constructor(t,i,u,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new m}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=_;class g{constructor(t,i,u=new m,a=new m,l=new R.ResourceMap,f=new m,v=new R.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=u,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,u){return this.getConsolidateConfigurationModel(i,u).getValue(t)}updateValue(t,i,u={}){let a;u.resource?(a=this._memoryConfigurationByResource.get(u.resource),a||(a=new m,this._memoryConfigurationByResource.set(u.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,u){const a=this.getConsolidateConfigurationModel(i,u),l=this.getFolderConfigurationModelForResource(i.resource,u),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),I=u?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,z=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),ue=a.getValue(t),H=T.distinct(T.flatten(a.overrides.map(B=>B.identifiers))).filter(B=>a.getOverrideValue(t,B)!==void 0);return{defaultValue:v,userValue:D,userLocalValue:h,userRemoteValue:p,workspaceValue:I,workspaceFolderValue:F,memoryValue:z,value:ue,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const u=i.filter(a=>E.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,E.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),v=t.getKeysForOverrideIdentifier(l),D=[...v.filter(h=>f.indexOf(h)===-1),...f.filter(h=>v.indexOf(h)===-1),...f.filter(h=>!S.equals(this._defaultConfiguration.override(l).getValue(h),t.override(l).getValue(h)))];return[l,D]});return this.updateDefaultConfiguration(t),{keys:i,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:u,removed:a,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),f=[...i,...u,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:u,removed:a,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...i,...u,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:u,removed:a,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...i,...u,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const u=this.folderConfigurations.get(t),{added:a,updated:l,removed:f,overrides:v}=(0,n.compare)(u,i);let D=[...a,...l,...f];return(D.length||!u)&&this.updateFolderConfiguration(t,i),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:u,updated:a,removed:l,overrides:f}=(0,n.compare)(i,void 0);return{keys:[...u,...a,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let u=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?u.override(t.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:t},i){let u=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(u=this.getFolderConsolidatedConfiguration(a.uri)||u);const l=this._memoryConfigurationByResource.get(t);l&&(u=u.merge(l))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const u=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=u.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=u}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const u=i.getFolder(t);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:u,overrides:a,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:u,overrides:a,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(u=>t.add(u))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),u=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((f,v)=>(f.set(k.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new R.ResourceMap);return new g(i,u,new m,a,l,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const a of o)a.keys.forEach(l=>t.add(l)),a.overrides.forEach(([l,f])=>{const v=(0,R.getOrSet)(i,l,new Set);f.forEach(D=>v.add(D))});const u=[];return i.forEach((a,l)=>u.push([l,[...a.values()]])),{keys:[...t.values()],overrides:u}}e.mergeChanges=w;class c{constructor(t,i,u,a){this.change=t,this.previous=i,this.currentConfiguraiton=u,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(v=>l.add(v)),t.overrides.forEach(([,v])=>v.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const f=new m;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var u;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(u=this.previous)===null||u===void 0?void 0:u.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!S.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let u=(0,n.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof u=="object"&&(a=Object.keys(u)[0]);){if(t=t[a],!t)return!1;u=u[a]}return!0}}e.ConfigurationChangeEvent=c;class d extends c{constructor(t,i,u,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=u,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=d}),define(be[90],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(S,k=R.Unknown,E){super(S);this._message=S,this._code=k,this._detail=E,this.isHandled=k===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(S){return S instanceof T&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof T&&S._code===R.NoResolverFound}static isHandled(S){return S instanceof T&&S.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[91],we([0,1,16]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(P){return P.scheme===y.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=R;function T(P){if(!!P){const S=P.indexOf("+");return S<0?P:P.substr(0,S)}}e.getRemoteName=T}),define(be[152],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class y{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,S=5){let k;return k=P(E=>{const n=typeof E=="string"?E:E.data;let A=this._terminalBufferMap.get(T);if(A){A.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(T),S);A={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,A)}),k}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=y}),define(be[153],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(be[154],we([0,1,4,6,30,3,153,37]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var E;(function(_){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}_.isThemeColor=g})(E=e.ThemeColor||(e.ThemeColor={}));function n(_){return{id:_}}e.themeColorFromId=n;var A;(function(_){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||E.isThemeColor(t.color))}_.isThemeIcon=g;const w=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const i=w.exec(t);if(!!i){let[,u]=i;return{id:u}}}_.fromString=c;function d(t,i){let u=t.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),i&&(u=`${u}~${i}`),{id:u}}_.modify=d;function o(t,i){var u,a;return t.id===i.id&&((u=t.color)===null||u===void 0?void 0:u.id)===((a=i.color)===null||a===void 0?void 0:a.id)}_.isEqual=o,_.asClassNameArray=k.CSSIcon.asClassNameArray,_.asClassName=k.CSSIcon.asClassName,_.asCSSSelector=k.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(_){switch(_){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,R.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new b;T.Registry.add(e.Extensions.ThemingContribution,m);function r(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=r;class s extends R.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let c=this.theme.getColor(g);return c&&w&&(c=w(c,this.theme)),c?c.toString():null}}e.Themable=s}),define(be[155],we([0,1,30,154,3,125,88,13,37]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${E.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,w,c,d){const o=this.iconsById[g];if(o){if(c&&!o.description){o.description=c,this.iconSchema.properties[g].markdownDescription=`${c} $(${g})`;const u=this.iconReferenceSchema.enum.indexOf(g);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=c),this._onDidChange.fire()}return o}let t={id:g,description:c,defaults:w,deprecationMessage:d};this.iconsById[g]=t;let i={$ref:"#/definitions/icons"};return d&&(i.deprecationMessage=d),c&&(i.markdownDescription=`${c}: $(${g})`),this.iconSchema.properties[g]=i,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const w=this.iconReferenceSchema.enum.indexOf(g);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,w){const c=this.iconFontsById[g];if(c)return c;let d={id:g,definition:w};return this.iconFontsById[g]=d,this._onDidChange.fire(),d}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(o,t)=>o.id.localeCompare(t.id),w=o=>{for(;R.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of d.filter(t=>!!t.description).sort(g))c.push(`|<i class="${w(o)}"></i>|${o.id}|${R.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const o of d.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(g))c.push(`|<i class="${w(o)}"></i>|${o.id}|`);return c.join(`
`)}}const A=new n;y.Registry.add(e.Extensions.IconContribution,A);function C(_,g,w,c){return A.registerIcon(_,g,w,c)}e.registerIcon=C;function b(){return A}e.getIconRegistry=b;function m(){for(const _ of E.iconRegistry.all)A.registerIcon(_.id,_.definition,_.description);E.iconRegistry.onDidRegister(_=>A.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let r=y.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,A.getIconSchema());const s=new k.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);A.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=C("widget-close",E.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",E.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",E.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=R.ThemeIcon.modify(E.Codicon.sync,"spin")}),define(be[47],we([0,1,2,24,4,22]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var S;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function k(b){const m=b;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function E(b){const m=b;return!!(m&&typeof m=="object"&&y.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=E;class n{constructor(m,r,s,_){this._id=m,this._configuration=s,this._ignorePathCasing=_,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class A{constructor(m,r){this.raw=r,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function C(b){return new A({uri:b,index:0,name:(0,R.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=C}),define(be[156],we([0,1,4,126,47,2,21,11,24,105,44,16,58,38,91]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(K){return(typeof K=="string"?(0,k.extname)(K):(0,E.extname)(K))===s}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function g(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function w(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=w;function c(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=c;function d(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=d;function o(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function i(K){const L=K;if(L==null?void 0:L.uri)return{id:L.id,uri:P.URI.revive(L.uri)};const U=K;if(U==null?void 0:U.configPath)return{id:U.id,configPath:P.URI.revive(U.configPath)};if(K==null?void 0:K.id)return{id:K.id}}e.reviveIdentifier=i;function u(K,L){return E.extUriBiasedIgnorePathCase.isEqualOrParent(K,L.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function a(K){return l(K)||f(K)}e.isStoredWorkspaceFolder=a;function l(K){const L=K;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=l;function f(K){const L=K;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=f;function v(K,L,U,x,Q=!S.isWindows,$){if(K.scheme!==x.scheme)return{name:U,uri:K.toString(!0)};let Z=L?void 0:$.relativePath(x,K);if(Z!==void 0)Z.length===0?Z=".":S.isWindows&&K.scheme===C.Schemas.file&&!Q&&(Z=Z.replace(/\//g,"\\"));else if(K.scheme===C.Schemas.file)Z=K.fsPath,S.isWindows&&(Z=(0,b.normalizeDriveLetter)(Z),Q&&(Z=(0,m.toSlashes)(Z)));else{if(!$.isEqualAuthority(K.authority,x.authority))return{name:U,uri:K.toString(!0)};Z=K.path}return{name:U,path:Z}}e.getStoredWorkspaceFolder=v;function D(K,L,U){let x=[],Q=new Set;const $=U.dirname(L);for(let Z of K){let ie=null;if(l(Z))Z.path&&(ie=U.resolvePath($,Z.path));else if(f(Z))try{ie=P.URI.parse(Z.uri),ie.path[0]!=="/"&&(ie=ie.with({path:"/"+ie.path}))}catch(re){console.warn(re)}if(ie){let re=U.getComparisonKey(ie);if(!Q.has(re)){Q.add(re);const ye=Z.name||U.basenameOrAuthority(ie);x.push(new T.WorkspaceFolder({uri:ie,name:ye,index:x.length},Z))}}}return x}e.toWorkspaceFolders=D;function h(K,L,U,x,Q){let $=p(L,K);const Z=Q.dirname(L),ie=Q.dirname(x),re=[],ye=I($.folders);for(const ze of $.folders){const N=l(ze)?Q.resolvePath(Z,ze.path):P.URI.parse(ze.uri);let G;U?G=!1:G=!l(ze)||(0,k.isAbsolute)(ze.path),re.push(v(N,G,ze.name,ie,ye,Q))}const Ie={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Ue=n.setProperty(K,["folders"],re,Ie);let Re=n.applyEdits(K,Ue);return $.remoteAuthority===(0,r.getRemoteAuthority)(x)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Ie))),Re}e.rewriteWorkspaceFileForNewLocation=h;function p(K,L){let U=A.parse(L);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>a(x));else throw new Error(`${K} looks like an invalid workspace file.`);return U}function I(K){return S.isWindows?K.some(L=>l(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function F(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function z(K){return typeof K.folderUri=="string"}function ue(K){return typeof K.fileUri=="string"}function H(K,L){const U={workspaces:[],files:[]};if(K){const x=function($,Z){for(let ie=0;ie<$.length;ie++)try{Z($[ie],ie)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify($[ie])}: ${re.toString()}. Skip entry.`)}},Q=K;if(Array.isArray(Q.entries))x(Q.entries,$=>{const Z=$.label,ie=$.remoteAuthority;F($)?U.workspaces.push({label:Z,remoteAuthority:ie,workspace:{id:$.workspace.id,configPath:P.URI.parse($.workspace.configPath)}}):z($)?U.workspaces.push({label:Z,remoteAuthority:ie,folderUri:P.URI.parse($.folderUri)}):ue($)&&U.files.push({label:Z,remoteAuthority:ie,fileUri:P.URI.parse($.fileUri)})});else{const $=K;Array.isArray($.workspaces3)&&x($.workspaces3,(Z,ie)=>{const re=Array.isArray($.workspaceLabels)&&$.workspaceLabels[ie]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?U.workspaces.push({label:re,workspace:{id:Z.id,configPath:P.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&U.workspaces.push({label:re,folderUri:P.URI.parse(Z)})}),Array.isArray($.files2)&&x($.files2,(Z,ie)=>{const re=Array.isArray($.fileLabels)&&$.fileLabels[ie]||void 0;typeof Z=="string"&&U.files.push({label:re,fileUri:P.URI.parse(Z)})})}}return U}e.restoreRecentlyOpened=H;function B(K){const L={entries:[]};for(const U of K.workspaces)w(U)?L.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):L.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of K.files)L.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return L}e.toStoreData=B}),define(be[92],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class y{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!y.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=y,y.enableDebugLogging=!1}),define(be[157],we([0,1,2,3]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(k=>({name:k.name,group:k.group,resource:y.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(be[48],we([0,1,16,4]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(y.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,k){k===null?this._providerInfo.delete(S):this._providerInfo.set(S,k)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,y.createDecorator)("IExtHostInitDataService")}),define(be[158],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class y{constructor(P,S,k){this._id=P,this._shared=S,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(E=>(this._value=E,this)),this._storageListener=this._storage.onDidChangeStorage(E=>{E.shared===this._shared&&E.key===this._id&&(this._value=E.value)})}get whenReady(){return this._init}get(P,S){let k=this._value[P];return typeof k=="undefined"&&(k=S),k}update(P,S){return this._value[P]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=y;class R extends y{constructor(P,S){super(P.identifier.value,!0,S);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=R}),define(be[14],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class R{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[159],we([0,1,25,3]),function(le,e,y,R){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(k,E){T.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=y.ExtensionIdentifier.toKey(k.identifier),nt(this,T,E),$e(this,T).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(k){return $e(this,T).get(this._id,k)}store(k,E){return $e(this,T).store(this._id,k,E)}delete(k){return $e(this,T).delete(this._id,k)}}e.ExtensionSecrets=P,T=new WeakMap}),define(be[93],we([0,1,4,3]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,y.createDecorator)("IExtHostTelemetry")}),define(be[67],we([0,1,4,3,14]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(k){function E(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public}}k.fromApiTunnel=E;function n(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.public}}k.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,y.createDecorator)("IExtHostTunnelService");let S=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,n){return{dispose:()=>{}}}async $providePortAttributes(E,n,A,C,b){return[]}async $forwardPort(E,n){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=qe([Ge(0,T.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[7],we([0,1,15,10,80,22,12,2,29,64,90]),function(le,e,y,R,T,P,S,k,E,n,A){"use strict";var C,b,m,r,s,_,g,w,c,d,o,t,i,u,a,l,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let h=s=class{constructor(M){C.set(this,void 0),nt(this,C,M)}static from(...M){let ne=M;return new s(function(){if(ne){for(const Ee of ne)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ne=void 0}})}dispose(){typeof $e(this,C)=="function"&&($e(this,C).call(this),nt(this,C,void 0))}};C=new WeakMap,h=s=qe([D],h),e.Disposable=h;let p=_=class{constructor(M,ne){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(ne<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ee=1;Ee<M.length;Ee++){const Be=M[Ee];Be.isBefore(ne)&&(ne=Be)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ee=1;Ee<M.length;Ee++){const Be=M[Ee];Be.isAfter(ne)&&(ne=Be)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof _)return!0;let{line:ne,character:Ee}=M;return typeof ne=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,R.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=0:typeof M=="number"?Ee=M:(Ee=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),Ee===0&&ne===0?this:new _(this.line+Ee,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,R.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=this.line:typeof M=="number"?Ee=M:(Ee=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),Ee===this.line&&ne===this.character?this:new _(Ee,ne)}toJSON(){return{line:this.line,character:this.character}}};p=_=qe([D],p),e.Position=p;let I=g=class{constructor(M,ne,Ee,Be){let Je,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof Be=="number"?(Je=new p(M,ne),ot=new p(Ee,Be)):M instanceof p&&ne instanceof p&&(Je=M,ot=ne),!Je||!ot)throw new Error("Invalid arguments");Je.isBefore(ot)?(this._start=Je,this._end=ot):(this._start=ot,this._end=Je)}static isRange(M){return M instanceof g?!0:M?p.isPosition(M.start)&&p.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof g?this.contains(M._start)&&this.contains(M._end):M instanceof p?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=p.Max(M.start,this._start),Ee=p.Min(M.end,this._end);if(!ne.isAfter(Ee))return new g(ne,Ee)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=p.Min(M.start,this._start),Ee=p.Max(M.end,this.end);return new g(ne,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,R.illegalArgument)();let Ee;return M?p.isPosition(M)?Ee=M:(Ee=M.start||this.start,ne=M.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ne.isEqual(this.end)?this:new g(Ee,ne)}toJSON(){return[this.start,this.end]}};I=g=qe([D],I),e.Range=I;let F=w=class extends I{constructor(M,ne,Ee,Be){let Je,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof Be=="number"?(Je=new p(M,ne),ot=new p(Ee,Be)):M instanceof p&&ne instanceof p&&(Je=M,ot=ne),!Je||!ot)throw new Error("Invalid arguments");super(Je,ot);this._anchor=Je,this._active=ot}static isSelection(M){return M instanceof w?!0:M?I.isRange(M)&&p.isPosition(M.anchor)&&p.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=w=qe([D],F),e.Selection=F;class z{constructor(M,ne,Ee){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,R.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,R.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=Ee}}e.ResolvedAuthority=z;class ue extends Error{constructor(M,ne=A.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(M);this._message=M,this._code=ne,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ue.prototype)}static NotAvailable(M,ne){return new ue(M,A.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new ue(M,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ue;var H;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var B;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=c=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof c?!0:M?I.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new c(M,ne)}static insert(M,ne){return c.replace(new I(M,M),ne)}static delete(M){return c.replace(M,"")}static setEndOfLine(M){const ne=new c(new I(new p(0,0),new p(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!I.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=c=qe([D],K),e.TextEdit=K;var L;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(L=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,Ee,Be){this._edits.push({_type:1,from:M,to:ne,options:Ee,metadata:Be})}createFile(M,ne,Ee){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:Ee})}deleteFile(M,ne,Ee){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:Ee})}replaceNotebookMetadata(M,ne,Ee){this._edits.push({_type:3,metadata:Ee,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,Ee,Be,Je){(ne!==Ee||Be.length>0)&&this._edits.push({_type:5,uri:M,index:ne,count:Ee-ne,cells:Be,metadata:Je})}replaceNotebookCellOutput(M,ne,Ee,Be){this._editNotebookCellOutput(M,ne,!1,Ee,Be)}appendNotebookCellOutput(M,ne,Ee,Be){this._editNotebookCellOutput(M,ne,!0,Ee,Be)}replaceNotebookCellOutputItems(M,ne,Ee,Be,Je){this._editNotebookCellOutputItems(M,ne,Ee,!1,Be,Je)}appendNotebookCellOutputItems(M,ne,Ee,Be,Je){this._editNotebookCellOutputItems(M,ne,Ee,!0,Be,Je)}_editNotebookCellOutputItems(M,ne,Ee,Be,Je,ot){this._edits.push({_type:6,metadata:ot,uri:M,index:ne,outputId:Ee,append:Be,newOutputItems:Je})}_editNotebookCellOutput(M,ne,Ee,Be,Je){this._edits.push({_type:4,metadata:Je,uri:M,index:ne,append:Ee,newOutputs:Be,newMetadata:void 0})}replaceNotebookCellMetadata(M,ne,Ee,Be){this._edits.push({_type:3,metadata:Be,uri:M,edit:{editType:11,index:ne,metadata:Ee}})}replace(M,ne,Ee,Be){this._edits.push({_type:2,uri:M,edit:new K(ne,Ee),metadata:Be})}insert(M,ne,Ee,Be){this.replace(M,new I(ne,ne),Ee,Be)}delete(M,ne,Ee){this.replace(M,ne,"",Ee)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const Ee of ne)Ee&&this._edits.push({_type:2,uri:M,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Be=this._edits[Ee];Be._type===2&&Be.uri.toString()===M.toString()&&(this._edits[Ee]=void 0)}(0,y.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===M.toString()&&ne.push(Ee.edit);return ne}entries(){const M=new P.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ee=M.get(ne.uri);Ee||(Ee=[ne.uri,[]],M.set(ne.uri,Ee)),Ee[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=qe([D],U),e.WorkspaceEdit=U;let x=d=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof d?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=d._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const Ee=new d;Ee._tabstop=this._tabstop,M(Ee),this._tabstop=Ee._tabstop,M=Ee.value}else M=d._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const Ee=M.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const Ee=new d;Ee._tabstop=this._tabstop,ne(Ee),this._tabstop=Ee._tabstop,ne=Ee.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};x=d=qe([D],x),e.SnippetString=x;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=o=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof I)this.range=ne;else if(ne instanceof p)this.range=new I(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof o?!0:M?I.isRange(M.range)&&k.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=o=qe([D],Z),e.Location=Z;let ie=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&I.isRange(M.location.range)&&k.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};ie=qe([D],ie),e.DiagnosticRelatedInformation=ie;let re=class{constructor(M,ne,Ee=$.Error){if(!I.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=Ee}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,y.equals)(M.tags,ne.tags)&&(0,y.equals)(M.relatedInformation,ne.relatedInformation,ie.isEqual)}};re=qe([D],re),e.Diagnostic=re;let ye=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,T.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=ne}};ye=qe([D],ye),e.Hover=ye;var Ie;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(M,ne=Ie.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Ue=qe([D],Ue),e.DocumentHighlight=Ue;var Re;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Re=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let N=t=class{constructor(M,ne,Ee,Be,Je){this.name=M,this.kind=ne,this.containerName=Je,typeof Ee=="string"&&(this.containerName=Ee),Be instanceof Z?this.location=Be:Ee instanceof I&&(this.location=new Z(Be,Ee)),t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};N=t=qe([D],N),e.SymbolInformation=N;let G=i=class{constructor(M,ne,Ee,Be,Je){this.name=M,this.detail=ne,this.kind=Ee,this.range=Be,this.selectionRange=Je,this.children=[],i.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(i.validate)}};G=i=qe([D],G),e.DocumentSymbol=G;var ee;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(M,ne){this.title=M,this.kind=ne}};oe=qe([D],oe),e.CodeAction=oe;let fe=u=class{constructor(M){this.value=M}append(M){return new u(this.value?this.value+u.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+u.sep)}};fe.sep=".",fe=u=qe([D],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Se=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=qe([D],Se),e.SelectionRange=Se;class Le{constructor(M,ne,Ee,Be,Je,ot){this.kind=M,this.name=ne,this.detail=Ee,this.uri=Be,this.range=Je,this.selectionRange=ot}}e.CallHierarchyItem=Le;class me{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=me;class Ce{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};Pe=qe([D],Pe),e.CodeLens=Pe;let xe=a=class{constructor(M,ne=!1){b.set(this,void 0),nt(this,b,new T.MarkdownString(M,{supportThemeIcons:ne}))}static isMarkdownString(M){return M instanceof a?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return $e(this,b).value}set value(M){$e(this,b).value=M}get isTrusted(){return $e(this,b).isTrusted}set isTrusted(M){$e(this,b).isTrusted=M}get supportThemeIcons(){return $e(this,b).supportThemeIcons}appendText(M){return $e(this,b).appendText(M),this}appendMarkdown(M){return $e(this,b).appendMarkdown(M),this}appendCodeblock(M,ne){return $e(this,b).appendCodeblock(ne!=null?ne:"",M),this}};b=new WeakMap,xe=a=qe([D],xe),e.MarkdownString=xe;let _e=class{constructor(M,ne){this.label=M,this.documentation=ne}};_e=qe([D],_e),e.ParameterInformation=_e;let Ke=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};Ke=qe([D],Ke),e.SignatureInformation=Ke;let j=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};j=qe([D],j),e.SignatureHelp=j;var Y;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(pe=e.InlineHintKind||(e.InlineHintKind={}));let Fe=class{constructor(M,ne,Ee){this.text=M,this.range=ne,this.kind=Ee}};Fe=qe([D],Fe),e.InlineHint=Fe;var He;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(O){O[O.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=qe([D],W),e.CompletionItem=W;let te=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};te=qe([D],te),e.CompletionList=te;var de;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var q;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var J;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var se;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ge;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(ne){switch(ne){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(M,ne){if(ne&&!k.URI.isUri(ne))throw(0,R.illegalArgument)("target");if(!I.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=ne}};Ne=qe([D],Ne),e.DocumentLink=Ne;let je=class{constructor(M,ne,Ee,Be){this.red=M,this.green=ne,this.blue=Ee,this.alpha=Be}};je=qe([D],je),e.Color=je;let Ye=class{constructor(M,ne){if(ne&&!(ne instanceof je))throw(0,R.illegalArgument)("color");if(!I.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=ne}};Ye=qe([D],Ye),e.ColorInformation=Ye;let Ze=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};Ze=qe([D],Ze),e.ColorPresentation=Ze;var ct;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(ct=e.ColorFormat||(e.ColorFormat={}));var lt;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var Ve;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(Ve=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=l=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,R.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ve.Clean=new l("clean","Clean"),ve.Build=new l("build","Build"),ve.Rebuild=new l("rebuild","Rebuild"),ve.Test=new l("test","Test"),ve=l=qe([D],ve),e.TaskGroup=ve;function De(O){let M="";for(let ne=0;ne<O.length;ne++)M+=O[ne].replace(/,/g,",,")+",";return M}let ae=class{constructor(M,ne,Ee){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ee):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return De(M)}};ae=qe([D],ae),e.ProcessExecution=ae;let V=class{constructor(M,ne,Ee){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=ne,this._options=Ee}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return De(M)}};V=qe([D],V),e.ShellExecution=V;var Me;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Me=e.ShellQuoting||(e.ShellQuoting={}));var Ae;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Ae=e.TaskScope||(e.TaskScope={}));class et{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,E.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=et;let Qe=f=class{constructor(M,ne,Ee,Be,Je,ot){this.__deprecated=!1,this._definition=this.definition=M;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ee,this.execution=Be,dt=Je,this.__deprecated=!0):ne===Ae.Global||ne===Ae.Workspace?(this.target=ne,this._name=this.name=Ee,this._source=this.source=Be,this.execution=Je,dt=ot):(this.target=ne,this._name=this.name=Ee,this._source=this.source=Be,this.execution=Je,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ae?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof V?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,E.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(f.EmptyType===ne||f.ProcessType===ne||f.ShellType===ne||f.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=f=qe([D],Qe),e.Task=Qe;var at;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(M,ne=Xe.None){this.collapsibleState=ne,k.URI.isUri(M)?this.resourceUri=M:this.label=M}};rt=qe([D],rt),e.TreeItem=rt;var Xe;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Xe=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(M,ne){this.id=M,this.color=ne}};st=qe([D],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let vt=class{constructor(M){this.id=M}};vt=qe([D],vt),e.ThemeColor=vt;var mt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(mt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(M,ne){if(typeof M!="string"&&(!M||!k.URI.isUri(M)&&!k.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof ne!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=k.URI.file(M),this.base=M):k.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};Dt=qe([D],Dt),e.RelativePattern=Dt;let _t=class{constructor(M,ne,Ee,Be){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,E.generateUuid)()),this._id}};_t=qe([D],_t),e.Breakpoint=_t;let Et=class extends _t{constructor(M,ne,Ee,Be,Je){super(ne,Ee,Be,Je);if(M===null)throw(0,R.illegalArgument)("location");this.location=M}};Et=qe([D],Et),e.SourceBreakpoint=Et;let pt=class extends _t{constructor(M,ne,Ee,Be,Je){super(ne,Ee,Be,Je);this.functionName=M}};pt=qe([D],pt),e.FunctionBreakpoint=pt;let Ft=class extends _t{constructor(M,ne,Ee,Be,Je,ot,dt){super(Be,Je,ot,dt);if(!ne)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=Ee}};Ft=qe([D],Ft),e.DataBreakpoint=Ft;let Lt=class{constructor(M,ne,Ee){this.command=M,this.args=ne||[],this.options=Ee}};Lt=qe([D],Lt),e.DebugAdapterExecutable=Lt;let ft=class{constructor(M,ne){this.port=M,this.host=ne}};ft=qe([D],ft),e.DebugAdapterServer=ft;let yt=class{constructor(M){this.path=M}};yt=qe([D],yt),e.DebugAdapterNamedPipeServer=yt;let Ht=class{constructor(M){this.implementation=M}};Ht=qe([D],Ht),e.DebugAdapterInlineImplementation=Ht;let qt=class{constructor(M,ne){this.range=M,this.expression=ne}};qt=qe([D],qt),e.EvaluatableExpression=qt;let Mt=class{constructor(M,ne){this.range=M,this.text=ne}};Mt=qe([D],Mt),e.InlineValueText=Mt;let ht=class{constructor(M,ne,Ee=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=Ee}};ht=qe([D],ht),e.InlineValueVariableLookup=ht;let Kt=class{constructor(M,ne){this.range=M,this.expression=ne}};Kt=qe([D],Kt),e.InlineValueEvaluatableExpression=Kt;let kt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};kt=qe([D],kt),e.InlineValueContext=kt;var Nt;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let zt=v=class extends Error{constructor(M,ne=n.FileSystemProviderErrorCode.Unknown,Ee){var Be;super(k.URI.isUri(M)?M.toString(!0):M);this.code=(Be=Ee==null?void 0:Ee.name)!==null&&Be!==void 0?Be:"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(M){return new v(M,n.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(M){return new v(M,n.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(M){return new v(M,n.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(M){return new v(M,n.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(M){return new v(M,n.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(M){return new v(M,n.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};zt=v=qe([D],zt),e.FileSystemError=zt;let Gt=class{constructor(M,ne,Ee){this.start=M,this.end=ne,this.kind=Ee}};Gt=qe([D],Gt),e.FoldingRange=Gt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class Ot{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ot;function fn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Ut{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,Ee=M.tokenTypes.length;ne<Ee;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,Ee=M.tokenModifiers.length;ne<Ee;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,Ee,Be,Je){if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof Be=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(M,ne,Ee,Be,Je);if(I.isRange(M)&&typeof ne=="string"&&fn(Ee))return this._push(M,ne,Ee);throw(0,R.illegalArgument)()}_push(M,ne,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Be=M.start.line,Je=M.start.character,ot=M.end.character-M.start.character,dt=this._tokenTypeStrToInt.get(ne);let wt=0;if(Ee)for(const Ct of Ee){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);wt|=1<<It>>>0}this._pushEncoded(Be,Je,ot,dt,wt)}_pushEncoded(M,ne,Ee,Be,Je){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const wt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<wt;Pt++){let Tt=this._data[5*Pt],Xt=this._data[5*Pt+1];Tt===0?(Tt=Ct,Xt+=It):Tt+=Ct,this._data[5*Pt]=Tt,this._data[5*Pt+1]=Xt,Ct=Tt,It=Xt}}let ot=M,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Je,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const Ee=M.length/5|0;for(let dt=0;dt<Ee;dt++)ne[dt]=dt;ne.sort((dt,wt)=>{const Ct=M[5*dt],It=M[5*wt];if(Ct===It){const Pt=M[5*dt+1],Tt=M[5*wt+1];return Pt-Tt}return Ct-It});const Be=new Uint32Array(M.length);let Je=0,ot=0;for(let dt=0;dt<Ee;dt++){const wt=5*ne[dt],Ct=M[wt+0],It=M[wt+1],Pt=M[wt+2],Tt=M[wt+3],Xt=M[wt+4],kn=Ct-Je,Tn=kn===0?It-ot:It,Zt=5*dt;Be[Zt+0]=kn,Be[Zt+1]=Tn,Be[Zt+2]=Pt,Be[Zt+3]=Tt,Be[Zt+4]=Xt,Je=Ct,ot=It}return Be}build(M){return this._dataIsSortedAndDeltaEncoded?new xt(new Uint32Array(this._data),M):new xt(Ut._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Ut;class xt{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=xt;class mn{constructor(M,ne,Ee){this.start=M,this.deleteCount=ne,this.data=Ee}}e.SemanticTokensEdit=mn;class gn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=gn;var At;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(At=e.DebugConsoleMode||(e.DebugConsoleMode={}));var pn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(pn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Vt=class{constructor(){}};Vt.Back={iconPath:new st("arrow-left")},Vt=qe([D],Vt),e.QuickInputButtons=Vt;var vn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(vn=e.ExtensionKind||(e.ExtensionKind={}));class _n{constructor(M,ne,Ee){this.badge=M,this.tooltip=ne,this.color=Ee}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=_n;let $t=class{constructor(M){this.kind=M}};$t=qe([D],$t),e.ColorTheme=$t;var nn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(nn=e.ColorThemeKind||(e.ColorThemeKind={}));class rn{constructor(M,ne){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(ne<M)throw(0,R.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=ne}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=rn;class Wt{constructor(M,ne,Ee,Be,Je,ot,dt){this.editable=M,this.breakpointMargin=ne,this.hasExecutionOrder=Ee,this.statusMessage=Be,this.inputCollapsed=Je,this.outputCollapsed=ot,this.custom=dt}with(M){let{editable:ne,breakpointMargin:Ee,hasExecutionOrder:Be,statusMessage:Je,inputCollapsed:ot,outputCollapsed:dt,custom:wt}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),Ee===void 0?Ee=this.breakpointMargin:Ee===null&&(Ee=void 0),Be===void 0?Be=this.hasExecutionOrder:Be===null&&(Be=void 0),Je===void 0?Je=this.statusMessage:Je===null&&(Je=void 0),ot===void 0?ot=this.inputCollapsed:ot===null&&(ot=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),wt===void 0?wt=this.custom:wt===null&&(wt=void 0),ne===this.editable&&Ee===this.breakpointMargin&&Be===this.hasExecutionOrder&&Je===this.statusMessage&&ot===this.inputCollapsed&&dt===this.outputCollapsed&&wt===this.custom?this:new Wt(ne,Ee,Be,Je,ot,dt,wt)}}e.NotebookCellMetadata=Wt;class Te{constructor(M=!0,ne=!0,Ee=!0,Be={},Je=!0){this.editable=M,this.cellEditable=ne,this.cellHasExecutionOrder=Ee,this.custom=Be,this.trusted=Je}with(M){let{editable:ne,cellEditable:Ee,cellHasExecutionOrder:Be,custom:Je,trusted:ot}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),Ee===void 0?Ee=this.cellEditable:Ee===null&&(Ee=void 0),Be===void 0?Be=this.cellHasExecutionOrder:Be===null&&(Be=void 0),Je===void 0?Je=this.custom:Je===null&&(Je=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),ne===this.editable&&Ee===this.cellEditable&&Be===this.cellHasExecutionOrder&&Je===this.custom&&ot===this.trusted?this:new Te(ne,Ee,Be,Je,ot)}}e.NotebookDocumentMetadata=Te;class Qt{constructor(M,ne,Ee,Be,Je,ot){this.kind=M,this.source=ne,this.language=Ee,this.outputs=Be!=null?Be:[],this.metadata=Je,this.latestExecutionSummary=ot}}e.NotebookCellData=Qt;class Jt{constructor(M,ne){this.cells=M,this.metadata=ne!=null?ne:new Te}}e.NotebookData=Jt;class gt{constructor(M,ne,Ee){this.mime=M,this.value=ne,this.metadata=Ee}static isNotebookCellOutputItem(M){return M instanceof gt}}e.NotebookCellOutputItem=gt;class bn{constructor(M,ne,Ee){this.outputs=M,typeof ne=="string"?(this.id=ne,this.metadata=Ee):(this.id=(0,E.generateUuid)(),this.metadata=ne!=null?ne:Ee)}}e.NotebookCellOutput=bn;var wn;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(wn=e.NotebookCellKind||(e.NotebookCellKind={}));var sn;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var on;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(on=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var En;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(En=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Yt=class{constructor(M,ne){this.label=M,this.timestamp=ne}};Yt=qe([D],Yt),e.TimelineItem=Yt;var yn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(yn=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class Dn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=Dn;var Cn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Cn=e.TestResult||(e.TestResult={}));var ln;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(O,M,ne)=>{let Ee=ne;return{enumerable:!0,configurable:!1,get(){return Ee},set(Be){var Je;(Je=O[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(M,Be),Ee=Be}}};class un{constructor(M){m.set(this,new Map),r.set(this,void 0),nt(this,r,M)}get size(){return $e(this,m).size}add(M){const ne=$e(this,m),Ee=$e(this,r).call(this),Be=ne.get(M.id);Be!==M&&(Be&&(Ee==null||Ee.delete(M.id)),ne.set(M.id,M),Ee==null||Ee.created(M))}get(M){return $e(this,m).get(M)}clear(){for(const M of $e(this,m).keys())this.delete(M)}delete(M){var ne;const Ee=typeof M=="string"?M:M.id;$e(this,m).has(Ee)&&($e(this,m).delete(Ee),(ne=$e(this,r).call(this))===null||ne===void 0||ne.delete(Ee))}toJSON(){return[...$e(this,m).values()]}[(m=new WeakMap,r=new WeakMap,Symbol.iterator)](){return $e(this,m).values()}}e.TestChildrenCollection=un;class X{constructor(M,ne,Ee,Be){this.label=ne,this.expandable=Be,Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},children:{value:new un(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:jt(this,"range",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var M;(M=this[e.TestItemHookProperty])===null||M===void 0||M.invalidate(this.id)}discoverChildren(M,ne){M.report({busy:!1})}}e.TestItem=X;class ce{constructor(M){this.state=M,this.messages=[]}}e.TestState=ce;class ke{constructor(M){this.message=M,this.severity=ln.Error}static diff(M,ne,Ee){const Be=new ke(M);return Be.expectedOutput=ne,Be.actualOutput=Ee,Be}}e.TestMessage=ke;var ut;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ut=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unknown=2]="Unknown"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var St;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(St=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[94],we([0,1,43,16,8,118,83,7,15]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function A(r,s){s?n.set(r,s):n.delete(r)}e.setWordDefinitionFor=A;function C(r){return n.get(r)}e.getWordDefinitionFor=C;class b extends P.MirrorTextModel{constructor(s,_,g,w,c,d,o,t){super(_,g,w,c);this._proxy=s,this._languageId=d,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,y.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,E.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===R.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(_){return _?s._getTextInRange(_):s.getText()},get eol(){return s._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(_){return s._lineAt(_)},offsetAt(_){return s._offsetAt(_)},positionAt(_){return s._positionAt(_)},validateRange(_){return s._validateRange(_)},validatePosition(_){return s._validatePosition(_)},getWordRangeAtPosition(_,g){return s._getWordRangeAtPosition(_,g)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,y.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,y.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const _=this._validateRange(s);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const g=this._eol,w=_.start.line,c=_.end.line,d=[];d.push(this._lines[w].substring(_.start.character));for(let o=w+1;o<c;o++)d.push(this._lines[o]);return d.push(this._lines[c].substring(0,_.end.character)),d.join(g)}_lineAt(s){let _;if(s instanceof k.Position?_=s.line:typeof s=="number"&&(_=s),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(s),g=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,g))}_validateRange(s){if(!(s instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(s.start),g=this._validatePosition(s.end);return _===s.start&&g===s.end?s:new k.Range(_.line,_.character,g.line,g.character)}_validatePosition(s){if(!(s instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:_,character:g}=s,w=!1;if(_<0)_=0,g=0,w=!0;else if(_>=this._lines.length)_=this._lines.length-1,g=this._lines[_].length,w=!0;else{const c=this._lines[_].length;g<0?(g=0,w=!0):g>c&&(g=c,w=!0)}return w?new k.Position(_,g):s}_getWordRangeAtPosition(s,_){const g=this._validatePosition(s);if(!_)_=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const w=(0,S.getWordAtText)(g.character+1,(0,S.ensureValidWordDefinition)(_),this._lines[g.line],0);if(w)return new k.Range(g.line,w.startColumn-1,g.line,w.endColumn-1)}}e.ExtHostDocumentData=b;class m{constructor(s,_,g){this._line=s,this._text=_,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[160],we([0,1,7,3,85,6,59,22,2,29]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(b,m,r,s){this._notebook=r,this._selector=s,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(g=>{const w=this._cellUris.get(g.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(g=>_(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const b=[],m=[];for(const r of this._notebook.cells)r.kind===y.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),b.push(r.document.getText().length+1),m.push(r.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(b){var m,r;if(!b){let c="";for(const d of this._cells)c+=d.document.getText()+`
`;return c=c.slice(0,-1),c}if(b.isEmpty)return"";const s=this.locationAt(b.start),_=this.locationAt(b.end),g=this._cells[(m=this._cellUris.get(s.uri))!==null&&m!==void 0?m:-1],w=this._cells[(r=this._cellUris.get(_.uri))!==null&&r!==void 0?r:-1];if(!g||!w)return"";if(g===w)return g.document.getText(new y.Range(s.range.start,_.range.end));{const c=g.document.getText(new y.Range(s.range.start,new y.Position(g.document.lineCount,0))),d=w.document.getText(new y.Range(new y.Position(0,0),_.range.end));return c+`
`+d}}offsetAt(b){const m=this._cellLines.getIndexOf(b.line),r=this._cellLengths.getAccumulatedValue(m.index-1),s=this._cells[m.index].document.offsetAt(b.with(m.remainder));return r+s}positionAt(b){if(typeof b=="number"){const r=this._cellLengths.getIndexOf(b),s=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(s)}const m=this._cellUris.get(b.uri);if(m!==void 0){const r=this._cellLines.getAccumulatedValue(m-1);return new y.Position(r+b.range.start.line,b.range.start.character)}return new y.Position(0,0)}locationAt(b){y.Range.isRange(b)||(b=new y.Range(b,b));const m=this._cellLines.getIndexOf(b.start.line);let r=m;b.isEmpty||(r=this._cellLines.getIndexOf(b.end.line));const s=new y.Position(m.remainder,b.start.character),_=new y.Position(r.remainder,b.end.character),g=new y.Range(s,_),w=this._cells[m.index];return new y.Location(w.document.uri,w.document.validateRange(g))}contains(b){return this._cellUris.has(b)}validateRange(b){const m=this.validatePosition(b.start),r=this.validatePosition(b.end);return b.with(m,r)}validatePosition(b){const m=this._cellLines.getIndexOf(b.line),r=new y.Position(m.remainder,b.character),s=this._cells[m.index].document.validatePosition(r),_=this._cellLines.getAccumulatedValue(m.index-1);return new y.Position(_+s.line,s.character)}}e.ExtHostNotebookConcatDocument=A}),define(be[161],we([0,1,7,14,3]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(k){this._actual=new y.ColorTheme(y.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let E=k==="light"?y.ColorThemeKind.Light:k==="dark"?y.ColorThemeKind.Dark:y.ColorThemeKind.HighContrast;this._actual=new y.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=qe([Ge(0,R.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(be[68],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,y.createDecorator)("IURITransformerService");class R{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=R}),define(be[69],we([0,1,2]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function R(P,S,k){const E=P.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",S);return y.URI.parse(E)}e.asWebviewUri=R;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(be[162],we([0,1,3,6,69,29]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(E,n,A){this._proxy=E,this._editors=n,this._initData=A,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const b of this._insets.values())C.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,n,A,C,b){let m;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===E){m=d;break}if(!m)throw new Error("not a visible editor");const r=this,s=this._handlePool++,_=new y.Emitter,g=new y.Emitter,w=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,T.asWebviewUri)(r._initData,this._uuid,d)}get cspSource(){return r._initData.webviewCspSource}set options(d){this._options=d,r._proxy.$setOptions(s,d)}get options(){return this._options}set html(d){this._html=d,r._proxy.$setHtml(s,d)}get html(){return this._html}get onDidReceiveMessage(){return _.event}postMessage(d){return r._proxy.$postMessage(s,d)}},c=new class{constructor(){this.editor=E,this.line=n,this.height=A,this.webview=w,this.onDidDispose=g.event}dispose(){r._insets.has(s)&&(r._insets.delete(s),r._proxy.$disposeEditorInset(s),g.fire(),g.dispose(),_.dispose())}};return this._proxy.$createEditorInset(s,m.id,m.value.document.uri,n+1,A,C||{},b.identifier,b.extensionLocation),this._insets.set(s,{editor:E,inset:c,onDidReceiveMessage:_}),c}$onDidDispose(E){const n=this._insets.get(E);n&&n.inset.dispose()}$onDidReceiveMessage(E,n){const A=this._insets.get(E);A&&A.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(be[163],we([0,1,3,63,136,4,6,22,30,15,50,23,37,155]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",b.Codicon.window,(0,T.localize)(0,null));var r;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var s;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function g(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=g;class w extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new y.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new y.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(f,v,D){var h;const p=this.get(f.id);if(p)return p;const I=f;return I.openCommandActionDescriptor=(D==null?void 0:D.donotRegisterOpenCommand)?void 0:(h=I.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:I.id},(0,k.getOrSet)(this.viewContainers,v,[]).push(I),(D==null?void 0:D.isDefault)&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:v}),I}deregisterViewContainer(f){for(const v of this.viewContainers.keys()){const D=this.viewContainers.get(v),h=D==null?void 0:D.indexOf(f);if(h!==-1){D==null||D.splice(h,1),D.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:v});return}}}get(f){return this.all.filter(v=>v.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(D=>(D==null?void 0:D.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===f)}}E.Registry.add(r.ViewContainersRegistry,new w);var c;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function d(l,f){var v,D,h,p;const I=(v=l.group)!==null&&v!==void 0?v:c.More,F=(D=f.group)!==null&&D!==void 0?D:c.More;return I!==F?I.localeCompare(F):((h=l.order)!==null&&h!==void 0?h:5)-((p=f.order)!==null&&p!==void 0?p:5)}class o extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new y.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new y.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new y.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new y.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(f,v){this.registerViews2([{views:f,viewContainer:v}])}registerViews2(f){f.forEach(({views:v,viewContainer:D})=>this.addViews(v,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,v){const D=this.removeViews(f,v);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:v})}moveViews(f,v){for(const D of this._views.keys())if(D!==v){const h=this.removeViews(f,D);h.length&&(this.addViews(h,v),this._onDidChangeContainer.fire({views:h,from:D,to:v}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const v of this._viewContainers){const D=(this._views.get(v)||[]).filter(h=>h.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(h=>h.id===f)[0])return v;return null}registerViewWelcomeContent(f,v){return this._viewWelcomeContents.add(f,v),this._onDidChangeViewWelcomeContent.fire(f),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,v),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,v){const D=new Map;for(const[h,p]of v)this._viewWelcomeContents.add(f,p),D.set(h,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,p),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const v=[];return this._viewWelcomeContents.forEach(f,D=>v.push(D)),v.sort(d)}addViews(f,v){let D=this._views.get(v);D||(D=[],this._views.set(v,D),this._viewContainers.push(v));for(const h of f){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(1,null,h.id));D.push(h)}}removeViews(f,v){const D=this._views.get(v);if(!D)return[];const h=[],p=[];for(const I of D)f.includes(I)?h.push(I):p.push(I);return h.length&&(p.length?this._views.set(v,p):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),h}}E.Registry.add(r.ViewsRegistry,new o),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(f,v){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,f),this._hasResolve=!!v,this.resolve=async D=>{var h,p;if(v&&!this.resolved){const I=await v(D);I&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:I.tooltip,this.command=(p=this.command)!==null&&p!==void 0?p:I.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(be[164],we([0,1,2,145,156,19,146,163]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function E(s){return(_,...g)=>s(_.get(R.ICommandService),...g)}class n{static execute(_,g){const w={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return _.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:n.ID,handler:E(n.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,_){return s.get(T.IWorkspacesService).removeRecentlyOpened([_])});class A{static execute(_,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?y.URI.parse(g):y.URI.file(g):g=y.URI.revive(g),_.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=A,A.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(A.ID,E(A.execute));class C{static execute(_,g){const w=typeof g=="string"?{extensionId:g}:g;return _.executeCommand("workbench.action.openIssueReporter",w)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,_){const g=s.get(T.IWorkspacesService);let w;const c=_.uri,d=_.label,o=_.remoteAuthority;return _.type==="workspace"?w={workspace:await g.getWorkspaceIdentifier(c),label:d,remoteAuthority:o}:_.type==="folder"?w={folderUri:c,label:d,remoteAuthority:o}:w={fileUri:c,label:d,remoteAuthority:o},g.addRecentlyOpened([w])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(T.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,_){const g=s.get(P.ILogService),w=s.get(S.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&g.setLevel(_)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(P.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,_){const g=s.get(k.IViewDescriptorService),w=g.getViewContainerById(_.destinationId);if(!!w){for(const c of _.viewIds){const d=g.getViewDescriptorById(c);(d==null?void 0:d.canMoveView)&&g.moveViewsToContainer([d],w,k.ViewVisibilityState.Default)}await s.get(k.IViewsService).openViewContainer(w.id,!0)}});class b{static execute(_,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):_.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:b.ID,handler:E(b.execute),description:{description:"Move Views",args:[]}});class m{static execute(_,g){return _.executeCommand("_workbench.open",g)}}m.ID="vscode.open",R.CommandsRegistry.registerCommand(m.ID,E(m.execute));class r{static execute(_,g,w,c,d){return _.executeCommand("_workbench.diff",[g,w,c])}}r.ID="vscode.diff",R.CommandsRegistry.registerCommand(r.ID,E(r.execute))}),define(be[165],we([0,1,3,13,137]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new y.Emitter,this._onExit=new y.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,E,n,A){const C={command:k};if(E&&Object.keys(E).length>0&&(C.arguments=E),this.internalSend("request",C),typeof A=="number"){const b=setTimeout(()=>{clearTimeout(b);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const r={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,A,k)};m(r)}},A)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,E){return k.type!=="event"||E.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,R.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const E=k,n=this.pendingRequests.get(E.request_seq);n&&(this.pendingRequests.delete(E.request_seq),n(E));break}}}internalSend(k,E){E.type=k,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((E,n)=>k.set(n,E)),await(0,R.timeout)(500),k.forEach((E,n)=>{E({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(be[166],we([0,1,8,2,11,23,16]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function E(i,u,a){return i.replace(k,function(l,f){return u&&f.length>0&&f[0]!=="_"?l:a&&a.hasOwnProperty(f)?a[f]:l})}e.formatPII=E;function n(i){const u={};for(const a of Object.keys(i))a.startsWith("!")||(u[a]=i[a]);return u}e.filterExceptionsFromTelemetry=n;function A(i){return i.configuration.request==="attach"&&!C(i)}e.isSessionAttach=A;function C(i){let u=i.configuration.type;if(!!u)return u==="vslsShare"&&(u=i.configuration.adapterProxy.configuration.type),(0,y.equalsIgnoreCase)(u,"extensionhost")||(0,y.equalsIgnoreCase)(u,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function b(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=b;function m(i,u,a){let l,f=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=v.exec(i);){let h=D.index+1,p=h+D[0].length;if(h<=u&&p>=a){l=D[0],f=h;break}}if(l){let h=/\w+/g,p=null;for(;(p=h.exec(l))&&!(p.index+1+f+p[0].length>=a););p&&(l=l.substring(0,h.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(r))}e.isUri=s;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return R.URI.parse(i.path);if((0,T.isAbsolute)(i.path))return R.URI.file(i.path)}return i.path}function g(i){if(typeof i.path=="object"){const u=R.URI.revive(i.path);if(u)return u.scheme===S.Schemas.file?u.fsPath:u.toString()}return i.path}function w(i,u){const a=u?_:g,l=(0,P.deepClone)(i);return d(l,(f,v)=>{f&&v&&(v.path=a(v))}),l}e.convertToDAPaths=w;function c(i,u){const a=u?_:g,l=(0,P.deepClone)(i);return d(l,(f,v)=>{!f&&v&&(v.path=a(v))}),l}e.convertToVSCPaths=c;function d(i,u){switch(i.type){case"event":const a=i;switch(a.event){case"output":u(!1,a.body.source);break;case"loadedSource":u(!1,a.body.source);break;case"breakpoint":u(!1,a.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(v=>u(!1,v));break;default:break}break;case"response":const f=i;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(v=>u(!1,v.source));break;case"loadedSources":f.body.sources.forEach(v=>u(!1,v));break;case"scopes":f.body.scopes.forEach(v=>u(!1,v.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(v=>u(!1,v.source));break;case"setBreakpoints":f.body.breakpoints.forEach(v=>u(!1,v.source));break;default:break}break}}function o(i){return i.filter(u=>{var a;return!((a=u.presentation)===null||a===void 0?void 0:a.hidden)}).sort((u,a)=>u.presentation?a.presentation?u.presentation.group?a.presentation.group?u.presentation.group!==a.presentation.group?u.presentation.group.localeCompare(a.presentation.group):t(u.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(u.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=o;function t(i,u){return typeof i!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:i-u}}),define(be[70],we([0,1,28,16,11,21,63]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(I){I[I.Markdown=1]="Markdown",I[I.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(I){I[I.Idle=1]="Idle",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.CellClearOutput=3]="CellClearOutput",I[I.CellsClearOutput=4]="CellsClearOutput",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.Unknown=12]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.OutputsSplice=6]="OutputsSplice",I[I.Move=7]="Move",I[I.Unknown=8]="Unknown",I[I.CellContent=9]="CellContent",I[I.OutputItems=10]="OutputItems",I[I.PartialMetadata=11]="PartialMetadata"})(b=e.CellEditType||(e.CellEditType={}));function m(I){const F=r.parse(I);return F?F.notebook.toString():I.toString()}e.getCellUndoRedoComparisonKey=m;var r;(function(I){I.scheme=R.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function z(K,L){return K.with({scheme:I.scheme,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==R.Schemas.file?K.scheme:""}`})}I.generate=z;function ue(K){if(K.scheme===I.scheme){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||R.Schemas.file,fragment:null})}}}I.parse=ue;function H(K,L){return K.with({scheme:R.Schemas.vscodeNotebookCellMetadata,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==R.Schemas.file?K.scheme:""}`})}I.generateCellMetadataUri=H;function B(K){if(K.scheme===R.Schemas.vscodeNotebookCellMetadata){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||R.Schemas.file,fragment:null})}}}I.parseCellMetadataUri=B})(r=e.CellUri||(e.CellUri={}));const s=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(I){var F,z;return(z=(F=s.get(I))===null||F===void 0?void 0:F.alwaysSecure)!==null&&z!==void 0?z:!1}e.mimeTypeIsAlwaysSecure=_;function g(I){var F,z;return(z=(F=s.get(I))===null||F===void 0?void 0:F.supportedByCore)!==null&&z!==void 0?z:!1}e.mimeTypeSupportedByCore=g;function w(I){var F,z;return(z=(F=s.get(I))===null||F===void 0?void 0:F.mergeable)!==null&&z!==void 0?z:!1}e.mimeTypeIsMergeable=w;function c(I,F){return P.isWindows&&(I=I.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),y.match(I,F)}function d(I,F,z){let ue=0;for(let H=0;H<F.length;H++){if(c(F[H],I))return ue;ue++}for(let H=0;H<z.length;H++){if(c(z[H],I))return ue;ue++}return ue}function o(I,F,z){return I.sort((ue,H)=>d(ue,F,z)-d(H,F,z))}e.sortMimeTypes=o;function t(I,F,z,ue=(H,B)=>H===B){const H=[];function B(U,x,Q){if(!(x===0&&Q.length===0)){const $=H[H.length-1];$&&$.start+$.deleteCount===U?($.deleteCount+=x,$.toInsert.push(...Q)):H.push({start:U,deleteCount:x,toInsert:Q})}}let K=0,L=0;for(;;){if(K===I.length){B(K,0,F.slice(L));break}if(L===F.length){B(K,I.length-K,[]);break}const U=I[K],x=F[L];if(ue(U,x)){K+=1,L+=1;continue}z(x)?(B(K,1,[]),K+=1):(B(K,0,[x]),L+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new S.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(I){I.default="default",I.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(I){const F=I;return!!((typeof F.include=="string"||y.isRelativePattern(F.include))&&(typeof F.exclude=="string"||y.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=u;function a(I,F,z){if(Array.isArray(I.viewType)&&I.viewType.indexOf(F)>=0||I.viewType===F)return!0;if(I.filenamePattern){let ue=u(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,H=u(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(y.match(ue,(0,T.basename)(z.fsPath).toLowerCase()))return!(H&&y.match(H,(0,T.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class l{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let z=0;z<this.textModel.cells.length;z++)F[z]=this.textModel.cells[z].getHashValue();return F}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var f;(function(I){I[I.LEFT=0]="LEFT",I[I.RIGHT=1]="RIGHT"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function v(I){I.sort((z,ue)=>z-ue);const F=I.shift();return F===void 0?[]:I.reduce(function(z,ue){return ue<=z[0][1]?z[0][1]=ue+1:z.unshift([ue,ue+1]),z},[[F,F+1]]).reverse().map(z=>({start:z[0],end:z[1]}))}e.cellIndexesToRanges=v;function D(I){return I.reduce((z,ue)=>{for(let H=ue.start;H<ue.end;H++)z.push(H);return z},[])}e.cellRangesToIndexes=D;function h(I){const F=I.sort((ue,H)=>ue.start-H.start),z=F[0];return z?F.reduce((ue,H)=>{const B=ue[ue.length-1];return B.end>=H.start?B.end=Math.max(B.end,H.end):ue.push(H),ue},[z]):[]}e.reduceRanges=h;function p(I,F){return F.start>=I.start&&F.end<=I.end}e.cellRangeContains=p}),define(be[167],we([0,1,139,4,63]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,y.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,y.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,y.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[168],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=y;function R(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=R}),define(be[95],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var y;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&Object.assign(E.item,n.item)};e.applyTestItemUpdate=R;var T;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.DeltaRootsComplete=3]="DeltaRootsComplete",E[E.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const P=(E,n)=>`${E}:${n.toString()}`;e.getTestSubscriptionKey=P;class S{add(n){}update(n){}remove(n,A){}complete(){}}e.IncrementalChangeCollector=S;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const A=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const b=C[1];if(b.parent){if(this.items.has(b.parent)){const m=this.items.get(b.parent);m.children.add(b.item.extId);const r=this.createItem(b,m);this.items.set(b.item.extId,r),A.add(r)}}else{this.roots.add(b.item.extId);const m=this.createItem(b);this.items.set(b.item.extId,m),A.add(m)}b.expand===2&&this.updateBusyProviders(1);break}case 1:{const b=C[1],m=this.items.get(b.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,b),A.update(m),b.expand!==void 0&&m.expand===2&&b.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const b=this.items.get(C[1]);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b.item.extId);const m=[[C[1]]];for(;m.length;)for(const r of m.pop()){const s=this.items.get(r);s&&(m.push(s.children),this.items.delete(r),A.remove(s,s!==b),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}A.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=k}),define(be[169],we([0,1,11,32,12,23,21,58,140]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,b,m){if(this._contributedVariables=new Map,this._context=C,this._labelService=b,m)if(S.isWindows){const r=Object.create(null);this._envVariables=r,Object.keys(m).forEach(s=>{r[s.toLowerCase()]=m[s]})}else this._envVariables=m}resolve(C,b){return this.recursiveResolve(C?C.uri:void 0,b)}resolveAnyBase(C,b,m,r){const s=P.deepClone(b);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(_=>s[_]=s.windows[_]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(_=>s[_]=s.osx[_]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(_=>s[_]=s.linux[_]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(C?C.uri:void 0,s,m,r)}resolveAny(C,b,m){return this.resolveAnyBase(C,b,m)}resolveAnyMap(C,b,m){const r=new Map;return{newConfig:this.resolveAnyBase(C,b,m,r),resolvedVariables:r}}resolveWithInteractionReplace(C,b,m,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,b,m,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,b){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,b)}recursiveResolve(C,b,m,r){if(T.isString(b))return this.resolveString(C,b,m,r);if(T.isArray(b))return b.map(s=>this.recursiveResolve(C,s,m,r));if(T.isObject(b)){let s=Object.create(null);return Object.keys(b).forEach(_=>{const g=this.resolveString(C,_,m,r);s[g]=this.recursiveResolve(C,b[_],m,r)}),s}return b}resolveString(C,b,m,r){return b.replace(n.VARIABLE_REGEXP,(_,g)=>{if(g.includes(n.VARIABLE_LHS))return _;let w=this.evaluateSingleVariable(_,g,C,m);return r&&r.set(g,w),w})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,b,m,r){let s;const _=b.split(":");_.length>1&&(b=_[0],s=_[1]);const g=()=>{const d=this._context.getFilePath();if(d)return d;throw new Error((0,E.localize)(0,null,C))},w=()=>{const d=g();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,E.localize)(1,null,C,y.basename(d)))},c=()=>{if(s){const d=this._context.getFolderUri(s);if(d)return d;throw new Error((0,E.localize)(2,null,C,s))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,C)):new Error((0,E.localize)(4,null,C))};switch(b){case"env":if(s){if(this._envVariables){const d=this._envVariables[S.isWindows?s.toLowerCase():s];if(T.isString(d))return d}return""}throw new Error((0,E.localize)(5,null,C));case"config":if(s){const d=this._context.getConfigurationValue(m,s);if(T.isUndefinedOrNull(d))throw new Error((0,E.localize)(6,null,C,s));if(T.isObject(d))throw new Error((0,E.localize)(7,null,C,s));return d}throw new Error((0,E.localize)(8,null,C));case"command":return this.resolveFromMap(C,s,r,"command");case"input":return this.resolveFromMap(C,s,r,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return m||s?(0,k.normalizeDriveLetter)(this.fsPath(c())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return y.basename(this.fsPath(c()));case"lineNumber":const d=this._context.getLineNumber();if(d)return d;throw new Error((0,E.localize)(9,null,C));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,E.localize)(10,null,C));case"file":return g();case"fileWorkspaceFolder":return w();case"relativeFile":return m||s?y.relative(this.fsPath(c()),g()):g();case"relativeFileDirname":const t=y.dirname(g());if(m||s){const l=y.relative(this.fsPath(c()),t);return l.length===0?".":l}return t;case"fileDirname":return y.dirname(g());case"fileExtname":return y.extname(g());case"fileBasename":return y.basename(g());case"fileBasenameNoExtension":const i=y.basename(g());return i.slice(0,i.length-y.extname(i).length);case"fileDirnameBasename":return y.basename(y.dirname(g()));case"execPath":const u=this._context.getExecPath();return u||C;case"execInstallFolder":const a=this._context.getAppRoot();return a||C;case"pathSeparator":return y.sep;default:try{const l=s?`${b}:${s}`:b;return this.resolveFromMap(C,l,r,void 0)}catch(l){return C}}}}resolveFromMap(C,b,m,r){if(b&&m){const s=r===void 0?m[b]:m[r+":"+b];if(typeof s=="string")return s;throw new Error((0,E.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[170],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var R;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var T;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var S;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var E;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var A;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function C(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(be[171],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,15,80,224,57,23,12,2,33,62,141,87,70,171,7]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ve){function De(V){const{selectionStartLineNumber:Me,selectionStartColumn:Ae,positionLineNumber:et,positionColumn:Qe}=V,at=new s.Position(Me-1,Ae-1),rt=new s.Position(et-1,Qe-1);return new s.Selection(at,rt)}ve.to=De;function ae(V){const{anchor:Me,active:Ae}=V;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}ve.from=ae})(_=e.Selection||(e.Selection={}));var g;(function(ve){function De(V){if(!!V){const{start:Me,end:Ae}=V;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}}ve.from=De;function ae(V){if(!!V){const{startLineNumber:Me,startColumn:Ae,endLineNumber:et,endColumn:Qe}=V;return new s.Range(Me-1,Ae-1,et-1,Qe-1)}}ve.to=ae})(g=e.Range||(e.Range={}));var w;(function(ve){function De(ae){switch(ae){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ve.to=De})(w=e.TokenType||(e.TokenType={}));var c;(function(ve){function De(V){return new s.Position(V.lineNumber-1,V.column-1)}ve.to=De;function ae(V){return{lineNumber:V.line+1,column:V.character+1}}ve.from=ae})(c=e.Position||(e.Position={}));var d;(function(ve){function De(V){switch(V){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ve.from=De;function ae(V){switch(V){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ve.to=ae})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(ve){function De(V){let Me;return V.code&&((0,k.isString)(V.code)||(0,k.isNumber)(V.code)?Me=String(V.code):Me={value:String(V.code.value),target:V.code.target}),Object.assign(Object.assign({},g.from(V.range)),{message:V.message,source:V.source,code:Me,severity:i.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(t.from),tags:Array.isArray(V.tags)?(0,y.coalesce)(V.tags.map(d.from)):void 0})}ve.from=De;function ae(V){var Me;const Ae=new s.Diagnostic(g.to(V),V.message,i.to(V.severity));return Ae.source=V.source,Ae.code=(0,k.isString)(V.code)?V.code:(Me=V.code)===null||Me===void 0?void 0:Me.value,Ae.relatedInformation=V.relatedInformation&&V.relatedInformation.map(t.to),Ae.tags=V.tags&&(0,y.coalesce)(V.tags.map(d.to)),Ae}ve.to=ae})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function De(V){return Object.assign(Object.assign({},g.from(V.location.range)),{message:V.message,resource:V.location.uri})}ve.from=De;function ae(V){return new s.DiagnosticRelatedInformation(new s.Location(V.resource,g.to(V)),V.message)}ve.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ve){function De(V){switch(V){case s.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}ve.from=De;function ae(V){switch(V){case b.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ve.to=ae})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(ve){function De(V){return typeof V=="number"&&V>=s.ViewColumn.One?V-1:V===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ve.from=De;function ae(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ae})(u=e.ViewColumn||(e.ViewColumn={}));function a(ve){return typeof ve.range!="undefined"}function l(ve){return ve.length===0?!0:!!a(ve[0])}e.isDecorationOptionsArr=l;var f;(function(ve){function De(Qe){return Qe.map(ve.from)}ve.fromMany=De;function ae(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function V(Qe){let at;if(ae(Qe)){const{language:vt,value:mt}=Qe;at={value:"```"+vt+`
`+mt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Qe)?at={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons}:typeof Qe=="string"?at={value:Qe}:at={value:""};const rt=Object.create(null);at.uris=rt;const Xe=vt=>{try{let mt=E.URI.parse(vt,!0);mt=mt.with({query:Me(mt.query,rt)}),rt[vt]=mt}catch(mt){}return""},st=new T.Renderer;return st.link=Xe,st.image=vt=>Xe(R.parseHrefAndDimensions(vt).href),T(at.value,{renderer:st}),at}ve.from=V;function Me(Qe,at){if(!Qe)return Qe;let rt;try{rt=(0,P.parse)(Qe)}catch(st){}if(!rt)return Qe;let Xe=!1;return rt=(0,S.cloneAndChange)(rt,st=>{if(E.URI.isUri(st)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[vt]=st,Xe=!0,vt}else return}),Xe?JSON.stringify(rt):Qe}function Ae(Qe){const at=new s.MarkdownString(Qe.value,Qe.supportThemeIcons);return at.isTrusted=Qe.isTrusted,at}ve.to=Ae;function et(Qe){if(!!Qe)return typeof Qe=="string"?Qe:ve.from(Qe)}ve.fromStrict=et})(f=e.MarkdownString||(e.MarkdownString={}));function v(ve){return l(ve)?ve.map(De=>({range:g.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?f.fromMany(De.hoverMessage):De.hoverMessage?f.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ve.map(De=>({range:g.from(De)}))}e.fromRangeOrRangeWithMessage=v;function D(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?E.URI.file(ve):ve}e.pathOrURIToURI=D;var h;(function(ve){function De(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?D(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ve.from=De})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(ve){function De(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?D(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}ve.from=De})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var I;(function(ve){function De(ae){if(typeof ae=="undefined")return ae;switch(ae){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=De})(I=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ve){function De(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?I.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?p.from(ae.light):void 0,dark:ae.dark?p.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?D(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}ve.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ve){function De(V){return{text:V.newText,eol:V.newEol&&Y.from(V.newEol),range:g.from(V.range)}}ve.from=De;function ae(V){const Me=new s.TextEdit(g.to(V.range),V.text);return Me.newEol=typeof V.eol=="undefined"?void 0:Y.to(V.eol),Me}ve.to=ae})(z=e.TextEdit||(e.TextEdit={}));var ue;(function(ve){function De(V,Me,Ae){var et,Qe,at;const rt={edits:[]};if(V instanceof s.WorkspaceEdit)for(let Xe of V._allEntries())if(Xe._type===1)rt.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const st=Me==null?void 0:Me.getDocument(Xe.uri);rt.edits.push({_type:2,resource:Xe.uri,edit:z.from(Xe.edit),modelVersionId:st==null?void 0:st.version,metadata:Xe.metadata})}else Xe._type===3?rt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(et=Ae==null?void 0:Ae.lookupNotebookDocument(Xe.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Xe._type===4?(Xe.newOutputs&&rt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(We.from)}}),Xe.newMetadata&&rt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:11,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?rt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Qe=Ae==null?void 0:Ae.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.notebookDocument.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(he.from)}}):Xe._type===6&&rt.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:10,outputId:Xe.outputId,items:((at=Xe.newOutputItems)===null||at===void 0?void 0:at.map(ge.from))||[],append:Xe.append}});return rt}ve.from=De;function ae(V){const Me=new s.WorkspaceEdit;for(const Ae of V.edits)Ae.edit?Me.replace(E.URI.revive(Ae.resource),g.to(Ae.edit.range),Ae.edit.text):Me.renameFile(E.URI.revive(Ae.oldUri),E.URI.revive(Ae.newUri),Ae.options);return Me}ve.to=ae})(ue=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ve){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function ae(Me){return typeof De[Me]=="number"?De[Me]:6}ve.from=ae;function V(Me){for(const Ae in De)if(De[Ae]===Me)return Number(Ae);return s.SymbolKind.Property}ve.to=V})(H=e.SymbolKind||(e.SymbolKind={}));var B;(function(ve){function De(V){switch(V){case s.SymbolTag.Deprecated:return 1}}ve.from=De;function ae(V){switch(V){case 1:return s.SymbolTag.Deprecated}}ve.to=ae})(B=e.SymbolTag||(e.SymbolTag={}));var K;(function(ve){function De(V){return{name:V.name,kind:H.from(V.kind),tags:V.tags&&V.tags.map(B.from),containerName:V.containerName,location:$.from(V.location)}}ve.from=De;function ae(V){const Me=new s.SymbolInformation(V.name,H.to(V.kind),V.containerName,$.to(V.location));return Me.tags=V.tags&&V.tags.map(B.to),Me}ve.to=ae})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(ve){function De(V){var Me,Ae;const et={name:V.name||"!!MISSING: name!!",detail:V.detail,range:g.from(V.range),selectionRange:g.from(V.selectionRange),kind:H.from(V.kind),tags:(Ae=(Me=V.tags)===null||Me===void 0?void 0:Me.map(B.from))!==null&&Ae!==void 0?Ae:[]};return V.children&&(et.children=V.children.map(De)),et}ve.from=De;function ae(V){const Me=new s.DocumentSymbol(V.name,V.detail,H.to(V.kind),g.to(V.range),g.to(V.selectionRange));return(0,y.isNonEmptyArray)(V.tags)&&(Me.tags=V.tags.map(B.to)),V.children&&(Me.children=V.children.map(ae)),Me}ve.to=ae})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ve){function De(ae){const V=new s.CallHierarchyItem(H.to(ae.kind),ae.name,ae.detail||"",E.URI.revive(ae.uri),g.to(ae.range),g.to(ae.selectionRange));return V._sessionId=ae._sessionId,V._itemId=ae._itemId,V}ve.to=De})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(ve){function De(ae){return new s.CallHierarchyIncomingCall(U.to(ae.from),ae.fromRanges.map(V=>g.to(V)))}ve.to=De})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ve){function De(ae){return new s.CallHierarchyOutgoingCall(U.to(ae.to),ae.fromRanges.map(V=>g.to(V)))}ve.to=De})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ve){function De(V){return{range:V.range&&g.from(V.range),uri:V.uri}}ve.from=De;function ae(V){return new s.Location(E.URI.revive(V.uri),g.to(V.range))}ve.to=ae})($=e.location||(e.location={}));var Z;(function(ve){function De(V){const Me=V,Ae=V;return{originSelectionRange:Me.originSelectionRange?g.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ae.uri,range:g.from(Me.targetRange?Me.targetRange:Ae.range),targetSelectionRange:Me.targetSelectionRange?g.from(Me.targetSelectionRange):void 0}}ve.from=De;function ae(V){return{targetUri:E.URI.revive(V.uri),targetRange:g.to(V.range),targetSelectionRange:V.targetSelectionRange?g.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?g.to(V.originSelectionRange):void 0}}ve.to=ae})(Z=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(ve){function De(V){return{range:g.from(V.range),contents:f.fromMany(V.contents)}}ve.from=De;function ae(V){return new s.Hover(V.contents.map(f.to),g.to(V.range))}ve.to=ae})(ie=e.Hover||(e.Hover={}));var re;(function(ve){function De(V){return{range:g.from(V.range),expression:V.expression}}ve.from=De;function ae(V){return new s.EvaluatableExpression(g.to(V.range),V.expression)}ve.to=ae})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ve){function De(V){if(V instanceof s.InlineValueText)return{type:"text",range:g.from(V.range),text:V.text};if(V instanceof s.InlineValueVariableLookup)return{type:"variable",range:g.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=De;function ae(V){switch(V.type){case"text":return{range:g.to(V.range),text:V.text};case"variable":return{range:g.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:g.to(V.range),expression:V.expression}}}ve.to=ae})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(ve){function De(V){return{frameId:V.frameId,stoppedLocation:g.from(V.stoppedLocation)}}ve.from=De;function ae(V){return new s.InlineValueContext(V.frameId,g.to(V.stoppedLocation))}ve.to=ae})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Ue;(function(ve){function De(V){return{range:g.from(V.range),kind:V.kind}}ve.from=De;function ae(V){return new s.DocumentHighlight(g.to(V.range),V.kind)}ve.to=ae})(Ue=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(ve){function De(ae){switch(ae){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ve.to=De})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ve){function De(ae){return{triggerKind:Re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ve.to=De})(ze=e.CompletionContext||(e.CompletionContext={}));var N;(function(ve){function De(V){switch(V){case s.CompletionItemTag.Deprecated:return 1}}ve.from=De;function ae(V){switch(V){case 1:return s.CompletionItemTag.Deprecated}}ve.to=ae})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ve){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ae(Ae){var et;return(et=De.get(Ae))!==null&&et!==void 0?et:9}ve.from=ae;const V=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ae){var et;return(et=V.get(Ae))!==null&&et!==void 0?et:s.CompletionItemKind.Property}ve.to=Me})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ve){function De(ae,V){var Me;const Ae=new s.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Ae.label2=ae.label),Ae.insertText=ae.insertText,Ae.kind=G.to(ae.kind),Ae.tags=(Me=ae.tags)===null||Me===void 0?void 0:Me.map(N.to),Ae.detail=ae.detail,Ae.documentation=R.isMarkdownString(ae.documentation)?f.to(ae.documentation):ae.documentation,Ae.sortText=ae.sortText,Ae.filterText=ae.filterText,Ae.preselect=ae.preselect,Ae.commitCharacters=ae.commitCharacters,n.Range.isIRange(ae.range)?Ae.range=g.to(ae.range):typeof ae.range=="object"&&(Ae.range={inserting:g.to(ae.range.insert),replacing:g.to(ae.range.replace)}),Ae.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ae.insertText=new s.SnippetString(ae.insertText):(Ae.insertText=ae.insertText,Ae.textEdit=Ae.range instanceof s.Range?new s.TextEdit(Ae.range,Ae.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ae.additionalTextEdits.map(et=>z.to(et))),Ae.command=V&&ae.command?V.fromInternal(ae.command):void 0,Ae}ve.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var oe;(function(ve){function De(V){return{label:V.label,documentation:V.documentation?f.fromStrict(V.documentation):void 0}}ve.from=De;function ae(V){return{label:V.label,documentation:R.isMarkdownString(V.documentation)?f.to(V.documentation):V.documentation}}ve.to=ae})(oe=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ve){function De(V){return{label:V.label,documentation:V.documentation?f.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(oe.from):[],activeParameter:V.activeParameter}}ve.from=De;function ae(V){return{label:V.label,documentation:R.isMarkdownString(V.documentation)?f.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(oe.to):[],activeParameter:V.activeParameter}}ve.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(ve){function De(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(fe.from):[]}}ve.from=De;function ae(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(fe.to):[]}}ve.to=ae})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(ve){function De(V){var Me;return{text:V.text,range:g.from(V.range),kind:me.from((Me=V.kind)!==null&&Me!==void 0?Me:s.InlineHintKind.Other),description:V.description&&f.fromStrict(V.description),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}ve.from=De;function ae(V){const Me=new s.InlineHint(V.text,g.to(V.range),me.to(V.kind));return Me.whitespaceAfter=V.whitespaceAfter,Me.whitespaceBefore=V.whitespaceBefore,Me.description=R.isMarkdownString(V.description)?f.to(V.description):V.description,Me}ve.to=ae})(Le=e.InlineHint||(e.InlineHint={}));var me;(function(ve){function De(V){return V}ve.from=De;function ae(V){return V}ve.to=ae})(me=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ve){function De(V){return{range:g.from(V.range),url:V.target,tooltip:V.tooltip}}ve.from=De;function ae(V){let Me;if(V.url)try{Me=typeof V.url=="string"?E.URI.parse(V.url,!0):E.URI.revive(V.url)}catch(Ae){}return new s.DocumentLink(g.to(V.range),Me)}ve.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(ve){function De(V){const Me=new s.ColorPresentation(V.label);return V.textEdit&&(Me.textEdit=z.to(V.textEdit)),V.additionalTextEdits&&(Me.additionalTextEdits=V.additionalTextEdits.map(Ae=>z.to(Ae))),Me}ve.to=De;function ae(V){return{label:V.label,textEdit:V.textEdit?z.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Me=>z.from(Me)):void 0}}ve.from=ae})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(ve){function De(V){return new s.Color(V[0],V[1],V[2],V[3])}ve.to=De;function ae(V){return[V.red,V.green,V.blue,V.alpha]}ve.from=ae})(xe=e.Color||(e.Color={}));var _e;(function(ve){function De(V){return{range:g.from(V.range)}}ve.from=De;function ae(V){return new s.SelectionRange(g.to(V.range))}ve.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ve){function De(ae){switch(ae){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ve.to=De})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(ve){function De(V){switch(V){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=De;function ae(V){switch(V){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ve.to=ae})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Y;(function(ve){function De(V){if(V===s.EndOfLine.CRLF)return 1;if(V===s.EndOfLine.LF)return 0}ve.from=De;function ae(V){if(V===1)return s.EndOfLine.CRLF;if(V===0)return s.EndOfLine.LF}ve.to=ae})(Y=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ve){function De(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=De})(pe=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ve){function De(ae){const V={start:ae.start+1,end:ae.end+1};return ae.kind&&(V.kind=He.from(ae.kind)),V}ve.from=De})(Fe=e.FoldingRange||(e.FoldingRange={}));var He;(function(ve){function De(ae){if(ae)switch(ae){case s.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}ve.from=De})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(ve){function De(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?g.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ve.from=De})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var tt;(function(ve){function De(V){return V instanceof s.RelativePattern||typeof V=="string"?V:ae(V)?new s.RelativePattern(V.base,V.pattern):V}ve.from=De;function ae(V){const Me=V;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(tt=e.GlobPattern||(e.GlobPattern={}));var W;(function(ve){function De(ae){if(ae){if(Array.isArray(ae))return ae.map(De);if(typeof ae=="string")return ae;{const V=ae;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:tt.from(V.pattern),exclusive:V.exclusive}}}else return}ve.from=De})(W=e.LanguageSelector||(e.LanguageSelector={}));var te;(function(ve){function De(V){return{start:V.start,end:V.end}}ve.from=De;function ae(V){return new s.NotebookCellRange(V.start,V.end)}ve.to=ae})(te=e.NotebookCellRange||(e.NotebookCellRange={}));var de;(function(ve){function De(ae){return new s.NotebookCellMetadata(ae.editable,ae.breakpointMargin,ae.hasExecutionOrder,ae.statusMessage,ae.inputCollapsed,ae.outputCollapsed,ae.custom)}ve.to=De})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ve){function De(V){return V}ve.from=De;function ae(V){return new s.NotebookDocumentMetadata(V.editable,V.cellEditable,V.cellHasExecutionOrder,V.custom,V.trusted)}ve.to=ae})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var J;(function(ve){function De(V){return{duration:V.lastRunDuration,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ve.to=De;function ae(V){return{lastRunSuccess:V.success,lastRunDuration:V.duration,executionOrder:V.executionOrder}}ve.from=ae})(J=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var se;(function(ve){function De(V){switch(V){case s.NotebookCellKind.Markdown:return m.CellKind.Markdown;case s.NotebookCellKind.Code:default:return m.CellKind.Code}}ve.from=De;function ae(V){switch(V){case m.CellKind.Markdown:return s.NotebookCellKind.Markdown;case m.CellKind.Code:default:return s.NotebookCellKind.Code}}ve.to=ae})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(ve){function De(V){var Me;return{cellKind:se.from(V.kind),language:V.language,source:V.source,metadata:Object.assign(Object.assign({},V.metadata),J.from((Me=V.latestExecutionSummary)!==null&&Me!==void 0?Me:{})),outputs:V.outputs?V.outputs.map(We.from):[]}}ve.from=De;function ae(V){return new s.NotebookCellData(se.to(V.cellKind),V.source,V.language,V.outputs?V.outputs.map(We.to):void 0,V.metadata?de.to(V.metadata):void 0)}ve.to=ae})(he=e.NotebookCellData||(e.NotebookCellData={}));var ge;(function(ve){function De(V){return{mime:V.mime,value:V.value,metadata:V.metadata}}ve.from=De;function ae(V){return new s.NotebookCellOutputItem(V.mime,V.value,V.metadata)}ve.to=ae})(ge=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(ve){function De(V){return{outputId:V.id,outputs:V.outputs.map(ge.from),metadata:V.metadata}}ve.from=De;function ae(V){const Me=V.outputs.map(ge.to);return new s.NotebookCellOutput(Me,V.outputId,V.metadata)}ve.to=ae})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(ve){function De(Ae){if(Ae!=null){if(Ae instanceof s.RelativePattern||typeof Ae=="string")return Ae;if(Me(Ae))return new s.RelativePattern(Ae.base,Ae.pattern);if(V(Ae))return{include:tt.from(Ae.include)||void 0,exclude:tt.from(Ae.exclude)||void 0}}}ve.from=De;function ae(Ae){return typeof Ae=="string"?Ae:Me(Ae)?{base:Ae.base,pattern:Ae.pattern}:{include:Ae.include,exclude:Ae.exclude}}ve.to=ae;function V(Ae){const et=Ae,Qe=tt.from(et.include);if(!(Qe&&Qe instanceof s.RelativePattern||typeof Qe=="string"))return!1;const at=tt.from(et.exclude);return!!(at&&at instanceof s.RelativePattern||typeof at=="string")}function Me(Ae){const et=Ae;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var je;(function(ve){function De(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?h.from(ae.top):void 0}}ve.from=De})(je=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ye;(function(ve){function De(ae){var V;return{transientOutputs:ae?ae.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(V=ae==null?void 0:ae.transientMetadata)!==null&&V!==void 0?V:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ve.from=De})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ve){function De(V){return{state:V.state,duration:V.duration,messages:V.messages.map(ct.from)}}ve.from=De;function ae(V){const Me=new s.TestState(V.state);return Me.duration=V.duration,Me.messages=V.messages.map(ct.to),Me}ve.to=ae})(Ze=e.TestState||(e.TestState={}));var ct;(function(ve){function De(V){return{message:f.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?$.from(V.location):void 0}}ve.from=De;function ae(V){const Me=new s.TestMessage(typeof V.message=="string"?V.message:f.to(V.message));return Me.severity=V.severity,Me.actualOutput=V.actualOutput,Me.expectedOutput=V.expectedOutput,Me}ve.to=ae})(ct=e.TestMessage||(e.TestMessage={}));var lt;(function(ve){function De(Ae){var et,Qe;return{extId:Ae.id,label:Ae.label,uri:Ae.uri,range:g.from(Ae.range),debuggable:(et=Ae.debuggable)!==null&&et!==void 0?et:!1,description:Ae.description,runnable:(Qe=Ae.runnable)!==null&&Qe!==void 0?Qe:!0,expandable:Ae.expandable}}ve.from=De;function ae(Ae){return{extId:Ae.id,label:Ae.label,uri:Ae.uri,range:g.from(Ae.range),debuggable:!1,description:Ae.description,runnable:!0,expandable:!0}}ve.fromResultSnapshot=ae;function V(Ae){return{id:Ae.extId,label:Ae.label,uri:E.URI.revive(Ae.uri),range:g.to(Ae.range),expandable:Ae.expandable,debuggable:Ae.debuggable,description:Ae.description,runnable:Ae.runnable}}ve.toPlain=V;function Me(Ae){const et=new s.TestItem(Ae.extId,Ae.label,E.URI.revive(Ae.uri),Ae.expandable);return et.range=g.to(Ae.range),et.debuggable=Ae.debuggable,et.description=Ae.description,et.runnable=Ae.runnable,et}ve.to=Me})(lt=e.TestItem||(e.TestItem={}));var it;(function(ve){function De(Me,Ae){var et,Qe,at;const rt={completedAt:Ae.completedAt,id:Me,items:[]},Xe=[[null,Ae.results]];for(;Xe.length;){const[st,vt]=Xe.pop();for(const mt of vt){const Dt={children:(Qe=(et=mt.children)===null||et===void 0?void 0:et.map(_t=>_t.id))!==null&&Qe!==void 0?Qe:[],computedState:mt.result.state,item:lt.fromResultSnapshot(mt),state:Ze.from(mt.result),retired:void 0,expand:3,parent:(at=st==null?void 0:st.item.extId)!==null&&at!==void 0?at:null,src:{provider:"",tree:-1},direct:!st};rt.items.push(Dt),mt.children&&Xe.push([Dt,mt.children])}}return rt}ve.from=De;const ae=(Me,Ae)=>Object.assign(Object.assign({},lt.toPlain(Me.item)),{result:Ze.to(Me.state),children:Me.children.map(et=>Ae.get(et)).filter(k.isDefined).map(et=>ae(et,Ae))});function V(Me){const Ae=[],et=new Map;for(const Qe of Me.items)et.set(Qe.item.extId,Qe),Qe.direct&&Ae.push(Qe);return{completedAt:Me.completedAt,results:Ae.map(Qe=>ae(Qe,et))}}ve.to=V})(it=e.TestResults||(e.TestResults={}));var Ve;(function(ve){function De(ae){switch(ae){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ve.to=De})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[172],we([0,1,2,10,7,9,45]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(n,A,C,b={timeout:1500,errors:3}){this._logService=n,this._documents=A,this._mainThreadBulkEdits=C,this._thresholds=b,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(A,C,b)=>{const r={dispose:this._callbacks.push([A,C,n])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(n,A){const C=y.URI.revive(n);let b=!1;const m=setTimeout(()=>b=!0,this._thresholds.timeout),r=[];try{for(let s of[...this._callbacks]){if(b)break;const _=this._documents.getDocument(C),g=await this._deliverEventAsyncAndBlameBadListeners(s,{document:_,reason:P.TextDocumentSaveReason.to(A)});r.push(g)}}finally{clearTimeout(m)}return r}_deliverEventAsyncAndBlameBadListeners([n,A,C],b){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,A,b).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,A,C,b){const m=[],r=Date.now(),{document:s,reason:_}=b,{version:g}=s,w=Object.freeze({document:s,reason:_,waitUntil(c){if(Object.isFrozen(m))throw(0,R.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{A.apply(C,[w])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,d)=>{const o=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),c(t)}).catch(t=>{clearTimeout(o),d(t)})}).then(c=>{const d={edits:[]};for(const o of c)if(Array.isArray(o)&&o.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:i,range:u}of o)d.edits.push({_type:2,resource:s.uri,edit:{range:u&&P.Range.from(u),text:t,eol:i&&P.EndOfLine.from(i)}});if(d.edits.length!==0)return g===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[173],we([0,1,3,13,28,2,9,7]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(C,b,m,r,s){this._onDidCreate=new y.Emitter,this._onDidChange=new y.Emitter,this._onDidDelete=new y.Emitter,this._config=0,m&&(this._config+=1),r&&(this._config+=2),s&&(this._config+=4);const _=(0,T.parse)(b),g=C(w=>{if(!m)for(let c of w.created){const d=P.URI.revive(c);_(d.fsPath)&&this._onDidCreate.fire(d)}if(!r)for(let c of w.changed){const d=P.URI.revive(c);_(d.fsPath)&&this._onDidChange.fire(d)}if(!s)for(let c of w.deleted){const d=P.URI.revive(c);_(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,b,m){this._logService=b,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new y.Emitter,this._onDidRenameFile=new y.Emitter,this._onDidCreateFile=new y.Emitter,this._onDidDeleteFile=new y.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,b,m,r){return new E(this._onFileSystemEvent.event,C,b,m,r)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,b){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(m=>P.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(m=>P.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,b){return(m,r,s)=>{const _=function(w){m.call(r,w)};return _.extension=C,b.event(_,void 0,s)}}async $onWillRunFileOperation(C,b,m,r){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))},m,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(s=>P.URI.revive(s.target))},m,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(s=>P.URI.revive(s.target))},m,r)}}async _fireWillEvent(C,b,m,r){const s=new Set,_=[];if(await C.fireAsync(b,r,async(w,c)=>{var d;const o=Date.now(),t=await Promise.resolve(w);t instanceof k.WorkspaceEdit&&(_.push(t),s.add((d=c.extension.displayName)!==null&&d!==void 0?d:c.extension.identifier.value)),Date.now()-o>m&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!r.isCancellationRequested&&_.length!==0){const g={edits:[]};for(let w of _){let{edits:c}=S.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(c)}return{edit:g,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(be[174],we([0,1,3,6,16,23,2,9,7,70]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(r,s,_,g){this.start=r,this.deletedCount=s,this.deletedItems=_,this.items=g}static asApiEvents(r){return r.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(_=>_.cell)}))}}class C{constructor(r,s,_){var g;this._notebook=r,this._extHostDocument=s,this._cellData=_,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=_.handle,this.uri=S.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=(g=_.metadata)!==null&&g!==void 0?g:{},this._metadata=k.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=k.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(r,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:r}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const r=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return r._notebook.getCellIndex(r)},notebook:r._notebook.notebookDocument,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get latestExecutionSummary(){return r._previousResult}})}return this._cell}setOutputs(r){this._outputs=r.map(k.NotebookCellOutput.to)}setOutputItems(r,s,_){const g=_.map(k.NotebookCellOutputItem.to),w=this._outputs.find(c=>c.id===r);w&&(s||(w.outputs.length=0),w.outputs.push(...g))}setMetadata(r){this._internalMetadata=r,this._metadata=k.NotebookCellMetadata.to(r),this._previousResult=k.NotebookCellPreviousExecutionResult.to(r)}}e.ExtHostCell=C;class b extends R.Disposable{constructor(r,s,_,g,w,c,d){super();this._proxy=r,this._textDocumentsAndEditors=s,this._textDocuments=_,this._emitter=g,this._viewType=w,this._metadata=c,this.uri=d,this.handle=b._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,R.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const r=this;this._notebook=Object.freeze({get uri(){return r.uri},get version(){return r._versionId},get fileName(){return r.uri.fsPath},get viewType(){return r._viewType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===T.Schemas.untitled},get cells(){return r._cells.map(s=>s.cell)},get metadata(){return r._metadata},set metadata(s){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return r._save()}})}return this._notebook}updateBackup(r){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=r}disposeBackup(){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=this._metadata.with(r.metadata))}acceptModelChanged(r,s){this._versionId=r.versionId,this._isDirty=s;for(const _ of r.rawEvents)_.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(_.changes,!0),_.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(_.changes,!1):_.kind===n.NotebookCellsChangeType.Move?this._moveCell(_.index,_.newIdx):_.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(_.index,_.outputs):_.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(_.index,_.outputId,_.append,_.outputItems):_.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(_.index,_.language):_.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(_.index,_.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(r,s){if(!this._disposed){const _=[],g=[],w=[];r.reverse().forEach(c=>{var d;const t=c[2].map(a=>{const l=new C(this,this._textDocumentsAndEditors,a);if(s||g.push(C.asModelAddData(this.notebookDocument,a)),!this._cellDisposableMapping.has(l.handle)){const f=new R.DisposableStore;f.add(l),this._cellDisposableMapping.set(l.handle,f)}return l});for(let a=c[0];a<c[0]+c[1];a++)(d=this._cellDisposableMapping.get(this._cells[a].handle))===null||d===void 0||d.dispose(),this._cellDisposableMapping.delete(this._cells[a].handle);const i=new A(c[0],c[1],[],t),u=this._cells.splice(c[0],c[1],...t);for(let a of u)w.push(a.uri),i.deletedItems.push(a.cell);_.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:w}),s||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:A.asApiEvents(_)}))}}_moveCell(r,s){const _=this._cells.splice(r,1);this._cells.splice(s,0,..._);const g=[new A(r,1,_.map(w=>w.cell),[]),new A(s,0,[],_)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:A.asApiEvents(g)}))}_setCellOutputs(r,s){const _=this._cells[r];_.setOutputs(s),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_setCellOutputItems(r,s,_,g){const w=this._cells[r];w.setOutputItems(s,_,g),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[w.cell]}))}_changeCellLanguage(r,s){const _=this._cells[r];_.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(_.uri,s)}_changeCellMetadata(r,s){var _;const g=this._cells[r],w=g.internalMetadata,c=g.cell.metadata;g.setMetadata(s);const d=g.cell.metadata;if((0,P.equals)(c,d)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:g.cell})),w.runState!==s.runState){const o=(_=s.runState)!==null&&_!==void 0?_:E.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.notebookDocument,cell:g.cell,executionState:o}))}}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(s=>s.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=b,b._handlePool=0}),define(be[175],we([0,1,3,7,9]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:E,metadata:n})}replaceCellOutput(E,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:E,outputs:n.map(A=>T.NotebookCellOutput.from(A))})}replaceCells(E,n,A){this._throwIfFinalized(),!(E===n&&A.length===0)&&this._collectedEdits.push({editType:1,index:E,count:n-E,cells:A.map(T.NotebookCellData.from)})}}class S{constructor(E,n,A,C,b,m,r){this.id=E,this._viewType=n,this._proxy=A,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=m,this._visibleRanges=b,this._viewColumn=r}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.notebookDocument},get selection(){var n;const A=E._selections[0];return A&&((n=E.notebookData.getCellFromIndex(A.start))===null||n===void 0?void 0:n.cell)},get selections(){return E._selections},get visibleRanges(){return E._visibleRanges},revealRange(n,A){E._proxy.$tryRevealRange(E.id,T.NotebookCellRange.from(n),A!=null?A:R.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},get onDidDispose(){return E.onDidDispose},edit(n){const A=new P(this.document.version);return n(A),E._applyEdit(A.finalize())},get kernel(){return E._kernel},setDecorations(n,A){return E.setDecorations(n,A)}}}return this._editor}_acceptKernel(E){this._kernel=E}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const n=[];let A=-1;for(let C=0;C<E.cellEdits.length;C++){if(A<0){n.push(E.cellEdits[C]),A++;continue}const m=n[A],r=E.cellEdits[C];if(m.editType===1&&r.editType===1&&m.index===r.index){m.cells.push(...E.cellEdits[C].cells),m.count+=E.cellEdits[C].count;continue}n.push(E.cellEdits[C]),A++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,E.documentVersionId,n)}setDecorations(E,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return n.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(n),E.key)}}e.ExtHostNotebookEditor=S}),define(be[176],we([0,1,9,150,131,20,51]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,b,m){const r=this._handles++,{title:s,location:_,cancellable:g}=b,w={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(r,{location:y.ProgressLocation.from(_),title:s,source:w,cancellable:g},C),this._withProgress(r,m,!!g)}_withProgress(C,b,m){let r;m&&(r=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,r));const s=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),r&&r.dispose()};let _;try{_=b(new n(this._proxy,C),m&&r?r.token:P.CancellationToken.None)}catch(g){throw s(C),g}return _.then(g=>s(C),g=>s(C)),_}$acceptProgressCanceled(C){const b=this._mapHandleToCancellationSource.get(C);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function E(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class n extends R.Progress{constructor(C,b){super(m=>this.throttledReport(m));this._proxy=C,this._handle=b}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}qe([(0,S.throttle)(100,(A,C)=>E(A,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(be[96],we([0,1,43,10,53,9,7]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(b,m){const r=k._Keys.nextId();b.$registerTextEditorDecorationType(r,P.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:r,dispose(){b.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class E{constructor(b,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,m){this._throwIfFinalized();let r=null;if(b instanceof S.Position)r=new S.Range(b,b);else if(b instanceof S.Range)r=b;else throw new Error("Unrecognized location");this._pushEdit(r,m,!1)}insert(b,m){this._throwIfFinalized(),this._pushEdit(new S.Range(b,b),m,!0)}delete(b){this._throwIfFinalized();let m=null;if(b instanceof S.Range)m=b;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(b,m,r){const s=this._document.validateRange(b);this._collectedEdits.push({range:s,text:m,forceMoveMarkers:r})}setEndOfLine(b){if(this._throwIfFinalized(),b!==S.EndOfLine.LF&&b!==S.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=E;class n{constructor(b,m,r,s){this._proxy=b,this._id=m,this._accept(r),this._logService=s;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(g){_._setTabSize(g)},get insertSpaces(){return _._insertSpaces},set insertSpaces(g){_._setInsertSpaces(g)},get cursorStyle(){return _._cursorStyle},set cursorStyle(g){_._setCursorStyle(g)},get lineNumbers(){return _._lineNumbers},set lineNumbers(g){_._setLineNumbers(g)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const m=Math.floor(b);return m>0?m:null}if(typeof b=="string"){const m=parseInt(b,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(b){const m=this._validateTabSize(b);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const m=this._validateInsertSpaces(b);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const m={};let r=!1;if(typeof b.tabSize!="undefined"){const s=this._validateTabSize(b.tabSize);s==="auto"?(r=!0,m.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,r=!0,m.tabSize=s)}if(typeof b.insertSpaces!="undefined"){const s=this._validateInsertSpaces(b.insertSpaces);s==="auto"?(r=!0,m.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,r=!0,m.insertSpaces=s)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,r=!0,m.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,r=!0,m.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(b){b.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class A{constructor(b,m,r,s,_,g,w,c){this.id=b,this._proxy=m,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new n(this._proxy,this.id,g,r),this._visibleRanges=w,this._viewColumn=c;const d=this;this.value=Object.freeze({get document(){return s.getValue()},set document(o){throw(0,R.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(o){if(!(o instanceof S.Selection))throw(0,R.illegalArgument)("selection");d._selections=[o],d._trySetSelection()},get selections(){return d._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof S.Selection)))throw(0,R.illegalArgument)("selections");d._selections=o,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(o){throw(0,R.readonly)("visibleRanges")},get options(){return d._options.value},set options(o){d._disposed||d._options.assign(o)},get viewColumn(){return d._viewColumn},set viewColumn(o){throw(0,R.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new E(s.getValue(),t);return o(i),d._applyEdit(i)},insertSnippet(o,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=d._selections.map(a=>P.Range.from(a));else if(t instanceof S.Position){const{lineNumber:a,column:l}=P.Position.from(t);u=[{startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l}]}else if(t instanceof S.Range)u=[P.Range.from(t)];else{u=[];for(const a of t)if(a instanceof S.Range)u.push(P.Range.from(a));else{const{lineNumber:l,column:f}=P.Position.from(a);u.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return m.$tryInsertSnippet(b,o.value,u,i)},setDecorations(o,t){const i=t.length===0;i&&!d._hasDecorationsForKey.has(o.key)||(i?d._hasDecorationsForKey.delete(o.key):d._hasDecorationsForKey.add(o.key),d._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return m.$trySetDecorations(b,o.key,P.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let a=0,l=t.length;a<l;a++){const f=t[a];u[4*a]=f.start.line+1,u[4*a+1]=f.start.character+1,u[4*a+2]=f.end.line+1,u[4*a+3]=f.end.character+1}return m.$trySetDecorationsFast(b,o.key,u)}}))},revealRange(o,t){d._runOnProxy(()=>m.$tryRevealRange(b,P.Range.from(o),t||S.TextEditorRevealType.Default))},show(o){m.$tryShowEditor(b,P.ViewColumn.from(o))},hide(){m.$tryHideEditor(b)}})}dispose(){(0,y.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,y.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,y.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,y.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,y.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const m=b.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const r=m.edits.map(_=>_.range);r.sort((_,g)=>_.end.line===g.end.line?_.end.character===g.end.character?_.start.line===g.start.line?_.start.character-g.start.character:_.start.line-g.start.line:_.end.character-g.end.character:_.end.line-g.end.line);for(let _=0,g=r.length-1;_<g;_++){const w=r[_].end;if(r[_+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=m.edits.map(_=>({range:P.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,s,{setEndOfLine:typeof m.setEndOfLine=="number"?P.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=A}),define(be[177],we([0,1,134,24,2,3,6,13,7,12,15,9,20]),function(le,e,y,R,T,P,S,k,E,n,A,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(_,g){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let w;return Array.isArray(_.highlights)&&(w=_.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),w=w.length?w:void 0),{label:_.label,highlights:w}}}class r{constructor(g,w,c){this._proxy=g,this.commands=w,this.logService=c,this.treeViews=new Map;function d(o){return o&&o.$treeViewId&&o.$treeItemHandle}w.registerArgumentProcessor({processArgument:o=>d(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>d(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(g,w,c){const d=this.createTreeView(g,{treeDataProvider:w},c);return{dispose:()=>d.dispose()}}createTreeView(g,w,c){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany}),o=this.createExtHostTreeView(g,w,c);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,i)=>o.reveal(t,i),dispose:async()=>{await d,this.treeViews.delete(g),o.dispose()}}}$getChildren(g,w){const c=this.treeViews.get(g);return c?c.getChildren(w):Promise.reject(new Error((0,y.localize)(0,null,g)))}async $hasResolve(g){const w=this.treeViews.get(g);if(!w)throw new Error((0,y.localize)(1,null,g));return w.hasResolve}$resolve(g,w,c){const d=this.treeViews.get(g);if(!d)throw new Error((0,y.localize)(2,null,g));return d.resolveTreeItem(w,c)}$setExpanded(g,w,c){const d=this.treeViews.get(g);if(!d)throw new Error((0,y.localize)(3,null,g));d.setExpanded(w,c)}$setSelection(g,w){const c=this.treeViews.get(g);if(!c)throw new Error((0,y.localize)(4,null,g));c.setSelection(w)}$setVisible(g,w){const c=this.treeViews.get(g);if(!c)throw new Error((0,y.localize)(5,null,g));c.setVisible(w)}createExtHostTreeView(g,w,c){const d=new s(g,w,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(g,d),d}convertArgument(g){const w=this.treeViews.get(g.$treeViewId);return w?w.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=r;class s extends S.Disposable{constructor(g,w,c,d,o,t){super();if(this.viewId=g,this.proxy=c,this.commands=d,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const l of t.contributes.views[a])l.id===g&&(this._title=l.name);this.dataProvider=w.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let i,u;this._register(P.Event.debounce(this._onDidChangeData.event,(a,l)=>(a||(a={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(f=>u=f),this.refreshPromise=this.refreshPromise.then(()=>i)),a.elements.push(l.element)),l.message&&(a.message=!0),a),200,!0)(({message:a,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=u;return i=null,this.refresh(l).then(()=>f())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,n.isUndefinedOrNull)(g))}getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(g);return(c?Promise.resolve(c):this.fetchChildrenNodes(w)).then(d=>d.map(o=>o.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const c=(0,n.isUndefinedOrNull)(w.select)?!0:w.select,d=(0,n.isUndefinedOrNull)(w.focus)?!1:w.focus,o=(0,n.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(u=>u.item)},{select:c,focus:d,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:d,expand:o})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,w){const c=this.getExtensionElement(g);c&&(w?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(g){(0,A.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,w){var c;if(!!this.dataProvider.resolveTreeItem){const d=this.elements.get(g);if(d){const o=this.nodes.get(d);if(o){const t=(c=await this.dataProvider.resolveTreeItem(o.extensionItem,d,w))!==null&&c!==void 0?c:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(w=>w?this.resolveUnknownParentChain(w).then(c=>this.resolveTreeNode(w,c[c.length-1]).then(d=>(c.push(d),c))):Promise.resolve([]))}resolveParent(g){const w=this.nodes.get(g);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,w){const c=this.nodes.get(g);return c?Promise.resolve(c):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(d=>this.createHandle(g,d,w,!0)).then(d=>this.getChildren(w?w.item.handle:void 0).then(()=>{const o=this.getExtensionElement(d);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(g){if(g){let w;if(typeof g=="string"){const c=this.getExtensionElement(g);w=c?this.nodes.get(c):void 0}else w=g;return w&&w.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const w=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=g?this.nodes.get(g):void 0,d=await this.dataProvider.getChildren(g);if(w.token.isCancellationRequested)return[];const o=await Promise.all((0,A.coalesce)(d||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,c):null}));return w.token.isCancellationRequested?[]:(0,A.coalesce)(o)}finally{w.dispose()}}refresh(g){if(g.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(g);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const w=new Set;for(const d of g){const o=this.nodes.get(d);if(o&&!w.has(o.item.handle)){let t=o;for(;t&&t.parent&&!w.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(o.item.handle)}}const c=[];return w.forEach(d=>{const o=this.elements.get(d);if(o){const t=this.nodes.get(o);t&&(!t.parent||!w.has(t.parent.item.handle))&&c.push(d)}}),c}refreshHandles(g){const w={};return Promise.all(g.map(c=>this.refreshNode(c).then(d=>{d&&(w[c]=d.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(g){const w=this.getExtensionElement(g);if(w){const c=this.nodes.get(w);if(c)return this.clearChildren(w),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(d=>{if(d){const o=this.createTreeNode(w,d,c.parent);return this.updateNodeCache(w,o,c,c.parent),c.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,w,c){const d=this.createTreeNode(g,w,c);if(w.id&&this.elements.has(d.item.handle))throw new Error((0,y.localize)(6,null,w.id));return this.addNodeToCache(g,d),this.addNodeToParentCache(d,c),d}getTooltip(g){return E.MarkdownString.isMarkdownString(g)?C.MarkdownString.from(g):g}getCommand(g,w){return w?this.commands.toInternal(w,g):void 0}createTreeNode(g,w,c){const d=new S.DisposableStore,o=this.createHandle(g,w,c),t=this.getLightIconPath(w);return{item:{handle:o,parentHandle:c?c.item.handle:void 0,label:m(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(d,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,n.isUndefinedOrNull)(w.collapsibleState)?E.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:c,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(g){return g.iconPath instanceof E.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:w,label:c,resourceUri:d},o,t){if(w)return`${s.ID_HANDLE_PREFIX}/${w}`;const i=m(c,this.extension),u=o?o.item.handle:s.LABEL_HANDLE_PREFIX;let a=i?i.label:d?(0,R.basename)(d):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const l=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,f=this.getChildrenNodes(o)||[];let v,D=0;do{if(v=`${u}/${D}:${a}`,t||!this.elements.has(v)||l===v)break;D++}while(D<=f.length);return v}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof E.ThemeIcon))return typeof g.iconPath=="string"||T.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof E.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return T.URI.isUri(g)?g:T.URI.file(g)}addNodeToCache(g,w){this.elements.set(w.item.handle,g),this.nodes.set(g,w)}updateNodeCache(g,w,c,d){this.elements.delete(w.item.handle),this.nodes.delete(g),w.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(g,w);const o=this.getChildrenNodes(d)||[],t=o.filter(i=>i.item.handle===c.item.handle)[0];t&&o.splice(o.indexOf(t),1,w)}addNodeToParentCache(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const w=this.nodes.get(g);if(w){if(w.children)for(const c of w.children){const d=this.elements.get(c.item.handle);d&&this.clear(d)}w.children=void 0}}else this.clearAll()}clear(g){const w=this.nodes.get(g);if(w){if(w.children)for(const c of w.children){const d=this.elements.get(c.item.handle);d&&this.clear(d)}this.nodes.delete(g),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(be[178],we([0,1,15,13,20,9,7,95]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class E{constructor(){this.testIdsToInternal=new Map}getTestById(r,s){if(s!==void 0){const _=this.testIdsToInternal.get(s),g=_==null?void 0:_.get(r);if(g)return[_,g]}return(0,y.mapFind)(this.testIdsToInternal.values(),_=>{const g=_.get(r);return g&&[_,g]})}createForHierarchy(r=()=>{}){return new b(this.createIdMap(A++),r)}createIdMap(r){const s=new C(r);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=E;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let A=0;class C{constructor(r){this.id=r,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(r){if(this.map.has(r.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${r.item.extId}`);this.map.set(r.item.extId,r),r.parent||this._roots.add(r)}has(r){return this.map.has(r)}delete(r){const s=this.map.get(r);return s?(this.map.delete(r),this._roots.delete(s),!0):!1}get(r){return this.map.get(r)}comparePositions(r,s){const _=typeof r=="string"?this.map.get(r):r,g=typeof s=="string"?this.map.get(s):s;if(!_||!g)return 0;if(_===g)return 3;for(let w=this.map.get(g.parent);w;w=this.map.get(w.parent))if(w===_)return 1;for(let w=this.map.get(_.parent);w;w=this.map.get(w.parent))if(w===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class b{constructor(r,s){this.testIdToInternal=r,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(r,s){this.addItem(r,s,null)}getTestByReference(r){return this.testItemToInternal.get(r)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const s=this.diff[this.diff.length-1];if(s&&r[0]===1){if(s[0]===1&&s[1].extId===r[1].extId){(0,k.applyTestItemUpdate)(s[1],r[1]);return}if(s[0]===0&&s[1].item.extId===r[1].extId){(0,k.applyTestItemUpdate)(s[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,s){var _;const g=this.testIdToInternal.object.get(r);if(!!g){if((g.expandLevels===void 0||s>g.expandLevels)&&(g.expandLevels=s),g.expand===1){const w=this.refreshChildren(g);return w.isSettled?this.expandChildren(g,s-1):w.p.then(()=>this.expandChildren(g,s-1))}else if(g.expand===3)return((_=g.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,s-1)):this.expandChildren(g,s-1)}}dispose(){var r;for(const s of this.testItemToInternal.values())(r=s.discoverCts)===null||r===void 0||r.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(r,s,_){if(!(r instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);if(this.testItemToInternal.has(r))throw new Error(`Attempted to add a single TestItem ${r.id} multiple times to the tree`);if(this.testIdToInternal.object.has(r.id))throw new Error(`Attempted to insert a duplicate test item ID ${r.id}`);const g=_?_.item.extId:null,w=r.expandable?1:0,c=_==null?void 0:_.expandLevels,d={provider:s,tree:this.testIdToInternal.object.id},o={actual:r,parent:g,item:P.TestItem.from(r),expandLevels:c&&w===1?c-1:void 0,expand:w,src:d};this.testIdToInternal.object.add(o),this.testItemToInternal.set(r,o),this.pushDiff([0,{parent:g,src:d,expand:w,item:o.item}]),r[S.TestItemHookProperty]={created:t=>this.addItem(t,s,o),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:r.id,item:{[t]:t==="range"?P.Range.from(i):i}}])};for(const t of r.children)this.addItem(t,s,o)}expandChildren(r,s){if(!(s<0)){const _=[...r.actual.children].map(g=>this.expand(g.id,s-1)).filter(R.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(r){r.discoverCts&&r.discoverCts.dispose(!0),r.expand=2,r.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(r);const s=new R.DeferredPromise;return r.initialExpand=s,r.actual.discoverChildren({report:_=>{_.busy?(r.expand=2,this.pushExpandStateUpdate(r)):(r.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(r))}},r.discoverCts.token),s}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.actual.id,expand:r.expand}])}removeItembyId(r){var s;this.pushDiff([2,r]);const _=[this.testIdToInternal.object.get(r)];for(;_.length;){const g=_.pop();if(!!g){(s=g.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const w of g.actual.children)_.push(this.testIdToInternal.object.get(w.id))}}}flushDiff(){const r=this.collectDiff();r.length&&this.publishDiff(r)}}e.SingleUseTestCollection=b}),define(be[179],we([0,1,25,3,11]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class S{constructor(A){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(y.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(y.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let C of A.activationEvents)C==="onUri"&&(C=`onUri:${y.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(A)}}keepOnly(A){const C=new Set;A.forEach(b=>C.add(y.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>C.has(y.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,C){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const b=S._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(b.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(r=>m.add(y.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!m.has(y.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(b)}static _findLoopingExtensions(A){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,g){this.addNode(_),this.addNode(g),this._arcs.has(_)?this._arcs.get(_).push(g):this._arcs.set(_,[g])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,g){const w=C.getArcs(_);for(let c=0;c<w.length;c++)if(!g.has(w[c]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let _ of A){const g=y.ExtensionIdentifier.toKey(_.identifier);if(b.set(g,_),_.extensionDependencies)for(let w of _.extensionDependencies){const c=y.ExtensionIdentifier.toKey(w);C.addArc(g,c)}}let m=new Set;C.getNodes().filter(_=>C.getArcs(_).length===0).forEach(_=>m.add(_));let r=C.getNodes().filter(_=>!m.has(_)),s;do{s=!1;for(let _=0;_<r.length;_++){const g=r[_];C.hasOnlyGoodArcs(g,m)&&(r.splice(_,1),_--,m.add(g),s=!0)}}while(s);return r.map(_=>b.get(_))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(y.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const C=this._activationMap.get(A);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const C=this._extensionsMap.get(y.ExtensionIdentifier.toKey(A));return C||void 0}}e.ExtensionDescriptionRegistry=S;var k;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(k||(k={}));function E(n,A){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(C!==b)return C-b;const m=T.posix.basename(n.extensionLocation.path),r=T.posix.basename(A.extensionLocation.path);return m<r?-1:m>r?1:0}}),define(be[180],we([0,1,26]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(k){const E=y.VSBuffer.alloc(1);switch(k){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=P;function S(k,E){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=S}),define(be[34],we([0,1,3,2,4,25,147]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(d){this.dependency=d}}e.MissingDependencyError=k;var E;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(d,o,t,i){this.codeLoadingTime=d,this.activateCallTime=o,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class A{constructor(d,o){this.description=d,this.value=o}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var C;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function b(c){c.enableProposedApi||m(c)}e.checkProposedApiEnabled=b;function m(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=m;function r(c){var d;((d=c.workspaceTrust)===null||d===void 0?void 0:d.required)||s(c)}e.checkRequiresWorkspaceTrust=r;function s(c){throw new Error(`[${c.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=s;function _(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=_;function g(c){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!1,extensionLocation:c.location},c.manifest),{uuid:c.identifier.uuid})}e.toExtensionDescription=g;class w{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None}activateByEvent(d){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(d,o){}_activateById(d,o){return Promise.resolve()}_onWillActivateExtension(d){}_onDidActivateExtension(d,o,t,i,u){}_onExtensionRuntimeError(d,o){}_onExtensionHostExit(d){}}e.NullExtensionService=w}),define(be[181],we([0,1,129,25,34,19]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class k{constructor(s,_,g,w){this.startup=s,this.codeLoadingTime=_,this.activateCallTime=g,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class E{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,_){return s===-1||_===-1?-1:_-s}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class n{constructor(s,_,g,w,c,d){this.activationFailed=s,this.activationFailedError=_,this.activationTimes=g,this.module=w,this.exports=c,this.subscriptions=d}}e.ActivatedExtension=n;class A extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class C extends n{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class b extends n{constructor(s){super(!0,s,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let m=class{constructor(s,_,g,w,c){this._logService=c,this._registry=s,this._resolvedExtensionsSet=new Set,_.forEach(d=>this._resolvedExtensionsSet.add(R.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,g.forEach(d=>this._hostExtensionsMap.set(R.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const _=R.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(_)}getActivatedExtension(s){const _=R.ExtensionIdentifier.toKey(s),g=this._activatedExtensions.get(_);if(!g)throw new Error("Extension `"+s.value+"` is not known or not activated");return g}activateByEvent(s,_){if(this._alreadyActivatedEvents[s])return S;const g=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(g.map(w=>({id:w.identifier,reason:{startup:_,extensionId:w.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,_){const g=this._registry.getExtensionDescription(s);if(!g)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:g.identifier,reason:_}])}_handleActivateRequest(s,_,g){if(this._hostExtensionsMap.has(R.ExtensionIdentifier.toKey(s.id))){_[R.ExtensionIdentifier.toKey(s.id)]=s;return}const w=this._registry.getExtensionDescription(s.id);if(!w){this._host.onExtensionActivationError(s.id,new T.MissingDependencyError(s.id.value));const o=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(R.ExtensionIdentifier.toKey(s.id),new b(o));return}const c=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let o=0,t=c.length;o<t;o++){const i=c[o];if(!this._resolvedExtensionsSet.has(R.ExtensionIdentifier.toKey(i))){const u=this._activatedExtensions.get(R.ExtensionIdentifier.toKey(i));if(!(u&&!u.activationFailed)){if(u&&u.activationFailed){this._host.onExtensionActivationError(w.identifier,y.localize(0,null,w.displayName||w.identifier.value,i));const f=new Error(`Dependency ${i} failed to activate`);f.detail=u.activationFailedError,this._activatedExtensions.set(R.ExtensionIdentifier.toKey(w.identifier),new b(f));return}if(this._hostExtensionsMap.has(R.ExtensionIdentifier.toKey(i))){d=!1,_[R.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(R.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){d=!1,_[R.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(w.identifier,new T.MissingDependencyError(i));const l=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(R.ExtensionIdentifier.toKey(w.identifier),new b(l));return}}}d?_[R.ExtensionIdentifier.toKey(w.identifier)]=s:g.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(c=>!this._activatedExtensions.has(R.ExtensionIdentifier.toKey(c.id))),s.length===0))return Promise.resolve(void 0);const _=Object.create(null),g=[];for(let c=0,d=s.length;c<d;c++)this._handleActivateRequest(s[c],_,g);for(let c=0,d=g.length;c<d;c++){const o=R.ExtensionIdentifier.toKey(g[c].id);_[o]&&delete _[o]}const w=Object.keys(_).map(c=>_[c]);return g.length===0?Promise.all(w.map(c=>this._activateExtension(c.id,c.reason))).then(c=>{}):this._activateExtensions(w).then(c=>this._activateExtensions(g))}_activateExtension(s,_){const g=R.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const w=this._activatingExtensions.get(g);if(w)return w;const c=this._host.actualActivateExtension(s,_).then(void 0,d=>(this._host.onExtensionActivationError(s,y.localize(1,null,s.value,d.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(d),new b(d))).then(d=>{this._activatedExtensions.set(g,d),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,c),c}};m=qe([Ge(4,P.ILogService)],m),e.ExtensionsActivator=m}),define(be[182],we([0,1,10]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,S)=>{this._actualOk=P,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,y.onUnexpectedError)(P))}then(P,S){return this._ensureActual().then(P,S)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=R}),define(be[97],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(E,n){this.isMain=E,this.sid=n,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const R=[];function T(k){const E=new y(!0,k);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=T;function P(k){const E=new y(!1,k);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=P;function S(k){return R[k].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,97,57]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var S;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(E=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(c){c.name="$ident";function d(t,i){return Object.defineProperty(t,c.name,{value:i,enumerable:!0}),t}c.mixin=d;function o(t){return t[c.name]}c.of=o})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var r;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(c){if(c&&c.edits)for(const d of c.edits)typeof d.resource=="object"?d.resource=y.URI.revive(d.resource):(d.newUri=y.URI.revive(d.newUri),d.oldUri=y.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,T.revive)(d.metadata));return c}e.reviveWorkspaceEditDto=g;var w;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,R.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,R.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,R.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,R.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,R.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,R.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,R.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,R.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,R.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,R.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,R.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,R.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,R.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,R.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,R.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,R.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,R.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,R.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,R.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,R.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,R.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,R.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,R.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,R.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,R.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,R.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,R.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,R.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,R.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,R.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,R.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,R.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,R.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,R.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,R.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,R.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,R.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,R.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,R.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,R.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,R.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,R.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,R.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,R.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,R.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,R.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,R.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,R.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,R.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,R.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,R.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,R.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,R.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,R.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,R.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,R.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,R.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,R.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,R.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,R.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,R.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,R.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,R.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,R.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,R.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,R.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,R.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,R.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,R.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,R.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,R.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,R.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,R.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,R.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,R.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,R.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,R.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,R.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,R.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,R.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,R.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,R.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,R.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,R.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,R.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,R.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,R.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,R.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,R.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,R.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,R.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,R.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,R.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,R.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,R.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,R.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[71],we([0,1,5,3,4]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(k){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(y.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,E){return this._proxy.$getPassword(k,E)}store(k,E,n){return this._proxy.$setPassword(k,E,n)}delete(k,E){return this._proxy.$deletePassword(k,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(be[72],we([0,1,4,19,5,14]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,y.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(E,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(T.MainContext.MainThreadTelemetry)}report(E,n,A){const C=this.getUsageKey(E,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:E}))}getUsageKey(E,n){return`${E}-${n.identifier.value}`}};S=qe([Ge(0,P.IExtHostRpcService),Ge(1,R.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(k,E,n){}})}),define(be[183],we([0,1,3,5,7,25]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new y.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new y.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,n,A,C={}){const b=P.ExtensionIdentifier.toKey(E.identifier),m=this._inFlightRequests.get(b)||[],r=A.sort().join(" ");let s=m.find(_=>_.scopes===r);if(s)return s.result;{const _=this._getSession(E,b,n,A,C);s={scopes:r,result:_},m.push(s),this._inFlightRequests.set(b,m);try{await _}finally{const g=m.findIndex(w=>w.scopes===r);g>-1&&(m.splice(g),this._inFlightRequests.set(b,m))}return _}}async _getSession(E,n,A,C,b={}){await this._proxy.$ensureProvider(A);const m=E.displayName||E.name;return this._proxy.$getSession(A,C,n,m,b)}async removeSession(E,n){const A=this._authenticationProviders.get(E);return A?A.provider.removeSession(n):this._proxy.$removeSession(E,n)}registerAuthenticationProvider(E,n,A,C){var b;if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:n,provider:A,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===E)||this._providers.push({id:E,label:n});const m=A.onDidChangeSessions(r=>{var s,_,g;this._proxy.$sendDidChangeSessions(E,{added:(s=r.added)!==null&&s!==void 0?s:[],changed:(_=r.changed)!==null&&_!==void 0?_:[],removed:(g=r.removed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(E,n,(b=C==null?void 0:C.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const r=this._providers.findIndex(s=>s.id===E);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,n){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,n){return this._onDidChangeSessions.fire({provider:{id:E,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,n){return E.forEach(A=>{this._providers.some(C=>C.id===A.id)||this._providers.push(A)}),n.forEach(A=>{const C=this._providers.findIndex(b=>b.id===A.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[184],we([0,1,5,14,9]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(k,E){this._extHostDocumentsAndEditors=E,this._proxy=k.getProxy(y.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const E=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};P=qe([Ge(0,R.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(be[185],we([0,1,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(P){const S=P.getProxy(y.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(k){return S.$writeText(k)}})}}e.ExtHostClipboard=R}),define(be[73],we([0,1,12,7,9,23,5,15,19,57,33,39,2,6,4,14]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=i,this.converter=new g(this,u=>{const a=this._apiCommands.get(u);return(a==null?void 0:a.result)===c.Void?a:void 0},i),this._argumentProcessors=[{processArgument(u){return(0,n.revive)(u)}},{processArgument(u){return(0,P.cloneAndChange)(u,function(a){if(A.Range.isIRange(a))return T.Range.to(a);if(C.Position.isIPosition(a))return T.Position.to(a);if(A.Range.isIRange(a.range)&&b.URI.isUri(a.uri))return T.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...u)=>{const a=t.args.map((f,v)=>{if(!f.validate(u[v]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${u[v]}`);return f.convert(u[v])}),l=await this.executeCommand(t.internalId,...a);return t.result.convert(l,u,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,u,a,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:u,thisArg:a,description:l}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,u){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const a=(0,P.cloneAndChange)(i,function(l){if(l instanceof R.Position)return T.Position.from(l);if(l instanceof R.Range)return T.Range.from(l);if(l instanceof R.Location)return T.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,a,u);return(0,n.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:a,thisArg:l,description:f}=u;if(f)for(let v=0;v<f.args.length;v++)try{(0,y.validateConstraint)(i[v],f.args[v].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[v].name}' - ${f.args[v].description}`)}try{return await a.apply(l,i)}catch(v){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...i);D&&(t=D.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(u=>this._argumentProcessors.reduce((a,l)=>l.processArgument(a),u)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(u=>u[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,u]of this._commands){let{description:a}=u;a&&(t[i]=a)}return Promise.resolve(t)}};_=qe([Ge(0,s.IExtHostRpcService),Ge(1,E.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class g{constructor(t,i,u){this._commands=t,this._lookupApiCommand=i,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const u={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return u;const a=this._lookupApiCommand(t.command);if(a)u.id=a.internalId,u.arguments=a.args.map((l,f)=>l.convert(t.arguments&&t.arguments[f]));else if((0,k.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),u.$ident=l,u.id=this.delegatingCommandId,u.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return u}}fromInternal(t){const i=S.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class w{constructor(t,i,u,a){this.name=t,this.description=i,this.validate=u,this.convert=a}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",o=>b.URI.isUri(o),o=>o),w.Position=new w("position","A position in a text document",o=>R.Position.isPosition(o),T.Position.from),w.Range=new w("range","A range in a text document",o=>R.Range.isRange(o),T.Range.from),w.Selection=new w("selection","A selection in a text document",o=>R.Selection.isSelection(o),T.Selection.from),w.Number=new w("number","",o=>typeof o=="number",o=>o),w.String=new w("string","",o=>typeof o=="string",o=>o),w.CallHierarchyItem=new w("item","A call hierarchy item",o=>o instanceof R.CallHierarchyItem,T.CallHierarchyItem.to);class c{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=c,c.Void=new c("no result",o=>o);class d{constructor(t,i,u,a,l){this.id=t,this.internalId=i,this.description=u,this.args=a,this.result=l}}e.ApiCommand=d}),define(be[186],we([0,1,6,9,7,62,73,164,15,84]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(R.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,s)=>{if(!(0,E.isFalsyOrEmpty)(r)){class _ extends T.SymbolInformation{static to(w){const c=new _(w.name,R.SymbolKind.to(w.kind),w.containerName||"",new T.Location(s[0],R.Range.to(w.range)));return c.detail=w.detail,c.range=c.location.range,c.selectionRange=R.Range.to(w.selectionRange),c.children=w.children?w.children.map(_.to):[],c}}return r.map(_.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(R.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(R.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>T.Position.isPosition(s)),r=>r.map(R.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(s=>{let _;for(const g of s.reverse())_=new T.SelectionRange(R.Range.to(g),_);return _}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const s=[];if(Array.isArray(r))for(let _ of r)s.push(..._[1].map(R.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new T.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new T.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,s,_)=>{if(!r)return new T.CompletionList([]);const g=r.suggestions.map(w=>R.CompletionItem.to(w,_));return new T.CompletionList(g,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,s,_)=>b(g=>new T.CodeLens(R.Range.to(g.range),g.command&&_.fromInternal(g.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.Range.isRange(r),r=>T.Selection.isSelection(r)?R.Selection.from(r):R.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,s,_)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(g.command)}else{const w=new T.CodeAction(g.title,g.kind?new T.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=R.WorkspaceEdit.to(g.edit)),g.command&&(w.command=_.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new T.ColorInformation(R.Range.to(s.range),R.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof T.Color,R.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(R.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientMetadata},filenamePattern:r.filenamePattern.map(s=>R.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class C{constructor(s){this._disposables=new y.DisposableStore,this._commands=s}static register(s){return A.forEach(s.registerApiCommand,s),new C(s).registerCommands()}registerCommands(){const s=_=>(...g)=>_(this._commands,...g);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,s(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:_=>typeof _=="string"}]}),this._register(k.OpenIssueReporter.ID,s(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:_=>typeof _=="string"||typeof _=="object"&&typeof _.extensionId=="string"}]})}_register(s,_,g){const w=this._commands.registerCommand(!1,s,_,this,g);this._disposables.add(w)}}e.ExtHostApiCommands=C;function b(r){return s=>{if(Array.isArray(s))return s.map(r)}}function m(r){if(!!Array.isArray(r)){const s=[];for(const _ of r)P.isLocationLink(_)?s.push(R.DefinitionLink.to(_)):s.push(R.location.to(_));return s}}}),define(be[187],we([0,1,13,51,3,6,2,62,25,9,7,5]),function(le,e,y,R,T,P,S,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(d,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(C.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const u=this._commentControllers.get(i.handle);return u||i}else if(i&&i.$mid===7){const u=this._commentControllers.get(i.commentControlHandle);if(!u)return i;const a=u.getCommentThread(i.commentThreadHandle);return a||i}else if(i&&i.$mid===8){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const a=u.getCommentThread(i.thread.commentThreadHandle);return a?{thread:a,text:i.text}:i}else if(i&&i.$mid===9){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const a=u.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.commentUniqueId,f=a.getCommentByUniqueId(l);return f||i}else if(i&&i.$mid===10){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const a=u.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.text,f=i.commentUniqueId,v=a.getCommentByUniqueId(f);return v?(v.body=l,v):i}return i}})}createCommentController(d,o,t){const i=b.handlePool++,u=new r(d,i,this._proxy,o,t);this._commentControllers.set(u.handle,u);const a=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(d.identifier))||[];return a.push(u),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(d.identifier),a),u}$createCommentThreadTemplate(d,o,t){const i=this._commentControllers.get(d);!i||i.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(d,o,t){const i=this._commentControllers.get(d);!i||i.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(d,o){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(d,o,t){const i=this._commentControllers.get(d);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const u=this._documents.getDocument(S.URI.revive(o));return(0,y.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(u,t)).then(a=>a?a.map(l=>n.Range.from(l)):void 0)}$toggleReaction(d,o,t,i,u){const a=this._commentControllers.get(d);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,y.asPromise)(()=>{const l=a.getCommentThread(o);if(l){const f=l.getCommentByUniqueId(i.uniqueIdInThread);if(a!==void 0&&f&&a.reactionHandler)return a.reactionHandler(f,g(u))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class m{constructor(d,o,t,i,u,a,l){this._proxy=d,this._commentController=o,this._id=t,this._uri=i,this._range=u,this._comments=a,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};d("range")&&(o.range=n.Range.from(this._range)),d("label")&&(o.label=this.label),d("contextValue")&&(o.contextValue=this.contextValue),d("comments")&&(o.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(o.collapseState=w(this._collapseState)),d("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(d){for(let o of this._commentsMap){let t=o[0],i=o[1];if(d===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,qe([(0,R.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class r{constructor(d,o,t,i,u){this._extension=d,this._handle=o,this._proxy=t,this._id=i,this._label=u,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,u)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,o,t,i){if(typeof d=="string"){const u=new m(this._proxy,this,d,o,t,i,this._extension.identifier);return this._threads.set(u.handle,u),u}else{const u=new m(this._proxy,this,void 0,d,o,t,this._extension.identifier);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(d,o){const t=new m(this._proxy,this,void 0,S.URI.revive(d),n.Range.to(o),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,o){let t=this._threads.get(d);t&&(t.range=n.Range.to(o))}$deleteCommentThread(d){let o=this._threads.get(d);o&&o.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(c,d,o,t){let i=t.get(o);i||(i=++c.commentHandle,t.set(o,i));const u=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(o.body),userName:o.author.name,userIconPath:u,label:o.label,commentReactions:o.reactions?o.reactions.map(a=>_(a)):void 0}}function _(c){return{label:c.label,iconPath:c.iconPath?n.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function g(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?S.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function w(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(be[98],we([0,1,2,5,7,4,14,19,15,8,11]),function(le,e,y,R,T,P,S,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class cn{constructor(m,r){this._logService=r,this._provider=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,r){const s=cn._handlePool++;this._provider.set(s,{provider:m,extensionId:r}),this._proxy.$registerDecorationProvider(s,r.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(s,null);return}let w=(0,E.asArray)(g);if(w.length<=cn._maxEventSize){this._proxy.$onDidChange(s,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,w.length);const c=w.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),d=(0,E.groupBy)(c,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let o=[];e:for(let t of d){let i;for(let u of t){let a=(0,A.dirname)(u.uri.path);if(i!==a&&(i=a,o.push(u.uri)>=cn._maxEventSize))break e}}this._proxy.$onDidChange(s,o)});return new T.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(m,r,s){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:g,extensionId:w}=this._provider.get(m);return await Promise.all(r.map(async c=>{try{const{uri:d,id:o}=c,t=await Promise.resolve(g.provideFileDecoration(y.URI.revive(d),s));if(!t)return;try{T.FileDecoration.validate(t),_[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(d){this._logService.error(d)}})),_}};C._handlePool=0,C._maxEventSize=250,C=qe([Ge(0,S.IExtHostRpcService),Ge(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(be[188],we([0,1,128,87,2,5,7,9,3,19,22]),function(le,e,y,R,T,P,S,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(r,s,_,g,w){this._name=r,this._owner=s,this._maxDiagnosticsPerFile=_,this._proxy=g,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new A.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,s){if(!r){this.clear();return}this._checkDisposed();let _=[];if(T.URI.isUri(r)){if(!s){this.delete(r);return}this._data.set(r,s.slice()),_=[r]}else if(Array.isArray(r)){_=[];let w;r=[...r].sort(C._compareIndexedTuplesByUri);for(const c of r){const[d,o]=c;if((!w||d.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=d,_.push(d),this._data.set(d,[])),o){const t=this._data.get(d);t&&t.push(...o)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!!this._proxy){const g=[];for(let w of _){let c=[];const d=this._data.get(w);if(d)if(d.length>this._maxDiagnosticsPerFile){c=[];const o=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of d)if(i.severity===o[t]&&c.push(k.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;c.push({severity:R.MarkerSeverity.Info,message:(0,y.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=d.map(o=>k.Diagnostic.from(o));g.push([w,c])}this._proxy.$changeMany(this._owner,g)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,s){this._checkDisposed();for(let _ of this._data.keys())r.apply(s,[_,this.get(_),this])}get(r){this._checkDisposed();const s=this._data.get(r);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,s){return r[0].toString()<s[0].toString()?-1:r[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=C;let b=class Bt{constructor(r,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,Bt._debouncer,50),Bt._mapper),this._proxy=r.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(r,s){return r?r.concat(s):s}static _mapper(r){const s=[],_=new Set;for(const g of r)typeof g=="string"?_.has(g)||(_.add(g),s.push(T.URI.parse(g))):_.has(g.toString())||(_.add(g.toString()),s.push(g));return Object.freeze(s),{uris:s}}createDiagnosticCollection(r,s){const{_collections:_,_proxy:g,_onDidChangeDiagnostics:w,_logService:c}=this,d=new class{$changeMany(i,u){g.$changeMany(i,u),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,u.length===0?"CLEARING":u)}$clear(i){g.$clear(i),c.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){g.dispose()}};let o;if(!s)s="_generated_diagnostic_collection_name_#"+Bt._idPool++,o=s;else if(!_.has(s))o=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do o=s+Bt._idPool++;while(_.has(o))}return new class extends C{constructor(){super(s,o,Bt._maxDiagnosticsPerFile,d,w);_.set(o,this)}dispose(){super.dispose(),_.delete(o)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const s=new Map,_=[];for(const g of this._collections.values())g.forEach((w,c)=>{let d=s.get(w.toString());typeof d=="undefined"&&(d=_.length,s.set(w.toString(),d),_.push([w,[]])),_[d][1]=_[d][1].concat(...c)});return _}}_getDiagnostics(r){let s=[];for(let _ of this._collections.values())_.has(r)&&(s=s.concat(_.get(r)));return s}$acceptMarkersChange(r){if(!this._mirrorCollection){const s="_generated_mirror",_=new C(s,s,Bt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,_),this._mirrorCollection=_}for(const[s,_]of r)this._mirrorCollection.set(T.URI.revive(s),_.map(k.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=qe([Ge(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(be[189],we([0,1,2,5]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(S){this._proxy=S.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(k=>k?k.map(E=>y.URI.revive(E)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(k=>k?y.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(be[190],we([0,1,10,2,7,5,16,20,8]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,b,m){this._documentsAndEditors=b,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,b){if(Object.keys(S.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,b),this._proxy.$registerTextContentProvider(m,C);let r;return typeof b.onDidChange=="function"&&(r=b.onDidChange(s=>{if(s.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(m,s).then(_=>{if(!(!_&&typeof _!="string")){const g=this._documentsAndEditors.getDocument(s);if(!!g){const w=(0,E.splitLines)(_);if(!g.equalLines(w))return this._proxy.$onVirtualDocumentChange(s,_)}}},y.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(C,b){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(R.URI.revive(b),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(be[191],we([0,1,3,6,2,5,94,9,12,23]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(b,m){this._onDidAddDocument=new y.Emitter,this._onDidRemoveDocument=new y.Emitter,this._onDidChangeDocument=new y.Emitter,this._onDidSaveDocument=new y.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const s of r)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const s of r)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const m=this._documentsAndEditors.getDocument(b);if(m)return m}}getDocument(b){const m=this.getDocumentData(b);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this._documentsAndEditors.getDocument(b);if(m)return Promise.resolve(m);let r=this._documentLoader.get(b.toString());return r||(r=this._proxy.$tryOpenDocument(b).then(s=>{this._documentLoader.delete(b.toString());const _=T.URI.revive(s);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(_))},s=>(this._documentLoader.delete(b.toString()),Promise.reject(s))),this._documentLoader.set(b.toString(),r)),r}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(m=>T.URI.revive(m))}$acceptModelModeChanged(b,m){const r=T.URI.revive(b),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(m),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(b){const m=T.URI.revive(b),r=this._documentsAndEditors.getDocument(m);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(b,m){const r=T.URI.revive(b),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(b,m,r){const s=T.URI.revive(b),_=this._documentsAndEditors.getDocument(s);if(!_)throw new Error("unknown document");_._acceptIsDirty(r),_.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:_.document,contentChanges:m.changes.map(g=>({range:k.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(b,m){(0,S.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=A}),define(be[40],we([0,1,43,3,6,2,4,5,94,14,96,9,19,22,16,54,106]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(d,o){this._extHostRpc=d,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const o=[],t=[],i=[];if(d.removedDocuments)for(const u of d.removedDocuments){const a=P.URI.revive(u),l=this._documents.get(a);(l==null?void 0:l.unref())&&(this._documents.delete(a),o.push(l.value))}if(d.addedDocuments)for(const u of d.addedDocuments){const a=P.URI.revive(u.uri);let l=this._documents.get(a);if(l&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);l||(l=new g(new E.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),a,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(a,l),t.push(l.value)),l.ref()}if(d.removedEditors)for(const u of d.removedEditors){const a=this._editors.get(u);this._editors.delete(u),a&&i.push(a)}if(d.addedEditors)for(const u of d.addedEditors){const a=P.URI.revive(u.documentUri);y.ok(this._documents.has(a),`document '${a}' does not exist`),y.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const l=this._documents.get(a).value,f=new A.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>l.document),u.selections.map(C.Selection.to),u.options,u.visibleRanges.map(v=>C.Range.to(v)),typeof u.editorPosition=="number"?C.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,f)}d.newActiveEditor!==void 0&&(y.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,T.dispose)(o),(0,T.dispose)(i),d.removedDocuments&&this._onDidRemoveDocuments.fire(o),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var o;return(o=this._documents.get(d))===null||o===void 0?void 0:o.value}allDocuments(){return s.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return d?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};w=qe([Ge(0,n.IExtHostRpcService),Ge(1,b.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[192],we([0,1,2,5,6,7,9,116,8,26]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const r=this._schemes.indexOf(m);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),r=[];let s,_,g=14,w=14;for(const c of m){let d=s?(0,E.commonPrefixLength)(s,c):0;for(d===0?_=1:_=w;d<c.length;d++)d+1===c.length?(g=w,w=9):w+=1,r.push([_,c.toUpperCase().charCodeAt(d),w]),r.push([_,c.toLowerCase().charCodeAt(d),w]),_=w;s=c,w=g}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new k.StateMachine(r)}}provideDocumentLinks(m){this._initStateMachine();const r=[],s=k.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of s){const g=S.DocumentLink.to(_);g.target&&r.push(g)}return r}}class C{constructor(m,r){this._extHostLanguageFeatures=r,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,r,s,_={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(g,s);let w=2;_.isCaseSensitive&&(w+=1024),_.isReadonly&&(w+=2048),typeof s.copy=="function"&&(w+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(g,r,w).catch(d=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${r}`),console.error(d)});const c=s.onDidChangeFile(d=>{const o=[];for(const t of d){let{uri:i,type:u}=t;if(i.scheme===r){let a;switch(u){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:i,type:a})}}this._proxy.$onFileSystemChange(g,o)});return(0,T.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(m){const{type:r,ctime:s,mtime:_,size:g}=m;return{type:r,ctime:s,mtime:_,size:g}}$stat(m,r){return Promise.resolve(this._getFsProvider(m).stat(y.URI.revive(r))).then(C._asIStat)}$readdir(m,r){return Promise.resolve(this._getFsProvider(m).readDirectory(y.URI.revive(r)))}$readFile(m,r){return Promise.resolve(this._getFsProvider(m).readFile(y.URI.revive(r))).then(s=>n.VSBuffer.wrap(s))}$writeFile(m,r,s,_){return Promise.resolve(this._getFsProvider(m).writeFile(y.URI.revive(r),s.buffer,_))}$delete(m,r,s){return Promise.resolve(this._getFsProvider(m).delete(y.URI.revive(r),s))}$rename(m,r,s,_){return Promise.resolve(this._getFsProvider(m).rename(y.URI.revive(r),y.URI.revive(s),_))}$copy(m,r,s,_){const g=this._getFsProvider(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(y.URI.revive(r),y.URI.revive(s),_))}$mkdir(m,r){return Promise.resolve(this._getFsProvider(m).createDirectory(y.URI.revive(r)))}$watch(m,r,s,_){const g=this._getFsProvider(m).watch(y.URI.revive(s),_);this._watches.set(r,g)}$unwatch(m,r){const s=this._watches.get(r);s&&(s.dispose(),this._watches.delete(r))}$open(m,r,s){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(y.URI.revive(r),s))}$close(m,r){const s=this._getFsProvider(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(m,r,s,_){const g=this._getFsProvider(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const w=n.VSBuffer.alloc(_);return Promise.resolve(g.read(r,s,w.buffer,0,_)).then(c=>w.slice(0,c))}$write(m,r,s,_){const g=this._getFsProvider(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(r,s,_.buffer,0,_.byteLength))}_getFsProvider(m){const r=this._fsProvider.get(m);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.ExtHostFileSystem=C}),define(be[74],we([0,1,5,64,7,26,4,14,48]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Rt{constructor(C,b){const m=C.getProxy(y.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return m.$stat(r).catch(Rt._handleError)},readDirectory(r){return m.$readdir(r).catch(Rt._handleError)},createDirectory(r){return m.$mkdir(r).catch(Rt._handleError)},async readFile(r){return m.$readFile(r).then(s=>s.buffer).catch(Rt._handleError)},writeFile(r,s){return m.$writeFile(r,P.VSBuffer.wrap(s)).catch(Rt._handleError)},delete(r,s){return m.$delete(r,Object.assign({recursive:!1,useTrash:!1},s)).catch(Rt._handleError)},rename(r,s,_){return m.$rename(r,s,Object.assign({overwrite:!1},_)).catch(Rt._handleError)},copy(r,s,_){return m.$copy(r,s,Object.assign({overwrite:!1},_)).catch(Rt._handleError)},isWritableFileSystem(r){const s=b.getCapabilities(r);if(typeof s=="number")return!(s&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case R.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case R.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case R.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case R.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};n=qe([Ge(0,k.IExtHostRpcService),Ge(1,E.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[193],we([0,1,6,5]),function(le,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(S){this._handlePool=0,this._proxy=S.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,S),(0,y.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(be[194],we([0,1,2,23,9,7,13,5,8,33,15,12,113,6,84,53,92,55,10]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(N,G){this._documents=N,this._provider=G}provideDocumentSymbols(N,G){const ee=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(ee,G)).then(oe=>{if(!(0,A.isFalsyOrEmpty)(oe))return oe[0]instanceof P.DocumentSymbol?oe.map(T.DocumentSymbol.from):c._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(N){var G;N=N.slice(0).sort((fe,Se)=>{let Le=fe.location.range.start.compareTo(Se.location.range.start);return Le===0&&(Le=Se.location.range.end.compareTo(fe.location.range.end)),Le});const ee=[],oe=[];for(const fe of N){const Se={name:fe.name||"!!MISSING: name!!",kind:T.SymbolKind.from(fe.kind),tags:((G=fe.tags)===null||G===void 0?void 0:G.map(T.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:T.Range.from(fe.location.range),selectionRange:T.Range.from(fe.location.range),children:[]};for(;;){if(oe.length===0){oe.push(Se),ee.push(Se);break}const Le=oe[oe.length-1];if(n.Range.containsRange(Le.range,Se.range)&&!n.Range.equalsRange(Le.range,Se.range)){Le.children&&Le.children.push(Se),oe.push(Se);break}oe.pop()}}return ee}}class d{constructor(N,G,ee){this._documents=N,this._commands=G,this._provider=ee,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,G){const ee=this._documents.getDocument(N),oe=await this._provider.provideCodeLenses(ee,G);if(!(!oe||G.isCancellationRequested)){const fe=this._cache.add(oe),Se=new m.DisposableStore;this._disposables.set(fe,Se);const Le={cacheId:fe,lenses:[]};for(let me=0;me<oe.length;me++)Le.lenses.push({cacheId:[fe,me],range:T.Range.from(oe[me].range),command:this._commands.toInternal(oe[me].command,Se)});return Le}}async resolveCodeLens(N,G){var ee;const oe=N.cacheId&&this._cache.get(...N.cacheId);if(!!oe){let fe;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?fe=oe:fe=await this._provider.resolveCodeLens(oe,G),fe||(fe=oe),!G.isCancellationRequested){const Se=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!Se)return N.command=this._commands.toInternal((ee=fe.command)!==null&&ee!==void 0?ee:d._badCmd,Se),N}}}releaseCodeLenses(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ze){return Array.isArray(ze)?ze.map(T.DefinitionLink.from):ze?[T.DefinitionLink.from(ze)]:[]}class t{constructor(N,G){this._documents=N,this._provider=G}provideDefinition(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(oe,fe,ee)).then(o)}}class i{constructor(N,G){this._documents=N,this._provider=G}provideDeclaration(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(oe,fe,ee)).then(o)}}class u{constructor(N,G){this._documents=N,this._provider=G}provideImplementation(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(oe,fe,ee)).then(o)}}class a{constructor(N,G){this._documents=N,this._provider=G}provideTypeDefinition(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(oe,fe,ee)).then(o)}}class l{constructor(N,G){this._documents=N,this._provider=G}provideHover(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(oe,fe,ee)).then(Se=>{if(!(!Se||(0,A.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=oe.getWordRangeAtPosition(fe)),Se.range||(Se.range=new P.Range(fe,fe)),T.Hover.from(Se)})}}class f{constructor(N,G){this._documents=N,this._provider=G}provideEvaluatableExpression(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,fe,ee)).then(Se=>{if(Se)return T.EvaluatableExpression.from(Se)})}}class v{constructor(N,G){this._documents=N,this._provider=G}provideInlineValues(N,G,ee,oe){const fe=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineValues(fe,T.Range.to(G),T.InlineValueContext.to(ee),oe)).then(Se=>{if(Array.isArray(Se))return Se.map(Le=>T.InlineValue.from(Le))})}}class D{constructor(N,G){this._documents=N,this._provider=G}provideDocumentHighlights(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(oe,fe,ee)).then(Se=>{if(Array.isArray(Se))return Se.map(T.DocumentHighlight.from)})}}class h{constructor(N,G){this._documents=N,this._provider=G}provideLinkedEditingRanges(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,fe,ee)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,A.coalesce)(Se.ranges.map(T.Range.from)),wordPattern:Se.wordPattern}})}}class p{constructor(N,G){this._documents=N,this._provider=G}provideReferences(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(fe,Se,ee,oe)).then(Le=>{if(Array.isArray(Le))return Le.map(T.location.from)})}}class I{constructor(N,G,ee,oe,fe,Se,Le){this._documents=N,this._commands=G,this._diagnostics=ee,this._provider=oe,this._logService=fe,this._extension=Se,this._apiDeprecation=Le,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=b.Selection.isISelection(G)?T.Selection.to(G):T.Range.to(G),Le=[];for(const Ce of this._diagnostics.getDiagnostics(N))if(Se.intersection(Ce.range)&&Le.push(Ce)>I._maxCodeActionsPerFile)break;const me={diagnostics:Le,only:ee.only?new P.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(fe,Se,me,oe)).then(Ce=>{var Pe;if(!(!(0,A.isNonEmptyArray)(Ce)||oe.isCancellationRequested)){const xe=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set(xe,_e);const Ke=[];for(let j=0;j<Ce.length;j++){const Y=Ce[j];!Y||(I._isCommand(Y)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Y.title,command:this._commands.toInternal(Y,_e)})):(me.only&&(Y.kind?me.only.contains(Y.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action is of kind '${Y.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[xe,j],title:Y.title,command:Y.command&&this._commands.toInternal(Y.command,_e),diagnostics:Y.diagnostics&&Y.diagnostics.map(T.Diagnostic.from),edit:Y.edit&&T.WorkspaceEdit.from(Y.edit),kind:Y.kind&&Y.kind.value,isPreferred:Y.isPreferred,disabled:(Pe=Y.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:xe,actions:Ke}}})}async resolveCodeAction(N,G){var ee;const[oe,fe]=N,Se=this._cache.get(oe,fe);if(!(!Se||I._isCommand(Se))&&!!this._provider.resolveCodeAction){const Le=(ee=await this._provider.resolveCodeAction(Se,G))!==null&&ee!==void 0?ee:Se;return(Le==null?void 0:Le.edit)?T.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}I._maxCodeActionsPerFile=1e3;class F{constructor(N,G){this._documents=N,this._provider=G}provideDocumentFormattingEdits(N,G,ee){const oe=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,G,ee)).then(fe=>{if(Array.isArray(fe))return fe.map(T.TextEdit.from)})}}class z{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeFormattingEdits(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=T.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Se,ee,oe)).then(Le=>{if(Array.isArray(Le))return Le.map(T.TextEdit.from)})}}class ue{constructor(N,G){this._documents=N,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(N,G,ee,oe,fe){const Se=this._documents.getDocument(N),Le=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Le,ee,oe,fe)).then(me=>{if(Array.isArray(me))return me.map(T.TextEdit.from)})}}class H{constructor(N,G){this._provider=N,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(N,G){const ee=k.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(N,G)).then(oe=>{if((0,A.isNonEmptyArray)(oe)){for(const fe of oe)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Se=k.IdObject.mixin(T.WorkspaceSymbol.from(fe));this._symbolCache.set(Se._id,fe),ee.symbols.push(Se)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(N,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const ee=this._symbolCache.get(N._id);if(ee){const oe=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,G));return oe&&(0,R.mixin)(N,T.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(N){const G=this._resultCache.get(N);if(G){for(let[ee,oe]=G;ee<=oe;ee++)this._symbolCache.delete(ee);this._resultCache.delete(N)}}}class B{constructor(N,G,ee){this._documents=N,this._provider=G,this._logService=ee}static supportsResolving(N){return typeof N.prepareRename=="function"}provideRenameEdits(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(fe,Se,ee,oe)).then(Le=>{if(!!Le)return T.WorkspaceEdit.from(Le)},Le=>{const me=B._asMessage(Le);return me?{rejectReason:me,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation(N,G,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(N),fe=T.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(oe,fe,ee)).then(Se=>{let Le,me;if(P.Range.isRange(Se)?(Le=Se,me=oe.getText(Se)):(0,C.isObject)(Se)&&(Le=Se.range,me=Se.placeholder),!!Le){if(Le.start.line>fe.line||Le.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Le),text:me}}},Se=>{const Le=B._asMessage(Se);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class K{constructor(N,G){this.resultId=N,this.tokens=G}}class L{constructor(N,G){this._documents=N,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(N,G,ee){const oe=this._documents.getDocument(N),fe=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,fe.resultId,ee):this._provider.provideDocumentSemanticTokens(oe,ee)).then(Se=>(fe&&this._previousResults.delete(G),Se?(Se=L._fixProvidedSemanticTokens(Se),this._send(L._convertToEdits(fe,Se),Se)):null))}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return L._isSemanticTokens(N)?L._isCorrectSemanticTokens(N)?N:new P.SemanticTokens(new Uint32Array(N.data),N.resultId):L._isSemanticTokensEdits(N)?L._isCorrectSemanticTokensEdits(N)?N:new P.SemanticTokensEdits(N.edits.map(G=>new P.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const G of N.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,G){if(!L._isSemanticTokens(G)||!N||!N.tokens)return G;const ee=N.tokens,oe=ee.length,fe=G.data,Se=fe.length;let Le=0;const me=Math.min(oe,Se);for(;Le<me&&ee[Le]===fe[Le];)Le++;if(Le===oe&&Le===Se)return new P.SemanticTokensEdits([],G.resultId);let Ce=0;const Pe=me-Le;for(;Ce<Pe&&ee[oe-Ce-1]===fe[Se-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Le,deleteCount:oe-Le-Ce,data:fe.subarray(Le,Se-Ce)}],G.resultId)}_send(N,G){if(L._isSemanticTokens(N)){const ee=this._nextResultId++;return this._previousResults.set(ee,new K(N.resultId,N.data)),(0,r.encodeSemanticTokensDto)({id:ee,type:"full",data:N.data})}if(L._isSemanticTokensEdits(N)){const ee=this._nextResultId++;return L._isSemanticTokens(G)?this._previousResults.set(ee,new K(G.resultId,G.data)):this._previousResults.set(ee,new K(N.resultId)),(0,r.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(N.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class U{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeSemanticTokens(N,G,ee){const oe=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,T.Range.to(G),ee)).then(fe=>fe?this._send(fe):null)}_send(N){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(N,G,ee,oe,fe){this._documents=N,this._commands=G,this._provider=ee,this._apiDeprecation=oe,this._extension=fe,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=T.Position.to(G),Le=fe.getWordRangeAtPosition(Se)||new P.Range(Se,Se),me=Le.with({end:Se}),Ce=new g.StopWatch(!0),Pe=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(fe,Se,oe,T.CompletionContext.to(ee)));if(!!Pe&&!oe.isCancellationRequested){const xe=Array.isArray(Pe)?new P.CompletionList(Pe):Pe,_e=x.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(_e,Ke);const j=[],Y={x:_e,b:j,a:{replace:T.Range.from(Le),insert:T.Range.from(me)},c:xe.isIncomplete||void 0,d:Ce.elapsed()};for(let pe=0;pe<xe.items.length;pe++){const Fe=xe.items[pe],He=this._convertCompletionItem(Fe,[_e,pe],me,Le);j.push(He)}return Y}}async resolveCompletionItem(N,G){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...N);if(!!ee){const oe=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(ee,G));if(!!oe)return this._convertCompletionItem(oe,N)}}}releaseCompletionItems(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,G,ee,oe){var fe;const Se=this._disposables.get(G[0]);if(!Se)throw Error("DisposableStore is missing...");const Le={x:G,a:(fe=N.label)!==null&&fe!==void 0?fe:"",o:N.label2,b:N.kind!==void 0?T.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(T.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(N.command,Se)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=N.textEdit.newText):typeof N.insertText=="string"?Le.h=N.insertText:N.insertText instanceof P.SnippetString&&(Le.h=N.insertText.value,Le.i|=4);let me;return N.textEdit?me=N.textEdit.range:N.range&&(me=N.range),P.Range.isRange(me)?Le.j=T.Range.from(me):me&&(!(ee==null?void 0:ee.isEqual(me.inserting))||!(oe==null?void 0:oe.isEqual(me.replacing)))&&(Le.j={insert:T.Range.from(me.inserting),replace:T.Range.from(me.replacing)}),Le}}class Q{constructor(N,G){this._documents=N,this._provider=G,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(N,G,ee,oe){const fe=this._documents.getDocument(N),Se=T.Position.to(G),Le=this.reviveContext(ee);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(fe,Se,oe,Le)).then(me=>{if(me){const Ce=this._cache.add([me]);return Object.assign(Object.assign({},T.SignatureHelp.from(me)),{id:Ce})}})}reviveContext(N){let G;if(N.activeSignatureHelp){const ee=T.SignatureHelp.to(N.activeSignatureHelp),oe=this._cache.get(N.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=ee.activeSignature,G.activeParameter=ee.activeParameter):G=ee}return Object.assign(Object.assign({},N),{activeSignatureHelp:G})}releaseSignatureHelp(N){this._cache.delete(N)}}class ${constructor(N,G){this._documents=N,this._provider=G}provideInlineHints(N,G,ee){const oe=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineHints(oe,T.Range.to(G),ee)).then(fe=>fe?{hints:fe.map(T.InlineHint.from)}:void 0)}}class Z{constructor(N,G){this._documents=N,this._provider=G,this._cache=new _.Cache("DocumentLink")}provideLinks(N,G){const ee=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(ee,G)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(T.DocumentLink.from)};{const fe=this._cache.add(oe),Se={links:[],id:fe};for(let Le=0;Le<oe.length;Le++){const me=T.DocumentLink.from(oe[Le]);me.cacheId=[fe,Le],Se.links.push(me)}return Se}}})}resolveLink(N,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...N);return ee?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(ee,G)).then(oe=>oe&&T.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(N){this._cache.delete(N)}}class ie{constructor(N,G){this._documents=N,this._provider=G}provideColors(N,G){const ee=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(ee,G)).then(oe=>Array.isArray(oe)?oe.map(Se=>({color:T.Color.from(Se.color),range:T.Range.from(Se.range)})):[])}provideColorPresentations(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Range.to(G.range),Se=T.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:oe,range:fe},ee)).then(Le=>{if(!!Array.isArray(Le))return Le.map(T.ColorPresentation.from)})}}class re{constructor(N,G){this._documents=N,this._provider=G}provideFoldingRanges(N,G,ee){const oe=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(oe,G,ee)).then(fe=>{if(!!Array.isArray(fe))return fe.map(T.FoldingRange.from)})}}class ye{constructor(N,G,ee){this._documents=N,this._provider=G,this._logService=ee}provideSelectionRanges(N,G,ee){const oe=this._documents.getDocument(N),fe=G.map(T.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(oe,fe,ee)).then(Se=>{if(!(0,A.isNonEmptyArray)(Se))return[];if(Se.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let me=0;me<fe.length;me++){const Ce=[];Le.push(Ce);let Pe=fe[me],xe=Se[me];for(;;){if(!xe.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(xe)),!xe.parent)break;Pe=xe.range,xe=xe.parent}}return Le})}}class Ie{constructor(N,G){this._documents=N,this._provider=G,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(N,G,ee){const oe=this._documents.getDocument(N),fe=T.Position.to(G),Se=await this._provider.prepareCallHierarchy(oe,fe,ee);if(!!Se){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(Se)?Se.map(me=>this._cacheAndConvertItem(Le,me)):[this._cacheAndConvertItem(Le,Se)]}}async provideCallsTo(N,G,ee){const oe=this._itemFromCache(N,G);if(!oe)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(oe,ee);if(!!fe)return fe.map(Se=>({from:this._cacheAndConvertItem(N,Se.from),fromRanges:Se.fromRanges.map(Le=>T.Range.from(Le))}))}async provideCallsFrom(N,G,ee){const oe=this._itemFromCache(N,G);if(!oe)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(oe,ee);if(!!fe)return fe.map(Se=>({to:this._cacheAndConvertItem(N,Se.to),fromRanges:Se.fromRanges.map(Le=>T.Range.from(Le))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,G){var ee;const oe=this._cache.get(N),fe={_sessionId:N,_itemId:oe.size.toString(36),name:G.name,detail:G.detail,kind:T.SymbolKind.from(G.kind),uri:G.uri,range:T.Range.from(G.range),selectionRange:T.Range.from(G.selectionRange),tags:(ee=G.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return oe.set(fe._itemId,G),fe}_itemFromCache(N,G){const ee=this._cache.get(N);return ee==null?void 0:ee.get(G)}}class Ue{constructor(N,G){this.adapter=N,this.extension=G}}class Re{constructor(N,G,ee,oe,fe,Se,Le){this._adapter=new Map,this._uriTransformer=G,this._proxy=N.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=oe,this._diagnostics=fe,this._logService=Se,this._apiDeprecation=Le}_transformDocumentSelector(N){return(0,A.coalesce)((0,A.asArray)(N).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:T.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new P.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return Re._handlePool++}_withAdapter(N,G,ee,oe,fe=!1){const Se=this._adapter.get(N);if(!Se)return Promise.resolve(oe);if(Se.adapter instanceof G){let Le;Se.extension&&(Le=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${G.name}'`));const me=ee(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(me).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),Pe=>{fe&&Pe instanceof w.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,G){const ee=this._nextHandle();return this._adapter.set(ee,new Ue(N,G)),ee}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,G,ee,oe){const fe=this._addNewAdapter(new c(this._documents,ee),N),Se=oe&&oe.label||Re._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(G),Se),this._createDisposable(fe)}$provideDocumentSymbols(N,G,ee){return this._withAdapter(N,c,oe=>oe.provideDocumentSymbols(y.URI.revive(G),ee),void 0)}registerCodeLensProvider(N,G,ee){const oe=this._nextHandle(),fe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ue(new d(this._documents,this._commands.converter,ee),N)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),fe);let Se=this._createDisposable(oe);if(fe!==void 0){const Le=ee.onDidChangeCodeLenses(me=>this._proxy.$emitCodeLensEvent(fe));Se=P.Disposable.from(Se,Le)}return Se}$provideCodeLenses(N,G,ee){return this._withAdapter(N,d,oe=>oe.provideCodeLenses(y.URI.revive(G),ee),void 0)}$resolveCodeLens(N,G,ee){return this._withAdapter(N,d,oe=>oe.resolveCodeLens(G,ee),void 0)}$releaseCodeLenses(N,G){this._withAdapter(N,d,ee=>Promise.resolve(ee.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(N,G,ee){const oe=this._addNewAdapter(new t(this._documents,ee),N);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition(N,G,ee,oe){return this._withAdapter(N,t,fe=>fe.provideDefinition(y.URI.revive(G),ee,oe),[])}registerDeclarationProvider(N,G,ee){const oe=this._addNewAdapter(new i(this._documents,ee),N);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration(N,G,ee,oe){return this._withAdapter(N,i,fe=>fe.provideDeclaration(y.URI.revive(G),ee,oe),[])}registerImplementationProvider(N,G,ee){const oe=this._addNewAdapter(new u(this._documents,ee),N);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation(N,G,ee,oe){return this._withAdapter(N,u,fe=>fe.provideImplementation(y.URI.revive(G),ee,oe),[])}registerTypeDefinitionProvider(N,G,ee){const oe=this._addNewAdapter(new a(this._documents,ee),N);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition(N,G,ee,oe){return this._withAdapter(N,a,fe=>fe.provideTypeDefinition(y.URI.revive(G),ee,oe),[])}registerHoverProvider(N,G,ee,oe){const fe=this._addNewAdapter(new l(this._documents,ee),N);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(G)),this._createDisposable(fe)}$provideHover(N,G,ee,oe){return this._withAdapter(N,l,fe=>fe.provideHover(y.URI.revive(G),ee,oe),void 0)}registerEvaluatableExpressionProvider(N,G,ee,oe){const fe=this._addNewAdapter(new f(this._documents,ee),N);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(G)),this._createDisposable(fe)}$provideEvaluatableExpression(N,G,ee,oe){return this._withAdapter(N,f,fe=>fe.provideEvaluatableExpression(y.URI.revive(G),ee,oe),void 0)}registerInlineValuesProvider(N,G,ee,oe){const fe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new v(this._documents,ee),N);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(G),fe);let Le=this._createDisposable(Se);if(fe!==void 0){const me=ee.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Le=P.Disposable.from(Le,me)}return Le}$provideInlineValues(N,G,ee,oe,fe){return this._withAdapter(N,v,Se=>Se.provideInlineValues(y.URI.revive(G),ee,oe,fe),void 0)}registerDocumentHighlightProvider(N,G,ee){const oe=this._addNewAdapter(new D(this._documents,ee),N);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights(N,G,ee,oe){return this._withAdapter(N,D,fe=>fe.provideDocumentHighlights(y.URI.revive(G),ee,oe),void 0)}registerLinkedEditingRangeProvider(N,G,ee){const oe=this._addNewAdapter(new h(this._documents,ee),N);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges(N,G,ee,oe){return this._withAdapter(N,h,async fe=>{const Se=await fe.provideLinkedEditingRanges(y.URI.revive(G),ee,oe);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Re._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(N,G,ee){const oe=this._addNewAdapter(new p(this._documents,ee),N);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences(N,G,ee,oe,fe){return this._withAdapter(N,p,Se=>Se.provideReferences(y.URI.revive(G),ee,oe,fe),void 0)}registerCodeActionProvider(N,G,ee,oe){var fe,Se;const Le=new m.DisposableStore,me=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(G),{providedKinds:(fe=oe==null?void 0:oe.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Se=oe==null?void 0:oe.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Re._extLabel(N),Boolean(ee.resolveCodeAction)),Le.add(this._createDisposable(me)),Le}$provideCodeActions(N,G,ee,oe,fe){return this._withAdapter(N,I,Se=>Se.provideCodeActions(y.URI.revive(G),ee,oe,fe),void 0)}$resolveCodeAction(N,G,ee){return this._withAdapter(N,I,oe=>oe.resolveCodeAction(G,ee),void 0)}$releaseCodeActions(N,G){this._withAdapter(N,I,ee=>Promise.resolve(ee.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(N,G,ee){const oe=this._addNewAdapter(new F(this._documents,ee),N);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(N,G,ee,oe){return this._withAdapter(N,F,fe=>fe.provideDocumentFormattingEdits(y.URI.revive(G),ee,oe),void 0)}registerDocumentRangeFormattingEditProvider(N,G,ee){const oe=this._addNewAdapter(new z(this._documents,ee),N);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(N,G,ee,oe,fe){return this._withAdapter(N,z,Se=>Se.provideDocumentRangeFormattingEdits(y.URI.revive(G),ee,oe,fe),void 0)}registerOnTypeFormattingEditProvider(N,G,ee,oe){const fe=this._addNewAdapter(new ue(this._documents,ee),N);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(G),oe,N.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(N,G,ee,oe,fe,Se){return this._withAdapter(N,ue,Le=>Le.provideOnTypeFormattingEdits(y.URI.revive(G),ee,oe,fe,Se),void 0)}registerWorkspaceSymbolProvider(N,G){const ee=this._addNewAdapter(new H(G,this._logService),N);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(N,G,ee){return this._withAdapter(N,H,oe=>oe.provideWorkspaceSymbols(G,ee),{symbols:[]})}$resolveWorkspaceSymbol(N,G,ee){return this._withAdapter(N,H,oe=>oe.resolveWorkspaceSymbol(G,ee),void 0)}$releaseWorkspaceSymbols(N,G){this._withAdapter(N,H,ee=>ee.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(N,G,ee){const oe=this._addNewAdapter(new B(this._documents,ee,this._logService),N);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),B.supportsResolving(ee)),this._createDisposable(oe)}$provideRenameEdits(N,G,ee,oe,fe){return this._withAdapter(N,B,Se=>Se.provideRenameEdits(y.URI.revive(G),ee,oe,fe),void 0)}$resolveRenameLocation(N,G,ee,oe){return this._withAdapter(N,B,fe=>fe.resolveRenameLocation(y.URI.revive(G),ee,oe),void 0)}registerDocumentSemanticTokensProvider(N,G,ee,oe){const fe=this._nextHandle(),Se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ue(new L(this._documents,ee),N)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(G),oe,Se);let Le=this._createDisposable(fe);if(Se){const me=ee.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Le=P.Disposable.from(Le,me)}return Le}$provideDocumentSemanticTokens(N,G,ee,oe){return this._withAdapter(N,L,fe=>fe.provideDocumentSemanticTokens(y.URI.revive(G),ee,oe),null,!0)}$releaseDocumentSemanticTokens(N,G){this._withAdapter(N,L,ee=>ee.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(N,G,ee,oe){const fe=this._addNewAdapter(new U(this._documents,ee),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(G),oe),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(N,G,ee,oe){return this._withAdapter(N,U,fe=>fe.provideDocumentRangeSemanticTokens(y.URI.revive(G),ee,oe),null,!0)}registerCompletionItemProvider(N,G,ee,oe){const fe=this._addNewAdapter(new x(this._documents,this._commands.converter,ee,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(G),oe,x.supportsResolving(ee),`${N.identifier.value}(${oe.join("")})`),this._createDisposable(fe)}$provideCompletionItems(N,G,ee,oe,fe){return this._withAdapter(N,x,Se=>Se.provideCompletionItems(y.URI.revive(G),ee,oe,fe),void 0)}$resolveCompletionItem(N,G,ee){return this._withAdapter(N,x,oe=>oe.resolveCompletionItem(G,ee),void 0)}$releaseCompletionItems(N,G){this._withAdapter(N,x,ee=>ee.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider(N,G,ee,oe){const fe=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,Se=this._addNewAdapter(new Q(this._documents,ee),N);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(G),fe),this._createDisposable(Se)}$provideSignatureHelp(N,G,ee,oe,fe){return this._withAdapter(N,Q,Se=>Se.provideSignatureHelp(y.URI.revive(G),ee,oe,fe),void 0)}$releaseSignatureHelp(N,G){this._withAdapter(N,Q,ee=>ee.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider(N,G,ee){const oe=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new $(this._documents,ee),N);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(G),oe);let Se=this._createDisposable(fe);if(oe!==void 0){const Le=ee.onDidChangeInlineHints(me=>this._proxy.$emitInlineHintsEvent(oe));Se=P.Disposable.from(Se,Le)}return Se}$provideInlineHints(N,G,ee,oe){return this._withAdapter(N,$,fe=>fe.provideInlineHints(y.URI.revive(G),ee,oe),void 0)}registerDocumentLinkProvider(N,G,ee){const oe=this._addNewAdapter(new Z(this._documents,ee),N);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof ee.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(N,G,ee){return this._withAdapter(N,Z,oe=>oe.provideLinks(y.URI.revive(G),ee),void 0)}$resolveDocumentLink(N,G,ee){return this._withAdapter(N,Z,oe=>oe.resolveLink(G,ee),void 0)}$releaseDocumentLinks(N,G){this._withAdapter(N,Z,ee=>ee.releaseLinks(G),void 0)}registerColorProvider(N,G,ee){const oe=this._addNewAdapter(new ie(this._documents,ee),N);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors(N,G,ee){return this._withAdapter(N,ie,oe=>oe.provideColors(y.URI.revive(G),ee),[])}$provideColorPresentations(N,G,ee,oe){return this._withAdapter(N,ie,fe=>fe.provideColorPresentations(y.URI.revive(G),ee,oe),void 0)}registerFoldingRangeProvider(N,G,ee){const oe=this._nextHandle(),fe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ue(new re(this._documents,ee),N)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),fe);let Se=this._createDisposable(oe);if(fe!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Se=P.Disposable.from(Se,Le)}return Se}$provideFoldingRanges(N,G,ee,oe){return this._withAdapter(N,re,fe=>fe.provideFoldingRanges(y.URI.revive(G),ee,oe),void 0)}registerSelectionRangeProvider(N,G,ee){const oe=this._addNewAdapter(new ye(this._documents,ee,this._logService),N);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges(N,G,ee,oe){return this._withAdapter(N,ye,fe=>fe.provideSelectionRanges(y.URI.revive(G),ee,oe),[])}registerCallHierarchyProvider(N,G,ee){const oe=this._addNewAdapter(new Ie(this._documents,ee),N);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy(N,G,ee,oe){return this._withAdapter(N,Ie,fe=>Promise.resolve(fe.prepareSession(y.URI.revive(G),ee,oe)),void 0)}$provideCallHierarchyIncomingCalls(N,G,ee,oe){return this._withAdapter(N,Ie,fe=>fe.provideCallsTo(G,ee,oe),void 0)}$provideCallHierarchyOutgoingCalls(N,G,ee,oe){return this._withAdapter(N,Ie,fe=>fe.provideCallsFrom(G,ee,oe),void 0)}$releaseCallHierarchy(N,G){this._withAdapter(N,Ie,ee=>Promise.resolve(ee.releaseSession(G)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,E.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:Re._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Re._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Re._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:Re._serializeRegExp(N.beforeText),afterText:N.afterText?Re._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?Re._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(Re._serializeOnEnterRule)}setLanguageConfiguration(N,G,ee){let{wordPattern:oe}=ee;if(oe&&(0,E.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const fe=this._nextHandle(),Se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Re._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Re._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Re._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,G,Se),this._createDisposable(fe)}$setWordDefinitions(N){for(const G of N)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(be[195],we([0,1,5,9,7]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(k,E){this._proxy=k.getProxy(y.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,E){await this._proxy.$changeLanguage(k,E);const n=this._documents.getDocumentData(k);if(!n)throw new Error(`document '${k.toString}' NOT found`);return n.document}async tokenAtPosition(k,E){var n;const A=k.version,C=R.Position.from(E),b=await this._proxy.$tokensAtPosition(k.uri,C),m={type:T.StandardTokenType.Other,range:(n=k.getWordRangeAtPosition(E))!==null&&n!==void 0?n:new T.Range(E.line,E.character,E.line,E.character)};if(!b)return m;const r={range:R.Range.to(b.range),type:R.TokenType.to(b.type)};return!r.range.contains(E)||A!==k.version?m:r}}e.ExtHostLanguages=P}),define(be[196],we([0,1,5,19,34]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(k){return k&&k.title}let S=class{constructor(E,n){this._logService=n,this._proxy=E.getProxy(y.MainContext.MainThreadMessageService)}showMessage(E,n,A,C,b){const m={extension:E};let r;typeof C=="string"||P(C)?r=[C,...b]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,r=b),m.useCustom&&(0,T.checkProposedApiEnabled)(E);const s=[];for(let _=0;_<r.length;_++){const g=r[_];if(typeof g=="string")s.push({title:g,handle:_,isCloseAffordance:!1});else if(typeof g=="object"){let{title:w,isCloseAffordance:c}=g;s.push({title:w,isCloseAffordance:!!c,handle:_})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(n,A,m,s).then(_=>{if(typeof _=="number")return r[_]})}};S=qe([Ge(1,R.ILogService)],S),e.ExtHostMessageService=S}),define(be[197],we([0,1,20,3,6,2,29,5,9,7,69,70,22,174,175,53,12,26,56]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends T.Disposable{constructor(v,D,h,p,I){super();this._editorId=v,this.uri=D,this._proxy=h,this._webviewInitData=p,this.document=I,this._onDidReceiveDocumentMessage=new R.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:F=>this._proxy.$postMessage(this._editorId,void 0,F),asWebviewUri:F=>this._asWebviewUri(F)}}onDidReceiveMessage(v,D){var h;this._onDidReceiveDocumentMessage.fire(D),v!==void 0&&((h=this._rendererIdToEmitters.get(v))===null||h===void 0||h.fire(D))}getRendererComm(v){const D=new R.Emitter;return this._rendererIdToEmitters.set(v,D),{editorId:this._editorId,onDidReceiveMessage:D.event,postMessage:h=>this._proxy.$postMessage(this._editorId,v,h),asWebviewUri:h=>this._asWebviewUri(h)}}_asWebviewUri(v){return(0,A.asWebviewUri)(this._webviewInitData,this._editorId,v)}}class d extends T.Disposable{constructor(v,D,h,p){super();this._proxy=v,this._handle=D,this._extension=h,this._provider=p,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(I=>{const F=I==null?void 0:I.uri;this._proxy.$onNotebookKernelChange(this._handle,F)}))}async provideKernels(v,D){const h=await this._provider.provideKernels(v.notebookDocument,D)||[],p=new Map;let I=0;const F=new Set,z=this._kernelToFriendlyId.get(v.uri),ue=h.map(B=>{let K=z==null?void 0:z.get(B);return K===void 0&&(B.id&&F.has(B.id)?K=`${this._extension.identifier.value}_${B.id}_${I++}`:K=`${this._extension.identifier.value}_${B.id||S.generateUuid()}`),p.set(B,K),{id:B.id,friendlyId:K,label:B.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:B.description,detail:B.detail,isPreferred:B.isPreferred,preloads:B.preloads,supportedLanguages:B.supportedLanguages,implementsInterrupt:!!B.interrupt}});this._kernelToFriendlyId.set(v.uri,p);const H=new Map;return p.forEach((B,K)=>{H.set(B,K)}),this._friendlyIdToKernel.set(v.uri,H),ue}getKernelByFriendlyId(v,D){var h;return(h=this._friendlyIdToKernel.get(v))===null||h===void 0?void 0:h.get(D)}async resolveNotebook(v,D,h,p){var I;const F=(I=this._friendlyIdToKernel.get(D.uri))===null||I===void 0?void 0:I.get(v);if(F&&this._provider.resolveKernel)return this._provider.resolveKernel(F,D.notebookDocument,h,p)}async executeNotebook(v,D,h){var p;const I=(p=this._friendlyIdToKernel.get(D.uri))===null||p===void 0?void 0:p.get(v);if(!!I){const F=h.map(z=>E.NotebookCellRange.to(z));return I.executeCellsRequest(D.notebookDocument,F)}}async interruptNotebookExecution(v,D){var h;const p=(h=this._friendlyIdToKernel.get(D.uri))===null||h===void 0?void 0:h.get(v);if(!(!p||!p.interrupt))return p.interrupt(D.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;class o{constructor(v,D){const h=o._Keys.nextId();v.$registerNotebookEditorDecorationType(h,E.NotebookDecorationRenderOptions.from(D)),this.value={key:h,dispose(){v.$removeNotebookEditorDecorationType(h)}}}}e.NotebookEditorDecorationType=o,o._Keys=new s.IdGenerator("NotebookEditorDecorationType");class t{constructor(v,D,h,p,I,F,z){this._textDocumentsAndEditors=h,this._textDocuments=p,this._webviewInitData=I,this.logService=F,this._extensionStoragePaths=z,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new R.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new b.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._proxy=v.getProxy(k.MainContext.MainThreadNotebook),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:ue=>{var H;if(ue&&ue.$mid===12){const B=(H=ue.notebookEditor)===null||H===void 0?void 0:H.notebookUri,K=ue.cell.handle,L=this._documents.get(B),U=L==null?void 0:L.getCell(K);if(U)return U.cell}return ue}})}get activeNotebookEditor(){var v;return(v=this._activeNotebookEditor)===null||v===void 0?void 0:v.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(v=>v.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(v){return this._documents.get(v)}_getNotebookDocument(v){const D=this._documents.get(v);if(!D)throw new Error(`NO notebook document for '${v}'`);return D}_getProviderData(v){const D=this._notebookContentProviders.get(v);if(!D)throw new Error(`NO provider for '${v}'`);return D}registerNotebookContentProvider(v,D,h,p){var I,F,z;if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:v,provider:h});let ue;h.onDidChangeNotebookContentOptions&&(ue=h.onDidChangeNotebookContentOptions(()=>{const K=E.NotebookDocumentContentOptions.from(h.options);this._proxy.$updateNotebookProviderOptions(D,K)}));const H=(I=p==null?void 0:p.viewOptions)===null||I===void 0?void 0:I.filenamePattern.map(K=>E.NotebookExclusiveDocumentPattern.from(K)).filter(K=>K!==void 0);((F=p==null?void 0:p.viewOptions)===null||F===void 0?void 0:F.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${(z=p==null?void 0:p.viewOptions)===null||z===void 0?void 0:z.filenamePattern}`);const B=E.NotebookDocumentContentOptions.from(p);return this._proxy.$registerNotebookProvider({id:v.identifier,location:v.extensionLocation,description:v.description},D,{transientOutputs:B.transientOutputs,transientMetadata:B.transientMetadata,viewOptions:(p==null?void 0:p.viewOptions)&&H?{displayName:p.viewOptions.displayName,filenamePattern:H,exclusive:p.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{ue==null||ue.dispose(),this._notebookContentProviders.delete(D),this._proxy.$unregisterNotebookProvider(D)})}registerNotebookKernelProvider(v,D,h){const p=t._notebookKernelProviderHandlePool++,I=new d(this._proxy,p,v,h);return this._notebookKernelProviders.set(p,I),this._proxy.$registerNotebookKernelProvider({id:v.identifier,location:v.extensionLocation,description:v.description},p,{viewType:D.viewType,filenamePattern:D.filenamePattern?E.NotebookExclusiveDocumentPattern.from(D.filenamePattern):void 0}),new n.Disposable(()=>{I.dispose(),this._notebookKernelProviders.delete(p),this._proxy.$unregisterNotebookKernelProvider(p)})}createNotebookEditorDecorationType(v){return new o(this._proxy,v).value}async openNotebookDocument(v){const D=this._documents.get(v);if(D)return D.notebookDocument;const h=await this._proxy.$tryOpenDocument(v),p=this._documents.get(P.URI.revive(h));return(0,_.assertIsDefined)(p==null?void 0:p.notebookDocument)}_withAdapter(v,D,h){const p=this._documents.get(P.URI.revive(D));if(!p)return[];const I=this._notebookKernelProviders.get(v);return I?h(I,p):[]}async showNotebookDocument(v,D){var h;P.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let p;typeof D=="object"?p={position:E.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:D.selection&&E.NotebookCellRange.from(D.selection),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const I=await this._proxy.$tryShowNotebookDocument(v.uri,v.viewType,p),F=I&&((h=this._editors.get(I))===null||h===void 0?void 0:h.editor);if(F)return F.editor;throw I?new Error(`Could NOT open editor for "${v.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.toString()}".`)}async $provideNotebookKernels(v,D,h){return this._withAdapter(v,D,(p,I)=>p.provideKernels(I,h))}async $resolveNotebookKernel(v,D,h,p,I){await this._withAdapter(v,h,async(F,z)=>{const ue=this._webviewComm.get(D);ue&&await F.resolveNotebook(p,z,ue.contentProviderComm,I)})}async $resolveNotebookEditor(v,D,h){const p=this._notebookContentProviders.get(v),I=P.URI.revive(D),F=this._documents.get(I);if(!(!F||!p)){let z=this._webviewComm.get(h);z||(z=new c(h,I,this._proxy,this._webviewInitData,F),this._webviewComm.set(h,z)),!!p.provider.resolveNotebook&&await p.provider.resolveNotebook(F.notebookDocument,z.contentProviderComm)}}async $executeNotebookKernelFromProvider(v,D,h,p){await this._withAdapter(v,D,async(I,F)=>I.executeNotebook(h,F,p))}registerNotebookSerializer(v,D,h,p){const I=this._handlePool++;this._notebookSerializer.set(I,h);const F=E.NotebookDocumentContentOptions.from(p);return this._proxy.$registerNotebookSerializer(I,{id:v.identifier,location:v.extensionLocation,description:v.description},D,F),(0,T.toDisposable)(()=>{this._proxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(v,D){const h=this._notebookSerializer.get(v);if(!h)throw new Error("NO serializer found");const p=await h.dataToNotebook(D.buffer);return{metadata:E.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(E.NotebookCellData.from)}}async $notebookToData(v,D){const h=this._notebookSerializer.get(v);if(!h)throw new Error("NO serializer found");const p=await h.notebookToData({metadata:E.NotebookDocumentMetadata.to(D.metadata),cells:D.cells.map(E.NotebookCellData.to)});return g.VSBuffer.wrap(p)}async $cancelNotebookCellExecution(v,D,h,p){await this._withAdapter(v,D,async(F,z)=>F.interruptNotebookExecution(h,z));const I=this._documents.get(P.URI.revive(D));if(!!I)for(let F of p)for(let z=F.start;z<F.end;z++){const ue=I.getCellFromIndex(z);ue&&this.cancelOneNotebookCellExecution(ue)}}cancelOneNotebookCellExecution(v){const D=this._activeExecutions.get(v.uri);D==null||D.cancel()}async $openNotebook(v,D,h,p,I){const{provider:F}=this._getProviderData(v),z=await F.openNotebook(P.URI.revive(D),{backupId:h,untitledDocumentData:p==null?void 0:p.buffer},I);return{metadata:E.NotebookDocumentMetadata.from(z.metadata),cells:z.cells.map(E.NotebookCellData.from)}}async $saveNotebook(v,D,h){const p=this._getNotebookDocument(P.URI.revive(D)),{provider:I}=this._getProviderData(v);return await I.saveNotebook(p.notebookDocument,h),!0}async $saveNotebookAs(v,D,h,p){const I=this._getNotebookDocument(P.URI.revive(D)),{provider:F}=this._getProviderData(v);return await F.saveNotebookAs(P.URI.revive(h),I.notebookDocument,p),!0}async $backupNotebook(v,D,h){var p;const I=this._getNotebookDocument(P.URI.revive(D)),F=this._getProviderData(v),z=(p=this._extensionStoragePaths.workspaceValue(F.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(F.extension),ue=String((0,w.hash)([I.uri.toString(),this._backupIdPool++])),H=P.URI.joinPath(z,ue),B=await F.provider.backupNotebook(I.notebookDocument,{destination:H},h);return I.updateBackup(B),B.id}$acceptNotebookActiveKernelChange(v){v.providerHandle!==void 0&&this._withAdapter(v.providerHandle,v.uri,async(D,h)=>{const p=v.kernelFriendlyId?D.getKernelByFriendlyId(P.URI.revive(v.uri),v.kernelFriendlyId):void 0;this._editors.forEach(I=>{I.editor.notebookData===h&&I.editor._acceptKernel(p)}),this._onDidChangeActiveNotebookKernel.fire({document:h.notebookDocument,kernel:p})})}$onDidReceiveMessage(v,D,h){var p;(p=this._webviewComm.get(v))===null||p===void 0||p.onDidReceiveMessage(D,h)}$acceptModelChanged(v,D,h){this._getNotebookDocument(P.URI.revive(v)).acceptModelChanged(D,h)}$acceptDirtyStateChanged(v,D){const h=this._getNotebookDocument(P.URI.revive(v));h.acceptModelChanged({rawEvents:[],versionId:h.notebookDocument.version},D)}$acceptModelSaved(v){const D=this._getNotebookDocument(P.URI.revive(v));this._onDidSaveNotebookDocument.fire(D.notebookDocument)}$acceptEditorPropertiesChanged(v,D){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,D);const h=this._editors.get(v);if(!h)throw new Error(`unknown text editor: ${v}`);D.visibleRanges&&h.editor._acceptVisibleRanges(D.visibleRanges.ranges.map(E.NotebookCellRange.to)),D.selections&&h.editor._acceptSelections(D.selections.selections.map(E.NotebookCellRange.to)),D.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.editor.editor,visibleRanges:h.editor.editor.visibleRanges}),D.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.editor.editor,selections:h.editor.editor.selections}))}$acceptDocumentPropertiesChanged(v,D){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",v.path,D);const h=this._getNotebookDocument(P.URI.revive(v));h.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:h.notebookDocument})}_createExtHostEditor(v,D,h){var p;const I=v.uri;let F=this._webviewComm.get(D);F||(F=new c(D,I,this._proxy,this._webviewInitData,v),this._webviewComm.set(D,F));const z=new r.ExtHostNotebookEditor(D,v.notebookDocument.viewType,this._proxy,v,h.visibleRanges.map(E.NotebookCellRange.to),h.selections.map(E.NotebookCellRange.to),typeof h.viewColumn=="number"?E.ViewColumn.to(h.viewColumn):void 0);(p=this._editors.get(D))===null||p===void 0||p.editor.dispose(),this._editors.set(D,{editor:z})}$acceptDocumentAndEditorsDelta(v){var D,h,p,I;let F=!1;if(v.removedDocuments)for(const ue of v.removedDocuments){const H=P.URI.revive(ue),B=this._documents.get(H);B&&(B.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.notebookDocument.cells.map(K=>K.document.uri)}),this._onDidCloseNotebookDocument.fire(B.notebookDocument));for(const K of this._editors.values())K.editor.notebookData.uri.toString()===H.toString()&&(K.editor.dispose(),this._editors.delete(K.editor.id),F=!0)}if(v.addedDocuments){const ue=[];for(const H of v.addedDocuments){const B=P.URI.revive(H.uri),K=H.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B}`);const L=this,U=new m.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){L._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){L._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){L._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){L._onDidChangeCellExecutionState.fire(x)}},K,H.metadata?E.NotebookDocumentMetadata.to(H.metadata):new n.NotebookDocumentMetadata,B);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),ue.push(...H.cells.map(x=>m.ExtHostCell.asModelAddData(U.notebookDocument,x))),(D=this._documents.get(B))===null||D===void 0||D.dispose(),this._documents.set(B,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:ue}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(v.addedEditors)for(const ue of v.addedEditors){if(this._editors.has(ue.id))return;const H=P.URI.revive(ue.documentUri),B=this._documents.get(H);B&&(this._createExtHostEditor(B,ue.id,ue),F=!0)}const z=[];if(v.removedEditors)for(const ue of v.removedEditors){const H=this._editors.get(ue);H&&(F=!0,this._editors.delete(ue),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===H.editor.id&&(this._activeNotebookEditor=void 0),z.push(H))}if(F&&z.forEach(ue=>{ue.editor.dispose()}),v.visibleEditors){this._visibleNotebookEditors=v.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const ue=new Set;this._visibleNotebookEditors.forEach(H=>ue.add(H.id));for(const H of this._editors.values()){const B=ue.has(H.editor.id);H.editor._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}v.newActiveEditor===null?this._activeNotebookEditor=void 0:v.newActiveEditor&&(this._activeNotebookEditor=(p=this._editors.get(v.newActiveEditor))===null||p===void 0?void 0:p.editor),v.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((I=this._activeNotebookEditor)===null||I===void 0?void 0:I.editor)}createNotebookCellStatusBarItemInternal(v,D,h){const p=new i(this._proxy,this._commandsConverter,v,D,h),I=C.CellUri.parse(v.document.uri);if(I){const F=this._documents.get(I.notebook);if(F){const z=F.getCell(I.handle);z&&R.Event.once(z.onDidDispose)(()=>p.dispose())}}return p}createNotebookCellExecution(v,D,h){const p=this.lookupNotebookDocument(v);if(!p)throw new Error(`Invalid cell uri/index: ${v}, ${D}`);const I=p.getCellFromIndex(D);if(!I)throw new Error(`Invalid cell uri/index: ${v}, ${D}`);if(!this._activeExecutions.has(I.uri)){const F=new l(v,p,I,this._proxy);this._activeExecutions.set(I.uri,F);const z=F.onDidChangeState(()=>{F.state===a.Resolved&&(F.dispose(),z.dispose(),this._activeExecutions.delete(I.uri))});return F.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends T.Disposable{constructor(v,D,h,p,I){super();this._proxy=v,this._commands=D,this._cell=h,this._priority=I,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=p!=null?p:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=u(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(v){this._alignment=v,this.update()}get priority(){return this._priority}set priority(v){this._priority=v,this.update()}get text(){return this._text}set text(v){this._text=v,this.update()}get tooltip(){return this._tooltip}set tooltip(v){this._tooltip=v,this.update()}get command(){var v;return(v=this._command)===null||v===void 0?void 0:v.fromApi}set command(v){var D;((D=this._command)===null||D===void 0?void 0:D.fromApi)!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:this._commands.toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:this._commands.toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var v;if(!this._isDisposed){const D={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(v=this._command)===null||v===void 0?void 0:v.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,D)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function u(f){return Object.freeze({cell:f.cell,get alignment(){return f.alignment},set alignment(v){f.alignment=v},get priority(){return f.priority},set priority(v){f.priority=v},get text(){return f.text},set text(v){f.text=v},get tooltip(){return f.tooltip},set tooltip(v){f.tooltip=v},get command(){return f.command},set command(v){f.command=v},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(v){f.accessibilityInformation=v},show(){f.show()},hide(){f.hide()},dispose(){f.dispose()}})}var a;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(a||(a={}));class l extends T.Disposable{constructor(v,D,h,p){super();this._uri=v,this._document=D,this._cell=h,this._proxy=p,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(v){return this._proxy.$applyEdits(this._uri,v,!1)}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(v){const D=[{editType:11,handle:this._cell.handle,metadata:v}];this.applyEdits(D)}cellIndexToHandle(v){const D=typeof v=="number"?this._document.getCellFromIndex(v):this._cell;if(!!D)return D.handle}asApiObject(){const v=this;return Object.freeze({get document(){return v._document.notebookDocument},get cell(){return v._cell.cell},get executionOrder(){return v._executionOrder},set executionOrder(D){v._executionOrder=D,v.mixinMetadata({executionOrder:D})},start(D){if(v._state===a.Resolved||v._state===a.Started)throw new Error("Cannot call start again");v._state=a.Started,v._onDidChangeState.fire(),v.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:D==null?void 0:D.startTime})},end(D){var h,p;if(v._state===a.Resolved)throw new Error("Cannot call resolve twice");v._state=a.Resolved,v._onDidChangeState.fire(),v.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(h=D==null?void 0:D.success)!==null&&h!==void 0?h:null,lastRunDuration:(p=D==null?void 0:D.duration)!==null&&p!==void 0?p:null})},clearOutput(D){return v.verifyStateForOutput(),this.replaceOutput([],D)},async appendOutput(D,h){v.verifyStateForOutput();const p=v.cellIndexToHandle(h);if(typeof p=="number")return D=Array.isArray(D)?D:[D],v.applyEdits([{editType:2,handle:p,append:!0,outputs:D.map(E.NotebookCellOutput.from)}])},async replaceOutput(D,h){v.verifyStateForOutput();const p=v.cellIndexToHandle(h);if(typeof p=="number")return D=Array.isArray(D)?D:[D],v.applyEdits([{editType:2,handle:p,outputs:D.map(E.NotebookCellOutput.from)}])},async appendOutputItems(D,h){return v.verifyStateForOutput(),D=Array.isArray(D)?D:[D],v.applyEdits([{editType:10,append:!0,items:D.map(E.NotebookCellOutputItem.from),outputId:h}])},async replaceOutputItems(D,h){return v.verifyStateForOutput(),D=Array.isArray(D)?D:[D],v.applyEdits([{editType:10,items:D.map(E.NotebookCellOutputItem.from),outputId:h}])},token:v._tokenSource.token})}}}),define(be[99],we([0,1,5,3,6,26,4,14]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends T.Disposable{constructor(r,s,_,g){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=g,this._id=g.$register(this.name,s,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?P.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(s=>this._proxy.$clear(s,r))}show(r,s){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof r=="boolean"?r:s)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class n extends E{constructor(r,s){super(r,!1,void 0,s)}append(r){super.append(r),this._id.then(s=>this._proxy.$append(s,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class A extends E{constructor(r,s,_){super(r,!0,s,_)}append(r){throw new Error("Not supported")}}class C{constructor(r,s){this.name=r,this._channel=s}append(r){this._channel.then(s=>s.append(r))}appendLine(r){this._channel.then(s=>s.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,s){this._channel.then(_=>_.show(r,s))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=C;let b=class{constructor(r){this._proxy=r.getProxy(y.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,s){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new A(r,s,this._proxy)}};b=qe([Ge(0,k.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[198],we([0,1,13,20,3,6,5,2,7,10,15,46]),function(le,e,y,R,T,P,S,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(m,r,s){const _=m.getProxy(S.MainContext.MainThreadQuickOpen);class g{constructor(a,l){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=l}showQuickPick(a,l,f,v=R.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(a),h=++this._instances,p=_.$show(h,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},v),I={},F=p.then(()=>I);return Promise.race([F,D]).then(z=>{if(z!==I)return D.then(ue=>{const H=[];for(let B=0;B<ue.length;B++){const K=ue[B];let L,U,x,Q,$;typeof K=="string"?L=K:(L=K.label,U=K.description,x=K.detail,Q=K.picked,$=K.alwaysShow),H.push({label:L,description:U,handle:B,detail:x,picked:Q,alwaysShow:$})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{f.onDidSelectItem(ue[B])}),_.$setItems(h,H),p.then(B=>{if(typeof B=="number")return ue[B];if(Array.isArray(B))return B.map(K=>ue[K])})})}).then(void 0,z=>{if(!(0,n.isPromiseCanceledError)(z))return _.$setError(h,z),Promise.reject(z)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,l=R.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,_.$input(a,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,n.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(a){return this._validateInput?(0,y.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,l=R.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!f){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(D=>D.uri.toString()===f.uri.toString())}}createQuickPick(a,l){const f=new t(a,l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(a){const l=new i(a,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(a,l){const f=this._sessions.get(a);f&&f._fireDidChangeValue(l)}$onDidAccept(a){const l=this._sessions.get(a);l&&l._fireDidAccept()}$onDidChangeActive(a,l){const f=this._sessions.get(a);f instanceof t&&f._fireDidChangeActive(l)}$onDidChangeSelection(a,l){const f=this._sessions.get(a);f instanceof t&&f._fireDidChangeSelection(l)}$onDidTriggerButton(a,l){const f=this._sessions.get(a);f&&f._fireDidTriggerButton(l)}$onDidHide(a){const l=this._sessions.get(a);l&&l._fireDidHide()}}class w{constructor(a,l){this._extensionId=a,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((l,f)=>{const v=l===E.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(v,l)}),this.update({buttons:a.map((l,f)=>({iconPath:c(l.iconPath),tooltip:l.tooltip,handle:l===E.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const l=this._handlesToButtons.get(a);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(a){if(!this._disposed){for(const l of Object.keys(a)){const f=a[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function c(u){if(u instanceof E.ThemeIcon)return{id:u.id};const a=o(u),l=d(u);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof l=="string"?k.URI.file(l):l}}function d(u){return typeof u=="object"&&"light"in u?u.light:u}function o(u){return typeof u=="object"&&"dark"in u?u.dark:u}class t extends w{constructor(a,l,f){super(a,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:a.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(a){const l=(0,A.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(a){const l=(0,A.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends w{constructor(a,l){super(a,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?C.default.Error:C.default.Ignore})}}return new g(r,s)}e.createExtHostQuickOpen=b}),define(be[199],we([0,1,2,3,51,6,13,5,15,110,19,25,34]),function(le,e,y,R,T,P,S,k,E,n,A,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(a){if(a)return typeof a.iconPath=="string"?y.URI.file(a.iconPath):a.iconPath}function r(a,l){if(!a.iconPath&&!l.iconPath)return 0;if(a.iconPath){if(!l.iconPath)return 1}else return-1;const f=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,v=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,n.comparePaths)(f,v)}function s(a,l){let f=0;if(a.strikeThrough!==l.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==l.faded)return a.faded?1:-1;if(a.tooltip!==l.tooltip)return(a.tooltip||"").localeCompare(l.tooltip||"");if(f=r(a,l),f!==0)return f;if(a.light&&l.light)f=r(a.light,l.light);else{if(a.light)return 1;if(l.light)return-1}if(f!==0)return f;if(a.dark&&l.dark)f=r(a.dark,l.dark);else{if(a.dark)return 1;if(l.dark)return-1}return f}function _(a,l){if(a.command!==l.command)return a.command<l.command?-1:1;if(a.title!==l.title)return a.title<l.title?-1:1;if(a.tooltip!==l.tooltip){if(a.tooltip!==void 0&&l.tooltip!==void 0)return a.tooltip<l.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(a.arguments===l.arguments)return 0;if(a.arguments)if(l.arguments){if(a.arguments.length!==l.arguments.length)return a.arguments.length-l.arguments.length}else return 1;else return-1;for(let f=0;f<a.arguments.length;f++){const v=a.arguments[f],D=l.arguments[f];if(v!==D)return v<D?-1:1}return 0}function g(a,l){let f=(0,n.comparePaths)(a.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(f!==0)return f;if(a.command&&l.command)f=_(a.command,l.command);else{if(a.command)return 1;if(l.command)return-1}if(f!==0)return f;if(a.decorations&&l.decorations)f=s(a.decorations,l.decorations);else{if(a.decorations)return 1;if(l.decorations)return-1}return f}function w(a,l){for(let f=0;f<a.length;f++)if(a[f]!==l[f])return!1;return!0}function c(a,l){return a.command===l.command&&a.title===l.title&&a.tooltip===l.tooltip&&(a.arguments&&l.arguments?w(a.arguments,l.arguments):a.arguments===l.arguments)}function d(a,l){return(0,E.equals)(a,l,c)}class o{constructor(l,f,v){this._extension=l,this._proxy=f,this._sourceControlHandle=v,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,b.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=o;class t{constructor(l,f,v,D,h){this._proxy=l,this._commands=f,this._sourceControlHandle=v,this._id=D,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,f){const v=this._resourceStatesCommandsMap.get(l);return v?(0,S.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const f=[...this._resourceStates].sort(g),D=(0,E.sortedDiff)(this._resourceSnapshot,f,g).map(I=>{const F=I.toInsert.map(z=>{const ue=this._resourceHandlePool++;this._resourceStatesMap.set(ue,z);const H=z.resourceUri,B=m(z.decorations),K=z.decorations&&m(z.decorations.light)||B,L=z.decorations&&m(z.decorations.dark)||B,U=[];let x;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ye=new P.DisposableStore;x=this._commands.converter.toInternal(z.command,ye),this._resourceStatesDisposablesMap.set(ue,ye)}else this._resourceStatesCommandsMap.set(ue,z.command);K&&U.push(K),L&&L.toString()!==(K==null?void 0:K.toString())&&U.push(L);const Q=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,Z=z.decorations&&!!z.decorations.faded,ie=z.contextValue||"";return{rawResource:[ue,H,U,Q,$,Z,ie,x],handle:ue}});return{start:I.start,deleteCount:I.deleteCount,toInsert:F}}),h=D.map(({start:I,deleteCount:F,toInsert:z})=>[I,F,z.map(ue=>ue.rawResource)]),p=D.reverse();for(const{start:I,deleteCount:F,toInsert:z}of p){const ue=z.map(B=>B.handle),H=this._handlesSnapshot.splice(I,F,...ue);for(const B of H)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(l=this._resourceStatesDisposablesMap.get(B))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=f,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,f,v,D,h,p){this._proxy=f,this._commands=v,this._id=D,this._label=h,this._rootUri=p,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,D,h,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=l;const f=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&d(this._statusBarCommands,l))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=l;const f=(l||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(l,f){const v=new t(this._proxy,this._commands,this.handle,l,f),D=R.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,D),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const l=[],f=[];for(const[v,D]of this.createdResourceGroups){D.dispose();const h=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});R.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),h.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),l.push([v.handle,v.id,v.label,v.features]);const p=v._takeResourceStateSnapshot();p.length>0&&f.push([v.handle,p]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,l,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(f=>{const v=f._takeResourceStateSnapshot();v.length!==0&&l.push([f.handle,v])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,qe([(0,T.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let u=class In{constructor(l,f,v){this._commands=f,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=l.getProxy(k.MainContext.MainThreadSCM),this._telemetry=l.getProxy(k.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===3){const h=this._sourceControls.get(D.sourceControlHandle);if(!h)return D;const p=h.getResourceGroup(D.groupHandle);return p?p.getResourceState(D.handle):D}else if(D&&D.$mid===4){const h=this._sourceControls.get(D.sourceControlHandle);return h?h.getResourceGroup(D.groupHandle):D}else if(D&&D.$mid===5){const h=this._sourceControls.get(D.handle);return h||D}return D}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,f,v,D){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,f,v,D),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const h=In._handlePool++,p=new i(l,this._proxy,this._commands,f,v,D);this._sourceControls.set(h,p);const I=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier))||[];return I.push(p),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(l.identifier),I),p}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const f=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier)),v=f&&f[f.length-1];return v&&v.inputBox}$provideOriginalResource(l,f,v){const D=y.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,D.toString());const h=this._sourceControls.get(l);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(D,v)).then(p=>p||null)}$onInputBoxValueChange(l,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const v=this._sourceControls.get(l);return v&&v.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(l,f,v,D){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,f,v);const h=this._sourceControls.get(l);if(!h)return Promise.resolve(void 0);const p=h.getResourceGroup(f);return p?p.$executeResourceCommand(v,D):Promise.resolve(void 0)}$validateInput(l,f,v){this.logService.trace("ExtHostSCM#$validateInput",l);const D=this._sourceControls.get(l);return!D||!D.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>D.inputBox.validateInput(f,v)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var f,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((f=this._sourceControls.get(l))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};u._handlePool=0,u=qe([Ge(2,A.ILogService)],u),e.ExtHostSCM=u});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[200],we([0,1,7,5,132,6]),function(le,e,y,R,T,P){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class E{constructor(b,m,r,s,_=y.StatusBarAlignment.Left,g,w){S.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,nt(this,S,b),nt(this,k,m),this._id=E.ID_GEN++,this._statusId=r,this._statusName=s,this._alignment=_,this._priority=g,this._accessibilityInformation=w}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!E.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:$e(this,k).toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:$e(this,k).toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,S).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=E.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,S).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,m,this._backgroundColor,this._alignment===y.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=E,S=new WeakMap,k=new WeakMap,E.ID_GEN=0,E.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new y.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),y.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const m={message:b};return this._messages.unshift(m),this._update(),new y.Disposable(()=>{const r=this._messages.indexOf(m);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(b,m){this._proxy=b.getProxy(R.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(b,m,r,s,_){return new E(this._proxy,this._commands,b,m,r,s,_)}setStatusBarMessage(b,m){const r=this._statusMessage.setMessage(b);let s;return typeof m=="number"?s=setTimeout(()=>r.dispose(),m):typeof m!="undefined"&&m.then(()=>r.dispose(),()=>r.dispose()),new y.Disposable(()=>{r.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=A}),define(be[75],we([0,1,5,3,4]),function(le,e,y,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(k){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(y.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,E){this._proxy.$registerExtensionStorageKeysToSync(k,E)}getValue(k,E,n){return this._proxy.$getValue(k,E).then(A=>A||n)}setValue(k,E,n){return this._proxy.$setValue(k,E,n)}$acceptValue(k,E,n){this._onDidChangeStorage.fire({shared:k,key:E,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(be[76],we([0,1,4,27,19,74,2]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,y.createDecorator)("IExtensionStoragePaths");let k=class{constructor(n,A,C){var b;this._logService=A,this._extHostFileSystem=C,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,C=S.URI.joinPath(this._environment.workspaceStorageHome,A);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};k=qe([Ge(0,R.IExtHostInitDataService),Ge(1,T.ILogService),Ge(2,P.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[41],we([0,1,3,5,4,2,14,6,7,133,10,168,20,29,152]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class s{constructor(t,i,u,a){this._proxy=t,this._id=i,this._creationOptions=u,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(f,v=!0){l._checkDisposed(),l._proxy.$sendText(l._id,f,v)},show(f){l._checkDisposed(),l._proxy.$show(l._id,f)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,i,u,a,l,f,v,D,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:u,env:a,waitOnExit:l,strictEnv:f,hideFromUser:v,isFeatureTerminal:D,isExtensionOwnedTerminal:h})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class _{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new y.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new y.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new y.Emitter,this._onProcessTitleChanged=new y.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new y.Emitter,this._onProcessShellTypeChanged=new y.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let g=1,w=class extends k.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new y.Emitter,this._onDidOpenTerminal=new y.Emitter,this._onDidChangeActiveTerminal=new y.Emitter,this._onDidChangeTerminalDimensions=new y.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new y.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new s(this._proxy,(0,m.generateUuid)(),t,t.name),u=new _(t.pty);return i.createExtensionTerminal().then(a=>{const l=this._setupExtHostProcessListeners(a,u);this._terminalProcessDisposables[a]=l}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new _(i),l=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:i})}async $acceptTerminalDimensions(t,i,u){const a=this._getTerminalById(t);a&&a.setDimensions(i,u)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,u){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,u)}async $acceptTerminalTitleChange(t,i){const u=this._getTerminalById(t);u&&(u.name=i)}async $acceptTerminalClosed(t,i){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const a=this._terminals.splice(u,1)[0];a.setExitCode(i),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,i,u,a){if(i){const v=this._getTerminalObjectIndexById(this._terminals,i);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const l={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:P.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},f=new s(this._proxy,t,l,u);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,i){const u=this._getTerminalById(t);u&&u._setProcessId(i)}async $startExtensionTerminal(t,i){const u=this._getTerminalById(t);if(!u)return{message:(0,n.localize)(0,null,t)};u.isOpen||await new Promise(l=>{const f=this.onDidOpenTerminal(async v=>{v===u.value&&(f.dispose(),l())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const u=new k.DisposableStore;u.add(i.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),u.add(i.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,i.onProcessData),u.add(i.onProcessExit(l=>this._onProcessExit(t,l))),i.onProcessOverrideDimensions&&u.add(i.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,i);const a=this._extensionTerminalAwaitingStart[t];return a&&i instanceof _&&(i.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.input(i)}$acceptProcessResize(t,i,u){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,u)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(t,u))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(u=>this._proxy.$sendProcessCwd(t,u))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const l=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const f=[],v={terminal:u.value,line:i},D=[];for(const I of this._linkProviders)D.push(new Promise(async F=>{l.token.onCancellationRequested(()=>F({provider:I,links:[]}));const z=await I.provideTerminalLinks(v,l.token)||[];l.token.isCancellationRequested||F({provider:I,links:z})}));const h=await Promise.all(D);if(l.token.isCancellationRequested)return[];const p=new Map;for(const I of h)I&&I.links.length>0&&f.push(...I.links.map(F=>{const z={id:g++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return p.set(z.id,{provider:I.provider,link:F}),z}));return this._terminalLinkCache.set(t,p),f}$activateLink(t,i){var u;const a=(u=this._terminalLinkCache.get(t))===null||u===void 0?void 0:u.get(i);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const u=this._getTerminalObjectIndexById(t,i);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,i){let u=null;return t.some((a,l)=>a._id===i?(u=l,!0):!1),u}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new c,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const u=(0,C.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const u=i[0],a=new c(i[1]);this._setEnvironmentVariableCollection(u,a)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};w=qe([Ge(1,S.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new y.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:E.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const u=this.map.get(t);(!u||u.value!==i.value||u.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((u,a)=>t.call(i,a,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let d=class extends w{constructor(t){super(!1,t)}createTerminal(t,i,u){throw new A.NotSupportedError}createTerminalFromOptions(t){throw new A.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new A.NotSupportedError}$getAvailableProfiles(t){throw new A.NotSupportedError}async $getDefaultShellAndArgs(t){throw new A.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};d=qe([Ge(0,S.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d}),define(be[201],we([0,1,3,15,5,96,9,7]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(A,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new y.Emitter,this._onDidChangeTextEditorOptions=new y.Emitter,this._onDidChangeTextEditorVisibleRanges=new y.Emitter,this._onDidChangeTextEditorViewColumn=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const C=this._extHostDocumentsAndEditors.allEditors();return A?C:C.map(b=>b.value)}async showTextDocument(A,C,b){let m;typeof C=="number"?m={position:S.ViewColumn.from(C),preserveFocus:b}:typeof C=="object"?m={position:S.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?S.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(A.uri,m),s=r&&this._extHostDocumentsAndEditors.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A){return new P.TextEditorDecorationType(this._proxy,A).value}$acceptEditorPropertiesChanged(A,C){const b=this._extHostDocumentsAndEditors.getEditor(A);if(!b)throw new Error("unknown text editor");if(C.options&&b._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(S.Selection.to);b._acceptSelections(m)}if(C.visibleRanges){const m=R.coalesce(C.visibleRanges.map(S.Range.to));b._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),r=C.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:r,kind:m})}if(C.visibleRanges){const m=R.coalesce(C.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:m})}}$acceptEditorPositionData(A){for(const C in A){const b=this._extHostDocumentsAndEditors.getEditor(C);if(!b)throw new Error("Unknown text editor");const m=S.ViewColumn.to(A[C]);b.value.viewColumn!==m&&(b._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:m}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=E});var dn=this&&this.__rest||function(le,e){var y={};for(var R in le)Object.prototype.hasOwnProperty.call(le,R)&&e.indexOf(R)<0&&(y[R]=le[R]);if(le!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,R=Object.getOwnPropertySymbols(le);T<R.length;T++)e.indexOf(R[T])<0&&Object.prototype.propertyIsEnumerable.call(le,R[T])&&(y[R[T]]=le[R[T]]);return y};define(be[202],we([0,1,2,4,5,6,7]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class k{constructor(A,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:b=>{var m,r;if(b&&b.$mid===11){const s=b.uri===void 0?void 0:y.URI.revive(b.uri);return(r=(m=this._itemsBySourceAndUriMap.get(b.source))===null||m===void 0?void 0:m.get(E(s)))===null||r===void 0?void 0:r.get(b.handle)}return b}})}async $getTimeline(A,C,b,m,r){const s=this._providers.get(A);return s==null?void 0:s.provideTimeline(y.URI.revive(C),b,m,r)}registerTimelineProvider(A,C,b,m){const r=new P.DisposableStore,s=this.convertTimelineItem(C.id,m,r).bind(this);let _;C.onDidChange&&(_=C.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:C.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:A,onDidChange:void 0,async provideTimeline(w,c,d,o){var t;(o==null?void 0:o.resetCache)&&(r.clear(),(t=g.get(C.id))===null||t===void 0||t.clear());const i=await C.provideTimeline(w,c,d);if(i!=null){const u=s(w,o);return Object.assign(Object.assign({},i),{source:C.id,items:i.items.map(u)})}},dispose(){var w;for(const c of g.values())(w=c.get(C.id))===null||w===void 0||w.clear();_==null||_.dispose(),r.dispose()}}))}convertTimelineItem(A,C,b){return(m,r)=>{let s;if(r==null?void 0:r.cacheResults){let _=this._itemsBySourceAndUriMap.get(A);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(A,_));const g=E(m);s=_.get(g),s===void 0&&(s=new Map,_.set(g,s))}return _=>{var g,w;const{iconPath:c}=_,d=dn(_,["iconPath"]),o=`${A}|${(g=_.id)!==null&&g!==void 0?g:_.timestamp}`;s==null||s.set(o,_);let t,i,u;return _.iconPath&&(c instanceof S.ThemeIcon?u={id:c.id}:y.URI.isUri(c)?(t=c,i=c):{light:t,dark:i}=c),Object.assign(Object.assign({},d),{id:(w=d.id)!==null&&w!==void 0?w:void 0,handle:o,source:A,command:_.command?C.toInternal(_.command,b):void 0,icon:t,iconDark:i,themeIcon:u,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{var b;for(const m of this._itemsBySourceAndUriMap.values())(b=m.get(A.id))===null||b===void 0||b.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=k;function E(n){return n==null?void 0:n.toString()}}),define(be[203],we([0,1,6,16,2,5]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,n,A,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=C.schemes.find(m=>!S.supportedSchemes.has(m));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,A),this._proxy.$registerUriOpener(n,C.schemes,E,C.label),(0,y.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(E,n,A){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener with id: ${E}`);const b=T.URI.revive(n);return C.canOpenExternalUri(b,A)}async $openUri(E,n,A){const C=this._openers.get(E);if(!C)throw new Error(`Unknown opener id: '${E}'`);return C.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},A)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[204],we([0,1,5,2,6,10,25]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(y.MainContext.MainThreadUrls)}registerUriHandler(n,A){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=k.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(C,A),this._proxy.$registerUriHandler(C,n),(0,T.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,A){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(R.URI.revive(A))}catch(b){(0,P.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return R.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[49],we([0,1,3,2,69,5]),function(le,e,y,R,T,P){"use strict";var S,k,E,n,A,C,b,m,r,s,_;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(u,a,l,f,v,D,h){S.set(this,void 0),k.set(this,void 0),E.set(this,void 0),n.set(this,void 0),A.set(this,void 0),C.set(this,void 0),b.set(this,""),m.set(this,void 0),r.set(this,!1),s.set(this,!1),this._onMessageEmitter=new y.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,_.set(this,new y.Emitter),this._onDidDispose=$e(this,_).event,nt(this,S,u),nt(this,k,a),nt(this,m,l),nt(this,n,f),nt(this,A,v),nt(this,C,D),nt(this,E,h)}dispose(){nt(this,r,!0),$e(this,_).fire(),$e(this,_).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return nt(this,s,!0),(0,T.asWebviewUri)($e(this,n),$e(this,S),u)}get cspSource(){return $e(this,n).webviewCspSource.replace("{{uuid}}",$e(this,S))}get html(){return this.assertNotDisposed(),$e(this,b)}set html(u){this.assertNotDisposed(),$e(this,b)!==u&&(nt(this,b,u),!$e(this,s)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(nt(this,s,!0),$e(this,E).report("Webview vscode-resource: uris",$e(this,C),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,k).$setHtml($e(this,S),u))}get options(){return this.assertNotDisposed(),$e(this,m)}set options(u){this.assertNotDisposed(),$e(this,k).$setOptions($e(this,S),d($e(this,C),$e(this,A),u)),nt(this,m,u)}async postMessage(u){return $e(this,r)?!1:$e(this,k).$postMessage($e(this,S),u)}assertNotDisposed(){if($e(this,r))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,S=new WeakMap,k=new WeakMap,E=new WeakMap,n=new WeakMap,A=new WeakMap,C=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap;class w{constructor(u,a,l,f,v){this.initData=a,this.workspace=l,this._logService=f,this._deprecationService=v,this._webviews=new Map,this._webviewProxy=u.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(u,a){const l=this.getWebview(u);l&&l._onMessageEmitter.fire(a)}$onMissingCsp(u,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,a,l){const f=new g(u,this._webviewProxy,o(a),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(u,f),f._onDidDispose(()=>{this._webviews.delete(u)}),f}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=w;function c(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=c;function d(i,u,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||t(i,u)}}e.serializeWebviewOptions=d;function o(i){var u;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(u=i.localResourceRoots)===null||u===void 0?void 0:u.map(a=>R.URI.from(a))}}e.reviveOptions=o;function t(i,u){return[...((u==null?void 0:u.getWorkspaceFolders())||[]).map(a=>a.uri),i.extensionLocation]}}),define(be[205],we([0,1,20,56,6,16,24,2,9,49,92,5,7]),function(le,e,y,R,T,P,S,k,E,n,A,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,u){const a=this.key(t,i.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new m(i,u);return this._documents.set(a,l),l}delete(t,i){const u=this.key(t,i.uri);this._documents.delete(u)}key(t,i){return`${t}@@@${i}`}}var s;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(s||(s={}));class _{constructor(){this._providers=new Map}addTextProvider(t,i,u){return this.add(0,t,i,u)}addCustomProvider(t,i,u){return this.add(1,t,i,u)}get(t){return this._providers.get(t)}add(t,i,u,a){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:u,provider:a}),new b.Disposable(()=>this._providers.delete(i))}}class g{constructor(t,i,u,a,l){this._extHostDocuments=i,this._extensionStoragePaths=u,this._extHostWebview=a,this._extHostWebviewPanels=l,this._editorProviders=new _,this._documents=new r,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,u,a){const l=new T.DisposableStore;return w(u)?(l.add(this._editorProviders.addTextProvider(i,t,u)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor})):(l.add(this._editorProviders.addCustomProvider(i,t,u)),this.supportEditing(u)&&l.add(u.onDidChangeCustomDocument(f=>{const v=this.getCustomDocumentEntry(i,f.document.uri);if(c(f)){const D=v.addEdit(f);this._proxy.$onDidEdit(f.document.uri,i,D,f.label)}else this._proxy.$onContentChange(f.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument)),b.Disposable.from(l,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,u,a,l){var f;const v=this._editorProviders.get(i);if(!v)throw new Error(`No provider found for '${i}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${i}'`);const D=k.URI.revive(t),h=await v.provider.openCustomDocument(D,{backupId:u,untitledDocumentData:a==null?void 0:a.buffer},l);let p;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(p=(f=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(i,h,p),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,i){const u=this._editorProviders.get(i);if(!u)throw new Error(`No provider found for '${i}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${i}'`);const a=k.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,a);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,u,a,l,f){const v=this._editorProviders.get(u);if(!v)throw new Error(`No provider found for '${u}'`);const D=E.ViewColumn.to(l),h=this._extHostWebview.createNewWebview(i,a.webviewOptions,v.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(i,u,a.title,D,a.panelOptions,h),I=k.URI.revive(t);switch(v.type){case 1:{const{document:F}=this.getCustomDocumentEntry(u,I);return v.provider.resolveCustomEditor(F,p,f)}case 0:{const F=this._extHostDocuments.getDocument(I);return v.provider.resolveCustomTextEditor(F,p,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,u){this.getCustomDocumentEntry(i,t).disposeEdits(u)}async $onMoveCustomEditor(t,i,u){const a=this._editorProviders.get(u);if(!a)throw new Error(`No provider found for '${u}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const f=k.URI.revive(i),v=this._extHostDocuments.getDocument(f);await a.provider.moveCustomTextEditor(v,l,y.CancellationToken.None)}async $undo(t,i,u,a){return this.getCustomDocumentEntry(i,t).undo(u,a)}async $redo(t,i,u,a){return this.getCustomDocumentEntry(i,t).redo(u,a)}async $revert(t,i,u){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(a.document,u),a.disposeBackup()}async $onSave(t,i,u){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(a.document,u),a.disposeBackup()}async $onSaveAs(t,i,u,a){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,k.URI.revive(u),a)}async $backup(t,i,u){const a=this.getCustomDocumentEntry(i,t),f=await this.getCustomEditorProvider(i).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},u);return a.updateBackup(f),f.id}getCustomDocumentEntry(t,i){const u=this._documents.get(t,k.URI.revive(i));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(t){const i=this._editorProviders.get(t),u=i==null?void 0:i.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function w(o){return typeof o.resolveCustomTextEditor=="function"}function c(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function d(o){const t=o.scheme===P.Schemas.file||o.scheme===P.Schemas.untitled?o.fsPath:o.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[206],we([0,1,3,6,2,29,9,49,5,7]),function(le,e,y,R,T,P,S,k,E,n){"use strict";var A,C,b,m,r,s,_,g,w,c,d,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(f,v,D,h,p,I,F){super();A.set(this,void 0),C.set(this,void 0),b.set(this,void 0),m.set(this,void 0),r.set(this,void 0),s.set(this,void 0),_.set(this,void 0),g.set(this,void 0),w.set(this,!0),c.set(this,!0),d.set(this,!1),o.set(this,this._register(new y.Emitter)),this.onDidDispose=$e(this,o).event,t.set(this,this._register(new y.Emitter)),this.onDidChangeViewState=$e(this,t).event,nt(this,A,f),nt(this,C,v),nt(this,b,D),nt(this,r,I),nt(this,g,p),nt(this,s,h),nt(this,m,F)}dispose(){$e(this,d)||(nt(this,d,!0),$e(this,o).fire(),$e(this,C).$disposeWebview($e(this,A)),$e(this,m).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,m)}get viewType(){return this.assertNotDisposed(),$e(this,b)}get title(){return this.assertNotDisposed(),$e(this,s)}set title(f){this.assertNotDisposed(),$e(this,s)!==f&&(nt(this,s,f),$e(this,C).$setTitle($e(this,A),f))}get iconPath(){return this.assertNotDisposed(),$e(this,_)}set iconPath(f){this.assertNotDisposed(),$e(this,_)!==f&&(nt(this,_,f),$e(this,C).$setIconPath($e(this,A),T.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return $e(this,r)}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,g)=="number"&&$e(this,g)<0))return $e(this,g)}get active(){return this.assertNotDisposed(),$e(this,c)}get visible(){return this.assertNotDisposed(),$e(this,w)}_updateViewState(f){$e(this,d)||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,c,f.active),nt(this,w,f.visible),nt(this,g,f.viewColumn),$e(this,t).fire({webviewPanel:this}))}reveal(f,v){this.assertNotDisposed(),$e(this,C).$reveal($e(this,A),{viewColumn:f?S.ViewColumn.from(f):void 0,preserveFocus:!!v})}assertNotDisposed(){if($e(this,d))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap,g=new WeakMap,w=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,t=new WeakMap;class u{constructor(f,v,D){this.webviews=v,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(f,v,D,h,p={}){const I=typeof h=="object"?h.viewColumn:h,F={viewColumn:S.ViewColumn.from(I),preserveFocus:typeof h=="object"&&!!h.preserveFocus},z=u.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(f),z,v,{title:D,panelOptions:a(p),webviewOptions:(0,k.serializeWebviewOptions)(f,this.workspace,p)},F);const ue=this.webviews.createNewWebview(z,p,f);return this.createNewWebviewPanel(z,v,D,I,p,ue)}$onDidChangeWebviewPanelViewStates(f){const v=Object.keys(f);v.sort((D,h)=>{const p=f[D],I=f[h];return p.active?1:I.active?-1:+p.visible-+I.visible});for(const D of v){const h=this.getWebviewPanel(D);if(!!h){const p=f[D];h._updateViewState({active:p.active,visible:p.visible,viewColumn:S.ViewColumn.to(p.position)})}}}async $onDidDisposeWebviewPanel(f){const v=this.getWebviewPanel(f);v==null||v.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,v,D){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:D,extension:f}),this._proxy.$registerSerializer(v),new n.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(f,v,D,h){const p=this._serializers.get(v);if(!p)throw new Error(`No serializer found for '${v}'`);const{serializer:I,extension:F}=p,z=this.webviews.createNewWebview(f,D.webviewOptions,F),ue=this.createNewWebviewPanel(f,v,D.title,h,D.panelOptions,z);await I.deserializeWebviewPanel(ue,D.state)}createNewWebviewPanel(f,v,D,h,p,I){const F=new i(f,this._proxy,v,D,h,p,I);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=u;function a(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[207],we([0,1,3,6,49,5,7]),function(le,e,y,R,T,P,S){"use strict";var k,E,n,A,C,b,m,r,s,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends R.Disposable{constructor(d,o,t,i,u,a){super();k.set(this,void 0),E.set(this,void 0),n.set(this,void 0),A.set(this,void 0),C.set(this,!1),b.set(this,void 0),m.set(this,void 0),r.set(this,void 0),s.set(this,this._register(new y.Emitter)),this.onDidChangeVisibility=$e(this,s).event,_.set(this,this._register(new y.Emitter)),this.onDidDispose=$e(this,_).event,nt(this,n,t),nt(this,m,i),nt(this,k,d),nt(this,E,o),nt(this,A,u),nt(this,b,a)}dispose(){$e(this,C)||(nt(this,C,!0),$e(this,_).fire(),$e(this,A).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,m)}set title(d){this.assertNotDisposed(),$e(this,m)!==d&&(nt(this,m,d),$e(this,E).$setWebviewViewTitle($e(this,k),d))}get description(){return this.assertNotDisposed(),$e(this,r)}set description(d){this.assertNotDisposed(),$e(this,r)!==d&&(nt(this,r,d),$e(this,E).$setWebviewViewDescription($e(this,k),d))}get visible(){return $e(this,b)}get webview(){return $e(this,A)}get viewType(){return $e(this,n)}_setVisible(d){d===$e(this,b)||$e(this,C)||(nt(this,b,d),$e(this,s).fire())}show(d){this.assertNotDisposed(),$e(this,E).$show($e(this,k),!!d)}assertNotDisposed(){if($e(this,C))throw new Error("Webview is disposed")}}k=new WeakMap,E=new WeakMap,n=new WeakMap,A=new WeakMap,C=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap;class w{constructor(d,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,o,t,i){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(d),o,i),new S.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(d,o,t,i,u){const a=this._viewProviders.get(o);if(!a)throw new Error(`No view provider found for '${o}'`);const{provider:l,extension:f}=a,v=this._extHostWebview.createNewWebview(d,{},f),D=new g(d,this._proxy,o,t,v,!0);this._webviewViews.set(d,D),await l.resolveWebviewView(D,{state:i},u)}async $onDidChangeWebviewViewVisibility(d,o){this.getWebviewView(d)._setVisible(o)}async $disposeWebviewView(d){const o=this.getWebviewView(d);this._webviewViews.delete(d),o.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const o=this._webviewViews.get(d);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=w}),define(be[100],we([0,1,3,5,2,16,8,4,14]),function(le,e,y,R,T,P,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Pn{constructor(C){this._onDidChangeWindowState=new y.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Pn.InitialState,this._proxy=C.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,b){let m;if(typeof C=="string"){m=C;try{C=T.URI.parse(C)}catch(r){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,S.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,b)}async asExternalUri(C,b){if((0,S.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,b);return T.URI.from(m)}};n.InitialState={focused:!0},n=qe([Ge(0,E.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[208],we([0,1,19,5,27,14]),function(le,e,y,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends y.AbstractLogger{constructor(E,n){super();this._proxy=E.getProxy(R.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(E){this.setLevel(E)}trace(E,...n){this.getLevel()<=y.LogLevel.Trace&&this._proxy.$log(this._logFile,y.LogLevel.Trace,Array.from(arguments))}debug(E,...n){this.getLevel()<=y.LogLevel.Debug&&this._proxy.$log(this._logFile,y.LogLevel.Debug,Array.from(arguments))}info(E,...n){this.getLevel()<=y.LogLevel.Info&&this._proxy.$log(this._logFile,y.LogLevel.Info,Array.from(arguments))}warn(E,...n){this.getLevel()<=y.LogLevel.Warning&&this._proxy.$log(this._logFile,y.LogLevel.Warning,Array.from(arguments))}error(E,...n){this.getLevel()<=y.LogLevel.Error&&this._proxy.$log(this._logFile,y.LogLevel.Error,Array.from(arguments))}critical(E,...n){this.getLevel()<=y.LogLevel.Critical&&this._proxy.$log(this._logFile,y.LogLevel.Critical,Array.from(arguments))}flush(){}};S=qe([Ge(0,P.IExtHostRpcService),Ge(1,T.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[209],we([0,1,13,20,10,3,6,111,182,97,26]),function(le,e,y,R,T,P,S,k,E,n,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(a,l){try{return JSON.stringify(a,l)}catch(f){return"null"}}function m(a,l){return JSON.stringify(a,l)}function r(a){return a?(l,f)=>f&&f.$mid===1?a.transformOutgoing(f):f:null}var s;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},w=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class d extends S.Disposable{constructor(l,f=null,v=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=f,this._uriTransformer=v,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,h=n.ProxyIdentifier.count;D<h;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new y.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,k.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:f,sid:v}=l;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,v)),this._proxies[f]}_createProxy(l,f){let v={get:(D,h)=>(typeof h=="string"&&!D[h]&&h.charCodeAt(0)===36&&(D[h]=(...p)=>this._remoteCall(l,h,p)),h===c?f:D[h])};return new Proxy(Object.create(null),v)}set(l,f){return this._locals[l.nid]=f,f}assertRegistered(l){for(let f=0,v=l.length;f<v;f++){const D=l[f];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const f=l.byteLength,v=o.read(l,0),D=v.readUInt8(),h=v.readUInt32();switch(D){case 1:case 2:{let{rpcId:p,method:I,args:F}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,h,p,I,F,D===2);break}case 3:case 4:{let{rpcId:p,method:I,args:F}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,h,p,I,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(f,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(f,h);break}case 7:{this._receiveReply(f,h,void 0);break}case 9:{let p=t.deserializeReplyOKJSON(v);this._uriTransformer&&(p=(0,k.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReply(f,h,p);break}case 8:{let p=t.deserializeReplyOKVSBuffer(v);this._receiveReply(f,h,p);break}case 10:{let p=t.deserializeReplyErrError(v);this._uriTransformer&&(p=(0,k.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReplyErr(f,h,p);break}case 11:{this._receiveReplyErr(f,h,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,f,v,D,h,p){this._logger&&this._logger.logIncoming(l,f,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(v)}.${D}(`,h);const I=String(f);let F,z;if(p){const H=new R.CancellationTokenSource;h.push(H.token),F=this._invokeHandler(v,D,h),z=()=>H.cancel()}else F=this._invokeHandler(v,D,h),z=g;this._cancelInvokedHandlers[I]=z;const ue=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(ue.byteLength,f,1,"ack"),this._protocol.send(ue),F.then(H=>{delete this._cancelInvokedHandlers[I];const B=t.serializeReplyOK(f,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,f,1,"reply:",H),this._protocol.send(B)},H=>{delete this._cancelInvokedHandlers[I];const B=t.serializeReplyErr(f,H);this._logger&&this._logger.logOutgoing(B.byteLength,f,1,"replyErr:",H),this._protocol.send(B)})}_receiveCancel(l,f){this._logger&&this._logger.logIncoming(l,f,1,"receiveCancel");const v=String(f);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(l,f,v){this._logger&&this._logger.logIncoming(l,f,0,"receiveReply:",v);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const h=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],h.resolveOk(v)}}_receiveReplyErr(l,f,v){this._logger&&this._logger.logIncoming(l,f,0,"receiveReplyErr:",v);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const h=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let p;v&&(v.$isError?(p=new Error,p.name=v.name,p.message=v.message,p.stack=v.stack):p=v),h.resolveErr(p)}}_invokeHandler(l,f,v){try{return Promise.resolve(this._doInvokeHandler(l,f,v))}catch(D){return Promise.reject(D)}}_doInvokeHandler(l,f,v){const D=this._locals[l];if(!D)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(l));let h=D[f];if(typeof h!="function")throw new Error("Unknown method "+f+" on actor "+(0,n.getStringIdentifierForProxy)(l));return h.apply(D,v)}_remoteCall(l,f,v){if(this._isDisposed)return Promise.reject(T.canceled());let D=null;if(v.length>0&&R.CancellationToken.isCancellationToken(v[v.length-1])&&(D=v.pop()),D&&D.isCancellationRequested)return Promise.reject(T.canceled());const h=t.serializeRequestArguments(v,this._uriReplacer),p=++this._lastMessageId,I=String(p),F=new E.LazyPromise;D&&D.onCancellationRequested(()=>{const ue=t.serializeCancel(p);this._logger&&this._logger.logOutgoing(ue.byteLength,p,0,"cancel"),this._protocol.send(t.serializeCancel(p))}),this._pendingRPCReplies[I]=F,this._onWillSendRequest(p);const z=t.serializeRequest(p,l,f,h,!!D);return this._logger&&this._logger.logOutgoing(z.byteLength,p,0,`request: ${(0,n.getStringIdentifierForProxy)(l)}.${f}(`,v),this._protocol.send(z),F}}e.RPCProtocol=d,C=w,d.UNRESPONSIVE_TIME=3*1e3;class o{constructor(l,f){this._buff=l,this._offset=f}static alloc(l,f,v){let D=new o(A.VSBuffer.alloc(v+1+4),0);return D.writeUInt8(l),D.writeUInt32(f),D}static read(l,f){return new o(l,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,f}static sizeMixedArray(l,f){let v=0;v+=1;for(let D=0,h=l.length;D<h;D++){const p=l[D],I=f[D];switch(v+=1,I){case 1:v+=this.sizeLongString(p);break;case 2:v+=this.sizeVSBuffer(p);break;case 3:break}}return v}writeMixedArray(l,f){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let v=0,D=l.length;v<D;v++){const h=l[v];switch(f[v]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(l);for(let v=0;v<l;v++)switch(this.readUInt8()){case 1:f[v]=this.readLongString();break;case 2:f[v]=this.readVSBuffer();break;case 3:f[v]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(l){for(let f=0,v=l.length;f<v;f++)if(l[f]instanceof A.VSBuffer||typeof l[f]=="undefined")return!0;return!1}static serializeRequestArguments(l,f){if(this._arrayContainsBufferOrUndefined(l)){let v=[],D=[];for(let h=0,p=l.length;h<p;h++){const I=l[h];I instanceof A.VSBuffer?(v[h]=I,D[h]=2):typeof I=="undefined"?(v[h]=A.VSBuffer.alloc(0),D[h]=3):(v[h]=A.VSBuffer.fromString(m(I,f)),D[h]=1)}return{type:"mixed",args:v,argsType:D}}return{type:"simple",args:m(l,f)}}static serializeRequest(l,f,v,D,h){return D.type==="mixed"?this._requestMixedArgs(l,f,v,D.args,D.argsType,h):this._requestJSONArgs(l,f,v,D.args,h)}static _requestJSONArgs(l,f,v,D,h){const p=A.VSBuffer.fromString(v),I=A.VSBuffer.fromString(D);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(p),F+=o.sizeLongString(I);let z=o.alloc(h?2:1,l,F);return z.writeUInt8(f),z.writeShortString(p),z.writeLongString(I),z.buffer}static deserializeRequestJSONArgs(l){const f=l.readUInt8(),v=l.readShortString(),D=l.readLongString();return{rpcId:f,method:v,args:JSON.parse(D)}}static _requestMixedArgs(l,f,v,D,h,p){const I=A.VSBuffer.fromString(v);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(I),F+=o.sizeMixedArray(D,h);let z=o.alloc(p?4:3,l,F);return z.writeUInt8(f),z.writeShortString(I),z.writeMixedArray(D,h),z.buffer}static deserializeRequestMixedArgs(l){const f=l.readUInt8(),v=l.readShortString(),D=l.readMixedArray(),h=new Array(D.length);for(let p=0,I=D.length;p<I;p++){const F=D[p];typeof F=="string"?h[p]=JSON.parse(F):h[p]=F}return{rpcId:f,method:v,args:h}}static serializeAcknowledged(l){return o.alloc(5,l,0).buffer}static serializeCancel(l){return o.alloc(6,l,0).buffer}static serializeReplyOK(l,f,v){return typeof f=="undefined"?this._serializeReplyOKEmpty(l):f instanceof A.VSBuffer?this._serializeReplyOKVSBuffer(l,f):this._serializeReplyOKJSON(l,b(f,v))}static _serializeReplyOKEmpty(l){return o.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,f){let v=0;v+=o.sizeVSBuffer(f);let D=o.alloc(8,l,v);return D.writeVSBuffer(f),D.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,f){const v=A.VSBuffer.fromString(f);let D=0;D+=o.sizeLongString(v);let h=o.alloc(9,l,D);return h.writeLongString(v),h.buffer}static deserializeReplyOKJSON(l){const f=l.readLongString();return JSON.parse(f)}static serializeReplyErr(l,f){return f?this._serializeReplyErrEror(l,f):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,f){const v=A.VSBuffer.fromString(b(T.transformErrorForSerialization(f),null));let D=0;D+=o.sizeLongString(v);let h=o.alloc(10,l,D);return h.writeLongString(v),h.buffer}static deserializeReplyErrError(l){const f=l.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(l){return o.alloc(11,l,0).buffer}}var i;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var u;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(u||(u={}))}),define(be[210],we([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const y=function(P){const S=k=>{self.removeEventListener("message",S);const E=k.data;Object.defineProperties(self,{postMessage:{value(n,A){E.postMessage(n,A)}},onmessage:{get(){return E.onmessage},set(n){E.onmessage=n}}}),E.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",S)}.toString();class R extends EventTarget{constructor(P,S,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${y})('${S}'))`,n=new Blob([E],{type:"application/javascript"}),A=URL.createObjectURL(n),C=new MessageChannel,b=A,m={type:"_newWorker",id:b,port:C.port2,url:A,options:k};P(m,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:b};C.port1.postMessage(r),URL.revokeObjectURL(A),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(r){C.port1.onmessage=r}},onmessageerror:{get(){return C.port1.onmessageerror},set(r){C.port1.onmessageerror=r}}}),C.port1.addEventListener("messageerror",r=>{const s=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(s)}),C.port1.addEventListener("message",r=>{const s=new MessageEvent("message",{data:r.data});this.dispatchEvent(s)}),C.port1.start()}}e.NestedWorker=R}),define(be[211],we([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,y.createDecorator)("remoteAgentService")}),define(be[212],we([0,1,16,11,21,2,4,211]),function(le,e,y,R,T,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let E=class{constructor(A,C){this.localUserHome=A,this.remoteAgentService=C,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||T.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||A})()}async userHome(A){return(A==null?void 0:A.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(A=>A===1?R.win32:R.posix)}async fileURI(A){let C="";if(await this.resolveOS===1&&(A=A.replace(/\\/g,"/")),A[0]==="/"&&A[1]==="/"){const m=A.indexOf("/",2);m===-1?(C=A.substring(2),A="/"):(C=A.substring(2,m),A=A.substring(m)||"/")}return P.URI.from({scheme:y.Schemas.file,authority:C,path:A,query:"",fragment:""})}};E=qe([Ge(1,k.IRemoteAgentService)],E),e.AbstractPathService=E}),define(be[42],we([0,1,15,28,23,38,8,4,11,10]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",C=" characters skipped \u27EB",b=(A.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var m;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function s(L){return!!L.preview}e.resultIsMatch=s;function _(L){return!!L.resource}e.isFileMatch=_;function g(L){return!!L.message}e.isProgressMessage=g;var w;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(w=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=c;class d{constructor(U,x,Q){this.ranges=x;const $=Array.isArray(x)?x:[x];if(Q&&Q.matchLines===1&&o($)){U=(0,S.getNLines)(U,Q.matchLines);let Z="",ie=0,re=0;const ye=Math.floor(Q.charsPerLine/5),Ie=[];for(const Ue of $){const Re=Math.max(Ue.startColumn-ye,0),ze=Ue.startColumn+Q.charsPerLine;if(Re>re+ye+b){const N=A+(Re-re)+C;Z+=N+U.slice(Re,ze),ie+=Re-(re+N.length)}else Z+=U.slice(re,ze);Ie.push(new i(0,Ue.startColumn-ie,Ue.endColumn-ie)),re=ze}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const Z=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:U,matches:(0,y.mapArrayOrNot)(x,ie=>new t(ie.startLineNumber-Z,ie.startColumn,ie.endLineNumber-Z,ie.endColumn))}}}}e.TextSearchMatch=d;function o(L){const U=L[0].startLineNumber;for(const x of L)if(x.startLineNumber!==U||x.endLineNumber!==U)return!1;return!0}class t{constructor(U,x,Q,$){this.startLineNumber=U,this.startColumn=x,this.endLineNumber=Q,this.endColumn=$}}e.SearchRange=t;class i extends t{constructor(U,x,Q){super(U,x,U,Q)}}e.OneLineRange=i;var u;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function a(L,U=!0){const x=L&&L.files&&L.files.exclude,Q=U&&L&&L.search&&L.search.exclude;if(!(!x&&!Q)){if(!x||!Q)return x||Q;let $=Object.create(null);return $=T.mixin($,T.deepClone(x)),$=T.mixin($,T.deepClone(Q),!0),$}}e.getExcludes=a;function l(L,U){return L.excludePattern&&R.match(L.excludePattern,U)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,U)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(x=>{const Q=x.folder.fsPath;if(P.isEqualOrParent(U,Q)){const $=E.relative(Q,U);return!x.includePattern||!!R.match(x.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(U,x){super(U);this.code=x}}e.SearchError=v;function D(L){const U=L.message;if((0,n.isPromiseCanceledError)(L))return new v(U,f.canceled);try{const x=JSON.parse(U);return new v(x.message,x.code)}catch(x){return new v(U,f.other)}}e.deserializeSearchError=D;function h(L){const U={message:L.message,code:L.code};return new Error(JSON.stringify(U))}e.serializeSearchError=h;function p(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=p;function I(L){return L.type==="success"}e.isSerializedSearchSuccess=I;function F(L){return!!L.path}e.isSerializedFileMatch=F;function z(L,U){const x=L.searchPath?L.searchPath:L.relativePath;return(0,S.fuzzyContains)(x,U)}e.isFilePatternMatch=z;class ue{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ue;function H(L,U){const x=Object.assign(Object.assign({},L||{}),U||{});return Object.keys(x).filter(Q=>{const $=x[Q];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=H;class B{constructor(U,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let Q=U.includePattern;x.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),x.includePattern):Q=x.includePattern),Q&&(this._parsedIncludeExpression=R.parse(Q))}includedInQuerySync(U,x,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,x,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,x,Q))}includedInQuery(U,x,Q){return Promise.resolve(this._parsedExcludeExpression(U,x,Q)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,x,Q)).then(ie=>!!ie):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=B;function K(L){for(const U in L)if(typeof L[U]!="boolean")return!0;return!1}}),define(be[31],we([0,1,15,13,20,3,22,16,78,24,8,12,2,135,4,19,149,47,48,27,14,7,42,5]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c,d,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(I,F,z){return new n.ExtUri(ue=>v(ue,z)).isEqual(I,F)}function a(I,F,z){return u(I.uri,F.uri,z)?0:(0,A.compare)(I.uri.toString(),F.uri.toString())}function l(I,F,z){return I.index!==F.index?I.index<F.index?-1:1:u(I.uri,F.uri,z)?(0,A.compare)(I.name,F.name):(0,A.compare)(I.uri.toString(),F.uri.toString())}function f(I,F,z,ue){const H=I.slice(0).sort((K,L)=>z(K,L,ue)),B=F.slice(0).sort((K,L)=>z(K,L,ue));return(0,y.delta)(H,B,(K,L)=>z(K,L,ue))}function v(I,F){const z=F.getCapabilities(I.scheme);return!(z&&z&1024)}class D extends g.Workspace{constructor(F,z,ue,H,B,K){super(F,ue.map(L=>new g.WorkspaceFolder(L)),H,K);this._name=z,this._isUntitled=B,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(K),ue.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,z,ue,H){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:K,folders:L,configuration:U,isUntitled:x}=F,Q=[],$=z;z?L.forEach((ye,Ie)=>{const Ue=b.URI.revive(ye.uri),Re=D._findFolder(ue||z,Ue,H);Re?(Re.name=ye.name,Re.index=ye.index,Q.push(Re)):Q.push({uri:Ue,name:ye.name,index:Ie})}):Q.push(...L.map(({uri:ye,name:Ie,index:Ue})=>({uri:b.URI.revive(ye),name:Ie,index:Ue}))),Q.sort((ye,Ie)=>ye.index<Ie.index?-1:1);const Z=new D(B,K,Q,U?b.URI.revive(U):null,!!x,ye=>v(ye,H)),{added:ie,removed:re}=f($?$.workspaceFolders:[],Z.workspaceFolders,a,H);return{workspace:Z,added:ie,removed:re}}static _findFolder(F,z,ue){for(let H=0;H<F.folders.length;H++){const B=F.workspaceFolders[H];if(u(B.uri,z,ue))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,z){return z&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let h=class{constructor(F,z,ue,H){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unknown,this._logService=H,this._extHostFileSystemInfo=ue,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const B=z.workspace;this._confirmedWorkspace=B?new D(B.id,B.name,[],B.configuration?b.URI.revive(B.configuration):null,!!B.isUntitled,K=>v(K,ue)):void 0}$initializeWorkspace(F,z){this._workspaceTrustState=z,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:k.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,ue,...H){const B=[];if(Array.isArray(H)&&H.forEach(Q=>{b.URI.isUri(Q.uri)&&!B.some($=>u($.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[z,ue].some(Q=>typeof Q!="number"||Q<0)||ue===0&&B.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+ue>K.length)return!1;const L=K.slice(0);L.splice(z,ue,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<L.length;Q++){const $=L[Q];if(L.some((Z,ie)=>ie!==Q&&u($.uri,Z.uri,this._extHostFileSystemInfo)))return!1}L.forEach((Q,$)=>Q.index=$);const{added:U,removed:x}=f(K,L,l,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,z,ue,B).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,Q,$.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,z){let ue,H="";if(typeof F=="string"?(ue=b.URI.file(F),H=F):typeof F!="undefined"&&(ue=F,H=F.fsPath),!ue)return H;const B=this.getWorkspaceFolder(ue,!0);if(!B)return H;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let K=(0,n.relativePath)(B.uri,ue);return z&&B.name&&(K=`${B.name}/${K}`),K}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:ue,removed:H}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ue,removed:H}))}findFiles(F,z,ue,H,B=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let K;if(z===null?K=!1:z&&(typeof z=="string"?K=z:K=z.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:U}=p(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(K),(0,C.withUndefinedAsNull)(ue),B).then(x=>Array.isArray(x)?x.map(Q=>b.URI.revive(Q)):[])}async findTextInFiles(F,z,ue,H,B=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),L=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:U,folder:x}=p(z.include),Q=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:L,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:U,excludePattern:Q},Z=!1;if(this._activeSearchCallbacks[K]=ie=>{if(!Z){const re=b.URI.revive(ie.resource);ie.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?ue({uri:re,preview:{text:ye.preview.text,matches:(0,y.mapArrayOrNot)(ye.preview.matches,Ie=>new o.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))},ranges:(0,y.mapArrayOrNot)(ye.ranges,Ie=>new o.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))}):ue({uri:re,text:ye.text,lineNumber:ye.lineNumber})})}},B.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(x),$,K,B);return delete this._activeSearchCallbacks[K],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[K],ie}}$handleTextSearchResult(F,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};h=qe([Ge(0,d.IExtHostRpcService),Ge(1,c.IExtHostInitDataService),Ge(2,w.IExtHostFileSystemInfo),Ge(3,s.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function p(I){let F,z;return I&&(typeof I=="string"?F=I:(F=I.pattern,z=I.baseFolder||b.URI.file(I.base))),{includePattern:F,folder:z}}}),define(be[35],we([0,1,23,3,31,5,7,151,66,12,13,4,14,19,2]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(i,u){if(u){const a=u.split(".");let l=i;for(let f=0;l&&f<a.length;f++)l=l[a[f]];return l}}function _(i){return i instanceof r.URI}function g(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(_(i))return{resource:i};if(g(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let o=class{constructor(u,a,l){this._proxy=u.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=l,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,a){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(u,a))}};o=qe([Ge(0,b.IExtHostRpcService),Ge(1,T.IExtHostWorkspace),Ge(2,m.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(u,a,l,f){this._onDidChangeConfiguration=new R.Emitter,this._proxy=u,this._logService=f,this._extHostWorkspace=a,this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,a){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,l))}getConfiguration(u,a,l){const f=d(a)||{},v=this._toReadonlyValue(u?s(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,f,l==null?void 0:l.identifier);function D(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(p){return typeof s(v,p)!="undefined"},get:(p,I)=>{this._validateConfigurationAccess(u?`${u}.${p}`:p,f,l==null?void 0:l.identifier);let F=s(v,p);if(typeof F=="undefined")F=I;else{let z;const ue=(H,B)=>{let K;const L=()=>{z=z||(0,y.deepClone)(v),K=K||s(z,B)};return(0,n.isObject)(H)?new Proxy(H,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return L(),()=>K;if(z)return K=K||s(z,B),K[x];const Q=U[x];return typeof x=="string"?ue(Q,`${B}.${x}`):Q},set:(U,x,Q)=>(L(),K&&(K[x]=Q),!0),deleteProperty:(U,x)=>(L(),K&&delete K[x],!0),defineProperty:(U,x,Q)=>(L(),K&&Object.defineProperty(K,x,Q),!0)}):H};F=ue(F,p)}return F},update:(p,I,F,z)=>{p=u?`${u}.${p}`:p;const ue=D(F);return I!==void 0?this._proxy.$updateConfigurationOption(ue,p,I,f,z):this._proxy.$removeConfigurationOption(ue,p,f,z)},inspect:p=>{var I,F,z,ue,H,B,K,L;p=u?`${u}.${p}`:p;const U=(0,y.deepClone)(this._configuration.inspect(p,f,this._extHostWorkspace.workspace));if(U)return{key:p,defaultValue:(I=U.default)===null||I===void 0?void 0:I.value,globalValue:(F=U.user)===null||F===void 0?void 0:F.value,workspaceValue:(z=U.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(ue=U.workspaceFolder)===null||ue===void 0?void 0:ue.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(B=U.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(K=U.workspace)===null||K===void 0?void 0:K.override,workspaceFolderLanguageValue:(L=U.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:U.overrideIdentifiers}}};return typeof v=="object"&&(0,y.mixin)(h,v,!1),Object.freeze(h)}_toReadonlyValue(u){const a=l=>(0,n.isObject)(l)?new Proxy(l,{get:(f,v)=>a(f[v]),set:(f,v,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(f,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(f,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return a(u)}_validateConfigurationAccess(u,a,l){const f=E.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),v=l?`[${l.value}] `:"";if(f===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(a==null?void 0:a.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,a){const l=new k.ConfigurationChangeEvent(u,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,v)=>l.affectsConfiguration(f,d(v))})}_toMap(u){return u.reduce((a,l)=>(a.set(l[0],l[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[101],we([0,1,2,13,3,5,7,31,40,35,20,41,14,27,4,16,21,19,72,167,10]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c,d){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function B(L){if(L!=null)return L}H.from=B;function K(L){if(L!=null)return L}H.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(H){function B(L){if(L!=null)return L}H.from=B;function K(L){if(L!=null)return L}H.to=K})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(H){function B(L){if(L!=null)return L}H.from=B;function K(L){if(L!=null)return L}H.to=K})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(H){function B(U){if(U){const x=U;return x&&!!x.process}else return!1}H.is=B;function K(U){if(U!=null){const x={process:U.process,args:U.args};return U.options&&(x.options=u.from(U.options)),x}}H.from=K;function L(U){if(U!=null)return new S.ProcessExecution(U.process,U.args,U.options)}H.to=L})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(H){function B(L){if(L!=null)return L}H.from=B;function K(L){if(L!=null)return L}H.to=K})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(H){function B(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=B;function K(U){if(U!=null){const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=l.from(U.options)),x}}H.from=K;function L(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new S.ShellExecution(U.commandLine,U.options):new S.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=L})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(H){function B(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}H.is=B;function K(U){return{customExecution:"customExecution"}}H.from=K;function L(U,x){return x.get(U)}H.to=L})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(H){function B(K,L){let U;return K.scope!==void 0&&typeof K.scope!="number"?U=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===S.TaskScope.Workspace&&L&&L.workspaceFile?U=L.workspaceFile:U=c.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:U}}H.from=B})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(H){function B(U,x){if(U==null)return[];const Q=[];for(let $ of U){const Z=K($,x);Z&&Q.push(Z)}return Q}H.fromMany=B;function K(U,x){if(U!=null){let Q;U.execution instanceof S.ProcessExecution?Q=a.from(U.execution):U.execution instanceof S.ShellExecution?Q=f.from(U.execution):U.execution&&U.execution instanceof S.CustomExecution&&(Q=v.from(U.execution));const $=t.from(U.definition);let Z;if(U.scope?typeof U.scope=="number"?Z=U.scope:Z=U.scope.uri:Z=S.TaskScope.Workspace,!(!$||!Z)){const ie=U.group?U.group.id:void 0;return{_id:U._id,definition:$,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:Z},execution:Q,isBackground:U.isBackground,group:ie,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=K;async function L(U,x,Q){if(U!=null){let $;a.is(U.execution)?$=a.to(U.execution):f.is(U.execution)?$=f.to(U.execution):v.is(U.execution)&&($=v.to(U._id,Q));const Z=t.to(U.definition);let ie;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?ie=U.source.scope:ie=await x.resolveWorkspaceFolder(y.URI.revive(U.source.scope)):ie=S.TaskScope.Workspace),!(!Z||!ie)){const re=new S.Task(Z,ie,U.name,U.source.label,$,U.problemMatchers);return U.isBackground!==void 0&&(re.isBackground=U.isBackground),U.group!==void 0&&(re.group=S.TaskGroup.from(U.group)),U.presentationOptions&&(re.presentationOptions=i.to(U.presentationOptions)),U._id&&(re._id=U._id),U.detail&&(re.detail=U.detail),re}}}H.to=L})(h=e.TaskDTO||(e.TaskDTO={}));var p;(function(H){function B(L){return L}H.from=B;function K(L){if(!!L)return Object.assign(Object.create(null),L)}H.to=K})(p=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(B,K,L){this._id=K,this._task=L,o.set(this,void 0),nt(this,o,B)}get task(){return this._task}terminate(){$e(this,o).terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}o=new WeakMap;var F;(function(H){function B(K){return{id:K._id,task:void 0}}H.from=B})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(B,K,L,U,x,Q,$,Z){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=B.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=U,this._configurationService=x,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,K,L){if(!L)return new S.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:K,provider:L,extension:B}),this._proxy.$registerTaskProvider(U,K),new S.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(B,K){this._proxy.$registerTaskSystem(B,K)}fetchTasks(B){return this._proxy.$fetchTasks(p.from(B)).then(async K=>{const L=[];for(let U of K){const x=await h.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&L.push(x)}return L})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(K=>B.push(K)),B}terminateTask(B){if(!(B instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,K,L){const U=this._providedCustomExecutions2.get(B.id);if(U){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,U),this._terminalService.attachPtyToTerminal(K,await U.callback(L))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const K=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:K,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:B.exitCode})}$provideTasks(B,K){const L=this._handlers.get(B);if(!L)return Promise.reject(new Error("no handler found"));const U=[],x=(0,R.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(Q=>this.provideTasksInternal(K,U,L,Q));return new Promise(Q=>{x.then($=>{Promise.all(U).then(()=>{Q($)})})})}async $resolveTask(B,K){const L=this._handlers.get(B);if(!L)return Promise.reject(new Error("no handler found"));if(K.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${L.type}].`);const U=await h.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await L.provider.resolveTask(U,A.CancellationToken.None);if(!!x){this.checkDeprecation(x,L);const Q=h.from(x,L.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(Q.execution)&&await this.addCustomExecution(Q,x,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,K,L){const U=await this._proxy.$createTaskId(B);!L&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,K.execution)}async getTaskExecution(B,K){if(typeof B=="string"){const x=this._taskExecutionPromises.get(B);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let L=this._taskExecutionPromises.get(B.id);if(L)return L;const U=new Promise(async(x,Q)=>{const $=K||await h.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);$?x(new I(this,B.id,$)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,U),U.then(x=>(this._taskExecutions.set(B.id,x),x),x=>Promise.reject(x))}checkDeprecation(B,K){B._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let L=this._notProvidedCustomExecutions.values(),U=L.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=L.next()}};z=qe([Ge(0,b.IExtHostRpcService),Ge(1,m.IExtHostInitDataService),Ge(2,k.IExtHostWorkspace),Ge(3,E.IExtHostDocumentsAndEditors),Ge(4,n.IExtHostConfiguration),Ge(5,C.IExtHostTerminalService),Ge(6,g.ILogService),Ge(7,w.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let ue=class extends z{constructor(B,K,L,U,x,Q,$,Z){super(B,K,L,U,x,Q,$,Z);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(B,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const L=h.from(K,B);if(L===void 0)throw new Error("Task is not valid");if(v.is(L.execution))await this.addCustomExecution(L,K,!1);else throw new d.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),K);return this._proxy.$executeTask(L).catch(x=>{throw new Error(x)}),U}provideTasksInternal(B,K,L,U){const x=[];if(U)for(let Q of U){this.checkDeprecation(Q,L),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const $=h.from(Q,L.extension);$&&v.is($.execution)?(x.push($),K.push(this.addCustomExecution($,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:L.extension}}async resolveTaskInternal(B){if(v.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,K){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,K,L){}};ue=qe([Ge(0,b.IExtHostRpcService),Ge(1,m.IExtHostInitDataService),Ge(2,k.IExtHostWorkspace),Ge(3,E.IExtHostDocumentsAndEditors),Ge(4,n.IExtHostConfiguration),Ge(5,C.IExtHostTerminalService),Ge(6,g.ILogService),Ge(7,w.IExtHostApiDeprecationService)],ue),e.WorkerExtHostTask=ue,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var dn=this&&this.__rest||function(le,e){var y={};for(var R in le)Object.prototype.hasOwnProperty.call(le,R)&&e.indexOf(R)<0&&(y[R]=le[R]);if(le!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,R=Object.getOwnPropertySymbols(le);T<R.length;T++)e.indexOf(R[T])<0&&Object.prototype.propertyIsEnumerable.call(le,R[T])&&(y[R[T]]=le[R[T]]);return y};define(be[213],we([0,1,15,13,20,3,52,6,23,12,2,29,5,40,14,9,7,31,178,95]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const d=(D,h)=>`${D}:${h.toString()}`;let o=class{constructor(h,p,I){this.documents=p,this.workspace=I,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new f(this.proxy),this.textDocumentObservers=new v(this.proxy,p)}registerTestProvider(h){const p=(0,C.generateUuid)();this.providers.set(p,h),this.proxy.$registerTestProvider(p);const I=[...this.testSubscriptions.keys()];return setTimeout(()=>{var F;for(const z of I)(F=this.testSubscriptions.get(z))===null||F===void 0||F.subscribeFn(p,h)},0),new _.Disposable(()=>{this.providers.delete(p),this.proxy.$unregisterTestProvider(p)})}createTextDocumentTestObserver(h){return this.textDocumentObservers.checkout(h.uri)}createWorkspaceTestObserver(h){return this.workspaceObservers.checkout(h.uri)}async runTests(h,p=T.CancellationToken.None){const I=F=>F.map(this.getInternalTestForReference,this).filter(n.isDefined).map(z=>({src:z.src,testId:z.item.extId}));await this.proxy.$runTests({exclude:h.exclude?I(h.exclude).map(F=>F.testId):void 0,tests:I(h.tests),debug:h.debug},p)}publishExtensionProvidedResults(h,p){this.proxy.$publishExtensionProvidedResults(s.TestResults.from((0,C.generateUuid)(),h),p)}$publishTestResults(h){this.results=Object.freeze(h.map(p=>(0,E.deepFreeze)(s.TestResults.to(p))).concat(this.results).sort((p,I)=>I.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(h,p){const I=A.URI.revive(p),F=d(h,I);if(!this.testSubscriptions.has(F)){const z=new T.CancellationTokenSource;let ue;if(h===1){let L=this.documents.getDocument(I);if(!L){const U=new k.DisposableStore;L=await new Promise(x=>{U.add((0,R.disposableTimeout)(()=>x(void 0),5e3)),U.add(this.documents.onDidAddDocuments(Q=>{const $=Q.find(Z=>Z.document.uri.toString()===I.toString());$&&x($)}))}).finally(()=>U.dispose())}if(L){const U=await this.workspace.getWorkspaceFolder2(I,!1);ue=x=>x.provideDocumentTestRoot?x.provideDocumentTestRoot(L.document,z.token):(0,e.createDefaultDocumentTestRoot)(x,L.document,U,z.token)}}else{const L=await this.workspace.getWorkspaceFolder2(I,!1);L&&(ue=U=>U.provideWorkspaceTestRoot(L,z.token))}if(!!ue){const H=async(L,U)=>{try{const x=await ue(U);x&&K.addRoot(x,L)}catch(x){console.error(x)}},B=new k.DisposableStore,K=B.add(this.ownedTests.createForHierarchy(L=>this.proxy.$publishDiff(h,p,L)));B.add((0,k.toDisposable)(()=>z.dispose(!0)));for(const[L,U]of this.providers)H(L,U);K.pushDiff([3,-1]),this.testSubscriptions.set(F,{store:B,collection:K,subscribeFn:H})}}}async $expandTest(h,p){const I=(0,y.mapFind)(this.testSubscriptions.values(),F=>F.collection.treeId===h.src.tree?F:void 0);await(I==null?void 0:I.collection.expand(h.testId,p<0?Infinity:p)),this.flushCollectionDiffs()}$unsubscribeFromTests(h,p){var I;const F=A.URI.revive(p),z=d(h,F);(I=this.testSubscriptions.get(z))===null||I===void 0||I.store.dispose(),this.testSubscriptions.delete(z)}$acceptDiff(h,p,I){h===1?this.textDocumentObservers.acceptDiff(A.URI.revive(p),I):this.workspaceObservers.acceptDiff(A.URI.revive(p),I)}async $runTestsForProvider(h,p){const I=this.providers.get(h.tests[0].src.provider);if(!!I){const F=h.tests.map(({testId:ue,src:H})=>this.ownedTests.getTestById(ue,H.tree)).filter(n.isDefined).map(([ue,H])=>H),z=h.excludeExtIds.map(ue=>this.ownedTests.getTestById(ue)).filter(n.isDefined).filter(([ue,H])=>F.some(B=>ue.comparePositions(B,H)===1));if(!!F.length)try{await I.runTests({setState:(ue,H)=>{for(const[B,K]of z){const L=B.comparePositions(K,ue.id);if(L===1||L===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(h.runId,ue.id,s.TestState.from(H))},tests:F.map(ue=>i.unwrap(ue.actual)),exclude:z.map(([,ue])=>i.unwrap(ue.actual)),debug:h.debug},p);for(const{collection:ue}of this.testSubscriptions.values())ue.flushDiff();return}catch(ue){throw console.error(ue),ue}}}$lookupTest(h){const p=this.ownedTests.getTestById(h.testId);if(!p)return Promise.resolve(void 0);const I=p[1],{actual:F,discoverCts:z,expandLevels:ue}=I,H=dn(I,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:h}of this.testSubscriptions.values())h.flushDiff()}getInternalTestForReference(h){var p,I;return(I=(p=this.workspaceObservers.getMirroredTestDataByReference(h))!==null&&p!==void 0?p:(0,y.mapFind)(this.testSubscriptions.values(),F=>F.collection.getTestByReference(h)))!==null&&I!==void 0?I:this.textDocumentObservers.getMirroredTestDataByReference(h)}};o=qe([Ge(0,r.IExtHostRpcService),Ge(1,m.IExtHostDocumentsAndEditors),Ge(2,g.IExtHostWorkspace)],o),e.ExtHostTesting=o;const t=async(D,h,p,I)=>{if(!!p){const F=await D.provideWorkspaceTestRoot(p,I);if(!!F)return I.onCancellationRequested(()=>{i.removeFilter(h)}),i.getWrapperForTestItem(F,h)}};e.createDefaultDocumentTestRoot=t;class i extends _.TestItem{constructor(h,p,I){super(h.id,h.label,h.uri,h.expandable);if(this.actual=h,this.filterDocument=p,this.parent=I,!(h instanceof _.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);h[_.TestItemHookProperty]={setProp:(F,z)=>this[F]=z,created:F=>i.getWrapperForTestItem(F,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:F=>this.children.delete(F)}}static removeFilter(h){this.wrapperMap.delete(h)}static getWrapperForTestItem(h,p,I){let F=this.wrapperMap.get(p);if(F==null?void 0:F.has(h))return F.get(h);F||(F=new WeakMap,this.wrapperMap.set(p,F));const z=new i(h,p,I);return F.set(h,z),z}static unwrap(h){return h instanceof i?h.actual:h}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var h;const p=this._cachedMatchesFilter;for(const F of this.actual.children){const z=i.getWrapperForTestItem(F,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.add(z):this.children.delete(z)}const I=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=I,I!==p&&((h=this.parent)===null||h===void 0||h.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=i,i.wrapperMap=new WeakMap;class u extends c.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,s.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:p,removed:I}=this;return{get added(){return[...h].map(F=>F.revived)},get updated(){return[...p].map(F=>F.revived)},get removed(){return[...I].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(h){let p=[];for(const I of h){const F=this.items.get(I);F&&p.push(F.revived)}return p}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,p){return Object.assign(Object.assign({},h),{revived:s.TestItem.toPlain(h.item),depth:p?p.depth+1:0,children:new Set})}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=a;class l{constructor(){this.resources=new Map}checkout(h){var p,I;const F=h.toString(),z=(p=this.resources.get(F))!==null&&p!==void 0?p:this.createObserverData(h);return(I=z.pendingDeletion)===null||I===void 0||I.dispose(),z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return z.tests.rootTestItems},dispose:(0,S.once)(()=>{--z.observers||(z.pendingDeletion=this.eventuallyDispose(h))})}}getMirroredTestDataByReference(h){for(const{tests:p}of this.resources.values()){const I=p.getMirroredTestDataByReference(h);if(I)return I}}eventuallyDispose(h){return(0,R.disposableTimeout)(()=>this.unlisten(h),10*1e3)}createObserverData(h){const p=new a,I=this.listen(h,z=>p.apply(z)),F={observers:0,tests:p,listener:I};return this.resources.set(h.toString(),F),F}unlisten(h){var p;const I=h.toString(),F=this.resources.get(I);F&&(F.observers=-1,(p=F.pendingDeletion)===null||p===void 0||p.dispose(),F.listener.dispose(),this.resources.delete(I))}}class f extends l{constructor(h){super();this.proxy=h,this.diffListeners=new Map}acceptDiff(h,p){var I;(I=this.diffListeners.get(h.toString()))===null||I===void 0||I(p)}listen(h,p){this.proxy.$subscribeToDiffs(0,h);const I=h.toString();return this.diffListeners.set(I,p),new _.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,h),this.diffListeners.delete(I)})}}class v extends l{constructor(h,p){super();this.proxy=h,this.documents=p,this.diffListeners=new Map}acceptDiff(h,p){var I;(I=this.diffListeners.get(h.toString()))===null||I===void 0||I(p)}listen(h,p){if(!this.documents.getDocument(h))return new _.Disposable(()=>{});const F=h.toString();return this.diffListeners.set(F,p),this.proxy.$subscribeToDiffs(1,h),new _.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,h),this.diffListeners.delete(F)})}}}),define(be[214],we([0,1,15,50,28,58,22,16,11,24,8,12,2,114,138,89,47,170,212,42]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(D,h,p,I){this.configurationService=D,this.workspaceContextService=h,this.editorGroupsService=p,this.pathService=I}text(D,h,p={}){D=this.getContentPattern(D,p);const I=this.configurationService.getValue(),F=h&&h.some(ue=>!this.configurationService.getValue({resource:ue}).search.useRipgrep),z=this.commonQuery(h==null?void 0:h.map(_.toWorkspaceFolder),p);return Object.assign(Object.assign({},z),{type:2,contentPattern:D,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles})}getContentPattern(D,h){const p=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const I=Object.assign(Object.assign({},D),{wordSeparators:p.editor.wordSeparators});return this.isCaseSensitive(D,h)&&(I.isCaseSensitive=!0),this.isMultiline(D)&&(I.isMultiline=!0),I}file(D,h={}){const p=this.commonQuery(D,h);return Object.assign(Object.assign({},p),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(D,h){return D?(D=Array.isArray(D)?D.map(a):a(D),h?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],h={}){const p=this.handleIncludeExclude(h.includePattern,h.expandPatterns),I=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),F=D.length>1,z=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,h,I)):D.map(B=>this.getFolderQueryForRoot(B,h,I,F))).filter(B=>!!B),ue={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:I.pattern,includePattern:p.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const K=y.coalesce(y.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,c.pathIncludedInQuery)(ue,U.fsPath)),L=this.commonQueryFromFileList(K);return Object.assign(Object.assign({},ue),L)}const H=h.extraFileResources&&h.extraFileResources.filter(B=>(0,c.pathIncludedInQuery)(ue,B.fsPath));return ue.extraFileResources=H&&H.length?H:void 0,ue}commonQueryFromFileList(D){const h=[],p=new S.ResourceMap,I={};let F=!1;return D.forEach(z=>{var ue,H;if(z.scheme!==k.Schemas.walkThrough)if((0,n.isAbsolutePath)(z)){const K=(H=(ue=this.workspaceContextService.getWorkspaceFolder(z))===null||ue===void 0?void 0:ue.uri)!==null&&H!==void 0?H:z.with({path:E.dirname(z.fsPath)});let L=p.get(K);L||(F=!0,L={folder:K,includePattern:{}},h.push(L),p.set(K,L));const U=E.relative(K.fsPath,z.fsPath);(0,C.assertIsDefined)(L.includePattern)[U.replace(/\\/g,"/")]=!0}else z.fsPath&&(F=!0,I[z.fsPath]=!0)}),{folderQueries:h,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,h){if(h.isSmartCase){if(D.isRegExp){if(A.containsUppercaseCharacter(D.pattern,!0))return!0}else if(A.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,m.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const h=L=>E.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),I=(Array.isArray(D)?D:i(D)).map(L=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(L,U.scheme===k.Schemas.file?U.fsPath:U.path):L}),F=R.groupBy(I,L=>h(L)?"searchPaths":"exprSegments"),z=(F.exprSegments||[]).map(L=>A.rtrim(L,"/")).map(L=>A.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),u(L))),ue={},H=this.expandSearchPathPatterns(F.searchPaths||[]);H&&H.length&&(ue.searchPaths=H);const B=y.flatten(z),K=t(...B);return K&&(ue.pattern=K),ue}getExcludesForFolder(D,h){return h.disregardExcludeSettings?void 0:(0,c.getExcludes)(D,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const h=y.flatten(D.map(I=>{let{pathPortion:F,globPortion:z}=o(I);z&&(z=l(z));const ue=this.expandOneSearchPath(F);return y.flatten(ue.map(H=>this.resolveOneSearchPathPattern(H,z)))})),p=new Map;return h.forEach(I=>{const F=I.searchPath.toString(),z=p.get(F);z?I.pattern&&(z.pattern=z.pattern||{},z.pattern[I.pattern]=!0):p.set(F,{searchPath:I.searchPath,pattern:I.pattern?t(I.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(D){if(E.isAbsolute(D)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==k.Schemas.file?[{searchPath:h[0].uri.with({path:D})}]:[{searchPath:b.URI.file(E.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=a(D),D.startsWith("../")||D===".."){const I=E.posix.resolve(h.path,D);return[{searchPath:h.with({path:I})}]}const p=l(D);return[{searchPath:h,pattern:p}]}else{if(D==="./"||D===".\\")return[];{const h=D.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const p=h[1],I=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===p);if(I.length)return I.map(F=>{const z=h[2];return{searchPath:F.uri,pattern:z&&l(z)}});{const F=r.localize(0,null,p);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(D,h){const p=D.pattern&&h?`${D.pattern}/${h}`:D.pattern||h,I=[{searchPath:D.searchPath,pattern:p}];return p&&!p.endsWith("**")&&I.push({searchPath:D.searchPath,pattern:p+"/**"}),I}getFolderQueryForSearchPath(D,h,p){const I=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(D.searchPath),h,p,!1);return I?Object.assign(Object.assign({},I),{includePattern:D.pattern}):null}getFolderQueryForRoot(D,h,p,I){let F;const z=b.URI.isUri(D)?D:D.uri;if(p.searchPaths){const L=p.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,z))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const ue=this.configurationService.getValue({resource:z}),H=this.getExcludesForFolder(ue,h),B=Object.assign(Object.assign({},H||{}),F||{}),K=b.URI.isUri(D)?(0,n.basename)(D):D.name;return{folder:z,folderName:I?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ue.files&&ue.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!ue.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!ue.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!ue.search.followSymlinks}}};d=qe([Ge(0,s.IConfigurationService),Ge(1,_.IWorkspaceContextService),Ge(2,g.IEditorGroupsService),Ge(3,w.IPathService)],d),e.QueryBuilder=d;function o(v){const D=v.match(/[\*\{\}\(\)\[\]\?]/);if(D){const h=D.index,p=v.substr(0,h).match(/[/|\\][^/\\]*$/);if(p){let I=v.substr(0,p.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:v.substr((p.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((D,h)=>(D[h]=!0,D),Object.create(null)):void 0}function i(v){return T.splitGlobAware(v,",").map(D=>D.trim()).filter(D=>!!D.length)}function u(v){return[`**/${v}/**`,`**/${v}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function a(v){return v.replace(/\\/g,"/")}function l(v){return a(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(v,D){v=y.distinct(v,I=>I.toString());const h=[],p=D.getWorkspace();return v&&v.forEach(I=>{let F;if(D.getWorkbenchState()===2)F=(0,n.relativePath)(p.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const z=D.getWorkspaceFolder(I);if(z){const ue=z.name;if(p.folders.filter(B=>B.name===ue).length===1){const B=(0,n.relativePath)(z.uri,I);B===""?F=`./${z.name}`:F=`./${z.name}/${B}`}else F=I.fsPath}}F&&h.push(F)}),h}e.resolveResourcesForSearchIncludes=f}),define(be[215],we([0,1,24,2,20,10,4,214,42,47]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function C(s,_){const g=_.activationEvents;if(!g)return Promise.resolve(void 0);const w=[],c=[];for(const a of g)if(/^workspaceContains:/.test(a)){const l=a.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||s.forceUsingSearch?c.push(l):w.push(l)}if(w.length===0&&c.length===0)return Promise.resolve(void 0);let d;const o=new Promise((a,l)=>{d=a}),t=a=>d({activationEvent:a}),i=Promise.all(w.map(a=>b(s,a,t))).then(()=>{}),u=m(s,_.identifier,c,t);return Promise.all([i,u]).then(()=>{d(void 0)}),o}e.checkActivateWorkspaceContainsExtension=C;async function b(s,_,g){for(const w of s.folders)if(await s.exists(y.joinPath(R.URI.revive(w),_))){g(`workspaceContains:${_}`);return}}async function m(s,_,g,w){if(g.length===0)return Promise.resolve(void 0);const c=new T.CancellationTokenSource,d=s.checkExists(s.folders,g,c.token),o=setTimeout(async()=>{c.cancel(),w(`workspaceContainsTimeout:${g.join(",")}`)},A);let t=!1;try{t=await d}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}c.dispose(),clearTimeout(o),t&&w(`workspaceContains:${g.join(",")}`)}function r(s,_,g,w){const c=s.get(S.IInstantiationService),d=s.get(E.ISearchService),t=c.createInstance(k.QueryBuilder).file(_.map(i=>(0,n.toWorkspaceFolder)(R.URI.revive(i))),{_reason:"checkExists",includePattern:g,exists:!0});return d.fileSearch(t,w).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var nt=this&&this.__classPrivateFieldSet||function(le,e,y){if(!e.has(le))throw new TypeError("attempted to set private field on non-instance");return e.set(le,y),y},$e=this&&this.__classPrivateFieldGet||function(le,e){if(!e.has(le))throw new TypeError("attempted to get private field on non-instance");return e.get(le)};define(be[36],we([0,1,130,11,77,24,13,6,22,2,19,5,35,181,75,31,34,179,10,25,16,26,158,7,90,4,27,76,14,65,67,41,3,215,71,159]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c,d,o,t,i,u,a,l,f,v,D,h,p,I,F,z,ue){"use strict";var H,B,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let L=class An extends k.Disposable{constructor($,Z,ie,re,ye,Ie,Ue,Re,ze,N){super();this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=ie,this._initData=Ue,this._extHostWorkspace=re,this._extHostConfiguration=ye,this._logService=Ie,this._extHostTunnelService=ze,this._extHostTerminalService=N,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=$.createChild(new D.ServiceCollection([r.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(ee=>G.add(c.ExtensionIdentifier.toKey(ee))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,oe)},actualActivateExtension:async(ee,oe)=>{if(G.has(c.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,oe),new m.HostExtension;const fe=this._registry.getExtensionDescription(ee);return this._activateExtension(fe,oe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){w.onUnexpectedError($)}}async deactivateAll(){let $=[];try{$=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,Z){return this._activator.activateByEvent($,Z)}_activateById($,Z){return this._activator.activateById($,Z)}activateByIdWithErrors($,Z){return this._activateById($,Z).then(()=>{const ie=this._activator.getActivatedExtension($);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const $=E.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(ie=>{if(!!this._getEntryPoint(ie))return this._hostUtils.realpath(ie.extensionLocation.fsPath).then(re=>$.set(n.URI.file(re).fsPath,ie))});this._extensionPathIndex=Promise.all(Z).then(()=>$)}return this._extensionPathIndex}_deactivate($){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return Z;const ie=this._activator.getActivatedExtension($);if(!ie)return Z;try{typeof ie.module.deactivate=="function"&&(Z=Promise.resolve(ie.module.deactivate()).then(void 0,re=>Promise.resolve(void 0)))}catch(re){}try{(0,k.dispose)(ie.subscriptions)}catch(re){}return Z}async _activateExtension($,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,Z).then(ie=>{const re=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,Z),this._logExtensionActivationTimes($,Z,"success",re),ie},ie=>{throw this._logExtensionActivationTimes($,Z,"failure"),ie})}_logExtensionActivationTimes($,Z,ie,re){const ye=U($,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),re||{}),{outcome:ie}))}_doActivateExtension($,Z){const ie=U($,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const re=this._getEntryPoint($);if(!re)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new m.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,P.joinPath)($.extensionLocation,re),ye),this._loadExtensionContext($)]).then(Ie=>(T.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),An._callActivate(this._logService,$.identifier,Ie[0],Ie[1],ye))).then(Ie=>(T.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Ie))}_loadExtensionContext($){const Z=new t.ExtensionGlobalMemento($,this._storage),ie=new t.ExtensionMemento($.identifier.value,!1,this._storage),re=new ue.ExtensionSecrets($,this._secretState),ye=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ie=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([Z.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const Ue=this;let Re;return Object.freeze({globalState:Z,workspaceState:ie,secrets:re,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ze){return R.join($.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=Ue._storagePath.workspaceValue($))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return Ue._storagePath.globalValue($).fsPath},get logPath(){return R.join(Ue._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return n.URI.joinPath(Ue._initData.logsLocation,$.identifier.value)},get storageUri(){return Ue._storagePath.workspaceValue($)},get globalStorageUri(){return Ue._storagePath.globalValue($)},get extensionMode(){return ye},get extension(){return Re===void 0&&(Re=new x(Ue,$.identifier,$,Ie)),Re},get extensionRuntime(){return(0,_.checkProposedApiEnabled)($),Ue.extensionRuntime},get environmentVariableCollection(){return Ue._extHostTerminalService.getEnvironmentVariableCollection($)}})})}static _callActivate($,Z,ie,re,ye){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional($,Z,ie,re,ye).then(Ie=>new m.ActivatedExtension(!1,null,ye.build(),ie,Ie,re.subscriptions))}static _callActivateOptional($,Z,ie,re,ye){if(typeof ie.activate=="function")try{ye.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Ie=typeof global=="object"?global:self,Ue=ie.activate.apply(Ie,[re]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Ue).then(Re=>(ye.activateResolveStop(),Re))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(ie)}_activateOneStartupFinished($,Z){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:Z}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const Z of $.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished($,Z)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(Z),re=Promise.all([$,ie]).then(()=>{});return Promise.race([re,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension($,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,Z){if(!this.isActivated(Z.identifier)){const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={folders:$.map(Ie=>Ie.uri),forceUsingSearch:ie,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,Ue,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,Ue,Re)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(re,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:Z}=this._initData.environment;if(!$||!Z||Z.scheme!==d.Schemas.file)throw new Error(y.localize(0,null));const ie=(0,P.originalFSPath)(Z),re=await this._loadCommonJSModule(null,Z,new m.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(y.localize(1,null,ie));return new Promise((ye,Ie)=>{const Ue=(ze,N)=>{ze?Ie(ze):ye(typeof N=="number"&&N>0?1:0)},Re=re.run(ie,Ue);Re&&Re.then&&Re.then(()=>{ye(0)}).catch(ze=>{Ie(ze.toString())})})}async $extensionTestsExit($){this._logService.info(`extension host terminating: test runner requested exit with code ${$}`),this._logService.info(`exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver($,Z){return this._resolvers[$]=Z,(0,k.toDisposable)(()=>{delete this._resolvers[$]})}async $resolveAuthority($,Z){const ie=$.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const re=$.substr(0,ie);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1);const ye=this._resolvers[re];if(!ye)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${re}`);const Ie=await ye.resolve($,{resolveAttempt:Z});T.mark(`code/extHost/didResolveAuthorityOK/${re}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const Ue={authority:$,host:Ie.host,port:Ie.port,connectionToken:Ie.connectionToken},Re={extensionHostEnv:Ie.extensionHostEnv};return{type:"ok",value:{authority:Ue,options:Re,tunnelInformation:{environmentTunnels:Ie.environmentTunnels}}}}catch(Ie){if(T.mark(`code/extHost/didResolveAuthorityError/${re}`),Ie instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Ie._code,message:Ie._message,detail:Ie._detail}};throw Ie}}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,Z){return Z===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent($,!1))}async $activate($,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,Z),!0):!1}async $deltaExtensions($,Z){$.forEach(re=>re.extensionLocation=n.URI.revive(re.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(Z.map(async re=>{const ye=this._registry.getExtensionDescription(re);if(!!ye){const Ie=await this._hostUtils.realpath(ye.extensionLocation.fsPath);ie.delete(n.URI.file(Ie).fsPath)}})),await Promise.all($.map(async re=>{const ye=await this._hostUtils.realpath(re.extensionLocation.fsPath);ie.set(n.URI.file(ye).fsPath,re)})),this._registry.deltaExtensions($,Z),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let Z=o.VSBuffer.alloc($),ie=Math.random()%256;for(let re=0;re<$;re++)Z.writeUInt8(ie,re);return Z}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};L=qe([Ge(0,a.IInstantiationService),Ge(1,e.IHostUtils),Ge(2,v.IExtHostRpcService),Ge(3,s.IExtHostWorkspace),Ge(4,b.IExtHostConfiguration),Ge(5,A.ILogService),Ge(6,l.IExtHostInitDataService),Ge(7,f.IExtensionStoragePaths),Ge(8,h.IExtHostTunnelService),Ge(9,p.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function U(Q,$){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class x{constructor($,Z,ie,re){H.set(this,void 0),B.set(this,void 0),K.set(this,void 0),nt(this,H,$),nt(this,B,Z),nt(this,K,ie.identifier),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=R.normalize((0,P.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=re}get isActive(){return $e(this,H).isActivated($e(this,K))}get exports(){if(this.packageJSON.api!=="none")return $e(this,H).getExtensionExports($e(this,K))}activate(){return $e(this,H).activateByIdWithErrors($e(this,K),{startup:!1,extensionId:$e(this,B),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,H=new WeakMap,B=new WeakMap,K=new WeakMap}),define(be[102],we([0,1,11,2,3,13,5,7,165,31,36,40,169,35,166,14,4,12,32]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let c=class{constructor(f,v,D,h,p){this._workspaceService=v,this._extensionService=D,this._editorsService=h,this._configurationService=p,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=f.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(F=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,v){const D=f;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let h=`debug:${encodeURIComponent(D.path||"")}`,p="?";return v&&(h+=`${p}session=${encodeURIComponent(v.id)}`,p="&"),h+=`${p}ref=${D.sourceReference}`,R.URI.parse(h)}else{if(D.path)return R.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const v=[];for(const D of f.getAllExtensionDescriptions())if(D.contributes){const h=D.contributes.debuggers;if(h&&h.length>0)for(const p of h)(0,r.isDebuggerMainContribution)(p)&&v.push(p.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(v=>f.push(v)),f}addBreakpoints(f){this.startBreakpoints();const v=f.filter(p=>{const I=p.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,p),!0)});this.fireBreakpointChanges(v,[],[]);const D=[],h=new Map;for(const p of v)if(p instanceof k.SourceBreakpoint){let I=h.get(p.location.uri.toString());I||(I={type:"sourceMulti",uri:p.location.uri,lines:[]},h.set(p.location.uri.toString(),I),D.push(I)),I.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof k.FunctionBreakpoint&&D.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(f){this.startBreakpoints();const v=f.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],v,[]);const D=v.filter(I=>I instanceof k.SourceBreakpoint).map(I=>I.id),h=v.filter(I=>I instanceof k.FunctionBreakpoint).map(I=>I.id),p=v.filter(I=>I instanceof k.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(D,h,p)}startDebugging(f,v,D){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,v,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,v,D){if(!v)return new k.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:h,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,D,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,h),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(f,v,D){if(!D)return new k.Disposable(()=>{});if(!this.definesDebugType(f,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:h,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,h),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(f,v){if(!v)return new k.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:D,factory:v}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==v)})}async $runInTerminal(f,v){return Promise.resolve(void 0)}async $substituteVariables(f,v){if(!this._variableResolver){const[p,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(p||[],this._editorsService,I)}let D;const h=await this.getFolder(f);return h&&(D={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(D,v)}createDebugAdapter(f,v){if(f.type==="implementation")return new u(f.implementation)}createSignService(){}async $startDASession(f,v){const D=this,h=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const I=this.convertToDto(p),F=this.createDebugAdapter(I,h);if(!F)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const z=F;return this._debugAdapters.set(f,z),this.getDebugAdapterTrackers(h).then(ue=>(ue&&this._debugAdaptersTrackers.set(f,ue),z.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const B=H,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(B.arguments.value);K.body={signature:L},z.sendResponse(K)}else throw new Error("no signer")}catch(L){K.success=!1,K.message=L.message,z.sendResponse(K)}}else ue&&ue.onDidSendMessage&&ue.onDidSendMessage(H),H=(0,r.convertToVSCPaths)(H,!0),D._debugServiceProxy.$acceptDAMessage(f,H)}),z.onError(H=>{ue&&ue.onError&&ue.onError(H),this._debugServiceProxy.$acceptDAError(f,H.name,H.message,H.stack)}),z.onExit(H=>{ue&&ue.onExit&&ue.onExit((0,g.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,g.withNullAsUndefined)(H),void 0)}),ue&&ue.onWillStartSession&&ue.onWillStartSession(),z.startSession()))})}$sendDAMessage(f,v){v=(0,r.convertToDAPaths)(v,!1);const D=this._debugAdaptersTrackers.get(f);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(v);const h=this._debugAdapters.get(f);h&&h.sendMessage(v)}$stopDASession(f){const v=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),v&&v.onWillStopSession&&v.onWillStopSession();const D=this._debugAdapters.get(f);return this._debugAdapters.delete(f),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const v=[],D=[],h=[];if(f.added)for(const p of f.added){const I=p.id;if(I&&!this._breakpoints.has(I)){let F;if(p.type==="function")F=new k.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")F=new k.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const z=R.URI.revive(p.uri);F=new k.SourceBreakpoint(new k.Location(z,new k.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}F._id=I,this._breakpoints.set(I,F),v.push(F)}}if(f.removed)for(const p of f.removed){const I=this._breakpoints.get(p);I&&(this._breakpoints.delete(p),D.push(I))}if(f.changed){for(const p of f.changed)if(p.id){const I=this._breakpoints.get(p.id);if(I){if(I instanceof k.FunctionBreakpoint&&p.type==="function"){const F=I;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.functionName=p.functionName}else if(I instanceof k.SourceBreakpoint&&p.type==="source"){const F=I;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.location=new k.Location(R.URI.revive(p.uri),new k.Position(p.line,p.character))}h.push(I)}}}this.fireBreakpointChanges(v,D,h)}$provideDebugConfigurations(f,v,D){return(0,P.asPromise)(async()=>{const h=this.getConfigProviderByHandle(f);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(v);return h.provideDebugConfigurations(p,D)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(f,v,D,h){return(0,P.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(v);return p.resolveDebugConfiguration(I,D,h)})}$resolveDebugConfigurationWithSubstitutedVariables(f,v,D,h){return(0,P.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(v);return p.resolveDebugConfigurationWithSubstitutedVariables(I,D,h)})}async $provideDebugAdapter(f,v){const D=this.getAdapterDescriptorFactoryByHandle(f);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(v);return this.getAdapterDescriptor(D,h).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(f){const v=await this.getSession(f);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(f){const v=await this.getSession(f);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,v){const D=await this.getSession(f);D&&D._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(f,v){const h={session:await this.getSession(f),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(f){if(f instanceof k.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof k.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const v=this._adapterFactories.filter(D=>D.type===f);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(f){const v=this._adapterFactories.filter(D=>D.handle===f);if(v.length>0)return v[0].factory}getConfigProviderByHandle(f){const v=this._configProviders.filter(D=>D.handle===f);if(v.length>0)return v[0].provider}definesDebugType(f,v){if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0){for(const h of D)if(h.label&&h.type&&h.type===v)return!0}}return!1}getDebugAdapterTrackers(f){const D=f.configuration.type,h=this._trackerFactories.filter(p=>p.type===D||p.type==="*").map(p=>(0,P.asPromise)(()=>p.factory.createDebugAdapterTracker(f)).then(I=>I,I=>null));return Promise.race([Promise.all(h).then(p=>{const I=p.filter(F=>!!F);if(I.length>0)return new i(I)}),new Promise((p,I)=>{const F=setTimeout(()=>{clearTimeout(F),I(new Error("timeout"))},1e3)})]).catch(p=>{})}async getAdapterDescriptor(f,v){const D=v.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new k.DebugAdapterServer(D));if(f){const p=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>f.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,p))).then(I=>{if(I)return I})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,h))}daExecutableFromPackage(f,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,v,D){(f.length>0||v.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:v,changed:D}))}async getSession(f){if(f)if(typeof f=="string"){const v=this._debugSessions.get(f);if(v)return v}else{let v=this._debugSessions.get(f.id);if(!v){const D=await this.getFolder(f.folderUri);v=new d(this._debugServiceProxy,f.id,f.type,f.name,D,f.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(f){if(f){const v=R.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};c=qe([Ge(0,s.IExtHostRpcService),Ge(1,n.IExtHostWorkspace),Ge(2,A.IExtHostExtensionService),Ge(3,C.IExtHostDocumentsAndEditors),Ge(4,m.IExtHostConfiguration)],c),e.ExtHostDebugServiceBase=c;class d{constructor(f,v,D,h,p,I){this._debugServiceProxy=f,this._id=v,this._type=D,this._name=h,this._workspaceFolder=p,this._configuration=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,v)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=d;class o{constructor(f){this.value=Object.freeze({append(v){f.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=o;class t extends b.AbstractVariableResolverService{constructor(f,v,D,h){super({getFolderUri:p=>{const I=f.filter(F=>F.name===p);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(p,I)=>D.getConfiguration(void 0,p).get(I),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const p=v.activeEditor();if(p)return y.normalize(p.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&h){const p=v.activeEditor();if(p){const I=h.getWorkspaceFolder(p.document.uri);if(I)return y.normalize(I.uri.fsPath)}}},getSelectedText:()=>{if(v){const p=v.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(v){const p=v.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,w.env)}}e.ExtHostVariableResolverService=t;class i{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(v=>v.onError?v.onError(f):void 0)}onExit(f,v){this.trackers.forEach(D=>D.onExit?D.onExit(f,v):void 0)}}class u extends E.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(f,v,D,h,p){super(f,v,D,h,p)}createVariableResolver(f,v,D){return new t(f,v,D)}};a=qe([Ge(0,s.IExtHostRpcService),Ge(1,n.IExtHostWorkspace),Ge(2,A.IExtHostExtensionService),Ge(3,C.IExtHostDocumentsAndEditors),Ge(4,m.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(be[216],we([0,1,77,2,5,35,34,25,14,27,4,36,32,19]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(c,d,o,t,i,u,a){this._apiFactory=c,this._extensionRegistry=d,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=u,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),y.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,d,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,d,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let d of c.nodeModuleName)this._factories.set(d,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(d=>c.alternativeModuleName(d))}};r=qe([Ge(2,A.IInstantiationService),Ge(3,P.IExtHostConfiguration),Ge(4,C.IExtHostExtensionService),Ge(5,n.IExtHostInitDataService),Ge(6,m.ILogService)],r),e.RequireInterceptor=r;class s{constructor(c,d,o,t,i){this._apiFactory=c,this._extensionPaths=d,this._extensionRegistry=o,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,d){const o=this._extensionPaths.findSubstr(d.fsPath);if(o){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,u)=>t+=`	${u} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(c,d){this.nodeModuleName="keytar";const{environment:o}=d,t=c.getProxy(T.MainContext.MainThreadKeytar);if(o.appRoot){let i=o.appRoot.fsPath;b.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,u)=>t.$getPassword(i,u),setPassword:(i,u,a)=>t.$setPassword(i,u,a),deletePassword:(i,u)=>t.$deletePassword(i,u),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(c,d){return this._impl}alternativeModuleName(c){const d=c.length;if(!(d<=7||!this.alternativeNames)){const o=d-7;if((c.charAt(o)==="/"||c.charAt(o)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};_=qe([Ge(0,E.IExtHostRpcService),Ge(1,n.IExtHostInitDataService)],_);let g=class{constructor(c,d,o){this._extensionPaths=c,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(T.MainContext.MainThreadTelemetry);const t=o.getProxy(T.MainContext.MainThreadWindow);this._impl=(i,u)=>{const a=R.URI.parse(i);return u?this.callOriginal(i,u):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,i,{}):this.callOriginal(i,u)}}load(c,d,o){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(c),this._impl}callOriginal(c,d){return this.sendNoForwardTelemetry(),this._original(c,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=qe([Ge(2,E.IExtHostRpcService)],g)}),define(be[217],we([0,1,13,10,77,6,2,5,209,19,61,65,27,148,14,68,36,41]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(d,o,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const u=new E.RPCProtocol(d,null,i);o=w._transform(o,u);const a=new C.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());a.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(u)),a.set(s.IURITransformerService,new s.URITransformerService(i)),a.set(_.IHostUtils,t);const l=new m.InstantiationService(a,!0),f=l.invokeFunction(p=>p.get(g.IExtHostTerminalService));this._disposables.add(f),this._logService=l.invokeFunction(p=>p.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=l.invokeFunction(p=>p.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(I,F)=>{let z="",ue,H;for(const B of F)z+=`
	at ${B.toString()}`,H=B.getFileName(),!ue&&H&&(ue=p.findSubstr(H));return v.set(I,ue),`${I.name||"Error"}: ${I.message||""}${z}`}});const D=u.getProxy(k.MainContext.MainThreadExtensionService),h=u.getProxy(k.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(p=>{const I=R.transformErrorForSerialization(p),F=v.get(p);F?D.$onExtensionRuntimeError(F.identifier,I):h.$onUnexpectedError(I)})}terminate(d){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,y.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(d,o){d.extensions.forEach(i=>i.extensionLocation=S.URI.revive(o.transformIncomingURIs(i.extensionLocation))),d.environment.appRoot=S.URI.revive(o.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(i=>S.URI.revive(o.transformIncomingURIs(i)))),d.environment.extensionTestsLocationURI=S.URI.revive(o.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=S.URI.revive(o.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=S.URI.revive(o.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=S.URI.revive(o.transformIncomingURIs(d.logsLocation)),d.logFile=S.URI.revive(o.transformIncomingURIs(d.logFile)),d.workspace=o.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=w}),define(be[218],we([0,1,11,20,60,28,24,55,42,32]),function(le,e,y,R,T,P,S,k,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(m,r,s){this.config=m,this.provider=r,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&P.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&P.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const r=this.config.folderQueries||[];return new Promise((s,_)=>{const g=w=>{this.resultCount++,m(w)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const c=w.toString(),d=y.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,d)||this.matchFile(g,{base:w,basename:d})}),Promise.all(r.map(w=>this.searchInFolder(w,g))).then(w=>{s({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{_(new Error((0,T.toErrorMessage)(w)))})})}searchInFolder(m,r){const s=new R.CancellationTokenSource;return new Promise((_,g)=>{const w=this.getSearchOptionsForFolder(m),c=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,m),o=!d.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(s),t=k.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,s.token))).then(i=>{const u=t.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(l=>{const f=y.posix.relative(m.folder.path,l.path);if(o){const v=y.basename(l.path);this.matchFile(r,{base:m.folder,relativePath:f,basename:v});return}this.addDirectoryEntries(c,m.folder,f,r)}),this.activeCancellationTokens.delete(s),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,d,r),{providerTime:u,postProcessTime:a.elapsed()})}).then(i=>{s.dispose(),_(i)},i=>{s.dispose(),g(i)})})}getSearchOptionsForFolder(m){const r=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),s=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:s,includes:r,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},r,s,_){if(s===this.filePattern){const w=y.basename(this.filePattern);this.matchFile(_,{base:r,relativePath:this.filePattern,basename:w})}function g(w){const c=y.basename(w),d=y.dirname(w);let o=m[d];o||(o=m[d]=[],g(d)),o.push({base:r,relativePath:w,basename:c})}g(s)}matchDirectoryTree({rootEntries:m,pathToEntries:r},s,_){const g=this,w=this.filePattern;function c(d){const o=P.hasSiblingFn(()=>d.map(t=>t.basename));for(let t=0,i=d.length;t<i;t++){const u=d[t],{relativePath:a,basename:l}=u;if(!!s.includedInQuerySync(a,l,w!==l?o:void 0)){const f=r[a];if(f)c(f);else{if(a===w)continue;g.matchFile(_,u)}if(g.isLimitHit)break}}}c(m)}matchFile(m,r){(!this.includePattern||r.relativePath&&this.includePattern(r.relativePath,r.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(r))}}class C{constructor(){this.sessions=new Map}fileSearch(m,r,s,_){const g=this.getSessionTokenSource(m.cacheKey),w=new A(m,r,g&&g.token);let c=0;const d=o=>{c+=o.length,s(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(w,C.BATCH_SIZE,d,_).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:o.stats}}))}clearCache(m){const r=this.getSessionTokenSource(m);r&&r.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new R.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:S.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,r,s,_){_.onCancellationRequested(()=>{m.cancel()});const g=c=>{c&&(w.push(c),r>0&&w.length>=r&&(s(w),w=[]))};let w=[];return m.search(g).then(c=>(w.length&&s(w),c),c=>(w.length&&s(w),Promise.reject(c)))}}e.FileSearchManager=C,C.BATCH_SIZE=512}),define(be[219],we([0,1,11,15,20,60,24,28,2,42,32,16]),function(le,e,y,R,T,P,S,k,E,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(c,d,o){this.query=c,this.provider=d,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,d){const o=this.query.folderQueries||[],t=new T.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((i,u)=>{this.collector=new r(c);let a=!1;const l=(f,v)=>{if(!a&&!this.isLimitHit){const D=this.resultSize(f);_(f)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const h=this.resultSize(f);this.resultCount+=h,(h>0||!_(f))&&this.collector.add(f,v)}};Promise.all(o.map((f,v)=>this.searchInFolder(f,D=>l(D,v),t.token))).then(f=>{t.dispose(),this.collector.flush();const v=f.some(D=>!!D&&!!D.limitHit);i({limitHit:this.isLimitHit||v,stats:{type:"textSearchProvider"}})},f=>{t.dispose();const v=(0,P.toErrorMessage)(f);u(new Error(v))})})}resultSize(c){return _(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,d){const o=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:o.slice(0,d),preview:{matches:t.slice(0,d),text:c.preview.text},uri:c.uri}}searchInFolder(c,d,o){const t=new n.QueryGlobTester(this.query,c),i=[],u={report:l=>{if(!!this.validateProviderResult(l)){const f=c.folder.scheme===C.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,v=S.relativePath(c.folder,l.uri);v&&i.push(t.includedInQuery(v,y.basename(v),f).then(D=>{D&&d(l)}))}}},a=this.getSearchOptionsForFolder(c);return new Promise(l=>(0,A.nextTick)(l)).then(()=>this.provider.provideTextSearchResults(m(this.query.contentPattern),a,u,o)).then(l=>Promise.all(i).then(()=>l))}validateProviderResult(c){if(_(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const d=(0,n.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),o=(0,n.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:E.URI.from(c.folder),excludes:o,includes:d,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class r{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,d=>this.sendItems(d))}add(c,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!S.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(s(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=r;function s(w){return _(w)?{preview:{matches:(0,R.mapArrayOrNot)(w.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:w.preview.text},ranges:(0,R.mapArrayOrNot)(w.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function _(w){return!!w.preview}e.extensionResultIsMatch=_;class g{constructor(c,d){this.maxBatchSize=c,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,d){!c||this.addItemToBatch(c,d)}addItems(c,d){!c||this.addItemsToBatch(c,d)}addItemToBatch(c,d){this.batch.push(c),this.batchSize+=d,this.onUpdate()}addItemsToBatch(c,d){this.batch=this.batch.concat(c),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(be[103],we([0,1,6,5,4,218,14,68,19,2,219]),function(le,e,y,R,T,P,S,k,E,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(s,_,g){this.extHostRpc=s,this._uriTransformer=_,this._logService=g,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,_){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const g=this._handlePool++;return this._textSearchProvider.set(g,_),this._proxy.$registerTextSearchProvider(g,this._transformScheme(s)),(0,y.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(s,_){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const g=this._handlePool++;return this._fileSearchProvider.set(g,_),this._proxy.$registerFileSearchProvider(g,this._transformScheme(s)),(0,y.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(s,_,g,w){const c=b(g),d=this._fileSearchProvider.get(s);if(d)return this._fileSearchManager.fileSearch(c,d,o=>{this._proxy.$handleFileMatch(s,_,o.map(t=>t.resource))},w);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,_,g,w){const c=this._textSearchProvider.get(s);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const d=b(g);return this.createTextSearchManager(d,c).search(t=>this._proxy.$handleTextMatch(s,_,t),w)}createTextSearchManager(s,_){return new A.TextSearchManager(s,_,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};C=qe([Ge(0,S.IExtHostRpcService),Ge(1,k.IURITransformerService),Ge(2,E.ILogService)],C),e.ExtHostSearch=C;function b(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(m),extraFileResources:r.extraFileResources&&r.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=b;function m(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(be[220],we([0,1,127,20,10,3,46,2,121,82,115,59,64,5,186,185,73,187,35,188,189,190,172,191,40,36,192,173,194,195,196,99,176,198,199,200,75,41,201,177,9,7,204,49,100,31,34,50,162,193,91,98,101,102,103,19,68,14,27,197,161,67,72,183,202,160,76,74,207,205,206,184,48,213,203,71,157,93]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c,d,o,t,i,u,a,l,f,v,D,h,p,I,F,z,ue,H,B,K,L,U,x,Q,$,Z,ie,re,ye,Ie,Ue,Re,ze,N,G,ee,oe,fe,Se,Le,me,Ce,Pe,xe,_e,Ke,j,Y,pe,Fe,He,Oe,tt,W,te,de,q,J,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function he(ge){const We=ge.get(Le.IExtHostInitDataService),Ne=ge.get(W.IExtHostFileSystemInfo),je=ge.get(pe.IExtHostConsumerFileSystem),Ye=ge.get(a.IExtHostExtensionService),Ze=ge.get(ie.IExtHostWorkspace),ct=ge.get(se.IExtHostTelemetry),lt=ge.get(w.IExtHostConfiguration),it=ge.get(fe.IURITransformerService),Ve=ge.get(Se.IExtHostRpcService),ve=ge.get(H.IExtHostStorage),De=ge.get(Y.IExtensionStoragePaths),ae=ge.get(oe.ILogService),V=ge.get(Pe.IExtHostTunnelService),Me=ge.get(xe.IExtHostApiDeprecationService),Ae=ge.get(Z.IExtHostWindow),et=ge.get(q.IExtHostSecretState);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,Ne),Ve.set(m.ExtHostContext.ExtHostLogService,ae),Ve.set(m.ExtHostContext.ExtHostWorkspace,Ze),Ve.set(m.ExtHostContext.ExtHostConfiguration,lt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Ye),Ve.set(m.ExtHostContext.ExtHostStorage,ve),Ve.set(m.ExtHostContext.ExtHostTunnelService,V),Ve.set(m.ExtHostContext.ExtHostWindow,Ae),Ve.set(m.ExtHostContext.ExtHostSecretState,et),Ve.set(m.ExtHostContext.ExtHostTelemetry,ct);const Qe=Ve.set(m.ExtHostContext.ExtHostDecorations,ge.get(ze.IExtHostDecorations)),at=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,ge.get(u.IExtHostDocumentsAndEditors)),rt=Ve.set(m.ExtHostContext.ExtHostCommands,ge.get(_.IExtHostCommands)),Xe=Ve.set(m.ExtHostContext.ExtHostTerminalService,ge.get(B.IExtHostTerminalService)),st=Ve.set(m.ExtHostContext.ExtHostDebugService,ge.get(G.IExtHostDebugService)),vt=Ve.set(m.ExtHostContext.ExtHostSearch,ge.get(ee.IExtHostSearch)),mt=Ve.set(m.ExtHostContext.ExtHostTask,ge.get(N.IExtHostTask)),Dt=Ve.set(m.ExtHostContext.ExtHostOutputService,ge.get(p.IExtHostOutputService)),_t=Ve.set(m.ExtHostContext.ExtHostEditorTabs,new J.ExtHostEditorTabs),Et=Ve.set(m.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(Ve)),pt=Ve.set(m.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Ve,at)),Ft=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(Ve,at,ae)),Lt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ae,pt,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),ft=Ve.set(m.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Ve,rt,at,pt,We.environment,ae,De)),yt=Ve.set(m.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(Ve,at)),Ht=Ve.set(m.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),rt,ae)),qt=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),yt,We.environment)),Mt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(Ve,ae)),ht=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(Ve,it,pt,rt,Mt,ae,Me)),Kt=Ve.set(m.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ve,ht)),kt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ve,ae,at)),Nt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Ve,Ze,rt)),zt=Ve.set(m.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(Ve,rt,ae)),Gt=Ve.set(m.ExtHostContext.ExtHostComments,new g.ExtHostComments(Ve,rt,pt)),en=Ve.set(m.ExtHostContext.ExtHostProgress,new I.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),hn=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ue.ExtHostLabelService(Ve)),tn=Ve.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(Ve)),Ot=Ve.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(Ve)),fn=Ve.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(Ve,rt)),Ut=Ve.set(m.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Ve,We.environment,Ze,ae,Me)),xt=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(Ve,Ut,Ze)),mn=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(Ve,pt,De,Ut,xt)),gn=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new Fe.ExtHostWebviewViews(Ve,Ut)),At=Ve.set(m.ExtHostContext.ExtHostTesting,new te.ExtHostTesting(Ve,at,Ze)),pn=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(Ve)),Vt=(0,ye.values)(m.ExtHostContext);Ve.assertRegistered(Vt);const vn=new tt.ExtHostBulkEdits(Ve,at),_n=new s.ExtHostClipboard(Ve),$t=new h.ExtHostMessageService(Ve,ae),nn=new d.ExtHostDialogs(Ve),rn=new ue.ExtHostStatusBar(Ve,rt.converter),Wt=new D.ExtHostLanguages(Ve,pt);return r.ExtHostApiCommands.register(rt),function(Te,Qt,Jt){const gt=function(){let X=!Te.isUnderDevelopment;function ce(ke){X||(ae.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")ce(ut);else{const bt=ut;typeof bt.scheme=="undefined"&&ce(ut),!Te.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,re.throwProposedApiError)(Te)}return ut}}(),bn={getSession(X,ce,ke){return Ot.getSession(Te,X,ce,ke)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,ut){return Ot.registerAuthenticationProvider(X,ce,ke,ut)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Te),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Te),Ot.providers},logout(X,ce){return(0,re.checkProposedApiEnabled)(Te),Ot.removeSession(X,ce)}},wn={registerCommand(X,ce,ke){return rt.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return rt.registerCommand(!0,X,(...ut)=>{const bt=yt.getActiveTextEditor();if(!bt){ae.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(St=>{ce.apply(ke,[bt,St,...ut])}).then(St=>{St||ae.warn("Edits from command "+X+" were not applied.")},St=>{ae.warn("An error occurred while running command "+X,St)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,re.checkProposedApiEnabled)(Te),rt.registerCommand(!0,X,async(...ut)=>{const bt=at.activeEditor(!0);if(!bt){ae.warn("Cannot execute "+X+" because there is no active text editor.");return}const St=await yt.getDiffInformation(bt.id);ce.apply(ke,[St,...ut])})),executeCommand(X,...ce){return rt.executeCommand(X,...ce)},getCommands(X=!1){return rt.getCommands(X)}},sn={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var X,ce;return(ce=(X=We.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return Xe.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ae.openUri(X,{allowTunneling:!!We.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===We.environment.appUriScheme?Et.createAppUri(X):Ae.asExternalUri(X,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Re.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(sn);const on=We.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,En={registerTestProvider(X){return(0,re.checkProposedApiEnabled)(Te),At.registerTestProvider(X)},createDocumentTestObserver(X){return(0,re.checkProposedApiEnabled)(Te),At.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,re.checkProposedApiEnabled)(Te),At.createWorkspaceTestObserver(X)},runTests(X){return(0,re.checkProposedApiEnabled)(Te),At.runTests(X)},publishTestResult(X,ce=!0){return(0,re.checkProposedApiEnabled)(Te),At.publishExtensionProvidedResults(X,ce)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Te),At.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Te),At.results}},Yt={getExtension(X){const ce=Qt.getExtensionDescription(X);if(ce)return new a.Extension(Ye,Te.identifier,ce,on)},get all(){return Qt.getAllExtensionDescriptions().map(X=>new a.Extension(Ye,Te.identifier,X,on))},get onDidChange(){return Qt.onDidChange}},yn={createDiagnosticCollection(X){return Mt.createDiagnosticCollection(Te.identifier,X)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:X=>Mt.getDiagnostics(X),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(X,ce){return Wt.changeLanguage(X.uri,ce)},match(X,ce){return(0,C.score)(U.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return ht.registerCodeActionProvider(Te,gt(X),ce,ke)},registerCodeLensProvider(X,ce){return ht.registerCodeLensProvider(Te,gt(X),ce)},registerDefinitionProvider(X,ce){return ht.registerDefinitionProvider(Te,gt(X),ce)},registerDeclarationProvider(X,ce){return ht.registerDeclarationProvider(Te,gt(X),ce)},registerImplementationProvider(X,ce){return ht.registerImplementationProvider(Te,gt(X),ce)},registerTypeDefinitionProvider(X,ce){return ht.registerTypeDefinitionProvider(Te,gt(X),ce)},registerHoverProvider(X,ce){return ht.registerHoverProvider(Te,gt(X),ce,Te.identifier)},registerEvaluatableExpressionProvider(X,ce){return ht.registerEvaluatableExpressionProvider(Te,gt(X),ce,Te.identifier)},registerInlineValuesProvider(X,ce){return ht.registerInlineValuesProvider(Te,gt(X),ce,Te.identifier)},registerDocumentHighlightProvider(X,ce){return ht.registerDocumentHighlightProvider(Te,gt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ht.registerLinkedEditingRangeProvider(Te,gt(X),ce)},registerReferenceProvider(X,ce){return ht.registerReferenceProvider(Te,gt(X),ce)},registerRenameProvider(X,ce){return ht.registerRenameProvider(Te,gt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return ht.registerDocumentSymbolProvider(Te,gt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Te,X)},registerDocumentFormattingEditProvider(X,ce){return ht.registerDocumentFormattingEditProvider(Te,gt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ht.registerDocumentRangeFormattingEditProvider(Te,gt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...ut){return ht.registerOnTypeFormattingEditProvider(Te,gt(X),ce,[ke].concat(ut))},registerDocumentSemanticTokensProvider(X,ce,ke){return ht.registerDocumentSemanticTokensProvider(Te,gt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return ht.registerDocumentRangeSemanticTokensProvider(Te,gt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...ut){return typeof ke=="object"?ht.registerSignatureHelpProvider(Te,gt(X),ce,ke):ht.registerSignatureHelpProvider(Te,gt(X),ce,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(X,ce,...ke){return ht.registerCompletionItemProvider(Te,gt(X),ce,ke)},registerDocumentLinkProvider(X,ce){return ht.registerDocumentLinkProvider(Te,gt(X),ce)},registerColorProvider(X,ce){return ht.registerColorProvider(Te,gt(X),ce)},registerFoldingRangeProvider(X,ce){return ht.registerFoldingRangeProvider(Te,gt(X),ce)},registerSelectionRangeProvider(X,ce){return ht.registerSelectionRangeProvider(Te,X,ce)},registerCallHierarchyProvider(X,ce){return ht.registerCallHierarchyProvider(Te,X,ce)},setLanguageConfiguration:(X,ce)=>ht.setLanguageConfiguration(Te,X,ce),getTokenInformationAtPosition(X,ce){return(0,re.checkProposedApiEnabled)(Te),Wt.tokenAtPosition(X,ce)},registerInlineHintsProvider(X,ce){return(0,re.checkProposedApiEnabled)(Te),ht.registerInlineHintsProvider(Te,X,ce)}},Sn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(X,ce,ke){const ut=await(k.URI.isUri(X)?Promise.resolve(an.openTextDocument(X)):Promise.resolve(X));return yt.showTextDocument(ut,ce,ke)},createTextEditorDecorationType(X){return yt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,ke){return yt.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return yt.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return yt.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return yt.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return yt.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return yt.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return Xe.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return Xe.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return Xe.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),Xe.onDidChangeTerminalDimensions(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),Xe.onDidWriteTerminalData(X,ce,ke)},get state(){return Ae.state},onDidChangeWindowState(X,ce,ke){return Ae.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return $t.showMessage(Te,S.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return $t.showMessage(Te,S.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return $t.showMessage(Te,S.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Nt.showQuickPick(X,!!Te.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Nt.showInput(X,ce)},showOpenDialog(X){return nn.showOpenDialog(X)},showSaveDialog(X){return nn.showSaveDialog(X)},createStatusBarItem(X,ce){let ke,ut,bt,St;return X&&typeof X!="number"?(ke=X.id,ut=X.name,bt=X.alignment,ce=X.priority,St=X.accessibilityInformation):(ke=Te.identifier.value,ut=y.localize(0,null,Te.displayName||Te.name),bt=X),rn.createStatusBarEntry(ke,ut,bt,ce,St)},setStatusBarMessage(X,ce){return rn.setStatusBarMessage(X,ce)},withScmProgress(X){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),en.withProgress(Te,{location:x.ProgressLocation.SourceControl},(ce,ke)=>X({report(ut){}}))},withProgress(X,ce){return en.withProgress(Te,X,ce)},createOutputChannel(X){return Dt.createOutputChannel(X)},createWebviewPanel(X,ce,ke,ut){return xt.createWebviewPanel(Te,X,ce,ke,ut)},createWebviewTextEditorInset(X,ce,ke,ut){return(0,re.checkProposedApiEnabled)(Te),qt.createWebviewEditorInset(X,ce,ke,ut,Te)},createTerminal(X,ce,ke){return typeof X=="object"?"pty"in X?Xe.createExtensionTerminal(X):Xe.createTerminalFromOptions(X):Xe.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return Xe.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return Ht.registerTreeDataProvider(X,ce,Te)},createTreeView(X,ce){return Ht.createTreeView(X,ce,Te)},registerWebviewPanelSerializer:(X,ce)=>xt.registerWebviewPanelSerializer(Te,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>mn.registerCustomEditorProvider(Te,X,ce,ke),registerFileDecorationProvider(X){return Qe.registerFileDecorationProvider(X,Te.identifier)},registerUriHandler(X){return Et.registerUriHandler(Te.identifier,X)},createQuickPick(){return Nt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Nt.createInputBox(Te.identifier)},get activeColorTheme(){return tn.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return tn.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return gn.registerWebviewViewProvider(Te,X,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Te),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Te),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,re.checkProposedApiEnabled)(Te),ft.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),pn.registerExternalUriOpener(Te.identifier,X,ce,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Te),_t.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Te),_t.onDidChangeTabs}},an={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(X){throw T.readonly()},getWorkspaceFolder(X){return Ze.getWorkspaceFolder(X)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(X){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(X){throw T.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>Ze.updateWorkspaceFolders(Te,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return Ze.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>Ze.getRelativePath(X,ce),findFiles:(X,ce,ke,ut)=>Ze.findFiles(U.GlobPattern.from(X),U.GlobPattern.from(ce),ke,Te.identifier,ut),findTextInFiles:(X,ce,ke,ut)=>{let bt,St;return typeof ce=="object"?(bt=ce,St=ke):(bt={},St=ce,ut=ke),Ze.findTextInFiles(X,bt||{},St,Te.identifier,ut)},saveAll:X=>Ze.saveAll(X),applyEdit(X){return vn.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,ut)=>kt.createFileSystemWatcher(U.GlobPattern.from(X),ce,ke,ut),get textDocuments(){return pt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw T.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=pt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ut=>pt.ensureDocumentData(ut).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,ke)=>pt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>pt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>pt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>pt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>Lt.getOnWillSaveTextDocumentEvent(Te)(X,ce,ke),onDidChangeConfiguration:(X,ce,ke)=>Jt.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,Jt.getConfiguration(X,ce,Te)},registerTextDocumentContentProvider(X,ce){return Ft.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Te,X,ce)),registerFileSystemProvider(X,ce,ke){return Kt.registerFileSystemProvider(Te.identifier,X,ce,ke)},get fs(){return je.value},registerFileSearchProvider:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),vt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),vt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),Ye.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,re.checkProposedApiEnabled)(Te),hn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>kt.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>kt.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>kt.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>kt.getOnWillCreateFileEvent(Te)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>kt.getOnWillDeleteFileEvent(Te)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>kt.getOnWillRenameFileEvent(Te)(X,ce,ke),openTunnel:X=>((0,re.checkProposedApiEnabled)(Te),V.openTunnel(Te,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,re.checkProposedApiEnabled)(Te),V.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,re.checkProposedApiEnabled)(Te),V.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),V.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),fn.registerTimelineProvider(X,ce,Te.identifier,rt.converter)),get trustState(){return(0,re.checkProposedApiEnabled)(Te),(0,re.checkRequiresWorkspaceTrust)(Te),Ze.trustState},requireWorkspaceTrust:X=>((0,re.checkProposedApiEnabled)(Te),(0,re.checkRequiresWorkspaceTrust)(Te),Ze.requireWorkspaceTrust(X)),onDidChangeWorkspaceTrustState:(X,ce,ke)=>Ze.onDidChangeWorkspaceTrustState(X,ce,ke)},Dn={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),zt.getLastInputBox(Te)},createSourceControl(X,ce,ke){return zt.createSourceControl(Te,X,ce,ke)}},Cn={createCommentController(X,ce){return Gt.createCommentController(Te,X,ce)}},ln={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(X,ce,ke){return st.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return st.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return st.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return st.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return st.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return st.registerDebugConfigurationProvider(X,ce,ke||x.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return st.registerDebugAdapterDescriptorFactory(Te,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return st.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?st.startDebugging(X,ce,{parentSession:ke}):st.startDebugging(X,ce,ke||{})},stopDebugging(X){return st.stopDebugging(X)},addBreakpoints(X){return st.addBreakpoints(X)},removeBreakpoints(X){return st.removeBreakpoints(X)},asDebugSourceUri(X,ce){return st.asDebugSourceUri(X,ce)}},jt={registerTaskProvider:(X,ce)=>mt.registerTaskProvider(Te,X,ce),fetchTasks:X=>mt.fetchTasks(X),executeTask:X=>mt.executeTask(Te,X),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(X,ce,ke)=>mt.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>mt.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>mt.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>mt.onDidEndTaskProcess(X,ce,ke)},un={openNotebookDocument:X=>((0,re.checkProposedApiEnabled)(Te),ft.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Te),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Te),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Te),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Te),ft.notebookDocuments.map(X=>X.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.registerNotebookSerializer(Te,X,ce,ke)},registerNotebookContentProvider:(X,ce,ke)=>((0,re.checkProposedApiEnabled)(Te),ft.registerNotebookContentProvider(Te,X,ce,ke)),registerNotebookKernelProvider:(X,ce)=>((0,re.checkProposedApiEnabled)(Te),ft.registerNotebookKernelProvider(Te,X,ce)),createNotebookEditorDecorationType(X){return(0,re.checkProposedApiEnabled)(Te),ft.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCells(X,ce,ke)},onDidChangeCellExecutionState(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,re.checkProposedApiEnabled)(Te),new j.ExtHostNotebookConcatDocument(ft,pt,X,ce)},createCellStatusBarItem(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.createNotebookCellStatusBarItemInternal(X,ce,ke)},createNotebookCellExecutionTask(X,ce,ke){return(0,re.checkProposedApiEnabled)(Te),ft.createNotebookCellExecution(X,ce,ke)}};return{version:We.version,authentication:bn,commands:wn,comments:Cn,debug:ln,env:sn,extensions:Yt,languages:yn,notebook:un,scm:Dn,tasks:jt,test:En,window:Sn,workspace:an,Breakpoint:x.Breakpoint,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:R.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:x.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:b.FileType,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,Hover:x.Hover,IndentAction:A.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItemCollapsibleState:x.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:k.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,InlineHint:x.InlineHint,InlineHintKind:x.InlineHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookCellRange:x.NotebookCellRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookDocumentMetadata:x.NotebookDocumentMetadata,NotebookCellMetadata:x.NotebookCellMetadata,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,LinkedEditingRanges:x.LinkedEditingRanges,TestItem:x.TestItem,TestState:x.TestState,TestResult:x.TestResult,TestMessage:x.TestMessage,TestMessageSeverity:x.TestMessageSeverity,WorkspaceTrustState:x.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=he}),define(be[221],we([0,1,61,99,31,98,35,73,40,41,101,102,103,76,75,67,72,100,74,48,71,93]),function(le,e,y,R,T,P,S,k,E,n,A,C,b,m,r,s,_,g,w,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,y.registerSingleton)(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),(0,y.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,y.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,y.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,y.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,y.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,y.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,y.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,y.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,y.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,y.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,y.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,y.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,y.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,y.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,y.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,y.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,y.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(be[222],we([0,1,220,36,216,7,13,5]),function(le,e,y,R,T,P,S,k){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var s;const _=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...c)=>{c.forEach(i=>{var u;if(!((u=self.trustedTypes)===null||u===void 0?void 0:u.isScript(i)))throw new Error("TrustedScripts only, please")});const d=c.slice(0,-1).join(","),o=c.pop().toString();return`(function anonymous(${d}) {
${o}
})`}});function g(...w){return _?self.eval(_.createScript("",...w)):new Function(...w)}r.create=g})(n||(n={}));class A extends T.RequireInterceptor{_installInterceptor(){}getModule(s,_){for(let g of this._alternatives){let w=g(s);if(w){s=w;break}}if(this._factories.has(s))return this._factories.get(s).load(s,_,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);m(s);const _=this._instaService.invokeFunction(y.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,_,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,_,g){var w,c,d,o,t,i,u,a;_=_.with({path:b(_.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const l=await fetch(_.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),l.status!==200)throw new Error(l.statusText);const f=await l.text(),v=`${_.toString(!0)}#vscode-extension`,D=`${f}
//# sourceURL=${v}`;let h;try{h=n.create((c=(w=C._ttpExtensionScripts)===null||w===void 0?void 0:w.createScript("module"))!==null&&c!==void 0?c:"module",(o=(d=C._ttpExtensionScripts)===null||d===void 0?void 0:d.createScript("exports"))!==null&&o!==void 0?o:"exports",(i=(t=C._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(a=(u=C._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript(D))!==null&&a!==void 0?a:D)}catch(z){throw s?console.error(`Loading code for extension ${s.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${_.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const p={},I={exports:p},F=z=>{const ue=this._fakeModules.getModule(z,_);if(ue===void 0)throw new Error(`Cannot load module '${z}'`);return ue};try{return g.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),h(I,p,F),I.exports!==p?I.exports:p}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),g.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const _=Date.now()+s;for(;Date.now()<_&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=(E=self.trustedTypes)===null||E===void 0?void 0:E.createPolicy("ExtensionScripts",{createScript:r=>r});function b(r,s){return r.endsWith(s)?r:r+s}function m(r){s("info","log"),s("log","log"),s("warn","warn"),s("error","error");function s(w,c){console[w]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:g(arguments)})}}const _=1e5;function g(w){const c=[],d=[];if(w.length)for(let o=0;o<w.length;o++){if(typeof w[o]=="undefined")w[o]="undefined";else if(w[o]instanceof Error){const t=w[o];t.stack?w[o]=t.stack:w[o]=t.toString()}d.push(w[o])}try{const o=JSON.stringify(d,function(t,i){if(i&&typeof i=="object"){if(c.indexOf(i)!==-1)return"[Circular]";c.push(i)}return i});return o.length>_?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}}),define(be[223],we([0,1,61,19,36,222,208]),function(le,e,y,R,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService),(0,y.registerSingleton)(R.ILogService,S.ExtHostLogService)}),define(be[225],we([0,1,26,3,180,217,210,11,77,221,223]),function(le,e,y,R,T,P,S,k,E){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const A=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const C=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const _=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),g=self.Worker;Worker=function(w,c){const d=`importScripts('${w}');`;c=c||{},c.name=c.name||k.basename(w.toString());const o=new Blob([d],{type:"application/javascript"}),t=URL.createObjectURL(o);return new g(_?_.createScriptURL(t):t,c)}}else self.Worker=class extends S.NestedWorker{constructor(_,g){super(C,_,Object.assign({name:k.basename(_.toString())},g))}};const b=new class{exit(_){A()}async exists(_){return!0}async realpath(_){return _}};class m{constructor(){const g=new MessageChannel,w=new R.Emitter;let c=!1;C(g.port2,[g.port2]),g.port1.onmessage=d=>{const{data:o}=d;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const t=y.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,T.isMessageOfType)(t,2)){c=!0,s("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:d=>{if(!c){const o=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);g.port1.postMessage(o,[o])}}}}}function r(_){return new Promise(g=>{const w=_.onMessage(c=>{w.dispose();const d=JSON.parse(c.toString());_.send((0,T.createMessageOfType)(0)),g({protocol:_,initData:d})});_.send((0,T.createMessageOfType)(1))})}let s=_=>A();(function(){const g=new m;E.mark("code/extHost/willConnectToRenderer"),r(g.protocol).then(w=>{E.mark("code/extHost/didWaitForInitData");const c=new P.ExtensionHostMain(w.protocol,w.initData,b,null);s=d=>c.terminate(d)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c71be15869a673c5ed7bfd3fe171757d2ba48142/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
